CBAB ***** changes made for LS coupling marked with CLIPAS
C  MODIFIED BASIS WHICH IS SEMI-INTELLIGENT.
C  THIS MAY BE QUICKER THAN THE USUAL APPROACH WHICH TRIES ALL POSSIBLE
C  MSCHEME STATES, ESPECIALLY FOR HIGH JZ OR TZ CASES.
C  THIS VERSION HAS A SHELL-METZNER SORT (NO RELATION) FOR THE BASIS.
 
CEO ******************************************************************
CEO
CEO   MODIFIED TO ALLOW RESTRICTIONS ON THE SUM OF SUBSHELLS
CEO
CEO *****************************************************************
 
      IMPLICIT INTEGER (A-Z)
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'bascom.inc'
      CHARACTER*9 FILEPART
      CHARACTER*2 FORMMAX,FORMNJL
      character formnptcl*5, cmm*6, cmn*6
      character*300 format1,format2
      COMMON/CILIST/ILIST
      COMMON/LISTPAR2/FORMNJL
      COMMON/CHBW/IHBWMAX,IHBW(10),IEHBW(MAX_NJL),KHBWGS
Cbab *** NOTE THAT BASCOM.INC CONTAINS THE STATEMENT "IMPLICIT INTEGER (A-Z)"
cekw *** No, the statement is above
      integer IBASA(MAX_NLWRDS,MAX_MSCHEME),
     1         IBASIS(MAX_NLWRDS,NLWRDS_BLOCK,MAX_NPART),
     1         IORDER_PAR(MAX_NPART),IFIRST_REC(MAX_NPART),
     1         NDIMA_KEEP(MAX_NPART)
 
      integer JZMAX(MAX_NSPS,MAX_NSPS-1),TZMAX(MAX_NSPS,MAX_NSPS-1)
      integer JZST_DUP(MAX_NSPS),TZST_DUP(MAX_NSPS),WHERE(MAX_NSPS)
      integer JLJI(MAX_NSPS),MAX_BAS(MAX_NLWRDS)
      integer SUM_IP(0:MAX_NJL)
 
      integer MAXSUM(MAX_NJL,MAX_NJL)
 
      LOGICAL MLOGICAL,ILOG
 
      INCLUDE 'data.inc'
 
CZ    WE CHANGE *.COM TO *.DAT FILE FOR CRAY, SO HERE WE OPEN
CZ    (UNIT=5...)
CZ    HERE WE OPEN(UNIT=6,...) FOR CRAY
 
CEKW  *** IF *.PAB & *.PAC FILES ARE DESIRED THEN SET IPA = 1 ***
CEKW  *** OR RUN WITH BASISZ                                  ***
      IPA = 1
CEKW  *** If testing output is desired in file for011.dat set I11 = 1
      i11 = 0
CEKW  **********************************************************
      IF(IFPS.EQ.2) THEN
      OPEN(UNIT=5,FILE='bdat',STATUS='OLD')
      OPEN(UNIT=6,FILE='bwrt',STATUS='NEW')
      ELSE
      END IF
      CALL TIMER('START')
      CALL TEST_BATCH(ILOG)
      ISIZE2=MAX_MSCHEME
      ILARGE=ISIZE2+10
      IVERS=2
      MLOGICAL=.FALSE.
      NDUD=0
 
CA   MAX_MSCHEME - MAXIMUM SIZE OF THE BASIS FOR A GIVEN PARTITION.
CA  MAX_IDISK   - MAXIMUM NUMBER OF RECORDS IN THE BASIS FILE. WITH
CA    OUR CHOICE OF REC_LENGTH(=NLWRDS_BLOCK*MAX_NLWRDS) IT IS APPROX.
CA     EQUIVALENT TO THE MAXIMUM NO. OF THE DIMENSION OF THE M-SCHEME BASIS
CA     FOR PARTITIONS DIVIDED BY REC_LENGTH AND IT IS ALSO APPROX.
CA    EQUIVALENT TO THE MAX. NO. OF DISK BLOCKS.
CA  ILARGE      - USED TO ORDER THE PARTITIONS BY THEIR DIMENSIONS. IT
CA    ONLY NEEDS TO BE LARGER THAN MAX_MSCHEME AND OCCURS ONLY
CA    IN THE MAIN PROGRAM, AT LABEL 94.
 
CBAB **** GET INPUT INFORMATION
 
      WRITE(6,1000)
1000  FORMAT(' Control integers ILPT,IBAS,IBPAIRS,MAX_BPAIRS,IPA : ')
      CALL FREE_INT(5,5,INT_VAR,READ_ERR)
      ILPT=INT_VAR(1)
      IBAS=INT_VAR(2)
      IBPAIRS=INT_VAR(3)
      MAX_BPAIRS=INT_VAR(4)
      IPA=INT_VAR(5)
      IF(ILOG)WRITE(6,700)ILPT,IBAS,IBPAIRS,MAX_BPAIRS,IPA
700   FORMAT('+',10I3)
1007  WRITE(6,1)
1     FORMAT(' Single-particle state file : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      SPSFIL=CHAR_VAR(1)
      LONGS=INDEX(SPSFIL,' ')-1
      IF(ILOG)WRITE(6,702)SPSFIL(1:LONGS)
702   FORMAT('+',29X,A9,'.sps')
      WRITE(6,18)
18    FORMAT(' Name for basis data file : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      BASFIL=CHAR_VAR(1)
      LONGB=INDEX(BASFIL,' ')-1
      IF(ILOG)WRITE(6,708)BASFIL(1:LONGB)
708   FORMAT('+',28X,A9,'.bas')
        IF(ILPT.GT.0)THEN
      CALL OPEN_FILE(3,BASFIL,'.lpb','NEW','FORM')
      IOUT = 3
      WRITE(3,1002)
1002  FORMAT(1X,'Output of BASIS')
      CALL TITLE(IOUT)
      END IF
      IF(IFPS.EQ.2) THEN
      SPS2='.s'
      SPSF=SPSFIL(1:LONGS)//'.s'
      ELSE
      SPS2='.sps'
      SPSF=SPSFIL(1:LONGS)//'.sps'
      END IF
 
      CALL OPENSPS(1,SPSF,0)
C
C  READ NO OF SP STATES ,NO OF J LEVELS, MAX NO OF
C  PARTICLES IN EACH LEVEL.
C
      CALL FREE_INT(1,30,INT_VAR,READ_ERR)
      NSPS=INT_VAR(1)
      NJL=INT_VAR(2)
      DO 13301 I=1,NJL
13301 NPJ(I)=INT_VAR(2+I)
      NOSC=INT_VAR(NJL+3)
      DO 13302 I=1,NOSC
13302 NOSCJL(I)=INT_VAR(3+NJL+I)
CWEO      READ(1,*) NSPS,NJL,(NPJ(I),I=1,NJL),NOSC,(NOSCJL(I),I=1,NOSC)
      MIX_PARITY=0
      IF(NSPS.LT.0)THEN
      NSPS=-NSPS
      MIX_PARITY=1
      END IF
      WRITE(FORMMAX,21001)MAX_NJL
      WRITE(FORMNJL,21001)NJL
21001 FORMAT(I2)
      NLWRDS=1+NSPS/MAX_BIT_NLWRDS
      IF(MOD(NSPS,MAX_BIT_NLWRDS).EQ.0)NLWRDS=NLWRDS-1
      IF(NLWRDS.GT.MAX_NLWRDS)THEN
      WRITE(6,998)NLWRDS,MAX_NLWRDS
998   FORMAT(' BASIS: NLWRDS.GT.MAX_NLWRDS - MAX_NLWRDS AND
     1 MAX_NSPS SHOULD BE ACCORDINGLY INCREASED',/,1X,
     2'NLWRDS, MAXNLWRDS: ',2(I12,1X))
      STOP ' ***** FATAL ERROR in MAIN *****'
      END IF
      DO 10001  I=1,NLWRDS
      ZERO(I)=0
C      END DO
10001 CONTINUE
 
      IF (NJL.GT.MAX_NJL) STOP ' ***** FATAL ERROR in MAIN : NJL.GT.MAX_
     1NJL
     1 *****'
      IF (NOSC.GT.MAX_NOSC) STOP ' ***** FATAL ERROR in MAIN :
     1 NOSC.GT.MAX_NOSC *****'
      IF(ILPT.GT.0)THEN
       WRITE(3,1003) NSPS,NJL,(NPJ(I),I=1,NJL)
       WRITE(3,10031) NOSC,(NOSCJL(I),I=1,NOSC)
      END IF
1111  FORMAT(' EXTENDED NUMBER OF SINGLE PARTICLE CONFIGURATIONS
     1CALCULATION'/' NUMBER OF LONG WORDS = ',I1)
1003  FORMAT(
     1/' No. of m states     : ',I3,
     1/' No. of j levels     : ',I3,
CEKW     1/' No. of states/level : ',100I3)   ! FOR PBALL
     1/' No. of states/level : ',14I3,/,23X,14I3)
10031 FORMAT(
     1 ' No. of major shells : ',I3,
     1/' No. of levels/shell : ',100I3)
      CALL FREE_REAL_A(1,NJL,CHAR_VAR,0,REAL_VAR,READ_ERR)
      DO 13001 I=1,NJL
13001 SHELL(I)=CHAR_VAR(I)
CWEO      READ (1,5) (SHELL(I),I=1,NJL)
CWEO5     FORMAT(<NJL>A)
      IF (ILPT.GT.0) WRITE(3,1006) (SHELL(I),I=1,NJL)
1006  FORMAT(/,1X,'Labels of j-levels',/,7(1X,A9))
C  READ IN QUANTUM NOS OF STATES
C  ORDERING: -VE M VALUES FIRST IN DECREASING ORDER OF MAGNITUDE
C  THEN +VE M VALUES  IN DECREASING ORDER OF MAGNITUDE
C  TZ=0.5 MUST IMMEDIATELY FOLLOW TZ=-0.5
CBAB      IF (ILPT.GT.0) WRITE(3,1009)
1009  FORMAT(/'    NUMBER         N         L        2J       2MZ
     1       2TZ',/)
      DO 10 NS=1,NSPS
C  NON IS A DUMMY VARIABLE JUST TO LABEL THE STATES ON THE FILE
C  IT IS NOT USED INTERNALLY
      CALL FREE_INT(1,6,INT_VAR,READ_ERR)
      NQU(NS)=INT_VAR(2)
      LQU(NS)=INT_VAR(3)
      JTW(NS)=INT_VAR(4)
      MZTW(NS)=INT_VAR(5)
      ITZTW(NS)=INT_VAR(6)
1010  FORMAT(6I10)
10    CONTINUE
      CLOSE(UNIT=1)
 
      ISOSPIN=.TRUE.
      IF(ITZTW(1).EQ.ITZTW(2))ISOSPIN=.FALSE.
      NPTYPE='NONE'
      IF(.NOT.ISOSPIN)NPTYPE='ONE'
      IF(NOSC.EQ.2.AND..NOT.ISOSPIN)NPTYPE='BOTH'
 
 
 
 
 
C  NQU IS THE PRINCIPLE QUANTUM NO
C  LQU IS THE L VALUE
C  JTW IS TWICE THE J VALUE
C  MZTW IS TWICE THE VALUE OF JZ
C  ITZTW IS TWICE THE VALUE OF THE ISOSPIN PROJECTION
C
C
C
C
C
C  READ IN ANY RESTRICTIONS, THAT IS THE MAX AND MIN NO. OF PARTICLES
C  IN ANY J LEVEL, AND THE TOTAL NO. OF PARTICLES
C  THE J LEVELS MUST BE IN THE SAME ORDER AS ABOVE
      WRITE(6,1018)
1018  FORMAT(' Number of particles : ')
      CALL FREE_INT(5,1,INT_VAR,READ_ERR)
      NPTCL=INT_VAR(1)
CWEO      READ(5,1001) NPTCL
      IF(ILOG)WRITE(6,704)NPTCL
704   FORMAT('+',22X,I4)
      WRITE(6,1020)
1020  FORMAT(' Any restrictions ? (Y/N) : ')
21    FORMAT(A1)
      READ(5,21)ANS3
      IF(ANS3.EQ.' ')ANS3='n'
      IF(ILOG)WRITE(6,705)ANS3
705   FORMAT('+',28X,A1)
      IREST=0
      IF (ANS3.EQ.'y') IREST=1
      IF (ILPT.GT.0) WRITE(3,1011) NPTCL
1011  FORMAT(/,1X,'total number of particles : ',I4)
      K=0
      DO 801 I=1,NOSC
      DO 800 J=1,NOSCJL(I)
      K=K+1
800   MXOSC(I)=MXOSC(I)+NPJ(K)
      MXOSC(I)=MIN(MXOSC(I),NPTCL)
801   MNOSC(I)=0
      IF (IREST.GT.0) GO TO 12
      IF (ILPT.GT.0) WRITE(3,1012)
1012  FORMAT(' no restrictions in filling j levels')
      DO 9 I=1,NJL
      MNFIL(I)=0
9     MXFIL(I)=MIN(NPJ(I),NPTCL)
 
CBAB *** LINES DOWN TO 3336 MODIFIED BY E ORMAND (JUNE 1985)
CBAB *** FOR PARTITION ENERGY RESTRICTIONS
 
      GO TO 5113
12    WRITE(6,2000)
CBAB NOT SURE THAT PARTITION ENERGY RESTRICTION ARE WORKING IN ALL CASES
CBAB2000  FORMAT(' List of restrictions - (M)ajor shell or (H)bw'
CBAB     1/,1X,'and/or (S)ub-shell restictions or
CBAB     2 (P)artition excitation energy or (L)ist : ')
2000  FORMAT(' List of restrictions - (M)ajor shell or (H)bw'
     1/,1X,'and/or (S)ub-shell restiction or (L)ist : ')
      READ(5,2001)R1,R2
2001  FORMAT(2A1)
      IF(R1.EQ.'m'.AND.R2.EQ.'s') RESTYP = 'B'
      IF(R1.EQ.'h'.AND.R2.EQ.'s') RESTYP = 'B'
      IF(R1.EQ.'n'.AND.R2.EQ.'s') RESTYP = 'B'
      IF(R1.EQ.'m'.AND.R2.EQ.'p') RESTYP = 'MP'
      IF(R1.EQ.'h'.AND.R2.EQ.'p') RESTYP = 'HP'
      IF(R1.EQ.'n'.AND.R2.EQ.'p') RESTYP = 'HP'
      IF(R1.EQ.'s'.AND.R2.EQ.'m') RESTYP = 'B'
      IF(R1.EQ.'s'.AND.R2.EQ.'h') RESTYP = 'B'
      IF(R1.EQ.'s'.AND.R2.EQ.'n') RESTYP = 'B'
      IF(R1.EQ.'p'.AND.R2.EQ.'m') RESTYP = 'MP'
      IF(R1.EQ.'p'.AND.R2.EQ.'h') RESTYP = 'HP'
      IF(R1.EQ.'p'.AND.R2.EQ.'n') RESTYP = 'HP'
      IF(R1.EQ.'m'.AND.R2.EQ.' ') RESTYP = 'M'
      IF(R1.EQ.'h'.AND.R2.EQ.' ') RESTYP = 'M'
      IF(R1.EQ.'n'.AND.R2.EQ.' ') RESTYP = 'M'
      IF(R1.EQ.'s'.AND.R2.EQ.' ') RESTYP = 'S'
      IF(R1.EQ.'b'.AND.R2.EQ.' ') RESTYP = 'B'
      IF(R1.EQ.'p'.AND.R2.EQ.' ') RESTYP = 'P'
      IF(R1.EQ.'l'.AND.R2.EQ.' ') RESTYP = 'B'
      IF(ILOG)WRITE(6,705)RESTYP
CEO   IF (RESTYP.EQ.'S') GO TO 2013
      IF (RESTYP.EQ.'S') GO TO 4110
      IF (RESTYP.EQ.'P') GO TO 5110
      IF(R1.EQ.'m') GO TO 2020
      IF(R1.EQ.'h') GO TO 2021
      IF(R1.EQ.'n') GO TO 2021
      IF(R1.EQ.'l') GO TO 7500
      WRITE(6,2023)R1
2023  FORMAT(1X,'ERROR IN BASIS: ILLEGAL VALUE FOR "R1" = ',A1)
      STOP
2020  CONTINUE
      WRITE(6,2002)
2002  FORMAT(/' MAJOR SHELL :')
      IF (ILPT.GT.0) WRITE(3,2003)
2003  FORMAT(/,1X,'Min,Max number of particles in major shells')
      K=1
      DO 2004 I=1,NOSC
      WRITE(6,'(1X,'//FORMMAX//'(A9,1X))')(SHELL(J),J=K,K+NOSCJL(I)-1)
CWEO2005  FORMAT(1X,<MAX_NJL>A)
CEKW2005  FORMAT(1X,12(A9,1X))
2005  FORMAT(7(1X,A9))
      WRITE(6,2008)MNOSC(I),MXOSC(I)
2008  FORMAT(' Min. and Max. no. of particles',2I4,' NEW ONES : ')
CWEO2108  FORMAT(2I)
CWEO      READ(5,2108)MNOSC(I),MAX
      CALL FREE_INT(5,2,INT_VAR,READ_ERR)
      MNOSC(I)=INT_VAR(1)
      MAX=INT_VAR(2)
      MXOSC(I)=MIN0(MAX,MXOSC(I))
      IF(ILOG)WRITE(6,706)MNOSC(I),MAX
      IF (ILPT.GT.0) WRITE(3,2009)
2009  FORMAT('  ')
      IF (ILPT.GT.0) WRITE(3,2005) (SHELL(J),J=K,K+NOSCJL(I)-1)
2011  FORMAT(1X,2I5)
      IF (ILPT.GT.0) WRITE(3,2011) MNOSC(I),MXOSC(I)
      DO 10002  IJ=K,K+NOSCJL(I)-1
      MXFIL(IJ)=MIN(NPTCL,NPJ(IJ))
      MXFIL(IJ)=MIN(MXFIL(IJ),MXOSC(I))
C      END DO
10002 CONTINUE
      K=K+NOSCJL(I)
2004  CONTINUE
cbab2012  FORMAT(///)
      GO TO 2022
 
2021  CONTINUE
      DO 4005 I = 1,NJL
      MNFIL(I) = 0
4005  MXFIL(I)=MIN(NPJ(I),NPTCL)
      NPTCL_LEFT=NPTCL
      DO 4002 I = 1,NOSC
      MXOSC(I)=MIN0(NPTCL_LEFT,MXOSC(I))
      IF(MXOSC(I).LT.0) MXOSC(I)=0
      MNOSC(I)=MXOSC(I)
      NPTCL_LEFT=NPTCL_LEFT-MXOSC(I)
4002  CONTINUE
 
 
      WRITE(6,3000)
3000  FORMAT(1X,'LIST VALUES FOR HBW [e.g. 0,2]')
      CALL FREE_INT(5,10,INT_VAR,READ_ERR)
      DO 13002 I=1,10
13002 IHBW(I)=INT_VAR(I)
CWEO      READ(5,3002)(IHBW(I),I=1,10)
CWEO3002  FORMAT(10I)
      DO 3003 I = 10,1,-1
      IHBWMAX=I
3003  IF(IHBW(I).NE.0) GO TO 3004
3004  IF(IHBWMAX.EQ.0) IHBWMAX=1
CBAB FOR HBW RESTRICTIONS
      DO 400 I=1,NOSC
400   KHBWGS=KHBWGS+(I+1)*MNOSC(I)
      K=0
      DO 401 I=1,NOSC
      DO 401 J=1,NOSCJL(I)
      K = K + 1
      IF(MNOSC(I).EQ.0.AND.
     1MXFIL(K).GT.IHBW(IHBWMAX))MXFIL(K)=IHBW(IHBWMAX)
      IF(I.EQ.1) GO TO 402
CBAB      IF(IHBW(IHBWMAX).GT.0.AND.I.GT.1.AND.MNOSC(I).EQ.0.AND.
CBAB     1MNOSC(I-1).EQ.0.AND.MXFIL(K).GT.(IHBW(IHBWMAX)-1))
CBAB     1MXFIL(K)=IHBW(IHBWMAX)-1
      IF(IHBW(IHBWMAX).GT.0.AND.MNOSC(I).EQ.0.AND.
     1MNOSC(I-1).EQ.0.AND.MXFIL(K).GT.(IHBW(IHBWMAX)-1))
     1MXFIL(K)=IHBW(IHBWMAX)-1
402   CONTINUE
401   IEHBW(K)=I+1
      GO TO 2022
 
2022  CONTINUE
 
 
      IF(RESTYP.EQ.'B')GOTO 2013
      IF((RESTYP.EQ.'M').OR.(RESTYP.EQ.'MP')) GO TO 15
      IF((RESTYP.EQ.'H').OR.(RESTYP.EQ.'HP')) GO TO 15
      IF((RESTYP.EQ.'N').OR.(RESTYP.EQ.'NP')) GO TO 15
CEO ***********************************************************
 
C     ADDED TO ALLOW RESTRICTIONS ON THE SUM OF SUBSHELLS
 
C     SUM RESTRICTIONS ARE DONE BY EXAMINING THE LABELS SHELL(I)
 
C     IF(SHELL(I)(2:).EQ.SHELL(J)(2:)), WHERE I=1 TO N0SCJL(1)
C     AND J=NOSCJL(1)+1 TO NJL, THE SUM OF PARTICLES IS RESTRICTED
C     BY
 
C     MNSUM(I,J) </= SHELL(I)+SHELL(J) </= MXSUM(I,J)
 
CEO **********************************************************
 
2013  IF(NPTYPE.NE.'BOTH')GOTO 4110
      WRITE(6,4102)
4102  FORMAT
     1(1X,'Restrict # of particles in sum of subshells? (Y/N): ')
      READ(5,4103)SUMRES
      IF(SUMRES.EQ.' ')SUMRES='n'
4103  FORMAT(A1)
      WRITE(6,4104)
4104  FORMAT(1X,'Restrict # of particles in each subshell? (Y/N): ')
      READ(5,4103)SUBRES
      IF(SUBRES.EQ.' ')SUBRES='n'
      IF(SUMRES.NE.'y')GOTO 4105
      NSUM=0
       IF (ILPT.GT.0) WRITE(3,5013)
5013  FORMAT(/' Nos. of particles allowed in sum of j levels'/
     1  12X,'MIN NO.',3X,'MAX NO.')
      DO 10003  I=1,NOSCJL(1)
      DO 10004  J=NOSCJL(1)+1,NJL
      RESUM(I,J)='N'
      MAXSUM(I,J)=NPJ(I)+NPJ(J)
      IF(SHELL(I)(2:).EQ.SHELL(J)(2:))THEN
      RESUM(I,J)='Y'
      NSUM=NSUM+1
      WRITE(6,4106)SHELL(I),SHELL(J),MAXSUM(I,J)
4106  FORMAT(1X,A9,' + ',A9,' Max. sum =',I3,' NEW MINIMUM
     1AND MAXIMUM: ')
      CALL FREE_INT(5,2,INT_VAR,READ_ERR)
      MNSUM(I,J)=INT_VAR(1)
      MXSUM(I,J)=INT_VAR(2)
CWEO      READ(5,11)MNSUM(I,J),MXSUM(I,J)
      IF(ILPT.GT.0)WRITE(3,4111)SHELL(I),SHELL(J),MNSUM(I,J),MXSUM(I,J)
4111  FORMAT(1X,A9,' + ',A9,3I10)
      ELSE
      CONTINUE
      END IF
C      END DO
10004 CONTINUE
C      END DO
10003 CONTINUE
      IF(NSUM.EQ.0)WRITE(6,4107)
4107  FORMAT(1X,'NO SUM RESTRICTIONS ARE POSSIBLE')
 
 
4105  IF(SUBRES.NE.'y')GOTO 15
 
4110   CONTINUE
 
       IF (ILPT.GT.0) WRITE(3,1013)
1013  FORMAT(//' Nos. of particles allowed in j levels'//
     1  12X,'MIN NO.',3X,'MAX NO.')
      WRITE(6,2007)
2007  FORMAT(/' SUB SHELL :')
      DO 13 I=1,NJL
      WRITE(6,14) SHELL(I),NPJ(I)
14    FORMAT(' ',A,' Max. no. particles =',I3,' NEW MINIMUM AND MAXIMUM
     1
     1:  ')
      CALL FREE_INT(5,2,INT_VAR,READ_ERR)
      MNFIL(I)=INT_VAR(1)
      MXFIL(I)=INT_VAR(2)
CWEO      READ(5,11)MNFIL(I),MXFIL(I)
CWEO11    FORMAT(3I)
9011  MXFIL(I)=MIN0(NPJ(I),MXFIL(I))
      IF(ILOG)WRITE(6,706)MNFIL(I),MXFIL(I)
706   FORMAT(' ',I4,1X,I4)
      IF (ILPT.GT.0) WRITE(3,1014)SHELL(I),MNFIL(I),MXFIL(I)
1014  FORMAT(1X,A9,3I10)
13    CONTINUE
      IF (ILPT.GT.0) WRITE(3,1019)
1019  FORMAT(/)
      GOTO 5113
 
 
 
 
 
15    IF(RESTYP(2:2).NE.'P')GOTO 5113
5110  IF(RESTYP.NE.'P')GOTO 5120
 
      DO 5005 I = 1,NJL
      MNFIL(I) = 0
5005  MXFIL(I)=MIN(NPJ(I),NPTCL)
      NPTCL_LEFT=NPTCL
      DO 5002 I = 1,NOSC
      MXOSC(I)=MIN0(NPTCL_LEFT,MXOSC(I))
      IF(MXOSC(I).LT.0) MXOSC(I)=0
      MNOSC(I)=MXOSC(I)
      NPTCL_LEFT=NPTCL_LEFT-MXOSC(I)
5002  CONTINUE
 
 
5120  WRITE(6,5111)
5111  FORMAT(1X,'Partition energy cutoff : ')
      CALL FREE_REAL(5,1,REAL_VAR,READ_ERR)
      E_CUTOFF=REAL_VAR(1)
      WRITE(6,5114)
5114  FORMAT(1X,'Interaction file : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,2,REAL_VAR,READ_ERR)
      INTFILE=CHAR_VAR(1)
      SPE_NORM=REAL_VAR(1)
      ME_NORM=REAL_VAR(2)
 
7500  CONTINUE
      DO 7507 I=1,NJL
      MNFIL(I)=9999
7507  MXFIL(I)=0
      WRITE(6,7501)
7501  FORMAT(1X,'*.PAR File name for list of partitions')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      FILEPART=CHAR_VAR(1)
      CALL OPEN_FILE(4,FILEPART,'.par','OLD','FORM')
      ILIST = 0
7506  CONTINUE
      ILIST = ILIST + 1
      CALL FREE_INT(4,NJL,INT_VAR,READ_ERR)
      IF(READ_ERR)GOTO 7505
      IBAB = 0
      DO 7512 J=1,NJL
      IBAB = IBAB + INT_VAR(J)
 7512 IPARTB(J,ILIST)=INT_VAR(J)
      IF(IPARTB(1,ILIST).LT.0) ILIST=ILIST-1
      IF(IPARTB(1,ILIST).LT.0) GO TO 7506
      ITOT = 0
      DO 7503 J = 1,NJL
      ITOT = ITOT + IPARTB(J,ILIST)
7503  CONTINUE
      IF(ITOT.EQ.0) GO TO 7505
      DO 7508 J = 1,NJL
      IF(IPARTB(J,ILIST).LT.MNFIL(J)) MNFIL(J)=IPARTB(J,ILIST)
      IF(IPARTB(J,ILIST).GT.MXFIL(J)) MXFIL(J)=IPARTB(J,ILIST)
7508  CONTINUE
      GO TO 7506
7505  ILIST = ILIST-1
      print 7511,filepart,ILIST
 7511 FORMAT(/,3X,A6,'.par file was read.
     1 It contains ',i5,' partitions',/)
      CLOSE(UNIT=4)
 
5113  NS=0
      DO 8 I=1,NJL
      NS=NPJ(I)+NS
      KPARQ(I)=MOD(LQU(NS),2)
8     CONTINUE
 
CA  SET UP TO RUN NEWPATM SO AS TO PASS EVEN NUMBER OF PARTICLES FROM ONE
CA  MAJOR SHELL TO ANOTHER
      IF(NOSC.GT.1)IREST=1
 
C  READ IN VALUES OF JZ*2,TZ*2, PARITY, AND MAX. T*2 REQD.
      WRITE(6,1017)
1017  FORMAT(' Jz*2, Tz*2 and Parity (0=+VE, 1=-VE) : ')
      CALL FREE_INT(5,3,INT_VAR,READ_ERR)
      IMZS=INT_VAR(1)
      ITZS=INT_VAR(2)
      KPAR=INT_VAR(3)
 
CWEO      READ(5,16) IMZS,ITZS,KPAR
CWEO16    FORMAT(15I)
CA  NEXT if .SPS files contains all neutrons or all protons
      ISIGN_TZ=1
      IF(ITZS.LT.0)ISIGN_TZ=-1
      IF(ILOG)WRITE(6,707)IMZS,ITZS,KPAR
707   FORMAT('+',38X,3I4)
CLIPAS      IF (MOD((NPTCL-IMZS),2).NE.0) GO TO 940
CLIPAS      IF (MOD((NPTCL-ITZS),2).NE.0) GO TO 940
      ITZSA=IABS(ITZS)
      IMZSA=IABS(IMZS)
      JZ=IMZS/2.0
      TZ=ITZS/2.0
      IF (ILPT.GT.0) WRITE(3,1015) JZ,TZ,KPAR
1015  FORMAT(  /' nuclear spin : JZ = ',F5.1/
     8  ' isospin :      TZ = ',F5.1/
     9  ' parity (0=+VE)    = ',I5)
C  0=POSITIVE PARITY
C  1=NEGATIVE PARITY
      IF (ILPT.GT.0) WRITE(3,205) BASFIL
205   FORMAT(/' name of BASIS output data file : ',A9)
 
CA  END OF INPUT INFORMATION. BEGINNING OF CALCULATION
 
 
 
      REC_LENGTH=NLWRDS*NLWRDS_BLOCK
 
CA  ******* SEE IF CORE
 
      IF (NPTCL.EQ.0) GO TO 1050
 
C  WORK OUT ALL POSS PARTITIONS
 
      IF(R1.EQ.'l') GO TO 3337
      IF((RESTYP.EQ.'P').OR.(RESTYP(2:2).EQ.'P')) GOTO 3334
      IF(R1.EQ.'h'.OR.R2.EQ.'h') GOTO 3335
      IF(R1.EQ.'n'.OR.R2.EQ.'n') GOTO 3338
      CALL WOTPTS
      CALL LISTPART(1)
      GOTO 3336
3334  CALL WOTPART
      CALL LISTPART(1)
      GOTO 3336
3337  CALL WOTL
      CALL LISTPART(1)
      GOTO 3336
3335  CALL WOTHBW(1)
      CALL LISTPART(1)
      GOTO 3336
3338  CALL WOTHBW(2)
      CALL LISTPART(1)
      GOTO 3336
3336  CONTINUE
 
 
CBAB   ****** NEXT CALL CHECKS PARITY
CBAB   ****** CALL PARITY
 
CBAB ------------------------------------------------------------
CBAB INSERTED JAN 23 1984 BASED ON LETTER FROM AE OF DEC 27 1983
C SUM NPJ(I) IS THE NO. OF SINGLE PARTICLE STATES UP TO J-LEVEL
C NO. I INCLUSINVE
 
      SUM_NPJ(0) = 0
      SUM_NPJ(1) = NPJ(1)
      DO 10005  NK = 2,NJL
      SUM_NPJ(NK) = SUM_NPJ(NK-1)+NPJ(NK)
C      END DO
10005 CONTINUE
 
C  CREATE TEMPORARY FILE TO STORE BASIS STATES IN BLOCKS OF REC_LENGTH
 
      NREC=1
CBAB  OPEN(UNIT=1,FILE=AREA_RUN//BASFIL//'.TMP',ACCESS='DIRECT',
CBAB 1ORGANIZATION='RELATIVE',RECL=REC_LENGTH,STATUS='SCRATCH',
CBAB 1ASSOCIATEVARIABLE=NREC,RECORDprint='FIXED')
CVAX      OPEN(UNIT=1,FILE=BASFIL(1:NPOS_BAS)//'.TMP',ACCESS='DIRECT',
CVAX     1ORGANIZATION='RELATIVE',RECL=REC_LENGTH,STATUS='NEW',
CVAX     1ASSOCIATEVARIABLE=NREC,RECORDprint='FIXED',DISPOSE='DELETE')
      CALL OPEN_BASIS(1,BASFIL,'.tmp','SCR',NLWRDS)
      DO 80 IP=1,NPART
 
CD     print *,' ********** IP = ',IP,' ********************'
 
      SUM_IP(0) = 0
      DO 10006  M = 1,NJL
CWEO       SUM_IP(M) = SUM_IP(M-1) + IPART_BYTE(M,IP)
       SUM_IP(M) = SUM_IP(M-1) + IPART(M,IP)
C      ENDDO
10006 CONTINUE
CD     print 4711,(SUM_IP(M),M=0,NJL)
4711  FORMAT('  SUM_IP(0...NJL) : ',12I4)
 
C  ARRAY JLJI HELPS KEEP TRACK OF WHICH J-LEVEL WE'RE IN
      M0 = 1
      DO 10007  M1=1,NJL
CWEO        DO 10008  M2=1,IPART_BYTE(M1,IP)
        DO 10008  M2=1,IPART(M1,IP)
        JLJI(M0) = M1
        M0 = M0 + 1
C        ENDDO
10008   CONTINUE
C      ENDDO
10007 CONTINUE
      M0 = M0 -1
CD     print 200,'JLJI',(JLJI(I),I=1,M0)
C
C  BUILD UP JZMAX, TZMAX ARRAY FOR THIS PARTITION
C
C  **** MP = # PARTICLES STILL TO BE ASSIGNED
      DO 10009  MP = 1,NPTCL-1
C  **** MQ = # PARTICLES ALREADY ASSIGNED
      MQ = NPTCL - MP
CD     IC_MP = 0
 
C  FIND HIGHEST J-LEVEL THAT IS (PARTIALLY) UNFILLED = MK
 
      MK = JLJI(MQ)
      MIN_MS = SUM_NPJ(MK-1) + MQ - SUM_IP(MK-1)
C  NOW FIND MAX_MS
C9/2/84JSW MAX_MS = SUM_NPJ(MK)
CWEO      MAX_MS = SUM_NPJ(MK) - (IPART_BYTE(MK,IP) - MQ + SUM_IP(MK-1))
      MAX_MS = SUM_NPJ(MK) - (IPART(MK,IP) - MQ + SUM_IP(MK-1))
      MIN_MT2 = SUM_NPJ(JLJI(MQ+1)-1) + 1
 
C  **** MS LABELS POSSIBLE STATES OF..
      DO 10010  MS = MIN_MS, MAX_MS
C  **** ... LAST PLACED PARTICLE.
 
C  **** INITIALIZE
        JZMAX(MS,MP) = 0
C
        TZMAX(MS,MP) = 0
        MIN_MT = MS + 1
        IF(MIN_MT.LT.MIN_MT2) MIN_MT = MIN_MT2
        DO 10011  MT = MIN_MT,SUM_NPJ(NJL)
        JZST_DUP(MT) = MZTW(MT)
        TZST_DUP(MT) = ITZTW(MT)
C        ENDDO
10011   CONTINUE
        DO 10012  MM=1,MP
         JZMX = -99
         TZMX = -99
C  ****  POINTS TO THE CURRENT PARTICLE
         MA = MQ + MM
         MIN_MT3 = SUM_NPJ(JLJI(MA)-1) + 1
         IF(MIN_MT.LT.MIN_MT3) MIN_MT = MIN_MT3
         MAX_MT = SUM_NPJ(JLJI(MA))
CD      print *,' MIN,MAX MT:',MIN_MT,MAX_MT
         DO 10013  MT = MIN_MT,MAX_MT
        IF(JZST_DUP(MT).GT.JZMX) THEN
          JZMX = JZST_DUP(MT)
          MT_JZ = MT
        ENDIF
        IF(TZST_DUP(MT).GT.TZMX) THEN
          TZMX = TZST_DUP(MT)
          MT_TZ = MT
        ENDIF
      IC = IC + 1
CD     IC_MP = IC_MP + 1
C  **** (OVER MT)
C  **** ENDDO
10013    CONTINUE
         JZMAX(MS,MP) = JZMAX(MS,MP) + JZMX
         TZMAX(MS,MP) = TZMAX(MS,MP) + TZMX
         JZST_DUP(MT_JZ) = -99
         TZST_DUP(MT_TZ) = -99
C **** (OVER MM)
C **** ENDDO
10012   CONTINUE
 
C  **** (OVER MS)
C  **** ENDDO
10010 CONTINUE
CD     print *,' LOOPS OVER MT FOR THIS MP =',IC_MP
C **** (OVER MP)
C **** ENDDO
10009 CONTINUE
 
CD     print 200,'JZMX',((JZMAX(I,J),I=1,12),J=1,3)
200   FORMAT(' ',A4,/,12(12I3,/))
CD     print 200,'TZMX',((TZMAX(I,J),I=1,12),J=1,3)
 
      IPOINT = SUM_NPJ(JLJI(1)-1) + 1
      JL = JLJI(1)
      JIPART=1
      IMZ=0
      ITZ=0
      NST = SUM_NPJ(NJL)
 
500   WHERE(JIPART)=IPOINT
      IMZ = IMZ + MZTW(IPOINT)
      ITZ = ITZ + ITZTW(IPOINT)
 
C ****  THIS IS THE LAST ONE
      IF(JIPART.EQ.NPTCL) THEN
CD       print 510,IMZ,ITZ
510     FORMAT(' LAST PTCL : IMZ, ITZ =',2I4)
        LQ = 0
        DO 10014  I=1,NPTCL
         LQ = LQ + LQU (WHERE(I))
C        ENDDO
10014   CONTINUE
        IF (IMZ-2.EQ.IMZSA.AND.ITZ.EQ.ITZS.AND.(MOD(LQ+KPAR,2).EQ.0))THE
     1N
         NDUD=NDUD+1
C  **** check if Jz+1 basis dim diff from zero
         MLOGICAL=.TRUE.
C  **** IMZ-2.EQ.IMZSA
        END IF
      ITZ=ISIGN_TZ*ITZ
      IF((IMZ.LT.IMZSA).OR.(ITZ.LT.ITZSA)) GO TO 48
CA  ONLY JVAL,TVAL MORE ABOVE MAX.
      IF((IMZ.GT.IMZSA+2*NO_JVAL).OR.(ITZ.GT.ITZSA+2*NO_TVAL))GO TO 48
C  INCREMENT TABLE OF NUMBER OF STATES POSSIBLE WITH IMZ AND ITZ,
C  AND NPTCL PARTICLES WITHIN THIS PARTITI0N
      NMZTZ(IP,(IMZ-IMZSA)/2+1,(ITZ-ITZSA)/2+1)=
     1  NMZTZ(IP,(IMZ-IMZSA)/2+1,(ITZ-ITZSA)/2+1)+1
48    ITZ=ITZ*ISIGN_TZ
      IF (IMZ.GT.MAXMZ(IP)) MAXMZ(IP)=IMZ
C **** SEE IF IT HAS THE CORRECT JZ
      IF (IMZ.NE.IMZS) GO TO 600
      IF (ITZ.GT.MAXTZ(IP)) MAXTZ(IP)=ITZ
C **** SEE IF IT HAS THE CORRECT TZ
      IF (ITZ.NE.ITZS) GO TO 600
C **** CHECKS THE PARITY
      IF (MOD(LQ+KPAR,2).NE.0) GO TO 600
C
C  IT'S A GOOD BASIS STATE SO...
 
        IGOOD = IGOOD+1
C  CONVERT TO BIT PATTERN
        CALL LIB_ZEROX(IPATRN,NLWRDS)
cxx      do 551 i = 1,nlwrds
cxx 551  ipatrn(i) = 0
 

        write(formnptcl,'(i3)') nptcl
        format1 = '(2(1X,I12),//'//formnptcl//'(5X,I12),/)'
c1234  FORMAT(2(1X,I12),//,<NPTCL>(5X,I12),/)
      do 552 i = 1,nptcl
 552     IF(I11.EQ.1)WRITE(11,format1)NLWRDS,WHERE(I)-1,
     1(IPATRN(KH),KH=1,NPTCL)
c 552 IF(I11.EQ.1)WRITE(11,1234)NLWRDS,WHERE(I)-1,
 
      DO 10015  I=1,NPTCL
      IF(LIB_BTSX(IPATRN,WHERE(I)-1,NLWRDS))GOTO9000
 9000 CONTINUE
10015 CONTINUE
 
        IF(ILPT.EQ.25)CALL BWRITE(3,NSPS,NLWRDS,IPATRN)
        IF(IBAS.EQ.25)CALL BWRITE(6,NSPS,NLWRDS,IPATRN)
        NDIM(IP)=NDIM(IP)+1
        CALL LIB_ASSIGNX(IPATRN(1),IBASIS(1,NDIM(IP),IP),NLWRDS)
CA  CHECK WHETHER TO WRITE. NDIM IS THE NUMBER OF BASIS STATES FOR A
CA  GIVEN PARTITION THAT HAVE NOT YET BEEN WRITTEN ON DISK. NDIMA IS THE
CA  DIMENSION FOR A GIVEN PARTITION. SEE NDIM IS ZEROED (BELOW LABEL 52)
        IF (NDIM(IP).LT.NLWRDS_BLOCK) GO TO 650
        NDIMA(IP)=NDIMA(IP)+NDIM(IP)
        CALL LIB_ASSIGNX(IPART(1,IP),IDISK(1,NREC),N_WORDS)
C  IDISK SAYS WHAT PARTITION IS IN A GIVEN RECORD
CA  FIRST WRITE ON UNIT 1(AND FOLLOWING ONES, INSIDE LOOP AT LABEL 40)
        WRITE(1,REC=NREC)((IBASIS(IW,I,IP),IW=1,NLWRDS),
     1 I=1,NLWRDS_BLOCK)
      NREC=NREC+1
C  **** ERROR MESSAGE
        IF (NREC.GT.MAX_IDISK) GO TO 900
CA  AFTER WRITING ON DISK,ZERO THE BASIS TO START AGAIN
        CALL LIB_ZEROX(IBASIS(1,1,IP),NLWRDS*NDIM(IP))
        NDIM(IP)=0
        GO TO 650
      ENDIF
 
      JZREQ = IMZS - IMZ
      TZREQ = ITZS - ITZ
      IF(JZMAX(IPOINT,NPTCL-JIPART).LT.JZREQ) GOTO 600
CBAB FOLLOWING CHANGE MADE DUE TO ERROR FOUND BY AE IN JUNE 1985
CBAB  IF(TZMAX(IPOINT,NPTCL-JIPART).LT.TZREQ) GOTO 600
      IF(ITZS.GE.0.AND.TZMAX(IPOINT,NPTCL-JIPART).LT.TZREQ) GOTO 600
CBAB FOLLOWING LINE CHANGED OCT 25 1985 TO ELIMINATE ERROR IN
CBAB PROTON-NEUTRON CALCULATIONS
CBAB  IF(ITZS.LT.0.AND.-TZMAX(IPOINT,NPTCL-JIPART).GT.TZREQ) GOTO 600
      IF(NPTYPE.NE.'BOTH'.AND.ITZS.LT.0.
     1AND.-TZMAX(IPOINT,NPTCL-JIPART).GT.TZREQ) GOTO 600
      JIPART = JIPART+1
      JL = JLJI(JIPART)
      IPOINT = IPOINT+1
      IF(IPOINT.LE.SUM_NPJ(JL-1)) IPOINT =
     1        SUM_NPJ(JL-1)+1
CD     print *,'BUMP UP IPOINT & JIPART',IPOINT,JIPART
      GO TO 500
C* IF WE GET HERE, MUST MOVE LAST PARTICLE IF POSSIBLE
600   CONTINUE
CD     print *,'600 - TRY SOMETHING ELSE'
      IBAD = IBAD+1
      IF(IBAS.EQ.25) THEN
       CALL LIB_ZEROX(IPATRN(1),NLWRDS)
       DO 10016  I=1,JIPART
CZ         CALL LIB_BTSX(IPATRN(1),WHERE(I)-1,NLWRDS)
        IF(LIB_BTSX(IPATRN(1),WHERE(I)-1,NLWRDS)) GOTO 9001
9001    CONTINUE
C       ENDDO
10016  CONTINUE
       CALL BWRITE(6,NSPS,NLWRDS,IPATRN)
      ENDIF
650   IMZ = IMZ - MZTW(IPOINT)
      ITZ = ITZ - ITZTW(IPOINT)
C WORK OUT NUMBER OF PARTICLES LEFT TO ASSIGN IN THIS JLEVEL
CWEO      NPLTA = IPART_BYTE(JL,IP) - (JIPART - SUM_IP(JL-1))
      NPLTA = IPART(JL,IP) - (JIPART - SUM_IP(JL-1))
      IF( IPOINT+NPLTA .LT. SUM_NPJ(JL) ) THEN
       IPOINT = IPOINT+1
CD      print *,'BUMP UP IPOINT',IPOINT
       GO TO 500
C              CAN'T MOVE THIS ONE
      ELSE
       JIPART = JIPART-1
CD      print *,'BACK TO JIPART =',JIPART
C **** FINISHED
       IF(JIPART.LE.0) GO TO 805
       IPOINT = WHERE(JIPART)
       JL = JLJI(JIPART)
CD      print *,' ... AND IPOINT =',IPOINT
       GOTO 650
      ENDIF
805   NTRIAL = IGOOD + IBAD
CD     print 810,IGOOD,NTRIAL
810   FORMAT('0 NUMBER OF GOOD BASIS STATES =',I4,/
     1      '            TRIAL STATES      =',I4)
 
C  **** end of do loop over all possible partitions
80    CONTINUE
      NTOT=0
CA  IT HAS NOW OBTAINED ALL BASIS STATES
      DO 84 IP=1,NPART
      NDIMA(IP)=NDIMA(IP)+NDIM(IP)
      IF (NDIMA(IP).EQ.0) GO TO 84
      IF (NDIM(IP).EQ.0) GO TO 83
      CALL LIB_ASSIGNX(IPART(1,IP),IDISK(1,NREC),N_WORDS)
CA  WRITES REMAINING ONES,THAT IS THOSE WITH NDIM LESS THAN NLWRDS_BLOCK
      WRITE(1,REC=NREC) ((IBASIS(IW,I,IP),IW=1,NLWRDS),
     1I=1,NLWRDS_BLOCK)
      NREC=NREC+1
C **** ERROR MESSAGE
      IF (NREC.GT.MAX_IDISK) GO TO 900
      CALL LIB_ZEROX(IBASIS(1,1,IP),NLWRDS*NDIM(IP))
83    CONTINUE
CA  NTOT IS THE TOTAL NUMBER OF M-SCHEME VECTORS FOR ALL PARTITIONS
      NTOT=NTOT+NDIMA(IP)
      DO 184 IJ=1,NO_JVAL
      DO 184 IT=1,NO_TVAL
CA  WORKS OUT DIMENSION FOR GOOD J AND T BASIS
      NMZTZ(IP,IJ,IT)=
     1 NMZTZ(IP,IJ,IT)-NMZTZ(IP,IJ+1,IT)
     2 -NMZTZ(IP,IJ,IT+1)+NMZTZ(IP,IJ+1,IT+1)
      NJTT(IJ,IT)=NJTT(IJ,IT)+NMZTZ(IP,IJ,IT)
184   CONTINUE
84    CONTINUE
C  GET RID OF ZERO DIMENSION PARTITIONS
C  SET UP FIRST_RECORD TO HOLD NO OF FIRST RECORD FOR IPART(I)
      N=1
      II=0
      DO 98 III=1,NPART
CA  CHECK THE DIMENSION FOR A GIVEN PARTITION
      IF (NDIMA(III).EQ.0) GO TO 98
      II=II+1
      CALL LIB_ASSIGNX(IPART(1,III),IPART(1,II),N_WORDS)
CWEO      WRITE(40,11101)(IPART(KP,II),KP=1,N_WORDS)
CWEO11101 FORMAT(1X,<N_WORDS>(I9,1X))
      NDIMA(II)=NDIMA(III)
      NDIM(II)=NDIM(III)
C **** SEE 5TH WRITE(21)
      IFIRST_REC(II)=N
      MAXMZ(II)=MAXMZ(III)
      MAXTZ(II)=MAXTZ(III)
      DO 95 IJ=1,NO_JVAL
      DO 95 IT=1,NO_TVAL
95    NMZTZ(II,IJ,IT)=NMZTZ(III,IJ,IT)
CA  THIS "TWELVE" BELOW BECAUSE OF RUBBISH BEFORE IBASA AT LABEL 106
CA  NO. OF LONG WORDS USED ARE 12 PLUS NUMBER BASIS STATES FOR PARTITION
CA  FOLLOWING PARTITION STARTS AT ND
      ND=NDIMA(II)+TWELVE
C **** SEE TWO BELOW LABEL 84
96    N=N+1
CA  NOW WORKS OUT HOW MANY RECORDS THIS PARTITION NEEDS,AND STORES IT
CA  IN N(ABOVE)
      ND=ND-NLWRDS_BLOCK
      IF (ND.GT.0) GO TO 96
98    CONTINUE
CA  NPART-II is the number of partitions with zero dimension
C ****  NPART IS NOW THE NO. OF PARTITIONS WITH NO ZERO DIMENSION
      NPART=II
      IF (NPART.EQ.0) GO TO 111
C  NEED TO KNOW ORDER OF PARTITIONS BY SIZE
      DO 94 K=1,NPART
      J=1
      IF (NPART.LT.2) GO TO 93
      DO 92 I=2,NPART
CA  IT NOW FINDS THE ORDER,SEE ILARGE AT LABEL 94
      IF (NDIMA(I).LT.NDIMA(J)) J=I
92    CONTINUE
CA  FOR K=1,WE STORE THE PARTITION NUMBER FOR THE SMALLEST DIMENSION
CA  WE THEN CARRY ON DO LOOP NO.94
C ****   SEE FIRST WRITE(22)
93    IORDER_PAR(K)=J
C ****  USED AL LABEL 99
      NDIMA_KEEP(J)=NDIMA(J)
94    NDIMA(J)=ILARGE
 
      DO 99 I=1,NPART
99    NDIMA(I)=NDIMA_KEEP(I)
      IF (NDIMA(IORDER_PAR(NPART)).GT.MAX_MSCHEME) GO TO 925
CA  CHECK IF IT IS A CORE
1050  IF (NPTCL.GT.0) GO TO 1060
      NPART=1
      NDIMA(1)=1
      IORDER_PAR(1)=1
      IFIRST_REC(1)=1
      IF(NPART.GT.REC_LENGTH)STOP ' ***** FATAL ERROR IN MAIN: NPART sho
     1uld
     1be for a core *****'
1060  BAS2='.bas'
      NPOS_BAS=INDEX(BASFIL,' ')-1
      BASF=BASFIL(1:NPOS_BAS)//'.bas'
      IRBAB=1
 
C  General information file
      CALL OPEN_FILE(22,BASFIL,'.inf','NEW','UFRM')
      IF(ILPT.EQ.2) OPEN(UNIT=32,FILE=BASFIL(1:NPOS_BAS)//'.lnf',
     &STATUS='NEW')
      MREADBAS=IMZS
C **** set up to call READBAS.FOR at later stages
      IF(MLOGICAL)THEN
      DO 10018  IW=1,NPART
      IF(MAXMZ(IW).GT.MREADBAS)MREADBAS=MAXMZ(IW)
C      END DO
10018 CONTINUE
C **** IF(MLOGICAL)
      END IF
C  PREDICT and PROJ will not open JZ=JZ+1 file if M=JAY
      WRITE(22) SPSF,NJL,(SHELL(I),I=1,NJL),NLWRDS,ZERO,IVERS,
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1(NOSCJL(I),I=1,NOSC),NPTCL,
     1IMZS,ITZS,KPAR,NPART,NSPS,
     1SUM_NPJ,MREADBAS
      IF(ILPT.EQ.2)
     1WRITE(32,*) SPSF,NJL,(SHELL(I),I=1,NJL),NLWRDS,ZERO,IVERS,
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1(NOSCJL(I),I=1,NOSC),NPTCL,
     1IMZS,ITZS,KPAR,NPART,NSPS,
     1SUM_NPJ,MREADBAS
C **** HOLDS THE ORDER
      WRITE(22)(IORDER_PAR(I),I=1,NPART)
      IF(ILPT.EQ.2)WRITE(32,*)(IORDER_PAR(I),I=1,NPART)
C ****  partitions
      WRITE(22)N_WORDS,((IPART(J,I),J=1,N_WORDS),I=1,NPART)
      IF(ILPT.EQ.2)
     1WRITE(32,*)N_WORDS,((IPART(J,I),J=1,N_WORDS),I=1,NPART)
 
      IF(IPA.EQ.0)WRITE(6,379) BASFIL,BASFIL
      IF(IPA.EQ.0)GOTO847
      WRITE(6,377) BASFIL
377   FORMAT(1X,'Ordered allowed partitions written to file: ',A9,'
     1.PAB')
      WRITE(6,378) BASFIL
378   FORMAT(1X,'Ordered partitions and their dimensions in: ',A9,'
     1.PAC')
379   FORMAT(1X,'If ordered allowed partitions for files ',A6,'
     1.PAB and ',A6,'.PAC are desired,',/,1X,'set IPA = 1')
      CALL OPEN_FILE(44,BASFIL,'.pab','NEW','FORM')
      CALL OPEN_FILE(45,BASFIL,'.pac','NEW','FORM')
      DO 844 I = NPART,1,-1
      IF(NMZTZ(IORDER_PAR(I),1,1).EQ.0) GO TO 844
      WRITE(44,845) (IPART(J,IORDER_PAR(I)),J=1,NJL)
845   FORMAT(1X,100(I2,1X))
CEKW *** ADDED 921114 TO GIVE D(J)*D(M) *****
      NHEIR = NMZTZ(IORDER_PAR(I),1,1)*NDIMA(IORDER_PAR(I))
      WRITE(45,846) NHEIR,NMZTZ(IORDER_PAR(I),1,1),
     1NDIMA(IORDER_PAR(I)),(IPART(J,IORDER_PAR(I)),J=1,NJL)
846   FORMAT(1X,I6,1X,I6,1X,I6,1X,100(I2,1X))
844   CONTINUE
      CLOSE(UNIT=44)
      CLOSE(UNIT=45)
847   CONTINUE
C **** dimensions
      WRITE(22)(NDIMA(I),I=1,NPART)
      IF(ILPT.EQ.2)WRITE(32,*)(NDIMA(I),I=1,NPART)
C **** first record of any given partitioBA
      WRITE(22)(IFIRST_REC(I),I=1,NPART)
      IF(ILPT.EQ.2)WRITE(32,*)(IFIRST_REC(I),I=1,NPART)
      CLOSE(22)
      IF(ILPT.EQ.2) CLOSE(32)
 
CA    NOW WRITE THE BASIS FILE IN AN ORDERLY WAY, TO BE READ BACK IN PROJ.
CA    IT READS THE UNORDERED  BASIS FILE FROM UNIT 1 .
CVAX      OPEN(UNIT=21,FILE=BASF,STATUS='NEW',FORM='UNFORMATTED',
CVAX     1ACCESS='DIRECT',ORGANIZATION='RELATIVE',RECL=REC_LENGTH,
CVAX     1ASSOCIATEVARIABLE=IRBAB)
      CALL OPEN_BASIS(21,BASFIL,'.bas','NEW',NLWRDS)
      IF(ILPT.EQ.2) OPEN(UNIT=31,FILE=BASFIL//'.las',STATUS='NEW')
      IF (NPTCL.GT.0) GO TO 1070
CA  IT IS A CORE, SO:
      NDIM2=1
      NMZTZ(1,1,1)=1
      III=1
      WRITE(21,REC=IRBAB) NDIM2,((NMZTZ(III,IJ,IT),IJ=1,NO_JVAL),
     1IT=1,NO_TVAL),  MAXMZ(III),MAXTZ(III)
      IF(ILPT.EQ.2)
     1WRITE(31,*) NDIM2,((NMZTZ(III,IJ,IT),IJ=1,NO_JVAL),
     1IT=1,NO_TVAL),  MAXMZ(III),MAXTZ(III)
C **** MAXIMUM VALUES FOR JZ AND TZ
 
      CALL TIMER('STOP')
      WRITE(6,120)
120   FORMAT(/)
      CALL EXIT
1070  CONTINUE
      NOREC_UNIT1=NREC-1
C
C  READ IN BASIS STATES AND WRITE TO BASIS FILE PARTITION BY PARTITION
C
      DO 109 III=1,NPART
      J=NLWRDS_BLOCK
      DO 103 N=1,NOREC_UNIT1
C **** TESTS IF SAME BASIS
CWEO      WRITE(40,11103)(IDISK(KP,N),KP=1,N_WORDS),
CWEO     1(IPART(KP,III),KP=1,N_WORDS)
CWEO11103 FORMAT(/,1X,<N_WORDS>(I9,1X),/,1X,<N_WORDS>(I9,1X))
      IF(.NOT.LIB_EQX(IDISK(1,N),IPART(1,III),N_WORDS))GO TO 103
      NREC=N
      READ(1,REC=NREC)((IBASA(IW,I+J),IW=1,NLWRDS),I=1,NLWRDS_BLOCK)
      J=J+NLWRDS_BLOCK
      IF ((J-NLWRDS_BLOCK).GE.NDIMA(III)) GO TO 105
103   CONTINUE
105   NDIM2=1
107   IF (NDIM2.GE.NDIMA(III)) GO TO 106
      NDIM2=NDIM2*2
      GO TO 107
106   CONTINUE
CJSW
CJSW  WE NOW HAVE TO SORT BASIS BECAUSE PREDICT/PROJ EXPECTS IT TO BE
CJSW  IN INCREASING ORDER.
CJSW  SHELL-METZNER SORT
CJSW
C *** NO NEED TO REORDER UNIT PARTITION
      IF(NDIMA(III).EQ.1) GOTO 4370
 
      J = NLWRDS_BLOCK
      JUMP = NDIMA(III)
4310  JUMP = JUMP / 2
C **** FINISHED
      IF (JUMP .EQ. 0) GOTO 4350
      M2 = NDIMA(III) - JUMP
      DO 4330 MJ = 1, M2
        MI = MJ
4320    M3 = MI + JUMP
        IF (LIB_LEX(IBASA(1,J+MI),
     1     IBASA(1,J+M3),NLWRDS)) GO TO 4330
CJSW  SWAP OVER ELEMENTS MI AND M3
        CALL LIB_ASSIGNX(IBASA(1,J+MI),MAX_BAS(1),NLWRDS)
        CALL LIB_ASSIGNX(IBASA(1,J+M3),IBASA(1,J+MI),NLWRDS)
        CALL LIB_ASSIGNX(MAX_BAS(1),IBASA(1,J+M3),NLWRDS)
 
        MI = MI - JUMP
        IF (MI .GT. 0) GO TO 4320
4330  CONTINUE
      GO TO 4310
C **** FINISHED SORTING, NOW WRITE IT OUT TO .BAS FILE
4350  CONTINUE
 
4370  CONTINUE
      WRITE(21,REC=IRBAB) NDIM2,((NMZTZ(III,IJ,IT),IJ=1,NO_JVAL),
     1IT=1,NO_TVAL),  MAXMZ(III),MAXTZ(III),
     1((IBASA(IW,I),IW=1,NLWRDS),I=NLWRDS_BLOCK+1,2*NLWRDS_BLOCK-TWELVE)
      IF(ILPT.EQ.2)WRITE(31,*) NDIM2,((NMZTZ(III,IJ,IT),IJ=1,NO_JVAL),
     1IT=1,NO_TVAL),  MAXMZ(III),MAXTZ(III),
     1((IBASA(IW,I),IW=1,NLWRDS),I=NLWRDS_BLOCK+1,2*NLWRDS_BLOCK-TWELVE)
      IRBAB=IRBAB+1
C      WRITE(11,20101) NDIM2,((NMZTZ(III,IJ,IT),IJ=1,NO_JVAL),
C     1IT=1,NO_TVAL),MAXMZ(III),MAXTZ(III),IRBAB,III
C20101 FORMAT(1X,I10,/,3(1X,10I8,/),1X,4I10)
 
      JDIMA=NLWRDS_BLOCK-TWELVE
      IF (NDIMA(III).LE.JDIMA) GO TO 109
      J=2*NLWRDS_BLOCK-TWELVE
CA  SECOND AND SUBSEQUENT WRITES IF BASIS DIMENSION IS LARGE
108   CONTINUE
      WRITE(21,REC=IRBAB)((IBASA(IW,I+J),IW=1,NLWRDS),I=1,NLWRDS_BLOCK)
      IF(ILPT.EQ.2)
     1WRITE(31,*)((IBASA(IW,I+J),IW=1,NLWRDS),I=1,NLWRDS_BLOCK)
      J=J+NLWRDS_BLOCK
      IRBAB=IRBAB+1
      IF (NDIMA(III).GT.(J-NLWRDS_BLOCK)) GO TO 108
109   CONTINUE
      CLOSE(UNIT=21)
      IF(ILPT.EQ.2)CLOSE(UNIT=31)
111   CLOSE(UNIT=1,STATUS='DELETE')
 
      IF (ILPT.GT.0.AND.NJL.LT.17) WRITE(3,
     1'(/''  No., partition, m-dim, j-dim (J,J+1,J+2)'',/,
C     21000(1X,I3,1X,'//FORMNJL//'I3,1X,I6,1X,1(3I4,1X),/))')
     21000(1X,I4,'//FORMNJL//'I3,1X,I6,1X,1(3I4,1X),/))')
     3(I,(IPART(J,I),J=1,NJL),NDIMA(I),((NMZTZ(I,IJ,IT),IJ=1,3),IT=1,1),
     4I=1,NPART)
      MN = NJL - 16
      MM = 3*(16 - MN)
      write(cmm,'(i3)') mm
      write(cmn,'(i3)') mn
      format2 = '(/'' No.,'','//cmn//'x,'' partition,'','//formnjl//
     1'x,'' m-dim, j-dim (J, J+1, J+2)'',/,'//
     2'1000(1x,i4,16i3,/,5x,'//cmm//'x,'//cmn//'i3,1x,i6,1x,'//
     3'1(3i4,1x),/))'
c     IF(ILPT.GT.0.AND.NJL.GT.16)WRITE(3,112)
      IF(ILPT.GT.0.AND.NJL.GT.16)WRITE(3,format2)
     1(I,(IPART(J,I),J=1,16),(IPART(J,I),J=17,NJL),
     2NDIMA(I),((NMZTZ(I,IJ,IT),IJ=1,3),IT=1,1),I=1,NPART)
c 112 FORMAT(/'  No.,',<MN>X,' partition,',<NJL>X,' m-dim,
c    1j-dim (J,J+1,J+2)',/,
c    21000(1X,I4,16I3,/,5X,<MM>X,<MN>I3,1X,I6,1X,1(3I4,1X),/))
      IF (ILPT.GT.0) WRITE(3,110) NTRIAL,NTOT,NPART,IC
      WRITE(6,110) NTRIAL,NTOT,NPART,IC
110   FORMAT(/' NO. OF TRIAL PATTERNS          :',I11/
     2      ' M-SCHEME BASIS DIMENSION       :',I11/
     3      ' NO. OF BASIS PARTITIONS STORED :',I11/
     4      ' NO. LOOPS FOR TABLE LOOKUP     :',I11)
      T(1)=ITZSA
      JAYA(1)=IMZSA
      DO 113 I=2,NO_JVAL
      JAYA(I)=JAYA(I-1)+2
113   CONTINUE
      DO 10019  I=2,NO_TVAL
      T(I)=T(I-1)+2
C      END DO
10019 CONTINUE
      IF (ILPT.GT.0) WRITE(3,114) (JAYA(I),I=1,NO_JVAL),
     1  (T(IT),(NJTT(IJ,IT),IJ=1,NO_JVAL),IT=1,NO_TVAL)
      WRITE(6,114) (JAYA(I),I=1,NO_JVAL),
     1  (T(IT),(NJTT(IJ,IT),IJ=1,NO_JVAL),IT=1,NO_TVAL)
CWEO114   FORMAT(//' NO. OF STATES WITH'/5X,' 2*J :',<NO_JVAL>I6//
CWEO     2  <NO_TVAL>(1X,'2*T =',I3,' :',<NO_JVAL>I6,/))
114   FORMAT(/' NO. OF STATES WITH'/5X,' 2*J :',10I6//
     23(1X,'2*T =',I3,' :',10I6,/))
      CALL TIMER('STOP')
      WRITE(6,120)
      CALL EXIT
C *** ***  ***  ***  ***  ***  ***  ***
CA  END OF BASIS. NEXT ERROR MESSAGES
900   WRITE(6,901)
901   FORMAT(' DIMENSION OF IDISK TOO SMALL,
     1 INCREASE MAX_IDISK')
      CLOSE(UNIT=1,STATUS='DELETE')
      CALL TIMER('STOP')
      WRITE(6,120)
      STOP ' ***** FATAL ERROR in MAIN *****'
CLIPAS940   WRITE(6,941)IMZS,ITZS,NPTCL
CLIPAS941   FORMAT(' ERROR IN INPUT : IMZS,ITZS,NPTCL = ',10I5)
CLIPAS      GO TO 15
925   WRITE(6,926)NDIMA(IORDER_PAR(NPART)),MAX_MSCHEME
      WRITE(6,942)(IPART(J,1),J=1,NJL)
942   FORMAT(1X,40(I2,1X))
926   FORMAT(' PARTITION TOO BIG, NDIM, MAX_MSCHEME = ',2I10)
      CALL TIMER('STOP')
      WRITE(6,120)
      STOP ' ***** FATAL ERROR in MAIN *****'
      END
