C
C
C  SUBROUTINE CALLED BY BASIS TO
C  WORK OUT ALL POSS PARTITIONS
C
C
CA  MXFIL(I)=MAXIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
CA  MNFIL(I)=MINIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
      SUBROUTINE WOTPTS 
      INCLUDE 'macfor.inc' 
      INCLUDE 'param.inc' 
      INCLUDE 'bascom.inc' 
      COMMON/CIALL/IALL
      DIMENSION MIN(MAX_NJL),MIN_O(MAX_NJL),MAX(MAX_NJL),MAX_O(MAX_NJL) 
      INTEGER index(MAX_NJL),low(MAX_NJL),high(0:MAX_NJL)
      INTEGER step(MAX_NJL),NLEFT1(MAX_NJL)
      INCLUDE 'data.inc' 
C
C  WORK OUT ALL POSSIBLE PARTITIONS
CA    DOESNT USE ANY BASIS STATE 
      NLEFT=NPTCL
      DO 34 I=1,NJL 
34    NLEFT=NLEFT-MNFIL(I) 
      IF (NLEFT.LT.0) STOP ' ***** Fatal Error in WOTPTS:  
     1RESTRICTIONS TOO SEVERE-NOT ENOUGH PARTICLES *****' 
      NPART=0 

CJSW - FIX UP CASE WHERE NJL = 1
      IF (NJL .EQ. 1) THEN 
        NPART = 1 
CHECK PARITY
        KPARIT=KPARQ(1)*NPTCL 
        IF(MOD(KPARIT,2).NE.MOD(KPAR,2))NPART=0 
CWEO        IPART_BYTE(1,1) = NPTCL 
        IPART(1,1) = NPTCL 
        GOTO 370 
      ENDIF 
C
C
CEO   ADDED TO REPLACE NUMBER OF DO LOOPS 
C         WILL DO AS MANY SUBSHELLS AS MAX_NJL


      nused_loops=NJL-1
      DO 10001  i=1,nused_loops
      low(i)=0
      step(i)=1
      index(i)=low(i)
C      END DO
10001 CONTINUE    
      DO 10002  i=1,nused_loops
      NUMP(i+1)=MNFIL(i+1)
      NLEFT1(i+1)=NLEFT
      high(i)=MIN0(MXFIL(i+1)-MNFIL(i+1),NLEFT1(i+1))
C      END DO
10002 CONTINUE    
      DO 10003  i=1,nused_loops+1
C      end do
10003 CONTINUE    
      GOTO 1002

1001  continue
      DO 10004  i=1,j
      NUMP(j+2-i)=MNFIL(j+2-i)+index(j+1-i)
      NLEFT1(j+1-i)=NLEFT1(j+2-i)-index(j+1-i)
      high(j-i)=MIN0(MXFIL(j+1-i)-MNFIL(j+1-i),NLEFT1(j+1-i))
C      END DO
10004 CONTINUE    

1002  NUMP(1)=MNFIL(1)+NLEFT1(2)-index(1) 
      IF (NUMP(1).GT.MXFIL(1)) GO TO 37 
      K=1 
      KPARIT=0 
      IPT=0 
CA  DO OVER MAJOR SHELL
      DO 361 I=1,NOSC 
      NPTOSC=0 
CA  DO OVER ORBITALS FOR A GIVEN MAJOR SHELL
      DO 36 J=1,NOSCJL(I) 
      NPTOSC=NPTOSC+NUMP(K) 
      IF (NPTOSC.GT.MXOSC(I)) GO TO 37 
CA  PARITY OF THE PATTERN
      KPARIT=KPARIT+KPARQ(K)*NUMP(K) 
36    K=K+1 
      IF (NPTOSC.LT.MNOSC(I)) GO TO 37 
361   CONTINUE 
      IF(NPprint.NE.'BOTH'.AND.SUMRES.NE.'y')GOTO 3611


      DO 3611 KK=1,NOSCJL(1)
      DO 3610 JJ=NOSCJL(1)+1,NJL
      IF(RESUM(KK,JJ).EQ.'Y')THEN
      IF((NUMP(KK)+NUMP(JJ)).LT.MNSUM(KK,JJ)) GO TO 37
      IF((NUMP(KK)+NUMP(JJ)).GT.MXSUM(KK,JJ)) GO TO 37
      ELSE
      CONTINUE
      END IF
3610  CONTINUE
3611  CONTINUE



951   IF (MOD(KPARIT,2).NE.MOD(KPAR,2)) GO TO 37
CBAB  IF(.NOT.BPAIRS)  GOTO 71 
      IF(IBPAIRS.EQ.0) GOTO 71 
C  Now test if odd number of particles in each J-orbit
CBAB  print *,' BPAIRS is true ' 
      ntest=0 
      do 70 iw=1,njl 
      if(mod(nump(iw),2).eq.0)goto 70 
      ntest=ntest+1 
      if(ntest.gt.max_bpairs)goto 37 
70    continue 
CA  THE PATTERN HAS A NUMBER OF PARTICLES (OR HOLES) NPTOSC IN ALL GIVEN MAJOR 
CA  SHELL AND SATIFIES THE RESTRICTIONS (IF ANY) IN THE MAJOR SHELL AND 
CA  THE PARITY SO INCREMENT THE NUMBER OF PARTITIONS;
71    CONTINUE 
      NPART=NPART+1 
C      print 7778,(NUMP(KKK),KKK=1,6)
C7778  FORMAT(20X,6I3)
      IF (NPART.GT.MAX_NPART) STOP ' ***** Fatal Error in WOTPTS:  
     1TOO MANY PARTITIONS *****' 
CA  NEXT DO LOOP IS MOST IMPORTANT: IT WORKS OUT THE PARTITION
      DO 10005  K=NJL,1,-1 
CWEO      IPART_BYTE(K,NPART)=NUMP(K) 
      IPART(K,NPART)=NUMP(K) 

      IF(NPART.EQ.1) THEN 
      MIN(K) = NUMP(K) 
      MAX(K) = NUMP(K) 
      ELSE 
      IF(NUMP(K).LT.MIN(K)) MIN(K) = NUMP(K) 
      IF(NUMP(K).GT.MAX(K)) MAX(K) = NUMP(K) 
      END IF       

C      END DO 
10005 CONTINUE    
37    CONTINUE 

      DO 10006  j=1,nused_loops
      index(j)=index(j)+step(j)
      IF(index(j).GT.high(j))THEN
       index(j)=low(j)

      else
      GOTO 1001
      END IF

C      END DO
10006 CONTINUE    








      DO 130 IW1 = 1,NPART 
      IW4 = 0 
      DO 130 IW2 = 1,NOSC 
      NPTOSC = 0 
      DO 131 IW3 = 1,NOSCJL(IW2) 
      IW4 = IW4 + 1 
CWEO      NPTOSC = NPTOSC + IPART_BYTE(IW4,IW1) 
      NPTOSC = NPTOSC + IPART(IW4,IW1) 
131   CONTINUE 
      IF(IW1.EQ.1) THEN 
      MAX_O(IW2) = NPTOSC 
      MIN_O(IW2) = NPTOSC 
      ELSE 
      IF(NPTOSC.LT.MIN_O(IW2)) MIN_O(IW2) = NPTOSC 
      IF(NPTOSC.GT.MAX_O(IW2)) MAX_O(IW2) = NPTOSC 
      END IF 
130   CONTINUE 

      DO 10007  IW = 1,NOSC 
      IF(MAX_O(IW).LT.MXOSC(IW)) THEN 
      IOSC = 1 
      MXOSC(IW) = MAX_O(IW) 
      END IF 
      IF(MIN_O(IW).GT.MNOSC(IW)) THEN 
      IOSC = 1 
      MNOSC(IW) = MIN_O(IW) 
      END IF 
C      END DO 
10007 CONTINUE    

      DO 10008  IW = 1,NJL 
      IF(MAX(IW).LT.MXFIL(IW)) THEN 
      IJL = 1 
      MXFIL(IW) = MAX(IW) 
      END IF 
      IF(MIN(IW).GT.MNFIL(IW)) THEN 
      IJL = 1 
      MNFIL(IW) = MIN(IW) 
      END IF 
C      END DO 
10008 CONTINUE    

370   IF (ILPT.GT.0.OR.NPART.EQ.0) 
CBAB     1print 375, NPART,((IPART_BYTE(J,I),J=NJL,1,-1),I=1,MIN0(110,NPART))
CWEO     1print 375, NPART,((IPART_BYTE(J,I),J=1,NJL),I=1,MIN0(110,NPART))
     1print 375, NPART,((IPART(J,I),J=1,NJL),I=1,MIN0(110,NPART))
375   FORMAT(' NO. OF PARTITIONS, PARTITIONS : '
     1,I4/100(1X,4(<NJL>I2,3X)/))
      IF (NPART.EQ.0) STOP ' ***** Fatal Error in WOTPTS, Hint: Check 
     1 restrictions and/or Jz,Tz and Par. *****' 
      IF(IOSC.AND.RESTYP.EQ.'M'.OR.RESTYP.EQ.'B') THEN 
      WRITE(*,310) 
      DO 10009  IDUD = 1,NOSC 
      WRITE(*,300) IDUD,MNOSC(IDUD),MXOSC(IDUD) 
C      END DO 
10009 CONTINUE    
310   FORMAT(/' ***** WARNING: Minimum and Maximum No. of Particles in 
     1 each MAJOR SHELL really is:') 
300   FORMAT(' Major Shell No. ',I2,' = ',2I5) 
      WRITE(*,320) 
320   FORMAT(' ************* O.K.? ************************** '/) 
C               IF(IOSC) 
      END IF   
      IF(IJL.AND.RESTYP.EQ.'S'.OR.RESTYP.EQ.'B') THEN 
      WRITE(*,311) 
      DO 10010  IDUD = 1,NJL 
      WRITE(*,312) SHELL(IDUD),MNFIL(IDUD),MXFIL(IDUD) 
C      END DO 
10010 CONTINUE    
311   FORMAT(/' ***** WARNING: Minimum and Maximum No. of Particles in 
     1each J-ORBIT really is: ') 
312   FORMAT(' In J-ORBIT',2X,A,' = ',2I5) 
      WRITE(*,320) 
C             IF(IJL) 
      END IF 

      RETURN 
      END 
