C
C
C  SUBROUTINE CALLED BY BASIS TO
C  WORK OUT ALL POSS PARTITIONS
C
C
CA  MXFIL(I)=MAXIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
CA  MNFIL(I)=MINIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
      SUBROUTINE WOTPART 
      IMPLICIT INTEGER (A-Z)
      INCLUDE 'macfor.inc'                
      INCLUDE 'param.inc'                
      PARAMETER (MAX_TBME = 10000)
      INCLUDE 'bascom.inc'                
      COMMON/LISTPARTM/
     1MIN(MAX_NJL),MIN_O(MAX_NJL),MAX(MAX_NJL),MAX_O(MAX_NJL)
      INTEGER jindex(MAX_NJL),low(MAX_NJL),high(0:MAX_NJL),
     1NLEFT1(MAX_NJL)
      INTEGER step(MAX_NJL),NUMPART(MAX_NPART,MAX_NJL),
     1NLAB(MAX_TBME,6),NUMPART2(MAX_NPART,MAX_NJL)
      REAL*8 BE(MAX_NPART),BEMAX,E,TBAV(MAX_NJL,MAX_NJL),
     1SPE(MAX_NJL),BEMIN
      REAL*8 TBME(MAX_TBME),DENOM,SF,EMAX,E2
      CHARACTER*13 INTNAME
      INCLUDE 'data.inc'                

      IF(ISOSPIN)THEN
      NJL2=NJL
      ELSE
      NJL2=NJL/2
      END IF

C
C  WORK OUT ALL POSSIBLE PARTITIONS
CA    DOESNT USE ANY BASIS STATE 
      NLEFT=NPTCL
      DO 34 I=1,NJL 
34    NLEFT=NLEFT-MNFIL(I) 
      IF (NLEFT.LT.0) STOP ' ***** Fatal Error in WOTPTS:  
     1RESTRICTIONS TOO SEVERE-NOT ENOUGH PARTICLES *****' 
      NPART=0 

CEO   ADDED TO REPLACE NUMBER OF DO LOOPS 
C         WILL DO AS MANY SUBSHELLS AS MAX_NJL

      MN=1

      nused_loops=NJL-1
      DO 10001  i=1,nused_loops
      low(i)=0
      step(i)=1
      jindex(i)=low(i)
C      END DO
10001 CONTINUE    
      DO 10002  i=1,nused_loops
      NUMP(i+1)=MNFIL(i+1)
      NLEFT1(i+1)=NLEFT
      high(i)=MIN0(MXFIL(i+1)-MNFIL(i+1),NLEFT1(i+1))
C      END DO
10002 CONTINUE    
      DO 10003  i=1,nused_loops+1
C      end do
10003 CONTINUE    
      GOTO 1002

1001  continue
      DO 10004  i=1,j
      NUMP(j+2-i)=MNFIL(j+2-i)+jindex(j+1-i)
      NLEFT1(j+1-i)=NLEFT1(j+2-i)-jindex(j+1-i)
      high(j-i)=MIN0(MXFIL(j+1-i)-MNFIL(j+1-i),NLEFT1(j+1-i))
C      END DO
10004 CONTINUE    

1002  NUMP(1)=MNFIL(1)+NLEFT1(2)-jindex(1) 
      IF (NUMP(1).GT.MXFIL(1)) GO TO 37 
      K=1 
      KPARIT=0 
      IPT=0 
CA  DO OVER MAJOR SHELL
      DO 361 I=1,NOSC 
      NPTOSC=0 
CA  DO OVER ORBITALS FOR A GIVEN MAJOR SHELL
      DO 36 J=1,NOSCJL(I) 
      NPTOSC=NPTOSC+NUMP(K) 
      IF (NPTOSC.GT.MXOSC(I)) GO TO 37 
CA  PARITY OF THE PATTERN
      KPARIT=KPARIT+KPARQ(K)*NUMP(K) 
36    K=K+1 
      IF (NPTOSC.LT.MNOSC(I)) GO TO 37 
361   CONTINUE 





951   IF (MOD(KPARIT,2).NE.MOD(KPAR,2)) GO TO 37
CA  THE PATTERN HAS A NUMBER OF PARTICLES (OR HOLES) NPTOSC IN ALL GIVEN MAJOR 
CA  SHELL AND SATIFIES THE RESTRICTIONS (IF ANY) IN THE MAJOR SHELL AND 
CA  THE PARITY SO INCREMENT THE NUMBER OF PARTITIONS;
        NPART=NPART+1
C      TYPE 7778,(NUMP(KKK),KKK=1,6)
C7778  FORMAT(20X,6I3)
      IF (NPART.GT.MAX_NPART) STOP ' ***** Fatal Error in WOTPTS:  
     1TOO MANY PARTITIONS *****' 
CA  NEXT DO LOOP IS MOST IMPORTANT: IT WORKS OUT THE PARTITION
      DO 10005  K=NJL,1,-1 
      NUMPART(NPART,K)=NUMP(K)

      IF(NPART.EQ.1) THEN 
      MIN(K) = NUMP(K) 
      MAX(K) = NUMP(K) 
      ELSE 
      IF(NUMP(K).LT.MIN(K)) MIN(K) = NUMP(K) 
      IF(NUMP(K).GT.MAX(K)) MAX(K) = NUMP(K) 
      END IF       

C      END DO 
10005 CONTINUE    

      DO 10006  K=NJL2,1,-1
      NUMPART2(NPART,K)=NUMP(K)+NUMP(K+NJL2)
C      END DO
10006 CONTINUE    


37    CONTINUE 

      DO 10007  j=1,nused_loops
      jindex(j)=jindex(j)+step(j)
      IF(jindex(j).GT.high(j))THEN
       jindex(j)=low(j)

      else
      GOTO 1001
      END IF

C      END DO
10007 CONTINUE    

      WRITE(6,3001)NPART
3001  FORMAT(1X,'NPART=',I3)
      JPOS=INDEX(INTFILE,' ')
      IF(JPOS.EQ.0)JPOS=10
      JPOS=JPOS-1
      INTNAME=INTFILE(1:JPOS)//'.int'
      CALL OPENINT(10,AREA_SPS,AREA_INT,INTNAME,0,IERR)
CBAB      OPEN(UNIT=10,NAME=INTFILE//'.INT',STATUS='OLD')
CBAB      CALL SKIPHEAD(10)

      CALL FREE_INT(10,1,INT_VAR,READ_ERR)
      NME=INT_VAR(1)
CWEO      READ(10,*)NME,(SPE(L),L=1,NJL2)
      DO 104 I=1,NME
      CALL FREE_INT(10,7,INT_VAR,READ_ERR)
      DO 13001 J=1,6
13001 NLAB(I,J)=INT_VAR(J)
      TBME(I)=INT_VAR(7)
104   CONTINUE
CWEO104   READ(10,*)(NLAB(I,J),J=1,6),TBME(I)
      CLOSE(UNIT=10)


      DO 105 I=1,NJL2
      DO 105 J=I,NJL2
      TBAV(I,J)=0.
      DENOM=0.
      DO 106 K=1,NME
      IF((NLAB(K,1).EQ.I).AND.(NLAB(K,2).EQ.J))GOTO 116
      IF((NLAB(K,1).EQ.J).AND.(NLAB(K,2).EQ.I))GOTO 116
      GOTO 106
116   IF((NLAB(K,1).EQ.NLAB(K,3)).AND.(NLAB(K,2).EQ.NLAB(K,4)))GOTO 117
      GOTO 106
117   TBAV(I,J)=TBAV(I,J)+(2.*NLAB(K,5)+1)*(2.*NLAB(K,6)+1)*TBME(K)
      DENOM=DENOM+(2.*NLAB(K,5)+1)*(2.*NLAB(K,6)+1)
106   CONTINUE
      TBAV(I,J)=TBAV(I,J)/DENOM
      TBAV(J,I)=TBAV(I,J)

105   CONTINUE


      DO 110 K=1,NPART
      BE(K)=0.
      DO 107 I=1,NJL2
      BE(K)=BE(K)+NUMPART2(K,I)*SPE(I)*SPE_NORM
     1+(NUMPART2(K,I)*(NUMPART2(K,I)-1)/2)*TBAV(I,I)*ME_NORM
      DO 108 J=I+1,NJL2
108   BE(K)=BE(K)+NUMPART2(K,I)*NUMPART2(K,J)*TBAV(I,J)*ME_NORM
107   CONTINUE
110   CONTINUE


      BEMAX=BE(1)
      BEMIN=BE(1)
      NMIN=1
      NMAX=1


      DO 111 K=2,NPART
      IF(BE(K).GT.BEMIN)THEN
      NMIN=K
      BEMIN=BE(K)
      END IF
      IF(BE(K).LT.BEMAX)THEN
      BEMAX=BE(K)      
      NMAX=K
      END IF
111   CONTINUE

      NPART1=NPART
      NPART=0
      DO 710 I=1,NPART1
      IF((BE(I)-BEMAX).GT.E_CUTOFF)GOTO 710
      NPART=NPART+1
      DO 711 K=1,NJL
CWEO711   IPART_BYTE(K,NPART)=NUMPART(I,K) 
711   IPART(K,NPART)=NUMPART(I,K) 
710   CONTINUE
      IF(NPART.EQ.0)STOP '**** FATAL ERROR IN WOTPART: 
     1HINT: CUTOFF RESTRICTION ARE TOO GREAT ****'
 259   RETURN
      END 
