C  SHELL MODEL PROGRAM
C  THIS PROGRAM APPLIES A TWO-BODY OPERATOR TO THE GOOD-MSCHEME VECTORS
C  THE RESULT IS A MATRIX <M1/H./O2>, SO ONLY
C  ONE GOOD J AND T BASIS ELEMENT IS NEEDED FOR EACH MATRIX ELEMENT.
C  THE OPERATOR(I.E. HAMILTONIAN) IS APPLIED TO |M1>s and result is
C  searched within m-scheme basis of /O2>, i.e. current partition (see
C  find subroutine in HOPER.
CA  SEE BASCOM.FOR FOR DETAILS OF CONSTANTS IN PARAMETER STATEMENTS
 
 
CBAB CHANGE FOR SDPFPN SPACE
cekw        PARAMETER (MAX_NPARTH=1000)    !910509 for pball
cekw Max_nparth is the "no. of non-zero hamiltonian partitions" in the
cekw log file for oper.
CBAB moved MAX_NPARTH to param.inc (May 1995)
C      PARAMETER (MAX_NPARTH=10000)
CBAB         PARAMETER (MAX_NPARTH=2000)
CBAB      PARAMETER (MAX_DIM=MAX_MSCHEME,
      PARAMETER (MAX_DIM=100000,
CEKW     1MAX_HDIM=5000,MAX_OPER_ELEMENTS= 300000)
C     1MAX_HDIM=5000,MAX_OPER_ELEMENTS=1600000)
c     1MAX_HDIM=5000,MAX_OPER_ELEMENTS=500000)
c  MAX_OPER_ELEMENTS moved to param.inc (May 1995)
     1MAX_HDIM=5000)
CVAX     1MAX_HDIM=5000,MAX_OPER_ELEMENTS= 200000)
CBAB      PARAMETER (MAX_NJTVEC=1000)
CBAB CHANGED FOR SDPFPN SPACE
CEKW      PARAMETER (MAX_NJTVEC=2000)   !910509 FOR PBALL
      PARAMETER (MAX_NJTVEC=20000)
CVAX      PARAMETER (MAX_ARRAY=50000,MAX_STORE=500000)
CBAB      PARAMETER (MAX_ARRAY=50000,MAX_STORE=325000)
CBAB      PARAMETER (MAX_ARRAY=50000,MAX_STORE=200000)
CBAB      PARAMETER (MAX_ARRAY=100000,MAX_STORE=200000)
CBAB MAX_ARRAY SHOULD BE THE MAXIMUM DIMENSION OF THE TOTAL MATRIX
CBAB OR THE THE LARGEST M-DIM IN A GIVEN PARTITION WHICH EVER IS LARGER
CBAB95      PARAMETER (MAX_ARRAY=200000,MAX_STORE=200000)
      PARAMETER (MAX_ARRAY=200000,MAX_STORE=2000000)
      PARAMETER (MAX_ARRAY2=500000)
c      PARAMETER MAX_ELEM_PART=30000 
      PARAMETER (MAX_ORTH=(MAX_NJT*(MAX_NJT+1))/2)
CA  MAX_ARRAY=MAXIMUM ALLOCATED SPACE FOR WORKING ARRAY
CA  MAX_STORE=MAXIMUM NO. H|M1> COEFFICIENTES ALLOWED IN HOPER.
      CHARACTER*13 BASF,SPSF(MAX_NJL),PRJF,INTF,OPF,REDF
      CHARACTER*9 PRJFIL,OPFIL,MATFIL,BASFIL,SHELL,SPSFIL,INTFIL
      CHARACTER*9 CHAR_VAR(30)
      COMMON/INTV/ INT_VAR(30),REAL_VAR(30)
      LOGICAL READ_ERR,ILOG
      REAL LIMIT
      LOGICAL EXIST,RET_STATUS,OPEN,OPEN1
      INTEGER *2 KW1,KW2
      INTEGER HANDLE,ZEROP(N_WORDS),ZERO,REC
      COMMON/DUD/LIMIT,NSPS(2)
      COMMON/PFIND/ NIPRT,NPRT2,IFINDP,IPART2(N_WORDS)
      COMMON/IPARTA/IPART(N_WORDS,MAX_NPART),IPRT(N_WORDS,MAX_NPART)
      COMMON/NAMES/PRJFIL,OPFIL(9),MATFIL,BASFIL,SPSF,INTF,
     1SHELL(MAX_NJL)
      COMMON/MATX/IT,NHPART,NDIMJ,NDIMT,NJL,JLTW(MAX_NJL),ENL(MAX_NJL),
     1ENLI(MAX_NJL,9),
     1IORD(MAX_NPART),NDIMA(MAX_NPART),NBLOCK(MAX_NPART),
     1NJTP(MAX_NPART),IMZS,ITZS,NREAD,NPTCL,KPAR,
     1MATDIM,  MNFIL(MAX_NJL),MXFIL(MAX_NJL),MNOSC(MAX_NOSC),
     1MXOSC(MAX_NOSC),NOSCJL(MAX_NOSC),NOSC,MAXNJT,JAY,NIPART
      COMMON/B2/IB2ST,MXNJT,N2JTP(MAX_NPART),N2JTP2(MAX_NPART),
     1IDEORD(MAX_NPART),KLOOKP(MAX_NPART)
      COMMON/BASCOM/NLWRDS,IPATRN(MAX_NLWRDS),JPATRN(MAX_NLWRDS),
     1ZERO(MAX_NLWRDS),IDUD(N_WORDS)
      COMMON/PARM1/ I,J,K,L,ISGN,IJKLW
      COMMON/FINDE/ NDIM,NDIM2,IFIND,ILOOK
      COMMON/INNER/ NDIMII,IBAS2,VIJKL,INEG,IHPRT(N_WORDS),IPROP
      COMMON/KWIK/KW1(MAX_STORE),KW2(MAX_STORE),VKW(MAX_STORE),NKW,
     1OPEN,KKW1(MAX_NJTVEC),KKW2(MAX_NJTVEC),NJTP2(MAX_NPART),
     1NJTA(NO_JVAL,NO_TVAL)
CBAB      COMMON/WRBACK/ IGDST,IST,IFN,COEF(MAX_DIM),IHF(MAX_NPARTH)
CBAB ERROR FOUND MARCH 1987
CBAB      COMMON/WRBACK/ IGDST,IST,IFN,COEF(MAX_DIM),IHF(2*MAX_NPARTH)
      COMMON/WRBACK/ IGDST,IST,IFN,COEF(MAX_MSCHEME),
     1IHF(2*MAX_NPARTH)
      INTEGER*4 IDEX
      COMMON/ORT/ COLUM(MAX_DIM),OPEN1,COEF0(MAX_MSCHEME),
     1IDEX(MAX_DIM),
     1IJKLH(MAX_OPER_ELEMENTS),ZEROP,IVH1(MAX_NPARTH),
CBAB     1VH(MAX_OPER_ELEMENTS),IHPART(N_WORDS,MAX_NPARTH),
CBAB ERROR FOUND MARCH 1987
     1VH(MAX_OPER_ELEMENTS),IHPART(N_WORDS,2*MAX_NPARTH),
     1NDIMH(MAX_NPARTH),VHI(MAX_OPER_ELEMENTS),
     1HOUT(MAX_ELEM_PART),IKOUT(MAX_ELEM_PART),IJOUT(MAX_ELEM_PART),
     1ORTH(MAX_ORTH),IPSA(MAX_NPART),NJTXA(MAX_NPART),SCOL(MAX_NJTVEC)
     1,ILPT,NJT,NRED
      COMMON/CMAC/IMAC
      COMMON/ORTFLS/SPSFIL,INTFIL,REDF,PRJF
      COMMON/HNORM/NINT,SPE_NORM(9),XME_NORM(9)
 
