CBAB SIMPLE FORM FOR SDI INTERACTION
CBAB SEE BRUSSAARD AND GLAUDEMANS, PAGE 109
      COMMON/CVDEL/VN,AL
      FWS(X,RWS,AWS) = 1./(1.+EXP((X-RWS)/AWS))
      CALL INDEX
      VN = -500.
      AL = .12
CBAB      TYPE 500
CBAB500   FORMAT(1X,'HBW,IA')
CBAB      ACCEPT 501,HBW,IAAA
501   FORMAT(F,I)
      HBW = 14.
      IAAA = 16
1000  CONTINUE
      TYPE 600
600   FORMAT(1X,'I1,I2,I3,I4,IJ,IT')
      ACCEPT 601,I1,I2,I3,I4,IJ,IT
601   FORMAT(20I)
      IRAD = 1
      IL = 0
      IF(IAAA.GT.0) RWS = 1.1*(IAAA**(1./3.))
      IF(IAAA.LE.0) RWS = 1.1*(16**(1./3.))
      IWS = RWS*10.
      AWS = 0.6
      XDDA = 1.
      XDDB = 1.
      XDDC = 0.01
      IF(DDA.NE.0.) XDDA = DDA
      IF(DDB.NE.0.) XDDB = DDB
      IF(DDC.NE.0.) XDDC = DDC
      S = 0.
      SS1 = 0.
      SS2 = 0.
      RM = 10.
      R = 0.
      H = .1
101   CONTINUE
      R = R+H
      IF(R.GT.RM) GO TO 100
      X1 = OSCRADN(I1,R,HBW)
      X2 = OSCRADN(I2,R,HBW)
      X3 = OSCRADN(I3,R,HBW)
      X4 = OSCRADN(I4,R,HBW)
      XXX = XDDA-XDDB*(FWS(R,RWS,AWS)**XDDC)
CBAB      IR = 10*R
CBAB      IF(IR.EQ.IWS) XXX = 100.
CBAB      IF(IR.NE.IWS) XXX = 0.
      ZZ1 = X1*X1*R*R
      ZZ2 = X2*X2*R*R
      S = S + XXX*X1*X2*X3*X4*R*R
      SS1 = SS1 + ZZ1
      SS2 = SS2 + ZZ2
      GO TO 101
100   CONTINUE
      FRAD = S*H 
      XVDEL = VDELY(I1,I2,I3,I4,IJ,IT)
      RH5B = XVDEL*FRAD
      TYPE 700,RH5B,XVDEL,FRAD
700   FORMAT(1X,'TOT,ANG,RAD = ',10F12.7)
      XNORM1 = SS1*H
      XNORM2 = SS2*H
      GO TO 1000
CBAB      RETURN
      END

      FUNCTION OSCRADN(I1,XR,HBW)
      COMMON/SRC/ISRC
      COMMON/INDEX/XL(3,200)
      F(X,Y) = SQRT(DFAC(2.*X+2.*Y+1.)/FAC(X))/DFAC(2.*Y+1.)
      G(X,Y,Z) = PAR(Z)*BINOM(X,Z)*DFAC(2.*Y+1.)/DFAC(2.*Y+2.*Z+1.)
      XSC = 1.
      AS = 1.1
      BS = .68
      IF(ISRC.EQ.0) GO TO 100
      XSC = 1.-EXP(-AS*XR*XR)*(1.-BS*XR*XR)
100   CONTINUE
      V = 41.4963/HBW
      V = 1./V
      XN = XL(1,I1)-1.
      XLL = XL(2,I1)
      CC = V**(.75+XLL/2.)
      XX = F(XN,XLL)
      C = 1.50225*(2.**((XLL/2.)-(XN/2.)))
      IXN = XN+1.
      R = XR
      S = 0.
      DO 21 J = 1,IXN
      XK = J-1
21    S = S + (V**XK)*G(XN,XLL,XK)*(R**(2.*XK))*(2.**XK)
      YY = V*R*R/2.
      SS = XX*EXP(-YY)*S*(R**XLL)
      SS = SS*C
      OSCRADN = SS*CC*XSC
      RETURN
      END


