CBAB  IMPROVEMENTS MADE IN MAY 1986
CBAB  1) OPTION IN VCEN TO MAKE IT FASTER
CBAB  2) INTRODUCED TALMI INTERGRALS AND UNIFIED RADIAL INTEGRAL PROGRAMS
CBAB  3) NEW PROGRAM FOR MOSHINSKY BRACKETS AND NEW SAVE ARRAY
CBAB  4) NORMALIZED CORE POLARIZATION FOR A GIVEN MULTIPOLE
CBAB  5) UNIFIED INPUTS IN GETVS
 
CBAB  VM(T+1,S+1,I,TYPE) CONTAINS THE MATRIX ELEMENT OBTAINED IN VCENNA
CBAB  VS(T+1,S+1,I,TYPE) CONTAINS THE STRENGTH OBTAINED IN GETVS
CBAB  TYPE = 1 FOR CENTRAL
CBAB  TYPE = 2 FOR SPIN ORBIT
CBAB  TYPE = 3 FOR TENSOR
CBAB  TYPE = 4 FOR ANTISYMMETRIC SPIN ORBIT
CBAB  I = 1-7 FOR DENSITY-INDEPENDENT G MATRIX
CBAB  I = 21-27 FOR DENSITY-DEPENDENT G MATRIX
CBAB  I = 8 FOR COULOMB
CBAB  I = 9 FOR MONOPOLE(CENTRAL) OR Q+Q(TENSOR)
CBAB  I = 10-20 FOR K MULTIPOLE-MULTIPOLE WHERE K = I-10
 
      FUNCTION VCEN(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      REAL*8 XLS,XCALL,XLS12,XLS34,VM,VCM
      COMMON/CANT/IANT
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
      COMMON/INDEX/XL(3,200)
      COMMON/RAD/RAD(7,200,200,4)
      COMMON/CVCENN/VCENN(4)
CWAR
      INCLUDE 'VNCOM.INC'
 
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      XJ34 = IJ34
      XT34 = IT34
      XI12 = I1-I2
      XI34 = I3-I4
      IF(IANT.EQ.1) GO TO 300
      IF(I1.NE.I2.AND.I3.NE.I4) GO TO 100
      IF(I1.EQ.I2.AND.I3.EQ.I4) GO TO 300
      GO TO 200
 
100   CONTINUE
      XN = SQRT((DELTA(XI12)+1.)*(DELTA(XI34)+1.))
      XN1 = 1./XN
      XN2 = PAR(XJ3+XJ4-XJ34-XT34)/XN
      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      CALL VCENNA(XN2,I1,I2,I4,I3,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500
 
200   CONTINUE
      XN1 = SQRT(2.)
      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500
 
300   CONTINUE
      XN1 = 1.
      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500
 
500   CONTINUE
      VCEN = 0.
      DO 854 IL = 1,4
854   VCENN(IL) = 0.
CBAB      DO 852 IL = 0,3
      DO 852 IL = 1,4
      DO 852 I = 1,30
      DO 852 IS12 =0,1
      X1 = VM(IT12+1,IS12+1,I,IL)
      X2 = VS(IT12+1,IS12+1,I,IL)
      IF(X2.EQ.0.) GO TO 852
CBAB      VCEN = VCEN + VM(IT12+1,IS12+1,I,IL+1)*VS(IT12+1,IS12+1,I,IL+1)
      VCENN(IL) = VCENN(IL) + X1*X2
CBAB     1+ VM(IT12+1,IS12+1,I,IL)*VS(IT12+1,IS12+1,I,IL)
852   CONTINUE
      VCEN = VCENN(1)+VCENN(2)+VCENN(3)+VCENN(4)
      RETURN
      END
 
      SUBROUTINE VCENNA
     1(XCALL,IO1,IO2,IO3,IO4,IJ12,IJ34,IT12,IT34,IJ,IT)
 
      DIMENSION KNS(140),KLS(140),KNC(140),KLC(140)    ! MOSHINSKY
      DIMENSION KNSP(140),KLSP(140),KNCP(140),KLCP(140)! MOSHINSKY
      CHARACTER*3 KEY
C      REAL*8 XLS,XCALL,XLS12,XLS34,VM,VCM,XXIL12,XXIS12,XLSJJN
C     1,XPAR
      REAL*8 XLS,XCALL,XLS12,XLS34,VM,VCM,XLSJJN,XPAR
      DIMENSION XAH(200,10)
      CHARACTER*9 WSF
      COMMON/WSF/WSF

      COMMON/CKEY/KEY,HBW
      DIMENSION SUMR(30),SUMRR(30)
      COMMON/CVLSS/KVLSS
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
CWAR
      INCLUDE 'VNCOM.INC'
      COMMON/BR/BRAD(15)
      COMMON/SUM/SUMRT(14,15)
CWAR
      COMMON/INDEX/XL(3,200)
      COMMON/CIDD/IDD,ALD,BLD,R0D,DIFFD
      COMMON/CSETPARV/ICAV,ILAV,ITAV,ISETL(10),ISETLNUM
 
      IF(HBW.GT.0.)
     1BOSCREL = SQRT(41.465/(HBW/2.)) ! USED ONLY FOR COULOMB
      IF(XCALL.EQ.0.) CALL ZEROVM
CWAR
      IF(XCALL.EQ.0.) CALL ZEROVMT
      IF(XCALL.EQ.0.) RETURN
 
CBAB      IF(IFIRST.EQ.1948) GO TO 948
CBAB MOVED TO MAIN PROGRAM ON JAN 18 1987
CBAB INITIALIZATION ----------------------------------
CBAB      CALL GETVS(0)
CBAB      IFIRST = 1948
CBAB948   CONTINUE
 
CBAB -------------------------------------------------
      IF(KEY.EQ.'SU3') CALL SU3
     1(XCALL,IO1,IO2,IO3,IO4,IJ12,IJ34,IT12,IT34,IJ,IT)
      IF(KEY.EQ.'SU3') RETURN
 
      XIJ = IJ
      XIT = IT
      XIJ12 = IJ12
      XIJ34 = IJ34
      XIT12 = IT12
      XIT34 = IT34


C      XN1 = XL(1,IO1)-1.
C      XN2 = XL(1,IO2)-1.
C      XN3 = XL(1,IO3)-1.
C      XN4 = XL(1,IO4)-1.
      XL1 = XL(2,IO1)
      XL2 = XL(2,IO2)
      XL3 = XL(2,IO3)
      XL4 = XL(2,IO4)
      XJ1 = XL(3,IO1)
      XJ2 = XL(3,IO2)
      XJ3 = XL(3,IO3)
      XJ4 = XL(3,IO4)



      L1 = XL1
      L2 = XL2
      L3 = XL3
      L4 = XL4
CBAB EXTRA CHECKS
      IF(TR(XJ1,XJ2,XIJ12).EQ.-1.) GO TO 801
      IF(TR(XJ3,XJ4,XIJ34).EQ.-1.) GO TO 801
      IF(TR(XIJ12,XIJ34,XIJ).EQ.-1.) GO TO 801
      GO TO 804
801   CONTINUE
      TYPE 802
802   FORMAT(1X,'ILLEGAL J COUPLINGS')
      TYPE 803,XJI,XJ2,XJ3,XJ4,XIJ12,XIJ34,XIJ
803   FORMAT(1X,'XJI,XJ2,XJ3,XJ4,XIJ12,XIJ34,XIJ = ',7F5.1)
      RETURN
804   CONTINUE
 
 
CBAB *****************************************************************
CBAB LOOP OVER POSSIBLE SPINS TENSORS
      DO 200 IS = 0,2
      XIS = IS
 
CBAB LOOP OVER POSSIBLE ORBITAL TENSORS
      ILMIN = ABS(XIS-XIJ)
      ILMAX = XIS+XIJ
      IF(ILMAX.LT.ILMIN) GO TO 200
      DO 250 IL = ILMIN,ILMAX
      XIL = IL
      IF(TR(XIL,XIS,XIJ).EQ.-1.) GO TO 250
      IF(IL.EQ.0.AND.ICAV.EQ.0) GO TO 250
      IF(IL.EQ.1.AND.ILAV.EQ.0) GO TO 250
      IF(IL.EQ.2.AND.ITAV.EQ.0) GO TO 250
 
CBAB LOOP OVER S AND L COUPLINGS OF THE INITIAL AND FINAL STATES
      JL12MIN = ABS(XL1-XL2)
      JL12MAX = XL1 + XL2
      JL34MIN = ABS(XL3-XL4)
      JL34MAX = XL3 + XL4
      DO 400 IL12 = JL12MIN,JL12MAX
      DO 400 IL34 = JL34MIN,JL34MAX
      DO 400 IS12 = 0,1
      DO 400 IS34 = 0,1
      XIL12 = IL12
      XIL34 = IL34
      XIS12 = IS12
      XIS34 = IS34
      IF(TR(XIL12,XIL34,XIL).EQ.-1.) GO TO 400
      IF(TR(XIS12,XIS34,XIS).EQ.-1.) GO TO 400
 
      XPAR = PAR(XIS12+XIL34+XIJ12)
      IF(KEY.EQ.'HCM')
     1XLS = 1.
      IF(KEY.NE.'HCM')
     1XLS = XPAR*SJ(XIL12,XIS12,XIJ12,XIS34,XIL34,XIL)
      IF(KEY.EQ.'HCM') 
     1 XLS12 = XLSJJN(XL1,0.5,XJ1,XL2,0.5,XJ2,XIL12,XIS12,XIJ12)
      IF(KEY.EQ.'HCM') 
     1 XLS34 = XLSJJN(XL3,0.5,XJ3,XL4,0.5,XJ4,XIL34,XIS34,XIJ34)
      IF(KEY.NE.'HCM') 
     1 XLS12 = XLSJJ(XL1,0.5,XJ1,XL2,0.5,XJ2,XIL12,XIS12,XIJ12)
      IF(KEY.NE.'HCM') 
     1 XLS34 = XLSJJ(XL3,0.5,XJ3,XL4,0.5,XJ4,XIL34,XIS34,XIJ34)
      IF(XLS.EQ.0.) GO TO 400
      IF(XLS12.EQ.0.) GO TO 400
      IF(XLS34.EQ.0.) GO TO 400

CWAR
CBAB SPIN MATRIX ELEMENTS
      XSPIN = 0.
      IF(IL.EQ.0) XSPIN = SQRT(2.*XIS12+1.)
      IF(IL.EQ.1.AND.IS12.EQ.IS34) XSPIN = SQRT(6.)
      IF(IL.EQ.1.AND.IS12.NE.IS34) XSPIN = ETBME(IS12,IS34,3)
      IF(IL.EQ.2) XSPIN = SQRT(20.)
 
C      XXIL12 = XIL12
C      XXIS12 = XIS12
 
      DO 850 I = 1,30
850   SUMR(I) = 0.
 
      IF(ITALMI.EQ.0) GO TO 860
CWAR  ZERO SUMRT FOR TALMI INTEGRALS
      DO 860 I = 1,14
      DO 860 IP = 0,ITMAX
      SUMRT(I,IP+1) = 0.
860   CONTINUE
 
      IF(IFH.EQ.999) GO TO 8001
      IHMAX = 10
      DO 8000 IHZ = 1,200
      NZ = XL(1,IHZ)
      XAH(IHZ,NZ) = 1.
8000  CONTINUE
 
      IF(WSF.EQ.' ') GO TO 910
      OPEN(UNIT=15,FILE=WSF//'.WS',STATUS='OLD')
      TYPE 914
      WRITE(11,914)
914   FORMAT(/,1X,'WS expansion parameters',/,3X,'K,N,A,sum A**2',/)
912   CONTINUE
      READ(15,*,ERR=911) IZ1,IZ2,XHZ
      IF(IZ1.LT.0)GOTO911
      IF(IZ1.NE.IZ1S) SXHZ = 0.
      IF(IZ1.EQ.IZ1S) GO TO 8003
      DO 8002 INZ = 1,10
      XAH(IZ1,INZ) = 0.
8002  CONTINUE
8003  CONTINUE
      SXHZ = SXHZ+XHZ*XHZ
      TYPE 915,IZ1,IZ2,XHZ,SXHZ
      WRITE(11,915) IZ1,IZ2,XHZ,SXHZ
915   FORMAT(1X,2I4,1X,F10.6,1X,F10.6)
      XAH(IZ1,IZ2) = XHZ
      IZ1S = IZ1
      GO TO 912
911   CLOSE(UNIT=15)
910   CONTINUE
      IFH = 999
8001  CONTINUE
 
      DO 251 IH1 = 1,IHMAX
      XH1 = IH1
      I1P = FINDEX(XH1,XL1,XJ1)
      IF(XAH(IO1,IH1).EQ.0.) GO TO 251
 
      DO 251 IH2 = 1,IHMAX
      XH2 = IH2
      I2P = FINDEX(XH2,XL2,XJ2)
      IF(XAH(IO2,IH2).EQ.0.) GO TO 251
 
      DO 251 IH3 = 1,IHMAX
      XH3 = IH3
      I3P = FINDEX(XH3,XL3,XJ3)
      IF(XAH(IO3,IH3).EQ.0.) GO TO 251
 
      DO 251 IH4 = 1,IHMAX
      XH4 = IH4
      I4P = FINDEX(XH4,XL4,XJ4)
      IF(XAH(IO4,IH4).EQ.0.) GO TO 251
 
      DO 253 I = 1,30
253   SUMRR(I) = 0.

      XN1 = XXN(I1P)-1.
      XN2 = XXN(I2P)-1.
      XN3 = XXN(I3P)-1.
      XN4 = XXN(I4P)-1.
      N1 = XN1
      N2 = XN2
      N3 = XN3
      N4 = XN4

      NN1 = 2*N1+L1
      NN2 = 2*N2+L2
      NN3 = 2*N3+L3
      NN4 = 2*N4+L4
CBAB ERROR FOUND ON DEC 15,1994
CBAB      IF(KEY.EQ.'HCM'.AND.
CBAB      1 IABS(NN1-NN3).GT.1.OR.IABS(NN2-NN4).GT.1)
CBAB      1 GO TO 400
      IF(KEY.EQ.'HCM'.AND.IABS(NN1-NN3).NE.1) GO TO 251
      IF(KEY.EQ.'HCM'.AND.IABS(NN2-NN4).NE.1) GO TO 251
C      IF(KEY.EQ.'HCM'.AND.
C     1 (IABS(NN1-NN3).GT.1.OR.IABS(NN2-NN4).GT.1))
C     1 GO TO 251

C      TYPE 7777,IH1,IH2,IH3,IH4,I1P,I2P,I3P,I4P
C     1,xah(iO1,ih1)
C     1,xah(iO2,ih2)
C     1,xah(iO3,ih3)
C     1,xah(iO4,ih4)
C7777  FORMAT(1X,4I5,1X,4I5,1x,4f10.7)

CWAR VLSS NOT USED FOR TALMI INTEGRAL CALCULATION
CWAR AS CONTRIBUTION OF SEPARATE ORDERS IP NEEDED
      IF(ITALMI.EQ.0)
     1 CALL VLSS(0,IVLSS,SUMRR,
     1N1,N2,N3,N4,L1,L2,L3,L4,IS12,IS34,IL12,IL34,IL)

      IF(IVLSS.EQ.1.AND.ITALMI.EQ.0) GO TO 700
C      TYPE 7777,I1P,I2P,I3P,I4P,IL12
C7777  FORMAT(1X,5I5)
      IF(KEY.EQ.'HCM'.AND.IS.GT.0) SUMRR(1) = 0.
      IF(KEY.EQ.'HCM'.AND.IS.EQ.0)
     1  SUMRR(1) = VCM(I1P,I2P,I3P,I4P,IL12)
C     1 VM(IT12+1,IS12+1,1,1) = VM(IT12+1,IS12+1,1,1)
C     1 +  XCALL*XLS12*XLS34*VCM(IO1,IO2,IO3,IO4,IL12)
      IF(KEY.EQ.'HCM') GO TO 5002
 
      ILM1=IL12
      ILPM1=IL34
      CALL MOSHQN(N1,L1,N2,L2,ILM1,KNS,KLS,KNC,KLC,NUM)
      IF(NUM.GT.140) TYPE 8100
      IF(NUM.GT.140) STOP
8100  FORMAT(1X,'INCREASE DIMENSION OF KNS ETC IN VCENNA')
      CALL MOSHQN(N3,L3,N4,L4,ILPM1,KNSP,KLSP,KNCP,KLCP,NUMP)
      IF(NUMP.GT.140) TYPE 8101
      IF(NUMP.GT.140) STOP
8101  FORMAT(1X,'INCREASE DIMENSION OF KNSP ETC IN VCENNA')
 
CBAB -------------------------------------------------------------
      DO 350 I = 1,NUM
      ISAVE = 0
      CALL BMOSH_SAVE(N1,L1,N2,L2,ILM1,I,ISAVE,BKT)
      IF(ISAVE.EQ.0)
     1BKT = BMOSH(N1,L1,N2,L2,ILM1,KNS(I),KLS(I),KNC(I),KLC(I))
      ISAVE = 2
      CALL BMOSH_SAVE(N1,L1,N2,L2,ILM1,I,ISAVE,BKT)
      IF(BKT.EQ.0.) GO TO 350
      DO 300 IP = 1,NUMP
      ISAVEP = 0
      CALL BMOSH_SAVEP(N3,L3,N4,L4,ILPM1,IP,ISAVEP,BKTP)
      IF(ISAVEP.EQ.0)
     1BKTP = BMOSH(N3,L3,N4,L4,ILPM1,KNSP(IP),KLSP(IP),KNCP(IP),
     1KLCP(IP))
      ISAVEP = 2
      CALL BMOSH_SAVEP(N3,L3,N4,L4,ILPM1,IP,ISAVEP,BKTP)
      IF(BKTP.EQ.0.) GO TO 300
 
      INOT = 0
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
      XKLC = KLC(I)
      XKLCP = KLCP(IP)
      IORBS = ISEEK_INDEX(KNS(I)+1,KLS(I))
      IORBSP = ISEEK_INDEX(KNSP(IP)+1,KLSP(IP))
      IORBC = ISEEK_INDEX(KNC(I)+1,KLC(I))
      IORBCP = ISEEK_INDEX(KNCP(IP)+1,KLCP(IP))
      IF(IORBS.EQ.-1) INOT = 1
      IF(IORBSP.EQ.-1) INOT = 1
      IF(IORBC.EQ.-1) INOT = 1
      IF(IORBCP.EQ.-1) INOT = 1
 
      XORB = 0.
 
      IF(ITR(KLS(I),KLSP(IP),IL).EQ.-1) GO TO 300
      IF(IS12.EQ.IS34) ILL = 0
      IF(IS12.NE.IS34) ILL = 1
      IF(ITR(KLC(I),KLCP(IP),ILL).EQ.-1) GO TO 300
      XILL = ILL
      X11 = SQRT((2.*XIL12+1.)*(2.*XIL34+1.)*(2.*XIL+1.))
     1*QJ(XKLS,XKLC,XIL12,XKLSP,XKLCP,XIL34,XIL,XILL,XIL)
      IF(X11.EQ.0.) GO TO 300
 
      IF(IS12.NE.IS34) GO TO 300
CBAB DELTA FUNCTION ON CENTER OF MASS COORDINATE
      IF(KLC(I)-KLCP(IP).NE.0) GO TO 300
      IF((IDD.EQ.0).AND.(KNC(I)-KNCP(IP).NE.0)) GO TO 300
      XREL = SQRT(2.*XKLC+1.)
 
CBAB ORBITAL MATRIX ELEMENTS FOR CENTRAL LS AND TENSOR
      IF(IL.EQ.0) XORB = DELTA(XKLS-XKLSP)*SQRT(2.*XKLS+1.)
      IF(IL.EQ.1) XORB =
     1DELTA(XKLS-XKLSP)*SQRT(XKLS*(XKLS+1.)
     1*(2.*XKLS+1.))
CBAB THE TENSOR OPERATOR IS S12 = [SQRT(6)C2].dot.[SIGxSIG]^2
CBAB                               XORB            XSPIN
      IF(IL.EQ.2) XORB = SQRT(6.)*PAR(XKLS)
     1*SQRT((2.*XKLS+1.)*(2.*XKLSP+1.))*TJ(XKLS,2.,XKLSP,0.,0.,0.)
      IF(XORB.EQ.0.) GO TO 300
 
CBAB      X11 = PAR(XKLS+XKLC+XIL12+XIL)
CBAB      X11 = X11*SJ(XKLS,XIL12,XKLC,XIL34,XKLSP,XIL)
CBAB      X11 = X11*SQRT((2.*XIL12+1.)*(2.*XIL34+1.))
      GO TO 333
 
332   CONTINUE
CBAB SPECIAL ALS TERM
CBAB ORBITAL MATRIX ELEMENTS FOR ALS
CBAB 4PI/3 FACTOR SO THAT WE HAVE CL RATHER THAN YL OPERATOR
      IF(INOT.EQ.0) 
     1 XORB = SQRT(4.*3.14159/3.)*YLLL(IORBS,IORBSP,1)
      IF(INOT.EQ.1) 
     1 XORB = 1.
      IF(INOT.EQ.0) 
     1 XREL = SQRT(4.*3.14159/3.)*YLLL(IORBC,IORBCP,1)
      IF(INOT.EQ.1) 
     1 XREL = 1.
      IF(XORB.EQ.0.) GO TO 300
      IF(XREL.EQ.0.) GO TO 300
 
      GO TO 333
333   CONTINUE
 
      IF(KNC(I).EQ.KNCP(IP)) XRELDI = 1.
      IF(KNC(I).NE.KNCP(IP)) XRELDI = 0.
      IF(IDD.GE.1.AND.INOT.EQ.0) XRELDD = FRADREL(IORBC,IORBCP)
      IF(IDD.GE.1.AND.INOT.EQ.1) XRELDD = 1.
      DO 4000 IRAD = 1,IVM
      XRAD = 0.
      IF((VS(IT12+1,IS12+1,IRAD,IL+1).NE.0..OR.
     1VS(IT12+1,IS12+1,IRAD+20,IL+1).NE.0.).AND.INOT.EQ.0)
     1XRAD = FRAD(IRAD,IORBS,IORBSP,IL)
      IF((VS(IT12+1,IS12+1,IRAD,IL+1).NE.0..OR.
     1VS(IT12+1,IS12+1,IRAD+20,IL+1).NE.0.).AND.INOT.EQ.1)
     1XRAD = 1.
      SUMRR(IRAD) = SUMRR(IRAD) + X11*XRAD*BKT*BKTP*XORB*XSPIN
     1*XREL*XRELDI
      XBAB = X11*XORB*XSPIN*XREL
C      IF(ABS(XRAD).GT..0001)
C     1 TYPE 7777,XBAB,XLS12,XLS34,XRAD,BKT,BKTP
C7777  FORMAT(1X,10F10.5)
 
      IF(ITALMI.EQ.0) GO TO 668
CWAR CALL ROUTINE RALL TO CALCULATE PRODUCTS OF B COEFFS
CWAR AND TALMI INTEGRALS AND STORE IN BRAD(IP) IP=ORDER
      IF(VS(IT12+1,IS12+1,IRAD,IL+1).EQ.0.) GO TO 667
      HBWR=HBW/2.
      IF(INOT.EQ.0) XDUM=RALL(IRAD,IL,IORBS,IORBSP,HBWR)
      IF(INOT.EQ.1) XDUM=1.
      DO 4001 IPT=1,ITMAX+1
      SUMRT(IRAD,IPT) = SUMRT(IRAD,IPT) + X11*BRAD(IPT)*BKT*BKTP*XORB
     1*XSPIN*XREL*XRELDI
CWAR DENSITY DEPENDENCE FOR TALMI INTEGRALS
      IF(IDD.GE.1)
     1SUMRT(IRAD+7,IPT) = SUMRT(IRAD+7,IPT) + X11*BRAD(IPT)*BKT*BKTP
     1*XORB*XSPIN*XREL*XRELDD
4001  CONTINUE
667   CONTINUE
668   CONTINUE
CWAR
 
      IF(IDD.GE.1)
     1SUMRR(IRAD+20) = SUMRR(IRAD+20) + X11*XRAD*BKT*BKTP*XORB*XSPIN
     1*XREL*XRELDD
 
4000  CONTINUE     ! LOOP OVER IRAD = 1,IVM
 
CBAB COULOMB TERM
      IF(IL.EQ.0.AND.INOT.EQ.0) SUMRR(8) = SUMRR(8) + 1.44
     1*X11*BKT*BKTP*XORB*XSPIN*XREL*XRELDI*RL(IORBS,IORBSP,-1)/BOSCREL
      IF(IL.EQ.0.AND.INOT.EQ.1) SUMRR(8) = SUMRR(8) + 0.
 
300   CONTINUE     ! LOOP OVER IP
350   CONTINUE     ! LOOP OVER I
CBAB -------------------------------------------------------------
 
CBAB MONOPOLE TERM
      IF((IL.EQ.0).AND.(IS12.EQ.IS34).AND.(IL12.EQ.IL34)
     1.AND.(N1.EQ.N3).AND.(N2.EQ.N4).AND.(L1.EQ.L3).AND.(L2.EQ.L4))
     1SUMRR(9) = SQRT(2.*XIL12+1.)*SQRT(2.*XIS12+1.)
CBAB     1SUMRR(7) = SQRT(2.*XIL12+1.)*SQRT(2.*XIS12+1.)
 
CBAB QUADRUPOLE AND HEXADECAPOLE TERMS
CBAB      IF(JL12MAX.GE.JL34MAX) JTOTMAX = JL12MAX
CBAB      IF(JL12MAX.LT.JL34MAX) JTOTMAX = JL34MAX
CBAB      DO 5000 IQQ = ISETLMIN,ISETLMAX
      DO 5000 IQQQ = 1,ISETLNUM
      IQQ = ISETL(IQQQ)
CBAB      IF(IQQ.LT.ISETLMIN.OR.IQQ.GT.ISETLMAX) GO TO 5000
      XIQQ = IQQ
      IQQL = IQQ+10
      IF(IQQL.GT.20.AND.I5001.EQ.0) TYPE 5001,IQQ
5001  FORMAT(1X,'Y(L).Y(L) WITH L = ',I3,
     1' NOT ALLOWED BY DIMENSION IN VCENNA')
      IF(IQQL.GT.20) I5001 = 999
      IF(IQQL.GT.20) GO TO 5000
CBAB QXQ FORM
      SUMRR(IQQL)=SQRT((2.*XIL12+1.)*(2.*XIL34+1.)*(2.*XIL+1.))
     1*QJ(XL1,XL2,XIL12,XL3,XL4,XIL34,XIQQ,XIQQ,XIL)
     1*YLLL(IO1,IO3,IQQ)*YLLL(IO2,IO4,IQQ)
CBAB     1*RL(IO1,IO3,IQQ)*RL(IO2,IO4,IQQ)
     1*FRADQQ(IO1,IO3,IQQ)*FRADQQ(IO2,IO4,IQQ)
CBAB Q+Q FORM FOR TENSOR
      SUMR1 = 0.
      SUMR2 = 0.
      IF(IL.EQ.2.AND.IQQ.EQ.2.AND.L2.EQ.L4.AND.N2.EQ.N4)
     1SUMR1 = SQRT((2.*XIL12+1.)*(2.*XIL34+1.))
     1*PAR(XL1+XL2+XIL34+XIQQ)
     1*SJ(XL1,XL3,XIQQ,XIL34,XIL12,XL4)
     1*YLLL(IO1,IO3,IQQ)
     1*FRADQQ(IO1,IO3,IQQ)
      IF(IL.EQ.2.AND.IQQ.EQ.2.AND.L1.EQ.L3.AND.N1.EQ.N3)
     1SUMR2 = SQRT((2.*XIL12+1.)*(2.*XIL34+1.))
     1*PAR(XL3+XL4+XIL12+XIQQ)
     1*SJ(XL2,XL4,XIQQ,XIL34,XIL12,XL1)
     1*YLLL(IO2,IO4,IQQ)
     1*FRADQQ(IO2,IO4,IQQ)
      IF(IL.EQ.2.AND.IQQ.EQ.2) SUMRR(9) = SUMR1+SUMR2
CBAB      IF(IL.EQ.1.AND.IQQL.EQ.6.AND.IS12.EQ.IS34)
CBAB     1TYPE 7788,IL,IS12,IS34,IL12,IL34,
CBAB     1XCALL,XLS,XLS12,XLS34,SUMRR(IQQL),ETBME(IS12,IS34,1)
CBAB7788  FORMAT(1X,5I3,10F9.5)
 
      IF(IL.EQ.0) SUMRR(IQQL) = SUMRR(IQQL)*ETBME(IS12,IS34,5)
CBAB SEVERAL EXPRESSIONS TRIED FOR Q.Q IN LS DO NOT HAVE
CBAB THE PROPER SYMMETRY, SO FOR NOW WE PUT THIS TO ZERO
      IF(IL.EQ.1.AND.IS12.EQ.IS34)
     1SUMRR(IQQL) = 0.
CBAB     1SUMRR(IQQL) = SUMRR(IQQL)*ETBME(IS12,IS34,1)
CBAB     1SUMRR(IQQL) = SUMRR(IQQL)*ETBME(IS12,IS34,2)
      IF(IL.EQ.1.AND.IS12.NE.IS34)
     1SUMRR(IQQL) = SUMRR(IQQL)*ETBME(IS12,IS34,3)
      IF(IL.EQ.2) SUMRR(IQQL) = SUMRR(IQQL)*ETBME(IS12,IS34,6)
      IF(IL.EQ.2) SUMRR(9) = SUMRR(9)*ETBME(IS12,IS34,6)
5000  CONTINUE
5002  CONTINUE

      IF(ITALMI.EQ.0)
     1 CALL VLSS(1,IVLSS,SUMRR,
     1N1,N2,N3,N4,L1,L2,L3,L4,IS12,IS34,IL12,IL34,IL)
700   CONTINUE
      DO 252 I = 1,30
252   SUMR(I) = SUMR(I)+SUMRR(I)
     1*XAH(IO1,IH1)*XAH(IO2,IH2)*XAH(IO3,IH3)*XAH(IO4,IH4)
251   CONTINUE
 
      DO 851 I = 1,30
      IF(SUMR(I).EQ.0.) GO TO 851
      XTOTAL = XCALL*XLS*XLS12*XLS34*SUMR(I)
      IF(IS12.EQ.IS34) VM(IT12+1,IS12+1,I,IL+1)
     1 = VM(IT12+1,IS12+1,I,IL+1) + XTOTAL
      IF(IS12.NE.IS34) VM(IT12+1,2,I,4)
     1 = VM(IT12+1,2,I,4) + XTOTAL
851   CONTINUE
 
999   FORMAT(4I4,1X,F7.3)
 
      IF(ITALMI.EQ.0) GO TO 856
CWAR DO TALMI SUMS ONLY FOR RANGES
      DO 857 I=1,14
      DO 859 IP=0,ITMAX
      IF(SUMRT(I,IP+1).EQ.0.) GO TO 859
      XTAL = XCALL*XLS12*XLS34*SUMRT(I,IP+1)
      IF(IS12.EQ.IS34) VMTAL(IT12+1,IS12+1,I,IP+1,IL+1)
     1 = VMTAL(IT12+1,IS12+1,I,IP+1,IL+1) + XTAL
859   CONTINUE
857   CONTINUE
856   CONTINUE
CWAR
 
400   CONTINUE     ! LOOP OVER IS12,IS34,IL12,IL34
250   CONTINUE     ! LOOP OVER IL
200   CONTINUE     ! LOOP OVER IS
CBAB *****************************************************************
 
      RETURN
      END
 
      SUBROUTINE LISTTALMI
      CHARACTER*3 KEY
      COMMON/CKEY/KEY
      COMMON/CTALMI/TALMI_SAVE(3,7,100)
      COMMON/CVLSS/KVLSS
      DO 1000 I3 = 1,100
      DO 1000 I2 = 1,7
      X1 = TALMI_SAVE(1,I2,I3)
      X2 = TALMI_SAVE(2,I2,I3)
      X3 = TALMI_SAVE(3,I2,I3)
      IF(X1.EQ.0.AND.X2.EQ.0.AND.X3.EQ.0.) GO TO 1000
      IF(IFIRST.NE.99) OPEN(UNIT=12,FILE='TALMI.'//KEY,STATUS='NEW')
      IF(IFIRST.NE.99) WRITE(6,100)
      IF(IFIRST.NE.99) WRITE(11,100)
100   FORMAT(/,1X,'LIST OF TALMI INTEGRALS',
     1/,1X,' IP  RANGE      C              LS             T')
      IF(IFIRST.NE.99) IFIRST = 99
      WRITE(6,301) I3-1,I2,X1,X2,X3
      WRITE(11,301) I3-1,I2,X1,X2,X3
      WRITE(12,301) I3-1,I2,X1,X2,X3
301   FORMAT(1X,2I4,10(1X,E14.6))
1000  CONTINUE
      IF(KVLSS.GT.0) WRITE(6,500),KVLSS
      IF(KVLSS.GT.0) WRITE(11,500),KVLSS
500   FORMAT(/,1X,'MAX NUMBER IN VLSS = ',I5)
      RETURN
      END
 
      SUBROUTINE READTALMI
      COMMON/CTALMI/TALMI_SAVE(3,7,100)
      CHARACTER*3 KEY
      COMMON/CKEY/KEY
      LOGICAL EXIST
      INQUIRE(FILE='TALMI.'//KEY,EXIST=EXIST)
      IF(EXIST) THEN
      OPEN(UNIT=12,FILE='TALMI.'//KEY,STATUS='OLD')
500   CONTINUE
      READ(12,301,ERR=501) I3,I2,
     1TALMI_SAVE(1,I2,I3+1),
     1TALMI_SAVE(2,I2,I3+1),
     1TALMI_SAVE(3,I2,I3+1)
301   FORMAT(1X,2I4,10(1X,E14.6))
      GO TO 500
501   CONTINUE
      CLOSE(UNIT=12)
      RETURN
      ELSE
600   WRITE(6,601) 'TALMI.'//KEY
601   FORMAT(1X,'FILE: ',A13,' DOES NOT EXIST, ASSUME IRADINT=0')
      RETURN
      ENDIF
      END
 
 
      SUBROUTINE ZERORAD
      COMMON/RAD/RAD(7,200,200,4)
      DO 510 K = 1,4
      DO 510 I = 1,7
      DO 510 I1 = 1,100
      DO 510 I2 = 1,100
510   RAD(I,I1,I2,K) = 0.
      RETURN
      END
 
      FUNCTION FRADREL(I1,I2)
      CHARACTER*3 KEY
      COMMON/CKEY/KEY,HBW
c      COMMON/RADREL/RADREL(100,100)
c      IF(I1.GT.100) GO TO 500
c      IF(I2.GT.100) GO TO 500
      COMMON/RADREL/RADREL(200,200)
      IF(I1.GT.200) GO TO 500
      IF(I2.GT.200) GO TO 500
      GO TO 501
500   TYPE 502,I1,I2
502   FORMAT(1X,'ERROR IN FRADREL, I1,I2 = ',2I4)
      FRADRAL = 0.
      RETURN
501   CONTINUE
      HBWC = 2.*HBW
      FRADREL = RADREL(I1,I2)
      IF(FRADREL.NE.0.) RETURN
      X=RREL(I1,I2,HBWC)
      RADREL(I1,I2) = X
      FRADREL = RADREL(I1,I2)
      RETURN
      END
 
      FUNCTION FRAD(IRAD,I1,I2,IL)
      CHARACTER*3 KEY
      COMMON/CKEY/KEY,HBW
c      COMMON/RAD/RAD(7,100,100,4)
c      IF(I1.GT.100) GO TO 500
c      IF(I2.GT.100) GO TO 500
      COMMON/RAD/RAD(7,200,200,4)
      IF(I1.GT.200) GO TO 500
      IF(I2.GT.200) GO TO 500
      GO TO 501
500   TYPE 502,I1,I2
502   FORMAT(1X,'ERROR IN FRAD, I1,I2 = ',2I4)
      FRAD = 0.
      RETURN
501   CONTINUE
      FRAD = RAD(IRAD,I1,I2,IL+1)
      IF(FRAD.NE.0.) RETURN
      HBWR = HBW/2.
      FRAD = RALL(IRAD,IL,I1,I2,HBWR)
      RAD(IRAD,I1,I2,IL+1) = FRAD
      RETURN
      END
 
CBAB RADIAL INTEGRAL FOR DENSITY DEPENDENT INTERACTION
      FUNCTION RREL(I1,I2,HBW)
      COMMON/CIDD/IDD,ALD,BLD,R0D,DIFFD
      COMMON/CIAAA/IAAA
      FWS(X,RWS,AWS) = 1./(1.+EXP((X-RWS)/AWS))
      XR0D = 1.1
      IF(R0D.NE.0.) XR0D = R0D
      XDIFFD = 0.6
      IF(DIFFD.NE.0.) XDIFFD = DIFFD
      IF(IAAA.GT.0) RWS = XR0D*(IAAA**(1./3.))
      IF(IAAA.LE.0) RWS = XR0D*(16**(1./3.))
CBAB      IF(IAAA.GT.0) RWS = 1.1*(IAAA**(1./3.))
CBAB      IF(IAAA.LE.0) RWS = 1.1*(16**(1./3.))
CBAB      IF(IAAA.GT.0) RWS = 0.8*(IAAA**(1./3.))
CBAB      IF(IAAA.LE.0) RWS = 0.8*(16**(1./3.))
      IF(IAAA.LE.0) TYPE 500
500   FORMAT(1X,'WARNING IN FUNCTION RREL: IAAA.LE.0 WILL ASSUME A=16')
      AWS = XDIFFD
 
      S = 0.
      RM = 10.
      R = .1
      H = .1
      XALD = 1.
      XBLD = 1.
      IF(ALD.NE.0.) XALD = ALD
      IF(BLD.NE.0.) XBLD = BLD
101   CONTINUE
      R = R + H
      IF(R.GT.RM) GO TO 100
      X1 = OSCRADN(I1,R,HBW)
      X2 = OSCRADN(I2,R,HBW)
      X = XALD*(FWS(R,RWS,AWS)**XBLD)
      S = S + X*X1*X2*R*R
      GO TO 101
100   CONTINUE
      RREL = S*H
      RETURN
      END
 
      FUNCTION RALL(IRAD,IL,I1,I2,HBW)
      CHARACTER*3 ALB,AMU
      COMMON/INDEX/XL(3,200)
      COMMON/CMU/XMU(7),AMU(3)
      COMMON/CTALMI/TALMI_SAVE(3,7,100)
CWAR
      INCLUDE 'VNCOM.INC'
      COMMON/BR/BRAD(15)
      IF(HBW.GT.0.) BOSC = SQRT(41.465/HBW)
      ALB = AMU(IL+1)
CBAB SPECIAL DELTA FUNCTION OPTION
      IF(ALB.EQ.'DEL') GO TO 600
      IF(XMU(IRAD).EQ.0.01) GO TO 600
CBAB SPECIAL CONSTANT OPTION
      IF(XMU(IRAD).EQ.999.) GO TO 700
      IF(ALB.EQ.' ') RALL = 0.
      IF(ALB.EQ.' ') RETURN
      RMAX = 6.
      DELR = .02
      S = 0.
      TH = BOSC/XMU(IRAD)
      BT = 0.
      IL1 = XL(2,I1)
      IL2 = XL(2,I2)
      IN1 = XL(1,I1)-1.
      IN2 = XL(1,I2)-1.
      IPMIN = (IL1+IL2)/2
      IPMAX = (2*IN1+2*IN2+IL1+IL2)/2
      IF(ITMAX.LT.IPMAX) ITMAX = IPMAX
      IF(ITMAX+1.GT.ITMAXMAX) TYPE 800,ITMAX+1
800   FORMAT(1X,'INCREASE THE PARAMETER ITMAXMAX TO',I5)
      IF(ITMAX+1.GT.ITMAXMAX) STOP
 
      IF(ITALMI.EQ.0) GO TO 510
CWAR  ZERO BRAD
      DO 510 IP=0,ITMAX
      BRAD(IP+1)=0.
510   CONTINUE
 
      DO 500 IP = IPMIN,IPMAX
      B = BREL(IN1,IL1,IN2,IL2,IP)
      IF(IP+1.GT.IPOUT) IPOUT = IP
      IF(IPOUT.GT.100) TYPE 501,IPOUT
501   FORMAT(1X,'INCREASE DIMENSION OF TALMI_SAVE IN RALL TO ',I5)
      IF(IPOUT.LE.100) BT = TALMI_SAVE(IL+1,IRAD,IP+1)
      IF(BT.EQ.0.) BT = TALMI(IP,TH,DELR,RMAX,ALB)
      IF(IPOUT.LE.100) TALMI_SAVE(IL+1,IRAD,IP+1) = BT
 
CWAR  MULTIPLYING B COEFF BY TALMI INTEGRAL FOR ORDER IP
      BRAD(IP+1)= B*BT
      S = S + B*BT
500   CONTINUE
      RALL = S
      RETURN
600   CONTINUE
      RALL = 0.
      IF(IL.NE.0) RETURN
      XXX = XMU(IRAD)
      RALL = OSCRADN(I1,XXX,HBW)*OSCRADN(I2,XXX,HBW)/(4.*3.14159)
      RETURN
700   CONTINUE
      RALL = 0.
      IF(I1.EQ.I2) RALL = 1.
      RETURN
      END
 
      FUNCTION FRADQQ(I1,I2,IL)
      CHARACTER*3 KEY
      COMMON/CKEY/KEY,HBW
      COMMON/SRADQQ/SRADQQ(50,50,20)
      IF(I1.GT.50) GO TO 500
      IF(I2.GT.50) GO TO 500
      IF(IL+1.GT.20) GO TO 500
      GO TO 501
500   TYPE 502,I1,I2,IL
502   FORMAT(1X,'ERROR IN FRADQQ, I1,I2,IL = ',3I4)
501   CONTINUE
      FRADQQ = SRADQQ(I1,I2,IL+1)
      IF(FRADQQ.NE.0.) RETURN
      FRADQQ=RADQQ(I1,I2,IL,HBW)
      SRADQQ(I1,I2,IL+1) = FRADQQ
      RETURN
      END
 
      FUNCTION RADQQ(I1,I2,IL,HBW)
      COMMON/CIAAA/IAAA
      FWS(X,RWS,AWS) = -1./(1.+EXP((X-RWS)/AWS))
      XIL = IL
      S = 0.
      RM = 10.
      R = 0.
      H = .1
      IF(IAAA.GT.0) RWS = 1.2*(IAAA**(1./3.))
      IF(IAAA.LE.0) RWS = 1.2*(16**(1./3.))
      IF(IAAA.LE.0) TYPE 500
500   FORMAT(1X,'WARNING IN FUNCTION RADQQ: IAAA.LE.0 WILL ASSUME A=16')
      AWS = 0.7
101   CONTINUE
      R = R+H
      IF(R.GT.RM) GO TO 100
      X1 = OSCRADN(I1,R,HBW)
      X2 = OSCRADN(I2,R,HBW)
      R1 = R-0.1
      R2 = R+0.1
      IF(IL.GT.0)X = (R**(XIL-1))*(FWS(R2,RWS,AWS)-FWS(R1,RWS,AWS))/0.2
      IF(IL.EQ.0)X =
     1-(3.*FWS(R,RWS,AWS)+R*(FWS(R2,RWS,AWS)-FWS(R1,RWS,AWS))/0.2)
CBAB      X = R**XIL       ! FOR TEST
      S = S + X*X1*X2*R*R
      GO TO 101
100   CONTINUE
      S = S*H
      IF(IL.EQ.0) RADQQ = S
      IF(IL.GT.0) RADQQ = 50.*S/(RWS**XIL)
      RETURN
      END
 
 
      FUNCTION ISEEK_INDEX(N,L)
      COMMON/INDEX/XL(3,200)
      XN = N
      XLL = L
      DO 100 I = 1,200
      IF(XN.EQ.XL(1,I).AND.XLL.EQ.XL(2,I)) GO TO 200
100   CONTINUE
      IF(IFIRST.NE.999) WRITE(6,300) N,L
      IF(IFIRST.NE.999) WRITE(11,300) N,L
300   FORMAT(/,1X,'WARNING: INDEX NOT FOUND FOR N,L = ',2I3)
      IF(IFIRST.NE.999) IFIRST = 999
      ISEEK_INDEX = -1      
      RETURN
200   ISEEK_INDEX = I
      RETURN
      END
 
      FUNCTION ETBME(I1,I2,ISYM)
      ETBME = 0.
      IF(ISYM.LT.0) GO TO 100
      IF(ISYM.GT.6) GO TO 100
      IF(ISYM.GT.0) GO TO 120
      WRITE(6,500)
      WRITE(11,500)
500   FORMAT(
     1/,1X,
     1/,1X,'      SYM(1,X1,X2) =  (X1  PLUS X2)^1',
     1/,1X,'      SYM(2,X1,X2) =  (X1 MINUS X2)^1',
     1/,1X,'      SYM(3,X1,X2) = i(X1 CROSS X2)^1',
     1/,1X,'      SYM(4,X1,X2) =  (X1   DOT X2)^0',
     1/,1X,'      SYM(5,X1,X2) = 1               ',
     1/,1X,'      SYM(6,X1,X2) =  (X1 CROSS X2)^2',
     1/,1X)
      RETURN
100   CONTINUE
      WRITE(6,110) ISYM
      WRITE(11,110) ISYM
110   FORMAT(1X,'ILLEGAL VALUE FOR ISYM',I5)
      RETURN
120   CONTINUE
      GO TO (10,20,30,40,50,60),ISYM
10    IF(I1.EQ.1.AND.I2.EQ.1) GO TO 11
      RETURN
11    ETBME = 2.*SQRT(6.)
      RETURN
20    IF(IABS(I1-I2).EQ.1) GO TO 21
      RETURN
21    X = I2
      ETBME = PAR(X)*2.*SQRT(3.)
      RETURN
30    IF(IABS(I1-I2).EQ.1) GO TO 31
      RETURN
31    ETBME = 2.*SQRT(3.)
      RETURN
40    IF(IABS(I1-I2).EQ.0) GO TO 41
      RETURN
41    IF(I1.EQ.0) ETBME = -3.
      IF(I1.EQ.1) ETBME = SQRT(3.)
      RETURN
50    IF(IABS(I1-I2).EQ.0) GO TO 51
      RETURN
51    X = I1
      ETBME = SQRT(2.*X+1.)
      RETURN
60    IF(I1.EQ.1.AND.I2.EQ.1) GO TO 61
      RETURN
61    ETBME = 2.*SQRT(5.)
      RETURN
      END
 
 
      FUNCTION OSCRADN(I1,XR,HBW)
      COMMON/SRC/ISRC
      COMMON/INDEX/XL(3,200)
      F(X,Y) = SQRT(DFAC(2.*X+2.*Y+1.)/FAC(X))/DFAC(2.*Y+1.)
      G(X,Y,Z) = PAR(Z)*BINOM(X,Z)*DFAC(2.*Y+1.)/DFAC(2.*Y+2.*Z+1.)
      XSC = 1.
      AS = 1.1
      BS = .68
      IF(ISRC.EQ.0) GO TO 100
      XSC = 1.-EXP(-AS*XR*XR)*(1.-BS*XR*XR)
100   CONTINUE
      V = 41.465/HBW
      V = 1./V
      XN = XL(1,I1)-1.
      XLL = XL(2,I1)
      CC = V**(.75+XLL/2.)
      XX = F(XN,XLL)
      C = 1.50225*(2.**((XLL/2.)-(XN/2.)))
      IXN = XN+1.
      R = XR
      S = 0.
      DO 21 J = 1,IXN
      XK = J-1
21    S = S + (V**XK)*G(XN,XLL,XK)*(R**(2.*XK))*(2.**XK)
      YY = V*R*R/2.
      SS = XX*EXP(-YY)*S*(R**XLL)
      SS = SS*C
      OSCRADN = SS*CC*XSC
      RETURN
      END
 
      SUBROUTINE ZEROVM
      REAL*8 VM
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
      DO 8000 I1 = 1,2
      DO 8000 I2 = 1,2
      DO 8000 I3 = 1,30
      DO 8000 I4 = 1,4
      VM(I1,I2,I3,I4) = 0.
8000  CONTINUE
      RETURN
      END
 
      SUBROUTINE ZEROVMT
CWAR ZERO VMTALMI
      INCLUDE 'VNCOM.INC'
      DO 8000 I1 = 1,2
      DO 8000 I2 = 1,2
      DO 8000 I3 = 1,14
      DO 8000 I4 = 1,ITMAXMAX
      DO 8000 I5 = 1,4
      VMTAL(I1,I2,I3,I4,I5) = 0.
8000  CONTINUE
      RETURN
      END
 
      FUNCTION YLLL(IA,IB,IK)
      COMMON/INDEX/XL(3,200)
CBAB THIS IS THE REDUCED ME: <L(IA)| Y(IK) |L(IB)>
      H(X) = SQRT(2.*X+1.)
      FPI = 4.*3.14159
      XLA = XL(2,IA)
      XLB = XL(2,IB)
      XK = IK
      X = PAR(XLA)*H(XLA)*H(XLB)*H(XK)/SQRT(FPI)
      X = X*TJ(XLA,XK,XLB,0.,0.,0.)
      YLLL = X
      RETURN
      END
 
      SUBROUTINE VLSS(IO,IVLSS,SUMR,
     1N1,N2,N3,N4,L1,L2,L3,L4,IS12,IS34,IL12,IL34,IL)
      PARAMETER (IVMAX=20000)
      DIMENSION SUMR(*)
c      DIMENSION I1(1000),I2(1000),I3(1000),
c     1V(1000,2,2,3,30),IV(1000,2,2,3)
      DIMENSION I1(IVMAX),I2(IVMAX),I3(IVMAX),
     1V(IVMAX,2,2,3,30),IV(IVMAX,2,2,3)
      COMMON/CVLSS/KMAX
      IVLSS = 0
C      IF(KSTOP.EQ.1) RETURN
      IF(KMAX.EQ.0) GO TO 300
      DO 100 K = 1,KMAX
      II1 = N1+10*N2+100*L1+10000*L2
      II2 = N3+10*N4+100*L3+10000*L4
      II3 = 100*IL12+IL34
      IF(II1.EQ.I1(K).AND.II2.EQ.I2(K).AND.II3.EQ.I3(K)) GO TO 200
100   CONTINUE
300   CONTINUE
      IF(IO.EQ.0) RETURN
600   CONTINUE
C      IF(K.GE.IVMAX) KSTOP = 1
      IF(KMAX+1.GE.IVMAX.AND.IFIRST.NE.999) TYPE 500
500   FORMAT(1X,'AN INCREASE IN THE DIMENSION IN VLSS
     1 WILL SPEED UP THE CALCULATION')
      IF(KMAX+1.GE.IVMAX.AND.IFIRST.NE.999) IFIRST = 999
      IF(KMAX+1.GE.IVMAX) RETURN
      KMAX = KMAX + 1
      K = KMAX
      I1(K) = N1+10*N2+100*L1+10000*L2
      I2(K) = N3+10*N4+100*L3+10000*L4
      I3(K) = 100*IL12+IL34
350   CONTINUE
      IV(K,IS12+1,IS34+1,IL+1) = 1
C      TYPE 7778,N1,N2,N3,N4,L1,L2,L3,L4,IL,K
C7778  FORMAT(10X,4I4,1X,4I4,1X,2I4)
      DO 301 I = 1,30
      V(K,IS12+1,IS34+1,IL+1,I) = SUMR(I)
301   CONTINUE
      RETURN
200   CONTINUE
      IF(IV(K,IS12+1,IS34+1,IL+1).EQ.0.AND.IO.EQ.0) RETURN
      IF(IV(K,IS12+1,IS34+1,IL+1).EQ.0.AND.IO.EQ.1) GO TO 350
      IVLSS = 1
C      TYPE 7777,N1,N2,N3,N4,L1,L2,L3,L4,IL,K
C7777  FORMAT(1X,4I4,1X,4I4,1X,2I4)
      DO 201 I = 1,30
      SUMR(I) = V(K,IS12+1,IS34+1,IL+1,I)
201   CONTINUE
      RETURN
      END
 
C      SUBROUTINE WEDDLE
C
      SUBROUTINE WEDDLE(Y,YI,NB,H)
      PARAMETER MAXDIM=1000
CBAB Y(I) STARTS AT R=0
      DOUBLE PRECISION S1,S2,S3,S4,S5,C1,C2,C3,C4
      DIMENSION Y(MAXDIM)
      IF(NB.GT.MAXDIM) TYPE 700
700   FORMAT(1X,'ERROR IN WEDDLE')
      IF(NB.GT.MAXDIM) STOP
      C1 = .29285714D+00
      C2 = 5.268293D+00
      C3 = .6585366D+00
      C4 = 6.634146D+00
      S1=0.0
      S2=0.0
      S3=0.0
      S4=0.0
      MAX=NB-6
      DO 1 J=1,MAX,6
      S1=S1+Y(J)+Y(J+6)
      S2=S2+Y(J+1)+Y(J+5)
      S3=S3+Y(J+2)+Y(J+4)
      S4=S4+Y(J+3)
1     CONTINUE
      S5 = C1*(S1+C2*S2+C3*S3+C4*S4)
      YI = H*S5
      RETURN
      END
 
      SUBROUTINE BMOSH_SAVE(N1,L1,N2,L2,IL,I,ISAVE,BKT)
      DIMENSION BKTS(50,140),IBKTS(50,140)
      IF(IL+1.GT.50) RETURN
      II = 1+L1+100*L2+10000*N1+100000*N2
      IF(ISAVE.EQ.2) GO TO 500
      IF(IBKTS(IL+1,I).EQ.II) GO TO 200
      ISAVE = 0
      RETURN
200   BKT = BKTS(IL+1,I)
      IF(BKT.NE.0.) ISAVE = 1
      RETURN
500   CONTINUE
      BKTS(IL+1,I) = BKT
      IBKTS(IL+1,I) = II
      ISAVE = 0
      RETURN
      END
 
      SUBROUTINE BMOSH_SAVEP(N1,L1,N2,L2,IL,I,ISAVE,BKT)
      DIMENSION BKTS(50,140),IBKTS(50,140)
      IF(IL+1.GT.50) RETURN
      II = 1+L1+100*L2+10000*N1+100000*N2
      IF(ISAVE.EQ.2) GO TO 500
      IF(IBKTS(IL+1,I).EQ.II) GO TO 200
      ISAVE = 0
      RETURN
200   BKT = BKTS(IL+1,I)
      IF(BKT.NE.0.) ISAVE = 1
      RETURN
500   CONTINUE
      BKTS(IL+1,I) = BKT
      IBKTS(IL+1,I) = II
      ISAVE = 0
      RETURN
      END
 
      SUBROUTINE LISTRAD
      CHARACTER*3 KEY
      COMMON/CKEY/KEY
      COMMON/INDEX/XL(3,200)
      COMMON/RAD/RAD(7,200,200,4)
      COMMON/CVLSS/KVLSS
      DO 1000 KK = 1,4
      DO 200 I1 = 1,100
      DO 200 I2 = 1,100
      X1 = RAD(1,I1,I2,KK)
      X2 = RAD(2,I1,I2,KK)
      X3 = RAD(3,I1,I2,KK)
      X4 = RAD(4,I1,I2,KK)
      X5 = RAD(5,I1,I2,KK)
      X6 = RAD(6,I1,I2,KK)
      X7 = RAD(7,I1,I2,KK)
      IF(X1.EQ.0.AND.X2.EQ.0.AND.X3.EQ.0.AND.X4.EQ.0
     1.AND.X5.EQ.0.AND.X6.EQ.0.AND.X7.EQ.0.) GO TO 200
      IF(IFIRST.NE.99) OPEN(UNIT=12,FILE='RADINT.'//KEY,STATUS='NEW')
      IF(IFIRST.NE.99) WRITE(6,100),KK
      IF(IFIRST.NE.99) WRITE(11,100),KK
100   FORMAT(/,1X,'  N1  L1  N2  L2   RADINT
     1 LIST OF RADIAL INTEGRALS USED FOR K = ',I1,/)
      IF(IFIRST.NE.99) IFIRST = 99
      N1 = XL(1,I1)
      N2 = XL(1,I2)
      L1 = XL(2,I1)
      L2 = XL(2,I2)
      WRITE(6,300) N1,L1,N2,L2,X1,X2,X3,X4,X5,X6,X7
      WRITE(11,300) N1,L1,N2,L2,X1,X2,X3,X4,X5,X6,X7
300   FORMAT(1X,4I4,10F9.7)
      WRITE(12,301) KK,I1,I2,X1,X2,X3,X4,X5,X6,X7
301   FORMAT(1X,3I4,10(1X,E14.6))
200   CONTINUE
1000  CONTINUE
      IF(KVLSS.GT.0) WRITE(6,500),KVLSS
      IF(KVLSS.GT.0) WRITE(11,500),KVLSS
500   FORMAT(/,1X,'MAX NUMBER IN VLSS = ',I5)
      RETURN
      END
 
      SUBROUTINE READRAD
      CHARACTER*3 KEY
      COMMON/CKEY/KEY
      COMMON/RAD/RAD(7,200,200,4)
      OPEN(UNIT=12,FILE='RADINT.'//KEY,STATUS='OLD')
500   CONTINUE
      READ(12,301,ERR=501) KK,I1,I2,RAD(1,I1,I2,KK),RAD(2,I1,I2,KK),
     1RAD(3,I1,I2,KK),RAD(4,I1,I2,KK),RAD(5,I1,I2,KK),
     1RAD(6,I1,I2,KK),RAD(7,I1,I2,KK)
301   FORMAT(1X,3I4,10(1X,E14.6))
      GO TO 500
501   CONTINUE
      CLOSE(UNIT=12)
      RETURN
      END

      FUNCTION VCM(I1,I2,I3,I4,IL)
      COMMON/INDEX/XL(3,200)
      REAL*8 VCM1,VCM2,VCM3,VCM4,VCM5,ADAG,AAAG,VCM,WN,XPAR
      L1 = 2*XL(2,I1)
      L2 = 2*XL(2,I2)
      L3 = 2*XL(2,I3)
      L4 = 2*XL(2,I4)
      IIL = 2*IL
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XL3 = XL(2,I3)
      XL4 = XL(2,I4)
      XIL = IL
      XPAR = -PAR(XIL+XL1+XL4)
      VCM1 = XPAR*WN(L1,L2,L3,L4,IIL,2)
      VCM2 = ADAG(I1,I3) 
      VCM3 = AAAG(I2,I4) 
      VCM4 = AAAG(I1,I3) 
      VCM5 = ADAG(I2,I4) 
      VCM = VCM1*(VCM2*VCM3+VCM4*VCM5)
      RETURN
      END

   
      FUNCTION AAAG(I1,I2)
      REAL*8 ADAG,AAAG
      AAAG = ADAG(I2,I1)
      RETURN
      END

      FUNCTION ADAG(I1,I2)
CBAB these equations are based on Gartenhaus and Schwartz,
CBAB Phys. Rev. 108, 482 (1957)
      REAL*8 ADAG,AAAG,XN1,XN2,XL1,XL2
      COMMON/INDEX/XL(3,200)
      N1 = 2.*XL(1,I1)+XL(2,I1)
      N2 = 2.*XL(1,I2)+XL(2,I2)
      XN1 = 2.*(XL(1,I1)-1.)+XL(2,I1)
      XN2 = 2.*(XL(1,I2)-1.)+XL(2,I2)
      L1 = XL(2,I1)
      L2 = XL(2,I2)
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      ADAG = 0.
      IF(N1.EQ.N2+1.AND.L1.EQ.L2+1) ADAG = SQRT((XL2+1.)*(XN2+XL2+3.))
      IF(N1.EQ.N2+1.AND.L1.EQ.L2-1) ADAG = SQRT((XL2)*(XN2-XL2+2.))
      RETURN
      END

      FUNCTION XLSJJN(XL1,XL2,XL3,XL4,XL5,XL6,XL7,XL8,XL9)
      DOUBLE PRECISION XLSJJN,XXL3,XXL6,XXL7,XXL8,COEF9
      XXL3 = XL3
      XXL6 = XL6
      XXL7 = XL7
      XXL8 = XL8
      L1 = 2.*XL1
      L2 = 2.*XL2
      L3 = 2.*XL3
      L4 = 2.*XL4
      L5 = 2.*XL5
      L6 = 2.*XL6
      L7 = 2.*XL7
      L8 = 2.*XL8
      L9 = 2.*XL9
      XLSJJN = SQRT((2.*XXL3+1.)*(2.*XXL6+1.)*(2.*XXL7+1.)*(2.*XXL8+1.))
      XLSJJN = XLSJJN*COEF9(L1,L2,L3,L4,L5,L6,L7,L8,L9)
      RETURN 
      END
C
C
C  TO CALC 9J 1 2 3
C             4 5 6
C             7 8 9
C
C  SUM OVER RACAH'S
C
C
      FUNCTION COEF9(J1,J2,J3,J4,J5,J6,J7,J8,J9)
      DOUBLE PRECISION COEF9,WN
      COEF9=0.0
      KMIN=MAX0(IABS(J1-J9),IABS(J4-J8),IABS(J2-J6))
      KMAX=MIN0(J1+J9,J4+J8,J2+J6)
      IF (KMIN.GT.KMAX) RETURN
      DO 100 K=KMIN,KMAX,2
      COEF9=COEF9+(K+1)
     1*WN(J1,J9,J4,J8,K,J7)
     2*WN(J2,J6,J8,J4,K,J5)
     3*WN(J1,J9,J2,J6,K,J3)
100   CONTINUE
      RETURN
      END
C
C
C  TO CALC W COEFFICIENT
C
      FUNCTION WN(IA,IB,IC,ID,IE,IF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION FACLOG(100),LT(6)
      EXP(X)=DEXP(X)
      SQRT(X)=DSQRT(X)
      ABS(X)=DABS(X)
      IF (ISETFC.GT.0) GO TO 10
      ISETFC=1
C
C  SET UP FACLOG
C
      FACLOG(1)=0.0
      FACLOG(2)=0.0
      FN=1.
      DO 5 N=3,100
      FN=FN+1.0D0
5     FACLOG(N)=FACLOG(N-1)+DLOG(FN)
10    K1=IA+IB-IE
      K3=IC+ID-IE
      K5=IA+IC-IF
      K7=IB+ID-IF
      K2=IE-IABS(IA-IB)
      K4=IE-IABS(IC-ID)
      K6=IF-IABS(IA-IC)
      K8=IF-IABS(IB-ID)
      K9=MIN0(K1,K2,K3,K4,K5,K6,K7,K8)
      WN=0.0
      IF (K9) 4000,20,20
   20 K2=K1-2*(K1/2)
      K4=K3-2*(K3/2)
      K6=K5-2*(K5/2)
      K8=K7-2*(K7/2)
      IF(MAX0(K2,K4,K6,K8)) 4000,25,4000
   25 LTMIN=MIN0(IA,IB,IC,ID,IE,IF)
      IF(LTMIN) 4000,30,150
   30 LT(1)=IA
      LT(2)=IB
      LT(3)=IC
      LT(4)=ID
      LT(5)=IE
      LT(6)=IF
      LTMIN=LT(1)
      KMIN=1
      DO 40 N=2,6
      IF(LT(N)-LTMIN)35,40,40
   35 LTMIN=LT(N)
      KMIN=N
   40 CONTINUE
      S1=1.0
      F1=IE
      F2=IF
      GO TO (55,55,55,55,45,50),KMIN
   45 F1=IA
      F2=IC
      S1=1-2*MOD(K5/2,2)
      GO TO 55
   50 F1=IA
      F2=IB
      S1=1-2*MOD(K1/2,2)
   55 WN=S1/ SQRT((F1+1.  )*(F2+1.  ))
      GO TO 4000
  150 IABEP=(IA+IB+IE)/2+1
      ICDEP=(IC+ID+IE)/2+1
      IACFP=(IA+IC+IF)/2+1
      IBDFP=(IB+ID+IF)/2+1
      IABE=IABEP-IE
      IEAB=IABEP-IB
      IBEA=IABEP-IA
      ICDE=ICDEP-IE
      IECD=ICDEP-ID
      IDEC=ICDEP-IC
      IACF=IACFP-IF
      IFAC=IACFP-IC
      ICFA=IACFP-IA
      IBDF=IBDFP-IF
      IFBD=IBDFP-ID
      IDFB=IBDFP-IB
      NZMAX=MIN0(IABE,ICDE,IACF,IBDF)
      IABCD1=(IA+IB+IC+ID+4)/2
      IEFMAD=(IE+IF-IA-ID)/2
      IEFMBC=(IE+IF-IB-IC)/2
      NZMI1=-IEFMAD
      NZMI2=-IEFMBC
      NZMIN=MAX0(0,NZMI1,NZMI2)+1
      SQLOG=0.5  *(FACLOG(IABE)+FACLOG(IEAB)+FACLOG(IBEA)+FACLOG(ICDE)
     1          +FACLOG(IECD)+FACLOG(IDEC)+FACLOG(IACF)+FACLOG(IFAC)
     2          +FACLOG(ICFA)+FACLOG(IBDF)+FACLOG(IFBD)+FACLOG(IDFB)
     3 -FACLOG(IABEP+1)-FACLOG(ICDEP+1)-FACLOG(IACFP+1)-FACLOG(IBDFP+1))
      DO 200 NZ=NZMIN,NZMAX
      NZM1=NZ-1
      S1=1-2*MOD(NZM1,2)
      K1=IABCD1-NZM1
      K2=IABE-NZM1
      K3=ICDE-NZM1
      K4=IACF-NZM1
      K5=IBDF-NZM1
      K6=NZ
      K7=IEFMAD+NZ
      K8=IEFMBC+NZ
      SSLOG=SQLOG+FACLOG(K1)-FACLOG(K2)-FACLOG(K3)-FACLOG(K4)
     1           -FACLOG(K5)-FACLOG(K6)-FACLOG(K7)-FACLOG(K8)
      SSTERM=S1* EXP(SSLOG)
      WN=WN+SSTERM
  200 CONTINUE
      IF( ABS(WN).LT.1.0E-10 ) WN=0.0
 4000 RETURN
      END

