CBAB  THIS IS A GENERAL PROGRAM WHICH CALCULATES TBME BASED ON
CBAB  HARMONIC OSCILLATOR RADIAL WAVE FUNCTIONS
CBAB B. A. BROWN, OCTOBER 1987
 
CBAB  IMPROVEMENTS MADE IN MAY 1986
CBAB  1) ADDED OPTIONS FOR DELTA AND SURFACE DELTA
CBAB  2) SIMPLIFIED THE SUBROUTINES READPRM AND SETVOUT
CBAB  3) SIMPLIFIED INPUTS IN MAIN
CWAR  IMPROVEMENTS MADE IN MAY 1987
CWAR  1) ADDED OPTION TO CALCULATE TALMI INTEGRAL COEFFICIENTS
CWAR  2) ADDED DENSITY DEPENDENCE FOR THESE COEFFICIENTS
 
      COMMON/CANT/IANT
      COMMON/CIDEC/IDEC
      COMMON/CIK/IK(30,4),IKMAX(4)
      COMMON/CIKOUT/IKOUT(200,4),IKCOF(200,4),IKASK(200)
      CHARACTER*3 KEY,KEY2
      COMMON/CSU3/XCSU3,XMSU3,XLSU3,XSSU3,
     1ISU3MAX,ISU3(50),SU3SPE(50),ISU3OUT(50)
      COMMON/CKEY/KEY,HBW
      COMMON/CKEY2/KEY2
      REAL*8 VM
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
      COMMON/CDELTA/VNDEL,ALDEL,A0,A1,B0,B1,Q0,Q1
      CHARACTER*20 TOTFIL
      CHARACTER*9 PRFIL,INDFIL,WSF
      COMMON/WSF/WSF
      COMMON/CNAME/PRFIL
      COMMON/INDEX/XL(3,200)
      COMMON/CRADINT/IRADINT
      COMMON/CIAAA/IAAA
      COMMON/CIDD/IDD,ALD,BLD,R0D,DIFFD
      COMMON/MEI/IDJ,IDT,IDP
      COMMON/CCOF/ICOF,NPARAM,VOUT(100)
      COMMON/CJME/JME
      COMMON/CSETPARV/ICAV,ILAV,ITAV,ISETL(10),ISETLNUM,ISETTMIN,ISETTMAX
 
      INCLUDE 'VNCOM.INC'
      COMMON/VTOL/VMTOTL(2,2,14,15,4)
      COMMON/VSAVE/SUMT_SAVE(2,2,15,3)
      COMMON/CORE/IKC(30),IKCMAX,XCORE(100)
      DIMENSION IFF(4),IFFF(4),ITEMP(30)
 
CBAB  UNIT NUMBERS IN USE: 5,6,9,11,12,14,30
 
      OPEN(UNIT=5,FILE='SYS$INPUT',STATUS='OLD')
      OPEN(UNIT=6,FILE='SYS$OUTPUT',STATUS='NEW')
      CALL INDEX
 
      NPARAM = 0
      WRITE(6,1)
    1 FORMAT(/,1X,'NAME FOR OUTPUT FILES (A9), NAME FOR *.WS FILE :')
      DO 908 I = 1,20
908   TOTFIL(I:I) = ' '
      DO 909 I = 1,9
      PRFIL(I:I) = ' '
909   WSF(I:I) = ' '
      READ(5,2) TOTFIL
    2 FORMAT(A20)
      ICOMMA = 0
      DO 900 I = 1,20
900   IF(TOTFIL(I:I).EQ.',') ICOMMA = I
      DO 901 I = 1,20
      IF(TOTFIL(I:I).EQ.' ') ISPACE = I
      IF(TOTFIL(I:I).EQ.' ') GO TO 902
901   CONTINUE
902   CONTINUE
      IF(ICOMMA.EQ.0) GO TO 903
      DO 904 I = 1,ICOMMA-1
904   PRFIL(I:I) = TOTFIL(I:I)
      DO 907 I = ICOMMA+1,ISPACE-1
907   WSF(I:I) = TOTFIL(I:I)
      GO TO 905
903   CONTINUE
      DO 906 I = 1,ISPACE-1
906   PRFIL(I:I) = TOTFIL(I:I)
905   CONTINUE
C      TYPE 7777,PRFIL,WSF
C7777  FORMAT(1X,A9,1X,A9)
C      READ(5,2) PRFIL
C    2 FORMAT(A9)
      IF(PRFIL.EQ.' ') PRFIL = 'TEST'
      OPEN(UNIT=11,FILE=PRFIL//'.DAO',STATUS='NEW')
      WRITE(11,3) PRFIL
    3 FORMAT(/,1X,'INTERACTION FILE NAME = ',A9)
      OPEN(UNIT=9,FILE=PRFIL//'.INT',STATUS='NEW')
      OPEN(UNIT=29,FILE=PRFIL//'.MIT',STATUS='NEW')
      WRITE(9,4) PRFIL
    4 FORMAT(1X,'! Name of command file for input = ',A9)
 
    5 CONTINUE
      WRITE(6,6)
      WRITE(11,6)
    6 FORMAT(
     1/,1X,'IRADINT = 2 to create TALMI file',
     1/,1X,'        = 1 to read existing TALMI file',
     1/,1X,'ICOF    = 0 for no *.COF file',
     1/,1X,'          1 for *.PRV file input and *.COF output',
     1/,1X,'          2 for *.PRV file input only',
     1/,1X,'          3 for *.COF output with SDI etc',
     1/,1X,'          4 for internal H7B *.COF output',
     1/,1X,'          5 for internal HBB *.COF output',
     1/,1X,'ITALMI  = 0 for normal output',
     1/,1X,'        = 1 to calculate Talmi integral coefficients',
     1/,1X,'            and store them in *.COF',
     1/,1X,'IT1     = 0 for both T=0 and 1',
     1/,1X,'        = 1 for T = 1 only',
     1/,1X,'        = 2 for T = 0 only',
     1/,1X,'ICH     = 0 for no change in VS',
     1/,1X,'        = 1 to change VS values',
     1/,1X,'ILIST   = 0 for internal order (I1.LE.I2 and I3.LE.I4)',
     11X,'and I1<=I3',
     1/,1X,'        = 1 for internal order (I2.LE.I1 and I4.LE.I3)',
     1/,1X,'        = 2 for no order check',
     1/,1X,'ILIST   = 3 for internal order (I1.LE.I2 and I3.LE.I4)',
     11X,'and I1>=I3',
     1/,1X,'        = 8 for indices from *.INT file',
     1/,1X,'        = 9 for indices from *.MIT file',
     1/,1X,'        =10 for indices from *.INL file (standard
     1 index)',
     1/,1X,'IDEC    = 0 for no extra output',
     1/,1X,'        = 1 for detailed decomposition output',
     1/,1X,'IANT    = 0 for normal direct + antisymmetric me',
     1/,1X,'        = 1 for direct me',
     1//,1X,'IRADINT,ICOF,ITALMI,IT1,ICH,ILIST,IDEC,IANT')
      READ(5,7) IRADINT,ICOF,ITALMI,IT1,ICH,ILIST,IDEC,IANT
    7 FORMAT(10I)
      I12 = ILIST
      IF(ILIST.EQ.3)I12 = 0
      WRITE(11,8) IRADINT,ICOF,ITALMI,IT1,ICH,ILIST,IDEC,IANT
    8 FORMAT(/,1X,'INPUT = ',10I3)
 
      WRITE(6,9)
      WRITE(11,9)
    9 FORMAT(
     1/,1X,'KEY,X  KEY = type of interaction',
     1/,1X,'       X = NZ (no zeros) to suppress output of TBME which
     1 are zero'
     1,/,1X,'KIN  all kinetic energies (in units of HBW)'
     1,/,1X,'PNC'
     1,/,1X,'KIO  only off-diagonal kinetic energies (in units of HBW)'
     1,/,1X,'HCO  one-body HCM'
     1,/,1X,'DET  Delta (V0,V1)'
     1,/,1X,'DEL  Delta (Vn,alpha)'
     1,/,1X,'SDI  Surface delta'
     1,/,1X,'PRN  TO READ *.PRN AND *.COF FILES')
      CALL GETVS(1)
      READ(5,10) KEY,KEY2
   10 FORMAT(A3,1X,A3)
      WRITE(11,11) KEY,KEY2
   11 FORMAT(/,1X,'INPUT = ',A3,1X,A3)
      IF(KEY.EQ.' ') STOP
CBAB ********** OUTPUT TO *.INT FILE HEADER
      WRITE(9,12) KEY
   12 FORMAT(1X,'! Type of interaction = ',A3)
 
      WRITE(6,13)
      WRITE(11,13)
   13 FORMAT(
     1/,1X,'IA  = integer mass of core',
     1/,1X,'HBW = hw in MeV,'
     1/,1X,'    input=0. will take hw = 45*(IA)**(-1/3)-25*(IA)**(-2/3)',
     1/,1X,'ALD,BLD,R0D,DIFFD for G-matrix density dependence',
     1/,1X,'    V(R) = ALD*(FWS(R)**BLD),
     1 FWS(R) = 1/[1+exp(R-R0D*A**1/3)/DIFFD]',
     1/,1X,'    input=0. will take ALD=BLD=1., R0D=1.1 and DIFFD=0.6',
     1//,1X,'IA,HBW,ALD,BLD,R0D,DIFFD')
 
      READ(5,14) IAAA,XHBW,ALD,BLD,R0D,DIFFD
   14 FORMAT(I,5F)
      WRITE(11,15) IAAA,XHBW,ALD,BLD,R0D,DIFFD
   15 FORMAT(/,1X,'INPUT = ',I4,2X,5F10.5)
 
      IF(XHBW.LT.0.) TYPE 16
      IF(XHBW.LT.0.) STOP
   16 FORMAT(1X,'HBW INPUT MUST BE >0')
      IF(XHBW.GT.0.) HBW = XHBW
      IF(XHBW.EQ.0..AND.IAAA.GT.0)
     1HBW = 45.*(IAAA**(-1./3.))-25.*(IAAA**(-2./3.))
      WRITE(11,17) HBW
   17 FORMAT(/,1X,'HBW = ',F10.5)
 
CBAB ********** OUTPUT TO *.INT FILE HEADER
      IF(KEY.NE.'HBW') WRITE(9,18) IAAA,HBW,ALD,BLD,R0D,DIFFD
   18 FORMAT(1X,'! IA,HBW,ALD,BLD,R0D,DIFFD = ',I4,1X,5(F7.3,2X))
 
      IF(KEY.EQ.'DEL') GO TO 1320
      IF(KEY.EQ.'DET') GO TO 1370
      IF(KEY.EQ.'SDI') GO TO 1340
      IF(KEY.EQ.'SU3') GO TO 1360
      IF(KEY.EQ.'PRN') GO TO 1330
      GO TO 1350
 
 1320 CONTINUE
      VNDEL = -500.
      ALDEL = 0.12
      WRITE(6,1316) VNDEL,ALDEL
      WRITE(11,1316) VNDEL,ALDEL
 1316 FORMAT(1X,'VN,AL FOR DELTA [ V = VN*(1+AL*SIGMA.SIGMA)*DELTA ]',
     1/,     1X,'      DEFAULTS VN,AL = ',2F10.3)
      READ(5,1317) X1,X2
 1317 FORMAT(2F)
      IF(X1.NE.0.) VNDEL = X1
      IF(X2.NE.0.) ALDEL = X2
      WRITE(9,5005) VNDEL,ALDEL
 5005 FORMAT(1X,'! VN,AL = ',2F10.3,4X,'V=VN*(1+AL*SIGMA.SIGMA)*DELTA')
      GO TO 1330
 
 1370 CONTINUE
      VNDEL = -500.
      ALDEL = 0.12
      V0DEL = VNDEL*(1.+ALDEL)
      V1DEL = VNDEL*(1.-3.*ALDEL)
      WRITE(6,1371) V0DEL,V1DEL
      WRITE(11,1371) V0DEL,V1DEL
 1371 FORMAT(1X,'V0,V1 FOR DELTA [ V = (V0(T=0) + V1(T=1))*DELTA ]',
     1/,     1X,'      DEFAULTS V0,V1 = ',2F10.3)
      READ(5,1372) X1,X2
 1372 FORMAT(2F)
      IF(X1.NE.0.) V0DEL = X1
      IF(X2.NE.0.) V1DEL = X2
      WRITE(9,1373) V0DEL,V1DEL
 1373 FORMAT(1X,'! V0,V1 = ',2F10.3,4X,'V=(V0(T=0)+V1(T=1))*DELTA')
      VNDEL = (3.*V0DEL+V1DEL)/4.
      IF(VNDEL.NE.0.) ALDEL = ((V0DEL/VNDEL)-1.)
      IF(VNDEL.EQ.0.) ALDEL = ((V0DEL/.0000001)-1.)
      GO TO 1330
 
 1340 CONTINUE
      A0 = 0.774
      A1 = 0.954
      B0 = -2.503
      B1 = 0.370
      Q0 = 0.
      Q1 = 0.
      WRITE(6,1346) A0,A1,B0,B1,Q0,Q1
      WRITE(11,1346) A0,A1,B0,B1,Q0,Q1
 1346 FORMAT(1X,'A0,A1,B0,B1,Q0,Q1
     1for V = A0*SDI(T=0)+A1*SDI(T=1)+B0+B1+Q.Q',
     1/,     1X,'            defaults = ',6F8.4)
      READ(5,1347) X1,X2,X3,X4,X5,X6
 1347 FORMAT(6F)
      IF(X1.NE.0.) A0 = X1
      IF(X2.NE.0.) A1 = X2
      IF(X3.NE.0.) B0 = X3
      IF(X4.NE.0.) B1 = X4
      IF(X5.NE.0.) Q0 = X5
      IF(X6.NE.0.) Q1 = X6
      WRITE(9,5006) A0,A1,B0,B1,Q0,Q1
 5006 FORMAT(1X,'! A0,A1,B0,B1,Q0,Q1 = ',6F8.4,' for surface delta')
      GO TO 1330
 
 1360 CONTINUE
CBAB ********** THESE ARE BASED ON BILL RAE'S ORIGINAL VALUES
      XCSU3 = -1./8.
      XMSU3 = -20.
      XLSU3 = 1./4.
      XSSU3 = 1.
      WRITE(6,1366) XCSU3,XMSU3,XLSU3,XSSU3
      WRITE(11,1366) XCSU3,XMSU3,XLSU3,XSSU3
 1366 FORMAT(1X,'constancts for C,M,L,S, defaults = ',4F8.4)
      READ(5,1367) X1,X2,X3,X4
 1367 FORMAT(4F)
      IF(X1.NE.0.) XCSU3 = X1
      IF(X2.NE.0.) XMSU3 = X2
      IF(X3.NE.0.) XLSU3 = X3
      IF(X4.NE.0.) XSSU3 = X4
      WRITE(9,1368) XCSU3,XMSU3,XLSU3,XSSU3
 1368 FORMAT(1X,'! constants for C,M,L,S = ',4F8.3)
      GO TO 1350
 
 1350 CONTINUE
      CALL GETVS(0)
 
      IF(ICH.EQ.0) GO TO 6000
 6004 CONTINUE
      WRITE(6,6001)
      WRITE(11,6001)
 6001 FORMAT(1X,'IT,IS,IR,ITYPE,VALUE (IT=0 TO END LIST)')
      READ(5,6002) I1,I2,I3,I4,X
 6002 FORMAT(4I,F)
      WRITE(11,6003) I1,I2,I3,I4,X
 6003 FORMAT(1X,'INPUT = ',4I3,F12.5)
      IF(I1.EQ.0) GO TO 6000
      IF(X.NE.0.) VS(I1,I2,I3,I4) = X
      GO TO 6004
 6000 CONTINUE
      GO TO 1330
 
 1330 CONTINUE
      IDUM = 0
CBAB ************ OUTPUT TO *.INT FILE HEADER
      IF(KEY.NE.'HBU'.AND.KEY.NE.'SU3'.AND.KEY.NE.'HCM')
     1 WRITE(9,5010)IDUM
 5010 FORMAT(1X,'! Fill in next line with number of TBME and SPE',
     1/,1X,I3)
      IF(KEY.EQ.'HBU')WRITE(9,5011)
 5011 FORMAT(1X,'  63  1.6791 -4.0003 -3.4512')
 
 
      IDJ = 0
      IDT = 0
      IDP = 0
      IF(KEY.EQ.'PNC') IDP = 1
      XDJ = IDJ
      XDT = IDT
      XDP = IDP
 
      IF(IRADINT.EQ.1) CALL READTALMI
 
      ICAV = 1
      ILAV = 1
      ITAV = 1
      ISETTMIN = 0
      ISETTMAX = 1
      IF(IT1.EQ.1) ISETTMIN = 1
      IF(IT1.EQ.1) ISETTMAX = 1
      IF(IT1.EQ.2) ISETTMIN = 0
      IF(IT1.EQ.2) ISETTMAX = 0
      IF(ICOF.EQ.1.OR.ICOF.EQ.2) CALL READPRM
      IF(ICOF.EQ.4.OR.ICOF.EQ.5) CALL READPRMI
 
      IF(ILIST.EQ.10) GO TO 7000
      WRITE(6,234)
      WRITE(11,234)
  234 FORMAT(/,1X,'TBME = <I1,I2,J,T|V|I3,I4,J,T>')

      IEND = 0
      DO 2000 III = 1,4
      IF(IEND.EQ.0) WRITE(6,230) III
      IF(IEND.EQ.0) WRITE(11,230) III
  230 FORMAT(/,1X,'LIST OF INDEX NUMBERS FOR ORBIT I',I1
     1,' (E.G. "1,2,3")')
      IF(IEND.EQ.0) READ(5,231) (IK(I,III),I=1,30)
      IF(IK(1,III).EQ.0) IEND = 1
      IF(IEND.EQ.0) GO TO 245
      DO 243 I = 1,30
243   IK(I,III) = IK(I,IEND)
245   CONTINUE
      DO 232 I = 1,30
      IF(IK(I,III).EQ.0) GO TO 233
  232 CONTINUE
  233 IKMAX(III) = I-1
      IF(IEND.EQ.0) WRITE(6,400) III
      IF(IEND.EQ.0) WRITE(11,400) III
  400 FORMAT(/,1X,'LIST OF OUTPUT LABELS FOR ORBIT I',I1
     1,' (E.G. "1,2,3")')
      IF(IEND.EQ.0) READ(5,231) (ITEMP(I),I=1,30)
  231 FORMAT(30I)
      DO 241 I = 1,IKMAX(III)
      IF(ITEMP(I).NE.0) IKOUT(IK(I,III),III) = ITEMP(I)
      IF(ITEMP(I).EQ.0) IKOUT(IK(I,III),III) = IK(I,III)
      IKCOF(IK(I,III),III) = IKOUT(IK(I,III),III)
  241 CONTINUE
      WRITE(11,229) (IK(I,III),I=1,IKMAX(III))
  229 FORMAT(/,1X,'INPUT = ',30I3)
      DO 510 I = 1,IKMAX(III)
      IKASK(IK(I,III)) = 99
      WRITE(6,511) IK(I,III),XL(1,IK(I,III)),XL(2,IK(I,III)),
     1XL(3,IK(I,III))
      WRITE(11,511) IK(I,III),XL(1,IK(I,III)),XL(2,IK(I,III)),
     1XL(3,IK(I,III))
511   FORMAT(1X,'FOR ORBIT: ',I3,3X,' N,L,J = ',3F5.1)
510   CONTINUE
      IF(III.EQ.1) GO TO 520
      GO TO 521
520   CONTINUE
      ISU3MAX = IKMAX(1)
      DO 522 IISU3 = 1,IKMAX(1)
522   ISU3(IISU3) = IK(IISU3,1)
521   CONTINUE
2000  CONTINUE
 
      IKOUTMIN = 999
      DO 2520 I = 1,200
      IF(IKASK(I).EQ.0) GO TO 2520
      IF(I.LE.IKOUTMIN) IKOUTMIN = I
 2520 CONTINUE
 
      DO 2500 I = 1,200
      IF(IKASK(I).EQ.0) GO TO 2500
      I1 = I
      I2 = IKOUT(I,1)
      IF(I1.GT.0.AND.I2.GT.0) ISU3OUT(I2) = I1
2500  CONTINUE
 
      IF(KEY.EQ.'SU3')CALL SSU3SPE
      IF(KEY.EQ.'SU3')WRITE(9,5012),IDUM,
     1(SU3SPE(ISU3OUT(I)),I=1,ISU3MAX)
5012  FORMAT(1X,I3,10F10.5)
 
      IF(ILIST.EQ.8.OR.ILIST.EQ.9) GO TO 7000
CBAB  ISH=1 FOR S,P SHELLS
CBAB  ISH=2 FOR P SHELL
CBAB  ISH=4 FOR SD SHELL AND 7 FOR FP
 
CBAB      IF(IK(1,1).EQ.1) ISH=1    ! FOR SP SPACE
CBAB      IF(IK(1,1).EQ.3) ISH=3    ! FOR P SPACE
 
CBAB      IF(IK(1,1).EQ.4) ISH=4    ! FOR SD SPACE "USD"
CBAB      IF(IK(1,1).EQ.7.AND.IK(2,1).EQ.9.AND.IK(3,1).EQ.8
CBAB     1.AND.IK(4,1).EQ.10.AND.IK(5,1).EQ.0) ISH=7    ! FOR FP SPACE
CBAB      IF(IK(4,1).EQ.7.AND.IK(5,1).EQ.9.AND.IK(6,1).EQ.8
CBAB     1.AND.IK(7,1).EQ.10.AND.IK(8,1).EQ.0) ISH=7    ! FOR SDFP SPACE
 
CBAB CHANGED JUNE 27 1988 ITMAX NOT SET IN SUBROUTINE RALL
CWAR  SET MAXIMUM ORDER FOR TALMI INTEGRAL PARAMETERIZATION
      IF(ITALMI.EQ.0) GO TO 3890
      ITMAX = 0
3890  CONTINUE
 
      IF(KEY.EQ.'HCM')THEN
      CALL CORE
      IF(IKMAX(1).LT.18)WRITE(9,5013)IDUM,(XCORE(I),I=1,IKMAX(1))
      IF(IKMAX(1).EQ.18)WRITE(9,5014)IDUM,(XCORE(I),I=1,IKMAX(1))
      ENDIF
 5013 FORMAT(1X,I5,<IKMAX(1)>F9.5)
 5014 FORMAT(1X,I5,6(F9.5,','),' - ',/,
     1(6X,6(F9.5,','),' - ',/),6X,6(F9.5,','))
      J=0
      IF(IKMAX(1).EQ.1.AND.IKMAX(2).EQ.1.AND.IKMAX(3).EQ.1.AND.
     1IKMAX(4).EQ.1) ILIST = 2
      DO 240 L1 = 1,IKMAX(1)
      DO 240 L2 = 1,IKMAX(2)
      DO 240 L3 = 1,IKMAX(3)
      DO 240 L4 = 1,IKMAX(4)
      I1 = IK(L1,1)
      I2 = IK(L2,2)
      I3 = IK(L3,3)
      I4 = IK(L4,4)
      IF(ILIST.EQ.2) GO TO 206
      IF(KEY.NE.'PNC'.AND.ILIST.LT.2)THEN
      IF((100*IKCOF(I1,1)+IKCOF(I2,2)).
     1GT.(100*IKCOF(I3,3)+IKCOF(I4,4))) GO TO 240
      ENDIF
      IF(KEY.NE.'PNC'.AND.ILIST.EQ.3)THEN
      IF((100*IKCOF(I1,3)+IKCOF(I2,4)).
     1LT.(100*IKCOF(I3,1)+IKCOF(I4,2))) GO TO 240
      ENDIF
      IF(ILIST.EQ.0.AND.(IKCOF(I1,1).GT.IKCOF(I2,2))) GO TO 240
      IF(ILIST.EQ.0.AND.(IKCOF(I3,3).GT.IKCOF(I4,4))) GO TO 240
      IF(ILIST.EQ.3.AND.(IKCOF(I1,1).GT.IKCOF(I2,2))) GO TO 240
      IF(ILIST.EQ.3.AND.(IKCOF(I3,3).GT.IKCOF(I4,4))) GO TO 240
      IF(ILIST.EQ.1.AND.(IKCOF(I1,1).LT.IKCOF(I2,2))) GO TO 240
      IF(ILIST.EQ.1.AND.(IKCOF(I3,3).LT.IKCOF(I4,4))) GO TO 240
  206 CONTINUE
 
      XLL1 = XL(2,I1)
      XLL2 = XL(2,I2)
      XLL3 = XL(2,I3)
      XLL4 = XL(2,I4)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      NM1 = XL(1,I1)
      NM2 = XL(1,I2)
      NM3 = XL(1,I3)
      NM4 = XL(1,I4)
      LL1 = XL(2,I1)
      LL2 = XL(2,I2)
      LL3 = XL(2,I3)
      LL4 = XL(2,I4)
      J1 = 2.*XJ1
      J2 = 2.*XJ2
      J3 = 2.*XJ3
      J4 = 2.*XJ4
 
      IF(PAR(XLL1+XLL2+XLL3+XLL4).NE.PAR(XDP)) GO TO 240
 
      J12MIN = 1+IABS(J1-J2)/2
      J34MIN = 1+IABS(J3-J4)/2
      J12MAX = 1+(J1+J2)/2
      J34MAX = 1+(J3+J4)/2
CFP
CWAR FIRST SET OF DO'S FOR SD SHELL
CWAR SECOND FOR FP SHELL
 
CBABCWAR  FIRST SET OF DO'S FOR SD SHELL
CBAB  AND FOR ALL OTHERS
      DO 250 KJ12 = J12MIN,J12MAX
      DO 250 KJ34 = J34MIN,J34MAX
      DO 250 KT12 = ISETTMIN+1,ISETTMAX+1
      DO 250 KT34 = ISETTMIN+1,ISETTMAX+1
      CALL ME(I1,I2,I3,I4,KJ12,KJ34,KT12,KT34)
  250 CONTINUE
  240 CONTINUE
      GO TO 7001
 
CBAB ********* INDEX NUMBERS OBTAINED FROM OLD *.INT FILE
 7000 CONTINUE
      IF(ILIST.EQ.8) GO TO 7010
      IF(ILIST.EQ.10) GO TO 7030
      IF(ILIST.EQ.9) GO TO 7011
7030  CONTINUE
      WRITE(6,7032)
      WRITE(11,7032)
7032  FORMAT(1X,'NAME FOR *.INL FILE FOR INDEX NUMBERS')
      READ(5,7033) INDFIL
7033  FORMAT(A)
      WRITE(11,7034) INDFIL
7034  FORMAT(1X,'INPUT = ',A13)
      OPEN(UNIT=19,FILE=INDFIL//'.INL',STATUS='OLD')
      CALL SKIPHEAD(19)
      GO TO 7013
7010  CONTINUE
      WRITE(6,7002)
      WRITE(11,7002)
7002  FORMAT(1X,'NAME FOR *.INT FILE FOR INDEX NUMBERS')
      READ(5,7003) INDFIL
7003  FORMAT(A)
      WRITE(11,7004) INDFIL
7004  FORMAT(1X,'INPUT = ',A13)
      OPEN(UNIT=19,FILE=INDFIL//'.INT',STATUS='OLD')
      CALL SKIPHEAD(19)
      READ(19,*)
      GO TO 7013
7011  CONTINUE
      WRITE(6,7022)
      WRITE(11,7022)
7022  FORMAT(1X,'NAME FOR *.MIT FILE FOR INDEX NUMBERS')
      READ(5,7023) INDFIL
7023  FORMAT(A)
      WRITE(11,7024) INDFIL
7024  FORMAT(1X,'INPUT = ',A13)
      OPEN(UNIT=19,FILE=INDFIL//'.MIT',STATUS='OLD')
      CALL SKIPHEAD(19)
      READ(19,*)
7013  CONTINUE
 
      IERR = 0
7008  CONTINUE
      IF(ILIST.EQ.8.OR.ILIST.EQ.10)
     1 READ(19,*,ERR=7007) (IFF(I),I=1,4),IJFF,ITFF
      IF(ILIST.EQ.9)
     1 READ(19,*,ERR=7007) IDUM,(IFF(I),I=1,4),IJFF,ITFF
      IF(IFF(1).EQ.0) BACKSPACE(UNIT=19)
      IF(IFF(1).EQ.0) GO TO 7008
      IF(ILIST.EQ.9) IJFF = IJFF/2
      IF(ILIST.EQ.9) ITFF = ITFF/2
      IF(ILIST.EQ.8.OR.ILIST.EQ.9) GO TO 6010
      IF(ILIST.EQ.10) GO TO 6012
      GO TO 6011
7007  CONTINUE
      IERR = IERR+1
      IF(IERR.EQ.2) GO TO 7001
      GO TO 7008
 
6010  CONTINUE
      DO 7006 I = 1,4
      DO 7006 J = 1,200
      IF(IFF(I).EQ.IKOUT(J,I)) IFFF(I) = J
7006  CONTINUE
      GO TO 6011
 
6012  CONTINUE
      DO 6013 I = 1,4
      IFFF(I) = IFF(I)
      IKOUT(IFF(I),I) = IFF(I)
      IKCOF(IFF(I),I) = IFF(I)
6013  CONTINUE
      GO TO 6011
 
6011  CONTINUE
      CALL ME(IFFF(1),IFFF(2),IFFF(3),IFFF(4),
     1IJFF+1,IJFF+1,ITFF+1,ITFF+1)
      GO TO 7008
 
7001  CONTINUE
      WRITE(6,300) JME
      WRITE(11,300) JME
300   FORMAT(/,1X,'NUMBER OF 2-BODY MATRIX ELEMENTS =',I5)
      IF(IRADINT.EQ.2) CALL LISTTALMI
 
      IF(ITALMI.EQ.0) GO TO 610
CWAR *********** WRITE INDICES OF NONZERO SUMT ELEMENTS
      WRITE(11,123)
123   FORMAT(/,' LIST OF LARGEST NONZERO TALMI COEFFICIENTS',/)
      DO 600 IL=0,2
      DO 600 IS=0,1
      DO 600 IT=0,1
      DO 600 IP=0,14
      IF(SUMT_SAVE(IT+1,IS+1,IP+1,IL+1).NE.0.)
     1 WRITE(11,1234) IT,IS,IP,IL,SUMT_SAVE(IT+1,IS+1,IP+1,IL+1)
1234  FORMAT(1X,'IT,IS,IP,IL',4I3,2X,E14.6)
600   CONTINUE
610   CONTINUE
 
820   CONTINUE
      STOP
      END
 
      SUBROUTINE ME(I1,I2,I3,I4,KJ12,KJ34,KT12,KT34)
      CHARACTER*9 PRFIL
      CHARACTER*3 KEY,KEY2
      COMMON/CIDEC/IDEC
      REAL*8 VM
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
      COMMON/CNAME/PRFIL
      COMMON/CIKOUT/IKOUT(200,4),IKCOF(200,4)
      COMMON/MEI/IDJ,IDT,IDP
      COMMON/CCOF/ICOF,NPARAM,VOUT(100)
      COMMON/CJME/JME
      COMMON/CKEY/KEY,HBW
      COMMON/CKEY2/KEY2
      COMMON/CZNEW/ZNEW
      COMMON/CSPACE/NFORM(100)
      COMMON/CVCENN/VCENN(4)
 
      COMMON/CTALMI/TALMI_SAVE(3,7,100)
      COMMON/VTOL/VMTOTL(2,2,14,15,4)
      DIMENSION IO(4)
      INCLUDE 'VNCOM.INC'
      COMMON/VSAVE/SUMT_SAVE(2,2,15,3)
      COMMON/VTL/SUMT(100)
      SUMTI=0.
      DO 18 IIND=1,100
      SUMT(IIND)=0.
18    CONTINUE
 
      IF(ICOF.EQ.1.OR.ICOF.EQ.2.OR.ICOF.EQ.4.OR.ICOF.EQ.5) GO TO 8810
      IF(I8812.EQ.999) GO TO 8810
      DO 8811 JOUT = 1,2
      IF(JOUT.EQ.1) IUN=6
      IF(JOUT.EQ.2) IUN=11
      WRITE(IUN,8812)
8812  FORMAT(1X,21X,'     Total     Central
     1        LS    Tensor       ALS')
8811  CONTINUE
      I8812 = 999
8810  CONTINUE
      IJ12 = KJ12-1
      IJ34 = KJ34-1
      IT12 = KT12-1
      IT34 = KT34-1
      XJ12 = IJ12
      XJ34 = IJ34
      XT12 = IT12
      XT34 = IT34
      IF(TR(XJ12,XJ34,XDJ).NE.1.) RETURN
      IF(TR(XT12,XT34,XDT).NE.1.) RETURN
 
      IF(I1.EQ.I2.AND.PAR(XJ12+XT12).EQ.1.) RETURN
      IF(I3.EQ.I4.AND.PAR(XJ34+XT34).EQ.1.) RETURN
 
      Z = TBME(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IDJ,IDT,IDP)
      II1 = IKCOF(I1,1)
      II2 = IKCOF(I2,2)
      II3 = IKCOF(I3,3)
      II4 = IKCOF(I4,4)
      IF(IHEAD.EQ.0)WRITE(6,246)
      IF(IHEAD.EQ.0)WRITE(11,246)
246   FORMAT(/,1X,' I1 I2 I3 I4   J   T      TBME   COEFFICIENTS',/)
 
      IF((ICOF.EQ.1.OR.ICOF.EQ.2.OR.ICOF.EQ.4.OR.ICOF.EQ.5)
     1.AND.KEY.NE.'PRN') CALL SETVOUT
 
      IF(ITALMI.NE.1) GO TO 606
      I=0
      J=0
      DO 600 IL=0,2
      DO 600 IS=0,1
      DO 600 IT=0,1
      DO 600 IP=0,ITMAX
      IF(ITMAX.EQ.0) TYPE 700
700   FORMAT(1X,'ERROR IN SUBROUTINE ME')
      IF(ITMAX.EQ.0) STOP
      J=J+1
      DO 601 IR=1,7
      IF(TALMI_SAVE(IL+1,IR,IP+1).GT.0.) THEN
      I=I+1
      SUMT(J) = SUMT(J) +
     1 VMTOTL(IT+1,IS+1,IR,IP+1,IL+1)
      END IF
601   CONTINUE
CWAR *********** SAVE NONZERO SUMT ELEMENTS
      VSAV=SUMT_SAVE(IT+1,IS+1,IP+1,IL+1)
      IF(ABS(SUMT(J)).GT.ABS(VSAV))
     1 SUMT_SAVE(IT+1,IS+1,IP+1,IL+1) = SUMT(J)
600   CONTINUE
      NPARAM=J
      DO 603 K=1,NPARAM
      SUMTI = SUMTI + SUMT(K)
603   CONTINUE
606   CONTINUE
 
      IF(NPARAM.NE.0.AND.IFIRST.NE.999)
     1OPEN(UNIT=30,FILE=PRFIL//'.COF',STATUS='NEW',FORM='UNFORMATTED')
      IF(NPARAM.NE.0.AND.IFIRST.NE.999)WRITE(30) NPARAM
      IF(NPARAM.NE.0.AND.IFIRST.NE.999) IFIRST = 999
 
      IF(IHEAD.EQ.0) IHEAD = 1
 
      ZOUT = 0.
      IF(ICOF.EQ.0.OR.ICOF.EQ.3) ZOUT = Z
      IF(ICOF.EQ.1.OR.ICOF.EQ.2.OR.ICOF.EQ.4.OR.ICOF.EQ.5) ZOUT = ZNEW
      IF(KEY2.EQ.'NZ'.AND.ZOUT.EQ.0.) GO TO 5501
 
      DO 5500 JOUT = 1,2
      IF(JOUT.EQ.1) IUN=6
      IF(JOUT.EQ.2) IUN=11
      IF(ICOF.EQ.0.OR.ICOF.EQ.3)
     1WRITE(IUN,211) II1,II2,II3,II4,IJ12,IT12,ZOUT
     1,(VCENN(LLL),LLL=1,4)
211   FORMAT(1X,4I3,2I4,1X,F10.4,2X,4F10.4)
 
      IF(IBFIRST.NE.999.AND.IDEC.EQ.1) WRITE(IUN,5003)
5003  FORMAT(22X,'Decomposition of matrix element',
     1/,22X,'C=channel index 1=central, 2=LS, 3=tensor, 4=ALS',
     1/,22X,'P=part index (to be matched with strength)',
     1/,22X,'      S*A   C  T  S  P   strength(S) amount(A)')
      IBFIRST = 999
      IF(IDEC.EQ.0) GO TO 5007
      DO 5000 IB4 = 1,4
      DO 5000 IB1 = 1,2
      DO 5000 IB2 = 1,2
      DO 5000 IB3 = 1,30
      XB1 = VS(IB1,IB2,IB3,IB4)
      XB2 = VM(IB1,IB2,IB3,IB4)
      XB3 = VS(IB1,IB2,IB3,IB4)*VM(IB1,IB2,IB3,IB4)
      IF(XB3.NE.0.AND.(ICOF.EQ.0.OR.ICOF.EQ.3)) WRITE(IUN,5001)
     1 XB3,IB4,IB1-1,IB2-1,IB3,XB1,XB2
5001  FORMAT(22X,F10.3,4I3,1X,2E12.4)
5000  CONTINUE
5007  CONTINUE
 
      IF(ICOF.EQ.1.OR.ICOF.EQ.2.OR.ICOF.EQ.4.OR.ICOF.EQ.5)
     1WRITE(IUN,210) II1,II2,II3,II4,IJ12,IT12,ZOUT
210   FORMAT(1X,4I3,2I4,1X,2F10.4)
 
      IF(NPARAM.EQ.0) GO TO 5500
 
      IF(ITALMI.EQ.1) THEN
 
CWAR ********** CHECK ON TALMI INTEGRAL VALUE OF TWO-BODY G-MATRIX ELEMENT
      WRITE(IUN,2202) SUMTI
2202  FORMAT(1X,'VTALMI=',F10.3)
      IF(JOUT.EQ.1) WRITE(30) (SUMT(IOUT),IOUT=1,NPARAM)
      WRITE(IUN,2222) (SUMT(IOUT),IOUT=1,NPARAM)
2222  FORMAT(5(3X,F10.3))
 
      ELSE
 
      IF(JOUT.EQ.1) WRITE(30) (VOUT(IOUT),IOUT=1,NPARAM)
      WRITE(IUN,2211) (VOUT(IOUT),IOUT=1,NPARAM)
2211  FORMAT(1X,
     1<NFORM(1)>F10.3,/,1X,<NFORM(2)>F10.3,/,1X,<NFORM(3)>F10.3,/,1X,
     1<NFORM(4)>F10.3,/,1X,<NFORM(5)>F10.3,/,1X,<NFORM(6)>F10.3,/,1X,
     1<NFORM(7)>F10.3,/,1X,<NFORM(8)>F10.3,/,1X,<NFORM(9)>F10.3,/,1X,
     1<NFORM(10)>F10.3,/,1X,<NFORM(11)>F10.3,/,1X,<NFORM(12)>F10.3,/,1X,
     1<NFORM(13)>F10.3,/,1X,<NFORM(14)>F10.3,/,1X,<NFORM(15)>F10.3,/,1X,
     1<NFORM(16)>F10.3,/,1X,<NFORM(17)>F10.3,/,1X,<NFORM(18)>F10.3,/,1X,
     1<NFORM(19)>F10.3,/,1X,<NFORM(20)>F10.3)
      END IF
 
5500  CONTINUE
5501  CONTINUE
      IO(1) = IKOUT(I1,1)
      IO(2) = IKOUT(I2,2)
      IO(3) = IKOUT(I3,3)
      IO(4) = IKOUT(I4,4)
      IF(KEY2.EQ.'NZ'.AND.ZOUT.EQ.0.) GO TO 5502
      IF(KEY.NE.'HCM'.AND.KEY.NE.'HCO') 
     1 WRITE(9,212)  (IO(IK),IK=1,4),IJ12,IT12,ZOUT
      IF(KEY.EQ.'HCM'.AND.ZOUT.NE.0.)
     1 WRITE(9,214)  (IO(IK),IK=1,4),IJ12,IT12,ZOUT
      IF(KEY.EQ.'HCO'.AND.ZOUT.NE.0.)
     1 WRITE(9,214)  (IO(IK),IK=1,4),IJ12,IT12,ZOUT
  212 FORMAT(1X,4I3,1X,2I3,1X,F13.5)
  214 FORMAT(1X,4I3,1X,2I3,1X,F13.8)
      WRITE(29,213)  (IO(IK),IK=1,4),2*IJ12,2*IT12,ZOUT
  213 FORMAT(' 28',7X,6I5,5X,F10.4)
 5502 CONTINUE
      JME=JME+1
      RETURN
      END
 
 
      FUNCTION TBME(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IDJ,IDT,IDP)
      CHARACTER*9 PRFIL
      COMMON/CNAME/PRFIL
      CHARACTER*3 KEY
      COMMON/INDEX/XL(3,200)
      COMMON/CKEY/KEY,HBW
      COMMON/CSPACE/NFORM(100)
      COMMON/CCOF/ICOF,NPARAM,VOUT(100)
      COMMON/CVDEL/VN,AL,HBWV          ! USED IN LIBRB FUNCTION VDEL
      COMMON/CDELTA/VNDEL,ALDEL,A0,A1,B0,B1,Q0,Q1
C      COMMON/CVHBW/HBWV           ! USED IN LIBRB FUNCTION VDEL
      COMMON/CVSN/VSN(100),NVSN
 
      INCLUDE 'VNCOM.INC'
      IF(KEY.EQ.'PRN') GO TO 2000
      IF(KEY.EQ.'VQQ') GO TO 100
      IF(KEY.EQ.'DEL') GO TO 200
      IF(KEY.EQ.'DET') GO TO 200
      IF(KEY.EQ.'SDI') GO TO 300
      IF(KEY.EQ.'KIN') GO TO 400
      IF(KEY.EQ.'KIO') GO TO 400
      IF(KEY.EQ.'PNC') GO TO 500
      IF(KEY.EQ.'HCO') GO TO 600
      TBME=VCEN(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IDJ,IDT)
      RETURN
  400 CONTINUE
      TBME=VSPE(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IDJ,IDT)
      RETURN
  500 CONTINUE
      TBME=VPNC(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IDJ,IDT)
      RETURN
  600 CONTINUE
      TBME=VHCM(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IDJ,IDT)
      RETURN
  100 CONTINUE
      TBME=VLL(I1,I2,I3,I4,IJ12,IT12,2)
      IF(ICOF.EQ.3) NPARAM = 2
      NFORM(1) = NPARAM
      VOUT(1) = 0.
      VOUT(2) = 0.
      IF(IT12.EQ.0) VOUT(1) = TBME
      IF(IT12.EQ.1) VOUT(2) = TBME
      RETURN
  200 CONTINUE
      HBWV = HBW
      VN = VNDEL
      AL = ALDEL
      TBME=VDEL(I1,I2,I3,I4,IJ12,IT12)
      IF(ICOF.EQ.3) NPARAM = 2
      NFORM(1) = NPARAM
      VOUT(1) = 0.
      VOUT(2) = 0.
      IF(IT12.EQ.0) VOUT(1) = TBME
      IF(IT12.EQ.1) VOUT(2) = TBME
      RETURN
  300 CONTINUE
      PI = 3.14159
      HBWV = 0.
      VN = 1.
      AL = 0.
      X=VDEL(I1,I2,I3,I4,IJ12,IT12)
      X2=VLL(I1,I2,I3,I4,IJ12,IT12,2)
      X3=VLL(I1,I2,I3,I4,IJ12,IT12,4)
      IF(IT12.EQ.0) A2 = -4.*PI*A0
      IF(IT12.EQ.1) A2 = -4.*PI*A1
      IF(IT12.EQ.0) Q2 = Q0
      IF(IT12.EQ.1) Q2 = Q1
      B2 = 0.
      IF(I1.EQ.I3.AND.I2.EQ.I4.AND.IT12.EQ.0) B2 = B0
      IF(I1.EQ.I4.AND.I2.EQ.I3.AND.IT12.EQ.0)
     1 B2 = B0*PAR(XL(3,I4)+XL(3,I3)-IJ12+1.-IT12+1.)
      IF(I1.EQ.I3.AND.I2.EQ.I4.AND.IT12.EQ.1) B2 = B1
      IF(I1.EQ.I4.AND.I2.EQ.I3.AND.IT12.EQ.1)
     1 B2 = B1*PAR(XL(3,I4)+XL(3,I3)-IJ12+1.-IT12+1.)
      TBME = A2*X+B2+Q2*X2
      IF(ICOF.EQ.3) NPARAM = 8
      NFORM(1) = NPARAM
      VOUT(1) = 0.
      VOUT(2) = 0.
      VOUT(3) = 0.
      VOUT(4) = 0.
      IF(IT12.EQ.0) VOUT(1) = -4.*PI*X
      IF(IT12.EQ.1) VOUT(2) = -4.*PI*X
      IF(I1.EQ.I3.AND.I2.EQ.I4.AND.IT12.EQ.0) VOUT(3) = 1.
      IF(I1.EQ.I3.AND.I2.EQ.I4.AND.IT12.EQ.1) VOUT(4) = 1.
      IF(IT12.EQ.0) VOUT(5) = X2
      IF(IT12.EQ.1) VOUT(6) = X2
      IF(IT12.EQ.0) VOUT(7) = X3
      IF(IT12.EQ.1) VOUT(8) = X3
      RETURN
 
 2000 CONTINUE
      TBME = 0.
      IF(IFIRST.NE.999) CALL GETVSN
      IF(IFIRST.NE.999) IFIRST = 999
      READ(15) (VOUT(I),I=1,NVSN)
      DO 2001 I = 1,NVSN
      TBME = TBME + VSN(I)*VOUT(I)
 2001 CONTINUE
      RETURN
 
      END
 
      SUBROUTINE GETVSN
      CHARACTER*9 FILE
      COMMON/CVSN/VSN(100),NVSN
      WRITE(6,100)
  100 FORMAT(1X,'*.PRN FILE NAME')
      READ(5,101) FILE
  101 FORMAT(A)
      OPEN(UNIT=15,FILE=FILE//'.PRN',STATUS='OLD')
      DO 200 I = 1,300
      READ(15,*,ERR=201) VSN(I)
200   CONTINUE
201   NVSN = I-1
      CLOSE(UNIT=15)
      WRITE(6,300)
300   FORMAT(1X,'*.COF FILE NAME')
      READ(5,101) FILE
      OPEN(UNIT=15,FILE=FILE//'.COF',STATUS='OLD',FORM='UNFORMATTED')
      READ(15) NPARAM
      IF(NVSN.NE.NPARAM) WRITE(6,301) NVSN,NPARAM
301   FORMAT(1X,'WARNING NVSN.NE.NPARAM: NVSN,NPARAM = ',2I4)
      RETURN
      END
 
 
      SUBROUTINE READPRM
 
CBAB  OPTIONS FOR "SPINT" INPUT
CBAB  SPINT = C FOR CENTRAL
CBAB  SPINT = L FOR LS
CBAB  SPINT = T FOR TENSOR
CBAB  SPINT = A FOR ALS
CBAB  SPINT = S FOR SPE
 
CBAB  OPTIONS FOR "SPD" INPUT
CBAB  SPD = I  FOR DENSITY-INDEPENDENT G MATRIX
CBAB  SPD = D  FOR DENSITY-DEPENDENT G MATRIX LINEAR IN FWS(R)
CBAB  SPD = E  FOR DENSITY-DEPENDENT G MATRIX I-D
CBAB  SPD = C  FOR COULOMB
CBAB  SPD = M  FOR MONOPOLE FOR CENTRAL AND Q+Q FOR TENSOR
CBAB  SPD = Q  FOR MULTIPOLE
 
CBAB  OPTIONS FOR "IT" AND "IS" INPUT
CBAB  IT = 0,1 FOR SEPERATE T COMPONENTS
CBAB  IS = 0,1 FOR SEPERATE S COMPONENTS
CBAB  IT = 2 TO COMBINE T=0 AND T=1
CBAB  IS = 2 TO COMBIME S=0 AND S=1
 
      CHARACTER*9 PRFIL
      COMMON/CNAME/PRFIL
      CHARACTER*1 SPINT,SPACE,SPD
      COMMON/CIDD/IDD,ALD,BLD,R0D,DIFFD
      COMMON/CCOF/ICOF,NPARAM,VOUT(100)
      COMMON/CSPACE/NFORM(100)
      COMMON/CSETPARV/ICAV,ILAV,ITAV,ISETL(10),ISETLNUM,ISETTMIN,ISETTMAX
      COMMON/CSETVOUT/STRENG(200),ITY(200),IT(200),IS(200),IR(200,5)
     1,JPRV,SPD(200)
      OPEN(UNIT=14,FILE=PRFIL//'.PRV',STATUS='OLD')
      J=0
      IDD = 0
      ISETTMIN = 999
      ISETTMAX = 0
      DO 500 I = 1,100
  500 NFORM(I) = 1
      ICAV = 0
      ILAV = 0
      ITAV = 0
      ISPACE = 1
      WRITE(6,200)
      WRITE(11,200)
  200 FORMAT(1X,'INPUT FROM *.PRV FILE',/)
   10 J=J+1
      READ(14,20,ERR=99)
     1STRENG(J),SPACE,SPINT,IT(J),IS(J),SPD(J),(IR(J,I),I=1,5)
   20 FORMAT(1X,F9.4,1X,A1,A1,3X,I1,3X,I1,2X,A1,I2,1X,5(I1,1X))
      IF(SPINT.EQ.'S') GO TO 99
      WRITE(6,20)
     1STRENG(J),SPACE,SPINT,IT(J),IS(J),SPD(J),(IR(J,I),I=1,5)
      WRITE(11,20)
     1STRENG(J),SPACE,SPINT,IT(J),IS(J),SPD(J),(IR(J,I),I=1,5)
 
      IF(SPD(J).NE.'Q') GO TO 4000
      IF(ISETLNUM.EQ.0) GO TO 4010
      DO 4001 III = 1,ISETLNUM
      IF(ISETL(III).EQ.IR(J,1)) GO TO 4000
4001  CONTINUE
      ISETLNUM = ISETLNUM+1
      ISETL(ISETLNUM) = IR(J,1)
      GO TO 4000
4010  CONTINUE
      ISETL(1) = IR(J,1)
      ISETLNUM = 1
4000  CONTINUE
 
      IF(IT(J).LT.ISETTMIN) ISETTMIN = IT(J)
      IF(IT(J).GT.ISETTMAX) ISETTMAX = IT(J)
      IF(SPD(J).EQ.'D') IDD = 1
      IF(SPD(J).EQ.'E') IDD = 2
 
      IF(J.GT.1.AND.(SPACE.EQ.'S'.OR.NFORM(ISPACE).GE.8))
     1ISPACE = ISPACE + 1
      IF(SPACE.EQ.'S'.OR.NFORM(ISPACE).GE.8)
     1NFORM(ISPACE) = 0
      IF(ISPACE.GT.20) TYPE 501
501   FORMAT(1X,'ERROR: TOO MANY SPACES - INCREASE FORMAT STATEMENT
     1 CONTAINING "NFORM"')
      IF(ISPACE.GT.20) STOP
      NFORM(ISPACE) = NFORM(ISPACE) + 1
 
      ITY(J) = 0
      IF(SPINT.EQ.'C') ITY(J)=1
      IF(SPINT.EQ.'L') ITY(J)=2
      IF(SPINT.EQ.'T') ITY(J)=3
      IF(SPINT.EQ.'A') ITY(J)=4
      IF(ITY(J).EQ.0) TYPE 800
      IF(ITY(J).EQ.0) STOP
800   FORMAT(1X,'ILLEGAL VALUE IN PRV INPUT: MUST BE C,L,T,A OR S')
 
      IF(ITY(J).EQ.1) ICAV = ICAV + 1
      IF(ITY(J).EQ.2.OR.ITY(J).EQ.4) ILAV = ILAV + 1
      IF(ITY(J).EQ.3) ITAV = ITAV + 1
 
      GO TO 10
99    CONTINUE
      NPARAM = ICAV+ILAV+ITAV
      WRITE(11,801)
     1 ISETTMIN,ISETTMAX,NPARAM,IDD,(ISETL(III),III=1,ISETLNUM)
      TYPE 801,ISETTMIN,ISETTMAX,NPARAM,IDD,(ISETL(III),III=1,ISETLNUM)
801   FORMAT(1X,'TMIN,TMAX,NPARAM,IDD,L1,L2,L3,ETC = ',20I4)
      JPRV = J-1
      CLOSE(UNIT=14)
      RETURN
      END
 
      SUBROUTINE READPRMI
 
CBAB  OPTIONS FOR "SPINT" INPUT
CBAB  SPINT = C FOR CENTRAL
CBAB  SPINT = L FOR LS
CBAB  SPINT = T FOR TENSOR
CBAB  SPINT = A FOR ALS
CBAB  SPINT = S FOR SPE
 
CBAB  OPTIONS FOR "SPD" INPUT
CBAB  SPD = I  FOR DENSITY-INDEPENDENT G MATRIX
CBAB  SPD = D  FOR DENSITY-DEPENDENT G MATRIX LINEAR IN FWS(R)
CBAB  SPD = E  FOR DENSITY-DEPENDENT G MATRIX I-D
CBAB  SPD = C  FOR COULOMB
CBAB  SPD = M  FOR MONOPOLE FOR CENTRAL AND Q+Q FOR TENSOR
CBAB  SPD = Q  FOR MULTIPOLE
 
CBAB  OPTIONS FOR "IT" AND "IS" INPUT
CBAB  IT = 0,1 FOR SEPERATE T COMPONENTS
CBAB  IS = 0,1 FOR SEPERATE S COMPONENTS
CBAB  IT = 2 TO COMBINE T=0 AND T=1
CBAB  IS = 2 TO COMBIME S=0 AND S=1
 
      CHARACTER*9 PRFIL
      CHARACTER*10 BBB
      COMMON/CBBB/BBB(100)
      COMMON/CNAME/PRFIL
      CHARACTER*1 SPINT,SPACE,SPD
      COMMON/CIDD/IDD,ALD,BLD,R0D,DIFFD
      COMMON/CCOF/ICOF,NPARAM,VOUT(100)
      COMMON/CSPACE/NFORM(100)
      COMMON/CSETPARV/ICAV,ILAV,ITAV,ISETL(10),ISETLNUM,ISETTMIN,ISETTMAX
      COMMON/CSETVOUT/STRENG(200),ITY(200),IT(200),IS(200),IR(200,5)
     1,JPRV,SPD(200)
      J=0
      IDD = 0
      ISETTMIN = 999
      ISETTMAX = 0
      DO 500 I = 1,100
500   NFORM(I) = 1
      ICAV = 0
      ILAV = 0
      ITAV = 0
      ISPACE = 1
      WRITE(6,200)
      WRITE(11,200)
      IF(ICOF.EQ.4) CALL GETPRV
      IF(ICOF.EQ.5) CALL GETPRVB
200   FORMAT(1X,'INPUT FROM SUBROUTINE READPRMI',/)
10    J=J+1
      STRENG(J) = ISINT(BBB(J)(1:1))
      SPACE = BBB(J)(2:2)
      SPINT = BBB(J)(3:3)
      IT(J) = ISINT(BBB(J)(4:4))
      IS(J) = ISINT(BBB(J)(5:5))
      SPD(J) = BBB(J)(6:6)
      IR(J,1) = ISINT(BBB(J)(7:7))
      IR(J,2) = ISINT(BBB(J)(8:8))
      IR(J,3) = ISINT(BBB(J)(9:9))
      IR(J,4) = ISINT(BBB(J)(10:10))
20    FORMAT(1X,F9.4,1X,A1,A1,3X,I1,3X,I1,2X,A1,I2,1X,5(I1,1X))
      IF(SPINT.EQ.'S') GO TO 99
      WRITE(6,20)
     1STRENG(J),SPACE,SPINT,IT(J),IS(J),SPD(J),(IR(J,I),I=1,5)
      WRITE(11,20)
     1STRENG(J),SPACE,SPINT,IT(J),IS(J),SPD(J),(IR(J,I),I=1,5)
 
      IF(SPD(J).NE.'Q') GO TO 4000
      IF(ISETLNUM.EQ.0) GO TO 4010
      DO 4001 III = 1,ISETLNUM
      IF(ISETL(III).EQ.IR(J,1)) GO TO 4000
4001  CONTINUE
      ISETLNUM = ISETLNUM+1
      ISETL(ISETLNUM) = IR(J,1)
      GO TO 4000
4010  CONTINUE
      ISETL(1) = IR(J,1)
      ISETLNUM = 1
4000  CONTINUE
 
      IF(IT(J).LT.ISETTMIN) ISETTMIN = IT(J)
      IF(IT(J).GT.ISETTMAX) ISETTMAX = IT(J)
      IF(SPD(J).EQ.'D') IDD = 1
      IF(SPD(J).EQ.'E') IDD = 2
 
      IF(J.GT.1.AND.(SPACE.EQ.'S'.OR.NFORM(ISPACE).GE.8))
     1ISPACE = ISPACE + 1
      IF(SPACE.EQ.'S'.OR.NFORM(ISPACE).GE.8)
     1NFORM(ISPACE) = 0
      IF(ISPACE.GT.20) TYPE 501
501   FORMAT(1X,'ERROR: TOO MANY SPACES - INCREASE FORMAT STATEMENT
     1 CONTAINING "NFORM"')
      IF(ISPACE.GT.20) STOP
      NFORM(ISPACE) = NFORM(ISPACE) + 1
 
      ITY(J) = 0
      IF(SPINT.EQ.'C') ITY(J)=1
      IF(SPINT.EQ.'L') ITY(J)=2
      IF(SPINT.EQ.'T') ITY(J)=3
      IF(SPINT.EQ.'A') ITY(J)=4
      IF(ITY(J).EQ.0) TYPE 800
      IF(ITY(J).EQ.0) STOP
800   FORMAT(1X,'ILLEGAL VALUE IN PRV INPUT: MUST BE C,L,T,A OR S')
 
      IF(ITY(J).EQ.1) ICAV = ICAV + 1
      IF(ITY(J).EQ.2.OR.ITY(J).EQ.4) ILAV = ILAV + 1
      IF(ITY(J).EQ.3) ITAV = ITAV + 1
 
      GO TO 10
99    CONTINUE
      NPARAM = ICAV+ILAV+ITAV
      WRITE(11,801)
     1 ISETTMIN,ISETTMAX,NPARAM,IDD,(ISETL(III),III=1,ISETLNUM)
      TYPE 801,ISETTMIN,ISETTMAX,NPARAM,IDD,(ISETL(III),III=1,ISETLNUM)
801   FORMAT(1X,'TMIN,TMAX,NPARAM,IDD,L1,L2,L3,ETC = ',20I4)
      JPRV = J-1
      CLOSE(UNIT=14)
      RETURN
      END
 
      SUBROUTINE SETVOUT
 
CWAR  NEW SUBROUTINE BY W.A.RICHTER,DEC 14,1985 TO ALLOW CHOOSING
CWAR  COMBINATIONS OF PARAMETERS BY READING FROM THE [INTERACTION].PRV
CWAR  FILE WHICH CONTAINS INITIAL PARAMETER VALUES. THE DIGITS USED
CWAR  TO INDICATE THE VARIOUS RANGES MUST BE CONSISTENT WITH THOSE
CWAR  IN THE SUBROUTINE GETVS (WHICH CONTAINS THE PARAMETER STRENGTHS)
CWAR  IN VG.FOR . IF THE FORMAT OF THE .PRV FILE IS CHANGED THE READ
CWAR  STATEMENT IN GETVS MUST BE MODIFIED. ALSO THE READ STATEMENT AND
CWAR  OUTPUT WRITE STATEMENT (TO THE [INTERACTION].LIS FILE) IN THE
CWAR  FITTING PROGRAM LEASTB (MAIN PROGRAM LSFME.FOR) MUST BE CHANGED
CWAR  ACCORDINGLY.
CWAR
      CHARACTER*1 SPD
      REAL*8 VM
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
      COMMON/CSETVOUT/STRENG(200),ITY(200),IT(200),IS(200),IR(200,5)
     1,JPRV,SPD(200)
      COMMON/CCOF/ICOF,NPARAM,VOUT(100)
      COMMON/CZNEW/ZNEW
      COMMON/CIDD/IDD,ALD,BLD,R0D,DIFFD
      COMMON/VTOL/VMTOTL(2,2,14,15,4)
      INCLUDE 'VNCOM.INC'
      DIMENSION VMT(3,3,30,4)
      ZNEW = 0.
 
      DO 800 I4 = 1,4
      DO 800 I3 = 1,30
      DO 801 I1 = 1,2
      DO 801 I2 = 1,2
CWAR
CBAB ADDED HEIARCHY OF CHOICES
CBAB 1) IF NO STRENGTH IS SPECIFIED IN GETVS
CBAB 2) IF A STRENGTH IS SPECIFIED IN GETVS
      IF(I3.LE.7)
     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)
      IF(I3.LE.7.AND.VS(I1,I2,I3,I4).NE.0.)
     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)*VS(I1,I2,I3,I4)
CBAB ADDED HEIARCHY OF CHOICES
CBAB 1) IF NO STRENGTH IS SPECIFIED IN GETVS
CBAB 2) IF A STRENGTH IS SPECIFIED IN GETVS
      IF(I3.GE.8.AND.I3.LE.20)
     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)
      IF(I3.GE.8.AND.I3.LE.20.AND.VS(I1,I2,I3,I4).NE.0.)
     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)
CBAB ADDED HEIARCHY OF CHOICES
CBAB 1) IF NO STRENGTH IS SPECIFIED IN GETVS
CBAB 2) IF A STRENGTH IS SPECIFIED IN THE DENSITY INDEPENDENT PART
CBAB 3) IF A STRENGTH IS SPECIFIED IN THE DENSITY DEPENDENT PART
      IF(I3.GE.21.AND.I3.LE.27)
     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)
      IF(I3.GE.21.AND.I3.LE.27.AND.VS(I1,I2,I3-20,I4).NE.0.)
     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)*VS(I1,I2,I3-20,I4)
      IF(I3.GE.21.AND.I3.LE.27.AND.VS(I1,I2,I3,I4).NE.0.)
     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)*VS(I1,I2,I3,I4)
 
CBAB      IF(I3.LT.7)
CBAB     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)*VS(I1,I2,I3,I4)
CBAB      IF(I3.GE.8.AND.I3.LE.20)
CBAB     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)
CBAB      IF(I3.GE.21.AND.I3.LE.27)
CBAB     1VMT(I1,I2,I3,I4) = VM(I1,I2,I3,I4)*VS(I1,I2,I3-20,I4)
 
      IF(ITALMI.EQ.0) GO TO 5002
      IF(I3.GT.7) GO TO 5002
      DO 802 JP = 1,ITMAX+1
      VMTOTL(I1,I2,I3,JP,I4)=VMTAL(I1,I2,I3,JP,I4)*VS(I1,I2,I3,I4)
CWAR *********** DENSITY-DEPENDENT TALMI INTEGRAL CASE
      IF(IDD.EQ.1.OR.IDD.EQ.2)
     1VMTOTL(I1,I2,I3+7,JP,I4)=VMTAL(I1,I2,I3+7,JP,I4)*VS(I1,I2,I3,I4)
      IF(IDD.EQ.1) VMTOTL(I1,I2,I3,JP,I4) =
     1 VMTOTL(I1,I2,I3+7,JP,I4)
      IF(IDD.EQ.2) VMTOTL(I1,I2,I3,JP,I4) =
     1 VMTOTL(I1,I2,I3,JP,I4) - VMTOTL(I1,I2,I3+7,JP,I4)
802   CONTINUE
5002  CONTINUE
 
801   CONTINUE
 
      VMT(1,3,I3,I4) = VMT(1,1,I3,I4)+VMT(1,2,I3,I4)
      VMT(2,3,I3,I4) = VMT(2,1,I3,I4)+VMT(2,2,I3,I4)
      VMT(3,1,I3,I4) = VMT(1,1,I3,I4)+VMT(2,1,I3,I4)
      VMT(3,2,I3,I4) = VMT(1,2,I3,I4)+VMT(2,2,I3,I4)
      VMT(3,3,I3,I4) = VMT(1,1,I3,I4)+VMT(1,2,I3,I4)+VMT(2,1,I3,I4)
     1+VMT(2,2,I3,I4)
800   CONTINUE
 
      DO 10 J = 1,JPRV
      IF(ITY(J).EQ.5) GO TO 10
      SUM=0.
      MQH=0
      IF(SPD(J).EQ.'I'.OR.SPD(J).EQ.'D'.OR.SPD(J).EQ.'E') GO TO 300
      IF(SPD(J).EQ.'C') VOUT(J) = VMT(IT(J)+1,IS(J)+1,8,ITY(J))
      IF(SPD(J).EQ.'M') VOUT(J) = VMT(IT(J)+1,IS(J)+1,9,ITY(J))
      IF(SPD(J).EQ.'Q') VOUT(J) = VMT(IT(J)+1,IS(J)+1,IR(J,1)+10,ITY(J))
      GO TO 11
300   CONTINUE
CWAR  ********** LOOP OVER RANGES INCLUDED IN .PRV FILE
      DO 90 K=1,7
      DO 70 I=1,5
      IF(IR(J,I).EQ.K) GO TO 80
 70   CONTINUE
      GO TO 90
 80   CONTINUE
      IF(SPD(J).EQ.'I') SUM=SUM + VMT(IT(J)+1,IS(J)+1,K,ITY(J))
      IF(SPD(J).EQ.'D') SUM=SUM + VMT(IT(J)+1,IS(J)+1,K+20,ITY(J))
      IF(SPD(J).EQ.'E') SUM=SUM + VMT(IT(J)+1,IS(J)+1,K,ITY(J))
     1                          - VMT(IT(J)+1,IS(J)+1,K+20,ITY(J))
 90   CONTINUE
      VOUT(J) = SUM
11    CONTINUE
      ZNEW = ZNEW + STRENG(J)*VOUT(J)
10    CONTINUE
 
      RETURN
      END
 
      SUBROUTINE SKIPHEAD(J)
      CHARACTER*1 A
      DIMENSION A(3)
100   READ(J,101) (A(I),I=1,3)
101   FORMAT(3A1)
      DO 200 I = 1,3
200   IF(A(I).EQ.'!') GO TO 100
      BACKSPACE J
      RETURN
      END
 
      SUBROUTINE GETPRV
      CHARACTER*10 BBB
      COMMON/CBBB/BBB(100)
      BBB(1)  = '1SC00I1'
      BBB(2)  = '1 C00I3'
      BBB(3)  = '1 C00I5'
      BBB(4)  = '1 C00I7'
      BBB(5)  = '0 C00D1'
      BBB(6)  = '0 C00D3'
      BBB(7)  = '0 C00D5'
      BBB(8)  = '0 C00D7'
      BBB(9)  = '0SC00M0'
      BBB(10) = '0 C00Q1'
      BBB(11) = '0 C00Q3'
      BBB(12) = '1SC10I1'
      BBB(13) = '1 C10I3'
      BBB(14) = '1 C10I5'
      BBB(15) = '1 C10I7'
      BBB(16) = '0 C10D1'
      BBB(17) = '0 C10D3'
      BBB(18) = '0 C10D5'
      BBB(19) = '0 C10D7'
      BBB(20) = '0SC10M0'
      BBB(21) = '0 C10Q1'
      BBB(22) = '0 C10Q3'
      BBB(23) = '1SC01I1'
      BBB(24) = '1 C01I3'
      BBB(25) = '1 C01I5'
      BBB(26) = '1 C01I7'
      BBB(27) = '0 C01D1'
      BBB(28) = '0 C01D3'
      BBB(29) = '0 C01D5'
      BBB(30) = '0 C01D7'
      BBB(31) = '0SC01M0'
      BBB(32) = '0 C01Q1'
      BBB(33) = '0 C01Q3'
      BBB(34) = '1SC11I1'
      BBB(35) = '1 C11I3'
      BBB(36) = '1 C11I5'
      BBB(37) = '1 C11I7'
      BBB(38) = '0 C11D1'
      BBB(39) = '0 C11D3'
      BBB(40) = '0 C11D5'
      BBB(41) = '0 C11D7'
      BBB(42) = '0SC11M0'
      BBB(43) = '0 C11Q1'
      BBB(44) = '0 C11Q3'
      BBB(45) = '1SL01I2'
      BBB(46) = '1 L01I4'
      BBB(47) = '0 L01D2'
      BBB(48) = '0 L01D4'
      BBB(49) = '1SL11I2'
      BBB(50) = '1 L11I4'
      BBB(51) = '0 L11D2'
      BBB(52) = '0 L11D4'
      BBB(53) = '1ST01I2'
      BBB(54) = '1 T01I7'
      BBB(55) = '0 T01D2'
      BBB(56) = '0 T01D7'
      BBB(57) = '1ST11I2'
      BBB(58) = '1 T11I7'
      BBB(59) = '0 T11D2'
      BBB(60) = '0 T11D7'
      BBB(61) = '0 A01Q2'
      BBB(62) = '0 A11Q2'
      BBB(63) = '0 S0000'
      RETURN
      END
 
      SUBROUTINE GETPRVB
      CHARACTER*10 BBB
      COMMON/CBBB/BBB(100)
      BBB(1)  = '1SC00I1'
      BBB(2)  = '1 C00I2'
      BBB(3)  = '1 C00I3'
      BBB(4)  = '1 C00I4'
      BBB(5)  = '0 C00D1'
      BBB(6)  = '0 C00D2'
      BBB(7)  = '0 C00D3'
      BBB(8)  = '0 C00D4'
      BBB(9)  = '0SC00M0'
      BBB(10) = '0 C00Q1'
      BBB(11) = '0 C00Q3'
      BBB(12) = '1SC10I1'
      BBB(13) = '1 C10I2'
      BBB(14) = '1 C10I3'
      BBB(15) = '1 C10I4'
      BBB(16) = '0 C10D1'
      BBB(17) = '0 C10D2'
      BBB(18) = '0 C10D3'
      BBB(19) = '0 C10D4'
      BBB(20) = '0SC10M0'
      BBB(21) = '0 C10Q1'
      BBB(22) = '0 C10Q3'
      BBB(23) = '1SC01I1'
      BBB(24) = '1 C01I2'
      BBB(25) = '1 C01I3'
      BBB(26) = '1 C01I4'
      BBB(27) = '0 C01D1'
      BBB(28) = '0 C01D2'
      BBB(29) = '0 C01D3'
      BBB(30) = '0 C01D4'
      BBB(31) = '0SC01M0'
      BBB(32) = '0 C01Q1'
      BBB(33) = '0 C01Q3'
      BBB(34) = '1SC11I1'
      BBB(35) = '1 C11I2'
      BBB(36) = '1 C11I3'
      BBB(37) = '1 C11I4'
      BBB(38) = '0 C11D1'
      BBB(39) = '0 C11D2'
      BBB(40) = '0 C11D3'
      BBB(41) = '0 C11D4'
      BBB(42) = '0SC11M0'
      BBB(43) = '0 C11Q1'
      BBB(44) = '0 C11Q3'
 
      BBB(45) = '1SL01I1'
      BBB(46) = '1 L01I23'
      BBB(47) = '0 L01D1'
      BBB(48) = '0 L01D23'
      BBB(49) = '1SL11I1'
      BBB(50) = '1 L11I23'
      BBB(51) = '0 L11D1'
      BBB(52) = '0 L11D23'
 
      BBB(53) = '1ST01I12'
      BBB(54) = '1 T01I4'
      BBB(55) = '0 T01D12'
      BBB(56) = '0 T01D4'
      BBB(57) = '1ST11I12'
      BBB(58) = '1 T11I4'
      BBB(59) = '0 T11D12'
      BBB(60) = '0 T11D4'
 
      BBB(61) = '0 A01Q2'
      BBB(62) = '0 A11Q2'
      BBB(63) = '0 S0000'
      RETURN
      END
 
      FUNCTION ISINT(A)
      CHARACTER*1 A
      IF(A.EQ.'0') ISINT = 0
      IF(A.EQ.'1') ISINT = 1
      IF(A.EQ.'2') ISINT = 2
      IF(A.EQ.'3') ISINT = 3
      IF(A.EQ.'4') ISINT = 4
      IF(A.EQ.'5') ISINT = 5
      IF(A.EQ.'6') ISINT = 6
      IF(A.EQ.'7') ISINT = 7
      IF(A.EQ.'8') ISINT = 8
      IF(A.EQ.'9') ISINT = 9
      RETURN
      END
