      FUNCTION VHCM(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
CBAB Way to put in single-particle operator into two-body
CBAB matrix elements. The matrix elements should be multiplied by
CBAB 1/(NV-1), where NV is the number of valence particles.
CBAB In OXBASH this is done in SHSH:SHSP.FOR
CBAB At present this is only used for the kinetic energy contribution
CBAB calculated with oscillator wave functions
      COMMON/INDEX/XL(3,200)
      VHCM = 0.
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      XJ34 = IJ34
      XT34 = IT34
      XI12 = I1-I2

      XI34 = I3-I4
      IF(I1.NE.I2.AND.I3.NE.I4) GO TO 100
      IF(I1.EQ.I2.AND.I3.EQ.I4) GO TO 300
      GO TO 200

100   CONTINUE
      XN = SQRT((DELTA(XI12)+1.)*(DELTA(XI34)+1.))
      XN1 = 1./XN
      XN2 = PAR(XJ3+XJ4-XJ34-XT34)/XN
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VHCM = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VHCM = VCHM+XN1*SPE(I2)
C      IF(I1.EQ.I4.AND.I2.EQ.I3) VHCM = VHCM+XN2*SPE(I1)
C      IF(I2.EQ.I3.AND.I1.EQ.I4) VHCM = VHCM+XN2*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VHCM = XN1*HCM(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VHCM = VHCM + XN1*HCM(I2,I4)
      IF(XL(3,I1).EQ.XL(3,I4).AND.I2.EQ.I3) 
     1 VHCM = VHCM + XN2*HCM(I1,I4)
      IF(XL(3,I2).EQ.XL(3,I3).AND.I1.EQ.I4) 
     1 VHCM = VHCM + XN2*HCM(I2,I3)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN2,I1,I2,I4,I3,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

200   CONTINUE
      XN1 = SQRT(2.)
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VHCM = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VHCM = VHCM+XN1*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VHCM = XN1*HCM(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VHCM = VHCM + XN1*HCM(I2,I4)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

300   CONTINUE
      XN1 = 1.
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VHCM = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VHCM = VHCM+XN1*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VHCM = XN1*HCM(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VHCM = VHCM + XN1*HCM(I2,I4)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

500   CONTINUE
      RETURN
      END

      FUNCTION VPNC(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
CBAB Way to put in single-particle operator into two-body
CBAB matrix elements. The matrix elements should be multiplied by
CBAB 1/(NV-1), where NV is the number of valence particles.
CBAB In OXBASH this is done in SHSH:SHSP.FOR
CBAB At present this is only used for the kinetic energy contribution
CBAB calculated with oscillator wave functions
      COMMON/INDEX/XL(3,200)
      VPNC = 0.
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      XJ34 = IJ34
      XT34 = IT34
      XI12 = I1-I2

      XI34 = I3-I4
      IF(I1.NE.I2.AND.I3.NE.I4) GO TO 100
      IF(I1.EQ.I2.AND.I3.EQ.I4) GO TO 300
      GO TO 200

100   CONTINUE
      XN = SQRT((DELTA(XI12)+1.)*(DELTA(XI34)+1.))
      XN1 = 1./XN
      XN2 = PAR(XJ3+XJ4-XJ34-XT34)/XN
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VPNC = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VPNC = VPNC+XN1*SPE(I2)
C      IF(I1.EQ.I4.AND.I2.EQ.I3) VPNC = VPNC+XN2*SPE(I1)
C      IF(I2.EQ.I3.AND.I1.EQ.I4) VPNC = VPNC+XN2*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VPNC = XN1*PNC(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VPNC = VPNC + XN1*PNC(I2,I4)
      IF(XL(3,I1).EQ.XL(3,I4).AND.I2.EQ.I3) 
     1 VPNC = VPNC + XN2*PNC(I1,I4)
      IF(XL(3,I2).EQ.XL(3,I3).AND.I1.EQ.I4) 
     1 VPNC = VPNC + XN2*PNC(I2,I3)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN2,I1,I2,I4,I3,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

200   CONTINUE
      XN1 = SQRT(2.)
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VPNC = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VPNC = VPNC+XN1*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VPNC = XN1*PNC(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VPNC = VPNC + XN1*PNC(I2,I4)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

300   CONTINUE
      XN1 = 1.
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VPNC = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VPNC = VPNC+XN1*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VPNC = XN1*PNC(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VPNC = VPNC + XN1*PNC(I2,I4)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

500   CONTINUE
      RETURN
      END

      FUNCTION VSPE(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
CBAB Way to put in single-particle operator into two-body
CBAB matrix elements. The matrix elements should be multiplied by
CBAB 1/(NV-1), where NV is the number of valence particles.
CBAB In OXBASH this is done in SHSH:SHSP.FOR
CBAB At present this is only used for the kinetic energy contribution
CBAB calculated with oscillator wave functions
      COMMON/INDEX/XL(3,200)
      VSPE = 0.
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      XJ34 = IJ34
      XT34 = IT34
      XI12 = I1-I2

      XI34 = I3-I4
      IF(I1.NE.I2.AND.I3.NE.I4) GO TO 100
      IF(I1.EQ.I2.AND.I3.EQ.I4) GO TO 300
      GO TO 200

100   CONTINUE
      XN = SQRT((DELTA(XI12)+1.)*(DELTA(XI34)+1.))
      XN1 = 1./XN
      XN2 = PAR(XJ3+XJ4-XJ34-XT34)/XN
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VSPE = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VSPE = VSPE+XN1*SPE(I2)
C      IF(I1.EQ.I4.AND.I2.EQ.I3) VSPE = VSPE+XN2*SPE(I1)
C      IF(I2.EQ.I3.AND.I1.EQ.I4) VSPE = VSPE+XN2*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VSPE = XN1*XKSS(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VSPE = VSPE + XN1*XKSS(I2,I4)
      IF(XL(3,I1).EQ.XL(3,I4).AND.I2.EQ.I3) 
     1 VSPE = VSPE + XN2*XKSS(I1,I4)
      IF(XL(3,I2).EQ.XL(3,I3).AND.I1.EQ.I4) 
     1 VSPE = VSPE + XN2*XKSS(I2,I3)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN2,I1,I2,I4,I3,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

200   CONTINUE
      XN1 = SQRT(2.)
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VSPE = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VSPE = VSPE+XN1*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VSPE = XN1*XKSS(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VSPE = VSPE + XN1*XKSS(I2,I4)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

300   CONTINUE
      XN1 = 1.
C      IF(I1.EQ.I3.AND.I2.EQ.I4) VSPE = XN1*SPE(I1)
C      IF(I2.EQ.I4.AND.I1.EQ.I3) VSPE = VSPE+XN1*SPE(I2)
      IF(XL(3,I1).EQ.XL(3,I3).AND.I2.EQ.I4) VSPE = XN1*XKSS(I1,I3)
      IF(XL(3,I2).EQ.XL(3,I4).AND.I1.EQ.I3) 
     1 VSPE = VSPE + XN1*XKSS(I2,I4)
C      CALL VCENNA(0.,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
C      CALL VCENNA(XN1,I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,IJ,IT)
      GO TO 500

500   CONTINUE
      RETURN
      END

      FUNCTION XKSS(I1,I2)
      CHARACTER*3 KEY
      COMMON/CKEY/KEY,HBW
      DIMENSION XKSA(10,10)
      XKSS = 0.
      IF(I1.EQ.I2.AND.KEY.EQ.'KIO') RETURN
      IF(I1.GT.10.OR.I2.GT.10) GO TO 200
      XKSS = XKSA(I1,I2)
      IF(XKSS.NE.0.) RETURN
      XKSS = XKS(I1,I2)
      XKSA(I1,I2) = XKSS
      XKSA(I2,I1) = XKSS
      RETURN
200   XKSS = XKS(I1,I2)
      RETURN
      END

      FUNCTION HCM(I1,I2)
      DIMENSION XAH(200,10)
      CHARACTER*9 WSF
      COMMON/WSF/WSF
      COMMON/INDEX/XL(3,200)


      HCM = 0.

      IF(IFH.EQ.999) GO TO 8001
      IHMAX = 10
      DO 8000 IHZ = 1,200
      NZ = XL(1,IHZ)
      XAH(IHZ,NZ) = 1.
8000  CONTINUE
 
      IF(WSF.EQ.' ') GO TO 910
      OPEN(UNIT=15,FILE=WSF//'.WS',STATUS='OLD')
      TYPE 914
      WRITE(11,914)
914   FORMAT(/,1X,'WS expansion parameters',/,3X,'K,N,A,sum A**2',/)
912   CONTINUE
      READ(15,*,ERR=911) IZ1,IZ2,XHZ
      IF(IZ1.LT.0)GOTO911
      IF(IZ1.NE.IZ1S) SXHZ = 0.
      IF(IZ1.EQ.IZ1S) GO TO 8003
      DO 8002 INZ = 1,10
      XAH(IZ1,INZ) = 0.
8002  CONTINUE
8003  CONTINUE
      SXHZ = SXHZ+XHZ*XHZ
      TYPE 915,IZ1,IZ2,XHZ,SXHZ
      WRITE(11,915) IZ1,IZ2,XHZ,SXHZ
915   FORMAT(1X,2I4,1X,F10.6,1X,F10.6)
      XAH(IZ1,IZ2) = XHZ
      IZ1S = IZ1
      GO TO 912
911   CLOSE(UNIT=15)
910   CONTINUE
      IFH = 999
8001  CONTINUE
 
      DO 251 IH1 = 1,IHMAX
      XH1 = IH1
      I1P = FINDEX(XH1,XL1,XJ1)
      IF(XAH(I1,IH1).EQ.0.) GO TO 251
 
      DO 251 IH2 = 1,IHMAX
      XH2 = IH2
      I2P = FINDEX(XH2,XL2,XJ2)
      IF(XAH(I2,IH2).EQ.0.) GO TO 251
      IF(I1P.NE.I2P) GO TO 251
 
      HCM = HCM + XAH(I1,IH1)*XAH(I2,IH2)*(2.*XXN(I1P)+XL(2,I1))
251   CONTINUE
      RETURN
      END

