      SUBROUTINE LANC
C
C     SUBROUTINE FOR DIAGONALIZATION BY LANCZOS ALGORITHM
C
C
CWEO ******************************************************************

CWEO         THIS STATEMENT GIVES US REAL*16 VARIABLES ON THE VAX/780
CWEO         AND IS FOLLOWED BY A CALL LIB$ESTABLISH(LIB$EMULATE)

CBAB      INCLUDE 'SHGRLIB:LANC.INC' 

CWEO ******************************************************************

      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
cmh
      include 'nrecmax.inc'
C      REAL*16 EVEC
      REAL*8 EVEC
      CHARACTER*9 FILE_NAME,EIGFIL
      CHARACTER*4 FILE_EXT
      COMMON/FIL/EIGFIL
      COMMON /VECTORS/VMP1(MAX_DIM),VMP2(MAX_DIM),VMPFILL(MAX_DIM) 
      COMMON /EIGENC/F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,XT(4*MAX_VEC),EVEC(MAX_VEC+2)
      COMMON/CIN/ORTFIL,ORT2,BIGF,BIGG 
      COMMON/IN/MAXB,IRSIZE,TOL1,TOL2,NKEEP,NOUT 
CWNC THESE NEXT TWO LINES CHANGED FROM (20) TO (201) TO AVOID OVERWRITING
      COMMON/OUT/EIGVAL(MAX_VEC+2) 
      COMMON/OUTO/EIGVALO(MAX_VEC+2) 
CBAB      COMMON/ITE /NPRE,ITMAX,IWC 
      COMMON/ITE /NPRE,IWC 
      COMMON/TIME/JEIGEN_TIME,JLANC_TIME,HANDLE
      COMMON/HEAD/IVERS,ICASE,NTTL,IREST,JAY,J2, 
     1 IT2,IMZS,KPAR 

cmh

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13

      CHARACTER*13 ORTF,BIGF,BIGG 
      CHARACTER*9 ORTFIL 
      CHARACTER*4 DUD4,ORT2 
      DIMENSION EI(MAX_VEC) 
      DIMENSION LOCN(40) 
      EQUIVALENCE (XT(2*MAX_VEC+1),EI(1)) 
      DIMENSION AMP1(MAX_DIM),AMP2(MAX_DIM) 
      EQUIVALENCE (AMP1(1),VMP1(1)),(AMP2(1),VMP2(1)) 
      INCLUDE 'SHGR:DATA.INC'

CWEO ***  SUBROUTINE TO ENABLE REAL*16 VARIABLES TO BE USED ****
       
CBAB                     CALL LIB_EMULATE

C         FPS VERSION JUST RETURNS
CWEO ***********************************************************

      CALL OPEN_FILE(13,EIGFIL,'.LTG','NEW','UFRM')

cmh
      nrec13=0
cmh      write(*,*)'nrm,maxb',nrecmax,maxb

      CALL OPEN_FILE(24,EIGFIL,'.LTF','NEW','UFRM')
C      CALL OPEN_FILE(25,EIGFIL,'.EEE','NEW','FORM')

CBAB JULY 2, 1984 ADDED SO THAT WE KNOW IMMEDIATELY HOW MUCH DISK
CBAB SPACE IS NEEDED FOR FILES 13 AND 22 AND 24 BY WRITING OUT TO
CBAB MAXIMUM SIZE
      DO 8002 IBAB = 1,MAXB
8002  VMPFILL(IBAB) = 0.11111111
CBAB      DO 8000 IBAB = 2,ITMAX
CBAB THE VALUE 50 BELOW REPRESENTS THE TYPICAL NUMBER OF ITERATIONS
CBAB BEYOND NKEEP TO ACHEIVE 0.5 KEV CONVERGENCE


      DO 8000 IBAB = 2,NKEEP+50
cmh      write(*,*)ibab,nrec13
8000  CALL WRITOUTm(131,VMPFILL,MAXB)
cmh 8000  CALL WRITOUT(13,VMPFILL,MAXB)

cmh
cmh      nrec13=nrec13+nkeep+50

cmh      WRITE(*,*)'v1'


CBAB      DO 8003 IBAB = 2,ITMAX


cmh      DO 8003 IBAB = 2,NKEEP+50
cmh8003  BACKSPACE 13

cmh
cmh      write(*,*)'b',nrec13
      call mbacks(nkeep+49,maxb)
cmh      write(*,*)'a',nrec13

cmh      nrec13=0

CBAB      DO 8001 IBAB = 1,NOUT
      DO 8001 IBAB = 1,NKEEP
8001  WRITE(24) DUMMY,(VMPFILL(J),J=1,MAXB)
      REWIND 24
CBAB      DO 8005 IBAB = 1,NOUT
      DO 8005 IBAB = 1,NKEEP
8005  WRITE(22) DUMMY,(VMPFILL(J),J=1,MAXB)
      REWIND 22
CBAB      WRITE(6,8006)
CBAB8006  FORMAT(1X,'ALL BIG FILES HAVE NOW BEEN OPENED')
CBAB JULY 2, 1984

CBAB      MAXBA = MAX_DIM 
      ITEST=0 
      DO 765 I=1,MAXB 
765   VMP1(I) =1.0 
C-----------------------------------------------------------------------
CW
CW  REOPEN .MAT 
CW  ENERGY MATRIX IS READ IN BY SUBROUTINE
CW  HMULT. CORE REQUIRED CORRESPONDS TO LENGTH
CW  OF ONE ROW (MAXB). 
CW
      IX = 1 
      IF(NPRE.EQ.0) GOTO 85 
C
C--- PERFORM PRE-ITERATIONS
      DO 80 I=1,NPRE 
      IX = MOD(IX,2) + 1 
      GOTO (78,79) IX 
78    CALL HMULT(VMP1,VMP2,MAXB) 
CBAB ADDED DEC 18, 1983
      IF(MAXB.EQ.1) RETURN
      GOTO 80 
79    CALL HMULT(VMP2,VMP1,MAXB) 
CBAB ADDED DEC 18, 1983
      IF(MAXB.EQ.1) RETURN
80    CONTINUE 

cmh
cmh      write(*,*)npre
cmh      write(*,*)(vmp1(i),i=1,maxb)
cmh      write(*,*)(vmp2(i),i=1,maxb)

C
C
85    CONTINUE 
      GOTO(86,87) IX 
86    CALL NORM(RNORM,MAXB,VMP1,VMP1,2) 

cmh      write(*,*)nrec13
      CALL WRITOUTm(132,VMP1,MAXB) 
cmh      write(*,*)nrec13

cmh      CALL WRITOUT(13,VMP1,MAXB) 

cmh
      

      GOTO 110 
87    CALL NORM(RNORM,MAXB,VMP2,VMP2,2) 

cmh
cmh      write(*,*)rnorm
cmh      write(*,*)(vmp1(i),i=1,maxb)
cmh      write(*,*)(vmp2(i),i=1,maxb)


      CALL WRITOUTm(133,VMP2,MAXB) 

cmh      CALL WRITOUT(13,VMP2,MAXB) 

cmh
      


110   CONTINUE 
C
C
C-----     --- CALL LANCZOS ROUTINE ---


      NST =0 
CWEO      IF(.NOT.LIB$STAT_TIMER(2,ICPULANC,HANDLE))GOTO 7550
CBAB115   CALL LANCZOS(VMP1,VMP2,MAXB,NST,ITMAX,IX,ITEST,NKEEP) 
115   CALL LANCZOS(VMP1,VMP2,MAXB,NST,IX,ITEST,NKEEP,NOUT) 
CWEO      IF(.NOT.LIB$STAT_TIMER(2,ICPULANC2,HANDLE))GOTO 7550
CZ      JLANC_TIME=ICPULANC2-ICPULANC
      JLANC_TIME=ICPULAN2-ICPULANC
CBAB      CLOSE(UNIT=10)
      CLOSE(UNIT=10,STATUS='DELETE')
      RETURN 
CWEO7550  STOP 'LIB$STAT_TIMER ERROR'
      END 




C         LANCZOS SUBROUTINE 
C-----------------------------------------------------------------------
C
      SUBROUTINE LANCZOS(VMP1,VMP2,MAXB, 
     1NST,IX,ITEST,NKEEP,NOUT)
CBAB     1NST,ITMAX,IX,ITEST,NKEEP)
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
cmh
      include 'nrecmax.inc'
C      REAL*16 EVEC
      REAL*8 EVEC
      CHARACTER*13 ORTF,BIGF 
      COMMON /EIGENC/F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,XT(4*MAX_VEC),EVEC(MAX_VEC+2)
      COMMON /OUT/EIGVAL(MAX_VEC+2) 
      COMMON /OUTO/EIGVALO(MAX_VEC+2) 
CWEO      COMMON /CIN/ORTF,BIGF 
      COMMON/CRAN/IRAN,IRANERR
      COMMON/CRIT/CRIT,MAX_NST,ITMIN,MAXITER
      COMMON/TIME/JEIGEN_TIME,JLANC_TIME,HANDLE

cmh

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13


      DIMENSION VMP1(MAXB),VMP2(MAXB) 
      INCLUDE 'SHGR:DATA.INC'               
CBAB      CHECK=1.
CBAB      NUMIN=0
      JEIGEN_TIME=0

cmh
cmh      write(*,*)'n,m',nrecmax,maxb


C
C
C--- START OF ITERATION LOOP
115   LTEST = 0 



      IX = MOD(IX,2) + 1 

cmh	write(*,*)'ix,lst1',ix,vmp1
cmh	write(*,*)'lst2',vmp2



120   CONTINUE 
32    CONTINUE 
      GOTO (121,122) IX 
121   CALL HMULT(VMP1,VMP2,MAXB) 
      GOTO 123 
122   CALL HMULT(VMP2,VMP1,MAXB) 
123   IF(NST.LT.1) GOTO 125 


cmh      BACKSPACE 13 
cmh      BACKSPACE 13 

cmh

      call mbacks(2,maxb)

cmh      nrec13=nrec13-2*maxb

C-----  ORTHOGONALISE AND OBTAIN MATRIX ELEMENTS
125   CONTINUE 
      GOTO (126,127) IX 
126   CALL NORM(SCLRP,MAXB,VMP1,VMP2,1) 
      GOTO 128 
127   CALL NORM(SCLRP,MAXB,VMP2,VMP1,1) 
128   F(NST+1) = SCLRP 
      IF(NST.LT.1) GOTO 165 
      GOTO(131,132) IX 

cmh 131   READ(13) VMP2

131   call READinm(134,VMP2,maxb)

cmh
      
 
      CALL NORM(SCLRP,MAXB,VMP1,VMP2,1) 
      GOTO 133 

cmh 132   READ(13) VMP1 

132   call READinm(135,VMP1,maxb) 

cmh
      

      CALL NORM(SCLRP,MAXB,VMP2,VMP1,1) 
133   G(NST) = SCLRP 
C-----  RE-ORTHOGONALISE AND NORMALISE


145      continue

cmh
      nrec13=0
        REWIND 13 

cmh 145   REWIND 13 

      NSTP = NST + 1 
      DO 160 I=1,NSTP 
      GOTO(158,159) IX 

cmh 158   READ(13) VMP2

158   call READinm(136,VMP2,maxb)


cmh	write(*,*)'vb61',vmp1
cmh	write(*,*)'vb62',vmp2      
 
      CALL NORM(SCLRP,MAXB,VMP1,VMP2,1) 

cmh	write(*,*)'vb71',sclrp,vmp1
cmh	write(*,*)'vb72',vmp2      


      GOTO 160 

cmh 159   READ(13) VMP1 

159   call READinm(137,VMP1,maxb) 

cmh      write(*,*)'v1',(vmp1(kk),kk=1,maxb)

cmh
      


      CALL NORM(SCLRP,MAXB,VMP2,VMP1,1) 
160   CONTINUE 
165   CONTINUE 
c      GOTO(156,157) IX 
c156   CALL NORM(RNORM,MAXB,VMP1,VMP1,2) 
c      GOTO 166 
c157   CALL NORM(RNORM,MAXB,VMP2,VMP2,2) 
CWEO  it seems that I have messed up the original lines here!
CWEO ---------------------------------------------------------
C        Added to prevent premature termination of Lanczos
C        procedure. It is done by starting from a new 
C        random vector that has been orthogonalized 
C        with all the vectors found so far. This procedure
C        should find the eigenvalues and eigenvectors exactly
C        even for degenerate eigenvalues and block-diagonal matrices.
C        Note the added subroutine newvec
CWEO ----------------------------------------------------------

cmh
cmh	write(*,*)'ix',ix,max_dim,maxb

      GOTO(156,157) IX 
156   continue
cmh
cmh	write(*,*)'vb',vmp1

      CALL NORM(RNORM,MAXB,VMP1,VMP1,2) 

cmh
cmh	write(*,*)'rn',rnorm
cmh	write(*,*)'v',vmp1

      IF(RNORM.GT.1.0E-6) GO TO 170 
      IF(NST.GE.(MAXB-1)) GO TO 190 
      call newvec(vmp1,maxb)
      GOTO 145
157   continue
cmh	write(*,*)'vb2',vmp2

      CALL NORM(RNORM,MAXB,VMP2,VMP2,2) 

cmh
cmh	write(*,*)'rn',rnorm
cmh	write(*,*)'v2',vmp2


      IF(RNORM.GT.1.0E-6) GO TO 170 
      IF(NST.GE.(MAXB-1)) GO TO 190 
      call newvec(vmp2,maxb)
      GOTO 145
C
C-----  PREMATURE TERMINATION RECOVERY
c166   CONTINUE 
c      IF(RNORM.GT.1.0E-6) GO TO 170 
c      IF(NST.GE.(MAXB-1)) GO TO 190 
c      LTEST=LTEST+1 
c      IF(LTEST.GT.2.AND.IFIRST_IRAN.EQ.999)WRITE(6,5001) 
c5001  FORMAT(1X,'***** FATAL ERROR in LANC: LTEST.GT.2 *****'
c     1/,1X,'SOLUTION: PUT RANDOM NUMBERS IN THE MATRIX. IN THIS CASE',
c     1/,1X,'PUT IRAN=N(keV/10), IN THE FIRST LINE',
c     1/,1X,'WE HAVE AUTOMATICALLY TRIED N=1, TRY A LARGER VALUE')
c      IF(LTEST.GT.2.AND.IFIRST_IRAN.EQ.999)STOP 
c      IF(LTEST.GT.2.AND.IFIRST_IRAN.NE.999)WRITE(6,5000) 
c5000  FORMAT(1X,'***** FATAL ERROR in LANC: LTEST.GT.2 *****'
c     1/,1X,'SOLUTION: PUT RANDOM NUMBERS IN THE MATRIX. IN THIS CASE',
c     1/,1X,'PUT IRAN=N(keV/10), IN THE FIRST LINE',
c     1/,1X,'TYPICALLY N=1, AT THIS POINT WE WILL THIS IS DONE
c     1 AUTOMATICALLY')
c      IF(LTEST.GT.2) IFIRST_IRAN=999
c      IF(LTEST.GT.2) IFIRST_CALL=0
c      IF(LTEST.GT.2) RETURN
c      GO TO 145 
C-----  WRITE NEW VECTOR ON DISC
170   GOTO(171,172) IX 


cmh 171   WRITE(13) VMP1 

171   call WRIToutm(138,VMP1,maxb) 

cmh
      


      GOTO 190 

cmh 172   WRITE(13) VMP2

172   call WRIToutm(139,VMP2,maxb)

cmh
      

190   NST=NST+1 
210   G(NST)=0.0 
CBAB      IF(NST.LT.NOUT) GO TO 115
      IF(NST.LT.NKEEP) GO TO 115
CBAB      IF(NST.LT.ITMAX)GOTO 115

CBAB WHEN NST GOES BEYOND THE VALUE OF ITMAX IT WILL START CHECKING
CBAB FOR CONVERGENCE
CBAB      ITMAX = NKEEP+10
      ITMAX = 5*NKEEP
CBAB START CHECKING WHEN WE ARE TWO FROM THE END OF MAX_VEC
      IF(ITMAX.GT.MAX_VEC-2) ITMAX=MAX_VEC-2
      IF(ITMAX.GT.MAXB) ITMAX=MAXB
      IF(NST.LT.ITMAX) GO TO 115
CBAB CONVERGENCE CHECK
CBAB      NUMIN=NUMIN+1
C-----  CALCULATE EIGENVALUES
      CALL EIGENH(NST) 
      DO 225 I=1,NST 
      J=NST+1-I 
CBAB      IF(NUMIN.GT.1) EIGVALO(I) = EIGVAL(I) 
      EIGVALO(I) = EIGVAL(I) 
      EIGVAL(I)=E(J) 
225   CONTINUE 
C      REWIND(UNIT=25)
C      WRITE(25,*) (EIGVAL(I),I=1,NST)
34    CONTINUE 

      IF(NST.EQ.MAXB) GO TO 220

CBAB      IF(NUMIN.GT.1)THEN 
      CHECK=0.

CBAB ADDED BY E ORMAND (JULY 1985) TO TRY TO GET VECTORS ABOVE NKEEP
CBAB PROPERLY CONVERGED
CBAB ERROR FOUND DEC 1987
CBAB      IF((NKEEP+10).LT.MATDIM)THEN

CBAB      IF((NKEEP+10).GE.MAXB)THEN
CBAB      NX=MAXB
CBAB      ELSE
CBAB      NX=NKEEP+10
CBAB      END IF

      NX = NKEEP

      DO 2255 KK=1,NX
      IF(ABS(EIGVALO(KK)-EIGVAL(KK)).GT.CHECK)CHECK
     1=ABS(EIGVALO(KK)-EIGVAL(KK))
2255  CONTINUE
CBAB      END IF

      WRITE(6,8000)NST,CHECK,EIGVAL(1),EIGVAL(2)
8000  FORMAT(1X,'ITERATION, MAX DEVIATION, E0,E1 = '
     1,I5,1X,3F9.4)
      IF(MAXITER.NE.0.AND.NST.GE.MAXITER) GO TO 1500
      IF(NST.EQ.(MAX_VEC-1)) GO TO 1500
      GO TO 1501

1500  CONTINUE
      WRITE(6,5505)
5505  FORMAT(1X,'***** WARNING #ITERATIONS EQ. (MAX_VEC-1) *****')
      IF(CHECK.LE.CRIT) WRITE(6,5506) NST,MAXB,NX
      IF(CHECK.GT.CRIT) WRITE(6,5507) NST,MAXB,NX
5506  FORMAT(1X,'CONVERGENCE TEST PASSED, NST,MAXB,NX = ',3I5)
5507  FORMAT(1X,'CONVERGENCE TEST FAILED, NST,MAXB,NX = ',3I5)
      GO TO 220

1501  CONTINUE
      IF(CHECK.LE.CRIT) GO TO 220 
      GO TO 115


CBAB      IF(NST.GT.ITMAX) GO TO 220
CBAB      IF(NST.LT.MAXB) GO TO 115
220   CONTINUE 
C-----------------------------------------------------------------------
C     CALCULATE REQUIRED EIGENVECTORS 
C-----------------------------------------------------------------------
CBAB JULY 2, 1984 MOVED UP TO AFTER OPE(UNIT=13)
CBABCBAB OPEN(UNIT=24,FILE='WOTDSK:'//BIGF,FORM='UNFORMATTED',
CBAB  OPEN(UNIT=24,FILE=AREA_RUN//BIGF,FORM='UNFORMATTED', 
CBAB 1 STATUS='NEW') 
CBAB      NKEEP = MIN0(NKEEP,MAXB) 
CBAB      NOUT = MIN0(NOUT,MAXB) 
      MAX_NST=NST
CBAB      IF(NOUT.LT.1) GOTO 260 
      IF(NKEEP.LT.1) GOTO 260 
2450  FORMAT(//' TRANSFORMATION (LANCZOS) MATRIX') 
CBAB      DO 2110 IJ=1,NOUT 
      DO 2110 IJ=1,NKEEP 

cmh
      nrec13=0
        REWIND 13
 
      I=NST+1-IJ 
      DO 230 J=1,MAXB 
230   VMP1(J)=0.0 
      CALL EIGENV(I,NST) 
C-----  TRANSFORM WITH LANCZOS MATRIX
      DO 240 J=1,NST

cmh      CALL READIN(13,VMP2,MAXB) 

      CALL READINm(1390,VMP2,MAXB) 

cmh
      

      EV = EVEC(J) 
      DO 240 L=1,MAXB 
240   VMP1(L) = VMP1(L) + VMP2(L)*EV 
250   FORMAT(/100(12F10.3/)) 
CBAB ERROR FOUND NOV 1987 - IT WAS NEVER A PROBLEM BECAUSE THE
CBAB EIGENVALUES WERE TRANSFERED TO THE MAIN PROGRAM VIA THE
CBAB COMMON BLOCK /OUT/ RATHER THAN IN THIS FILE
CBAB      WRITE(24) EIGVAL(I),(VMP1(J),J=1,MAXB) 
      WRITE(24) EIGVAL(IJ),(VMP1(J),J=1,MAXB) 
      DO 255 L=1,MAXB 
255   VMP1(L)=VMP1(L)*VMP1(L) 
2110  CONTINUE 
260   CONTINUE 
CBAB      CLOSE(UNIT=24) 
      CLOSE(UNIT=13,STATUS='DELETE') 
CZ      CLOSE(UNIT=7) 
900   FORMAT(/1H )                  
1100  FORMAT(1H0,'TERMINATION TEST') 
1200  FORMAT(1H ,'PREMATURE TERMINATION - RECOVERY FAILED') 
1300  FORMAT(8(' ',I5,F11.6)) 
1600  FORMAT(/(1X,12F10.6)) 
        RETURN
      END 

      SUBROUTINE READIN(I,ARRAY,N) 
      DIMENSION ARRAY(N) 
      READ(I) ARRAY 
      RETURN 
      END 

      SUBROUTINE WRITOUT(I,ARRAY,N) 
      DIMENSION ARRAY(N) 
      WRITE(I) ARRAY 
      RETURN 
      END 


      SUBROUTINE READINm(I,ARRAY,N) 
cmh
cmh
      include 'nrecmax.inc'

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13
cmh      common /nrecold/nrold,nwold

      DIMENSION ARRAY(N) 

cmh      write(*,*)'r',i,n,nrec13

cmh      nrecmax=nrecmax
      if(nrec13+n.gt.nrecmax)then
cmh      write(*,*)'r overpassed nrecmax',nrec13
      call readin(13,array,n)
cmh      write(*,*)'rf',i,nrec13,(array(l),l=1,n)
      nrec13=nrec13+n
      return
      endif
      

      do 1 j=1,n
      array(j)=vltg(nrec13+j)
cmh      write(*,*)j,array(j),nrec13+j
1      continue
cmh      write(*,*)'rm',i,nrec13,(array(l),l=1,n)
      nrec13=nrec13+n

cmh      nrold=nrec13
      RETURN 
      END 

      SUBROUTINE WRITOUTm(I,ARRAY,N) 
cmh
cmh
      include 'nrecmax.inc'

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13

      DIMENSION ARRAY(N) 
cmh      write(*,*)'w',i,n,nrec13

cmh      nrecmax=nrecmax
      if(nrec13+n.gt.nrecmax)then
cmh      write(*,*)'w overpassed nrecmax',nrec13
      call writout(13,array,n)
cmh      write(*,*)'wf',i,nrec13,(array(l),l=1,n)
      nrec13=nrec13+n
      return
      endif

      do 1 j=1,n
cmh      write(*,*)nrec13+j,array(j)
1      vltg(nrec13+j)=array(j)
cmh      write(*,*)'wm',i,nrec13,(array(l),l=1,n)
      nrec13=nrec13+n


      RETURN 
      END 


      SUBROUTINE HMULT(AMPN,AMPO,MAXB) 
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'
      COMMON/XLEE/XLEE
      COMMON/CDET/DET,IDEX               
      DIMENSION DET(MAX_DIM) 
      INTEGER*4 IDEX(MAX_DIM)
      DIMENSION AMPN(MAX_DIM),AMPO(MAX_DIM) 
      COMMON/CRAN/IRAN,IRANERR

cmh
      common/midex/imidex,kmx,midex(max_dim)
	common /diag0/idiag0


      INCLUDE 'SHGR:DATA.INC'               
      IF(IFIRST_CALL.EQ.0)CALL MATWR
      IFIRST_CALL=1 
      REWIND 9
      REWIND 10 
      DO 5009 I=1,MAXB
5009  AMPN(I)=0.0
      DO 5004 L=1,MAXB 
      APP=0.0
      READ(9) K,(IDEX(I),I=1,K),(DET(I),I=1,K)
      IF(IRAN.NE.0) CALL ADDRAN(K,L) 
      DO 5010 I = 1,K
5010  DET(I) = XLEE*DET(I)
      READ(10) DET(K)

cmh
	fdiag0=idiag0/100.0e0	

cmh
      if(imidex.ne.1)go to 91
      do 90 kk=1,kmx
90      if(l.eq.midex(kk))go to 91
      go to 5004
91      continue

      DO 5003 I=1,K

cmh
      if(imidex.ne.1)go to 93
      do 92 kk=1,kmx
92      if(idex(i).eq.midex(kk))go to 93
      go to 5003
93      continue

cmh      APP=AMPO(IDEX(I))*DET(I)+APP
cmh
	detii=det(i)
	if(idiag0.eq.0)go to 6633
	if(idex(i).eq.l)detii=fdiag0*det(i)
6633  continue
      APP=AMPO(IDEX(I))*DETIi+APP
      AMPN(IDEX(I))=AMPN(IDEX(I))+AMPO(L)*DET(I)
5003  CONTINUE
      AMPN(L)=APP
5004  CONTINUE
      RETURN 
      END 


      SUBROUTINE NORM(RNRM,MAXB,AMP1,AMP2,NORMT) 
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
      DIMENSION AMP1(MAX_DIM),AMP2(MAX_DIM) 
5002  FORMAT(' AMPN: ',10E12.3) 
      AM=0 
      DO 55 I=1,MAXB 
55    AM = AM + AMP1(I)*AMP2(I) 
70    CONTINUE 
      IF (NORMT .EQ. 1) GOTO 10 
      RNRM=SQRT(AM) 
CBAB  PUT IN FEB 6, 1984 WHEN I FOUND A CASE WHERE RNRM WAS ZERO 
      IF(RNRM.EQ.0) WRITE(6,500)
500   FORMAT(/,1X,'WARNING: RNRM SET EQUAL TO 10E-13 IN SUBROUTINE 
     1 NORM') 
      IF(RNRM.EQ.0) RNRM = 10E-13 
      AM=1.0/RNRM 
      DO 20 I=1,MAXB 
20    AMP1(I) = AMP1(I)*AM 
      RETURN 
10    CONTINUE 
      RNRM=AM 
      DO 30 I=1,MAXB 
30    AMP1(I) = AMP1(I) -AM*AMP2(I) 
      RETURN 
      END 




       SUBROUTINE EIGENH(NN) 
C  CALCULATE EIGENVALUES OF THE SYMMETRIC TRIDIAGONAL MATRIX IN F & G
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
C      REAL*16 Y
      REAL*8 Y
      COMMON/EIGENC/ F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,Q(MAX_VEC),R(MAX_VEC),IN(MAX_VEC),
     1DM(MAX_VEC),Y(MAX_VEC+2) 
      LOGICAL*4 IN 
      INCLUDE 'SHGR:DATA.INC'               
      IF(NN.GT.1) GO TO 5 
      E(1)=F(1) 
      GO TO 130 
5     RNORM=ABS(F(1))+ABS(G(1)) 
      IF(ABS(G(1)).LE.1.0E-15) G(1)=1.0E-15 
      P(1)=G(1)*G(1) 
      DO 10 I=2,NN 
      TNORM=ABS(F(I))+ABS(G(I))+ABS(G(I-1)) 
      RNORM=AMAX1(RNORM,TNORM) 
      IF(ABS(G(I)).LE.1.0E-15) G(I)=1.0E-15 
10    P(I)=G(I)*G(I) 
      K=1 
      U=RNORM 
      DO 20 I=1,NN 
20    E(I)=-RNORM 
30    RL=E(K) 
40    DL=0.5*(RL+U) 
      IF((DL.EQ.RL).OR.(DL.EQ.U)) GO TO 120 
      IAG=0 
      I=1 
50    S=F(I)-DL 
60    IF(S.GE.0.0) IAG=IAG+1 
      IF(S.EQ.0.0) GO TO 70 
      I=I+1 
      IF(I.GT.NN) GO TO 80 
      S=F(I)-DL-P(I-1)/S 
      GO TO 60 
70    I=I+2 
      IF(I.LE.NN) GO TO 50 
80    IF(IAG.GE.K) GO TO 90 
      U=DL 
      GO TO 40 
90    RL=DL 
      M=IAG 
      IF(NN.LT.IAG) M=NN 
      DO 110 I=K,M 
110   E(I)=DL 
      GO TO 40 
120   E(K)=DL 
      K=K+1 
      IF(K.LE.NN) GO TO 30 
130   RETURN 
      END 




      SUBROUTINE EIGENV(II,N) 
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
C      REAL*16 Y,DT
      REAL*8 Y,DT
      COMMON/EIGENC/ F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,Q(MAX_VEC),R(MAX_VEC),IN(MAX_VEC),
     1DM(MAX_VEC),Y(MAX_VEC+2) 
      LOGICAL IN 
      INCLUDE 'SHGR:DATA.INC'               
C
C-----------------------------------------------------------------------
C     CALCULATE I'TH EIGENVECTOR
C-----------------------------------------------------------------------
      IF(N.GT.1) GOTO 130 
      Y(1) = 1.0 
      RETURN 
130   CONTINUE 
      IRS=N-1 
      IRE=0 
      DO 140 J=1,N 
      P(J)=0.0 
      Q(J)=G(J) 
      R(J)=F(J)-E(II) 
140   Y(J)=1.0 
      Y(N+1)=0.0 
      Y(N+2)=0.0 
C-----  TRIANGULAR REDUCTION OF LEFT HAND SIDE
      IAG=N-1 
      DO 170 J=1,IAG 
      JJ=J+1 
      IF(ABS(R(J)).LT.ABS(G(J))) GO TO 150 
      DT=G(J)/R(J) 
      IN(J)=.FALSE. 
      GO TO 160 
150   DT=R(J)/G(J) 
      IN(J)=.TRUE. 
      R(J)=G(J) 
      U=R(JJ) 
      R(JJ)=Q(J) 
      Q(J)=U 
      P(J)=Q(JJ) 
      Q(JJ)=0.0 
160   DM(J)=DT 
      Q(JJ)=Q(JJ)-DT*P(J) 
      R(JJ)=R(JJ)-DT*Q(J) 
      IF(ABS(R(J)).LT.1.0E-30) R(J)=1.0E-30 
170   CONTINUE 
      IF(ABS(R(N)).LT.1.0E-30) R(N)=1.0E-30 
C-----  BACK SUBSTITUTION
190   CONTINUE 
      DO 230 J=1,N 
      JJ=N+1-J 
      T=Y(JJ) 
210   Y(JJ)=(T-Y(JJ+1)*Q(JJ)-Y(JJ+2)*P(JJ))/R(JJ) 
      IF(ABS(Y(JJ)).LE.1.0E33) GO TO 230 
      DO 220 JJJ=1,N 
220   Y(JJJ)=Y(JJJ)*1.0E-20 
      T=T*1.0E-20 
      GO TO 210 
230   CONTINUE 
      IF(IRE.EQ.2) GO TO 260 
      IRE=IRE+1 
C-----  TRIANGULAR REDUCTION OF NEW RHS
      DO 250 J=1,IRS 
      JJ=J+1 
      IF(IN(J)) GO TO 240 
      Y(JJ)=Y(JJ)-DM(J)*Y(J) 
      GO TO 250 
240   T=Y(J) 
      Y(J)=Y(JJ) 
      Y(JJ)=T-DM(J)*Y(JJ) 
250   CONTINUE 
      GO TO 190 
C-----  NORMALISE EIGENVECTOR
260   DT=0.0 
      DO 330 J=1,N 
C      Y(J)=Y(J)*1.0E-10 
      Y(J)=Y(J)*1.0E-20 
C      TYPE 7777,Y(J)
C7777  FORMAT(1X,E12.5)
      DT=DT+Y(J)**2 
C  WRITE(8,350)Y(J),DT
330   CONTINUE 
C      DT= SQRT(1.0/DT)*1.0E-20 
      DT= SQRT(1.0/DT)*1.0E-10 
      DO 340 J=1,N 
340   Y(J)=Y(J)*1.0E+10*DT 
      RETURN 
      END 



      SUBROUTINE MATWR
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
      COMMON/CDET/DET,IDEX               
      DIMENSION DET(MAX_DIM),DETIN(MAX_DIM) 
      INTEGER*4 IDEX(MAX_DIM),IDEXIN(MAX_DIM)
      CHARACTER*4 DUD4,MAT_EXT,ORT2
      CHARACTER*9 ORTFIL
      CHARACTER*13 ORTF,BIGF,BIGG,NAME
      COMMON/CILPT/ILPT
      COMMON/CBAB/SPEBAB
      CHARACTER*1 ANSSPE
      COMMON/SPE1/ANSSPE
      COMMON/SPE/NJL,ENL(MAX_NJL),ENLOLD(MAX_NJL),
     1SPE_CHANGE(MAX_NPART) 
      COMMON/ORB/IORB,NIPART,NJTP(MAX_NPART) 
      COMMON/IN/MAXB,IRSIZE,TOL1,TOL2,NEIG,NOUT,NMX,SIGN 
      COMMON/CIN/ORTFIL,ORT2,BIGF,BIGG 
      COMMON/VBAR/IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
     1VBAR,DIAGMIN,TRACE

cmh
      common/midex/imidex,kkk,midex(max_dim)

      dimension dism(max_dim)

      INCLUDE 'SHGR:DATA.INC'               

      IMATOUT = 0       
      MAT_EXT='.MAT' 
      IF(IWC.EQ.1) MAT_EXT='.MAW' 
CBAB      CALL OPEN_FILE(9,ORTFIL,MAT_EXT,'OLD','UFRM')
      NAME = ORTFIL//MAT_EXT
      CALL OPENGEN(9,AREA_MAT,NAME,1)
      CALL OPEN_FILE(10,ORTFIL,'.MTP','NEW','UFRM')
      IF(IMATOUT.EQ.1) OPEN(UNIT=40,FILE=ORTFIL//'.MAL',STATUS='NEW')
      SPEBAB = 0.

      IPARTNO=NIPART 
      NDIAGONA=0 

CBAB      READ(9)
CBAB      READ(9)


cmh

      do 88 i=1,maxb
      midex(i)=0
88      continue

c      write(*,*)'enter imidex (1 to open MIDEX.INP file - allowed vectors)'
c      read(*,*)imidex
c      write(*,*)'midex red ',imidex

      if(imidex.ne.1)go to 91
      open(unit=39,file='midex.inp',status='old')


      kkk=1
89      continue
      read(39,*,end=90)kk,midex(kkk)
      kkk=kkk+1
      go to  89
90      continue
      close(unit=39)
91      continue
c      write(*,*)'we passed '

      DIAGMIN = 99999999.
      TRACE = 0.
      VBAR =0.
      IVBAR = 0
      IVZBAR = 0
      IVZ2BAR= 0
      IVZ3BAR = 0
      IVZ4BAR = 0
      IVZ5BAR = 0
      IVZ6BAR = 0
      IVZ7BAR = 0
      IVZ8BAR = 0
      IVZ9BAR = 0
      IVZ10BAR = 0
      IVZ11BAR = 0

cmh
      open(unit=37,file=ortfil//'.dia',status='unknown')
CMH      open(unit=38,file=ortfil//'.NDP',status='unknown')
      open(unit=36,file=ortfil//'.NDG',status='unknown')

      do 60001 i=1,maxb
60001      dism(i)=0.0


      DO 5004 L=1,MAXB 
      READ(9) KMAX,(IDEXIN(I),I=1,KMAX),(DETIN(I),I=1,KMAX)
CBAB      READ(9)(DET(I),I=1,L)
      IF(IMATOUT.EQ.1) WRITE(40,4001) KMAX,(IDEXIN(I),I=1,KMAX)
4001  FORMAT(1X,10I5)
      IF(IMATOUT.EQ.1) WRITE(40,4000) (DETIN(I),I=1,KMAX)
4000  FORMAT(1X,10F10.3)
      K=0
C-----------------------------------------------------------------
      DO 5010 I=1,L
5010  DET(I) = 0.
      DO 5011 IK = 1,KMAX
5011  DET(IDEXIN(IK)) = DETIN(IK)

cmh
      do 6002 im=1,maxb
      if(im.ne.l)dism(im)=dism(im)+det(im)*det(im)
6002      continue

      dish=0.0

      do 6000 id=1,maxb
      if(id.ne.l)dish=dish+det(id)*det(id)
6000      continue

c      write(36,*)l,kmax,sqrt(dish)

      dism(l)=dism(l)+dish

      DO 5000 I=1,L

cmh
      IF(I.EQ.L) write(37,*)L,DET(I)


      IF(I.EQ.L) TRACE = TRACE + DET(I)
      IF(I.NE.L) VBAR = VBAR + DET(I)*DET(I)
      IF(I.NE.L) IVBAR = IVBAR + 1
      IF(I.NE.L.AND.DET(I).NE.0.) IVZBAR = IVZBAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.001) IVZ2BAR = IVZ2BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.01) IVZ3BAR = IVZ3BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.1) IVZ4BAR = IVZ4BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.2) IVZ5BAR = IVZ5BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.4) IVZ6BAR = IVZ6BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.6) IVZ7BAR = IVZ7BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.8) IVZ8BAR = IVZ8BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.1.0) IVZ9BAR = IVZ9BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.1.5) IVZ10BAR = IVZ10BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.2.0) IVZ11BAR = IVZ11BAR + 1

cmh

CMH      IF(I.NE.L.AND.ABS(DET(I)).GT.2.0) write(38,*)i,l,det(i)


C                                 Do you want to change SPEs ? 
      IF(ANSSPE.EQ.'Y')THEN      
C                                          Change single particles energies 
      IF(I.EQ.L.AND.ANSSPE.EQ.'Y')THEN    
C                                          in matrix 
      NDIAGONA=NDIAGONA+1               
      IF(NDIAGONA.GE.NJTP(IPARTNO)+1)THEN 
313   IPARTNO=IPARTNO-1 
      IF(NJTP(IPARTNO).EQ.0)GO TO 313 
      NDIAGONA=1 
      END IF 

C                                           change diagonal elements 
      DET(I)=DET(I)+SPE_CHANGE(IPARTNO)    

CAB ADDED DEC 18 1983

      IF(MAXB.EQ.1) SPEBAB = SPEBAB + SPE_CHANGE(IPARTNO)

CBAB IS THIS AN ERROR? AS AN EXAMPLE, FOR THE O16 1P1H PSD 0- STATE
CBAB THE VALUES OF IPARTNO ARE 5 AND 4
CBAB  IF(L.EQ.MAXB.AND.IPARTNO.NE.1)STOP  
CBAB 1' ***** FATAL ERROR in LANC: IPARTNO.NE.1 *****' 

CBAB ADDED FROM AE LETTER OF JUNE(MAY) 17 1983
871   IF(L.EQ.MAXB.AND.IPARTNO.NE.1)THEN
C                                      check if remaining partitions
      IF(NJTP(IPARTNO-1).EQ.0)THEN   
C                                      have zero JT-dimension.
      IPARTNO = IPARTNO-1            
      GO TO 871
      END IF
      STOP ' ***** FATAL ERROR in LANC: Partition number.NE.1.  Loop
     1 has not been performed over all partitions *****'
      END IF

      END IF 
      END IF 

CBAB      XMATMIN = .0001
CBAB      IF(ABS(DET(I)).GT.XMATMIN)THEN
CBAB      K=K+1
CBAB      IDEXOUT(K)=I
CBAB      END IF
      IF(I.EQ.L.AND.DET(I).LT.DIAGMIN) DIAGMIN = DET(I)
5000  CONTINUE
C-----------------------------------------------------------------
      IF(ILPT.EQ.2.AND.I30.NE.999)
     1CALL OPEN_FILE(30,ORTFIL,'.LTP','NEW','FORM')
      IF(ILPT.EQ.2.AND.I30.NE.999) I30 = 999
      WRITE(10) DET(L)
      IF(IMATOUT.EQ.1) WRITE(40,4000) DET(L)
5004  CONTINUE 



cmh

      do 6003 im=1,maxb
6003      write(36,*)im,sqrt(dism(im))


      close(unit=37)
CMH      close(unit=38)
      close(unit=36)


      IF(IVBAR.NE.0) VBAR = SQRT(VBAR/FLOAT(IVBAR))
      IF(IVBAR.EQ.0) VBAR = 0.
      WRITE(6,7000)IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
     1IVZ5BAR,IVZ6BAR,IVZ7BAR,IVZ8BAR,IVZ9BAR,IVZ10BAR,IVZ11BAR,
     1VBAR,DIAGMIN,TRACE
C      WRITE(3,7000)IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
C     1VBAR,DIAGMIN,TRACE
7000  FORMAT(/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS',/,
     11X,I9,' NON ZERO OFF DIAGONAL MATRIX ELEMENTS',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.001',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.01',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.1',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.2',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.4',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.6',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.8',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 1.0',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 1.5',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 2.0',/,
     11X,F12.4,' AVERAGE (V**2)**(1/2) FOR OFF DIAGONAL ME',/,
     11X,F12.4,' MOST NEGATIVE DIAGONAL MATRIX ELEMENT',/,
     11X,E16.8,' TRACE')
CBAB      CLOSE(UNIT=9)
      RETURN
      END 

      SUBROUTINE ADDRAN(K,L)
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
      COMMON/CDET/DET,IDEX               
      DIMENSION DET(MAX_DIM) 
      INTEGER*4 IDEX(MAX_DIM)
      COMMON/CRAN/IRAN,IRANERR

      IF(L.EQ.1) IFIRST = 0
      IF(IFIRST.EQ.999) GO TO 1000
      XRAN=IRAN
      XRAN=XRAN/10000.
      ISEED=-8573419
      IF(IFPS.EQ.2) CALL RANSET(ISEED)
      IFIRST = 999
1000  CONTINUE

      DO 2000 I = 1,K
      IF(IFPS.EQ.2) THEN
      IF(IRAN.GT.0)DET(I)=XRAN*(RANF(ISEED)-0.5)+DET(I)
      ELSE
C      IF(IRAN.GT.0)DET(I)=XRAN*(RAN(ISEED)-0.5)+DET(I)
      IF(IRAN.GT.0)DET(I)=XRAN*(RAN(ISEED)-0.5)
      END IF
2000  CONTINUE
C      TYPE 7777,L,XRAN,XRAN*(RAN(ISEED)-0.5)
C7777  FORMAT(1X,I3,2F10.5)

      RETURN
      END
      subroutine newvec(vec,idim)
      common/ran/iseed
      dimension vec(idim)
      WRITE(6,'(1X,''Have encountered a premature termination of 
     1the Lanczos procedure.'',/,1x,''Will try to restart'')')
      do 10 i=1,idim
      ix=500*ran(iseed)
      sign=1.0
      if(iand(ix,1).eq.0)sign=-1.0
10    vec(i)=5.*sign*ran(iseed)
c      write(6,'(1x,f10.6)')vec(i)
      CALL NORM(RNORM,idim,VEC,VEC,2) 
c      write(6,'(1x,e15.6,/1x,10f10.6)')rnorm,(vec(i),i=1,idim)
      RETURN
      END

cmh
      subroutine mbacks(m,length)
cmh
      include 'nrecmax.inc'

cmh     replace "backspace 13" m times

      common/nrec13/nrec13

      m1=(nrec13-1-nrecmax)/length+1

cmh      write(*,*)'backs',nrec13,nrecmax,m1,m

      if(nrec13.le.nrecmax)then
      nrec13=nrec13-m*length
      return
      endif


      if(m.le.m1)then
      do i=1,m
      backspace 13
      enddo
      nrec13=nrec13-m*length
      return

      else
cmh      m2=m-m1
      rewind 13
      nrec13=nrec13-m*length

      endif
      
      return
      end
