C--------------------------------------------------------------------------
C
C     OXFORD-BUENOS AIRES SHELL MODEL CODE
C     MAIN PROGRAM FOR LANCZOS EIGENVALUES
C
C--------------------------------------------------------------------------
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'lancom.inc'
      CHARACTER*13 PRJF,MATF,EIGF,SPEF,DUD13,ORTF,BIGF,BIGG,REDF
      CHARACTER*13 NAME
CBAB  CHARACTER*9 MATFIL,EIGFIL,SPEFIL,LPTFIL,SPSFIL,BASFIL,INTFIL
      CHARACTER*9 MATFIL,EIGFIL,SPEFIL,LPTFIL,SPSFIL,BASFIL
      CHARACTER*9 GNDFIL,DUD9,ORTFIL,REDFIL,OPFIL
      CHARACTER*9 SHELL,LEENAME
CBAB  PARAMETER MAX_NJL=9,N_WORDS=MAX_NJL/4+1,MAX_NOSC=3
      CHARACTER*4 MAT2,EIG2,SPE2,GND2,DUD4,ORT2,BIG2,RED2
      INTEGER JLTW(MAX_NJL),HANDLE
      LOGICAL RET_STATUS
      REAL JAAY,JZ
      DIMENSION AVNJ(MAX_NJL,MAX_VEC),NJ(MAX_NJL),SUMHBW(MAX_vec,11)
CBAB      EQUIVALENCE (AVNJ(1,1),EVEC(5001))
      COMMON/HNORM/HNORM
      COMMON/CSK/IRAN,IRANERR,IDD
      COMMON/XLEE/XLEE
      COMMON/CILPT/ILPT
      COMMON/CBAB/SPEBAB
CBAB  COMMON/CHEAD/LPTFIL,SPSFIL,BASFIL,INTFIL
      COMMON/VBAR/IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
     1VBAR,DIAGMIN,TRACE
      COMMON/CHEAD/LPTFIL,SPSFIL,BASFIL,
     1OPFIL(9)
CWEO     1OPFIL(9),NINTZ,SPE_NORM(9),XME_NORM(9),ENLI(MAX_NJL,9),
CWEO     1ENLIN(MAX_NJL,9)
c     COMMON/HEAD/ IVERS,ICASE,NPTCL,IREST,JAY,IMZS,
c
c     Temporary reassignment to see if "HEAD" has problems.....
c     (S.K., 5/20/96)
c
      COMMON/HSK/ IVERS
      common/hska/ ICASE
      common/hskb/ NPTCL
      common/hskc/ IREST
      common/hskd/ JAY
      common/hske/ IMZS
      common/hsk1/IT,ITZS,KPAR,MNFIL(MAX_NJL),MXFIL(MAX_NJL)
      common/hsk2/MXOSC(MAX_NOSC),MNOSC(MAX_NOSC)
      common/hsk3/NOSC,NOSCJL(MAX_NOSC),KTPAR,NINTZ,SPE_NORM(9)
      common/hsk4/XME_NORM(9),ENLI(MAX_NJL,9),ENLIN(MAX_NJL,9)
c     COMMON/HSK/ IVERS,ICASE,NPTCL,IREST,JAY,IMZS,
c    1IT,ITZS,KPAR,MNFIL(MAX_NJL),MXFIL(MAX_NJL),MXOSC(MAX_NOSC),
c    1MNOSC(MAX_NOSC),NOSC,NOSCJL(MAX_NOSC),KTPAR,NINTZ,SPE_NORM(9),
c    1XME_NORM(9),ENLI(MAX_NJL,9),ENLIN(MAX_NJL,9)
CBAB      COMMON/MAT/ EVEC(20100)
      COMMON/MAT/ EVEC(MAX_DIM)
CBAB  COMMON/ORB/ IORB,NIPART,NJTP(110),IPART(N_WORDS,110),EXTRA(2200)
CBAB      COMMON/ORB/ IORB,NIPART,NJTP(MAX_NPART),
CBAB     1IPART(N_WORDS,MAX_NPART),EXTRA(2200)
      COMMON/ORB/ IORB,NIPART,NJTP(MAX_NPART),
     1IPART(N_WORDS,MAX_NPART)
C  IN NEXT TWO LINES (201) WAS ORIGINALLY (20) ... LED TO OVERWRITING
CBAB      COMMON/OUT/ EIGVAL(MAX_VEC+2),SUBM(MAX_VEC,MAX_VEC),ERR(MAX_VEC)
CBAB     1,EXTRA2(300)
      COMMON/OUT/ EIGVAL(MAX_VEC+2)
      COMMON/OUTO/EIGVALO(MAX_VEC+2)
      COMMON/IN/MATDIM,IRSIZE,TOL1,TOL2,NEIG,NOUT,NMX,SIGN
      COMMON/CIN/ORTFIL,ORT2,BIGF,BIGG
      COMMON/CSPE/SHELL(MAX_NJL)
CBAB  COMMON/SPE/NJL,ENL(MAX_NJL),ENLOLD(MAX_NJL),ANSSPE
      CHARACTER*1 ANSSPE
      COMMON/SPE1/ANSSPE
      COMMON/SPE/NJL,ENL(MAX_NJL),DENL(MAX_NJL)
      CHARACTER*1 ANSGND
      COMMON/CGND/GNDFIL,GND2
      COMMON/GND1/ANSGND
      COMMON/GND/IGND,GNDE
      COMMON/FIL / EIGFIL,EIG2,SPEFIL,SPE2
CBAB      COMMON/ITE /NPRE,ITMAX,IWC
      COMMON/ITE /NPRE,IWC
      COMMON/ILOG/ILOG
      COMMON/CRIT/ CRIT,MAX_NST,ITMIN,MAXITER
      COMMON/TIMESK/JEIGEN_TIME,JLANC_TIME,HANDLE
      INCLUDE 'data.inc'
CEKW ****
CEKW      ISUM = 1
CEKW ****
      IF(IFPS.EQ.2) THEN
      OPEN(UNIT=5,FILE='ldat',STATUS='OLD')
      OPEN(UNIT=6,FILE='lwrt',STATUS='NEW')
      ELSE
      END IF
CZ
C                                          START CPU TIMER
      CALL TIMER('START')
C
      CALL TEST_BATCH(ILOG)
 
      NSIZE=5000
C                               MAX_NJL
      NSIZE2=MAX_NJL
C                         MAXIMUM NUMBER OF E-VALUES ASKED FOR
      NSIZE3=MAX_VEC
      NSIZE4=MAX_VEC
CWNC  INTRODUCE NSIZE5 1-DEC-1981
C                         MAXIMUM OF ITERATIONS ALLOWED
      NSIZE5=MAX_VEC
C
      IF (NSIZE*2.GT.NSIZE4**2) STOP 'ERROR: NSIZE*2>NSIZE4**2'
C
C--- ACCEPT VALUES OF CONTROL VARIABLES AND CHECK THEM
C
      WRITE(6,2)
2     FORMAT(
     1/,1X,'ILPT = 1 for formatted *.lpe output; = 0 for no output',
C     1/,1X,'IWC  = 1 for output to Etchegoyens weak coupling program',
C     1/,1X,'ICFN = # of states on *.LPE with partition occupations',
C     1/,1X,'         default is 10 (ICFN=0) and ICFN=-1 for none',
     1/,1X,'IRAN = # for multiplicative factor to added random matix',
     1/,1X,'         in units of keV/10',
C     1//,1X,'Control integers ILPT,IWC,ICFN,IRAN : ')
     1//,1X,'Control integers ILPT,IRAN : ')
 
      CALL FREE_INT(5,3,INT_VAR,READ_ERR)
      ILPT=INT_VAR(1)
C      IWC=INT_VAR(2)
C      ICFN=INT_VAR(3)
      IRAN=INT_VAR(2)
C      ISUM=INT_VAR(5)
      IDD=INT_VAR(3)
      XLEE = 1.
      IF(IDD.EQ.1) print 910
910   FORMAT(1X,'XNORM,LEE_NAME')
      IF(IDD.EQ.1) then
         read*, xlee
         READ(5,911) LEENAME
      endif
911   FORMAT(A)
      IF(IDD.EQ.1) OPEN(UNIT=35,FILE=LEENAME//'.lee',STATUS='NEW')
CWEO      READ(5,5) ILPT,IWC,ICFN,IRAN
CWEO5     FORMAT(10I)
C      IF(ILOG)WRITE(6,460)ILPT,IWC,ICFN,IRAN,IDD
      IF(ILOG)WRITE(6,460)ILPT,IRAN,IDD
460   FORMAT('+',10I4)
        ILAN = 1
      WRITE(6,3)
3     FORMAT(' Matrix filename : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      ORTFIL=CHAR_VAR(1)
CWEO      READ(5,4) ORTFIL
CWEO4     FORMAT(A)
      NPOS=INDEX(ORTFIL,' ')
      ORT2='.mat'
      IF(IWC.EQ.1) ORT2='.maw'
C      IF(IWC) ORT2='.MAW'
      IF(ILOG)WRITE(6,461)ORTFIL(1:NPOS-1),ORT2
461   FORMAT('+',A9,A4)
      EIGFIL=ORTFIL
      LPTFIL=ORTFIL
      GNDFIL=ORTFIL
      ORTF = ORTFIL//ORT2
C
C--- READ FROM .ORT FILE
C
CBAB      CALL OPEN_FILE(1,ORTFIL,ORT2,'OLD','UFRM')
      NAME = ORTFIL(1:index(ortfil,' ')-1)//'.mah'
      IFORM = 1
      CALL OPENGEN(1,AREA_MAT,NAME,IFORM)
      NAME = ORTFIL(1:index(ortfil,' ')-1)//'.mat'
      CALL OPENGEN(11,AREA_MAT,NAME,IFORM)
      READ(1) IVERS,IT,NUMSPS,SPSFIL,OPFIL,BASFIL,REDF,PRJF,
     1  NPTCL,IMZS,ITZS,KPAR,NIPART,NHPART,
     1  MATDIM,(NJTP(I),I=1,NIPART),NJL,(SHELL(I),I=1,NJL),
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),(ENL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1MAXNJT,JLTW,JAY,(NOSCJL(I),I=1,NOSC),
     1NINTZ,(SPE_NORM(IINT),XME_NORM(IINT),IINT=1,NINTZ),
     1((ENLI(I,IINT),I=1,NJL),IINT=1,NINTZ)
CBAB
      IF(MATDIM.EQ.0) GO TO 8889
CBAB
      READ(1)NWORDS,((IPART(J,I),J=1,NWORDS),I=1,NIPART)
 
 
      IF(MATDIM.LE.10) NEIG = MATDIM
      IF(MATDIM.GT.10) NEIG = 10
C      NOUT = NEIG
      NOUT = 10
      NPRE = 3
CBAB DEC 22, 1983 I CHANGED MAX_VEC TO MAX_VEC-1 TO PREVENT
CBAB GOING OUTSIDE ONE OF ARRAYS WHEN THERE ARE MAX_VEC ITERATIONS
CBAB THIS WAS NOT FIXED DIRECTLY BY INCREASING ONE OF THE ARRAYS
CBAB SINCE I DO NOT KNOW EXACTLY WHERE THE PROBLEM IS
      MAXNEIG = MATDIM
      IF(MAXNEIG.GT.(MAX_VEC-1)) MAXNEIG = MAX_VEC-1
 
      CRIT=0.1
      MAXITER = 0
      WRITE(6,405)MAXNEIG,NEIG,NOUT,CRIT
405   FORMAT(1X,'NEIG,NOUT,CRIT,MAXIT:'
     1,/,1X,'NEIG = # of vectors converged and in *.EIG (unformatted)
     1 output',/,1X,7X,'(Max=',I4,',-1 for all)'
     1,/,1X,'NOUT = # of vectors in *.LPE (formatted)
     1 output',/,1X,7X,'(default = 10, -1 for all)'
     1,/,1X,'CRIT = convergence criteria (keV)'
     1,/,1X,'MAXIT = maximum number of interactions (default
     1 determined by CRIT)'
     1,/,1X,'Defaults = ',2I4,3X,F6.2,' : ')
      CALL FREE_REAL(5,8,REAL_VAR,READ_ERR)
CZ      I1=REAL_VAR(1)
      I1=NINT(REAL_VAR(1))
      I2=NINT(REAL_VAR(2))
      XCRIT=REAL_VAR(3)
      MAXITER=NINT(REAL_VAR(4))
      XSHIFT0=REAL_VAR(5)
      XSHIFT2=REAL_VAR(6)
      XSHIFT4=REAL_VAR(7)
      HNORM = REAL_VAR(8)
CWEO      READ(5,510)I1,I2,XCRIT
CWEO510   FORMAT(2I,F)
      IF(I1.GT.0) NEIG = I1
cbab      IF(I1.GT.0.AND.I2.EQ.0) NOUT = I1
      IF(I1.EQ.-1) NEIG = MATDIM
      IF(NEIG.GT.MATDIM) NEIG = MATDIM
      IF(NOUT.GT.MATDIM) NOUT = MATDIM
      IF(I2.GT.0) NOUT = I2
      IF(I2.EQ.-1) NOUT = MATDIM
      IF(NEIG.GT.(MAX_VEC-1)) NEIG = MAX_VEC-1
      IF(NOUT.GT.(MAX_VEC-1)) NOUT = MAX_VEC-1
      IF(XCRIT.NE.0.)THEN
      CRIT=XCRIT/1000.
      ELSE
      XCRIT=CRIT
      CRIT=CRIT/1000.
      END IF
      IF(MAXITER.GT.0.AND.NEIG.GT.MAXITER) NEIG = MAXITER
      IF(MAXITER.GT.0.AND.NOUT.GT.MAXITER) NOUT = MAXITER
      WRITE(6,406)MATDIM,NEIG,NOUT,MAXITER,XCRIT
406   FORMAT(1X,'MATDIM,NEIG,NOUT,MAXIT,CRITERIA = ',4I5,3X,F6.2)
      IF(ILOG)WRITE(6,462)NEIG,NOUT,XCRIT
462   FORMAT('+',2I4,3X,F6.2)
      ILAN=1
 
CBAB      ITMAX=NEIG+20
 
CBAB      IF(ITMAX.GT.MAXB)ITMAX=MAXB-1
CBAB      IF(ITMAX.GT.MATDIM)ITMAX=MATDIM
CBAB      IF(ITMAX.GT.MAX_VEC)ITMAX=MAX_VEC-2
      READ(11)IBAB,IBAB,ENBAB
      IF(ILPT.NE.0)CALL OPEN_FILE(3,LPTFIL,'.lpe','NEW','FORM')
C  GROUND RETURNS GNDFIL=GND STATE FILE NAME (DEFAULT=ORTFIL)
CBAB
8889  CONTINUE
CBAB
      print 7777,gndfil
7777  format(1x,a9)
      CALL GROUND
      IF(NIPART.NE.0) CALL SPECH
        IF(ILAN.NE.1) GO TO 14
C READ IN IDIAGONAL
      DO 10001  IW = 1,MATDIM-1
      READ(11)
C      END DO
10001 CONTINUE
cbab      READ(1) IDIAGONA
      CLOSE (UNIT=1)
      CLOSE (UNIT=11)
14    IF (ILPT.EQ.0) GO TO 15
C      IF (ICFN.EQ.0) ICFN=10
C      IF (ICFN.LT.0) ICFN=0
C                                    PRINT ERROR MESSAGE & STOP
15    IF (NJL.GT.NSIZE2) GO TO 998
C
C
CBAB JULY 2, 1984  THIS FILE IS NOW OPEN BEFORE CALLING "LANC"
CBAB SO THAT ITS SIZE CAN BE DETERMINED IN "LANC" AND FILLED UP
CBAB IN ORDER TO PREVENT A BOMB IN CASE DISK SPACE RUNS OUT
      CALL OPEN_FILE(22,EIGFIL,'.eig','NEW','UFRM')
 
CBAB  BIGF='LANCZOS.TMP'
CBAB  BIGF=EIGFIL//'.TMP'
CBAB  BIGG=EIGFIL//'.TMT'
      BIGF=EIGFIL(1:index(eigfil,' ')-1)//'.ltf'
      BIGG=EIGFIL(1:index(eigfil,' ')-1)//'.ltg'
      IF(MATDIM.EQ.0) CLOSE(UNIT=22,STATUS='DELETE')
      IF(MATDIM.EQ.0) WRITE(6,8888)
      IF(MATDIM.EQ.0) STOP
8888  FORMAT(1X,'Matrix dimension = 0, nothing done')
CBAB        IF(ILAN.EQ.1.AND.MATDIM.GT.1) CALL LANC
        IF(ILAN.EQ.1.AND.MATDIM.GE.1) CALL LANC
      IF(IRANERR.EQ.1) IRAN=1
      IF(IRANERR.EQ.1) CALL LANC
CBAB MARCH 1985
CBAB THIS WAS SET UP BY A ETCHEGOYEN IN FEB 1985 SINCE
CBAB LANC DID NOT WORK WHEN THE MATRIX WAS DIAGONAL
CBAB IT IS NOT USED HERE SINCE IT DOES NOT ALLOW FOR A
CBAB SINGLE-PARTICLE ENERGY CHANGE
CBAB      IF(ILAN.EQ.1.AND.MATDIM.GT.1.AND..NOT.IDIAGONAL) THEN
CBAB      CALL LANC
CBAB      ELSE IF(IDIAGAONAL)THEN
CBAB      CALL DIAGONAL
CBAB      END IF
      IF(MATDIM.EQ.1) EIGVAL(1) = ENBAB+SPEBAB
      IF(MATDIM.EQ.1) EVEC(1) = 1.
      IF(MATDIM.EQ.1) CLOSE(UNIT=13,STATUS='DELETE')
      WRITE(6,36)MATDIM,EIGVAL(1),EIGFIL
36    FORMAT(' MATRIX DIMENSION =',I10/
     1  ' LOWEST EIGENVALUE =',F10.3,2X,'FOR VECTOR ',A9)
      IF (ANSGND.NE.'Y') GOTO 388
      J=1
      DO 38 I=1,NOUT
      IF (EIGVAL(I).LT.EIGVAL(J)) J=I
38    CONTINUE
      GNDE=EIGVAL(J)
388   CALL GROUND
 
C  WRITE TO DISK
      WRITE(22) IVERS,PRJF,MATDIM,NJL,(SHELL(I),I=1,NJL),
     1(ENL(I),I=1,NJL),BASFIL,OPFIL,MATFIL,GNDFIL,
     1GNDE,(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1NEIG,ORTFIL,REDF,(NOSCJL(I),I=1,NOSC),NPTCL,
     1NINTZ,(SPE_NORM(IINT),XME_NORM(IINT),IINT=1,NINTZ),
     1((ENLIN(I,IINT),I=1,NJL),IINT=1,NINTZ),(DENL(I),I=1,NJL)
      WRITE(22) (EIGVAL(I),I=1,NEIG)
374   IF (ILPT.EQ.0) GO TO 390
C
C  HEADER OUTPUTS SPLURGE TO LPT
C
      CALL HEADER
 
      WRITE(3,7000)IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
     1VBAR,DIAGMIN,TRACE
7000  FORMAT(/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS',/,
     11X,I9,' NON ZERO OFF DIAGONAL MATRIX ELEMENTS',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.0001',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.001',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.1',/,
     11X,F12.4,' AVERAGE (V**2)**(1/2) FOR OFF DIAGONAL ME',/,
     11X,F12.4,' MOST NEGATIVE DIAGONAL MATRIX ELEMENT',/,
     11X,E16.8,' TRACE')
 
 
      TRACEB = 0.
      DO 8010 I = 1,NEIG
8010  TRACEB = TRACEB + EIGVALO(I)
      WRITE(3,37) TRACEB,(EIGVALO(I),I=1,NEIG)
      WRITE(6,37) TRACEB,(EIGVALO(I),I=1,NEIG)
37    FORMAT(/1X,'Lowest eigenvalues obtained
CEKW 1 in next to last iteration, trace = ',E16.8,
     1 in penultimate iteration, trace = ',E16.8,
     1/,500(1X,5F10.3/))
      TRACEB = 0.
      EIG1 = EIGVAL(1)
      DO 8011 I = 1,NEIG
8011  TRACEB = TRACEB + EIGVAL(I)
      WRITE(3,47) TRACEB,(EIGVAL(I),I=1,NEIG)
      WRITE(6,47) TRACEB,(EIGVAL(I),I=1,NEIG)
47    FORMAT(/1X,'Lowest eigenvalues obtained
     1 in last iteration, trace = ',E16.8,
     1/,500(1X,5F10.3/))
      WRITE(3,389) GNDE
      WRITE(6,389) GNDE
      IF(XSHIFT0.NE.0.)WRITE(3,8014)XSHIFT0
 8014 FORMAT(/,1X,'A bias of ',f7.3,' was added to all
     1 lowest(N) hw partitions')
      IF(XSHIFT2.NE.0.)WRITE(3,8012)XSHIFT2
 8012 FORMAT(/,1X,'A bias of ',f7.3,' was added to all
     1 (N+2) hw partitions')
      IF(XSHIFT4.NE.0.)WRITE(3,8013)XSHIFT4
 8013 FORMAT(/,1X,'A bias of ',f7.3,' was added to all
     1 (N+4) hw partitions')
389   FORMAT(/,1X,'Eigenvalue of ground state : ',F10.3)
390   DO 39 I=1,NEIG
39    EIGVAL(I)=EIGVAL(I)-GNDE
      WRITE(6,394) (EIGVAL(I),I=1,NEIG)
394   FORMAT(/,1X,'Energy levels : '/500(1X,5F10.3/))
      WRITE(6,241)MAX_NST
241   FORMAT(1X,'# OF ITERATIONS : ',I5)
C  WRITE TO DISK
      WRITE(22) (EIGVAL(I),I=1,NEIG)
CBAB  IF (ICFN.GT.0) WRITE(3,40) (SHELL(I),I=1,NJL)
      IF(IWC.EQ.1) CALL WCDUMP
CWEO      IF(IWC) CALL WCDUMP
 
      PERCENT = 1.
C      PERCENT = 0.
      WRITE(3,440) PERCENT
440   FORMAT(/,1X,'components greater than ',F6.2,'% are printed out')
      WRITE(3,40) (SHELL(I),I=1,NJL)
40    FORMAT(/,1X,'[No. of unpaired nucleons] - Percent occupation
     1 - Partition - Order of orbits',/,2X,8(A7,', '),/,2X,
     28(A7,', '),/,2X,8(A7,', '))
 
C
C  READ BACK EACH EIGENVECTOR FROM LANCZOS.LTF, WRITE IT TO EIGF AND
C  FOR EACH VECTOR WORK OUT THE AVERAGE NO OF PARTICLES IN EACH J-LEVEL
C
CBAB      IF(MATDIM.GT.1)CALL OPEN_FILE(23,EIGFIL,'.LTF','OLD','UFRM')
      IF(MATDIM.GT.1) REWIND(UNIT=24)
 
C  LOOP OVER EIGENVECTORS
      DO 60 NV=1,NEIG
 
CBAB      IF(MATDIM.GT.1)READ(23) DUD,(EVEC(I),I=1,MATDIM)
      IF(MATDIM.GT.1)READ(24) DUD,(EVEC(I),I=1,MATDIM)
      WRITE(22) (EVEC(I),I=1,MATDIM)
C      IF(NV.GT.NOUT) GO TO 60
 
      IF(NIPART.EQ.0) GO TO 8000
CCEKW ****
C      IF(NV.LE.NOUT.AND.NV.NE.1.AND.ISUM.EQ.1)THEN
C      IF(NV.LE.NOUT.AND.NV.NE.1)THEN
C      IF(IHBW(0).EQ.0)WRITE(3,12345)SUMAVN1,SUMAVN2,SUMAVN3
C      IF(IHBW(1).EQ.1)WRITE(3,12346)SUMAVN1,SUMAVN2
C      ENDIF
C12345 FORMAT(/,1X,'PERCENTAGE 0HW, 2HW, 4HW = ',F6.2,
C     1',',F6.2,','F6.2)
C12346 FORMAT(/,1X,'PERCENTAGE 1HW, 3HW = ',F6.2,
C     1',',F6.2)
C      SUMAVN1 = 0.0
C      SUMAVN2 = 0.0
C      SUMAVN3 = 0.0
CCEKW ****
      IF(NV.LE.NOUT) WRITE(3,520) NV,EIGVAL(NV)
520   FORMAT(/,1X,'State',I4,'  (',F8.3,' MeV Excitation )  :  ',/)
      DO 53 I=1,NJL
53    AVNJ(I,NV)=0
C  LOOP OVER PARTITIONS
      JJ=0
      DO 60 III=NIPART,1,-1
      NJT=NJTP(III)
      IF (NJT.EQ.0) GO TO 60
      DO 52 I=NJL,1,-1
      NJ(I) = IPART(I,III)
52    CONTINUE
      AVN=0
C  LOOP OVER STATES WITHIN A PARTITION
      DO 59 JJJ=1,NJT
      JJ=JJ+1
59    AVN=AVN+(EVEC(JJ))**2
C  LOOP OVER J-LEVELS
      DO 592 I=1,NJL
592   AVNJ(I,NV)=AVNJ(I,NV)+AVN*NJ(I)
      AVN=AVN*100
      ISEN = 0
      DO 10002  IW=1,NJL
      ISEN = ISEN + MOD(NJ(IW),2)
10002 CONTINUE
      IF(NV.LE.NOUT.AND.AVN.GT.PERCENT)
     1 WRITE(3,594) ISEN,AVN,(NJ(IW),IW=1,NJL)
594   FORMAT(1X,'[',I2,']',1X,F6.2,1X,15(I2,','),13(I1,','))
 
CEKW ****
C      IF(ISUM.EQ.0)GOTO60
      DO 877 IIH = 0,10
      IF(IHBW(III).EQ.IIH) SUMHBW(NV,IIH+1) = SUMHBW(NV,IIH+1) + AVN
877   CONTINUE
CEKW ****
60    CONTINUE
 
 
 
      IF (ILPT.GT.0) THEN
        WRITE(3,632)
632     FORMAT(1X)
        WRITE(3,62) (SHELL(I),I=1,NJL)
61      FORMAT(1X,'NO',2X,' ENERGY LEVEL',
     1  8X,'AVERAGE NO OF PARTICLES IN EACH J-LEVEL'//)
62     FORMAT(17X,8(A7,1X),/,17X,8(A7,1X),/,17X,8(A7,1X))
        WRITE(3,63) (ENL(I),I=1,NJL)
63    FORMAT(1X,'S-P ENERGY:',3X,8(F8.3),/,15X,8(F8.3),/,
     115X,8(F8.3),/)
        WRITE(3,61)
      DO 905 I = 1,NEIG
905   WRITE(35,906) EIGVAL(I)+GNDE
906   FORMAT(1X,F13.5)

        DO 65 I=1,NEIG
65      WRITE(3,64) I,EIGVAL(I),(AVNJ(J,I),J=1,NJL)
64      FORMAT(I3,F12.3,8F8.3,/,15X,8F8.3,/,15X,8F8.3)
 
      DO 878 I = 1,NEIG
      DO 880 IH = 10,0,-1
      IF(SUMHBW(I,IH+1).NE.0.) GO TO 881
880   CONTINUE
881   IHMAX = IH
878   CONTINUE
      IF(IHMAX.EQ.0) GO TO 883
      write(3,885)eigfil,eig1
  885 FORMAT(/,1X,'file = ',A6,',',1x,'the g.s. energy = ',F10.3)
      WRITE(3,884)(IH,IH=0,IHMAX)
884   FORMAT(/,1X,'HBW decomposition',/,19X,10(I2,6X),/)
      DO 882 I = 1,NEIG
      IF(SUMHBW(I,1).NE.0..OR.SUMHBW(I,2).NE.0.)
     1WRITE(3,879) I,EIGVAL(I),(SUMHBW(I,IH+1),IH=0,IHMAX)
879   FORMAT(I3,F12.3,8F8.3)
882   CONTINUE
883   CONTINUE
 
 
      END IF
8000  CONTINUE
CBAB      CLOSE(UNIT=23,STATUS='DELETE')
      CLOSE(UNIT=24,STATUS='DELETE')
70    CONTINUE
CWEO      CALL TIME_LAN('EIGENH    ',JEIGEN_TIME)
CWEO      CALL TIME_LAN('LANCZOS   ',JLANC_TIME)
      CALL TIMER('STOP')
      WRITE(6,13001)
13001 FORMAT(1X,' ')
      CALL EXIT
970   WRITE(6,975)MATDIM
975   FORMAT(' INCREASE MATRIX DIMENSIONS AND NSIZE BY ',I7)
      STOP
998   WRITE(6,999)NSIZE2,NJL
999   FORMAT(' INCREASE DIMENSION OF AVNJ(,),NJ() AND NSIZE2 FROM',I4,
     1  ' TO',I4)
      STOP
      END
 
 
      SUBROUTINE DIAGONAL
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'lancom.inc'
      CHARACTER*13 ORTF,BIGF,NAME
      CHARACTER*9 MATFIL
      CHARACTER*9 ORTFIL,BIGFIL
      CHARACTER*9 FILE_NAME
      CHARACTER*4 FILE_EXT
      CHARACTER*4 MAT2,BIG2,ORT2
CBAB      COMMON/MAT/ EVEC(20100)
      COMMON/MAT/ EVEC(MAX_DIM)
      COMMON/OUT/ EIGVAL(MAX_VEC+2)
      COMMON/IN/MATDIM,IRSIZE,TOL1,TOL2,NEIG,NOUT
      COMMON/CIN/ORTFIL,ORT2,BIGF
      INCLUDE 'data.inc'
 
C  This subroutine creates a .LTF file. Used  only for diagonal matrices
 
      ORTF=ORTFIL(1:index(ortfil,' ')-1)//'.mat'
CBAB      CALL OPEN_FILE(9,ORTFIL,'.MAT','OLD','UFRM')
      NAME = ORTFIL(1:index(ortfil,' ')-1)//'.mat'
      IFORM = 1
      print*,'LANCZOS: area_mat, name, iform = '
      write(*,'(a)') area_mat,name
      print*,iform
      CALL OPENGEN(9,AREA_MAT,NAME,IFORM)
      CALL NAME_FILE(BIGF,FILE_NAME,FILE_EXT)
CBAB      CALL OPEN_FILE(23,FILE_NAME,FILE_EXT,'NEW','UFRM')
      CALL OPEN_FILE(24,FILE_NAME,FILE_EXT,'NEW','UFRM')
      READ(9)
      READ(9)
 
      DO 10003  IW=1,NOUT
      CALL BLOCK_READ(9,EVEC,MATDIM)
      EIGVAL(IW)=EVEC(IW)
C      END DO
10003 CONTINUE
 
      DO 10004  IW1=1,MATDIM
 
      DO 10005  IW2=1,MATDIM
      EVEC(IW2)=0
      IF(IW2.EQ.IW1)EVEC(IW2)=1.
C      END DO
10005 CONTINUE
 
CBAB      WRITE(23) DUD,(EVEC(I),I=1,MATDIM)
      WRITE(24) DUD,(EVEC(I),I=1,MATDIM)
C      END DO
10004 CONTINUE
CBAB      CLOSE (23)
      CLOSE (9)
      CLOSE (19)
      RETURN
      END
 
 
      SUBROUTINE BLOCK_READ(IDEV,ARRAY,NDIM)
      DIMENSION ARRAY(NDIM)
C  Read in orthogonal matrix <Oi|H|Oj>
      READ(IDEV) ARRAY
      RETURN
      END
 
