C------------------------------------------------------------------------------
C				BADJT
C------------------------------------------------------------------------------
C  SHELL MODEL - FOR SHELL.FOR
C
C  N SETS OF BAD J,T VALUES
C  SET	J1 = -1	TO ASK "BAD J,T VALUES ?"
C	   = -2	TO WRITE OUT BAD J,T VALUES (FOR ELEV-SHELL)
C	   = >0	TO TEST IF J,T BAD:  RETURNS N=-1 IF BAD
C
C
	SUBROUTINE BADJT(N,J1,IT1)
	LOGICAL EMPTY
	DIMENSION JTBAD(3,10),NBAD(3)
	BLANK=' '
	IF (J1.GE.0) GO TO 100
	IF (J1.EQ.-2) GO TO 200
	IF (N.GT.3) STOP 'ERROR: N>3 IN BADJT'
	NBAD(N)=0
1	TYPE 5

5	FORMAT(' Bad J, T values ( <CR> to end ) : ',$)
C*JSW	READ(5,7,ERR=30) SPIN1,SPIN2
	CALL FREEFM(EMPTY,SPIN1,SPIN2,DUMMY)
	IF(EMPTY)RETURN
C*JSW	GO TO 31
C*JSW30	RETURN

CBAB5	FORMAT(' Bad J, T values  (or N for no more) : ',$)
CBAB	READ(5,7,ERR=30) SPIN1,SPIN2
CBAB	GO TO 31
CBAB30	RETURN
7	FORMAT(2F15.0)
31	JAY=SPIN1*2
	ITT=SPIN2*2
	NBAD(N)=NBAD(N)+1
	IF (NBAD(N).GT.10) PAUSE 'ERROR: TOO MANY BAD STATES'
	JTBAD(N,NBAD(N))=JAY*100+ITT
	GO TO 1
C
C
100	IF (NBAD(N).EQ.0) RETURN
	DO 110 I=1,NBAD(N)
	JT=J1*100+IT1
	IF (JTBAD(N,I).EQ.JT) GO TO 115
110	CONTINUE
	RETURN
115	N=-1
	RETURN
C
C
200	IF (NBAD(N).EQ.0) GO TO 220
	DO 210 I=1,NBAD(N)
	JAY=JTBAD(N,I)/100
	ITT=JTBAD(N,I)-JAY*100
	SPIN1=JAY/2.0
	SPIN2=ITT/2.0
	WRITE(21,208) SPIN1,SPIN2
208	FORMAT(1X,2F6.1)
210	CONTINUE
220	WRITE(21,7) BLANK
	RETURN
	END
