      FUNCTION DELV(I1,I2,I3,I4,IJ,IT)
CBAB DELTA FUNCTION INTERACTION
CBAB <I1,I2,IJ,IT| VN(1+AL SIG.SIG) |I3,I4,IJ,IT>
      COMMON/CVDEL/VN,AL,HBWV
      BHBW = SQRT(41.4963/HBWV)
      T = DELY(I1,I2,I3,I4,IJ,IT)
      DELV=T*RV(I1,I2,I3,I4)/(BHBW*BHBW*BHBW)
      RETURN
      END

      FUNCTION SDELV(I1,I2,I3,I4,IJ,IT)
CBAB SURFACE DELTA FUNCTION INTERACTION
CBAB <I1,I2,IJ,IT| VN(1+AL SIG.SIG) |I3,I4,IJ,IT>
      COMMON/INDEX/XL(3,200)
      T = DELY(I1,I2,I3,I4,IJ,IT)
      SDELV=T*PAR(XL(1,I1)+XL(1,I2)+XL(1,I3)+XL(1,I4))
      RETURN
      END

      FUNCTION DELY(I1,I2,I3,I4,IJ,IT)
CBAB THE ANGULAR PART OF THE DELTA FUNCTION INTERACTION
      COMMON/CVDEL/VN,AL,HBWV
      COMMON/INDEX/XL(3,200)
      HJ(XX) = SQRT(2.0*XX+1.0)
      PJ(X,Y,Z)=((2.*X+1.)+PAR(X+Y+Z)*(2.*Y+1.))/(2.*SQRT(Z*(Z+1.)))
      DELY = 0.
      IF(VN.EQ.0.) RETURN
      PI = 3.14159
      XJ = IJ
      XT = IT
      XI1 = I1
      XI2 = I2
      XI3 = I3
      XI4 = I4
      XN1 = XL(1,I1)
      XN2 = XL(1,I2)
      XN3 = XL(1,I3)
      XN4 = XL(1,I4)
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XL3 = XL(2,I3)
      XL4 = XL(2,I4)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      SL = XL1+XL2+XL3+XL4
      SN = XN1+XN2+XN3+XN4
      SP = XJ1+XJ2+XJ3+XJ4
      T = HJ(XJ1)*HJ(XJ2)*HJ(XJ3)*HJ(XJ4)
      T1=4.*(2.*XJ+1.)*SQRT((1.+DELTA(XI1-XI2))*(1.+DELTA(XI3-XI4)))
      T = T*(1.+PAR(SL))/T1
      T = T*CG(XJ1,.5,XJ2,-.5,XJ,0.)*CG(XJ3,.5,XJ4,-.5,XJ,0.)
      IF(XJ) 10,11,10
11    T1 = 0.0
      GO TO 12
10    T1 = (1.0+AL)*(1.0+PAR(XT))*PAR(SP)
      T1 = T1*PJ(XJ1,XJ2,XJ)*PJ(XJ3,XJ4,XJ)
12    T2 = 1.0-AL-2.0*AL*PAR(XL3+XL4+XJ )
      T2 = T2*PAR(XL2+XL4+XJ2-XJ4)
      T3 = XJ+XT+XL3-XL4
      T2 = T2*(1.0-PAR(T3))
      T = (T1+T2)*T*PAR(SL-SP)/(4.*PI)
      DELY=VN*T
      RETURN
      END

      FUNCTION RV(I1,I2,I3,I4)
CBAB THE RADIAL PART OF THE DELTA FUNCTION INTERACTION
CBAB IN UNITS OF 1/B**3
      COMMON/INDEX/XL(3,200)
      G(A,B) = SQRT(DFAC(2.0*A+2.0*B+1.0))/SQRT(FAC(B))
      F(X,Y,Z)=(BINOM(Y,Z)*PAR(Z))/(DFAC(2.*X+2.*Z+1.)*(2.**Z))
      PI = 3.14159
      XNORM = 2.0*SQRT(1./(2.0*PI))
      XN1 = XL(1,I1)-1.0
      XN2 = XL(1,I2)-1.0
      XN3 = XL(1,I3)-1.0
      XN4 = XL(1,I4)-1.0
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XL3 = XL(2,I3)
      XL4 = XL(2,I4)
      IF(PAR(XL1+XL2+XL3+XL4)) 20,20,21
20    RV = 0.0
      RETURN
21    II1 = XN1+1.0
      II2 = XN2 + 1.0
      II3 = XN3 + 1.0
      II4 = XN4 + 1.0
      XX = XL1 + XL2 + XL3 + XL4
      XY = XN1 + XN2 + XN3 + XN4
      S = 0.0
      DO 13 J1 = 1,II1
      XI1 = J1-1
      S1 = F(XL1,XN1,XI1)
      DO 13 J2 = 1,II2
      XI2 = J2-1
      S2 = F(XL2,XN2,XI2)
      DO 13 J3 = 1,II3
      XI3 = J3-1
      S3 = F(XL3,XN3,XI3)
      DO 13 J4 = 1,II4
      XI4 = J4-1
      S4 = F(XL4,XN4,XI4)
      T = S1*S2*S3*S4
      S = S + T*DFAC(XX+2.0*(XI1+XI2+XI3+XI4)+1.0)
13    CONTINUE
      S  = S*G(XL1,XN1)*G(XL2,XN2)*G(XL3,XN3)*G(XL4,XN4)
100   FORMAT(F13.5)
      RV = S/(2.0**((XX+XY)/2.0))
      RV = RV*XNORM
      RETURN
      END

      FUNCTION XMT(IA,IB,IK,IKT)
CBAB XMT IS ALSO IN DENSMH.FOR AND LIBRV.FOR 
CBAB THIS IS THE REDUCED ME: SQRT(4*PI)*<J(IA)|| [Y(IK)*S]^(IKT) ||J(IB)>
      FPI = 4.*3.14159
      XMT = SQRT(FPI)*TYSIG(IA,IB,IK,IKT)/2.
      RETURN
      END

      FUNCTION VPNQQNA(I1,I2,I3,I4,IJ,IV)
      XINT(I1,I2,I3,I4,IJ,IT)=VQQNA(I1,I2,I3,I4,IJ,IT)
      IF(IV.EQ.0) GO TO 22
      IF(IV.EQ.1) GO TO 11
11    CONTINUE
      IT = 1
      VPN = XINT(I1,I2,I3,I4,IJ,IT)
      GO TO 1000
22    IT = 0
      VPN = XINT(I1,I2,I3,I4,IJ,IT)
      IT = 1
      VPN = VPN+XINT(I1,I2,I3,I4,IJ,IT)
      VPN = VPN/2.0
1000  VPNQQNA = VPN
      RETURN
      END

      FUNCTION VQQNA(IA,IB,IC,ID,IJ,IT)
      COMMON/CVHBW/HBWV
      COMMON/CVQQ/VQQN,VQQS,VQQT,VQQTS
      COMMON/INDEX/XL(3,200)
      DIMENSION XX(2)
      IF(HBWV.LE.0..AND.HBW.EQ.0.) TYPE 400
400   FORMAT(1X,'IN FUNCTION VQQNA, DEFAULT HBW = 14. MEV')
      IF(HBWV.LE.0.) HBW = 14.
      IF(HBWV.GT.0.) HBW = HBWV
      IF(IT.EQ.0) XNT = -3.
      IF(IT.EQ.1) XNT = 1.
      XLA = XL(2,IA)
      XLB = XL(2,IB)
      XLC = XL(2,IC)
      XLD = XL(2,ID)
      XJA = XL(3,IA)
      XJB = XL(3,IB)
      XJC = XL(3,IC)
      XJD = XL(3,ID)
      XJ = IJ
      XT = IT
      SUM = 0.
      DO 100 LT = 1,2
      XLT = LT
      X1 = PAR(XJB+XJC+XJ)*SJ(XJA,XJB,XJ,XJD,XJC,XLT)
      X2 = XMT(IA,IC,2,LT)
      X3 = XMT(IB,ID,2,LT)
      XX(LT) = X1*X2*X3
      X4 = VQQN+XNS*VQQS+XNT*VQQT+XNT*XNS*VQQTS
      SUM = SUM + X1*X2*X3*X4
100   CONTINUE
      X5 = ELL(IA,IC,2)*ELL(IB,ID,2)
      X6 = RL(IA,IC,2)*RL(IB,ID,2)
      VQQNA = SUM*X5*X6*(41.4963/HBW)*(41.4963/HBW)
      RETURN
110   CONTINUE
      VQQNA = 0.
      RETURN
      END

      FUNCTION VDEL(I1,I2,I3,I4,IJ,IT)
      COMMON/CVDEL/VN,AL,HBWV
      COMMON/INDEX/XL(3,200)
      ISDV = 0
      IF(HBWV.EQ.0.) ISDV = 1
      IF(ISDV.EQ.0)BHBW = SQRT(41.4963/HBWV)
      T = DELY(I1,I2,I3,I4,IJ,IT)
      IF(ISDV.EQ.0)VDEL=T*RV(I1,I2,I3,I4)/(BHBW*BHBW*BHBW)
      IF(ISDV.EQ.1)VDEL=T*PAR(XL(1,I1)+XL(1,I2)+XL(1,I3)+XL(1,I4))
      RETURN
      END

