C  TO ORDER AN ARRAY NUMERICALLY
C
C  ICNTL =0  ORDERS IARRAY
C       =1    "      "    & SETS UP IORDER 
C       =2    "      "    & ELIMINATES RECURRANCES OF SAME ELEMENT 
C       =3    "      "    &     "          "      AND SETS UP IORDER 
C       =4  CHECKS WHETHER ALREADY ORDERED, RETURNS ICNTL=0 IF ORDERED,
C
C
C
      SUBROUTINE ORDER(IDIM,ICNTL,IARRAY,IORDER) 
      DIMENSION IORDER(*),IARRAY(*) 
      IF (MOD(ICNTL,2).EQ.0) GO TO 8 
      DO 5 I=1,IDIM 
5     IORDER(I)=I 
8     ISWAPT=0 
      DO 20 I=1,IDIM 
      ISWAP=0 
      DO 10 J=1,IDIM-I 
      IF (IARRAY(J+1).GE.IARRAY(J)) GO TO 10 
      ISWAP=1 
      ITEMP=IARRAY(J+1) 
      IARRAY(J+1)=IARRAY(J) 
      IARRAY(J)=ITEMP 
      IF (MOD(ICNTL,2).EQ.0) GO TO 10 
      ITEMP=IORDER(J+1) 
      IORDER(J+1)=IORDER(J) 
      IORDER(J)=ITEMP 
10    CONTINUE 
      IF (ISWAP.EQ.0) GO TO 50 
      ISWAPT=1 
20    CONTINUE 
50    IF (ICNTL.EQ.4) ICNTL=ISWAPT 
      IF (ICNTL.EQ.2) GO TO 60 
      IF (ICNTL.EQ.3) GO TO 60 
      RETURN 
60    IF (IDIM.EQ.1) RETURN 
      N=1 
      DO 65 I=2,IDIM 
      IF (IARRAY(I).EQ.IARRAY(N)) GO TO 65 
      N=N+1 
      IARRAY(N)=IARRAY(I) 
      IF (ICNTL.EQ.2) GO TO 65 
      IORDER(N)=IORDER(I) 
65    CONTINUE 
      IDIM=N 
      RETURN 
      END 
