cbab      SUBROUTINE MAT(IGOOD,IBASIS) 
      SUBROUTINE MAT 
      INCLUDE 'macfor.inc'                
      INCLUDE 'param.inc'                
      INCLUDE 'integer_mat.inc'                
      INCLUDE 'matcom.inc'                
cbab      DIMENSION IBASIS(MAX_NLWRDS,MAX_ARRAY),IGOOD(MAX_ARRAY), 
cbab     1IBAS_TEMP(MAX_NLWRDS,MAX_NJTVEC) 
      COMMON/CDIM/IMAX_ARRAY,IMAX_ARRAY2,IMAX_NJTVEC
      COMMON/CIBAS/IBASIS(MAX_NLWRDS,MAX_ARRAY),IGOOD(MAX_ARRAY2)
      COMMON/IRESTART/IRESTART
      DIMENSION IBAS_TEMP(MAX_NLWRDS,MAX_NJTVEC) 
      REAL COEF_TEMP(MAX_NJTVEC) 
      INCLUDE 'data.inc'                

C  ARRAY is used as follows (example when calculating part no. 4)
C   --------------------------------------------------------------------
C   !III=1    !III=2   !III=3 !         NDIMII              !III=4!   
C   --------------------------------------------------------------------
C                                                            !IGDST
C  first 3 partition good m-scheme basis states stored in first three
C  corresponding boxes. Then, present partition all m-scheme states and
C  lastly present partition good m-scheme basis numbers 
C  ( not the basis states themselves)

      njtx = 0
      jj = 0
      DO 10001  I=1,N_WORDS 
      ZEROP(I)=0 
C      END DO 
10001 CONTINUE    
CZ
      IF(IFPS.EQ.2) WRITE(6,700)
700   FORMAT(1X,'FOR THE CRAY VERSION YOU NEED BOTH THE *.RED FILE
     1 AND A COPY OF IT CALLED *.REZ')
      IF(IFPS.EQ.2) CALL OPEN_FILE(2,PRJFIL,'.rez','OLD','UFRM')
      IF(IFPS.EQ.0) CALL OPEN_FILE(2,PRJFIL,'.red','OLD','UFRM')
CZ
      READ(2) 
      J=NHPART 
      DO 7 I=2,NHPART 
      IF(LIB_EQX(IHPART(1,I),ZEROP(1),N_WORDS))STOP 
     1' ***** FATAL ERROR in MAIN: wrong order in HPART *****'  
      J=J+1 
CA  See that negative partition have J>NHPART
      CALL LIB_ASSIGNX(IHPART(1,I),IHPART(1,J),N_WORDS) 
      DO 10002  IJ=1,NJL 
C                       Change particles(holes) to holes(particles)      
CWEO      IHPART_BYTE(IJ,J)=-IHPART_BYTE(IJ,J)  
      IHPART(IJ,J)=-IHPART(IJ,J)  
C      END DO 
10002 CONTINUE
      IHF(J)=I 
7     CONTINUE 
      NPRT2=1 
1     NPRT2=NPRT2*2 
      IF (NPRT2.LT.NIPRT) GO TO 1 
CA  IBAS1 will always be first place in ARRAY of IBASIS after 
CA  all previous NJT states.
      IBAS1=1 
      IBAS2=0 

C      LOOP OVER ALL PARTITIONS -----------------------
      DO 101 III=NIPART,1,-1  
      II=IORD(III) 
CA  II=First record of partition III
C  READ IN BASIS
      IF(IBAS1+NLWRDS_BLOCK-1-TWELVE.GT.MAX_ARRAY)STOP 
     1 ' ***** FATAL ERROR in MAT: increase MAX_ARRAY *****' 
      IF(IBAS1+NLWRDS_BLOCK-1-TWELVE.GT.IMAX_ARRAY) IMAX_ARRAY =   
     1 IBAS1+NLWRDS_BLOCK-1-TWELVE   
      READ(1,REC=NBLOCK(II)) NDM2II,NJTA,MAXJZ,MAXTZ, 
     1((IBASIS(IW,I),IW=1,NLWRDS),I=IBAS1,IBAS1+NLWRDS_BLOCK-1-TWELVE) 
      NDIMII=NDIMA(II) 
      IF (NDIMII.EQ.0) STOP ' ***** FATAL ERROR in MAT: NDIMII IS  
     1ZERO *****' 
      IF (NDIMII.GT.NLWRDS_BLOCK-TWELVE)THEN 
      NREAD=NBLOCK(II)
      J=NLWRDS_BLOCK-TWELVE 
12    IF(J+IBAS1+NLWRDS_BLOCK-1.GT.MAX_ARRAY)STOP  
     1' ***** FATAL ERROR in MAT: Increase MAX_ARRAY *****'
      IF(J+IBAS1+NLWRDS_BLOCK-1.GT.IMAX_ARRAY) IMAX_ARRAY =   
     1 J+IBAS1+NLWRDS_BLOCK-1   
      NREAD=NREAD+1
      READ(1,REC=NREAD)((IBASIS(IW,I+J),IW=1,NLWRDS), 
     1I=IBAS1,IBAS1+NLWRDS_BLOCK-1) 
      J=J+NLWRDS_BLOCK 
      IF (NDIMII.GT.J) GO TO 12 
      END IF 
CA  NJT = no. of good |JT> vectors for a given partition
      NJT=NJTP(III) 
      IF (NJT.EQ.0) GO TO 101 
      NDIM2=1 
8     NDIM2=NDIM2*2 
      IF (NDIM2.LT.NJT) GO TO 8 
      NJTP2(III)=NDIM2 
      IDEORD(II)=III 
15    IF (III.NE.1) NREAD=NBLOCK(IORD(III-1)) 
CWEO15    IF (III.NE.1) FIND(1,REC=NBLOCK(IORD(III-1))) 
CA IGDST = to properly place no. of good m-scheme vectors after IBASIS
CA         ARRAY. See read(20).
      IGDST=MAX_NLWRDS*(IBAS2+NDIMII) 
      NGOOD=0 
      HSING=0 
CA Get the one body hamiltonian
      NSUM=0 
      CALL LIB_ASSIGNX(IPART(1,II),IDUD(1),N_WORDS) 
      DO 20 I=NJL,1,-1 
CWEO      IF(IDUD_BYTE(I).LT.0)STOP ' ***** FATAL ERROR in MAT: holes in 
      IF(IDUD(I).LT.0)STOP ' ***** FATAL ERROR in MAT: holes in 
     1basis pattern *****' 
C      IDUD_BYTE(I)=-IDUD_BYTE(I)
CWEO      NJ=IDUD_BYTE(I) 
      NJ=IDUD(I) 
      NSUM=NSUM+NJ 
CA  Hsing = Single particle hamiltonian, 
CA  NJ = no. particles in given J-orbit
20    HSING=HSING+NJ*ENL(I) 
      IF(NSUM.NE.NPTCL)THEN 
      WRITE(6,13001)NSUM,NPTCL
13001 FORMAT(1X,'NSUM,NPTCL ',2I10)
      STOP ' ***** FATAL ERROR in MAT: NSUM.NE.NPTCL *****' 
      END IF 
C*JSW : KWIKFL TELLS US WHETHER HOPER CALCN. 
C       HAS BEEN DONE FOR THIS PARTITION
      KWIKFL = 0 
      NKW    = 1 
      IF(OPEN)CLOSE(UNIT=40,STATUS='DELETE') 
      OPEN=.FALSE. 
CWR  READ IN GOOD STATE INFO from .RED file
      IF(IGDST+NJTX.GT.IMAX_ARRAY2) IMAX_ARRAY2 = IGDST+NJTX
      IF(IGDST+NJTX.GT.MAX_ARRAY2)STOP 
     1 ' ***** FATAL ERROR in MAT: increase MAX_ARRAY2 *****' 
      READ(2) NJTX,NXX,(IGOOD(IGDST+I),I=1,NJTX) 
      READ(2) 
CBAB      IF(IGDST+NJTX.GT.MAX_ARRAY)STOP ' ***** FATAL ERROR in MAIN: 
CBAB     1 Increase MAX_ARRAY *****' 
C      LOOP OVER NJT BASIS STATES WITHIN A PARTITION -------
      DO 100 JJJ=1,NJT
CA  COEF0 is present |JT> wfn coefficients as in PROJ.
      IF(NDIMII.GT.MAX_MSCHEME)STOP ' ***** FATAL ERROR in MAT: 
     1 Increase MAX_MSCHEME *****' 
C                              PROJ file, read in |Ojjj> 
      READ(20)NGOOD,          
     1   NDIMII,IGOODX,(COEF0(I),I=1,NDIMII) 
      IF (IGOODX.NE.IGOOD(IGDST+NGOOD)) STOP  
     1' ***** FATAL ERROR in MAT: M-scheme vector no. diff. in .RED and 
     1 .PRJ files *****' 
CA  IGOOD = no. of good m-scheme vector 
CA  (i.e the one used to project from)
      IF (JJJ.NE.NGOOD)THEN 
      WRITE(6,902)JJJ,NGOOD 
902   FORMAT(' ERROR: JJJ,NGOOD : ',2I10) 
      STOP ' ***** FATAL ERROR in MAT *****' 
      END IF 
      IF(IRESTART.EQ.1) CALL READMAT(IERRMAT)
      IF(IRESTART.EQ.1.AND.IERRMAT.EQ.0) GO TO 100  
C  APPLY OPERATOR
2012  KK=0 
CA  -1 in do 71 because of partition = 0
C        Loop over the hamiltonian partitions ---------
      DO 71 KKK=NHPART*2-1,1,-1  
      CALL LIB_ASSIGNX(IHPART(1,KKK),IHPRT(1),N_WORDS) 
      IF(LIB_EQX(IHPRT(1),ZEROP(1),N_WORDS)) GO TO 50 
CA  <2|HPjt|1> so the partition of <2| has to be equal to the sum of the
CA  partitions of H and |1>. <2| is a good m-scheme vector so what we
CA  strictly need are to search over the partitions of these vectors, not
CA  all the m-scheeme vectors. We nevertheless make no distintion because
CA  there would not be any in general.
      DO 10003  IP=1,NJL 
CWEO      IPART2_BYTE(IP)=IPART_BYTE(IP,II)+IHPRT_BYTE(IP) 
      IPART2(IP)=IPART(IP,II)+IHPRT(IP) 
      IF(IPART2(IP).GT.MXFIL(IP).OR.IPART2(IP).LT.MNFIL(IP)) 
     1GOTO 71 
C      END DO 
10003 CONTINUE    
      CALL FINDP 
C                                Partition not found 
      IF (IFINDP.EQ.0)GOTO 71   
C  IFINDP RETURNS POSITION OF IPART2 IN IPRT. 
C  LLL WILL GIVE POSITION OF PARTITION IPART2 WITHIN THE MATRIX
CA  so the matrix is split into blocks, each one for two given partitions
CA  (partition of <2| in x-axis and of <1| in y-axis). That is,
CA  in the vertical direction blocks are ordered according to the 
CA  partition of
CA  |1> in decreasing dimension, whereas in the x-axis they are ordered 
CA  according to LLL (also in decreasing dimension).
      LLL=IDEORD(IFINDP) 
      IF (LLL.EQ.0) GO TO 71 
CA  Calculate only a triangular Hamiltonian matrix, since it is 
CA  hermitian. 
C   Check whether block is above or below the diagonal: 
C   LLL x-axis, III y-axis
      IF (LLL.LT.III) GO TO 71 
CA  INEG = 0  positive hamiltonian partition
CA       = 1  negative hamiltonian partition
CA  used in Hoper to unwrap ijlk
      INEG=0 
      KK2=KKK 
C                                NEGATIVE Hamiltonian partition 
      IF (KKK.GT.NHPART)THEN    
       KK2=IHF(KKK) 
       INEG=1 
      END IF 
CA  NDIMII = Dimension of present partition m-scheme basis
CA  NDIM2  = First 2**N number larger than present partition 
CA           J-scheme basis 
CA           dimension. Used in find subroutines.
CA  NDIM   = Dimension of partition LLL J-scheme basis
CA  NDIM2  = First 2**N number larger than  partition LLL J-scheme basis
CA           dimension
CA  KLOOKP(LLL) starting position in ARRAY of good m-scheme vectors for
CA              partition LLL
CA  IWRITE = No. of present spaces needed for matrix elememts. 
CA           See WRITE(21)
      NDIM=NDIMII 
      NDIM2=NDM2II 
      ILOOK=IBAS1 
      IST=KLOOKP(LLL) 
      IFN=IST+NJTP(LLL)-1 
      IWRITE=NJTP(LLL) 
      NZERO=IWRITE 
      GO TO 51 
C                  We get here is IHPRT=0, diagonal blocks 
50    LLL=III     
      KK2=KKK 
      INEG=0 
      IF(KKK.NE.1)WRITE(6,710)KKK 
710   FORMAT(' ***** INFORMATION from MAT: Diagonal Hamiltonian  
     1partition has KKK = ',I4,' *****') 
      NDIM=NDIMII 
      NDIM2=NDM2II 
      ILOOK=IBAS1 
      IWRITE=NJT 
      IST=1 
      IFN=NJT 
C  See first if statement below do 100 in HOPER to see how good m-scheme
C  basis patterns are found for diagonal matrix blocks. See that these
C  basis states are not stored separetely at this stage but have 
C  to be found out of the complete m-scheme basis set.
      NZERO=NDIM 
CWR
51    CONTINUE 
      IF (NDIMH(KK2).EQ.0) GO TO 57 
      IF (KWIKFL.EQ.1) THEN 
      IF (KKW2(KKK).LT.KKW1(KKK)) GOTO 53 
        DO 10004  K=KKW1(KKK),KKW2(KKK) 
         IF(K.LE.MAX_STORE)THEN 
         COEF(KW1(K)) = COEF(KW1(K))+ VKW(K)*COEF0(KW2(K)) 
CBAB  IF(VKW(K).EQ.0.AND.ME_NORM.NE.0.) 
C*     IF(VKW(K).EQ.0.) 
C*    1print *,' ***** WARNING in MAT: one VKW is zero *****' 
         ELSE 
         IF(K.EQ.MAX_STORE+1)REWIND 40 
         READ(40)KPOS,KPOS1,VKWMAT 
         COEF(KPOS)=COEF(KPOS)+VKWMAT*COEF0(KPOS1) 
         END IF 
C        END DO 
10004   CONTINUE    
53    END IF 
      IF(KWIKFL.EQ.0) THEN 
      IF(KKK.GT.IMAX_NJTVEC) IMAX_NJTVEC = KKK 
         IF(KKK.GT.MAX_NJTVEC)THEN 
        WRITE(6,52)MAX_NJTVEC,KKK 
52      FORMAT(' INCREASE MAX_NJTVEC FROM ',I5, ' TO',I5) 
              CALL EXIT 
         END IF 
C                         STORE ADDRESS OF KWIK ARRAYS 
         KKW1(KKK)=NKW  
         DO 55 IJKL=IVH1(KK2),NDIMH(KK2)+IVH1(KK2)-1 
         IJKLW=IJKLH(IJKL) 
CBAB     VIJKL=ME_NORM*VH(IJKL) 
         VIJKL=VH(IJKL) 
         IF(VIJKL.NE.0.) CALL HOPER(IBASIS,IGOOD) 
55       CONTINUE 
C                             STORE ADDRESS OF KWIK ARRAYS 
         KKW2(KKK)=NKW-1    
CWR
      END IF 

57    IF (LIB_NEX(IHPRT(1),ZEROP(1),N_WORDS)) GO TO 60 

C  Sum one body hamiltonian (hsing) to two body hamiltonian (coef)
56    DO 58 K=1,NJT 
      N=IGOOD(IGDST+K) 
CBAB58 COEF_TEMP(K)=COEF(N)+SPE_NORM*HSING*COEF0(N)
58    COEF_TEMP(K)=COEF(N)+HSING*COEF0(N) 
      DO 10005  IW=1,NJT 
      COEF(IW)=COEF_TEMP(IW) 
C      END DO 
10005 CONTINUE    
C
60    KK=KK+1 
CA  We see below that we need to book IWRITE spaces for the matrix 
CA  in ARRAY for <m2|HPjt|m1> IWRITE is the dimension of partition 
CA  of good |m2> vectors
CWR COPY INTO COLUMN
      INC=0 
      ISTART=KLOOKP(LLL) 
      IF (LIB_EQX(IHPRT(1),ZEROP(1),N_WORDS))ISTART=IBAS1 
      DO 10006  I=1,IWRITE 
      COLUM(ISTART+INC)=COEF(I) 
      INC=INC+1 
C      ENDDO 
10006 CONTINUE    
CWR
CA  Zero matrix elementes
      MZERO=NDIMII 
      IF(LLL.NE.III)MZERO=IWRITE 
      DO 70 I=1,MZERO 
70    COEF(I)=0.0 
C  End of  do loop ove hamiltonian partitions ------------------

71    CONTINUE           
CWR
CWR   WRITE OUT 
      CALL ORTOUT 
CWR
CWR ZERO COLUMN
      DO 10008  I=1,IBAS1+NJT 
      COLUM(I)=0.0 
C      ENDDO 
10008 CONTINUE    
CWR
      IF (NGOOD.GE.NJT) GO TO 104 
C*JSW
C                      quick flag 
         KWIKFL = 1   
C*JSW
C  End of do loop over good JT states for one partition ---------
100   CONTINUE         
104   IF (NGOOD.LT.NJT) WRITE(6,1010)(IPART(IJ,II),IJ=1,N_WORDS),
     1NJT,NGOOD 
1010  FORMAT(' ERROR:IPART1,NJT,NGOOD ',12I11,I7,I7) 
      IF (NGOOD.LT.NJT) STOP ' ***** FATAL ERROR in MAT *****' 
CA  next two do loops store present NJT good m-scheme vectors 
CA  starting at the
CA  first position of IBASIS in ARRAY. Frees NDIM-NGOOD places
      IF(JJ.GT.IMAX_NJTVEC) IMAX_NJTVEC = JJ
      IF(JJ.GT.MAX_NJTVEC) STOP ' ***** FATAL ERROR in MAT: Increase 
     1 MAX_NJTVEC *****' 
      DO 103 JJ=1,NGOOD 
      IF(IMAC.EQ.0) IBAS_TEMP(1,JJ)=IBASIS(1,IGOOD(IGDST+JJ)+IBAS2) 
      IF(IMAC.NE.0)  
     1CALL LIB_ASSIGNX(IBASIS(1,IGOOD(IGDST+JJ)+IBAS2), 
     1IBAS_TEMP(1,JJ),NLWRDS) 
103   CONTINUE 
      DO 10010  JJ=1,NGOOD 
      IF(IMAC.EQ.0) IBASIS(1,(JJ+IBAS2))=IBAS_TEMP(1,JJ) 
      IF(IMAC.NE.0)  
     1CALL LIB_ASSIGNX(IBAS_TEMP(1,JJ),IBASIS(1,(JJ+IBAS2)),NLWRDS) 
C      END DO 
10010 CONTINUE    

      KLOOKP(III)=IBAS1 
      IBAS1=IBAS1+NJT 
      IBAS2=IBAS1-1 
C  end of loop over partitions -----------------------------------
101   CONTINUE 
      KK=1 
      IF(OPEN)CLOSE(UNIT=40,STATUS='DELETE') 
      WRITE(6,110)MATDIM 
110   FORMAT(' MATRIX DIMENSION  =',I6) 
      RETURN 
1000  WRITE(6,1001) 
1001  FORMAT(' INCREASE MAX_ARRAY ') 
      STOP ' ***** FATAL ERROR in MAT *****' 
      END 
