      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'integer_mat.inc'
      INCLUDE 'matcom.inc'
      CHARACTER*9 OPFILE,FILENAME
      CHARACTER NAME*13,NAMEOP*13,LONGNAME*100
      CHARACTER*4 FILEEXT
      logical posexist,longexist
CEKW      REAL SPE_NORMI,ME_NORMI
cbab      INTEGER DUD(N_WORDS),IARRAY(MAX_ARRAY)
      COMMON/CDIM/IMAX_ARRAY,IMAX_ARRAY2,IMAX_NJTVEC
      COMMON/CKDT/KDT,KDTR
      COMMON/IRESTART/IRESTART
      DIMENSION AVE(20)
      INTEGER DUD(N_WORDS)
      INCLUDE 'data.inc'
 
CEKW **** If i11 = 1 then some test output is printed in file for011.dat
      i11 = 0
 
      IF(IFPS.EQ.2) THEN
      OPEN(UNIT=5,FILE='mdat',STATUS='OLD')
      OPEN(UNIT=6,FILE='mwrt',STATUS='NEW')
      ELSE
      END IF
CZ
      CALL TIMER('START')
      OPEN1=.TRUE.
      CALL TEST_BATCH(ILOG)
CWEO11    FORMAT(A)
      WRITE(6,51)
51    FORMAT(' Lineprinter file (0=None,1=<Oi|H|Oj>M.E.,
     12=as 1 plus <m|H|Oj>M.E.),IRESTART,IPRH : ')
      CALL FREE_INT(5,3,INT_VAR,READ_ERR)
      ILPT=INT_VAR(1)
      IRESTART = INT_VAR(2)
      IPRH = INT_VAR(3)
      IF(ILOG)WRITE(6,53)ILPT
53    FORMAT('+',I1)
 
CBAB NINT IS A NEW INPUT PARAMETER ADDED NOV 1984 TO ALLOW MORE
CBAB THAN ONE INTERACTION (*.OP) FILE TO BE READ IN
CBAB THE DEFAULT IS NINT=1 IF NOTHING IS READ
CBAB THE MAX IS 10
      IINT = 0
      WRITE(6,13)
13    FORMAT(' List of up to 9 interactions (*.OP files),
     1 <CR> to end list')
9914  CONTINUE
      IINT = IINT + 1
      WRITE(6,12) IINT
12    FORMAT(' Name of 2-body interaction #',I1,' : ')
CWEO      READ(5,9911)OPFILE
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      OPFILE=CHAR_VAR(1)
      IF(OPFILE.EQ.' ') GO TO 9912
      IF(ILOG)WRITE(6,918)OPFILE
918   FORMAT('+',A9,'.op')
      WRITE(6,18)
18    FORMAT(' One and two body Hamiltonians normalisations (2F) : ')
      CALL FREE_REAL(5,2,REAL_VAR,READ_ERR)
      SPE_NORMI=REAL_VAR(1)
      XME_NORMI=REAL_VAR(2)
CWEO      READ(5,*)SPE_NORMI,ME_NORMI
CWEO9911  FORMAT(A,2F)
      IF(NINT.GT.9) WRITE(6,1500)
      IF(NINT.GT.9) STOP
1500  FORMAT(1X,'No more than 9 inputs are allowed')
      OPFIL(IINT) = OPFILE
      SPE_NORM(IINT) = SPE_NORMI
      XME_NORM(IINT) = XME_NORMI
      IF(SPE_NORM(IINT).EQ.0)SPE_NORM(IINT)=1.
      IF(XME_NORM(IINT).EQ.0)XME_NORM(IINT)=1.
      IF(XME_NORM(IINT).EQ.-10.)XME_NORM(IINT)=0.
      IF(ILOG)WRITE(6,935)SPE_NORM(IINT),XME_NORM(IINT)
935   FORMAT('+',2F9.4)
      GO TO 9914
9912  CONTINUE
      NINT = IINT-1
      IF(NINT.EQ.0) WRITE(6,9915)
9915  FORMAT(1X,'ERROR: no interaction read in')
      IF(NINT.EQ.0) STOP
 
CTEST      DO 16101 IIJ=1,NINT
CTEST16101 WRITE(11,'(1X,I10,2(F10.6,1X))')IIJ,SPE_NORM(IIJ),XME_NORM(IIJ)
 
      WRITE(6,147)
147   FORMAT(' Name of projected-basis : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      PRJFIL=CHAR_VAR(1)
CWEO      READ(5,11) PRJFIL
      NPOS=INDEX(PRJFIL,' ')
      IF(ILOG)WRITE(6,919)PRJFIL(1:NPOS-1)
919   FORMAT('+',A9,'.prj')
      WRITE(6,15)
15    FORMAT(' Name for matrix : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      MATFIL=CHAR_VAR(1)
CWEO      READ(5,11)MATFIL
      IF (MATFIL.EQ.' ')MATFIL=PRJFIL
      NPOS=INDEX(MATFIL,' ')
      IF(ILOG)WRITE(6,920)MATFIL(1:NPOS-1)
920   FORMAT('+',A9,'.mat')
 
      nameop = opfil(1)(1:(index(opfil(1),' ')-1))//'.pos'
      inquire(file=nameop,exist=posexist)
      if (.not.posexist) then
         longname = area_op(1:index(area_op,' ')-1)//'/'//nameop
         inquire(file=longname,exist=longexist)
         if (.not.longexist)
     &       stop 'Rerun OPER to generate .pos file from .int file'
      endif
c//////////////////////////////////////////////////////////////////
c
c       (S.K. 2/4/1993:) The program, to avoid crashes, until
c       I can think of a better way of doing it, requires in the
c       appropriate code below, to extract nhp
c
c               NHP = NNEG_HPARTP
c                   = number of POSITIVE (>0) Hamiltonian partitions
c
c       At the moment it relies on the number of non-negative
c       partitions, but this causes a crash if a zero-value
c       partition is in the file.
c
c*****************************************************************
c
c       So the following code extracts NNEG_HPARTP=NHP which
c       exists in the .pos file generated by OPER.
c
c/////////////////////////////////////////////////////////////////
      if (posexist) then
         open(unit=51,file=nameop,status='old')
      else if (longexist) then
         open(unit=51,file=longname,status='old')
      endif
      read(51,*) nhsk
      close(51)
c/////////////////////////////////////////////////////////////////
c
c       End of new code: the value of nhsk = nhp is taken from the first
c       .pos file.
c
c/////////////////////////////////////////////////////////////////
      DO 1502 IINT = 1,NINT
      IOP=INDEX(OPFIL(IINT),' ')
      IF(IOP.EQ.0)IOP=10
      IOP=IOP-1
CZ
      IF(IFPS.EQ.2) THEN
      NAME=OPFIL(IINT)(1:IOP)//'.o'
      ELSE
      NAME=OPFIL(IINT)(1:IOP)//'.op'
      END IF
CZ
      iintnew = iint+30
      CALL OPENOP(IINTnew,AREA_OP,NAME,1)
C
CBAB  READ(1) INTF,NSPS(1),NHPART,NJL,ENL,SHELL,SPSF(1)
      READ(IINT+30) INTF,NSPS(1),NHPART,NJL,(ENLI(I,IINT),I=1,NJL)
     1,(SHELL(I),I=1,NJL),SPSF(1)
c     print*, 'nhpart = ', nhpart
      if(i11.eq.1)WRITE(11,15100)INTF,(SHELL(I),I=1,NJL),SPSF(1)
15100 FORMAT(1X,13(A9,1X))
CTEST      WRITE(11,'(1X,2(I10,1X))')NSPS(1),NHPART,NJL
CTEST      WRITE(11,'(1X,12(F9.6,1X))')(ENLI(I,IINT),I=1,NJL)
 
      DO 1503 I = 1,NJL
1503  ENL(I) = ENL(I) + SPE_NORM(IINT)*ENLI(I,IINT)
1502  CONTINUE
 
CA  NHPART = NO. OF PARTITIONS OF THE HAMILTONIAN
CA  NHP    = NO. OF NON NEGATIVE PARTITIONS OF THE HAMILTONIAN. NO NEED TO
CA           WORK WITH NEGATIVE PARTITIONS BECAUSE HAMILTONIAN MATRIX IS
CA           SYMMETRIC
CA  NDIMH  = HAMILTONIAN DIMENSION FOR A GIVEN PARTITION
CA  NHA    = DIM OF HIJKL FOR ALL NON NEGATIVE PARTITIONS, I.E. SUM OF NDIMH
      NHPART=(NHPART-1)/2+1
      NHP=NHPART
c     print*, 'nhp    = ', nhp
CA  AT THIS STAGE NHPART IS ALSO THE NUMBER OF NON NEGATIVE PARTITIONS
      if(i11.eq.1)WRITE(11,1235)NHP
 1235 FORMAT(1X,5I5)
c     print*,'Entering first j loop'
c     DO 10001  J=1,NHP
      do 10001 j = 1, nhsk
CBAB  READ(1,ERR=756)DUD,NDIMH(1)
cmh	write(*,*)'1',j
csk      print*,'First read... j = ', j
      READ(31,ERR=756,end=77)NOP_WORDS,(DUD(I),I=1,NOP_WORDS),NDIMH(1),KOUT
csk   print*,'Second read...'
      READ(31)
      if(i11.eq.1)WRITE(11,'(''NOP_WORDS: '',I10,''NDIMH: '',I10)')
     1NOP_WORDS,NDIMH(1)
      IF(NOP_WORDS.GT.N_WORDS) WRITE(6,800)NOP_WORDS,N_WORDS
      IF(NOP_WORDS.GT.N_WORDS) STOP
      IF (NDIMH(1).EQ.0)STOP ' ***** FATAL ERROR in MAIN: Hamiltonian Pa
     1rt.
     1 Dim. is zero (something wrong in OPER) *****'
C      END DO
10001 CONTINUE
csk    print*,'Exited first j loop.'
      read(31)
      GO TO 757

cmh
77	write(*,*)'end of file'
756   CONTINUE
	go to 757
      IF(I11.LE.1)then
      WRITE(6,1234)
      endif
 1234 FORMAT(1X,'Got to the place where a "backspace" is invoked')
      BACKSPACE(31)
 
 757  continue
c     read(31) ! Is this needed? -- test. Moved from above.
      READ(31) NHA,NHPART
c     print*,' nha, nhpart = ', nha, nhpart
      IF(I11.EQ.1)WRITE(11,'(2(I10,1X))')NHA,NHPART
      NHP=NHPART
      IF(NHA.GT.MAX_OPER_ELEMENTS)THEN
      WRITE(6,888)NHA
888   FORMAT(' Increase MAX_OPER_ELEMENTS to = ',I10)
      STOP ' ***** FATAL ERROR in MAIN *****'
      END IF
      IF(NHPART.GT.MAX_NPARTH)THEN
      WRITE(6,889)NHPART
889   FORMAT(' Increase MAX_NPARTH to = ',I10)
      STOP ' ***** FATAL ERROR in MAIN *****'
      END IF
CA  NHPART  = No. of non negative partitions with dimension GT 0
 
CBAB IF THERE IS A SIZE PROBLEM, POSSIBLY THE PROGRAM CAN BE REWRITTEN
CBAB SO THAT "VHI" CAN BE REDUCED TO THE LARGEST VALUE OF NDIMH(J)
      DO 21 IINT = 1,NINT
      IKEEP = 0
      REWIND IINT+30
CA  Now read the operator:
      READ(IINT+30)
      IVH1(1)=1
      IJPRV=0
c     print*,'iint, nhp = ', iint, nhp
      DO 21 J=1,NHP
CBAB  READ(1)(IHPART(I,J),I=1,N_WORDS),NDIMH(J),
C      READ(IINT+30)NOP_WORDS,(IHPART(I,J),I=1,NOP_WORDS),NDIMH(J),
C     1  (IJKLH(IJ),VHI(IJ),IJ=IJPRV+1,IJPRV+NDIMH(J))
      READ(IINT+30)NOP_WORDS,(IHPART(I,J),I=1,NOP_WORDS),NDIMH(J),KOUT
      IF(KOUT.LT.NDIMH(J)/2) GO TO 9002
      GO TO 9003
9002  CONTINUE
      READ(IINT+30) (IKOUT(IK),IJOUT(IK),HOUT(IK),IK=1,KOUT)
      DO 9001 IK = 1,NDIMH(J)
9001  VHI(IJPRV+IK) = 0.
      DO 9000 IK = 1,KOUT
      IJKLH(IJPRV+IKOUT(IK)) = IJOUT(IK)
      IF(IJKLH(IJPRV+IKOUT(IK)).LE.0) print 7777,IINT,IK
      IF(IJKLH(IJPRV+IKOUT(IK)).LE.0) STOP
7777  FORMAT(1X,'A',2I8)
      VHI(IJPRV+IKOUT(IK)) = HOUT(IK)
9000  CONTINUE
      GO TO 9004
9003  CONTINUE
      READ(IINT+30) (IJKLH(IJ),VHI(IJ),IJ=IJPRV+1,IJPRV+NDIMH(J))
      DO 7779 IJ=IJPRV+1,IJPRV+NDIMH(J)
      IF(IJKLH(IJ).LE.0) print 7778,IINT,IJ
      IF(IJKLH(IJ).LE.0) STOP
7778  FORMAT(1X,'B',2I8)
7779  CONTINUE
9004  CONTINUE
CTEST      WRITE(11,'(''NOP_WORDS: '',I10)')NOP_WORDS
CTEST      DO 15200 I=1,NOP_WORDS
CTEST15200 WRITE(11,'(1X,I10)')IHPART(I,J)
CTEST      DO 15201 IJ=IJPRV+1,IJPRV+NDIMH(J)
CTEST15201 WRITE(11,'(1X,I10,E15.7)')IJKLH(IJ),VHI(IJ)
 
      IF(NOP_WORDS.GT.N_WORDS) WRITE(6,800)NOP_WORDS,N_WORDS
      IF(NOP_WORDS.GT.N_WORDS) STOP
800   FORMAT(1X,' **** FATAL ERROR IN MAIN: NOP_WORDS,N_WORDS = ',2I4)
      DO 822 IJ = IJPRV+1,IJPRV+NDIMH(J)
      IKEEP = IKEEP + 1
      XBABAV = XME_NORM(IINT)*VHI(IJ)
      AVE(IINT) = AVE(IINT) + XBABAV*XBABAV
      VH(IJ) = VH(IJ) + XME_NORM(IINT)*VHI(IJ)
CTEST      WRITE(11,'(1X,2(F10.6,1X))')XME_NORM(IINT),VH(IJ)
822   CONTINUE
      IJPRV=IJPRV+NDIMH(J)
      IVH1(J+1)=IVH1(J)+NDIMH(J)
c     print*,'ivh1(',j+1,'), ivh1(',j,'), ndimh = ',
c    & ivh1(j+1), ivh1(j), ndimh(j)
21    CONTINUE
 
      DO 221 IINT = 1,NINT
      XBABAV = SQRT(AVE(IINT)/IKEEP)
      print 222,IINT,IKEEP,XBABAV
  222 FORMAT(1X,I3,1X,I9,1X,F12.8)
  221 CONTINUE
      IF ((J-1).NE.NHPART) GOTO 910
      IF(IVH1(NHP+1).NE.NHA+1)THEN
      WRITE(6,764)NHA,IVH1(NHP+1)-1
764   FORMAT(' NHA,IVH1 =',2I8)
      STOP ' ***** FATAL ERROR in MAIN:IVH1 not properly set up *****'
      END IF
      DO 1510 IINT = 1,NINT
CBAB  CLOSE(UNIT=1)
1510  CLOSE(UNIT=IINT+30)
 
CA ****  OPEN PRJFIL AND BASFIL
 
      NAME = PRJFIL(1:index(prjfil,' ')-1)//'.prj'
      IFORM = 1
      CALL OPENGEN(20,AREA_PROJ,NAME,IFORM)
      READ(20) JAY,IT,NIPART,NSPS(2),SPSF(2),BASFIL,BASF,
     2MATDIM,(NJTP(I),I=1,NIPART)

      IF(IPRH.EQ.1) NAME = PRJFIL(1:index(prjfil,' ')-1)//'.prh'
      IF(IPRH.EQ.1) IFORM = 1
      IF(IPRH.EQ.1) CALL OPENGEN(21,AREA_PROJ,NAME,IFORM)
      IF(IPRH.EQ.1) READ(21) JAY,IT,NIPART,NSPS(2),SPSF(2),BASFIL,BASF,
     2MATDIM,(NJTP(I),I=1,NIPART)

      CALL CHECK_RED
 
CTEST      WRITE(11,'(1X,A9,1X,2(A13,1X))')BASFIL,BASF,SPSF(2)
CTEST      WRITE(11,'(1X,5(I10,1X))')JAY,IT,NSPS(2),NIPART,MATDIM
CTEST      DO 15102 I=1,NIPART
CTEST15102 WRITE(11,'(1X,I10)')NJTP(I)
 
      NIPRT=NIPART
      CALL READBAS
      IPRJ=INDEX(PRJFIL,' ')-1
      REDF=PRJFIL(1:IPRJ)//'.red'
      PRJF=PRJFIL(1:IPRJ)//'.prj'
CA  Remember:
CA  NDIMA (I) = Dimension of basis for I-partition in decreasing order
CA  NBLOCK(I) = First block for partition I
      IMZSA=IABS(IMZS)
      ITZSA=IABS(ITZS)
      IF (ITZSA.GT.IT) GO TO 500
      DO 3010 I=1,NIPART
CA  MAXNJT = MAX NO. OF GOOD JT STATES OF ALL PARTITIONS
      IF (NJTP(I).GT.MAXNJT) MAXNJT=NJTP(I)
3010  CALL LIB_ASSIGNX(IPART(1,I),IPRT(1,I),N_WORDS)
CBAB  OPF=OPFIL//'.OP'
      IPRJ=INDEX(PRJFIL,' ')-1
      PRJF=PRJFIL(1:IPRJ)//'.prj'
      DO 32 I=1,3
      IF (SPSF(I).NE.SPSF(2)) GO TO 520
32    CONTINUE
33    MDIM=MATDIM
      CALL NAME_FILE(SPSF,FILENAME,FILEEXT)
      SPSFIL=FILENAME
CWEO      SPSFIL=SPSF(1:9)
 
      IF(ILPT.GT.0) CALL OPEN_FILE(3,MATFIL,'.mlp','NEW','FORM')
      IF(ILPT.GT.0) CALL TITLE(3)
      IF(ILPT.GT.0) WRITE(3,3510)
3510  FORMAT(/,1X,'OUTPUT OF MATRIX'/)
      IF(ILPT.GT.0) WRITE(3,3511)BASFIL,PRJFIL,OPFIL(1),MATFIL
3511  FORMAT(' M-Scheme Basis Filename       = ',A13,' -  JT-Scheme Basis
     1 Filename =  ',A,/,' M-Scheme Hamiltonian Filename = ',A13,
     1' -  JT-Scheme Matrix Filename = ',A13//)
 
      IF(ILPT.EQ.2)WRITE(3,3512)
3512  FORMAT(' Matrix elements between good m-scheme basis vectors
     1 and '/' JT-scheme orthonormal vectors: '/)
CBAB IMAC>0 WILL RUN ALL MACRO ROUTINES FOR NLWDS
CBAB IMAC=0 WILL RUN SOME FORTRAN ROUTINES FOR NLWRDS
      IF(NSPS(2).LE.IMAC_NSPS) IMAC=0
      IF(NSPS(2).GT.IMAC_NSPS) IMAC=1
 
      CALL ORTOUT
      CALL MAT
 
      WRITE(6,13002) IMAX_ARRAY,IMAX_ARRAY2,IMAX_NJTVEC,KDT,KDTR
13002 FORMAT(
     1/,1X,'IMAX_ARRAY  = ',I10,
     1/,1X,'IMAX_ARRAY2 = ',I10,
     1/,1X,'IMAX_NJTVEC = ',I10,
     1/,1X,'KDT         = ',I10,
     1/,1X,'KDTR        = ',I10,
     1/)
      CALL TIMER('STOP')
      WRITE(6,13001)
13001 FORMAT(/)
CA  Main exit statement
      CALL EXIT
C
500   WRITE(6,505)
505   FORMAT(' ERROR: T LESS THAN TZ')
      STOP ' ***** FATAL ERROR in MAIN *****'
510   CLOSE(UNIT=21)
520   NPOS3=INDEX(SPSF(3)(1:9),' ')
      NPOS2=INDEX(SPSF(2)(1:9),' ')
      NPOS1=INDEX(SPSF(1)(1:9),' ')
      IF(NPOS1.GT.1)NPOS1=NPOS1-1
      IF(NPOS2.GT.1)NPOS2=NPOS2-1
      IF(NPOS3.GT.1)NPOS3=NPOS3-1
      WRITE(6,521)SPSF(3),SPSF(2),SPSF(1)
CWEO      WRITE(6,521)SPSF(3)(1:NPOS1),SPSF(2)(1:NPOS2),
CWEO     1 SPSF(1)(1:NPOS1)
521   FORMAT(' WARNING: DIFFERENT .sps FILES'/
     2 ' For .bas = ',A13,/' For .prj = ',A13
     1,/' For .op = ',A13)
CWEO     2 ' For .BAS = ',A9,'.SPS'/' For .PRJ = ',A9
CWEO     1,'.SPS'/' For .OP = ',A9,'.SPS')
      SPSF(1) = SPSF(3)
      GO TO 33
910   WRITE(6,911)J,NHPART
911   FORMAT(' ERROR: J.NE.NHPART,  J,NHPART',2I5)
      STOP ' ***** FATAL ERROR in MAIN *****'
      END
C  SUBROUTINE TO READ IN A BASIS INF FILE
 
      SUBROUTINE READBAS
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'integer_mat.inc'
      INCLUDE 'matcom.inc'
      INCLUDE 'data.inc'
      NPOS_BAS=INDEX(BASFIL,' ')-1
      CALL OPEN_FILE(2,BASFIL,'.inf','OLD','UFRM')
 
      NREAD=1
      READ(2)SPSF(3),NJL,(SHELL(I),I=1,NJL),NLWRDS,ZERO,IVERS,
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1(NOSCJL(I),I=1,NOSC),NPTCL,IMZS,ITZS,KPAR,NIPART,
     1NSPS(2)
      IF(NIPART.NE.NIPRT) WRITE(6,8888) NIPART,NIPRT
8888  FORMAT(1X,' ***** FATAL ERROR in READBAS:',
     1/,1X,'PROJ and BASIS files dont have same number of
     1 partitions',
     1/,1X,'NIPART, NIPRT = ',2I5)
      IF(NIPART.NE.NIPRT) STOP
      IF(NIPART.GT.MAX_NPART)THEN
      WRITE(6,887)NIPART
887   FORMAT(' Increase MAX_NPART to = ',I10)
      STOP ' ***** FATAL ERROR in READBAS *****'
      END IF
C                                     holds order
      READ(2)(IORD(I),I=1,NIPART)
      READ(2)NWORDS,((IPART(J,I),J=1,NWORDS),I=1,NIPART)
      READ(2)(NDIMA(I),I=1,NIPART)
C                                     first block of partition I
      READ(2)(NBLOCK(I),I=1,NIPART)
      CLOSE(2)
CVAX      OPEN(UNIT=1,FILE=BASFIL(1:NPOS_BAS)//'.BAS',ACCESS='DIRECT',
CVAX     1FORM='UNFORMATTED',STATUS='OLD',ASSOCIATEVARIABLE=NREAD,
CVAX     1READONLY)
      CALL OPEN_BASIS(1,BASFIL,'.bas','OLD',NLWRDS)
      RETURN
      END
