CBAB  THIS IS A GENERAL PROGRAM WHICH MAKES A LIST OF SINGLE-PARTICLE
CBAB  AND TWO-BODY MATRIX ELEMENTS BASED ON FUNCTION "TBME"

      COMMON/CORE/IKC(20),IKCMAX
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CSPE/SPE(20),SPEK(20)
      DIMENSION IK(20)
      DIMENSION INTL(8,1000),VINT(1000)
      CHARACTER*4 KEY
CBAB      CHARACTER*3 KEYO
      CHARACTER*9 PRFIL
      CHARACTER*13 AREA_SPS,AREA_INT,FILE_INT
      COMMON/KEY/KEY
      COMMON/CDELTV/VN,AL,HBWV
      COMMON/INDEX/XL(3,200)

      OPEN(UNIT=5,FILE='SYS$INPUT',STATUS='OLD')
      OPEN(UNIT=6,FILE='SYS$OUTPUT',STATUS='NEW')
      OPEN(UNIT=11,FILE='CORE.DAO',STATUS='NEW')
      IHEAD = 0
      CALL INDEX

      INEWINT = 1
CBAB GENERAL INPUT
CBAB      WRITE(6,800)
CBAB      WRITE(11,800)
CBAB800   FORMAT(
CBAB     1/,1X,'IDJ,IDT,IDP = SPIN,ISOSPIN AND PARITY RANK OR OPERATOR',
CBAB     1/,1X,
CBAB     1/,1X,' KEY   TYPE OF POTENTIAL               IDJ IDP',
CBAB     1/,1X,'----------------------------------------------',
CBAB     1/,1X,' PNC     SCALAR  PARITY-VIOLATION        0   1',
CBAB     1/,1X,'         WITH SYMMETRIC COMMUTATOR',
CBAB     1/,1X,
CBAB     1/,1X,' PNA     SCALAR  PARITY-VIOLATION        0   1',
CBAB     1/,1X,'         WITH ANTI-SYMMETRIC COMMUTATOR',
CBAB     1/,1X,
CBAB     1/,1X,' MEX     TWO-BODY MESON EXCHANGE         1   0',
CBAB     1/,1X,
CBAB     1/,1X,' SCA     SCALAR INTERACTION              0   0',
CBAB     1/,1X,'---------------------------------------------')
CBAB      WRITE(6,801)
CBAB801   FORMAT(/,1X,'IDT,KEY (<CR> TO EXIT):',$)
CBAB      READ(5,802) IDT,KEY
CBAB802   FORMAT(I,A)
CBAB      IF(KEY.EQ.' ') GO TO 820
CBAB      WRITE(11,803) IDT,KEY
CBAB803   FORMAT(/,1X,'INPUT  IDT,KEY =  ',I4,3X,A4)
      KEY = 'SCA'
      IF(KEY.EQ.'PNC') IDJ = 0
      IF(KEY.EQ.'PNC') IDP = 1
      IF(KEY.EQ.'PNA') IDJ = 0
      IF(KEY.EQ.'PNA') IDP = 1
      IF(KEY.EQ.'MEX') IDJ = 1
      IF(KEY.EQ.'MEX') IDP = 0
      IF(KEY.EQ.'SCA') IDJ = 0
      IF(KEY.EQ.'SCA') IDP = 0
CBAB      WRITE(6,330)
CBAB      WRITE(11,330)
CBAB330   FORMAT(/,1X,'IDJ,IDT,IDP
CBAB     1 (SPIN,ISOSPIN, AND PARITY RANK OF OPERATOR)')
CBAB      READ(5,331) IDJ,IDT,IDP
CBAB331   FORMAT(3I)
CBAB      WRITE(11,332) IDJ,IDT,IDP
CBAB332   FORMAT(/,1X,'INPUT = ',3I3)
      XDJ = IDJ
      XDT = IDT
      XDP = IDP

      WRITE(6,200)
      WRITE(11,200)
200   FORMAT(/,1X,'TYPE 0 FOR LIST OF TBME, TYPE 1 FOR ONE TBME')
      READ(5,201) INOP
201   FORMAT(I)
      WRITE(11,202) INOP
202   FORMAT(/,1X,'INPUT = ',I2)
      IF(INOP.EQ.0) WRITE(6,220)
      IF(INOP.EQ.0) WRITE(11,220)

220   FORMAT(/,1X,'NAME FOR .INT FILE (A9) :')
      IF(INOP.EQ.0) READ(5,221) PRFIL
221   FORMAT(A9)
      WRITE(11,222) PRFIL
222   FORMAT(/,1X,'INPUT = ',A9)
CBAB      KEYO = KEY
CBAB      IF(KEYO.EQ.'PNA') KEYO = 'PNC'
CBAB      IF(INOP.EQ.0.AND.PRFIL.NE.' ')
CBAB     1OPEN(UNIT=9,FILE=PRFIL//'.'//KEYO,STATUS='NEW')
      AREA_SPS = 'SHSPS:'
      AREA_INT = 'SHINT:'
      FILE_INT = PRFIL//'.INT'
      IF(INOP.EQ.0.AND.PRFIL.NE.' ') 
     1CALL OPENINT(10,AREA_SPS,AREA_INT,FILE_INT,0,IERR)
      IF(INOP.EQ.0.AND.PRFIL.NE.' ')
     1OPEN(UNIT=9,FILE=PRFIL//'.NEW',STATUS='NEW')

600   CONTINUE
      IF(INOP.EQ.0) GO TO 203
      WRITE(6,204)
      WRITE(11,204)
204   FORMAT(/,1X,'I1,I2,I3,I4,IJ12,IJ34,IT12,IT34')
      READ(5,205) I1,I2,I3,I4,IJ12,IJ34,IT12,IT34
205   FORMAT(10I)
      IF(I1.EQ.0) GO TO 820
      GO TO 206
203   CONTINUE

      WRITE(6,230)
      WRITE(11,230)
230   FORMAT(/,1X,'INDEX OF ORBITS TO BE INCLUDED IN INT FILE')
      READ(5,231) (IK(I),I=1,20)
231   FORMAT(20I)
      IF(IK(1).EQ.0) GO TO 820
      DO 232 I = 1,20
      IF(IK(I).EQ.0) GO TO 233
232   CONTINUE
233   IKMAX = I-1
      WRITE(11,229) (IK(I),I=1,IKMAX)
229   FORMAT(/,1X,'INPUT = ',20I3)
      DO 510 I = 1,IKMAX
      WRITE(6,511) IK(I),XL(1,IK(I)),XL(2,IK(I)),XL(3,IK(I))
      WRITE(11,511) IK(I),XL(1,IK(I)),XL(2,IK(I)),XL(3,IK(I))
511   FORMAT(/,1X,'FOR ORBIT: ',I3,3X,' N,L,J = ',3F5.1)
510   CONTINUE

      WRITE(6,730)
      WRITE(11,730)
730   FORMAT(/,1X,'INDEX OF ORBITS TO BE INCLUDED IN CORE ENERGY')
      READ(5,731) (IKC(I),I=1,20)
731   FORMAT(70I)
      DO 732 I = 1,20
      IF(IKC(I).EQ.0) GO TO 733
732   CONTINUE
733   IKCMAX = I-1
      IF(IKCMAX.LE.0) GO TO 700
      WRITE(11,729) (IKC(I),I=1,IKCMAX)
729   FORMAT(/,1X,'INPUT = ',20I3)
      DO 710 I = 1,IKCMAX
      WRITE(6,711) IKC(I),XL(1,IKC(I)),XL(2,IKC(I)),XL(3,IKC(I))
      WRITE(11,711) IKC(I),XL(1,IKC(I)),XL(2,IKC(I)),XL(3,IKC(I))
711   FORMAT(/,1X,'FOR ORBIT: ',I3,3X,' N,L,J = ',3F5.1)
710   CONTINUE

      CALL READINT(IKMAX)
CBAB SINGLE PARTICLE ENERGIES
      DO 700 I1 = 1,IKMAX
      XJ1 = XL(3,IK(I1))
      SPE(IK(I1)) = COREME(IK(I1)) + SPEK(I1)

CBAB      N1 = XL(1,IK(I1))
CBAB      L1 = XL(2,IK(I1))
CBAB      J1 = 2.*XL(3,IK(I1))
CBAB      N2 = XL(1,IK(I2))
CBAB      L2 = XL(2,IK(I2))
CBAB      J2 = 2.*XL(3,IK(I2))
CBAB      WRITE(9,591) N1,L1,J1,N2,L2,J2,XCORE
CBAB591   FORMAT(6I4,40X,F12.4)

700   CONTINUE

      J=0
      DO 240 L1 = 1,IKMAX
      DO 240 L2 = L1,IKMAX
      DO 240 L3 = 1,IKMAX
      DO 240 L4 = L3,IKMAX
      IF((100*L1+L2).GT.(100*L3+L4)) GO TO 240
      I1 = IK(L1)
      I2 = IK(L2)
      I3 = IK(L3)
      I4 = IK(L4)

206   CONTINUE
      XLL1 = XL(2,I1)
      XLL2 = XL(2,I2)
      XLL3 = XL(2,I3)
      XLL4 = XL(2,I4)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      NM1 = XL(1,I1)
      NM2 = XL(1,I2)
      NM3 = XL(1,I3)
      NM4 = XL(1,I4)
      LL1 = XL(2,I1)
      LL2 = XL(2,I2)
      LL3 = XL(2,I3)
      LL4 = XL(2,I4)
      J1 = 2.*XJ1
      J2 = 2.*XJ2
      J3 = 2.*XJ3
      J4 = 2.*XJ4

      IF(INOP.EQ.1) GO TO 208

      IF(PAR(XLL1+XLL2+XLL3+XLL4).NE.PAR(XDP)) GO TO 240

      J12MIN = 1+IABS(J1-J2)/2
      J34MIN = 1+IABS(J3-J4)/2
      J12MAX = 1+(J1+J2)/2
      J34MAX = 1+(J3+J4)/2
      DO 240 KJ12 = J12MIN,J12MAX
      DO 240 KJ34 = J34MIN,J34MAX
      DO 240 KT12 = 1,2
      DO 240 KT34 = 1,2
      IJ12 = KJ12-1
      IJ34 = KJ34-1
      IT12 = KT12-1
      IT34 = KT34-1
      XJ12 = IJ12
      XJ34 = IJ34
      XT12 = IT12
      XT34 = IT34
      IF(TR(XJ12,XJ34,XDJ).NE.1.) GO TO 240
      IF(TR(XT12,XT34,XDT).NE.1.) GO TO 240

      IF(I1.EQ.I2.AND.PAR(XJ12+XT12).EQ.1.) GO TO 240
      IF(I3.EQ.I4.AND.PAR(XJ34+XT34).EQ.1.) GO TO 240

208   CONTINUE

      Z = TBMEA(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34)

      IF(IHEAD.EQ.0)WRITE(6,246)
      IF(IHEAD.EQ.0)WRITE(11,246)
246   FORMAT(/,1X,'   I1  I2  I3  I4 J12 J34 T12 T34   TBME',/)
      IF(IHEAD.EQ.0) IHEAD = 1
      WRITE(6,210)  I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,Z
      WRITE(11,210) I1,I2,I3,I4,IJ12,IJ34,IT12,IT34,Z
210   FORMAT(1X,8I4,F10.5)
      IF(INOP.EQ.1) GO TO 600
      J=J+1
      INTL(1,J) = I1
      INTL(2,J) = I2
      INTL(3,J) = I3
      INTL(4,J) = I4
      INTL(5,J) = IJ12
      INTL(6,J) = IT12
      INTL(7,J) = IJ34
      INTL(8,J) = IT34
      VINT(J) = Z
280   CONTINUE
240   CONTINUE

      JMAX = J
      IF(INOP.EQ.0)TYPE 300,JMAX
300   FORMAT(/,1X,'NUMBER OF 2-BODY MATRIX ELEMENTS =',I5)

CBAB      CALL LISTRAD

CBAB MAKE *.INT FILE
CBAB      WRITE(9,592) JMAX,(SPE(IK(I)),I=1,IKMAX)
CBAB592   FORMAT(1X,I5,10F9.3)
      DO 852 I = 1,IKMAX
      WRITE(9,590) IK(I),IK(I),IK(I),IK(I),IJDUM,ITDUM,SPEK(IK(I))
852   CONTINUE
      DO 851 I = 1,IKMAX
      WRITE(9,590) IK(I),IK(I),IK(I),IK(I),IJDUM,ITDUM,SPE(IK(I))
851   CONTINUE
592   FORMAT(1X,I5,10F9.3)
      DO 850 I1 = 1,IKMAX
      DO 850 I2 = 1,IKMAX
      X = VBAR(IK(I1),IK(I2))
      WRITE(9,590) IK(I1),IK(I2),IK(I1),IK(I2),IJDUM,ITDUM,X
850   CONTINUE

      IDUM = 0
      DO 810 J = 1,JMAX
      NM1 = XL(1,INTL(1,J))
      LL1 = XL(2,INTL(1,J))
      J1 = 2.*XL(3,INTL(1,J))
      NM2 = XL(1,INTL(2,J))
      LL2 = XL(2,INTL(2,J))
      J2 = 2.*XL(3,INTL(2,J))
      NM3 = XL(1,INTL(3,J))
      LL3 = XL(2,INTL(3,J))
      J3 = 2.*XL(3,INTL(3,J))
      NM4 = XL(1,INTL(4,J))
      LL4 = XL(2,INTL(4,J))
      J4 = 2.*XL(3,INTL(4,J))
      Z = VINT(J)
      IJ12 = INTL(5,J)
      IT12 = INTL(6,J)
      IJ34 = INTL(7,J)
      IT34 = INTL(8,J)
CBAB      WRITE(9,590) NM1,LL1,J1,NM2,LL2,J2,
CBAB     1 NM3,LL3,J3,NM4,LL4,J4,IJ12,IJ34,IT12,IT34,Z
CBAB590   FORMAT(16I4,F12.4)
      WRITE(9,590) INTL(1,J),INTL(2,J),INTL(3,J),INTL(4,J),IJ12,IT12,Z
590   FORMAT(4I3,2X,2I3,F10.4)
810   CONTINUE
      STOP 'The *.PNC files should be left on area SHPNCH:'
820   CONTINUE
      STOP
      END


      FUNCTION COREME(I1)
      COMMON/CORE/IKC(20),IKCMAX
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/INDEX/XL(3,200)

      GS = 0.

      DO 600 ICC = 1,IKCMAX
      IC = IKC(ICC)
      XJ1 = XL(3,I1)
      XJC = XL(3,IC)
      JTMIN = 1
      JTMAX = 2
      XC = 1.
      JMIN = ABS(XJ1-XJC) + 1.
      JMAX = XJ1 + XJC + 1.
      S = 0.

      DO 200 JT = JTMIN,JTMAX
      DO 200 J = JMIN,JMAX
      IJ = J-1
      IT = JT-1
      XJ = IJ
      XT = IT
      XIC = IC
      XI1 = I1
      X = (2.*XJ+1.)*(2.*XT+1.)/((2.*XJ1+1.)*(2.))
      X = X*(1.+DELTA(XIC-XI1))
      XX = TBMEA(IC,I1,IC,I1,IJ,IJ,IT,IT)
CBAB      TYPE 7777,IC,I1,IC,I1,IJ,IT,X,XX,XC
CBAB      WRITE(11,7777)IC,I1,IC,I1,IJ,IT,X,XX,XC
CBAB7777  FORMAT(1X,6I3,3F8.3)
      S = S+X*XX*XC
200   CONTINUE
      GS = S + GS
      
CBAB      WRITE(6,410) I1,IC,S,GS
CBAB      WRITE(11,410) I1,IC,S,GS
CBAB410   FORMAT(1X,'I1,ICORE,COREME,TOTAL COREME = ',2I4,2F10.5)
600   CONTINUE
      COREME = GS

      RETURN
      END


      FUNCTION VBAR(I1,I2)
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/INDEX/XL(3,200)
      VBAR = 0.
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      JTMIN = 1
      JTMAX = 2
      JMIN = ABS(XJ1-XJ2) + 1.
      JMAX = XJ1 + XJ2 + 1.
      S = 0.
      DO 200 JT = JTMIN,JTMAX
      DO 200 J = JMIN,JMAX
      IJ = J-1
      IT = JT-1
      XJ = IJ
      XT = IT
      X1 = (2.*XJ+1.)*(2.*XT+1.)
      X2 = TBMEA(I1,I2,I1,I2,IJ,IJ,IT,IT)
      S = S + X1*X2
200   CONTINUE
      VBAR = S
      RETURN
      END

      FUNCTION TBMEA(I1,I2,I3,I4,IJ12,IJ34,IT12,IT34)
      COMMON/CINT/VINT(200000)
      TBMEA = VINT(IADD(I1,I2,I3,I4,IJ12,IT12))
      RETURN
      END

      SUBROUTINE READINT(IKMAX)
      COMMON/CSPE/SPE(20),SPEK(20)
      COMMON/CINT/VINT(200000)
      READ(10,*) NINT,(SPEK(I),I=1,IKMAX)
      DO 100 I = 1,NINT
      READ(10,*) I1,I2,I3,I4,IJ,IT,V

      ITOT = IADD(I1,I2,I3,I4,IJ,IT)
      VINT(ITOT) = V
      ITOT = IADD(I2,I1,I3,I4,IJ,IT)
      VINT(ITOT) = PHASE(I2,I1,IJ,IT)*V
      ITOT = IADD(I1,I2,I4,I3,IJ,IT)
      VINT(ITOT) = PHASE(I3,I4,IJ,IT)*V
      ITOT = IADD(I2,I1,I4,I3,IJ,IT)
      VINT(ITOT) = PHASE(I1,I2,IJ,IT)*PHASE(I3,I4,IJ,IT)*V

      ITOT = IADD(I3,I4,I1,I2,IJ,IT)
      VINT(ITOT) = V
      ITOT = IADD(I4,I3,I1,I2,IJ,IT)
      VINT(ITOT) = PHASE(I3,I4,IJ,IT)*V
      ITOT = IADD(I3,I4,I2,I1,IJ,IT)
      VINT(ITOT) = PHASE(I1,I2,IJ,IT)*V
      ITOT = IADD(I4,I3,I2,I1,IJ,IT)
      VINT(ITOT) = PHASE(I1,I2,IJ,IT)*PHASE(I3,I4,IJ,IT)*V

100   CONTINUE
      RETURN
      END

      FUNCTION PHASE(I1,I2,IJ,IT)
      COMMON/INDEX/XL(3,200)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ = IJ
      XT = IT
      PHASE = PAR(XJ1+XJ2-XJ-XT)
      RETURN
      END

      FUNCTION IADD(I1,I2,I3,I4,IJ,IT)
      IADD = 100000*IT+10000*IJ+1000*I4+100*I3+10*I2+I1
      RETURN
      END
