*  This program generate a matrix nxn
*  using GOA distribution


	dimension a(1000,1000)

        external fg

      open(unit=10,file='goa.dao',status='new')
        iseed=456123789

        write(*,*)'enter n (matrix dimension)'
        read(*,*)n

        si1=1./sqrt(float(n))
        si2=si1*sqrt(2.0)
        write(*,*)si1,si2

        write(*,*)' dia'

        do i=1,n
        x0=0.0
        r=ran(iseed)
        call seq(fg,r,si2,x0)
        a(i,i)=x0
      write(10,100) i,i,a(i,i)
100   format(1x,2i4,f9.5)
        enddo

        write(*,*)' ndia'

        do 1 i=2,n
        do 1 j=1,i-1
        x0=0.0
        r=ran(iseed)
        call seq(fg,r,si1,x0)
        a(i,j)=x0
        a(j,i)=a(i,j)
      write(10,100) i,j,a(i,j)
1       continue

	end



        subroutine seq(f,r,si,x0)
        eps=1.e-4
        h=0.05
        h2=0.5/h
2       continue
        x1=x0-h
        x3=x0+h
        f1=f(x1,si)
        f2=f(x0,si)
        f3=f(x3,si)
        fp=(f3-f1)*h2
        dx=(f2-r)/fp
        if(abs(dx).lt.eps)go to 1
        x0=x0-dx
        go to 2
1       continue
        return
        end


        function fg(x,si)
        xf=6.0*si
        if(x.lt.-xf)then
        fg=0.0
        return
        endif
        if(x.gt.xf)then
        fg=1.0
        return
        endif
        si2=si*si
        si22=0.5/si2
        an=sqrt(6.283185*si2)
        an=1.0/an
        xi=-x
        ni=200
        dx=(xf-xi)/ni
        dx3=dx/3.0
        t3=dx3
        s=0.0
        y=xi-dx
        do i=1,ni+1
        y=y+dx
        s=s+t3*exp(-y*y*si22)
        t3=dx+dx3
        dx3=-dx3
        enddo
        fg=s*an
        return
        end

