CBAB OCT 1992  - a more general version is now built into SHINTH:VN
C  OXBASH SHELL MODEL PROGRAMS
C
C
C  TO CALCULATE HAMILTONIAN OPERATOR FOR
C  SPURIOUS CENTRE OF MASS MOTION
C
C  MODIFIED NJE and AE  3/12/80
C  TO ALLOW ANY CORE
C
C
      INCLUDE 'HCMCOM.INC'
      CHARACTER *13 SPSF,INTF
      CHARACTER *9 SPSFIL,INTFIL,CHAR_VAR(30)
      CHARACTER *6 SHELL
      CHARACTER *4 SPS2,INT2
      REAL REAL_VAR(30)
      DOUBLE PRECISION COEF9,W
CBAB  PARAMETER N_WORDS=2,MAX_NJL=4*N_WORDS,MAX_NOSC=2
      EQUIVALENCE (SPSF,SPSFIL),(INTF,INTFIL)
      DIMENSION NPJ(MAX_NJL),NQ(MAX_NJL),LQ(0:MAX_NJL),NTQ(0:MAX_NJL),
     1JTW(MAX_NJL),MNFIL(MAX_NJL),MXFIL(MAX_NJL),MXOSC(MAX_NOSC),
     2MNOSC(MAX_NOSC),NOSCJL(MAX_NOSC),SHELL(MAX_NJL),ENL(MAX_NJL)
      DIMENSION KUON(6),KUOL(6),KUOJ(6)
      COMMON/FIL/ SPSFIL,SPS2,INTFIL,INT2
      LOGICAL EXIST
C
      IPHASE(N)=1-2*IABS(N-2*(N/2))
C
      WRITE(*,1)
    1 FORMAT(/' WARNING:'/' This program uses the integer N of N,L,J '
     1' The .SPS file must contain'/' the correct values.
     1OPER runs are independent of N. ',/)
      TYPE 2
    2 FORMAT(' Single-particle state file : ',$)
      READ(*,3) SPSFIL
    3 FORMAT(A)
    4 TYPE 5
    5 FORMAT(' Output filename for the interaction : ',$)
        ACCEPT 6, LONG,INTFIL
    6 FORMAT(Q,A)
      TYPE 8
    8 FORMAT(' Write zero M.E.S.? <CR>=Y: ',$)
      ACCEPT 9, ANSZ
    9 FORMAT(A1)
      IF(ANSZ.EQ.' ')ANSZ='Y'
C
C  OPEN SPS FILE
C
      SPS2='.SPS'
      CALL OPENSPS(1,SPSF,0)
C
C  READ NO OF SP STATES ,NO OF J LEVELS, MAX NO OF
C  PARTICLES IN EACH LEVEL.
C
      READ(1,*) NSPS,NJL,(NPJ(I),I=1,NJL),NOSC,(NOSCJL(I),I=1,NOSC)
      NSPS=IABS(NSPS)
      IF(NJL.GT.MAX_NJL)  STOP ' ***** FATAL ERROR: NJL>MAX_NJL *****'
      IF(NOSC.GT.MAX_NOSC)STOP ' **** FATAL ERROR: NOSC>MAX_NOSC ****'
      CALL FREE_REAL_A(1,NJL,CHAR_VAR,0,REAL_VAR,READ_ERR)
      DO 7 I = 1,NJL
    7 SHELL(I) = CHAR_VAR(I)
      DO 10 I=1,NJL
      READ(1,*) NON,NQ(I),LQ(I),JTW(I)
      NTQ(I)=2*(NQ(I)-1)+LQ(I)
      JTW(I)=IABS(JTW(I))
      DO 10 J=1,NPJ(I)-1
      READ(1,*)
   10 CONTINUE
      CLOSE(UNIT=1)
C
C  MAKE UP SINGLE-PARTICLE ENERGIES  FOR CORE
C  READ IN CORE ORBITALS
C
401     WRITE(*,400)
400     FORMAT(' Number of orbitals in the core (99 for help): ',$)
        READ(*,402) NORB
402     FORMAT(I)
        IF(NORB.EQ.99) GOTO 410
        GO TO 403
410     WRITE(*,404)
404     FORMAT(' NO-CORE=0,4HE=1,12C=2,16O=3,28SI=4,32S=5,40CA=6',/)
        GOTO 401
403     IF(NORB.LE.6) GOTO 405
        WRITE(5,406)
406     FORMAT(' NORB>6 NOT ALLOWED ',/)
        GOTO 401
405     KUON(1)=0
        KUON(2)=1
        KUON(3)=1
        KUON(4)=2
        KUON(5)=2
        KUON(6)=2
        KUOL(1)=0
        KUOL(2)=1
        KUOL(3)=1
        KUOL(4)=2
        KUOL(5)=0
        KUOL(6)=2
        KUOJ(1)=1
        KUOJ(2)=3
        KUOJ(3)=1
        KUOJ(4)=5
        KUOJ(5)=1
        KUOJ(6)=3
        JL2=0
        JL3=0
        IRET=1
C
C  LOOP OVER J LEVELS
C
        DO 50 JL1=1,NJL
        JL4=JL1
        J1=JTW(JL1)
        J4=JTW(JL4)
        L1TW=2*LQ(JL1)
        L4TW=2*LQ(JL4)
C
C  LOOP OVER J,T COUPLING
C
        ESUM=0.0
        IF(NORB.EQ.0) GO TO 411
        DO 407 NRUN=1,NORB
        NTQ(0)=KUON(NRUN)
        LQ(0)=KUOL(NRUN)
        J2=KUOJ(NRUN)
        J3=J2
        L2TW=2*LQ(0)
        L3TW=L2TW
        JMIN=IABS(J1-J2)
        JMAX=J1+J2
        IF (JMIN.GT.JMAX) GO TO 50
        DO 45 JJ=JMIN,JMAX,2
        DO 45 IT=0,2,2
        GO TO 180
C
40      CONTINUE
        ESUM=ESUM+(JJ+1)*(IT+1)*IPHASE((J3+J4-JJ+2-IT)/2)*V
C
45      CONTINUE
407     CONTINUE
411     CONTINUE
50      ENL(JL1)=NTQ(JL1)+ESUM/(2*(J1+1))
C
C  OPEN INTERACTION FILE
C
        INT2='.TMP'
        OPEN(UNIT=1,FILE=INTF,STATUS='NEW',DISPOSE='DELETE')
        WRITE(1,60) NMAT,IPAR,(ENL(I),I=1,NJL)
60      FORMAT(2(I3,','),8(F12.8,','))
C
C  CALC 2-BODY M.E.'S
C
C  LOOP OVER ALL J-LEVELS AND J,T COUPLING
C
        IRET=2
        ICOUNT=0
        DO 100 JL1=1,NJL
        J1=JTW(JL1)
        L1TW=2*LQ(JL1)
        DO 100 JL2=1,JL1
        J2=JTW(JL2)
        L2TW=2*LQ(JL2)
        DO 100 JL4=1,JL1
        J4=JTW(JL4)
        L4TW=2*LQ(JL4)
        DO 100 JL3=1,JL4
        J3=JTW(JL3)
        L3TW=2*LQ(JL3)
        IF (JL1.EQ.JL4.AND.JL2.LT.JL3) GO TO 100
        IF (MOD(L1TW+L2TW+L3TW+L4TW,4).NE.0) GO TO 100
        JMIN=MAX0(IABS(J1-J2),IABS(J3-J4))
        JMAX=MIN0(J1+J2,J3+J4)
        IF (JMIN.GT.JMAX) GO TO 100
        DO 75 JJ=JMIN,JMAX,2
        DO 75 IT=0,2,2
        IF ((JL1.EQ.JL2.OR.JL3.EQ.JL4).AND.MOD(JJ+IT,4).EQ.0) GO TO 75
        GO TO 180
C
70      ICOUNT=ICOUNT+1
        IF (ANSZ.NE.'Y'.AND.V.EQ.0.0) GO TO 75
        ICNZ=ICNZ+1
        JAY=JJ/2
        ITEE=IT/2
C
C  USE STANDARD ORDERING
C
        V=V*IPHASE((J3+J4-JJ+2-IT)/2)
        WRITE(1,72) NQ(JL1),LQ(JL1),JTW(JL1),
     1       NQ(JL2),LQ(JL2),JTW(JL2),
     1       NQ(JL4),LQ(JL4),JTW(JL4),
     1       NQ(JL3),LQ(JL3),JTW(JL3),JAY,ITEE,V
72      FORMAT(14I4,F16.8)
75      CONTINUE
100     CONTINUE
        TYPE 120, ICNZ,ICOUNT
120     FORMAT(' MATRIX ELEMENTS WRITTEN TO DISK',I5,/
     1,' CALCULATED',I5)
C  Now rewrite interaction file in proper format
        CALL INTER(SHELL,SPSFIL,INTFIL,ICNZ)
        CLOSE (1)
        CALL EXIT
C
C
C
C  CALC 2-BODY M.E. HERE
C
C
C  FIRST TEST IF HCM=0
C
180     V=0.0
        ITERM1=0
        ITERM2=0
        IF (NTQ(JL1)-NTQ(JL3).EQ.1
     1       .AND.NTQ(JL4)-NTQ(JL2).EQ.1
     2       .AND.IABS(LQ(JL1)-LQ(JL3)).EQ.1
     3       .AND.IABS(LQ(JL2)-LQ(JL4)).EQ.1
     4       .AND.IABS(J1-J3).LE.2
     5       .AND.IABS(J2-J4).LE.2) ITERM1=1
        IF (NTQ(JL1)-NTQ(JL4).EQ.1
     1       .AND.NTQ(JL3)-NTQ(JL2).EQ.1
     2       .AND.IABS(LQ(JL1)-LQ(JL4)).EQ.1
     3       .AND.IABS(LQ(JL2)-LQ(JL3)).EQ.1
     4       .AND.IABS(J1-J4).LE.2
     5       .AND.IABS(J2-J3).LE.2) ITERM2=1
        IF (ITERM1+ITERM2.EQ.0) GO TO 250
        IDEL12=0
        IDEL34=0
        IF (JL1.EQ.JL2) IDEL12=1
        IF (JL3.EQ.JL4) IDEL34=1
        OUTER=SQRT(((J1+1.0)*(J2+1)*(J3+1)*(J4+1))/
     1       ((1+IDEL12)*(1+IDEL34)))
        IF (ITERM1.EQ.0) GO TO 185
        TERM1=ADAG(NTQ(JL1),LQ(JL1),NTQ(JL3),LQ(JL3))
     1       *ADAG(NTQ(JL4),LQ(JL4),NTQ(JL2),LQ(JL2))
     2       *OUTER
185     IF (ITERM2.EQ.0) GO TO 188
        TERM2=ADAG(NTQ(JL1),LQ(JL1),NTQ(JL4),LQ(JL4))
     1       *ADAG(NTQ(JL3),LQ(JL3),NTQ(JL2),LQ(JL2))
     2       *OUTER
188     SUM=0.0
C
        DO 200 IS=0,2,2
        LMIN=MAX0(IABS(L1TW-L2TW),IABS(L3TW-L4TW),IABS(JJ-IS))
        LMAX=MIN0(L1TW+L2TW,L3TW+L4TW,JJ+IS)
        IF (LMIN.GT.LMAX) GO TO 200
        DO 200 LLTW=LMIN,LMAX,2
        SUMFAC=(LLTW+1)*(IS+1)
     1       *COEF9(L1TW,1,J1,L2TW,1,J2,LLTW,IS,JJ)
     2       *COEF9(L3TW,1,J3,L4TW,1,J4,LLTW,IS,JJ)
        IF (ITERM1.GT.0) SUM=SUM
     1 +SUMFAC*W(L1TW,L2TW,L3TW,L4TW,LLTW,2)*TERM1
     2       *IPHASE((LLTW+L1TW+L4TW)/2)
        IF (ITERM2.GT.0) SUM=SUM
     1 +SUMFAC*W(L1TW,L2TW,L4TW,L3TW,LLTW,2)*TERM2
     2       *IPHASE((L1TW+L4TW+IS+IT)/2+1)
200     CONTINUE
        V=SUM
250     IF (IRET.EQ.1) GO TO 40
        IF (IRET.EQ.2) GO TO 70
        STOP 'MISTAKE'
        END
C
C
C  REDUCED M.E. OF A+
C
        FUNCTION ADAG(N1,L1,N2,L2)
        ADAG=0.0
        IF (L1.EQ.L2+1) ADAG=SQRT(L1*(N2+L2+3.0))
        IF (L1.EQ.L2-1) ADAG=SQRT(L2*(N2-L2+2.0))
        RETURN
        END
 
 
 
 
 
 
 
 
 
C  Subroutine to write interaction file in new format, as used by shell
C  model code
      SUBROUTINE INTER(SHELL,SPSFIL,INTFIL,NMAT)
      INCLUDE 'HCMCOM.INC'
CBAB    PARAMETER N_WORDS=2,MAX_NJL=4*N_WORDS
      CHARACTER *9 INTFIL,SPSFIL,CHAR_VAR(30)
      CHARACTER *6 SHELL(MAX_NJL)
      REAL REAL_VAR(30)
      DIMENSION NPJ(MAX_NJL),IORDER(MAX_NJL),INTORDER(4),ID(MAX_NJL)
     1,NPOSV(MAX_NJL),ENL(MAX_NJL)
      CALL OPENSPS(10,SPSFIL//'.SPS',0)
      READ(10,*)IDUD,NJL,(NPJ(I),I=1,NJL)
      CALL FREE_REAL_A(10,NJL,CHAR_VAR,0,REAL_VAR,READ_ERR)
      DO 1 I = 1,NJL
    1 SHELL(I) = CHAR_VAR(I)
        DO I=1,NJL
        DO J=1,NPJ(I)
        READ(10,*)IDUD,N,L,JJ
        END DO
        IORDER(I)=JJ+100*L+10**4*N
        END DO
        CLOSE(10)
        OPEN(2,FILE=INTFIL//'.INT',STATUS='NEW')
        DO I=1,NJL
        NPOS=INDEX(SHELL(I),' ')
        NPOSV(I)=NPOS
        ID(I)=I
        END DO
        WRITE(2,505)(ID(I),SHELL(I)(1:NPOSV(I)),I=1,NJL)
505     FORMAT(<NJL>(' ! ORDER IS: ',6(I2,'=',A,2X)/))
        REWIND 1
        READ(1,*)IDUD,IDUD,(ENL(I),I=1,NJL)
        WRITE(2,506)NMAT,(ENL(I),I=1,NJL)
506     FORMAT(I6,<NJL>(F6.3,','))
        N=0
  199 N=N+1
      READ(1,*,END=205)IN,IL,IJ,JN,JL,JJ,KN,KL,KJ,LN,LL,LJ,JT,IT,V
      INTORDER(1)=IJ+100*IL+10000*IN
      INTORDER(2)=JJ+100*JL+10000*JN
      INTORDER(3)=KJ+100*KL+10000*KN
      INTORDER(4)=LJ+100*LL+10000*LN
      DO IO=1,NJL
      IF(INTORDER(1).EQ.IORDER(IO))GO TO 200
      END DO
      STOP 'IO'
  200 DO JO=1,NJL
      IF(INTORDER(2).EQ.IORDER(JO))GO TO 201
      END DO
      STOP 'JO'
  201 DO KO=1,NJL
      IF(INTORDER(3).EQ.IORDER(KO))GO TO 202
      END DO
      STOP 'KO'
  202 DO LO=1,NJL
      IF(INTORDER(4).EQ.IORDER(LO))GO TO 203
      END DO
      STOP 'LO'
  203 WRITE(2,204)IO,JO,KO,LO,JT,IT,V
  204 FORMAT(4I4,5X,2I4,F)
      GO TO 199
  205 N=N-1
      IF(N.NE.NMAT)TYPE 206,N,NMAT
  206 FORMAT(' ERROR: N.NE.NMAT = ',2I)
      RETURN
      END
