C  This one reads an .INT file written in the old OXBASH format (N,L,J)
C  and creates a new .INT file in the new format, i.e. assigning an integer
C  to each J-orbit. It writes this new .INT file with the same name but with
C  extension .NIN
      INCLUDE 'INTERCOM.INC'
CBAB	PARAMETER N_WORDS=2,MAX_NJL=N_WORDS*4
	CHARACTER *9 INTFIL,SPSFIL,SHELL(MAX_NJL)
	DIMENSION NPJ(MAX_NJL),IORDER(MAX_NJL),INTORDER(4),ID(MAX_NJL)
	1,NPOSV(MAX_NJL),ENL(MAX_NJL)
	TYPE 100
100	FORMAT(' INTERACTION FILENAME = ',$)
	READ(*,110)INTFIL
110	FORMAT(10A)
	TYPE 120
120	FORMAT(' .SPS FILENAME = ',$)
	READ(*,110)SPSFIL
CBAB	OPEN(1,FILE=SPSFIL//'.SPS',STATUS='OLD',READONLY)
	OPEN(1,FILE=AREA_SPS//SPSFIL//'.SPS',STATUS='OLD',READONLY)
      CALL OPENSPS(1,SPSFIL//'.SPS',0)
	READ(1,*)IDUD,NJL,(NPJ(I),I=1,NJL)
	READ(1,110)(SHELL(I),I=1,NJL)
	DO I=1,NJL
	DO J=1,NPJ(I)
	READ(1,*)IDUD,N,L,JJ
	END DO
	IORDER(I)=JJ+100*L+10**4*N
	END DO
	CLOSE(1)
CBAB	OPEN(2,FILE=INTFIL//'.NIN',STATUS='NEW')
      OPEN(2,FILE=AREA_SPS//INTFIL//'.NIN',STATUS='NEW')
	DO I=1,NJL
	NPOS=INDEX(SHELL(I),' ')
	NPOSV(I)=NPOS
	ID(I)=I
	END DO
	WRITE(2,505)(ID(I),SHELL(I)(1:NPOSV(I)),I=1,NJL)
505	FORMAT(' ORDER IS: ',<NJL>(I2,' = ',A,2X))
CBAB	OPEN(1,FILE=INTFIL//'.INT',STATUS='OLD',READONLY)
C	OPEN(1,FILE='SHINTO:'//INTFIL//'.INT',STATUS='OLD',READONLY)
      CALL OPENINT(1,AREA_SPS,AREA_INT,INTFIL//'.INT',0,IERR)
	READ(1,*)NMAT,IDUD,(ENL(I),I=1,NJL)
	WRITE(2,506)NMAT,(ENL(I),I=1,NJL)
506	FORMAT(I6,<NJL>F)
	N=0
204	N=N+1
	READ(1,*,END=7)IN,IL,IJ,JN,JL,JJ,KN,KL,KJ,LN,LL,LJ,JT,IT,V	
	INTORDER(1)=IJ+100*IL+10000*IN
	INTORDER(2)=JJ+100*JL+10000*JN
	INTORDER(3)=KJ+100*KL+10000*KN
	INTORDER(4)=LJ+100*LL+10000*LN
	DO IO=1,NJL
	IF(INTORDER(1).EQ.IORDER(IO))GO TO 200
	END DO
	STOP 'IO'
200	DO JO=1,NJL
	IF(INTORDER(2).EQ.IORDER(JO))GO TO 201
	END DO
	STOP 'JO'
201	DO KO=1,NJL
	IF(INTORDER(3).EQ.IORDER(KO))GO TO 202
	END DO
	STOP 'KO'
202	DO LO=1,NJL
	IF(INTORDER(4).EQ.IORDER(LO))GO TO 203
	END DO
	STOP 'LO'
203	WRITE(2,500)IO,JO,KO,LO,JT,IT,V
500	FORMAT(4I4,5X,2I4,F)
	GO TO 204
7	N=N-1
	IF(N.NE.NMAT)TYPE 206,N,NMAT
206	FORMAT(' ERROR: N.NE.NMAT = ',2I)
	END

