CBAB MODIFIED TO CONVERT T=1 ISOSCALAR *.INT INPUT
CBAB TO ISOVECTOR AND ISOTENSOR *PN.INT OUTPUT
CBAB
CBAB PROGRAM TO CONVERT INTERACTION AND SPS FILES IN ISOSPIN FORMALISM
CBAB INTO FILES IN PROTON-NEUTRON FORMALISM
CBAB      INCLUDE 'SHGR:MAINCOM.INC'
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'SHEXE:DATA.INC'
      PARAMETER MAX_V = 5000
      CHARACTER*9 INTFIL,SPSFIL
      CHARACTER*11 INTFILPN,SPSFILPN
      CHARACTER*16 INTFILOUT
      CHARACTER*11 NINTFILPN,NSPSFILPN
      CHARACTER*1 LAB,LABP,LABN,ISO_TYPE
      CHARACTER*3 V_TYPE
      DIMENSION LAB(9,MAX_NJL),LABP(9,MAX_NJL),LABN(9,MAX_NJL)
      DIMENSION KNJL(MAX_NJL),KNOSC(MAX_NOSC),IFIRST(MAX_NJL)
      DIMENSION KNJLPN(MAX_NJL),KNOSCPN(MAX_NOSC)
      DIMENSION KD(MAX_NSPS),KN(MAX_NSPS),KL(MAX_NSPS)
      DIMENSION KJ(MAX_NSPS),KM(MAX_NSPS),KT(MAX_NSPS)
      DIMENSION ENL(MAX_NJL),XJJ(MAX_NJL)
      DIMENSION KV(6,MAX_V),V(MAX_V)
      V_TYPE='ALL'
      TYPE 1000
 1000 FORMAT(1X,'THIS PROGRAM CALCULATES ISOVECTOR AND ISOTENSOR',
     1/,1X,'COMPONENTS OF AN INTERACTION WHICH IS GIVEN IN ISOSPIN
     2 SPACE')
      TYPE *,'ISOVECTOR (V) OR ISOTENSOR (T) INTERACTION'
      ACCEPT 111,ISO_TYPE
      TYPE 110
110   FORMAT(1X,'SPS file name (A9): '$)
      ACCEPT 111,SPSFIL
111   FORMAT(A)
      TYPE 100
100   FORMAT(1X,'INT file name (A9): '$)
      ACCEPT 101,INTFIL
101   FORMAT(A)
      SPSFILPN = SPSFIL//'PN'
CBAB      ISPSOUT = 1
      ISPSOUT = 0
      IINTOUT = 1

      IPL = INDEX(INTFIL,' ')-1
      IF(IPL.LE.0) IPL = 11
      IF(ISO_TYPE.EQ.'V')INTFILOUT=INTFIL(1:IPL)//'IVPN.INT'
      IF(ISO_TYPE.EQ.'T')INTFILOUT=INTFIL(1:IPL)//'ITPN.INT'
      TYPE 8111,INTFILOUT
8111  FORMAT(1X,'OUTPUT FILE = ',A)

      OPEN (UNIT=10,FILE=SPSFIL//'.SPS',STATUS='OLD')
      OPEN(UNIT=11,FILE=INTFIL//'.INT',STATUS='OLD')
      OPEN(UNIT=21,FILE=INTFILOUT,STATUS='NEW')

      IF(ISO_TYPE.EQ.'V')THEN
      XPP=0.5
      XNN=-0.5
      XPN=0.0
      ELSE
      XPP=1./6.
      XNN=1./6.
      XPN=-1./3.
      END IF


CBAB READ OLD SPS FILE
      CALL SKIPHEAD(10)
      READ(10,*) NSPS,NJL,(KNJL(I),I=1,NJL),NOSC,(KNOSC(I),I=1,NOSC)
      READ(10,200) ((LAB(J,I),J=1,9),I=1,NJL)
200   FORMAT(200A1)
      DO 201 I = 1,NSPS
      READ(10,*,END=202) KD(I),KN(I),KL(I),KJ(I),KM(I),KT(I)
201   CONTINUE
202   CONTINUE

      II = 1
      DO 220 I = 1,NJL
      XJJ(I) = KJ(II)
      XJJ(I) = XJJ(I)/2.
      II = II + KNJL(I)
220   CONTINUE

CBAB MAKE NEW SPS FILE
      NSPSPN = NSPS
      NJLPN = 2*NJL
      NOSCPN = 2*NOSC

      DO 321 I = 1,NJL
      DO 322 J = 1,9
      IF(LAB(J,I).NE.' ') IFIRST(I) = J
      IF(LAB(J,I).NE.' ') GO TO 321
322   CONTINUE
321   CONTINUE

      MAX_JPN = 0
      DO 301 I = 1,NJL
      KNJLPN(I)=KNJL(I)/2
      LABP(1,I) = 'P'
      LABN(1,I) = 'N'
      JJ = 1
      DO 311 J = IFIRST(I),9
      JJ = JJ+1
      IF(LAB(J,I).NE.' '.AND.JJ.GT.MAX_JPN) MAX_JPN=JJ
      LABP(JJ,I) = LAB(J,I)
      LABN(JJ,I) = LAB(J,I)
311   CONTINUE
301   CONTINUE
      IF(ISPSOUT.EQ.1) 
     1WRITE(20,300) NSPSPN,NJLPN,(KNJLPN(I),I=1,NJL),(KNJLPN(I),I=1,NJL)
     1,NOSCPN,(KNOSC(I),I=1,NOSC),(KNOSC(I),I=1,NOSC)
300   FORMAT(1X,I3,1X,I3,1X,<NJL>(1X,I2),1X,<NJL>(1X,I2),2X,I3,
     1<NOSCPN>(1X,I2))
      IF(ISPSOUT.EQ.1) WRITE(20,305) ((LABP(J,I),J=1,9),I=1,NJL),
     1((LABN(J,I),J=1,9),I=1,NJL)
305   FORMAT(100A1)
      ID = 0
      DO 302 I = 1,NSPS
      IF(KT(I).EQ.-1) ID = ID + 1
      IF(ISPSOUT.EQ.1.AND.KT(I).EQ.-1) 
     1WRITE(20,303) ID,KN(I),KL(I),KJ(I),KM(I),KT(I)
303   FORMAT(1X,10I5)
302   CONTINUE
      DO 304 I = 1,NSPS
      IF(KT(I).EQ.1) ID = ID + 1
      IF(ISPSOUT.EQ.1.AND.KT(I).EQ.1) 
     1WRITE(20,303) ID,KN(I),KL(I),KJ(I),KM(I),KT(I)
304   CONTINUE

CBAB READ OLD INT FILE

      CALL SKIPHEAD(11)
      READ(11,*) NV,(ENL(I),I=1,NJL)
      INV = 0
401   CONTINUE
      INV = INV + 1
      IF(INV.GT.MAX_V) TYPE 410
      IF(INV.GT.MAX_V) STOP
410   FORMAT(1X,'ERROR: INCREASE MAX_V')
      READ(11,*,END=402) (KV(I,INV),I=1,6),V(INV)
      GO TO 401
402   CONTINUE
      INV = INV-1
      IF(INV.NE.NV) TYPE 403,NV,INV
403   FORMAT(1X,'WARNING: FIRST # OF SECOND LINE OF *.INT FILE (NV)'
     1/,'DIFFERS FROM # OF MATRIX ELEMENTS READ IN (INV)',
     1/,'IN,INV = ',2I5)

CBAB OUTPUT TO NEW INT FILE
      WRITE(21,405) (I,(LABP(J,I),J=1,MAX_JPN),I=1,NJL)
     1,(I+NJL,(LABN(J,I),J=1,MAX_JPN),I=1,NJL)
405   FORMAT(1X'!',
     1<NJL>(I2,'=',<MAX_JPN>(A1)),<NJL>(I2,'=',<MAX_JPN>(A1)))

      INVPN = 0
      DO 600 I = 1,INV
      IF(KV(6,I).EQ.1) INVPN = INVPN+1
600   CONTINUE
      DO 602 I = 1,INV
      IF(KV(6,I).EQ.1) INVPN = INVPN+1
602   CONTINUE
      IF(ISO_TYPE.EQ.'V')GOTO 700
      DO 603 I = 1,INV
      IF(KV(6,I).EQ.1)INVPN = INVPN+1
      IF(KV(1,I).NE.KV(2,I).AND.KV(6,I).EQ.1) INVPN = INVPN+1
      IF(KV(3,I).NE.KV(4,I).AND.KV(6,I).EQ.1) INVPN = INVPN+1
      IF(KV(1,I).NE.KV(2,I).AND.KV(3,I).NE.KV(4,I).AND.KV(6,I).EQ.1)
     1 INVPN = INVPN+1
603   CONTINUE
 700  DO I=1,2*NJL
      ENL(I)=0.0
      END DO


      WRITE(21,520) INVPN,(ENL(I),I=1,NJL),(ENL(I),I=NJL+1,2*NJL)
520   FORMAT(1X,I5,20(1X,F9.5))

      DO 500 I = 1,INV
      IF(KV(6,I).EQ.1) WRITE(21,501) (KV(J,I),J=1,4),
     1(KV(J,I),J=5,6),XPP*V(I)
501   FORMAT(1X,4I4,1X,2I3,1X,F10.5)
500   CONTINUE
      DO 502 I = 1,INV
      IF(KV(6,I).EQ.1) 
     1WRITE(21,501) (KV(J,I)+NJL,J=1,4),
     1(KV(J,I),J=5,6),XNN*V(I)
502   CONTINUE
      IF(ISO_TYPE.EQ.'V')GOTO 503
      DO 503 I = 1,INV
550   IF(KV(6,I).EQ.1) 
     1WRITE(21,501) KV(1,I),KV(2,I)+NJL,KV(3,I),KV(4,I)+NJL,
     1(KV(J,I),J=5,6),XPN*V(I)
      XJT = KV(5,I)
      XTT = KV(6,I)
      P12 = PAR(XJJ(KV(1,I))+XJJ(KV(2,I))-XJT-XTT)
      PV12 = P12*XPN*V(I)
      IF(KV(1,I).NE.KV(2,I).AND.KV(6,I).EQ.1)
     1WRITE(21,501) KV(2,I),KV(1,I)+NJL,KV(3,I),KV(4,I)+NJL,
     1(KV(J,I),J=5,6),PV12
      P34 = PAR(XJJ(KV(3,I))+XJJ(KV(4,I))-XJT-XTT)
      PV34 = P34*XPN*V(I)
      IF(KV(3,I).NE.KV(4,I).AND.KV(6,I).EQ.1)
     1WRITE(21,501) KV(1,I),KV(2,I)+NJL,KV(4,I),KV(3,I)+NJL,
     1(KV(J,I),J=5,6),PV34
      PV1234 = P12*P34*XPN*V(I)
      IF(KV(1,I).NE.KV(2,I).AND.KV(3,I).NE.KV(4,I).
     1AND.KV(6,I).EQ.1)
     1WRITE(21,501) KV(2,I),KV(1,I)+NJL,KV(4,I),KV(3,I)+NJL,
     1(KV(J,I),J=5,6),PV1234
503   CONTINUE
      STOP
      END

      FUNCTION PAR(A)
      I=A
      A=I/2
      P=A/2.0
      Q=I
      IF(P-Q)1,2,1
 1    PAR=-1.0
      RETURN
 2    PAR=1.0
      RETURN
      END

      SUBROUTINE SKIPHEAD(J)
      CHARACTER*1 A
      DIMENSION A(3)
100   READ(J,101) (A(I),I=1,3)
101   FORMAT(3A1)
      DO 200 I = 1,3
200   IF(A(I).EQ.'!') GO TO 100
      BACKSPACE J
      RETURN
      END
