      FUNCTION AFRPI(I1,I2,XUM,ISC,HBW,XNORM1,XNORM2)
      X = FRPI(I1,I2,XUM,ISC,HBW,XNORM1,XNORM2)
      AFRPI = 2.*FRDI(I1,I2,XUM,ISC,HBW)+X
      RETURN
      END
 
      FUNCTION FRDI(I1,I2,XUM,ISC,HBW)
      COMMON/INDEX/XL(3,200)
      PIE = 3.14159
      XLL = XL(2,I1)
      XLLP = XL(2,I2)
      IF(XLL-XLLP) 200,200,201
201   AL = -XLLP
      GO TO 202
200   AL = XLLP+1.
202   CONTINUE
CBAB      HBW = 7.0
      I = I1
      IP = I2
      S = 0.
      XM = .000001
      RM = 10.
      R2 = 0.02
      H = .02
101   CONTINUE
      R2 = R2 + H
      R1 = R2 - H
      R3 = R2 + H
      X2 = OSCRADN(I,R2,HBW,ISC)
      X1P = OSCRADN(IP,R1,HBW,ISC)
      X2P = OSCRADN(IP,R2,HBW,ISC)
      X3P = OSCRADN(IP,R3,HBW,ISC)
      XD = (X3P-X1P)/(2.*H)
      XD = XD+AL*X2P/R2
      XX = XUM*R2
      ZZ = EXP(-XX)/(R2*4.*PIE)
      X = X2*XD*ZZ*R2*R2
      IF(ABS(X).LT.XM.AND.R2.GT.RM) GO TO 100
      S = S + X
      GO TO 101
100   CONTINUE
      S = S*H*ANGI(I1,I2)
      FRDI = S*41.465
      RETURN
      END
 
      FUNCTION FRPI(I1,I2,XUM,ISC,HBW,XNORM1,XNORM2)
      PIE = 3.14159
CBAB      HBW = 7.0
      S = 0.
      SS1 = 0.
      SS2 = 0.
      XM = .000001
      RM = 10.
      R = 0.
      H = .02
101   CONTINUE
      R = R+H
      X1 = OSCRADN(I1,R,HBW,ISC)
      X2 = OSCRADN(I2,R,HBW,ISC)
      XX = XUM*R
      ZZ = -XUM*XUM*(1.+1./XX)*EXP(-XX)/(XX*4.*PIE)
      X = X1*X2*ZZ*R*R
      ZZ1 = 0.
      ZZ2 = 0.
      IF(ABS(X1).GT.1E-20) ZZ1 = X1*X1*R*R
      IF(ABS(X2).GT.1E-20) ZZ2 = X2*X2*R*R
      IF(ABS(X).LT.XM.AND.R.GT.RM) GO TO 100
      S = S + X
      SS1 = SS1 + ZZ1
      SS2 = SS2 + ZZ2
      GO TO 101
100   CONTINUE
      S = S*H*ANGI(I1,I2)
      FRPI=41.465*S
      XNORM1 = SS1*H
      XNORM2 = SS2*H
      RETURN
      END
 
      FUNCTION SIGPME(I1,I2)
      COMMON/INDEX/XL(3,200)
      XLL = XL(2,I1)
      XJ = XL(3,I1)
      XLLP = XL(2,I2)
      XJP = XL(3,I2)
      IF(XJ-XJP) 100,101,100
100   SIGPME = 0.
      RETURN
101   X = PAR(.5+XJ+XLLP)*SQRT(2.*XJ+1.)
      X = X*SQRT(6.)*SJ(XLL,.5,XJ,.5,XLLP,1.)
      X = X*DELME(I1,I2,HBW)
      SIGPME = X
      RETURN
      END
 
      FUNCTION DELME(I1,I2,HBW)
      COMMON/INDEX/XL(3,200)
      XLL = XL(2,I1)
      XLLP = XL(2,I2)
      IF(XLL-XLLP) 100,100,101
101   A = -XLLP
      GO TO 102
100   A = XLLP+1.
102   CONTINUE
      X1 = DRINT(I1,I2)
      X2 = A*RLD(I1,I2,-1,HBW)
      X = SQRT((2.*XLL+1.)*(2.*XLLP+1.))
      X =X*PAR(XLL)*TJ(XLL,1.,XLLP,0.,0.,0.)
      DELME = X*(X1+X2)
      RETURN
      END
 
      FUNCTION DRINT(I1,I2)
      ISC = 0
      HBW = 14.
      I = I1
      IP = I2
      XL = 0.
      S = 0.
      XM = .000001
      RM = 10.
      R2 = 0.
      H = .02
101   CONTINUE
      R2 = R2 + H
      R1 = R2 - H
      R3 = R2 + H
      X2 = OSCRADN(I,R2,HBW,ISC)
      X1P = OSCRADN(IP,R1,HBW,ISC)
      X3P = OSCRADN(IP,R3,HBW,ISC)
      XD = (X3P-X1P)/(2.*H)
      X = X2*XD*(R2**(XL+2.))
      IF(ABS(X).LT.XM.AND.R2.GT.RM) GO TO 100
      S = S + X
      GO TO 101
100   DRINT = S*H
      RETURN
      END
 
      FUNCTION OSCRADN(I1,XR,HBW,ISC)
      COMMON/INDEX/XL(3,200)
      F(X,Y) = SQRT(DFAC(2.*X+2.*Y+1.)/FAC(X))/DFAC(2.*Y+1.)
      G(X,Y,Z) = PAR(Z)*BINOM(X,Z)*DFAC(2.*Y+1.)/DFAC(2.*Y+2.*Z+1.)
      XSC = 1.
C      AS = 1.1
C      BS = .68
      IF(ISC.EQ.0) GO TO 100
C      XSC = 1.-EXP(-AS*XR*XR)*(1.-BS*XR*XR)
      XQ = 3.93*XR
      XSC = 1-(SIN(XQ)/XQ)
100   CONTINUE
      V = 41.465/HBW
      V = 1./V
      XN = XL(1,I1)-1.
      XLL = XL(2,I1)
      CC = V**(.75+XLL/2.)
      XX = F(XN,XLL)
      C = 1.50225*(2.**((XLL/2.)-(XN/2.)))
      IXN = XN+1.
      R = XR
      S = 0.
      DO 21 J = 1,IXN
      XK = J-1
21    S = S + (V**XK)*G(XN,XLL,XK)*(R**(2.*XK))*(2.**XK)
      YY = V*R*R/2.
      SS = XX*EXP(-YY)*S*(R**XLL)
      SS = SS*C
      OSCRADN = SS*CC*XSC
      RETURN
      END
 
      FUNCTION RLD(I1,I2,I,HBW)
CBAB      HBW = 14.
      B = SQRT(41.465/HBW)
      XI = I
      RLD = RL(I1,I2,I)*(B**XI)
      RETURN
      END
 
      FUNCTION ANGI(I1,I2)
      COMMON/INDEX/XL(3,200)
      XLL = XL(2,I1)
      XLLP = XL(2,I2)
      X = SQRT((2.*XLL+1.)*(2.*XLLP+1.))
      X =X*PAR(XLL)*TJ(XLL,1.,XLLP,0.,0.,0.)
      ANGI = X
      RETURN
      END
 
      FUNCTION FRI(I1,I2,XUM,ISC,HBW,XNORM1,XNORM2)
      PIE = 3.14159
      S = 0.
      SS1 = 0.
      SS2 = 0.
      XM = .000001
      RM = 10.
      R = 0.
      H = .02
101   CONTINUE
      R = R+H
      X1 = OSCRADN(I1,R,HBW,ISC)
      X2 = OSCRADN(I2,R,HBW,ISC)
      ZZ = FUNC(R,XUM)
      X = X1*X2*ZZ*R*R
      ZZ1 = X1*X1*R*R
      ZZ2 = X2*X2*R*R
      IF(ABS(X).LT.XM.AND.R.GT.RM) GO TO 100
      S = S + X
      SS1 = SS1 + ZZ1
      SS2 = SS2 + ZZ2
      GO TO 101
100   CONTINUE
      S = S*H
      FRI = S
      XNORM1 = SS1*H
      XNORM2 = SS2*H
      RETURN
      END
 
      FUNCTION RMEEX(I1,I2,XUM,ISC,HBW,XNORM1,XNORM2)
      PIE = 3.14159
      S = 0.
      SS1 = 0.
      SS2 = 0.
      XM = .000001
      RM = 10.
      R = 0.
      H = .02
101   CONTINUE
      R = R+H
      X1 = OSCRADN(I1,R,HBW,ISC)
      X2 = OSCRADN(I2,R,HBW,ISC)
      IF(XUM.GT.0.) ZZ = (EXP(-XUM*R))/(XUM*R)
      IF(XUM.EQ.0.) ZZ = 1.
      X = X1*X2*ZZ*R*R
      ZZ1 = X1*X1*R*R
      ZZ2 = X2*X2*R*R
      IF(ABS(X).LT.XM.AND.R.GT.RM) GO TO 100
      S = S + X
      SS1 = SS1 + ZZ1
      SS2 = SS2 + ZZ2
      GO TO 101
100   CONTINUE
      S = S*H
      RMEEX = S
      XNORM1 = SS1*H
      XNORM2 = SS2*H
      RETURN
      END
 
      FUNCTION FUNC(X,XUM)
C     XM = XUM
C     FUNC = 1./X
C     FUNC = (EXP(-XM*X))/X
C     FUNC = VCD1(X)
      AP = .8
      XX = SQRT(12.)*X/AP
      Y = 0.
      Y = (48.+33.*XX+9.*XX*XX+XX*XX*XX)/48.
      Y = 1.-EXP(-XX)*Y
      FUNC = 1./X
      RETURN
      END
