      FUNCTION PV(I1,I2,I3,I4,IJ,IT,ITP)
      DIMENSION KNS(1000),KLS(1000),KNC(1000),KLC(1000)
      DIMENSION KNSP(1000),KLSP(1000),KNCP(1000),KLCP(1000)
ca      DIMENSION VL(12,12,12,12,100)
 
      DIMENSION XAH(200,10)
      CHARACTER*9 WSF
      COMMON/WSF/WSF
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CXMU/IMU,XMU
      COMMON/CPV/ISYMT,ISYMS,IRAD,CONST,XUM,ISC,HBW
      COMMON/INDEX/XL(3,200)
 
      IF(INEWINT.EQ.0) GO TO 948
 
      CLOSE(UNIT=8)
CBAB      OPEN(UNIT=8,FILE='MO.DAT',STATUS='OLD')
CBAB      OPEN(UNIT=8,FILE='MBKT.DAT',STATUS='OLD')
CBAB      CALL READM(FLAB,FREL,FBKT,IFROM,ITAL)
      CALL ETBME(0,0,0)
CBAB LEFT OUT UNDER THE ASSUMPTION THAT ONLY ONE INTERACTION IS
CBAB RUN AT A TIME
C      CALL ZERORAD
      WRITE(6,610)
      WRITE(11,610)
610   FORMAT(
     1/,1X,'THIS IS THE PNC INTERACTION IN THE
     1 FORM GIVEN BY DESPLANQUES-DONOHUE-HOLSTEIN',
     1/,1X,'EXCEPT FOR A FACTOR (-i)',
     1/,1X,'PNC(r) = CONST SYM(ISYMT,TAU1,TAU2) SYM(ISYMS,SIG1,SIG2).
     1DOT.RADINT',
     1/,1X
     1/,1X,'WHERE "CONST" IS A CONSTANT ( e.g. 2.2E-06 FOR THE OPEP)',
     1/,1X,
     1/,1X,'RADINT = 41.465*<[DEL,G(ABS(XUM),r))]> FOR "PV"'
     1/,1X,'RADINT = 41.465*<{DEL,G(ABS(XUM),r))}> FOR "PVA"'
     1/,1X,
     1/,1X,'WHERE G(X,r) = exp(-X*r)/(4*pi*r)  AND DEL IS THE GRADIENT
     1 OPERATOR',
     1/,1X,'41.465 = hbar*hbar*c*c/(proton-mass*c*c)
     1 AND X = meson-mass*c*c/(hbar*c)',
     1/,1X,
     1/,1X,'HBW IS THE NUCLEAR OSCILLATOR CONSTANT (THE RELATIVE
     1 OSC CONSTANT IS HBW/2.)',
     1/,1X,
     1/,1X,'ISC = (0/1) = (WITHOUT/WITH) SRC (SHORT RANGE CORRELATIONS)',
     1/,1X,' ISC=1 FOR SRC = 1.-[EXP(-1.1*XR*XR)*(1.-0.68*XR*XR)]',
     1/,1X,' ISC=2 FOR SRC = 1.-SIN(3.93*R)/3.93*R',
     1/,1X,' ISC=3 FOR SRC = 1 (R > 0.7), 0 (R < 0.7)',
     1/,1X,' IMU=0 mu capture normal',
     1/,1X,' IMU=1 mu capture - (kR)**2/6 term',
     1/,1X,' IMU=2 mu capture - (kr)**2/24 term',
     1/,1X,' IMU=3 mu capture + k**2 Rr (s1-s2)/6 term',
     1/,1X,' IMU=4 mu capture - (kR)**4/120 term',
     1/,1X,' XK = k')
      WRITE(6,220)
      WRITE(11,220)
220   FORMAT(/,1X,'CONST,ISYMT,ISYMS,XUM,ISC,HBW,IMU,XK')
      READ(5,221) CONST,ISYMT,ISYMS,XUM,ISC,HBW,IMU,XMU
221   FORMAT(F,2I,F,I,F,I,F)
      WRITE(11,223) CONST,ISYMT,ISYMS,XUM,ISC,HBW,IMU,XMU
223   FORMAT(/,1X,'INPUT = ',F10.5,2X,2I4,F10.5,I2,F10.5,I2,1X,F5.3,/)
CBAB      CALL RADRD
      INEWINT = 0
948   CONTINUE
      PV = 0.
      IF(ETBME(IT,ITP,ISYMT).EQ.0.) RETURN
      XTTT = ETBME(IT,ITP,ISYMT)
      XTP = ITP
      XT = IT
 
      LAMDA = 1
      XLAMDA = LAMDA
 
      IJP = IJ
      XJ = IJ
      XJP = IJP
      J = 2*IJ
      JP = 2*IJP
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XL3 = XL(2,I3)
      XL4 = XL(2,I4)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      L1 = 2.*XL1
      L2 = 2.*XL2
      L3 = 2.*XL3
      L4 = 2.*XL4
      J1 = 2.*XJ1
      J2 = 2.*XJ2
      J3 = 2.*XJ3
      J4 = 2.*XJ4
      LL1 = XL1
      LL2 = XL2
      LL3 = XL3
      LL4 = XL4
      S = 0.
      IF(ITR(J1,J2,J)) 801,801,802
802   IF(ITR(J3,J4,JP)) 801,801,803
803   CONTINUE
      XC = SQRT((2.*XJ1+1.)*(2.*XJ2+1.)*(2.*XJ3+1.)*(2.*XJ4+1.))
      XC = XC/SQRT((2.*XJ+1.)*(2.*XJP+1.))
 
ca      IF(I1.GT.10.OR.I2.GT.10.OR.I3.GT.10.OR.I4.GT.10)
ca    1 TYPE 830,I1,I2,I3,I4
ca      IF(I1.GT.10.OR.I2.GT.10.OR.I3.GT.10.OR.I4.GT.10) STOP
ca 830   FORMAT(1X,'increase dimension for VL, I1,I2,I3,I4 = ',4I4)
 
      ISMIN = 1
      ISMAX = 2
      ILMIN = IABS(LL1-LL2) + 1
      ILMAX = LL1 + LL2 + 1
      ILPMIN = IABS(LL3-LL4) + 1
      ILPMAX = LL3 + LL4 + 1
 
C      IF(ILMAX.GE.10.OR.ILPMAX.GE.10)
C     1 TYPE 831,ILMAX,ILPMAX
C      IF(ILMAX.GE.10.OR.ILPMAX.GE.10) STOP
C831   FORMAT(1X,'increase dimension for VL, ILMAX,ILPMAX = ',2I4)
 
 
      DO 200 IL = ILMIN,ILMAX
      DO 200 ILP = ILPMIN,ILPMAX
      DO 200 IS = ISMIN,ISMAX
      DO 200 ISP = ISMIN,ISMAX
      XIL = IL-1
      XILP = ILP-1
      XS = IS-1
      XSP = ISP-1
      JL = 2*IL-2
      JLP = 2*ILP-2
      JS = 2*IS-2
      JSP = 2*ISP-2
CBAB203   IF(IJ-IJP) 201,204,201
204   IF(ITR(JL,JS,J)) 201,201,205
205   IF(ITR(JLP,JSP,JP)) 201,201,206
206   CONTINUE
208   CONTINUE
      IIS = XS
      IISP = XSP
      X12 = ETBME(IIS,IISP,ISYMS)
      IF(IMU.EQ.3) X12 = ETBME(IIS,IISP,2)
      IF(X12.EQ.0.) GO TO 201
      ITS = 2*(ITP+1-1)+IT+1
      ISS = 2*(ISP-1)+IS
      ILS = 10*ILP + IL
 
      X1 = SJ(XIL,XS,XJ,XSP,XILP,1.)
      X1 = X1*PAR(XS+XJ+XILP)
      X11= X1*SQRT(2.*XJ+1.)
      IF(X11.EQ.0.) GO TO 201
      X = XNIN(L1,1,J1,L2,1,J2,JL,JS,J)
      X = X*XNIN(L3,1,J3,L4,1,J4,JLP,JSP,JP)
      IF(X.EQ.0.) GO TO 201
      X = X*X11*X12
 
ca      XVL = VL(I1,I2,I3,I4,ILS)
ca      IF(XVL.NE.0.) GO TO 260
 
      XVL = 0.
 
      IF(IFH.EQ.999) GO TO 8001
      IHMAX = 10
      DO 8000 IHZ = 1,200
      NZ = XL(1,IHZ)
      XAH(IHZ,NZ) = 1.
8000  CONTINUE
 
      IF(WSF.EQ.' ') GO TO 910
      OPEN(UNIT=15,FILE=WSF//'.WS',STATUS='OLD')
      TYPE 914
      WRITE(11,914)
914   FORMAT(/,1X,'WS expansion parameters',/,3X,'K,N,A',/)
912   CONTINUE
      READ(15,*,ERR=911) IZ1,IZ2,XHZ
      IF(IZ1.LT.0)GOTO911
      TYPE 915,IZ1,IZ2,XHZ
      WRITE(11,915) IZ1,IZ2,XHZ
915   FORMAT(1X,2I4,1X,F10.6)
      XAH(IZ1,IZ2) = XHZ
      GO TO 912
911   CLOSE(UNIT=15)
910   CONTINUE
      IFH = 999
8001  CONTINUE
 
      DO 251 IH1 = 1,IHMAX
      XH1 = IH1
      I1P = FINDEX(XH1,XL1,XJ1)
      IF(XAH(I1,IH1).EQ.0.) GO TO 251
 
      DO 251 IH2 = 1,IHMAX
      XH2 = IH2
      I2P = FINDEX(XH2,XL2,XJ2)
      IF(XAH(I2,IH2).EQ.0.) GO TO 251
 
      DO 251 IH3 = 1,IHMAX
      XH3 = IH3
      I3P = FINDEX(XH3,XL3,XJ3)
      IF(XAH(I3,IH3).EQ.0.) GO TO 251
 
      DO 251 IH4 = 1,IHMAX
      XH4 = IH4
      I4P = FINDEX(XH4,XL4,XJ4)
      IF(XAH(I4,IH4).EQ.0.) GO TO 251
 
      XN1 = XXN(I1P)-1.
      XN2 = XXN(I2P)-1.
      XN3 = XXN(I3P)-1.
      XN4 = XXN(I4P)-1.
      N1 = XN1
      N2 = XN2
      N3 = XN3
      N4 = XN4
c      TYPE 7777,I1P,I2P,I3P,I4P
c     1,xah(i1,ih1)
c     1,xah(i2,ih2)
c     1,xah(i3,ih3)
c     1,xah(i4,ih4)
c7777  FORMAT(1X,4I5,1x,4f10.7)
 
 
      SS = 0.
 
      ILM1=IL-1
      ILPM1=ILP-1
 
CBAB      CALL CMSUM(N1,LL1,N2,LL2,ILM1,NUM,KNS,KLS,KNC,KLC)
CBAB      CALL CMSUM(N3,LL3,N4,LL4,ILPM1,NUMP,KNSP,KLSP,KNCP,KLCP)
 
      CALL MOSHQN(N1,LL1,N2,LL2,ILM1,KNS,KLS,KNC,KLC,NUM)
      CALL MOSHQN(N3,LL3,N4,LL4,ILPM1,KNSP,KLSP,KNCP,KLCP,NUMP)
      DO 300 I = 1,NUM
      DO 300 IP = 1,NUMP
      IF(ITR(KLS(I),KLSP(IP),LAMDA)) 301,301,303
303   CONTINUE
c305   IF(KNC(I)-KNCP(IP)) 301,306,301
c306   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
CBAB      IF(TR(XKLS,XKLSP,1.)) 301,301,307
CBAB307   CONTINUE
CBAB      CALL MOSHIN(KNS(I),KLS(I),KNC(I),KLC(I),N1,LL1,N2,LL2,ILM1,BKT)
CBAB      CALL MOSHIN(KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP)
CBAB     1,N3,LL3,N4,LL4,ILPM1,BKTP)
      BKT = BMOSH(N1,LL1,N2,LL2,ILM1,KNS(I),KLS(I),KNC(I),KLC(I))
      BKTP = BMOSH(N3,LL3,N4,LL4,ILPM1,
     1KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP))
      XXX = FRAD(KNS(I)+1,KLS(I)+1,KNSP(IP)+1,KLSP(IP)+1)
      IF(KLC(I)-KLCP(IP)) 301,304,301
304   CONTINUE
      XCM = FRADCM(KNC(I)+1,KLC(I)+1,KNCP(IP)+1,KLCP(IP)+1)
      IF(XXX) 901,900,901
900   WRITE(6,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
      WRITE(11,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
902   FORMAT(1X,'MISSING RADIAL INTEGRAL'5I5)
901   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
      XKLC = KLC(I)
      X11 = PAR(XKLS+XKLC+XILP+XLAMDA)
      X11 = X11*SJ(XKLS,XIL,XKLC,XILP,XKLSP,XLAMDA)
      X11 = X11*SQRT((2.*XIL+1.)*(2.*XILP+1.))
      XX = XXX*XCM*BKT*BKTP
      XX = XX*X11
      SS = SS + XX
301   CONTINUE
300   CONTINUE
      XVL = XVL + SS
     1*XAH(I1,IH1)*XAH(I2,IH2)*XAH(I3,IH3)*XAH(I4,IH4)
251   CONTINUE
ca      XVL = XVL + 0.00000001
ca      VL(I1,I2,I3,I4,ILS) = XVL
C      TYPE 7777,I1,I2,I3,I4,LL1,LL2,LL3,LL4,IL,ILP,XVL
C7777  FORMAT(1X,4I4,2X,4I4,2X,2I4,2X,F10.5)
ca      ILS2 = 10*IL + ILP
C      VL(I3,I4,I1,I2,ILS2) = XVL
ca      VL(I2,I1,I4,I3,ILS) = PAR(XL1+XL2-XIL)*PAR(XL3+XL4-XILP)*XVL
C      VL(I4,I3,I2,I1,ILS2) = PAR(XL1+XL2-XIL)*PAR(XL3+XL4-XILP)*XVL
260   CONTINUE
 
 
      S = S + XVL*X
201   CONTINUE
 
200   CONTINUE
      S = S*XC
801   CONTINUE
CBAB      PV = S*CONST*XTTT/1000.
      PV = S*CONST*XTTT
      RETURN
      END
 
      SUBROUTINE LISTRAD
      COMMON/RAD/KNMAX,KLMAX,RAD(30,20,30,20)
      WRITE(6,100)
      WRITE(11,100)
100   FORMAT(/,1X,'  N1  L1  N2  L2   RADINT
     1 LIST OF RADIAL INTEGRALS USED',/)
      DO 200 KN1 = 1,KNMAX
      DO 200 KL1 = 1,KLMAX
      DO 200 KN2 = 1,KNMAX
      DO 200 KL2 = 1,KLMAX
      X = RAD(KN1,KL1,KN2,KL2)
      IF(X.EQ.0.) GO TO 200
      N1 = KN1
      N2 = KN2
      L1 = KL1-1
      L2 = KL2-1
      WRITE(6,300) N1,L1,N2,L2,X
      WRITE(11,300) N1,L1,N2,L2,X
300   FORMAT(1X,4I4,F10.5)
200   CONTINUE
      RETURN
      END
 
      SUBROUTINE ZERORAD
      COMMON/RAD/KNMAX,KLMAX,RAD(30,20,30,20)
      KNMAX = 0
      KLMAX = 0
      DO 510 I = 1,30
      DO 510 J = 1,20
      DO 510 K = 1,30
      DO 510 L = 1,20
510   RAD(I,J,K,L) = 0.
      RETURN
      END
 
      FUNCTION FRAD(KN1,KL1,KN2,KL2)
      CHARACTER*4 KEY
      COMMON/IKMAX/IKMAX
      COMMON/KEY/KEY
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CPV/ISYMT,ISYMS,IRAD,CONST,XUM,ISC,HBW
      COMMON/RAD/KNMAX,KLMAX,RAD(30,20,30,20)
      DIMENSION XNOR(30,20)
      IF(KN1.GT.30) TYPE 301,KN1
      IF(KN1.GT.30) STOP
301   FORMAT(1X,'Increase dimension for RAD, KN1 = ',I4)
      IF(KL1.GT.20) TYPE 302,KL1
      IF(KL1.GT.20) STOP
302   FORMAT(1X,'Increase dimension for RAD, KL1 = ',I4)
      IF(KN2.GT.30) TYPE 303,KN2
      IF(KN2.GT.30) STOP
303   FORMAT(1X,'Increase dimension for RAD, KN2 = ',I4)
      IF(KL2.GT.20) TYPE 304,KL2
      IF(KL2.GT.20) STOP
304   FORMAT(1X,'Increase dimension for RAD, KL2 = ',I4)
      IF(KL1.GT.KLMAX) KLMAX = KL1
      IF(KL2.GT.KLMAX) KLMAX = KL2
      IF(KN1.GT.KNMAX) KNMAX = KN1
      IF(KN2.GT.KNMAX) KNMAX = KN2
      FRAD = RAD(KN1,KL1,KN2,KL2)
      IF(FRAD.NE.0.) RETURN
      N1 = KN1-1
      N2 = KN2-1
      L1 = KL1-1
      L2 = KL2-1
      I1 = IFINDEXI(N1+1,L1,2*L1+1)
      I2 = IFINDEXI(N2+1,L2,2*L2+1)
      IF(KEY.EQ.'PNC')X=FRPI(I1,I2,ABS(XUM),ISC,HBW/2.)
      IF(KEY.EQ.'PNA')X=AFRPI(I1,I2,ABS(XUM),ISC,HBW/2.)
      IF(KEY.EQ.'MEX')X=RMEEX(I1,I2,ABS(XUM),ISC,HBW/2.)
      IF(XNOR(KN1,KL1).EQ.0.) XNOR(KN1,KL1) = XNORM(I1,ISC,HBW/2.)
      IF(XNOR(KN2,KL2).EQ.0.) XNOR(KN2,KL2) = XNORM(I2,ISC,HBW/2.)
      RAD(KN1,KL1,KN2,KL2) = X/SQRT(XNOR(KN1,KL1)*XNOR(KN2,KL2))
      FRAD = RAD(KN1,KL1,KN2,KL2)
      IF(KN1.NE.KN2.AND.KL1.NE.KL2) GO TO 200
      RETURN
200   IF(IFS.EQ.999) GO TO 201
      IF(RAD(KN2,KL2,KN1,KL1).EQ.0.) RETURN
      ISIGN = RAD(KN2,KL2,KN1,KL1)/RAD(KN1,KL1,KN2,KL2)
      IFS = 999
201   RAD(KN2,KL2,KN1,KL1) = ISIGN*RAD(KN1,KL1,KN2,KL2)
      RETURN
      END
 
      FUNCTION FRADCM(KN1,KL1,KN2,KL2)
      CHARACTER*4 KEY
      COMMON/IKMAX/IKMAX
      COMMON/KEY/KEY
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CPV/ISYMT,ISYMS,IRAD,CONST,XUM,ISC,HBW
      COMMON/RADCM/KNMAXCM,KLMAXCM,RADCM(30,20,30,20)
      IF(KN1.GT.30) TYPE 301,KN1
      IF(KN1.GT.30) STOP
301   FORMAT(1X,'Increase dimension for RAD, KN1 = ',I4)
      IF(KL1.GT.20) TYPE 302,KL1
      IF(KL1.GT.20) STOP
302   FORMAT(1X,'Increase dimension for RAD, KL1 = ',I4)
      IF(KN2.GT.30) TYPE 303,KN2
      IF(KN2.GT.30) STOP
303   FORMAT(1X,'Increase dimension for RAD, KN2 = ',I4)
      IF(KL2.GT.20) TYPE 304,KL2
      IF(KL2.GT.20) STOP
304   FORMAT(1X,'Increase dimension for RAD, KL2 = ',I4)
      IF(KL1.GT.KLMAXCM) KLMAXCM = KL1
      IF(KL2.GT.KLMAXCM) KLMAXCM = KL2
      IF(KN1.GT.KNMAXCM) KNMAXCM = KN1
      IF(KN2.GT.KNMAXCM) KNMAXCM = KN2
      FRADCM = RADCM(KN1,KL1,KN2,KL2)
      IF(FRADCM.NE.0.) RETURN
      N1 = KN1-1
      N2 = KN2-1
      L1 = KL1-1
      L2 = KL2-1
      I1 = IFINDEXI(N1+1,L1,2*L1+1)
      I2 = IFINDEXI(N2+1,L2,2*L2+1)
      IF(KEY.EQ.'PNC')X=FRCM(I1,I2,ABS(XUM),ISC,2.*HBW)
      IF(KEY.EQ.'PNA')X=FRCM(I1,I2,ABS(XUM),ISC,2.*HBW)
      IF(KEY.EQ.'MEX')X=FRCM(I1,I2,ABS(XUM),ISC,2.*HBW)
      RADCM(KN1,KL1,KN2,KL2) = X
      FRADCM = RADCM(KN1,KL1,KN2,KL2)
      IF(KN1.NE.KN2.AND.KL1.NE.KL2) GO TO 200
      RETURN
200   IF(IFS.EQ.999) GO TO 201
      IF(RADCM(KN2,KL2,KN1,KL1).EQ.0.) RETURN
      ISIGN = RADCM(KN2,KL2,KN1,KL1)/RADCM(KN1,KL1,KN2,KL2)
      IFS = 999
201   RADCM(KN2,KL2,KN1,KL1) = ISIGN*RADCM(KN1,KL1,KN2,KL2)
      RETURN
      END
 
      FUNCTION ETBME(I1,I2,ISYM)
      ETBME = 0.
      IF(ISYM.LT.0) GO TO 100
      IF(ISYM.GT.6) GO TO 100
      IF(ISYM.GT.0) GO TO 120
      WRITE(6,500)
      WRITE(11,500)
500   FORMAT(
     1/,1X,
     1/,1X,'  SYM(X1,X2,1) =  (X1  PLUS X2)^1',
     1/,1X,'  SYM(X1,X2,2) =  (X1 MINUS X2)^1',
     1/,1X,'  SYM(X1,X2,3) = i(X1 CROSS X2)^1 (vector not tensor)',
     1/,1X,'  SYM(X1,X2,4) =  (X1   DOT X2)^0 (vector not tensor)',
     1/,1X,'  SYM(X1,X2,5) = 1               ',
     1/,1X,'  SYM(X1,X2,6) =  (X1 CROSS X2)^2 (tensor)',
     1/,1X)
      RETURN
100   CONTINUE
      WRITE(6,110) ISYM
      WRITE(11,110) ISYM
110   FORMAT(1X,'ILLEGAL VALUE FOR ISYM',I5)
      RETURN
120   CONTINUE
      GO TO (10,20,30,40,50,60),ISYM
10    IF(I1.EQ.1.AND.I2.EQ.1) GO TO 11
      RETURN
11    ETBME = 2.*SQRT(6.)
      RETURN
20    IF(IABS(I1-I2).EQ.1) GO TO 21
      RETURN
21    X = I2
      ETBME = PAR(X)*2.*SQRT(3.)
      RETURN
30    IF(IABS(I1-I2).EQ.1) GO TO 31
      RETURN
31    ETBME = 2.*SQRT(3.)
      RETURN
40    IF(IABS(I1-I2).EQ.0) GO TO 41
      RETURN
41    IF(I1.EQ.0) ETBME = -3.
      IF(I1.EQ.1) ETBME = SQRT(3.)
      RETURN
50    IF(IABS(I1-I2).EQ.0) GO TO 51
      RETURN
51    X = I1
      ETBME = SQRT(2.*X+1.)
      RETURN
60    IF(I1.EQ.1.AND.I2.EQ.1) GO TO 61
      RETURN
61    ETBME = 2.*SQRT(5.)
      RETURN
      END
      FUNCTION XNIN(I1,I2,I3,I4,I5,I6,I7,I8,I9)
      X1 = I1
      X2 = I2
      X3 = I3
      X4 = I4
      X5 = I5
      X6 = I6
      X7 = I7
      X8 = I8
      X9 = I9
      X1 = X1/2.
      X2 = X2/2.
      X3 = X3/2.
      X4 = X4/2.
      X5 = X5/2.
      X6 = X6/2.
      X7 = X7/2.
      X8 = X8/2.
      X9 = X9/2.
      XI7=I7
      XI8=I8
      XI9=I9
      XNIN=SQRT((XI7+1.)*(XI8+1.)*(XI9+1.))
     1*QJ(X1,X2,X3,X4,X5,X6,X7,X8,X9)
      RETURN
      END
 
      FUNCTION XMEEX(I1,I2,I3,I4,IJ12,IJ34,IT,ITP)
      DIMENSION KNS(1000),KLS(1000),KNC(1000),KLC(1000)
      DIMENSION KNSP(1000),KLSP(1000),KNCP(1000),KLCP(1000)
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CPV/ISYMT,ISYMS,IRAD,CONST,XUM,ISC,HBW
      COMMON/INDEX/XL(3,200)
 
      IF(INEWINT.EQ.0) GO TO 948
 
      CLOSE(UNIT=8)
CBAB      OPEN(UNIT=8,FILE='MO.DAT',STATUS='OLD')
CBAB      OPEN(UNIT=8,FILE='MBKT.DAT',STATUS='OLD')
CBAB      CALL READM(FLAB,FREL,FBKT,IFROM,ITAL)
      CALL ETBME(0,0,0)
      CALL ZERORAD
      WRITE(6,220)
      WRITE(11,220)
220   FORMAT(/,1X,'C,ISYMT,ISYMS,XUM,ISC,HBW')
      READ(5,221) CONST,ISYMT,ISYMS,XUM,ISC,HBW
221   FORMAT(F,2I,F,I,F)
      WRITE(11,223) CONST,ISYMT,ISYMS,XUM,ISC,HBW
223   FORMAT(/,1X,'INPUT = ',F10.5,2X,2I4,F10.5,I2,F10.5)
      INEWINT = 0
948   CONTINUE
      XMEEX = 0.
CBAB      IF(ETBME(IT,ITP,ISYMT).EQ.0.) RETURN
CBAB      XTTT = ETBME(IT,ITP,ISYMT)
      XTTT = 1.
      LAMDA = 0
      XLAMDA = LAMDA
 
      IJ = IJ12
      IJP = IJ34
      XJ = IJ12
      XJP = IJP
      J = 2*IJ
      JP = 2*IJP
      XN1 = XL(1,I1)-1.
      XN2 = XL(1,I2)-1.
      XN3 = XL(1,I3)-1.
      XN4 = XL(1,I4)-1.
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XL3 = XL(2,I3)
      XL4 = XL(2,I4)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      N1 = XN1
      N2 = XN2
      N3 = XN3
      N4 = XN4
      L1 = 2.*XL1
      L2 = 2.*XL2
      L3 = 2.*XL3
      L4 = 2.*XL4
      J1 = 2.*XJ1
      J2 = 2.*XJ2
      J3 = 2.*XJ3
      J4 = 2.*XJ4
      LL1 = XL1
      LL2 = XL2
      LL3 = XL3
      LL4 = XL4
      S = 0.
      IF(ITR(J1,J2,J)) 801,801,802
802   IF(ITR(J3,J4,JP)) 801,801,803
803   CONTINUE
      ISMIN = 1
      ISMAX = 2
      ILMIN = IABS(LL1-LL2) + 1
      ILMAX = LL1 + LL2 + 1
      ILPMIN = IABS(LL3-LL4) + 1
      ILPMAX = LL3 + LL4 + 1
      DO 200 IL = ILMIN,ILMAX
      DO 200 ILP = ILPMIN,ILPMAX
      DO 200 IS = ISMIN,ISMAX
      DO 200 ISP = ISMIN,ISMAX
      XIL = IL-1
      XILP = ILP-1
      XS = IS-1
      XSP = ISP-1
      JL = 2*IL-2
      JLP = 2*ILP-2
      JS = 2*IS-2
      JSP = 2*ISP-2
      XC = SQRT((2.*XJ1+1.)*(2.*XJ2+1.)*(2.*XJ3+1.)*(2.*XJ4+1.))
      XC = XC/SQRT((2.*XJ+1.)*(2.*XJP+1.))
CBAB203   IF(ITR(J,JP,IDJ)) 201,201,204
204   IF(ITR(JL,JS,J)) 201,201,205
205   IF(ITR(JLP,JSP,JP)) 201,201,206
206   CONTINUE
208   CONTINUE
      IIS = XS
      IISP = XSP
c      XX12 = 0.5*ETBME(IIS,IISP,1)*ETBME(IT,ITP,1)
cweo      IF(IIS.EQ.0)XX12 = XX12 - 0.5*ETBME(IIS,IISP,2)*ETBME(IT,ITP,2)
cweo      IF(IIS.EQ.1)XX12 = XX12 + 1.5*ETBME(IIS,IISP,2)*ETBME(IT,ITP,2)
c      IF(IISP.EQ.0)XX12 = XX12 - 0.5*ETBME(IIS,IISP,2)*ETBME(IT,ITP,2)
c      IF(IISP.EQ.1)XX12 = XX12 + 1.5*ETBME(IIS,IISP,2)*ETBME(IT,ITP,2)
      XX12 = ETBME(IIS,IISP,ISYMS)*ETBME(IT,ITP,ISYMT)
CBAB      XX12 = ETBME(IIS,IISP,ISYMS)
CBAB      XX12 = ETBME(IIS,IISP,1)*ETBME(IT,ITP,1)
CBAB     1 + ETBME(IIS,IISP,2)*ETBME(IT,ITP,2)
CBAB     1 - 2.*ETBME(IIS,IISP,3)*ETBME(IT,ITP,3)
CBAB      XX12 = -2.*ETBME(IIS,IISP,3)*ETBME(IT,ITP,3)
      IF(XX12.EQ.0.) GO TO 201
 
      IF(IL.NE.ILP) GO TO 201
CBAB -----------------------------------
      X1 = SJ(XS,XSP,1.,XJP,XJ,XIL)
      X1 = X1*PAR(XILP+XSP+XJ+1.)
      XX11 = X1*SQRT((2.*XJ+1.)*(2.*XJP+1.))
CBAB -----------------------------------
 
 
      X = XNIN(L1,1,J1,L2,1,J2,JL,JS,J)
      XX3 = X*XNIN(L3,1,J3,L4,1,J4,JLP,JSP,JP)
      X = XX3*XX11*XX12
      IF(X.EQ.0.) GO TO 201
      SS = 0.
      ILM1=IL-1
      ILPM1=ILP-1
CBAB      CALL CMSUM(N1,LL1,N2,LL2,ILM1,NUM,KNS,KLS,KNC,KLC)
CBAB      CALL CMSUM(N3,LL3,N4,LL4,ILPM1,NUMP,KNSP,KLSP,KNCP,KLCP)
      CALL MOSHQN(N1,LL1,N2,LL2,ILM1,KNS,KLS,KNC,KLC,NUM)
      CALL MOSHQN(N3,LL3,N4,LL4,ILPM1,KNSP,KLSP,KNCP,KLCP,NUMP)
      DO 300 I = 1,NUM
      DO 300 IP = 1,NUMP
      IF(ITR(KLS(I),KLSP(IP),LAMDA)) 301,301,303
303   IF(KLC(I)-KLCP(IP)) 301,304,301
304   CONTINUE
305   IF(KNC(I)-KNCP(IP)) 301,306,301
306   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
CBAB      CALL MOSHIN(KNS(I),KLS(I),KNC(I),KLC(I),N1,LL1,N2,LL2,ILM1,BKT)
CBAB      CALL MOSHIN(KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP)
CBAB     1,N3,LL3,N4,LL4,ILPM1,BKTP)
      BKT = BMOSH(N1,LL1,N2,LL2,ILM1,KNS(I),KLS(I),KNC(I),KLC(I))
      BKTP = BMOSH(N3,LL3,N4,LL4,ILPM1,
     1KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP))
      XXX = FRAD(KNS(I)+1,KLS(I)+1,KNSP(IP)+1,KLSP(IP)+1)
      IF(XXX) 901,900,901
900   WRITE(6,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
      WRITE(11,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
902   FORMAT(1X,'MISSING RADIAL INTEGRAL'5I5)
901   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
      XKLC = KLC(I)
 
CBAB --------------------------------------------------
CBAB      X11 = PAR(XKLS+XKLC+XILP+XLAMDA)
CBAB      X11 = X11*SJ(XKLS,XIL,XKLC,XILP,XKLSP,XLAMDA)
CBAB      X11 = X11*SQRT((2.*XIL+1.)*(2.*XILP+1.))
      X11 = 1.
CBAB --------------------------------------------------
 
      XX = X11*XXX*BKT*BKTP
CBAB      XX = XX*X11
      SS = SS + XX
CBAB      WRITE(6,7777) IS,ISP,IL,ILP,KNS(I)+1,KLS(I)+1,KNSP(IP)+1,
CBAB     1KLSP(IP)+1,XXX,BKT,BKTP,XX,SS
CBAB      WRITE(11,7777) IS,ISP,IL,ILP,KNS(I)+1,KLS(I)+1,KNSP(IP)+1,
CBAB     1KLSP(IP)+1,XXX,BKT,BKTP,XX,SS
CBAB7777  FORMAT(1X,8I3,5F10.5)
301   CONTINUE
300   CONTINUE
      S = S + SS*X
CBAB      WRITE(6,7778) IS,ISP,IL,ILP,XX11,XX12,XX3,X,S
CBAB      WRITE(11,7778) IS,ISP,IL,ILP,XX11,XX12,XX3,X,S
CBAB7778  FORMAT(1X,4I3,5F10.5)
201   CONTINUE
200   CONTINUE
      S = S*XC
801   CONTINUE
      XMEEX = S*CONST*XTTT
      RETURN
      END
 
