      FUNCTION AFRPI(I1,I2,XUM,ISC,HBW)
      X = FRPI(I1,I2,XUM,ISC,HBW)
      AFRPI = 2.*FRDI(I1,I2,XUM,ISC,HBW)+X
      RETURN
      END
 
      FUNCTION FRDI(I1,I2,XUM,ISC,HBW)
      COMMON/CINT/RM,H
      DIMENSION SUM(1000)
      PIE = 3.14159
      XLL = XXL(I1)
      XLLP = XXL(I2)
      IF(XLL-XLLP) 200,200,201
201   AL = -XLLP
      GO TO 202
200   AL = XLLP+1.
202   CONTINUE
CBAB      HBW = 7.0
      I = I1
      IP = I2
      S = 0.
      XM = .000001
      R2 = H
      IS = 1
101   CONTINUE
      IS = IS + 1
      R2 = R2 + H
      R1 = R2 - H
      R3 = R2 + H
      X2 = OSCRADN(I,R2,HBW,ISC)
      X1P = OSCRADN(IP,R1,HBW,ISC)
      X2P = OSCRADN(IP,R2,HBW,ISC)
      X3P = OSCRADN(IP,R3,HBW,ISC)
      XD = (X3P-X1P)/(2.*H)
      XD = XD+AL*X2P/R2
      XX = XUM*R2
      ZZ = EXP(-XX)/(R2*4.*PIE)
      X = X2*XD*ZZ*R2*R2
      IF(ABS(X).LT.XM.AND.R2.GT.RM) GO TO 100
      SUM(IS) = X
      GO TO 101
100   CONTINUE
      S=SUMM6(1,IS,SUM)
      S = S*ANGI(I1,I2)
      FRDI = S*41.465
      RETURN
      END
 
      FUNCTION FRPI(I1,I2,XUM,ISC,HBW)
      COMMON/CXMU/IMU,XMU
      COMMON/CINT/RM,H
      DIMENSION SUM(1000)
      FPIE = 4.*3.14159
      XM = .000001
      R = 0.
      XK2 = XMU*XMU
      IS = 1
101   CONTINUE
      IS = IS + 1
      R = R+H
      IF(R.GT.RM) GO TO 100
      XX = XUM*R
      ZZ = -XUM*XUM*(1.+1./XX)*EXP(-XX)/(XX*FPIE)
      IF(R.LE.1.) ZZN = ZZ
      IF(R.LE.1.) GO TO 200
      IF(ABS(ZZ/ZZN).LT.1E-5) GO TO 100
200   CONTINUE
      X1 = OSCRADN(I1,R,HBW,ISC)
      X2 = OSCRADN(I2,R,HBW,ISC)
      X = X1*X2*ZZ*R*R
      IF(IMU.EQ.2) X = -X1*X2*ZZ*R*R*XK2*R*R/24.
      IF(IMU.EQ.3) X = X1*X2*ZZ*R*R*XK2*R/6.
      SUM(IS) = X
      GO TO 101
100   CONTINUE
 
      S=SUMM6(1,IS,SUM)
C      TYPE 7777,IS,NBMAX,S
C7777  FORMAT(1X,'IS = ',2I5,2F10.5)
      S = S*ANGI(I1,I2)
      FRPI=41.465*S
      RETURN
      END
 
      FUNCTION FRCM(I1,I2,XUM,ISC,HBW)
      COMMON/CXMU/IMU,XMU
      COMMON/CINT/RM,H
      DIMENSION SUM(1000)
      FPIE = 4.*3.14159
      XM = .000001
      R = 0.
      XK2 = XMU*XMU
      IS = 1
101   CONTINUE
      IS = IS + 1
      R = R+H
      IF(R.GT.RM) GO TO 100
C      XX = XUM*R
C      ZZ = -XUM*XUM*(1.+1./XX)*EXP(-XX)/(XX*FPIE)
      ZZ = 1.
      IF(R.LE.1.) ZZN = ZZ
      IF(R.LE.1.) GO TO 200
      IF(ABS(ZZ/ZZN).LT.1E-5) GO TO 100
200   CONTINUE
      X1 = OSCRADN(I1,R,HBW,0)
      X2 = OSCRADN(I2,R,HBW,0)
      X = X1*X2*ZZ*R*R
      IF(IMU.EQ.1) X = -X1*X2*ZZ*R*R*XK2*R*R/6.
      IF(IMU.EQ.3) X = X1*X2*ZZ*R*R*R
      IF(IMU.EQ.4) X = X1*X2*ZZ*R*R*XK2*R*R*XK2*R*R/120.
      SUM(IS) = X
      GO TO 101
100   CONTINUE
 
      S=SUMM6(1,IS,SUM)
C      TYPE 7777,IS,NBMAX,S
C7777  FORMAT(1X,'IS = ',2I5,2F10.5)
      FRCM=S
C      TYPE 7777,I1,I2,HBW,FRCM
C7777  FORMAT(1X,2I3,2F10.5)
      RETURN
      END
 
      FUNCTION SIGPME(I1,I2)
      XLL = XXL(I1)
      XJ = XXJ(I1)
      XLLP = XXL(I2)
      XJP = XXJ(I2)
      IF(XJ-XJP) 100,101,100
100   SIGPME = 0.
      RETURN
101   X = PAR(.5+XJ+XLLP)*SQRT(2.*XJ+1.)
      X = X*SQRT(6.)*SJ(XLL,.5,XJ,.5,XLLP,1.)
      X = X*DELME(I1,I2,HBW)
      SIGPME = X
      RETURN
      END
 
      FUNCTION DELME(I1,I2,HBW)
      XLL = XXL(I1)
      XLLP = XXL(I2)
      IF(XLL-XLLP) 100,100,101
101   A = -XLLP
      GO TO 102
100   A = XLLP+1.
102   CONTINUE
      X1 = DRINT(I1,I2)
      X2 = A*RLD(I1,I2,-1,HBW)
      X = SQRT((2.*XLL+1.)*(2.*XLLP+1.))
      X =X*PAR(XLL)*TJ(XLL,1.,XLLP,0.,0.,0.)
      DELME = X*(X1+X2)
      RETURN
      END
 
      FUNCTION DRINT(I1,I2)
      COMMON/CINT/RM,H
      DIMENSION SUM(1000)
      ISC = 0
      HBW = 14.
      I = I1
      IP = I2
      XL = 0.
      S = 0.
      XM = .000001
      R2 = 0.
      IS = 0
101   CONTINUE
      IS = IS + 1
      R2 = R2 + H
      R1 = R2 - H
      R3 = R2 + H
      X2 = OSCRADN(I,R2,HBW,ISC)
      X1P = OSCRADN(IP,R1,HBW,ISC)
      X3P = OSCRADN(IP,R3,HBW,ISC)
      XD = (X3P-X1P)/(2.*H)
      X = X2*XD*(R2**(XL+2.))
      IF(ABS(X).LT.XM.AND.R2.GT.RM) GO TO 100
      SUM(IS) = X
      GO TO 101
100   CONTINUE
      DRINT=SUMM6(1,IS,SUM)
      RETURN
      END
 
      FUNCTION OSCRADN(I1,XR,HBW,ISC)
      F(X,Y) = SQRT(DFAC(2.*X+2.*Y+1.)/FAC(X))/DFAC(2.*Y+1.)
      G(X,Y,Z) = PAR(Z)*BINOM(X,Z)*DFAC(2.*Y+1.)/DFAC(2.*Y+2.*Z+1.)
      XSC = 1.
      AS = 1.1
      BS = .68
      IF(ISC.EQ.0) GO TO 100
      IF(ISC.EQ.1) XSC = 1.-EXP(-AS*XR*XR)*(1.-BS*XR*XR)
      XQ = 3.93*XR
      IF(ISC.EQ.2) XSC = 1-(SIN(XQ)/(XQ))
      IF(ISC.EQ.3.AND.XR.LE.0.7)XSC = 0.0
      IF(ISC.EQ.3.AND.XR.GT.0.7)XSC = 1.0
100   CONTINUE
      V = 41.465/HBW
      V = 1./V
      XN = XXN(I1)-1.
      XLL = XXL(I1)
      CC = V**(.75+XLL/2.)
      XX = F(XN,XLL)
      C = 1.50225*(2.**((XLL/2.)-(XN/2.)))
      YY = V*XR*XR/2.
      CB = EXP(-YY)*(XR**XLL)
 
      S = 0.
      IXN = XN+1.
      DO 21 J = 1,IXN
      XK = J-1
      X1 = CB*(V**XK)
      X2 = G(XN,XLL,XK)
      IF(XK.LE.10.)X3 = XR**(2.*XK)
      IF(XK.GT.10.)X3 = 2*XK*LOG(XR)
      X4 = 2.**XK
      IF(XK.LE.10.)S = S + X1*X2*X3*X4
      IF(XK.GT.10.)X5 = LOG(X1)+LOG(X4)
      IF(XK.GT.10.)S = S + X2*EXP(X3+X5)
21    CONTINUE
      SS = XX*S*C*CC
      OSCRADN = SS*XSC
      RETURN
      END
 
      FUNCTION RLD(I1,I2,I,HBW)
CBAB      HBW = 14.
      B = SQRT(41.465/HBW)
      XI = I
      RLD = RL(I1,I2,I)*(B**XI)
      RETURN
      END
 
      FUNCTION ANGI(I1,I2)
      XLL = XXL(I1)
      XLLP = XXL(I2)
      X = SQRT((2.*XLL+1.)*(2.*XLLP+1.))
      X =X*PAR(XLL)*TJ(XLL,1.,XLLP,0.,0.,0.)
      ANGI = X
      RETURN
      END
 
      FUNCTION FRI(I1,I2,XUM,ISC,HBW)
      COMMON/CINT/RM,H
      DIMENSION SUM(1000)
      S = 0.
      XM = .000001
      R = 0.
      IS = 0
101   CONTINUE
      IS = IS + 1
      R = R+H
      X1 = OSCRADN(I1,R,HBW,ISC)
      X2 = OSCRADN(I2,R,HBW,ISC)
      ZZ = FUNC(R,XUM)
      X = X1*X2*ZZ*R*R
      IF(ABS(X).LT.XM.AND.R.GT.RM) GO TO 100
      SUM(IS) = X
      GO TO 101
100   CONTINUE
      FRI=SUMM6(1,IS,SUM)
      RETURN
      END
 
      FUNCTION XNORM(I1,ISC,HBW)
      COMMON/CINT/RM,H
      DIMENSION SUM(1000)
      R = 0.
      IS = 0
101   CONTINUE
      IS = IS + 1
      R = R+H
      IF(R.GT.RM) GO TO 100
      X1 = OSCRADN(I1,R,HBW,ISC)
      SUM(IS) = X1*X1*R*R
      GO TO 101
100   CONTINUE
      NBMAX = IS
      XNORM=SUMM6(1,IS,SUM)
      RETURN
      END
 
      FUNCTION RMEEX(I1,I2,XUM,ISC,HBW)
      COMMON/CINT/RM,H
      DIMENSION SUM(1000)
      S = 0.
      XM = .000001
      R = 0.
      IS = 0
101   CONTINUE
      IS = IS + 1
      R = R+H
      X1 = OSCRADN(I1,R,HBW,ISC)
      X2 = OSCRADN(I2,R,HBW,ISC)
      IF(XUM.GT.0.) ZZ = (EXP(-XUM*R))/(XUM*R)
      IF(XUM.EQ.0.) ZZ = 1.
      X = X1*X2*ZZ*R*R
      IF(ABS(X).LT.XM.AND.R.GT.RM) GO TO 100
      SUM(IS) = X
      GO TO 101
100   CONTINUE
      RMEEX=SUMM6(1,IS,SUM)
      RETURN
      END
 
      FUNCTION FUNC(X,XUM)
C     XM = XUM
C     FUNC = 1./X
C     FUNC = (EXP(-XM*X))/X
C     FUNC = VCD1(X)
      AP = .8
      XX = SQRT(12.)*X/AP
      Y = 0.
      Y = (48.+33.*XX+9.*XX*XX+XX*XX*XX)/48.
      Y = 1.-EXP(-XX)*Y
      FUNC = 1./X
      RETURN
      END
 
      FUNCTION SUMM6(MIN,MAX,SUM)
      COMMON/CINT/RM,H
      DIMENSION SUM(*)
      S1=0.
      S2=0.
      S3=0.
      S4=0.
      MAX1=MAX-6
      DO 30 J=MIN,MAX1,6
      S1=S1+SUM(J)+SUM(J+6)
      S2=S2+SUM(J+1)+SUM(J+5)
      S3=S3+SUM(J+2)+SUM(J+4)
 30   S4=S4+SUM(J+3)
      SUMM6=0.29285714*(S1+5.268293*S2+0.6585366*S3+6.634146*S4)*H
      RETURN
      END
