      SUBROUTINE FEDUP(SINGL_COEF0,*)
C  Called by PROJ.FOR. Use for orthogonalization prior to projection
C  method.
C  Used when predicted set finished and an NGOOD.NE.NJT, i.e. JT basis
C  not complete

      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
      DIMENSION IDUD(3),SINGL_COEF0(NDIMII)
      INCLUDE 'SHEXE:DATA.INC'

      IPSF(J,I)=(J-1)*J/2+I
      IPRC(I,J)=IPSF(J,I)
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPUF,HANDLE))STOP ' FATAL ERROR in
*BT     1FEDUP, time routine '      !START CLOCK
CBAB      TYPE 933,NLILIM,NGOOD,NPRED,NJT,NDIMII
CBAB933   FORMAT(' ***** INFORMATION from FEDUP: NLILIM,NGOOD,NPRED,
CBAB     1NJT,NDIMII ',E11.3,4I6, ' *****')
CBAB      TYPE *
C  Reinitialize
      I1=NPRED+1
      IF(NGOOD.EQ.0)THEN
C!First pass for a given partition. No predicted file
      NPRED=MAX(NDIMII/10,5)
      IF(NPRED.GT.MAX_PRED)STOP ' ***** FATAL ERROR in FEDUP: Increase
     1 MAX_PRED *****'
      DO I=1,NPRED
      I_PRD(I)=.TRUE.
      END DO
      DO I=1,NDIMII
      IPROT_BYTE(I)=.TRUE.
      END DO
      ELSE           !NGOOD.NE.0
      DO IW=1,NGOOD
      IPROT_BYTE(IGOOD(IW))=.FALSE.
C!Make certain not to repredict, see under 110
      END DO
      IF(NJT.EQ.0)STOP ' ***** FATAL ERROR in FEDUP: NJT.EQ.0 *****'
      NPRED=NJT   ! will predict NJT new states

C  As .PRJ file is in single precision increase NLILIM in an effort to
C  avoid rounding errors. Next three lines could be commented out
*      IF(NLILIM.LT.1.E-04)NLILIM=1.E-04
*      NLILIM=3.*NLILIM
*      IF(NLILIM.GT.1.E-03)NLILIM=1.E-03

      END IF
      IF(NPRED.EQ.0) STOP ' ***** FATAL ERROR in FEDUP:
     1NPRED.EQ.0 *****'
      NPREDN=NPRED+I1-1    !Sum over all previous calls
      IF(NPREDN.GE.MAX_PRED)THEN
      NPREDN=MAX_PRED
      NPRED=NPREDN-I1+1
      IF(NPRED.GT.MAX_PRED)STOP ' ***** FATAL ERROR in FEDUP: Increase
     1 MAX_PRED *****'
      FEDUP_CALL=.FALSE.
      END IF
      DO I=I1,NPREDN
      I_PRD(I)=.TRUE.
      END DO
C  define I_PREDICT
      I=I1-1
      J=1
100   IF(J.GT.NDIMII)THEN
      NPREDN=I
      NPRED=I-I1+1
      IF(NPRED.GT.MAX_PRED)STOP ' ***** FATAL ERROR in FEDUP: Increase
     1 MAX_PRED *****'
      FEDUP_CALL=.FALSE.
C!End of possible good m-scheme vectors,
Cif predicted set finishes again in MAIN, change NILILIM limit
      GO TO 110
      END IF
      IF(IPROT_BYTE(J).OR.NGOOD.EQ.0)THEN
      I=I+1
      I_PREDICT(I)=J
      IF(I-I1+1.EQ.NPRED)GOTO 110
      END IF
      J=J+1
      GOTO 100
110   IF(NGOOD.EQ.0)GOTO 777
C! running without advanced prediction file. First pass
      DO I=I1,NPREDN
      I_PRD(I)=.TRUE.
      END DO
      IF(NGOOD.NE.0)THEN
      DO IW=1,NGOOD
      IPROT_BYTE(IGOOD(IW))=.TRUE.
      ENDDO
      END IF
C  Get ready to store required ORTHOGS in memory
      N1=NPREDN
C!Total no. of predicted set over all passes thorough FEDUP
      IF(IPSF(N1,N1).GT.MAX_ORTHOG)THEN
      TYPE 120,IPSF(N1,N1)
120   FORMAT(' Increase MAX_ORTHOG to ',I)
      STOP ' ***** FATAL ERROR in FEDUP *****'
      END IF
C  Rewind .PRJ file to begining of present partition
      REWIND 23
      DO IW=1,NUNIT23-NGOOD
      READ(23)
      END DO

      IREAD=0
150   READ(23,END=17)IDUD,SINGL_COEF0
      IREAD=IREAD+1
      IF(IDUD(1).NE.IREAD.OR.IDUD(2).NE.NDIMII.OR.IDUD(3).NE.
     1IGOOD(IREAD))THEN
      TYPE 5091,IDUD(1),IREAD,IDUD(2),NDIMII,IDUD(3),IGOOD(IREAD)
5091  FORMAT(1X,'IDUD(1),IREAD,IDUD(2),NDIMII,IDUD(3),IGOOD(IREAD) = '
     1,/,6(1X,I5))
      TYPE 5092
5092  FORMAT(' ** FATAL ERROR in FEDUP: ABOVE PAIRS SHOULD BE EQUAL **')
      STOP
      ENDIF
      IR=NG(IREAD)
      DO J=I1,NPREDN
      ORTHOG(IPRC(IR,J))=SINGL_COEF0(I_PREDICT(J))
      END DO
C  NSTART initial address for present <Oi|I_Predict(NGOODPLUS)>
C  i.GT.NGOODPLUS
C  MAX_PRED,MAX_PRED-1,MAX_PRED-2,MAX_PRED-3,...
      NSTART=(IR-1)*MAX_PRED-((IR-1)*(IR-2))/2
      IN=I1-1-IR !avoid previously defined goodcoefo_previous
      DO 59 J=I1,NPREDN
      IN=IN+1
      GOODCOEF0_PREVIOUS(NSTART+IN)=SINGL_COEF0(I_PREDICT(J))
59    CONTINUE
      GO TO 150
17    IF(IREAD.NE.NGOOD)THEN
      TYPE 1995,IREAD,NGOOD
1995  FORMAT(' IREAD,NGOOD ',2I5)
      STOP ' ***** FATAL ERROR in FEDUP: IREAD.NE.NGOOD *****'
      END IF

C NP_DIFF,PROT_PART are vectors to use JMJP2 only for given proton
C  partitions,
C  not all.
      DO 19 J=I1,NPREDN
      DO IPTN=1,NDIFFM
      IF(LIB_EQX(NP_DIFF(1,IPTN),IPROT(1,I_PREDICT(J)),N_WORDS))THEN
      PROT_PART(I_PREDICT(J))=IPTN
      GO TO 19
      END IF
      IF(IPTN.EQ.NDIFFM)STOP ' ***** FATAL ERROR in FEDUP: A PROTON
     1PARTITION HAS NOT BEEN FOUND *****'
      END DO
19    CONTINUE

777   CONTINUE
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPUF2,HANDLE))STOP ' FATAL ERROR in
*BT     1FEDUP, time routine '     !STOP CLOCK
*BT      IFED_TIME = IFED_TIME + ICPUF2 - ICPUF
      IF(NDIMII.LT.NPRED)STOP ' ***** FATAL ERROR in FEDUP: NDIMII.LT.
     1NPRED *****'
***      TYPE 733,(IPROT_BYTE(IW),IW=1,NDIMII)
***733   FORMAT(' FEDUP - IPROT_BYTE '/<NDIMII/50+1>(50(L1,1X)/))
      IF(NGOOD.NE.0)THEN
***      TYPE *,' NJT,JKEEP',NJT,JKEEP
***      TYPE 733,(NG(IW),IW=1,NGOOD)
***      TYPE 734,(IGOOD(IW),IW=1,NGOOD)
***      TYPE 735,(I_PREDICT(IW),IW=1,NPREDN)
***      TYPE 736,(I_PRD(IW),IW=1,NPREDN)
733   FORMAT(' NG '/<NPREDN>(10(I6,1X)/))
734   FORMAT(' IG '/<NPREDN>(10(I6,1X)/))
735   FORMAT(' I_PREDICT'/<NPREDN>(10(I6,1X)/))
736   FORMAT(' I_PRD'/<NPREDN>(50(1X,L1)/))
***      TYPE 737,(IPROT_BYTE(IW),IW=1,1000)
737   FORMAT(' IPROT_BYTE'/100(50(1X,L1)/))
***   TYPE *,ORTHOG(IPRC(418,418))
      NPRED=NPREDN
***   STOP ' *************************************************'
      RETURN 1    !Return to main and calculate JKEEP
      END IF
      NPRED=NPREDN
      RETURN
C!Normal return - first pass, no predicted set
      END
