      SUBROUTINE JMJP0
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
      INTEGER*2 IBAB1,IBAB2,IBAB3
      REAL*8 XBAB,XBAB1,XBAB2
      INTEGER *2 NPSTORE(MAX_STORE,MAX_IPROT),
     1TABLENP(MAX_IPROT*MAX_STORE)
      INTEGER *2 JJSTORE(MAX_STORE,MAX_IPROT),
     1NSTORE(MAX_STORE,MAX_IPROT),
     1TABLEJJ(MAX_STORE*MAX_IPROT),TABLEN(MAX_STORE*MAX_IPROT)
      DIMENSION IPOSN(MAX_NSPS),IARG(MAX_IPROT),ISTART(MAX_IPROT)
      DIMENSION JPATRN(MAX_NLWRDS),MPATRN(MAX_NLWRDS),
     1IARG_KEEP(0:MAX_IPROT),IARGO(MAX_IPROT),KEEP_SUM(0:MAX_IPROT)
      EQUIVALENCE(TABLENP(1),NPSTORE(1,1))
      EQUIVALENCE(TABLEJJ(1),JJSTORE(1,1))
      EQUIVALENCE(TABLEN(1),NSTORE(1,1))
      INCLUDE 'SHEXE:DATA.INC'

CA   THIS SUBROUTINE APPLIES THE TOTAL J-J+ OPERATOR WITHOUT GOOD
C    PROTON PARTITION.
CA   IT IS USED FOR RANDOM VECTOR FIRST AND J TO PROJECT OUT ONLY
C    IT APPLIES J-J+ OPERATORS TO COEF0 AND RETURNS RESULT IN COEF.
CA   COEF IS THEN,THE OUTPUT OF THE SUBROUTINE
CA   J-J+ IS TAKEN AS A SUM OVER NNM(NNP)SINGLE PARTICLE J- (J+)
CA   OPERATORS. SEE DO LOOPS 300 AND 200.
CA   INITIALLY WE HAVE SOME WAVEFUNCTION |W>=SUMi COEF0(i)IBASIS(i)
CA   RETURNS J-J+|W>= SUMi COEF(i)IBASIS(i)

      KEEP_SUM(0)=0
      IARG_KEEP(0)=0
      NBLOCKS=0
      LLL = 1
CA  NP_DIFF IS AN ARRAY WITH ALL POSSIBLE DIFFERENT PROTON PARTITIONS,
CA  IPA PRESENT PROTON PARTITION. THEY ARE ARBITRARILY NUMBERED FROM 1 TO
CA  MAX_IPROT
CA  IARG PRESENT NUMBER OF COEFFICIENTS - 1 STORED FOR EACH OF THE 
CA  PROTON 
CA  PARTITIONS
CA  IARG_KEEP NUMBER OF COEFFICIENTS FOR EACH PROTON PARTITION. IT IS
CA  EQUAL TO IARG -1 WHEN UNIT 21 IS NOT USED, OR ELSE THE SUM OVER IARG
CA  OVER THE PRESENT AND WRITTEN RECORDS
CA  KEEP_SUM SUM OF IARG_KEEP(IPA) FOR I.LE.IPA
CA  IARGO LIKE KEEP-SUM BUT ONLY OVER THE RECORDS READ AT ANY GIVEN 
CA  MOMENT
CA  ARE YOU LOST? SO AM I.

      DO IPA=1,NDIFFM
      IARGO(IPA)=0
      IARG_KEEP(IPA)=0
      IARG(IPA)=1
      KEEP_SUM(IPA)=0
      END DO

      NDIM2B=NDM2P/2

CA   START OF THE LOOP OVER THE BASIS STATES

      DO 400 JJ=1,NDIMII
CA  SORT OUT THE PROTON PARTITION TO STORE IT.
      DO IPA=1,NDIFFM
      IF(LIB_EQX(NP_DIFF(1,IPA),IPROT(1,JJ),N_WORDS))GO TO 12
      END DO
      STOP ' JMJP0: ONE PROTON PARTITION IS NOT IN THE TABLE'
12    CALL LIB_ASSIGNX(IBASIS(1,JJ),JPATRN(1),NLWRDS)
      NPTCLE=0


CA   NEXT DO LOOP FINDS WHERE THE PARTICLES IN JPATRN ARE.FINDS IN 
CA   WHAT SINGLE
CA   PARTICLE STATES THEY ARE AND STORES THE RESULT IN IPOSN.


      DO I=1,NLWRDS
      NSTART=0
CA  SEE RUNTIME MANUAL FOR SUBROUTINE LIB$FFS.SHORTLY,IT FINDS THE
CA  FIRST BIT IN JPATRN(1) THAT OCCURS FROM POSITION NSTART ONWARDS.
CA  IT RETURNS THE POSITION  OF THE FIRST OCCURENCE IN N.
20    IF(.NOT.LIB$FFS(NSTART,32,JPATRN(I),N))GO TO 10
      IF(N.GT.31)GO TO 10
      NSTART=N+1
      NPTCLE=NPTCLE+1
      IPOSN(NPTCLE)=NSTART+(I-1)*32
      GO TO 20
10    CONTINUE
      END DO


CA   WE SHALL NOW APPLY J+(DO 300)AND THEN J-(DO 200)

      DO 300  NNP=1,NPTCLE
      CALL LIB_ASSIGNX(JPATRN(1),IPATRN(1),NLWRDS)
      NP=IPOSN(NNP)       !NP POSITION WHERE PARTICLE IS

CA   JP TELLS WHAT PATTERN WE GET WHEN WE APPLY J+(NNP) TO IPATRN.
CA   J+(NNP) IS APPLIED ONLY ON PARTICLE IN POSITION NP AND IT
CA   MOVES IT TO POSITION JP.
      JP=JPLUS(NP)
      IF(JP.EQ.0)GO TO 300
      IF(LIB_BTSX(IPATRN(1),JP-1,NLWRDS))GOTO 300


CA   WE HAVE JUST CHECKED (and set) THAT THE PLACE IS EMPTY,SO NOW 
CA   CHANGE THE
CA   PLACE OF THE PARTICLE.

      CALL LIB_BTCX(IPATRN(1),NP-1,NLWRDS)


CA   NEXT FEW LINES,UP TO LABEL 110 IS THE FIND SUBROUTINE.IF YOU
CA   WANT THE COMMENTED VERSION SEE FINDP.FOR.

      N=NDIMP
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110
      N=NDIM2B
      M=N
      IF(LIB_LTX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 101
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110
      M=M/2
      N=NDIMP-M
      GO TO 102
101   M=M/2
      N=N-M

CA   ******************************************************************
102   IF(M.EQ.0)THEN
      TYPE *,' Initial pattern'
      CALL BWRITE(6,NSPS,NLWRDS,JPATRN)
      TYPE *,' Final pattern'
      CALL BWRITE(6,NSPS,NLWRDS,IPATRN)
      TYPE 335,NP,JP
335   FORMAT(' NP,JP = ',2I4)
      NMAX=MIN(100,NDIMP)
      TYPE *,' BASIS '
      DO I=1,NMAX
      CALL BWRITE(6,NSPS,NLWRDS,IBASISP(1,I))
      END DO
      STOP 'ERROR IN JMJP0: 
     1A BASIS PATTERN HAS NOT BEEN FOUND-ARRAYS DIMENSIONS COULD 
     1BE WRONG. COMPILE WITH THE CHECK SWITCH'
      END IF
CA   *****************************************************************

      IF(LIB_LTX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 101
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110
      M=M/2
      N=N+M
      GO TO 102
110   CONTINUE
CA   WORK OUT THE PHASE
      IPHASP=1
      IF(IMAX.EQ.0)THEN
      IF(LIB_BTX(JPATRN(1),NP,NLWRDS))IPHASP=-1
      END IF
      IF(FACP(NP).EQ.0)
     1STOP ' ***** FATAL ERROR in JMJP: FACP.EQ.0 *****'
CJ   ******************************************************************
      IF(IARG(IPA).LT.MAX_STORE)THEN
      IPACK=NP+NSPS*((1-IPHASP)/2)
      NPSTORE(IARG(IPA),IPA)=IPACK
      JJSTORE(IARG(IPA),IPA)=JJ
      NSTORE (IARG(IPA),IPA)=N
      ELSE
      IPACK=NP+NSPS*((1-IPHASP)/2)
      NPSTORE(IARG(IPA),IPA)=IPACK
      JJSTORE(IARG(IPA),IPA)=JJ
      NSTORE (IARG(IPA),IPA)=N
      LLL=LLL+1
      LTEST=LLL
      IARG(IPA)=IARG(IPA)+1
      NBLOCKS=NBLOCKS+1
      WRITE(21)(IARG(I),I=1,NDIFFM)
      WRITE(21)((NPSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM)
      WRITE(21)((JJSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM)
      WRITE(21)((NSTORE (I,J),I=1,IARG(J)-1),J=1,NDIFFM)
      DO I=1,NDIFFM
      IARG_KEEP(I)=IARG_KEEP(I)+IARG(I)-1
      IARG(I)=1
      END DO
      GO TO 300
      ENDIF
      LLL=LLL+1
      IARG(IPA)=IARG(IPA)+1
CJ   ******************************************************************
300   CONTINUE
400   CONTINUE
      DO IPA=1,NDIFFM
      IARG_KEEP(IPA)=IARG_KEEP(IPA)+IARG(IPA)-1
      KEEP_SUM(IPA)=KEEP_SUM(IPA-1)+IARG_KEEP(IPA)
      END DO
      IF(LLL-1.GT.MAX_IPROT*MAX_STORE)THEN
      WRITE(6,501)LLL-1
501   FORMAT(' JMJP0: INCREASE MAX_IPROT*MAX_STORE TO =',I)
      STOP
      END IF
      IF(NBLOCKS.GT.0.AND.LTEST.NE.LLL)THEN
      NBLOCKS=NBLOCKS+1
      WRITE(21)(IARG(IPA),IPA=1,NDIFFM)
      WRITE(21)((NPSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM)
      WRITE(21)((JJSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM)
      WRITE(21)((NSTORE (I,J),I=1,IARG(J)-1),J=1,NDIFFM)
      ENDIF
CA  READ THEM ORDERLY AND DUMP THEM IN THE TABLES AVOINDING THE BLANKS
CA  INITIALLY WE DIMENSIONED THE ARRAYS IN MAX_IPROT BLOCKS OF MAX_STORE
CA  PLACES EACH. THE WRITING IN UNIT 21 WAS PERFORMED IN ORDER TO DIVIDE 
CA  THE PLACES
CA  ACCORDING TO THE REAL DIMENSIONS OF THE DIFFERENT PROTON 
CA  PARTITIONS. AT
CA  THIS STAGE WE KNOW THESE DIMENSIONS AND HAVE STORED THEM IN 
CA  IARG_KEEP.
      IF(NBLOCKS.GT.0)THEN
      REWIND 21
      DO NB=1,NBLOCKS
      READ(21)(IARG(IPA),IPA=1,NDIFFM)
      READ(21)((TABLENP(I+IARGO(IPA)),
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1),
     2  IPA=1,NDIFFM)
      READ(21)((TABLEJJ(I+IARGO(IPA)),
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1),
     2  IPA=1,NDIFFM)
      READ(21)((TABLEN(I+IARGO(IPA)),
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1),
     2  IPA=1,NDIFFM)
      DO IPA=1,NDIFFM
      IARGO(IPA)=IARG(IPA)+IARGO(IPA)-1
      END DO
      END DO
      END IF
      IF(NBLOCKS.GT.0)WRITE(6,551)PRJFIL(1:LONGP),LLL-1
551   FORMAT(1X,A<LONGP>,'.JJ FILE HAS BEEN OPENED'/
     1' NO. OF PROJECTION COEFFICIENTS = ',I)
CA  SET UP DO LOOP LIMITS FOR JMJP1 AND JMJP2
      ISTART(1)=1
      DO IPA=2,NDIFFM
      IF(NBLOCKS.EQ.0)THEN
      ISTART(IPA)=ISTART(IPA-1)+MAX_STORE
      ELSE
      ISTART(IPA)=ISTART(IPA-1)+IARG_KEEP(IPA-1)
      END IF
      END DO
      CLOSE(21,DISPOSE='DELETE')
C  Entry JMJP1 and then return

      ENTRY JMJP1
CA SUBROUTINE FOR ADMIXTURE OF PROTON PARTITIONS
C  Apply J+
      DO IPAR1=1,NDIFFM
      DO J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1
      COEF_JP(TABLEN(J))=COEF_JP(TABLEN(J))+FACP(TABLENP(J))*
     1               COEF0(TABLEJJ(J))
      END DO
      END DO
C  Now apply J-
      DO IPAR1=1,NDIFFM
      DO J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1
      COEF(TABLEJJ(J))=COEF(TABLEJJ(J))+FACP(TABLENP(J))*
     1               COEF_JP(TABLEN(J))
      END DO
      END DO

      DO IW=1,NDIMP
      COEF_JP(IW)=0.
      END DO

      RETURN

      ENTRY JMJP2(IPAR)
CA  SUBROUTINE FOR GOOD PROTON PARTITION STATES
C  Apply J+
      DO J=ISTART(IPAR),ISTART(IPAR)+IARG_KEEP(IPAR)-1
      COEF_JP(TABLEN(J))=COEF_JP(TABLEN(J))+FACP(TABLENP(J))*
     1               COEF0(TABLEJJ(J))
      END DO
C  Now apply J-

      DO 10016  J=ISTART(IPAR),ISTART(IPAR)+IARG_KEEP(IPAR)-1 
      IBAB1 = TABLEN(J)
      IF(COEF_JP(IBAB1).EQ.0.) GO TO 10016 
      IBAB2 = TABLEJJ(J)
      IBAB3 = TABLENP(J)
      XBAB1 = FACP(IBAB3)
      XBAB2 = COEF_JP(IBAB1)
      XBAB = XBAB1*XBAB2 
      COEF(IBAB2)=COEF(IBAB2)+XBAB
10016 CONTINUE    

CBAB      DO J=ISTART(IPAR),ISTART(IPAR)+IARG_KEEP(IPAR)-1
CBAB      COEF(TABLEJJ(J))=COEF(TABLEJJ(J))+FACP(TABLENP(J))*
CBAB     1               COEF_JP(TABLEN(J))
CBAB      END DO

      DO IW=1,NDIMP
      COEF_JP(IW)=0.
      END DO

      RETURN
      END

      SUBROUTINE BWRITE(IDEV,NSPS,NLWRDS,ICMPT)
C  THIS SUBROUTINE OUTPUTS A BINARY PATTERN HELD IN ICMPT
C  ONTO DEVICE IDEV IN ASCII
      IMPLICIT INTEGER(A-Z)
      PARAMETER MAX_NLWRDS=2,MAX_NSPS=32*MAX_NLWRDS
      DIMENSION ICMPT(MAX_NLWRDS)
      CHARACTER *1 PATRN(MAX_NSPS+15*MAX_NLWRDS)
CA  ABOVE, NO. 15 TO ALLOW A BLANK EVERY FOUR BITS
      IP=0
      DO 10 N=1,NSPS
CA  LEAVE BLANK EVERY FOUR BITS
      IF (MOD(N-1,4).NE.0) GO TO 9
      IP=IP+1
      PATRN(IP)=' '
9     IP=IP+1
      PATRN(IP)='0'
      IF(LIB_BTX(ICMPT(1),N-1,NLWRDS))PATRN(IP)='1'
10    CONTINUE
      WRITE(IDEV,11)(PATRN(I),I=IP,1,-1)
11    FORMAT(' ',100A1)
      RETURN
      END

