C
C
C
C  THESE TO APPLY J- T- PROJECTION OPERATORS
C
C
      SUBROUTINE JTPROJ(JJJ) 
      INCLUDE 'SHGRLIB:MACFOR.INC'                
      INCLUDE 'SHGR:PARAM.INC'                
      INCLUDE 'REAL.INC'                
      INCLUDE 'PRJCOM.INC'                
      REAL*8 XBAB,XBAB1,XBAB2
C  APPLY J-PROJECTION OPERATOR
C  JMJP0 J-J+ TO COEF0 AND RETURN RESULT IN COEF
C  JMJP0 IS APPLIED TO ALL M-SCHEME BASIS STATES, AND IT WILL
CA INCREAMENT TO RANDOM VECTOR COEFFIENTS
C  [J**2 = J-J+ + JZ(JZ+1)]
      DOUBLE PRECISION UNIT 
      COMMON/READ/NJTA(NO_JVAL,NO_TVAL)
      INCLUDE 'SHGR:DATA.INC'                

CBAB      SUBROUTINE JMJP0 
CBAB      INCLUDE 'SHGRLIB:MACFOR.INC'                
CBAB      INCLUDE 'SHGR:PARAM.INC'                
CBAB      INCLUDE 'REAL.INC'                
CBAB      INCLUDE 'PRJCOM.INC'                
      INTEGER *2 IBAB1,IBAB2,IBAB3
      INTEGER *2 NPSTORE(MAX_STORE,MAX_IPROT),
     1TABLENP(MAX_IPROT*MAX_STORE) 
      INTEGER *2 JJSTORE(MAX_STORE,MAX_IPROT),
     1NSTORE(MAX_STORE,MAX_IPROT), 
     1TABLEJJ(MAX_STORE*MAX_IPROT),TABLEN(MAX_STORE*MAX_IPROT)
      DIMENSION IPOSN(MAX_NSPS),IARG(MAX_IPROT),ISTART(MAX_IPROT) 
      DIMENSION JPATRN(MAX_NLWRDS),MPATRN(MAX_NLWRDS), 
     1IARG_KEEP(0:MAX_IPROT),IARGO(MAX_IPROT),KEEP_SUM(0:MAX_IPROT)
      EQUIVALENCE(TABLENP(1),NPSTORE(1,1)) 
      EQUIVALENCE(TABLEJJ(1),JJSTORE(1,1)) 
      EQUIVALENCE(TABLEN(1),NSTORE(1,1)) 
CBAB      INCLUDE 'SHGR:DATA.INC'                

CBAB      SUBROUTINE TMPP0 
CBAB      INCLUDE 'SHGRLIB:MACFOR.INC'                
CBAB      INCLUDE 'SHGR:PARAM.INC'                
CBAB      INCLUDE 'REAL.INC'                
CBAB      INCLUDE 'PRJCOM.INC'                
      INTEGER *2 TTSTORE(MAX_TTORE),NTTORE(MAX_TTORE) 
      INTEGER *2 JJ20(NUNIT20),N20(NUNIT20) 
      DIMENSION JPATRNT(MAX_NLWRDS),MPATRNT(MAX_NLWRDS),IPOSNT(MAX_NSPS) 
CBAB      INCLUDE 'SHGR:DATA.INC'                


CA FIND PROTON PARTITION
      IF(JJJ.NE.0)THEN 
      DO 10003  IPTN=1,NDIFFM 
      IF(LIB_EQX(NP_DIFF(1,IPTN),IPROT(1,JJJ),N_WORDS))GOTO 19 
      IF(IPTN.EQ.NDIFFM)STOP ' ***** FATAL ERROR in JTPROJ: A  
     1PROTON PARTITION HAS NOT  BEEN FOUND *****' 
C      END DO 
10003 CONTINUE    
      END IF 
19    IBP=0 
      IZ=0 
      NPRJ=0 
20    IF (IMZSA.GE.MAXJZ) GO TO 30 
CWEO      IF(NPRJ.GT.0)TYPE 61,(WOTPT_BYTE(I),I=NJL,1,-1),JJJ,NPRJ,TEMP 
CBAB      IF(NPRJ.GT.0)WRITE(6,61)(WOTPT(I),I=MAX_NJL,1,-1),JJJ,NPRJ,TEMP 
CBAB61    FORMAT(' Partition   JJJ  NPRJ  Rounding error  ',/ 
CBAB     112I3,2I5,E15.7) 
      IF(NPRJ.GT.0)WRITE(6,61)JJJ,NPRJ,TEMP,(WOTPT(I),I=NJL,1,-1)
61    FORMAT(1X,'OUTPUT MAY BE IN ERROR: IF SO, REPLACE PROJ WITH PROJQ'
     1/,1X,'JJJ,NPRJ,Rounding error,Partition = ',2I5,E15.7,50I3)
      JJJJ=JJJ 
CA    IF(NJT.EQ.1) JJJJ=0
      JABAB = 0
      DO 29 JA=IMZSA,MAXJZ,2
      JABAB = JABAB+1
CBAB      TYPE 6666,JA,JABAB,NJTA(JABAB,1)
6666  FORMAT(1X,3I5)
CBAB      DO 29 JA=MAXJZ,IMZSA,-2 
CBAB      IF(NJTA(JABAB,1).EQ.0) GO TO 29
C                              SKIP PROJECTION OF J OF INTEREST 
      IF (JA.EQ.JAY) GO TO 29 
CD     IF(ILPT.GT.3) WRITE(IDEV,2001)JJJ,IMZSA,MAXJZ,NDIMII,JA 
2001    FORMAT(/,1X,'JJJ,IMZSA,MAXJZ,NDIMII,JA',5I5,' IN JTPROJ')
2000    FORMAT(1X,I4,2D9.2)     

CA  JMJP_FLAG PROJECTS ONLY IN FIRST PASS(RANDOM VECTOR) AND 
CA  STORES COEFFICIENTS

      IF (JMJP_FLAG) THEN 
CA  IT SHOULD BE HERE ONLY ONCE FOR EACH PARTITION
              CALL READBAS(2) 
C*BT   IF(.NOT.LIB$STAT_TIMER(2,ICPU3,HANDLE)) STOP ' FATAL ERROR JMJP0  
C*BT  1TIMER1' 
        JMJP_FLAG=.FALSE.  

CBAB JMJP0

CA   THIS SUBROUTINE APPLIES THE TOTAL J-J+ OPERATOR WITHOUT GOOD
C    PROTON PARTITION.
CA   IT IS USED FOR RANDOM VECTOR FIRST AND J TO PROJECT OUT ONLY
C    IT APPLIES J-J+ OPERATORS TO COEF0 AND RETURNS RESULT IN COEF.
CA   COEF IS THEN,THE OUTPUT OF THE SUBROUTINE
CA   J-J+ IS TAKEN AS A SUM OVER NNM(NNP)SINGLE PARTICLE J- (J+)
CA   OPERATORS. SEE DO LOOPS 300 AND 200.
CA   INITIALLY WE HAVE SOME WAVEFUNCTION |W>=SUMi COEF0(i)IBASIS(i)
CA   RETURNS J-J+|W>= SUMi COEF(i)IBASIS(i)

      KEEP_SUM(0)=0 
      IARG_KEEP(0)=0 
      NBLOCKS=0 
      LLL = 1 
CA  NP_DIFF IS AN ARRAY WITH ALL POSSIBLE DIFFERENT PROTON PARTITIONS,
CA  IPA PRESENT PROTON PARTITION. THEY ARE ARBITRARILY NUMBERED FROM 1 TO
CA  MAX_IPROT
CA  IARG PRESENT NUMBER OF COEFFICIENTS - 1 STORED FOR EACH OF THE PROTON 
CA  PARTITIONS
CA  IARG_KEEP NUMBER OF COEFFICIENTS FOR EACH PROTON PARTITION. IT IS
CA  EQUAL TO IARG -1 WHEN UNIT 21 IS NOT USED, OR ELSE THE SUM OVER IARG
CA  OVER THE PRESENT AND WRITTEN RECORDS
CA  KEEP_SUM SUM OF IARG_KEEP(IPA) FOR I.LE.IPA
CA  IARGO LIKE KEEP-SUM BUT ONLY OVER THE RECORDS READ AT ANY GIVEN MOMENT

      DO 10001  IPA=1,NDIFFM 
      IARGO(IPA)=0 
      IARG_KEEP(IPA)=0 
      IARG(IPA)=1 
      KEEP_SUM(IPA)=0 
C      END DO 
10001 CONTINUE    

      NDIM2B=NDM2P/2 

CA   START OF THE LOOP OVER THE BASIS STATES

      DO 400 JJ=1,NDIMII 
CA  SORT OUT THE PROTON PARTITION TO STORE IT.
      DO 10002  IPA=1,NDIFFM 
      IF(LIB_EQX(NP_DIFF(1,IPA),IPROT(1,JJ),N_WORDS))GO TO 12 
C      END DO 
10002 CONTINUE    
      STOP ' JMJP0: ONE PROTON PARTITION IS NOT IN THE TABLE' 
12    CONTINUE 
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(IBASIS(1,JJ),JPATRN(1),NLWRDS) 
      IF(IMAC.EQ.0) JPATRN(1)=IBASIS(1,JJ) 
      NPTCLE=0 


CA   NEXT DO LOOP FINDS WHERE THE PARTICLES IN JPATRN ARE.FINDS IN WHAT SINGLE
CA   PARTICLE STATES THEY ARE AND STORES THE RESULT IN IPOSN.


      DO 11003  I=1,NLWRDS 
      NSTART=0 
CA  SEE RUNTIME MANUAL FOR SUBROUTINE LIB$FFS.SHORTLY,IT FINDS THE
CA  FIRST BIT IN JPATRN(1) THAT OCCURS FROM POSITION NSTART ONWARDS.
CA  IT RETURNS THE POSITION  OF THE FIRST OCCURENCE IN N.
CWEO20    IF(.NOT.LIB$FFS(NSTART,32,JPATRN(I),N))GO TO 10 
CWEO LIB$FFS REPLACED 30 APRIL 1986 WITH SHELL-MODEL LIBRARY ROUTINE
CWEO LIB_WHERE_BIT SO THAT COMPATABILITY WITH OTHER COMPUTERS IS POSSIBLE
2020  IF(.NOT.LIB_WHERE_BIT(NSTART,MAX_BIT_NLWRDS,JPATRN(I),N))GO TO 10 
CWEO      IF(N.GT.31)GO TO 10 
      IF(N.GT.(MAX_BIT_NLWRDS-1))GO TO 10 
      NSTART=N+1 
      NPTCLE=NPTCLE+1 
CWEO      IPOSN(NPTCLE)=NSTART+(I-1)*32 
      IPOSN(NPTCLE)=NSTART+(I-1)*MAX_BIT_NLWRDS
      GO TO 2020
10    CONTINUE 
C      END DO 
11003 CONTINUE    


CA   WE SHALL NOW APPLY J+(DO 300)AND THEN J-(DO 200)

      DO 300  NNP=1,NPTCLE 
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(JPATRN(1),IPATRN(1),NLWRDS) 
      IF(IMAC.EQ.0) IPATRN(1)=JPATRN(1) 
C                          NP POSITION WHERE PARTICLE IS 
      NP=IPOSN(NNP)       

CA   JP TELLS WHAT PATTERN WE GET WHEN WE APPLY J+(NNP) TO IPATRN.
CA   J+(NNP) IS APPLIED ONLY ON PARTICLE IN POSITION NP AND IT
CA   MOVES IT TO POSITION JP.
      JP=JPLUS(NP) 
      IF(JP.EQ.0)GO TO 300 
      IF(IMAC.NE.0) GO TO 5040 
      IBAB=0 
      IF(JIAND(IPATRN(1),2**(JP-1)).NE.0) IBAB=1 
CWEO      IPATRN(1)=IPATRN(1).OR.2**(JP-1) 
      IPATRN(1)=JIOR(IPATRN(1),2**(JP-1)) 
      IF(IBAB.EQ.1) GO TO 300 
      GO TO 5041 
5040  CONTINUE 
      IF(LIB_BTSX(IPATRN(1),JP-1,NLWRDS))GOTO 300 
5041  CONTINUE 

CA   WE HAVE JUST CHECKED (and set) THAT THE PLACE IS EMPTY,SO NOW CHANGE THE
CA   PLACE OF THE PARTICLE.

      CALL LIB_BTCX(IPATRN(1),NP-1,NLWRDS) 
CWEO      IF(IMAC.EQ.0) IPATRN(1)=IPATRN(1).AND..NOT.2**(NP-1) 


CA   NEXT FEW LINES,UP TO LABEL 110 IS THE FIND SUBROUTINE.IF YOU
CA   WANT THE COMMENTED VERSION SEE FINDP.FOR.

      N=NDIMP 
      IF(IMAC.NE.0) GO TO 5030 
      IF(IPATRN(1).EQ.IBASISP(1,N))GO TO 110 
      GO TO 5031 
5030  IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110 
5031  CONTINUE 
      N=NDIM2B 
      M=N 
      IF(IMAC.NE.0) GO TO 5050 
      IF(IPATRN(1).LT.IBASISP(1,N))GO TO 101 
      IF(IPATRN(1).EQ.IBASISP(1,N))GO TO 110 
      GO TO 5051 
5050  IF(LIB_LTX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 101 
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110 
5051  CONTINUE 
      M=M/2 
      N=NDIMP-M 
      GO TO 102 
101   M=M/2 
      N=N-M 

CA   **********************************************************************
102   IF(M.EQ.0)THEN 
      WRITE(6,'(1X,''Initial pattern'')') 
       CALL BWRITE(6,NSPS,NLWRDS,JPATRN) 
      WRITE(6,'(1X,''Final pattern'')') 
       CALL BWRITE(6,NSPS,NLWRDS,IPATRN) 
       WRITE(6,335)NP,JP 
335    FORMAT(' NP,JP = ',2I4) 
      NMAX=MIN(100,NDIMP) 
      WRITE(6,'(1X,''BASIS'')') 
      DO 10004  I=1,NMAX 
       CALL BWRITE(6,NSPS,NLWRDS,IBASISP(1,I)) 
C      END DO 
10004 CONTINUE    
       STOP 'ERROR IN JMJP0:  
     1A BASIS PATTERN HAS NOT BEEN FOUND-ARRAYS DIMENSIONS COULD  
     1BE WRONG. COMPILE WITH CHECK SWITCH' 
      END IF 
CA   *********************************************************************

      IF(IMAC.NE.0) GO TO 5060 
      IF(IPATRN(1).LT.IBASISP(1,N))GO TO 101 
      IF(IPATRN(1).EQ.IBASISP(1,N))GO TO 110 
      GO TO 5061 
5060  IF(LIB_LTX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 101 
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110 
5061  CONTINUE 
      M=M/2 
      N=N+M 
      GO TO 102 
110   CONTINUE 
CA   WORK OUT THE PHASE
      IPHASP=1 
      IF(IMAX.EQ.0)THEN 
      IF(IMAC.NE.0) GO TO 5070 
      IF(JIAND(JPATRN(1),2**NP).NE.0)IPHASP=-1 
      GO TO 5071 
5070  IF(LIB_BTX(JPATRN(1),NP,NLWRDS))IPHASP=-1 
5071  CONTINUE 
      END IF 
      IF(FACP(NP).EQ.0)STOP ' ***** FATAL ERROR in JMJP: FACP.EQ.0 *****
     1' 
CJ   *********************************************************************
      IF(IARG(IPA).LT.MAX_STORE)THEN 
       IPACK=NP+NSPS*((1-IPHASP)/2) 
       NPSTORE(IARG(IPA),IPA)=IPACK 
       JJSTORE(IARG(IPA),IPA)=JJ 
       NSTORE (IARG(IPA),IPA)=N 
      ELSE 
       IPACK=NP+NSPS*((1-IPHASP)/2) 
       NPSTORE(IARG(IPA),IPA)=IPACK 
       JJSTORE(IARG(IPA),IPA)=JJ 
       NSTORE (IARG(IPA),IPA)=N 
       LLL=LLL+1 
       LTEST=LLL 
       IARG(IPA)=IARG(IPA)+1 
       NBLOCKS=NBLOCKS+1 
       WRITE(21)(IARG(I),I=1,NDIFFM) 
       WRITE(21)((NPSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((JJSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((NSTORE (I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       DO 10005  I=1,NDIFFM 
       IARG_KEEP(I)=IARG_KEEP(I)+IARG(I)-1 
       IARG(I)=1 
C       END DO 
10005  CONTINUE    
       GO TO 300 
      ENDIF 
      LLL=LLL+1 
      IARG(IPA)=IARG(IPA)+1 
CJ   *********************************************************************
300   CONTINUE 
400   CONTINUE 
       DO 10006  IPA=1,NDIFFM 
       IARG_KEEP(IPA)=IARG_KEEP(IPA)+IARG(IPA)-1 
       KEEP_SUM(IPA)=KEEP_SUM(IPA-1)+IARG_KEEP(IPA) 
C       END DO 
10006  CONTINUE    
       IF(LLL-1.GT.MAX_IPROT*MAX_STORE)THEN 
        WRITE(6,501)LLL-1 
501     FORMAT(' JMJP0: INCREASE MAX_IPROT*MAX_STORE TO =',I10) 
        STOP 
       END IF 
      IF(NBLOCKS.GT.0.AND.LTEST.NE.LLL)THEN 
       NBLOCKS=NBLOCKS+1 
       WRITE(21)(IARG(IPA),IPA=1,NDIFFM) 
       WRITE(21)((NPSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((JJSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((NSTORE (I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
      ENDIF 
CA  READ THEM ORDERLY AND DUMP THEM IN THE TABLES AVOINDING THE BLANKS
CA  INITIALLY WE DIMENSIONED THE ARRAYS IN MAX_IPROT BLOCKS OF MAX_STORE
CA  PLACES EACH. THE WRITING IN UNIT 21 WAS PERFORMED IN ORDER TO DIVIDE 
CA  THE PLACES
CA  ACCORDING TO THE REAL DIMENSIONS OF THE DIFFERENT PROTON PARTITIONS. AT
CA  THIS STAGE WE KNOW THESE DIMENSIONS AND HAVE STORED THEM IN IARG_KEEP.
      IF(NBLOCKS.GT.0)THEN 
       REWIND 21 
      DO 10007  NB=1,NBLOCKS 
       READ(21)(IARG(IPA),IPA=1,NDIFFM) 
       READ(21)((TABLENP(I+IARGO(IPA)), 
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1), 
     2  IPA=1,NDIFFM) 
       READ(21)((TABLEJJ(I+IARGO(IPA)), 
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1), 
     2  IPA=1,NDIFFM) 
       READ(21)((TABLEN(I+IARGO(IPA)), 
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1), 
     2  IPA=1,NDIFFM) 
      DO 10008  IPA=1,NDIFFM 
      IARGO(IPA)=IARG(IPA)+IARGO(IPA)-1 
C      END DO 
10008 CONTINUE    
C      END DO   
10007 CONTINUE    
      END IF 
      IF(NBLOCKS.GT.0)WRITE(6,551)PRJFIL(1:LONGP),LLL-1 
551   FORMAT(1X,A9,'.JJ FILE HAS BEEN OPENED'/ 
     1' NO. OF PROJECTION COEFFICIENTS = ',I10) 
CA  SET UP DO LOOP LIMITS FOR JMJP1 AND JMJP2
      ISTART(1)=1 
      DO 10009  IPA=2,NDIFFM 
      IF(NBLOCKS.EQ.0)THEN 
       ISTART(IPA)=ISTART(IPA-1)+MAX_STORE 
      ELSE 
       ISTART(IPA)=ISTART(IPA-1)+IARG_KEEP(IPA-1) 
      END IF 
C      END DO 
10009 CONTINUE    
      CLOSE(21) 
C  Entry JMJP1 and then return
       
CBAB      ENTRY JMJP1 
CA SUBROUTINE FOR ADMIXTURE OF PROTON PARTITIONS
C  Apply J+
      DO 10010  IPAR1=1,NDIFFM 
      DO 10011 JBAB = 1,2
      DO 10011  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF_JP(TABLEN(J),JBAB)=COEF_JP(TABLEN(J),JBAB)
     1+FACP(TABLENP(J))* 
     1               COEF0(TABLEJJ(J),JBAB) 
C      END DO 
10011 CONTINUE    
C      END DO 
10010 CONTINUE    
C  Now apply J-
      DO 10012  IPAR1=1,NDIFFM 
      DO 10013 JBAB = 1,2
      DO 10013  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF(TABLEJJ(J),JBAB)=COEF(TABLEJJ(J),JBAB)
     1+FACP(TABLENP(J))* 
     1               COEF_JP(TABLEN(J),JBAB) 
C      END DO 
10013 CONTINUE    
C      END DO 
10012 CONTINUE    

      DO 10014  IW=1,NDIMP 
      DO 10014 JBAB = 1,2
      COEF_JP(IW,JBAB)=0. 
C      END DO 
10014 CONTINUE    

CBAB      RETURN 

CBAB        CALL JMJP0 

C*BT   IF(.NOT.LIB$STAT_TIMER(2,ICPU4,HANDLE)) STOP 'FATAL ERROR  
C*BT  1JMJP0 TIMER2' 
C*BT   JMJP0_TIME = JMJP0_TIME + ICPU4 - ICPU3 
      ELSE IF(JJJ.EQ.0)THEN 
C*BT   IF(.NOT.LIB$STAT_TIMER(2,ICPU5,HANDLE)) STOP 'JMJP1 TIMER1' 

CBAB        CALL JMJP1 
CBAB      ENTRY JMJP1 
CA SUBROUTINE FOR ADMIXTURE OF PROTON PARTITIONS
C  Apply J+
      DO 12010  IPAR1=1,NDIFFM 
      DO 12011 JBAB = 1,2
      DO 12011  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF_JP(TABLEN(J),JBAB)=COEF_JP(TABLEN(J),JBAB)
     1+FACP(TABLENP(J))* 
     1               COEF0(TABLEJJ(J),JBAB) 
C      END DO 
12011 CONTINUE    
C      END DO 
12010 CONTINUE    
C  Now apply J-
      DO 12012  IPAR1=1,NDIFFM 
      DO 12013 JBAB = 1,2
      DO 12013  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF(TABLEJJ(J),JBAB)=COEF(TABLEJJ(J),JBAB)
     1+FACP(TABLENP(J))* 
     1               COEF_JP(TABLEN(J),JBAB) 
C      END DO 
12013 CONTINUE    
C      END DO 
12012 CONTINUE    

      DO 12014  IW=1,NDIMP 
      DO 12014 JBAB = 1,2
      COEF_JP(IW,JBAB)=0. 
C      END DO 
12014 CONTINUE    

C*BT   IF(.NOT.LIB$STAT_TIMER(2,ICPU6,HANDLE)) STOP 'JMJP1 TIMER2' 
C*BT   JMJP1_TIME = JMJP1_TIME + ICPU6 - ICPU5 
      ELSE 

CA  GET THE TABLE
C*BT   IF(.NOT.LIB$STAT_TIMER(2,ICPU7,HANDLE)) STOP 'JMJP2 TIMER1' 

CBAB        CALL JMJP2(IPTN) 
CBAB      ENTRY JMJP2(IPAR) 
      IPAR = IPTN

CA  SUBROUTINE FOR GOOD PROTON PARTITION STATES
C  Apply J+
      DO 10015  J=ISTART(IPAR),ISTART(IPAR)+IARG_KEEP(IPAR)-1 
      DO 10015 JBAB = 1,2
CBAB      TYPE 7777,J,TABLEN(J),TABLENP(J),TABLEJJ(J)
CBAB7777  FORMAT(1X,'J+ ',10I5)
      IF(COEF0(TABLEJJ(J),JBAB).NE.0) 
     1COEF_JP(TABLEN(J),JBAB)=COEF_JP(TABLEN(J),JBAB)
     1+FACP(TABLENP(J))* 
     1               COEF0(TABLEJJ(J),JBAB) 
C      END DO 
10015 CONTINUE    
C  Now apply J-
      DO 10016 JBAB = 1,2
      DO 10016  J=ISTART(IPAR),ISTART(IPAR)+IARG_KEEP(IPAR)-1 
      IBAB1 = TABLEN(J)
      IF(COEF_JP(IBAB1,JBAB).EQ.0.) GO TO 10016 
      IBAB2 = TABLEJJ(J)
      IBAB3 = TABLENP(J)
      XBAB1 = FACP(IBAB3)
      XBAB2 = COEF_JP(IBAB1,JBAB)
      XBAB = XBAB1*XBAB2 
      COEF(IBAB2,JBAB)=COEF(IBAB2,JBAB)+XBAB
      
CBAB      IF(COEF_JP(TABLEN(J)).NE.0) 
CBAB     1COEF(TABLEJJ(J))=COEF(TABLEJJ(J))+FACP(TABLENP(J))* 
CBAB     1               COEF_JP(TABLEN(J)) 
C      END DO 
10016 CONTINUE    

      DO 10017  IW=1,NDIMP 
      DO 10017 JBAB = 1,2
      COEF_JP(IW,JBAB)=0. 
C      END DO 
10017 CONTINUE    

C*BT   IF(.NOT.LIB$STAT_TIMER(2,ICPU8,HANDLE)) STOP 'JMJP2 TIMER2' 
C*BT   JMJP2_TIME = JMJP2_TIME + ICPU8 - ICPU7 
      END IF 

      DO 20000 JJ = 1,NDIMII
      JSQ4=JA*(JA+2) 
      SING=(IMZSQ4-JSQ4)*.25 
      DEN=(JAYSQ4-JSQ4)*.25 
      UNIT=SING/DEN 
      COEF0(JJ,2) = COEF0(JJ,1)*UNIT
      COEF0(JJ,1) = COEF(JJ,1)/DEN
      IF(JJ.EQ.1) TYPE 20010,JJJ,JA,COEF0(JJ,1),COEF0(JJ,2)
20010 FORMAT(1X,2I4,2E12.4)
20000 CONTINUE
CBAB      JJJJ=1 
CBAB      IF(UNIT.NE.1)THEN 
CBAB      DO 11004   JJ=1,NDIMII 
CBABCA  SETS NEW WFN TO PROJECT OUT NEXT J-VALUE
CBAB      COEF0(JJ) = COEF(JJ)/DEN + UNIT*COEF0(JJ) 
CBABC      END DO 
CBAB11004 CONTINUE    
CBAB      ELSE 
CBAB      DO 11005  JJ=1,NDIMII 
CBAB      COEF0(JJ)=COEF(JJ)/DEN +COEF0(JJ) 
CBABC      END DO 
CBAB11005 CONTINUE    
CBAB      END IF 

CBAB      IF(JJJ.EQ.0) GO TO 7782
CBBA      XBAB = 0.
CBAB      DO 7778 JJ = 1,NDIMII
CBAB      IF(JA.EQ.40) TYPE 7779,JJJ,JJ,COEF0(JJ)
CBAB7779  FORMAT(1X,2I4,E12.4)
CBAB7778  XBAB = XBAB + COEF0(JJ)*COEF0(JJ)
CBAB      XBAB = COEF0(JJJ)
CBAB      DO 7780 JJ = 1,NDIMII
CBAB      COEF0(JJ) = COEF0(JJ)/XBAB
CBAB      IF(JA.EQ.40) TYPE 7779,JJJ,JJ,COEF0(JJ)
CBAB7780   CONTINUE
CBAB7782  CONTINUE

      DO 11006  JJ=1,NDIMII 
      DO 11006 JBAB = 1,2
      COEF(JJ,JBAB)=0 
C      END DO 
11006 CONTINUE    
CEO29 END DO                                  !-------END DO OVER J-VALUES 
 29     CONTINUE

      JJJJ = 1
      SING=1.
      DEN =1.
      DO 20029 JA=IMZSA,MAXJZ,2
      IF(JA.EQ.JAY) GO TO 20029
      JSQ4=JA*(JA+2) 
      XXBAB1 = (IMZSQ4-JSQ4)*.25
      XXBAB2 = (JAYSQ4-JSQ4)*.25
CBAB      SING=(IMZSQ4-JSQ4)*.25
CBAB      DEN=(JAYSQ4-JSQ4)*.25
      DEN = DEN*XXBAB2/10.
      UNIT=UNIT*XXBAB1/XXBAB2
20029 CONTINUE
CBAB      UNIT=SING/DEN 
      IF(UNIT.NE.1)THEN 
      DO 11004   JJ=1,NDIMII 
CA  SETS NEW WFN TO PROJECT OUT NEXT J-VALUE
CBAB      COEF0(JJ,1) = COEF0(JJ,1)/DEN + UNIT*COEF0(JJ,2) 
      COEF0(JJ,1) = COEF0(JJ,1) + COEF0(JJ,2) 
      TYPE 20030,JJ,COEF0(JJ,1),COEF0(JJ,1),COEF0(JJ,2)
20030 FORMAT(1X,I4,3E12.4)
C      END DO 
11004 CONTINUE    
      ELSE 
      DO 11005  JJ=1,NDIMII 
      COEF0(JJ,1)=COEF(JJ,1)/DEN +COEF0(JJ,1) 
C      END DO 
11005 CONTINUE    
      END IF 


CA    WRITE(IDEV,1235)(COEF0(IJK),IJK=1,NDIMII) 
CA1235  FORMAT('GOOD J BAD T'/<NDIMII/10+1>(10D10.2/)) 
CA  COEF0 ARE NOW THE COEFFCIENTS OF A GOOD J AND A BAD T WFN (HOPEFULLY)
C
C     JUMP WITHOUT CHECKING FOR GOOD PROJECTION UNLESS IROU > 0 

      IF(IROU.LT.1.AND.JJJ.NE.0) GO TO 30 
C
CA  J**2 = J-J+ + Jz(Jz+1)
CA  J**2(sumi COEF0(i)) = sumi COEF(i) + Jz(Jz+1) = J(J+1)(sumi COEF0(i))

CBAB      CALL JMJP1 
CBAB      ENTRY JMJP1 
CA SUBROUTINE FOR ADMIXTURE OF PROTON PARTITIONS
C  Apply J+
      DO 13010  IPAR1=1,NDIFFM 
      DO 13011  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF_JP(TABLEN(J),1)=COEF_JP(TABLEN(J),1)
     1+FACP(TABLENP(J))* 
     1               COEF0(TABLEJJ(J),1) 
C      END DO 
13011 CONTINUE    
C      END DO 
13010 CONTINUE    
C  Now apply J-
      DO 13012  IPAR1=1,NDIFFM 
      DO 13013  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF(TABLEJJ(J),1)=COEF(TABLEJJ(J),1)+FACP(TABLENP(J))* 
     1               COEF_JP(TABLEN(J),1) 
C      END DO 
13013 CONTINUE    
C      END DO 
13012 CONTINUE    

      DO 13014  IW=1,NDIMP 
      COEF_JP(IW,1)=0. 
C      END DO 
13014 CONTINUE    

      TEMP=0. 
      DO 42 JJ=1,NDIMII 
      TEM=COEF(JJ,1)+(IMZSQ4-JAYSQ4)*.25*COEF0(JJ,1) 
      TEMP=TEMP+TEM*TEM 
42    COEF(JJ,1)=0 
      NPRJ=NPRJ+1 
      NPRJM=MAX0(NPRJ,NPRJM) 
      IF(JJJ.NE.0)THEN 
       IF (COEF0(JJJ,1).LT.1E-20) IZ=1 
      END IF 
      IF (NPRJ.GT.5) IBP=1 
      IF (IBP+IZ.GT.0) GO TO 777 
      IF(JJJ.NE.0)TEMP=TEMP/COEF0(JJJ,1) 
44    IF (TEMP.GT.PJLIM)THEN 
      IROU=1 
      GO TO 20 
      END IF 
CA SUCESS!
      IF(ILPT.GT.2)WRITE(IDEV,2010)TEMP 
2010  FORMAT(' After J-projection, J**2 was reapplied  
     1new vector differs in modulus from previous one in',E15.7) 

CA  IF IT GOES TO 20 IT WILL PROJECT AGAIN BUT START WITH PRESENT COEF0S,
CA  RATHER THAN COEF0(JJJ)=1 AND ALL THE REST =0. WHAT IT ACTUALLY DOES
CA  IS PJT PJT|IBASIS(JJJ)>. SECOND (AND FOLLOWING) PROJECTIONS MIGHT
CA  BE NEEDED BECAUSE OF ROUDING ERRORS. IT WILL TRY THIS UP TO FIVE TIMES
C
C   APPLY T-PROJECTION OPERATOR
C   TMTP APPLIES T-T+
C
30    IF (ITZSA.GE.MAXTZ) GO TO 777 
        IF(IMAX.NE.0) STOP ' ***** FATAL ERROR in PRJSBS: IMAX.NE.0 and 
     1ITZSA.NE.MAXTZ *****' 
      NPRT=0 
50    JJJJ=JJJ 
CA    IF(NJT.EQ.1) JJJJ=0 
      DO 39 JA=ITZSA,MAXTZ,2 
      IF (JA.EQ.ITT) GO TO 39 
      IF(TMTP_FLAG)THEN 
         TMTP_FLAG=.FALSE. 

CBAB         CALL TMTP0 
CBAB      SUBROUTINE TMPP0 

CA   THE TWO SUBROUTINES JMJP0 AND TMTP0 ARE ESSENTIALLY
CA   THE SAME. THEY DIFFERS IN THAT TMTP0 HAS IPHASE=FACPM(NP,NM)=1
CA   THIS SUBROUTINE APPLIES THE TOTAL T-T+ OPERATOR WITH NO GOOD
C    PROTON PARTITION.
C    IT APPLIES T-T+ OPERATORS TO COEF0 AND RETURNS RESULT IN COEF.
CA   COEF IS THEN, THE OUTPUT OF THE SUBROUTINE
CA   T-T+ IS TAKEN AS A SUM OVER NNM(NNP)SINGLE PARTICLE T- (T+)
CA   OPERATORS. SEE DO LOOPS 300 AND 200.


      LLLT = 1 
      ITIMET=1 
      NBLOCKST=0 

      NDIM2BT=NDM2II/2 

CA   START OF THE LOOP OVER THE BASIS STATES

      DO 20400 JJ=1,NDIMII 
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(IBASIS(1,JJ),JPATRNT(1),NLWRDS) 
      IF(IMAC.EQ.0) JPATRNT(1)=IBASIS(1,JJ) 
      NPTCLET=0 


CA   NEXT DO LOOP FINDS WHERE THE PARTICLES IN JPATRNT ARE (I.E. IN WHAT SINGLE
CA   PARTICLE STATES THEY ARE) AND STORES THE RESULT IN IPOSNT.


      DO 20001  I=1,NLWRDS 
      NSTARTT=0 
CA  SEE RUNTIME MANUAL FOR SUBROUTINE LIB$FFS.SHORTLY,IT FINDS THE
CA  FIRST BIT IN JPATRNT(1) THAT OCCURS FROM POSITION NSTARTT ONWARDS.
CA  IT RETURNS THE POSITION  OF THE FIRST OCCURENCE IN N.
CWEO20    IF(.NOT.LIB$FFS(NSTARTT,32,JPATRNT(I),N))GO TO 10 
3020  IF(.NOT.LIB_WHERE_BIT(NSTARTT,MAX_BIT_NLWRDS,JPATRNT(I),N))
     1GO TO 3010 
      IF(N.GT.(MAX_BIT_NLWRDS-1))GO TO 3010 
      NSTARTT=N+1 
      NPTCLET=NPTCLET+1 
      IPOSNT(NPTCLET)=NSTARTT+(I-1)*MAX_BIT_NLWRDS 
      GO TO 3020 
3010  CONTINUE 
C      END DO 
20001 CONTINUE    

CA   WE SHALL NOW APPLY T+(DO 20300)AND THEN T-(DO 20200)

      DO 20300  NNP=1,NPTCLET 
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(JPATRNT(1),IPATRN(1),NLWRDS) 
      IF(IMAC.EQ.0) IPATRN(1)=JPATRNT(1) 
      NP=IPOSNT(NNP) 
      JP=TPLUS(NP) 

CA   JP TELLS WHAT PATTERN WE GET WHEN WE APPLY T+(NNP) TO IPATRN.
CA   T+(NNP) IS APPLIED ONLY ON PARTICLE IN POSITION NP AND IT
CA   MOVES IT TO POSITION JP.

      IF(JP.EQ.0)GO TO 20300 
      IF(IMAC.NE.0) GO TO 25050 
      IF(JIAND(IPATRN(1),2**(JP-1)).NE.0)GO TO 20300 
      GO TO 25051 
25050 IF(LIB_BTX(IPATRN(1),JP-1,NLWRDS))GO TO 20300 
25051 CONTINUE 

CA   WE HAVE JUST CHECKED THAT THE PLACE IS EMPTY,SO NOW CHANGE THE
CA   PLACE OF THE PARTICLE.

      CALL LIB_BTSX(IPATRN(1),JP-1,NLWRDS) 
      CALL LIB_BTCX(IPATRN(1),NP-1,NLWRDS) 
CWEO      IF(IMAC.EQ.0) IPATRN(1)=IPATRN(1).OR.2**(JP-1) 
CWEO      IF(IMAC.EQ.0) IPATRN(1)=IPATRN(1).AND..NOT.2**(NP-1) 

      DO 20200 NNM=1,NPTCLET 
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(IPATRN(1),MPATRNT(1),NLWRDS) 
      IF(IMAC.EQ.0) MPATRNT(1)=IPATRN(1) 
      NM=IPOSNT(NNM) 
      IF(NNP.NE.NNM)GO TO 2050 

C    THEY ARE EQUAL,SO WE ARE APPLYING T+ AND T- TO THE SAME 
C    PARTICLE. REMEMBER THAT T+ HAS ALREADY MOVED THE PARTICLE TO
CA   NP+2.

      N=JJ 
      NM=NP+2 
      GO TO 20110 

CA   THEY ARE DIFFERENT PARTICLES, SO REPEAT PROCEDURE OF DO 300
CA   BUT NOW FOR T-:

2050  JM=TMIN(NM) 
      IF(JM.EQ.0)GO TO 20200 
      IF(IMAC.NE.0) GO TO 25060 
      IF(JIAND(MPATRNT(1),2**(JM-1)).NE.0)GO TO 20200 
      GO TO 25061 
25060  IF(LIB_BTX(MPATRNT(1),JM-1,NLWRDS))GO TO 20200 
25061  CONTINUE 
      CALL LIB_BTSX(MPATRNT(1),JM-1,NLWRDS) 
      CALL LIB_BTCX(MPATRNT(1),NM-1,NLWRDS) 
CWEO      IF(IMAC.EQ.0) MPATRNT(1)=MPATRNT(1).OR.2**(JM-1) 
CWEO      IF(IMAC.EQ.0) MPATRNT(1)=MPATRNT(1).AND..NOT.2**(NM-1) 


CA   NEXT FEW LINES,UP TO LABEL 110 IS THE FIND SUBROUTINE.IF YOU
CA   WANT THE COMMENTED VERSION SEE FINDP.FOR

      N=NDIMII 
      IF(IMAC.NE.0) GO TO 25070 
      IF(MPATRNT(1).EQ.IBASIS(1,N))GO TO 20110 
      GO TO 25071 
25070  IF(LIB_EQX(MPATRNT(1),IBASIS(1,N),NLWRDS))GO TO 20110 
25071  CONTINUE 
      N=NDIM2BT 
      M=N 
      IF(IMAC.NE.0) GO TO 25080 
      IF(MPATRNT(1).LT.IBASIS(1,N))GO TO 20101 
      IF(MPATRNT(1).EQ.IBASIS(1,N))GO TO 20110 
      GO TO 25081 
25080  IF(LIB_LTX(MPATRNT(1),IBASIS(1,N),NLWRDS))GO TO 20101 
      IF(LIB_EQX(MPATRNT(1),IBASIS(1,N),NLWRDS))GO TO 20110 
25081  CONTINUE 
      M=M/2 
      N=NDIMII-M 
      GO TO 20102 
20101 M=M/2 
      N=N-M 

CA   **********************************************************************
20102 IF(M.EQ.0)STOP 'ERROR IN TMTP0:  
     1A BASIS PATTERN HAS NOT BEEN FOUND- ARRAYS DIMENSIONS COULD  
     1BE WRONG. TRY COMPILING WITH CHECK SWITCH' 
CA   *********************************************************************

      IF(IMAC.NE.0) GO TO 25090 
      IF(MPATRNT(1).LT.IBASIS(1,N))GO TO 20101 
      IF(MPATRNT(1).EQ.IBASIS(1,N))GO TO 20110 
      GO TO 25091 
25090 IF(LIB_LTX(MPATRNT(1),IBASIS(1,N),NLWRDS))GO TO 20101 
      IF(LIB_EQX(MPATRNT(1),IBASIS(1,N),NLWRDS))GO TO 20110 
25091 CONTINUE 
      M=M/2 
      N=N+M 
      GO TO 20102 
20110 COEF(N,1)=COEF(N,1)+COEF0(JJ,1) 
      IF(LLLT.LE.MAX_TTORE)THEN 
       TTSTORE(LLLT) = JJ 
       NTTORE(LLLT) = N 
      ELSE 
       IF(ITIMET.LT.NUNIT20)THEN 
        N20(ITIMET)=N 
        JJ20(ITIMET)=JJ 
        ITIMET=ITIMET+1 
       ELSE 
        N20(NUNIT20)=N 
        JJ20(NUNIT20)=JJ 
        WRITE(20)JJ20,N20 
        ITIMET=1 
        NBLOCKST=NBLOCKST+1 
       ENDIF 
      ENDIF 
      LLLT = LLLT + 1 

20200 CONTINUE 
20300 CONTINUE 
20400 CONTINUE 
      IF(ITIMET.GT.1)THEN 
       WRITE(20)JJ20,N20 
       NBLOCKST=NBLOCKST+1 
      ENDIF 
      IF(LLLT-1.GT.MAX_TTORE)WRITE(6,501)PRJFIL(1:LONGP),LLLT-1 
20501 FORMAT(1X,A9,'.TT FILE HAS BEEN OPENED'/ 
     1' NO. OF COEFFICIENTS = ',I10) 
CBAB      RETURN 

      ELSE 

CBAB         CALL TMTP1 

CBAB      ENTRY TMTP1 
      DO 20002  J=1,MIN(LLLT-1,MAX_TTORE) 
      COEF(NTTORE(J),1)=COEF(NTTORE(J),1) + COEF0(TTSTORE(J),1) 
C      END DO 
20002 CONTINUE    
      IF(LLLT-1.GT.MAX_TTORE)THEN 
       REWIND 20 
       DO 20003  JSW=1,NBLOCKST 
       NUMBER=NUNIT20 
       IF(JSW.EQ.NBLOCKST)NUMBER=ITIMET-1 
       READ(20)JJ20,N20 
       DO 20004  IKP=1,NUMBER 
       COEF(N20(IKP),1)=COEF(N20(IKP),1)+COEF0(JJ20(IKP),1) 
C       END DO 
20004  CONTINUE    
C       END DO 
20003  CONTINUE    
      END IF 
CBAB      RETURN 
CBAB      END 

      ENDIF 
      JJJJ=1 
      JSQ4=JA*(JA+2) 
      SING=(ITZSQ4-JSQ4)*.25 
      DEN=(ITTSQ4-JSQ4)*.25 
      DO 11007  JJ=1,NDIMII 
      COEF0(JJ,1)=(COEF(JJ,1)+SING*COEF0(JJ,1))/DEN 
      COEF(JJ,1)=0 
C      END DO 
11007 CONTINUE    
CEO39 END DO 
 39     CONTINUE
      IF(IROU.LT.2)GO TO 777 
CA TEST OF PROJECTION ACCURACY FOR T-PROJECTION

CBAB      CALL TMTP1 
CBAB      ENTRY TMTP1 

      DO 30002  J=1,MIN(LLLT-1,MAX_TTORE) 
      COEF(NTTORE(J),1)=COEF(NTTORE(J),1) + COEF0(TTSTORE(J),1) 
C      END DO 
30002 CONTINUE    
      IF(LLLT-1.GT.MAX_TTORE)THEN 
       REWIND 20 
       DO 30003  JSW=1,NBLOCKST 
       NUMBER=NUNIT20 
       IF(JSW.EQ.NBLOCKST)NUMBER=ITIMET-1 
       READ(20)JJ20,N20 
       DO 30004  IKP=1,NUMBER 
       COEF(N20(IKP),1)=COEF(N20(IKP),1)+COEF0(JJ20(IKP),1) 
C       END DO 
30004  CONTINUE    
C       END DO 
30003  CONTINUE    
      END IF 
CBAB      RETURN 
CBAB      END 

      TEMP2=0 
      DO 11008  JJ=1,NDIMII 
      TEM=COEF(JJ,1)+(ITZSQ4-ITTSQ4)*.25*COEF0(JJ,1) 
      TEMP2=TEMP2+TEM*TEM 
      COEF(JJ,1)=0 
C      END DO 
11008 CONTINUE    
      NPRT=NPRT+1 
      IF(NPRT.GT.5)IBP=1 
      IF(JJJ.NE.0)THEN 
       IF(COEF0(JJJ,1).LT.1.E-20)IZ=1 
      END IF 
      IF(IBP+IZ.GT.0)GO TO 777 
      IF(JJJ.NE.0)TEMP2=TEMP2/COEF0(JJJ,1) 
      IF(TEMP2.GT.PJLIM)GO TO 50 
      IF(ILPT.GT.2)WRITE(IDEV,2005)TEMP2 
2005  FORMAT(' After T-projection, T**2 was reapplied, and  
     1new vector differs in modulus from previous one in',D15.7) 
CA  Extra check for rounding errors. Done always.
CA  Check is: <JJJ|PP|JJJ>=<JJJ|P|JJJ>= COEF0(JJJ). Should also be equal to
CA  Sum Coef0(i)**2. Limit of difference 1.0E-5. On failing, it projects
CA  again. 
777   IF(JJJ.NE.0)THEN 
CBAB      XBAB = COEF0(JJJ)
CBAB      DO 11109  I=1,NDIMII
CBBA      COEF0(I)=COEF0(I)*XBAB
CBAB11109 CONTINUE    
      OPEN(UNIT=98,FILE='TEMP.DAT',STATUS='NEW')
      COEFK=0 
      DO 11009  I=1,NDIMII 
      WRITE(98,8888) JJJ,I,COEF0(I,1)
8888  FORMAT(1X,2I5,F10.5)
      COEFK=COEFK+COEF0(I,1)**2 
C      END DO 
11009 CONTINUE    
      CLOSE(UNIT=98)
C*DP   TEMP=ABS(COEFK-COEF0(JJJ,1)) 
CBAB      TEMP=DABS(COEFK-COEF0(JJJ,1)) 
      TEMP=ABS(COEFK-COEF0(JJJ,1)) 
CBAB      GO TO 8888
      IF(TEMP.GT.1.E-5)THEN 
      WRITE(6,188)JJJ,COEFK,COEF0(JJJ,1) 
188   FORMAT(' ***** INFORMATION in PRJSBS: Rounding error for JJJ =', 
     1I4,/,1X,' Next two numbers should be equal ',2D11.3,' *****') 
      NPRJ=NPRJ+1 
      IF(NPRJ.GT.3)THEN 
      WRITE(6,15101)
15101 FORMAT(1X,' ***** INFORMATION: Tried 3 times - Above vector 
     1 rejected *****') 
      WRITE(6,'(1X)')
C              Signal bad projection to main program 
      IBP=1   
      RETURN 
      ENDIF 
C                 Reproj 
      GO TO 20   
      END IF 
CBAB8888  CONTINUE
      END IF 
      RETURN 
      END 


CCC
