c************************************************************************
c
c     (5/6/1996) Newest version of the SHELL program to be converted to
c     UNIX. This version relies on the use of the Korn Shell (a' la version
c     by Mihai Horoi, 1993). To be used with the OXBASH program on DEC OSF/1
c     Alpha computers. The rest of the OXBASH program is almost identical
c     to the VMS version.
c
c     -   Steven Karataglidis, NSCL, 1996.
c
c************************************************************************
c
c     Note that ALL strings which refer to IO or files have been
c     converted to lower case as is consistent with normal UNIX
c     operation. This applies to ALL OXBASH programs.
c
c************************************************************************
C     
C     SHELL.FOR
C
      implicit real(a-h,o-z)
      implicit integer(i-n)
      INCLUDE 'shlcom.inc'
      COMMON/IZOUT/IZOUT
      COMMON/CISOBAB/ISOBAB
      COMMON/CSPSOP2/SPSOP2
      COMMON/INDICES/IPPR                 ! EKW
      COMMON/MATFILS/MATFILS
      character*9 matfil1
      character cmatfil*500,cmatfil1*500,cmf*1,ccom*70
      character cmatfil2*500
      character*1 iplt
      integer ictlfil,ioption
      character*9 p2fil
      CHARACTER*9 MATFILS
      CHARACTER*9 SPSOP2
      CHARACTER*1 MS(10),ACAP
      CHARACTER *9 PFIL,BFIL,OFIL,OPFILI,BAS_INT,GNDFIL_OLD
      CHARACTER*9 ADUMMY
      CHARACTER*200 OPFILR
      CHARACTER *72 DEFDIR,DEFSDIR
      PARAMETER (MAX_OPNAME=20)
      CHARACTER*13 OPNAME(MAX_OPNAME)
      LOGICAL EXIST,EXIST2
      COMMON/HNORM/SPE_NORM(11),XME_NORM(11),OPFILI(11),NINT,BAS_INT
C     1MNOSC(MAX_NOSC),MXOSC(MAX_NOSC)

      ivers = 2             ! as commented out from DATA.INC
      iopname = 0           ! explicit assignment required for g77
                            ! S.K. -- 4/11/1997
      SPSOP2 = ' '
      LONG_EXE=INDEX(AREA_EXE,' ')-1
      LONG_RUN=INDEX(AREA_RUN,' ')-1
      BLANK='         '
      IF(IFPS.EQ.0)THEN
      LONG_RU=LONG_EXE+8
c     RUN='''$RUN '//AREA_EXE(1:LONG_EXE)//''','
c
c     On UNIX systems, only the program name is needed to execute -- S.K.
c
      run = area_exe(1:long_exe)
      ELSE
      LONG_RU=10
      RUN='''CLEAR'',/,'
      END IF
      EFIL1 = BLANK
      EFIL2 = BLANK
      EFIL3 = BLANK
      GNDFIL=BLANK
      USER=AREA_EXE
      IOPTION = 0
CBAB TOOK OUT READ AND WRITE TO UNIT=7 IN RBAS ON DEC 17 1985
CBAB TO DO THIS PROPERLY ONE MUST INCLUDE CHECKS ON THE RESTRICTIONS
CBAB OF PREVIOUS BASIS RUNS
CBAB IN ANY CASE, BASIS USUALLY RUNS VERY QUICKLY
CBAB  OPEN(7,STATUS='SCRATCH',CARRIAGECONTROL='LIST',FILE='SHELL.SCT')
      CALL TITLE(0)
      CALL RUN_AREA(DEFSDIR)
      IPPR = 0
7700  print 400
400   FORMAT(//' Name for command file (<CR>=SHELL) : ',$)
      READ(5,2,ERR=7720) CTLFIL
      IF(CTLFIL.EQ.' ') CTLFIL = 'shell'
      DO 7621 I = 13,1,-1
      IF(CTLFIL(I:I).EQ.'.') GO TO 7622
7621  CONTINUE
C      OPEN(UNIT=51,FILE=CTLFIL//'.ANS',STATUS='NEW',
C     1CARRIAGECONTROL='LIST',dispose='delete')
      ictlfil = index(ctlfil,' ') - 1
      OPEN(UNIT=51,FILE=CTLFIL(1:ictlfil)//'.ans',STATUS='new')
      GO TO 7623
7622  CONTINUE
      OPEN(UNIT=5,FILE=CTLFIL(1:ictlfil),STATUS='old')
      CTLFIL(I:I) = ' '
      CTLFIL(I+1:I+1) = ' '
      CTLFIL(I+2:I+2) = ' '
      CTLFIL(I+3:I+3) = ' '
      OPEN(UNIT=51,FILE='temp.ans',STATUS='new')
7623  CONTINUE
 
      IF(CTLFIL.EQ.' ') CTLFIL = 'shell'
      OPEN(UNIT=21,FILE=CTLFIL(1:index(ctlfil,' ')-1)//
     1'.shl',STATUS='new')
 
      OPEN(UNIT=50,FILE=CTLFIL(1:index(ctlfil,' ')-1)//
     1'.rec',STATUS='new')
c      OPEN(UNIT=50,FILE=CTLFIL//'.REC',STATUS='NEW',
c     1CARRIAGECONTROL='LIST')
c//////////////////////////////////////////////////////////
c
c       (S.K. 5/6/1996:) The first line of a Korn shell script
c       is
c               #!/bin/ksh
c
c       This sets it up:
c
c//////////////////////////////////////////////////////////
      write(21,'(''#!/bin/ksh'')')
 
      CALL TITLE(50)
      WRITE(50,400)
 
 
      DEFDIR='.'       !   default in UNIX
      NPOS=3
 
      WRITE(21,4061)
c4061  FORMAT('$SET NOON'11X,'! do not crash on errors'
c     1,/'$SET VERIFY')
 4061 format('set echo        # set the output flag')
      IF(DEFSDIR.NE.' ')THEN
      NPOS=INDEX(DEFSDIR,' ')
      WRITE(21,255)DEFSDIR(1:NPOS-1)
c255   FORMAT('$SET DEFAULT ',A)
 255  format('cd ',A)         ! UNIX equivalent.
cbab      WRITE(21,256)DEFSDIR(1:NPOS-1)
Cbab256   FORMAT('$ASSIGN ',A,' RSH:')
      END IF
cbab      write(21,4062)
cbab4062  format('$ set def ''p1'':')
 
 
c1    FORMAT(30I)
c*****************************************************
c
c     (5/6/1996) Anything with this format statement
c     changed to free-formats. Hopefully it will work
c     elsewhere. This is consistent with other UNIX
c     versions.
c
c*****************************************************
 2    FORMAT(5A)
 3    FORMAT(10(I5,','))
 4    FORMAT(A1)
 5    FORMAT(10F15.0)
 6    FORMAT(10(F12.6,','))
 9    FORMAT(/)
C
C
305   IBAS=0
      IPROJ=0
      IOPER=0
      IMAT=0
      IPRD=0
      ITRMP=0
      ILANC=0
      IMVEC = 0
      IDEM = 0
      IDEL = 0
      XDUM = ZNORMBAB(-1,0)
        XDUM=ZNORM(-1,0,1)
        XDUM=ZNORM(-1,0,2)
        XDUM=ZNORM(-1,0,3)
      GO TO 5013
5012  print 5010
      WRITE(50,5010)
CBAB5010  FORMAT(/,1X,'LAN  : (BASIS,PREDICT,PRIORPROJ,MATRIX,LANCZOS)'
CBAB     1      ,/,1X,'TRP  : (MVEC,TRAMP) For overlaps, parentage
CBAB     1 amplitudes, OBTD and TBTD'
CBAB     1,/,1X,'DET  : For a more detailed selection of IBAS,... etc.'
CBAB     1      ,/,1X,'DEL  : Delete, rename files or any wild command'
CBAB     1      ,/,1X,'EXIT : Exit')
5010  FORMAT(
     1/,1X,'Normal sequences are:'
     1/,1X,'LPE in this job and then DEN in this or a latter job'
C     1/,1X,'VEC in this job and then DEN in this job'
C     1/,1X,'VEC in this job and then DEM in a latter job'
     1/,1X,'LPE,N  : Set up the command file to obtain eigenvalues'
     1/,1X,'       : and eigenvectors and keep everything'
     1/,1X,'       : N is the number of eigenvectors to keep
     1 (default = 10)'
     1/,1X,'VEC,N  : Same as LPE except that the *.VEC file needed by'
     1/,1X,'       : DEN will be made and then all unnecessary files'
     1/,1X,'       : (extensions:RED,PRJ,MAH,MAT,LTF,PAB,PAC) will
     1 be deleted'
     1/,1X,'DEN    : Set up the command file to obtain parentage'
     1/,1X,'       : amplitudes, or OBTD or TBTD'
C     1/,1X,'       : (*.VEC file created if LPE has been used
C     1 previously)'
C     1/,1X,'DEM    : Same as DEN except that we assume that *.VEC'
C     1/,1X,'       : file has been created in a previous job'
     1/,1X,'ADD    : Will add arbitrary lines to the command file'
     1/,1X,'ST     : Stop'
     1/,1X,'H      : Help')
 5013 CONTINUE
 7701 print 5011
      IOPTION = IOPTION + 1
      WRITE(50,5011)
CBAB5011 FORMAT(/,1X,'Option (LAN,TRP,DET,DEL,STOP OR HELP) : ',$)
5011  FORMAT(/,1X,'Option (vec, lpe, den, st or h) : ',$)
      READ(5,5029,ERR=7701) OPTION,ISPM,IZOUT,ES0,ES2,ES4
      write(51,5029) OPTION,ISPM,IZOUT,ES0,ES2,ES4
5029  FORMAT(A3,1X,2I3,3F6.3)
C   ******************************
CBAB GET INTO CAPITOL LETTERS
c     ACAP = OPTION(1:1)
c     CALL CAP(ACAP)
c     OPTION(1:1) = ACAP
c     ACAP = OPTION(2:2)
c     CALL CAP(ACAP)
c     OPTION(2:2) = ACAP
c     ACAP = OPTION(3:3)
c     CALL CAP(ACAP)
c     OPTION(3:3) = ACAP
c
c     Switched off for UNIX operation. -- S.K. 5/6/1996.
C   ***************************
      NEIG=10
C      IF(ISPM.GT.0) NEIG = ISPM
      IF(ISPM.NE.0) NEIG = ISPM
      IF(OPTION.EQ.'det')  GO TO 5000
CBAB      IF(OPTION.EQ.'LAN')  GO TO 5030
CBAB      IF(OPTION.EQ.'TRP')  GO TO 5032
      IF(OPTION.EQ.'h')    GO TO 5012
      IF(OPTION.EQ.'st') GO TO 5020
      IF(OPTION.EQ.' ')    GO TO 5020
      IF(OPTION.EQ.'lpe')  GO TO 5130
      IF(OPTION.EQ.'mat')  GO TO 5131
      IF(OPTION.EQ.'ppr')  GO TO 5134
      IF(OPTION.EQ.'mec')  GO TO 5135
      IF(OPTION.EQ.'lan')  GO TO 5132
      IF(OPTION.EQ.'bas')  GO TO 5133
      IF(OPTION.EQ.'vec')  GO TO 5036
      IF(OPTION.EQ.'den')  GO TO 5032
      IF(OPTION.EQ.'dem')  GO TO 5037
      IF(OPTION.EQ.'del')  GO TO 5033
      IF(OPTION.EQ.'add')  GO TO 5033
      print 5034
      WRITE(50,5034)
5034  FORMAT(/,1X,'NOT A VALID OPTION. Try again, please')
      GO TO 5012
5033  CONTINUE
      CALL DEL
      GO TO 5012
5036  CONTINUE
      IDEL = 1
      IDEM = 1
      GO TO 5130
5037  CONTINUE
      IDEM = 1
      GO TO 5032
C                     Set up for autolanczos
5130  CONTINUE
      IBAS=1
      IPRD=1
      IPROJ=1
      IMAT=1
      ILANC=1
      IAUT=1
      GO TO 5001
5131  CONTINUE
      IBAS=0
      IPRD=0
      IPROJ=0
      IMAT=1
      ILANC=1
      IAUT=1
      GO TO 5001
5132  CONTINUE
      IBAS=0
      IPRD=0
      IPROJ=0
      IMAT=0
      ILANC=1
      IAUT=1
      GO TO 5001
5133  CONTINUE
      IBAS=1
      IPRD=0
      IPROJ=0
      IMAT=0
      ILANC=0
      IAUT=1
      GO TO 5001
5134  CONTINUE
      IPPR = 1
      IBAS=1
      IPRD=0
      IPROJ=1
      IMAT=1
      ILANC=1
      IAUT=1
      GO TO 5001
5135  CONTINUE
      IBAS=0
      IPRD=0
      IPROJ=0
      IMAT=0
      ILANC=0
      ITRMP = 0
      IDEL = 0
      IDEM = 1
      IAUT=1
      GO TO 5001
C                   set up for autotramp
5032  CONTINUE
      ITRMP=1
      IAUT=1
      GO TO 5001
5000  CONTINUE
      IAUT=1
7702  print 300
      WRITE(50,300)
300   FORMAT(' Autoshell ? : ',$)
CBAB  ACCEPT 4, ANS
      READ(5,4,ERR=7702) ANS
      write(51,4) ANS
      IF (ANS.EQ.'n') IAUT=0
      GO TO 500
C
C  AUTOSHELL
C
308   P2FIL=' '
      GNDFIL=BLANK
      NBAS=IBAS
      NPROJ=IPROJ
      NPRD=NPROJ
      NMAT=IMAT
      NLANC=ILANC
      NMVEC=IMVEC
      NELEV=IELEV
      IELEV=0
      N=NBAS+NPRD+NPROJ+NMAT+NMVEC+NELEV+NLANC+IOPER
C                               TRAMP?
      IF (N.EQ.0) GO TO 380
      ISHELL=-1
CA  SET UP TO RUN BASIS WITH AUTOSHELL
C?    CALL HNORM(SPSFIL,OPFIL,NPTCL)
      CALL RBAS
7703  print 312
      WRITE(50,312)
312   FORMAT(' Interaction filename : ',$)
CBAB  ACCEPT 2, ANS
      READ(5,2,ERR=7703) ANS
      write(51,2) ANS
      IF (ANS.NE.' ') OPFIL=ANS
CBAB ***** GET INTO CAPITOL LETTERS *****
c     ACAP = OPFIL(1:1)
c     CALL CAP(ACAP)
c     OPFIL(1:1) = ACAP
c     ACAP = OPFIL(2:2)
c     CALL CAP(ACAP)
c     OPFIL(2:2) = ACAP
c     ACAP = OPFIL(3:3)
c     CALL CAP(ACAP)
c     OPFIL(3:3) = ACAP
c     ACAP = OPFIL(4:4)
c     CALL CAP(ACAP)
c     OPFIL(4:4) = ACAP
c     ACAP = OPFIL(5:5)
c     CALL CAP(ACAP)
c     OPFIL(5:5) = ACAP
c     ACAP = OPFIL(6:6)
c     CALL CAP(ACAP)
c     OPFIL(6:6) = ACAP
c     ACAP = OPFIL(7:7)
c     CALL CAP(ACAP)
c     OPFIL(7:7) = ACAP
CBAB ********************
313   CONTINUE
7704  print 314
      WRITE(50,314)
314   FORMAT(' Min. J, Max. J : (2F) : ',$)
C
CBAB  ACCEPT 5, SPIN1,SPIN2
      READ(5,*,ERR=7704) SPIN1,SPIN2
      write(51,*) SPIN1,SPIN2
c9055  FORMAT(10F)
      JMIN=2*SPIN1
      JMAX=2*SPIN2
      JMIN_KEEP=JMIN
      JMAX=MAX0(JMIN,JMAX)
      GROUFLAG=.TRUE.
      IF (JMIN.LT.0) GO TO 305
CBAB  IF(ISOSPIN)THEN
      IF(ISOBAB.EQ.0)THEN
7705  print 315
      WRITE(50,315)
315   FORMAT(' Min. T, Max. T : (2F) : ',$)
CBAB  ACCEPT 5, SPIN1,SPIN2
      READ(5,*,ERR=7705) SPIN1,SPIN2
      write(51,*) SPIN1,SPIN2
C            Neutron/proton formalism
      ELSE
      SPIN1=IABS(ITZNP)/2.
      SPIN2=SPIN1
      END IF
      ITMIN=2*SPIN1
      ITMAX=2*SPIN2
      ITMIN_KEEP=ITMIN
      ITMAX=MAX0(ITMIN,ITMAX)
      IF (ITMIN.LT.0) GO TO 305
 
cbab      IF (MOD(JMIN+NPTCL,2).NE.0.OR.MOD(ITMIN+NPTCL,2).NE.0)THEN
cbab      IF(MOD(JMIN+NPTCL,2).NE.0)THEN
cbab      print 431,FLOAT(JMIN)/2.,NPTCL
cbab      WRITE(50,431) FLOAT(JMIN)/2.,NPTCL
cbab431   FORMAT(' Careful: Jmin = ',F4.1,' and No.particles =',I3,
cbab     1' Please, try again')
cbab      GO TO 313
cbab      ELSE
cbab      print 432,FLOAT(ITMIN)/2.,NPTCL
cbab      WRITE(50,432) FLOAT(ITMIN)/2.,NPTCL
cbab432   FORMAT(' Careful: Tmin = ',F4.1,' and No.particles =',I3,
cbab     1' Please, try again')
cbab      GO TO 313
cbab      END IF
cbab      END IF
 
      CALL BADJT(1,-1,-1)
7706  print 317
      WRITE(50,317)
317   FORMAT(' Parity (0=+VE, 1=-VE, 2=both) : ',$)
CBAB  ACCEPT 1, KPARIN
      READ(5,*,ERR=7706) KPARIN
      write(51,*) KPARIN
      IF(KPARIN.NE.0.AND.KPARIN.NE.1.AND.KPARIN.NE.2) GO TO 7706
      IKPARMIN = KPARIN
      IKPARMAX = KPARIN
      IF(KPARIN.EQ.2) IKPARMIN = 0
      IF(KPARIN.EQ.2) IKPARMAX = 1
 
CBAB      IF(ITZNP.LT.0) print 6666,ITZNP
CBAB6666  FORMAT(1X,'Since 2Tz = ',I4,' is negative the parity label
CBAB     1 will be increased by 2 units')
CBAB      IF(ITZNP.LT.0) KPAR = KPAR+2
      IROU=0
      IOUT=0
      ILIM=0
      ILPT = 1
C     ILPT = 0
C     IF(AILPT.EQ.'Y') ILPT = 1
      IF (ILPT.LT.0) GO TO 305
      MSIZE=0
CBAB      NEIG=10
CBAB      IF(ISPM.GT.0) NEIG = ISPM
      IF (ILANC.GT.0.AND.IAUT.EQ.0)THEN
7707    print 405
        WRITE(50,405)
        READ(5,*,ERR=7707) N
        write(51,*) N
        IF(N.EQ.0)NEIG=N
      END IF
      INP=0
      IF (IOPER.GT.0) GO TO 505
340   IMATE=0
      IVEC=0
      ICFN=0
      IEIGB=0
      NVEC=NEIG
CA  Do loop over possible J and T values with autoshell
367   CONTINUE
      DO 360 IKPAR = IKPARMIN,IKPARMAX
      KPAR = IKPAR
      IF(ITZNP.LT.0) print 6666,ITZNP
6666  FORMAT(1X,'Since 2Tz = ',I4,' is negative the parity label
     1 will be increased by 2 units')
      IF(ITZNP.LT.0) KPAR = KPAR+2
      DO 360 IT=ITMIN,ITMAX,2
      ITZS=IT
      DO 360 JAY=JMIN,JMAX,2
      N=1
      CALL BADJT(N,JAY,IT)
      IF (N.LT.0) GO TO 360
CEKW **************
      IMZS = JAY
CEKW      IF(IPPR.EQ.1.AND.JAY.GT.1)IMZS=JAY-2    ! EKW
      CALL LABEL(BASFIL,BASFILP)
CEKW      IMZS=JAY                     ! EKW
      IF (IVERS.LT.0) GO TO 305
      PRJFIL=BASFIL
      CALL LABEL(MATFIL,ADUMMY)
      IF (IVERS.LT.0) GO TO 305
      LPTFIL=MATFIL
      GNDFIL_OLD = GNDFIL
      IF (GNDFIL_OLD.EQ.BLANK) GNDFIL=MATFIL
      ANSGND='     '
      IF (MATFIL.EQ.GNDFIL) ANSGND='y'
      print 355, MATFIL
      WRITE(50,355) MATFIL
355   FORMAT(/' ',A,' :',$)
      IBAS=NBAS
      IPROJ=NPROJ
      IF(IAUT.NE.0)IPRD=IPROJ
      IMAT=NMAT
      ILANC=NLANC
      GO TO 510
360   CONTINUE
CA  Labels have been found out
C
C
C  TRAMP WITH AUTOSHELL
C
C  ONLY ONE MODE WILL RUN PER CALL
C
380   IF (ITRMP.LE.0.AND.IOBOP.LE.0) GO TO 305
      CALL RTRAMP
      GO TO 305
C
C
C
500   CONTINUE
7708  print 502
      WRITE(50,502)
502   FORMAT(' Control IBAS,IPRD,IPROJ,IMAT,ISCHEME,IOPER : ',$)
CBAB  ACCEPT 1, IBAS,IPRD,IPROJ,IMAT,IELEV,IOPER
      READ(5,*,ERR=7708) IBAS,IPRD,IPROJ,IMAT,IELEV,IOPER
      write(51,*) IBAS,IPRD,IPROJ,IMAT,IELEV,IOPER
7709  print 503
      WRITE(50,503)
503   FORMAT(' Control ILANC,ITRMP,IOBOP : ',$)
CBAB  ACCEPT 1, ILANC,ITRMP,IOBOP
      READ(5,*,ERR=7709) ILANC,ITRMP,IOBOP
      write(51,*) ILANC,ITRMP,IOBOP
5001  CONTINUE
C
C
      IF (IAUT.GT.0) GO TO 308
C
C
 505  IF (IOPER.LE.0) GO TO 509
      print 506
      WRITE(50,506)
506   FORMAT('+oper ',$)
c     WRITE(21,'('//RUN(1:LONG_RU)//'''OPER'')')
      write(21,'(''nice time '//run(1:long_exe)//'oper << oplab'')')
508   IF (IAUT.GT.0) GO TO 5088
7710  print 5080
      WRITE(50,5080)
5080  FORMAT(' Line printer output (0=None,1=JT Mat.elemts,2=
     1JzTz Mat.elemts. ',$)
CBAB  ACCEPT 1, INP
      READ(5,*,ERR=7710) INP
      write(51,*) INP
7711  print 5082
      WRITE(50,5082)
5082  FORMAT(' Single-particle state file : ',$)
CBAB  ACCEPT 2, ANS
      READ(5,5083,ERR=7711) ANS
      write(51,5083) ANS
5083  FORMAT(A9)
      IF (ANS.NE.' ') SPSFIL=ANS
 
      CALL NEWLAB(SPSFIL,LONG_SPS)
7712  print 312
      WRITE(50,312)
CBAB  ACCEPT 2, ANS
      READ(5,2,ERR=7712) ANS
      write(51,2) ANS
      IF (ANS.NE.' ') OPFIL=ANS
5088  WRITE(21,3001) INP
c3001  FORMAT(I4,',',10X,'! line printer output (0,1, or 2)')
 3001 format(i4,',',10x,'# line printer output (0,1, or 2)')
      IF(INP.EQ.0) GO TO 5090
      IF(IAUT.GT.0) GO TO 5091
5091  CONTINUE
5090  CONTINUE
      WRITE(21,2010) SPSFIL
c2010  FORMAT(A9,11X,'! SPSFIL name')
 2010 format(a9,11x,'# spsfil name')
      WRITE(21,2011) OPFIL
c2011  FORMAT(A9,11X,'! OPFIL name')
 2011 format(a9,11x,'# opfil name')
      write(21,'(''oplab'')')
      LONG_OP=INDEXF(OPFIL)-1
      LONG_AOP=INDEX(AREA_OP,' ')-1
c     OPFILR = OPFIL(1:LONG_OP)//'.op '//AREA_OP(1:LONG_AOP)//'*.*'
      opfilr = opfil(1:long_op)//'.op '//area_op(1:long_aop)
      WRITE(21,2012) OPFILR(1:long_op+long_aop+3)
      opfilr = opfil(1:long_op)//'.pos '//area_op(1:long_aop)
      WRITE(21,2012) OPFILR(1:long_op+long_aop+4)
c2012  FORMAT('$COPY ',A25)
 2012 format('cp ',a)
      IOPER=IOPER-1
      GO TO 505
C
C
509   IF (IAUT.GT.0) GO TO 340
C
C
510   IF (IBAS.LE.0) GO TO 550
      print 512
      WRITE(50,512)
512   FORMAT('+basis ',$)
      IF(IAUT.NE.0)ISHELL=2
C      CALL HNORM(SPSFIL,OPFIL,NPTCL)
      CALL HNORM1(SPSFIL,OPFIL)  ! to avoid conflict with common -- S.K.
 
      IF(IFPS.EQ.1)CALL FPS_SETUP
 
      CALL RBAS
c      write(21,183),ishell,iaut
c183  FORMAT(3X,'Well, we have got back to shell.',2i3)
      IBAS=IBAS-1
      GO TO 510
C
C
550   CONTINUE
CBAB OCT 1988
CBAB THIS WAS PUT IN TO ALWAYS SKIP PREDICT
      IPRD = 0
      IF(IPRD.LE.0)GO TO 520
      print 551
      WRITE(50,551)
551   FORMAT('+prd ',$)
      WRITE(21,'('//RUN(1:LONG_RU)//'''PREDICT'')')
552   FORMAT('$RU ',A,'PREDICT')
      IF(IAUT.GT.0)GO TO 555
7713  WRITE(6,553)
553   FORMAT(' ILPT (0,1,2) : ',$)
      READ(5,4,ERR=7713)IOUT
      write(51,4)IOUT
7714  WRITE(6,810)
      READ(5,2,ERR=7714) BFIL
      write(51,2) BFIL
      IF (BFIL.NE.' ') BASFIL=BFIL
7715  WRITE(6,556)
556   FORMAT(' Name for predicted-basis : ',$)
      READ(5,2,ERR=7715) PRJFIL
      write(51,2) PRJFIL
      IF (PRJFIL.EQ.' ') PRJFIL=BASFIL
7716  WRITE(6,817)
CBAB  ACCEPT 1,JAY,IT
      READ(5,*,ERR=7716) JAY,IT
      write(51,*) JAY,IT
CBAB555 OUT='N'
555   IOUT=0
      WRITE(21,4020)IOUT
4020  FORMAT(I1,19X,'! ILPT (0,1,2)')
      WRITE(21,2021) BASFIL,BASFILP
2021  FORMAT(A6,',',A6,7X,'! BASFIL,BASFIL2')
      WRITE(21,2022) PRJFIL
2022  FORMAT(A9,11X,'! PRJFIL name')
      WRITE(21,3023) JAY,IT
3023  FORMAT(2(I4,','),10X,'! J*2, T*2')
      IPRD=IPRD-1
      GO TO 550
 
520   IF (IPROJ.LE.0) GO TO 530
      print 522
      WRITE(50,522)
522   FORMAT('+proj ',$)
c     IF(IPPR.NE.1)WRITE(21,'('//RUN(1:LONG_RU)//'''PROJ'')')
c     IF(IPPR.EQ.1)WRITE(21,'('//RUN(1:LONG_RU)//'''PRIORPROJ'')')
      IF(IPPR.NE.1)WRITE(21,'(''nice time '//RUN(1:LONG_EXE)//
     &'proj << projlab'')')
      IF(IPPR.EQ.1)WRITE(21,'(''nice time '//RUN(1:LONG_EXE)//
     &'priorproj << projlab'')')
c521   FORMAT('$RUN ',A,'PROJ')
524   IF (IAUT.GT.0) GO TO 820
7717  print 808
      WRITE(50,808)
808   FORMAT(' Control integers IOUT,ILIM,IROU : ',$)
CBAB  ACCEPT 1, IOUT,ILIM,IROU
      READ(5,*,ERR=7717) IOUT,ILIM,IROU
      write(51,*) IOUT,ILIM,IROU
7718  WRITE(6,810)
810   FORMAT(' Name of basis : ',$)
      READ(5,2,ERR=7718) BFIL
      write(51,2) BFIL
      IF (BFIL.NE.' ') BASFIL=BFIL
7719  WRITE(6,812)
812   FORMAT(' Name for projected-basis : ',$)
      READ(5,2,ERR=7719) PRJFIL
      write(51,2) PRJFIL
      IF (PRJFIL.EQ.' ') PRJFIL=BASFIL
7720  WRITE(6,817)
817   FORMAT(' Value of J*2, T*2 : ',$)
CBAB  ACCEPT 1,JAY,IT
      READ(5,*,ERR=7720) JAY,IT
      write(51,*) JAY,IT
      IDUM = 0
820   WRITE(21,3030) IOUT,ILIM,IROU,0,0    ! a test
c     3030  FORMAT(5(I3,','),5X,'# IOUT,ILIM,IROU,IPMIN,IPMAX')
 3030 format(i2,',',i2,',',i2,',',i2,',',i2,5x,
     & ' # IOUT,ILIM,IROU,IPMIN,IPMAX')
      WRITE(21,2031) BASFIL,BASFILP
2031  FORMAT(A6,',',A6,7X,'# BASFIL,BASFIL2')
      WRITE(21,2032) PRJFIL
2032  FORMAT(A9,11X,'# PRJFIL')
      WRITE(21,3033) JAY,IT
3033  FORMAT(2(I4,','),10X,'# J*2, T*2')
822   IF (ILIM.EQ.0) GO TO 526
      PRDLIM=0.004
      NLILIM=0.003
7721  print 824, PRDLIM,NLILIM
      WRITE(50,824) PRDLIM,NLILIM
824   FORMAT(' PRDLIM = Limit for linear independence prediction'/
     1  ' NLILIM = Limit of linear independence check'/
     1  ' Old limits PRDLIM,NLILIM : ',2F11.6,' NEW LIMITS : ',$)
CBAB  ACCEPT 5,PRDLIM,NLILIM
      READ(5,5,ERR=7721) PRDLIM,NLILIM
      write(51,*) PRDLIM,NLILIM
      WRITE(21,6034) PRDLIM,NLILIM
6034  FORMAT(2(F12.6,','),5X,'# PRDLIM,NLILIM')
526   IPROJ=IPROJ-1
      write(21,'(''projlab'')')     ! end of either PROJ run
      GO TO 520
C
C
530   IF (IMAT.LE.0) GO TO 540
      IF (IAUT.GT.0) GO TO 538
7722  WRITE(6,12)
12    FORMAT(' Name of 2-body interaction : ',$)
      READ(5,2,ERR=7722) OFIL
      write(51,2) OFIL
      IF (OFIL.NE.' ') OPFIL=OFIL
7723  WRITE(6,147)
147   FORMAT(' Name of projected-basis : ',$)
      READ(5,2,ERR=7723) PFIL
      write(51,2) PFIL
      IF (PFIL.NE.' ') PRJFIL=PFIL
7724  WRITE(6,15)
15    FORMAT(' Name for matrix : ',$)
      READ(5,2,ERR=7724) MATFIL
      write(51,2) MATFIL
      IF (MATFIL.EQ.' ') MATFIL=PRJFIL
C538   CALL HNORM(SPSFIL,OPFIL,NPTCL)
 538  CALL HNORM1(SPSFIL,OPFIL)
 
      DO 5504 IINT = 1,NINT
CBAB INSERTED NOV 6, 1983 FOR AUTOMATIC RUNNING OF OPER
      iopfint = index(opfili(iint),' ')-1
      INQUIRE(FILE=OPFILI(IINT)(1:iopfint)//'.op',EXIST=EXIST)
c     IF(EXIST.EQ..TRUE.) GO TO 5501
c     IF(EXIST.EQ..FALSE.) GO TO 6000
      if (exist) goto 5501
      INQUIRE(FILE=AREA_OP(1:index(area_op,' ')-1)//
     &OPFILI(IINT)(1:iopfint)//'.op',EXIST=EXIST2)
c     IF(EXIST2.EQ..TRUE.) GO TO 5501
c     IF(EXIST2.EQ..FALSE.) GO TO 6001
      if (exist2) goto 5501
      IF(IOPNAME.EQ.0) GO TO 5503
CBAB      DO 5502 I = 1,MAX_OPNAME
      DO 5502 I = 1,IOPNAME
5502  IF(OPFILI(IINT).EQ.OPNAME(I)) GO TO 5501
5503  CONTINUE
      IOPNAME = IOPNAME+1
      OPNAME(IOPNAME) = OPFILI(IINT)
       print 5532
       WRITE(50,5532)
5532  FORMAT('+oper ',$)
CWEO  WRITE(21,5531) AREA_EXE(1:LONG_EXE)
c     WRITE(21,'('//RUN(1:LONG_RU)//'''OPER'')')
      write(21,'(''nice time '//run(1:long_exe)//
     &'oper << oplab'')')
      WRITE(21,25001)
25001 FORMAT('0',19X,'# line printer output (0,1, or 2)')
c5531  FORMAT('$RUN ',A,'OPER'/'0',
c     119X,'! line printer output (0,1, or 2)')
      WRITE(21,2040) SPSFIL
2040  FORMAT(A9,11X,'# SPSFIL')
      WRITE(21,2041) OPFILI(IINT)
2041  FORMAT(A9,11X,'# OPFIL')
      write(21,'(''oplab'')')
      OPFILR = OPFILI(IINT)
      LONG_OP=INDEXF(OPFILR)-1
      LONG_AOP=INDEX(AREA_OP,' ')-1
c     OPFILR = OPFILR(1:LONG_OP)//'.op '//AREA_OP(1:LONG_AOP)//'*.*'
      OPFILR = OPFILR(1:LONG_OP)//'.op '//AREA_OP(1:LONG_AOP)
      IF(IFPS.EQ.0)WRITE(21,2012) OPFILR(1:long_op+long_aop+3)
      IF(IFPS.EQ.1)WRITE(21,21012)OPFILI(IINT)(1:LONG_OP),
     1AREA_OP(1:LONG_AOP),OPFILI(IINT)(1:LONG_OP)
      OPFILR = OPFILR(1:LONG_OP)//'.pos '//AREA_OP(1:LONG_AOP)
      IF(IFPS.EQ.0)WRITE(21,2012) OPFILR(1:long_op+long_aop+4)
      IF(IFPS.EQ.1)WRITE(21,21012)OPFILI(IINT)(1:LONG_OP),
     1AREA_OP(1:LONG_AOP),OPFILI(IINT)(1:LONG_OP)
21012 FORMAT('COPYOUT/BIN ',A,'.OP,',A,A,'.OP')
CBAB  IF(ISOSPIN)THEN
CBAB  IF(ISOBAB.EQ.0)THEN
CBAB  GO TO 2014
CBAB  ELSE  !Neutron/proton formalism
CBAB  WRITE(21,2012)
CBAB  END IF
CBAB2014 CONTINUE
      GOTO 5504
5501  CONTINUE
      LONG_OP=INDEX(OPFILI(IINT),' ')
      IF(LONG_OP.EQ.0)LONG_OP=10
      LONG_OP=LONG_OP-1
      LONG_AOP=INDEX(AREA_OP,' ')-1
      IF(IFPS.EQ.1)WRITE(21,25111)AREA_OP(1:LONG_AOP),
     1OPFILI(IINT)(1:LONG_OP),OPFILI(IINT)(1:LONG_OP)
25111 FORMAT('COPYIN/BIN ',A,A,'.OP,',A,'.OP')
5504  CONTINUE
 
      print 532
      WRITE(50,532)
532   FORMAT('+matrix ',$)
CWEO      WRITE(21,533) AREA_EXE(1:LONG_EXE)
c     WRITE(21,'('//RUN(1:LONG_RU)//'''MATRIX'')')
      write(21,'(''nice time '//run(1:long_exe)//
     &'matrix << matlab'')')
c533   FORMAT('$RUN ',A,'MATRIX')
      WRITE(21,531)
531   FORMAT('0',19X,'# Line printer output (0,1, or 2)')
 
      DO 6003 IINT = 1,NINT
CBAB      IF(XME_NORM(IINT).NE.0..AND.SPE_NORM(IINT).NE.0)
      WRITE(21,6002)OPFILI(IINT)
6002  FORMAT(A9,11X,'# OPFIL')
CBAB      IF(XME_NORM(IINT).NE.0..AND.SPE_NORM(IINT).NE.0)
      WRITE(21,6004) SPE_NORM(IINT),XME_NORM(IINT)
6004  FORMAT(F9.5,',',F9.5,',# SPE_NORM,ME_NORM')
6003  CONTINUE
 
c     WRITE(21,6002)OPFILI(NINT+1)
      write(21,'('' '')')
c           must input blank line to terminate OP files
 
      WRITE(21,2050) PRJFIL
2050  FORMAT(A9,11X,'# PRJFIL')
      CALL PN_INT(SPSFIL,OPFIL,MATFIL)
      IF (GNDFIL_OLD.EQ.BLANK) GNDFIL=MATFIL
      WRITE(21,2051) MATFIL
2051  FORMAT(A9,11X,'# MATFIL')
      write(21,'(''matlab'')')
      IMAT=IMAT-1
      GO TO 530
C
C
540   IF (ILANC.LE.0) GO TO 700
      IIII=0
      IIII=IIII+1
      print 6600
      WRITE(50,6600)
6600  FORMAT('+lanczos ',$)
CWEO  IF (ILANC.GT.0) WRITE(21,6561) AREA_EXE(1:LONG_EXE)
c     IF (ILANC.GT.0) WRITE(21,'('//RUN(1:LONG_RU)//'''LANCZOS'')')
      if (ilanc.gt.0)
     &write(21,'(''nice time '//run(1:long_exe)//
     &'lanczos << lanlab'')')
CBAB6561 FORMAT('$RUN [SHELLGROU]LANCZOS')
c6561  FORMAT('$RUN ',A,'LANCZOS')
564   IF (IAUT.GT.0) GO TO 566
7725  WRITE(6,562)
562   FORMAT(' Control integers ILPT,IRAN : ',$)
      READ(5,*,ERR=7725) ILPT,IRAN
      write(51,*) ILPT,IRAN
7726  WRITE(6,543)
543   FORMAT (' Matrix filename : ',$)
      READ(5,2,ERR=7726) MFIL
      write(51,2) MFIL
      IF (MFIL.NE.' ') MATFIL=MFIL
      IF (GNDFIL.EQ.BLANK) GNDFIL=MFIL
7727  print 405
      WRITE(50,405)
405   FORMAT(' Number of eigenvectos reqd. (DEFAULT=10) : ',$)
CBAB  ACCEPT 1, N
      READ(5,*,ERR=7727) N
      write(51,*) N
      NEIG=10
c     IF (N.LE.0) NEIG=N
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
c
c     (S.K. 5/7/1995) The following is more appropriate for
c     inputting a different value of NEIG.
c
c     N = -1 instructs LANCZOS to give all states.
c
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      if ((n.eq.-1).or.(n.gt.0)) neig = n
566   IDUMMY=ILPT
      IF(IDUMMY.EQ.2)IDUMMY=1
      IMIN=100
      izero = 0
      iran = 0
      WRITE(21,3060) IDUMMY,IRAN,IZERO,IMIN,IZERO,IZERO
3060  FORMAT(3(I2,','),I3,',',2(I2,','),6X,'# ILPT,IRAN,IDD,IMIN')
      WRITE(21,2061) MATFIL
      MATFILS = MATFIL
2061  FORMAT(A9,11X,'# MATFIL')
      WRITE(21,3062) NEIG,IZERO,ZERO,IZERO,ES0,ES2,ES4
C3062  FORMAT(2(I4,','),F3.1,',',iI16X,'! NEIG,NOUT,CRIT(keV)')
 3062 FORMAT(I4,',',I2,',',F3.1,',',I2,',',F7.3,',',F7.3,',',
     1F7.3,',# NEIG,NOUT,CRIT(keV),MAXIT,ES0,ES2,ES4')
      IF(IIII.EQ.1)ISHELL=-1
      CALL GROUND
      CALL SPECH
      GROUFLAG=.FALSE.
      ISHELL=2
      if (ilanc.gt.0) write(21,'(''lanlab'')')
786   ILANC=ILANC-1
      IMAT=INDEX(MATFIL,' ')-1
      IF(IFPS.EQ.1)WRITE(21,22011)MATFIL(1:IMAT)
22011 FORMAT('COPYOUT ',A,'.LPE')
CJAB
CJAB    ****** DESTROY FILENAME.MAT,.RED,.PRJ,.LTF,.GND, .ETC ****
CJAB
      IF(IDEM.GT.0) CALL WMVEC(MATFIL,1,NEIG)
c     IF(IDEL.GT.0.AND.IDEM.GT.0) WRITE(21,6564)BASFILP,BASFILP
c     IF(IDEL.GT.0.AND.IDEM.GT.0) WRITE(21,6562)MATFIL,MATFIL,MATFIL,
c    1MATFIL,MATFIL,MATFIL,MATFIL,MATFIL
c     IF(IDEL.GT.0.AND.IDEM.EQ.0) WRITE(21,6563)MATFIL,MATFIL,MATFIL
c    1,MATFIL
      write(cmf,'(i1)') index(matfil,' ') - 1
      cmatfil = '(''/bin/rm '',a'//cmf//',''.ltf''/
     1''/bin/rm '',a'//cmf//',''.prj''/
     2''/bin/rm '',a'//cmf//',''.mah''/
     3''/bin/rm '',a'//cmf//',''.mat'')'
      cmatfil1 = '(''/bin/rm '',a'//cmf//',''.ltf''/
     1''/bin/rm '',a'//cmf//',''.gnd''/
     2''/bin/rm '',a'//cmf//',''.prj''/
     3''/bin/rm '',a'//cmf//',''.pab'')'
      cmatfil2 = '(''/bin/rm '',a'//cmf//',''.mah''/
     5''/bin/rm '',a'//cmf//',''.mat''/
     6''/bin/rm '',a'//cmf//',''.red'')'
      lm = index(matfil,' ')-1
      lbm = index(basfilp,' ')-1
      IF(IDEL.GT.0.AND.IDEM.GT.0) WRITE(21,6564)
     &BASFILP(1:lbm),BASFILP(1:lbm)
      IF(IDEL.GT.0.AND.IDEM.GT.0) WRITE(21,cmatfil1)MATFIL(1:lm),
     &matfil(1:lm),matfil(1:lm),matfil(1:lm)
      IF(IDEL.GT.0.AND.IDEM.EQ.0) WRITE(21,cmatfil2)MATFIL(1:lm),
     &MATFIL(1:lm),MATFIL(1:lm)
      IF(IDEL.GT.0.AND.IDEM.EQ.0) WRITE(21,cmatfil)MATFIL(1:lm),
     1matfil(1:lm),MATFIL(1:lm),matfil(1:lm)
 6564 format(
     &/,'/bin/rm ',a6,'.pab',
     &/,'/bin/rm ',a6,'.pac')
c6564  FORMAT(
c     1/,'$ DELETE ',A6,'.PAB.*',
c     1/,'$ DELETE ',A6,'.PAC.*')
c6563  FORMAT(
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.LTF.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.PRJ.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.MAH.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.MAT.*')
c6562  FORMAT(
c     1'$ DELETE ',A<INDEXF(MATFIL)-1>,'.LTF.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.GND.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.PRJ.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.PAB.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.PAC.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.MAH.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.MAT.*',
c     1/,'$ DELETE ',A<INDEXF(MATFIL)-1>,'.RED.*')
700   CONTINUE
C
710   IF (ITRMP.LE.0) GO TO 720
      CALL RTRAMP
C
C
720   IF (IELEV.LE.0) GO TO 570
      print 722
      WRITE(50,722)
722   FORMAT('+scheme ',$)
CWEO  WRITE(21,721) AREA_EXE(1:LONG_EXE)
c     WRITE(21,'('//RUN(1:LONG_RU)//'''SCHEME'')')
      write(21,'(''nice time '//run(1:long_exe)//
     &'scheme << schlab'')')
CBAB721 FORMAT('$RUN [SHELLGROU]SCHEME')
c721   FORMAT('$RUN ',A,'SCHEME')
726   IPLT = 'n'
      IF (IAUT.GT.0) GO TO 727
7728  print 728
      WRITE(50,728)
728   FORMAT(' Plot energy levels  (Y/N) ? ',$)
CBAB  ACCEPT 4,IPLT
      READ(5,4,ERR=7728) IPLT
      write(51,4) IPLT
7729  print 704
      WRITE(50,704)
704   FORMAT(' Name of eigenfunctions file : ',$)
CBAB  ACCEPT 2, EFIL
      READ(5,2,ERR=7729)  EFIL
      write(51,2)  EFIL
      IF (EFIL.EQ.' ') EFIL=MATFIL
7730  print 724
      WRITE(50,724)
724   FORMAT(' Min. J, Max. J (2F) : ',$)
CBAB  ACCEPT 5,SPIN1,SPIN2
      READ(5,5,ERR=7730) SPIN1,SPIN2
      write(51,*) SPIN1,SPIN2
7731  print 723
      WRITE(50,723)
723   FORMAT(' Min. T, Max. T (2F): ',$)
CBAB  ACCEPT 5,SPIN3,SPIN4
      READ(5,5,ERR=7731) SPIN3,SPIN4
      write(51,*) SPIN3,SPIN4
      CALL BADJT(1,-1,-1)
7732  print 725
      WRITE(50,725)
725   FORMAT(' Max. exct. energy (-1 FOR ALL) : ',$)
CBAB  ACCEPT 5, EMAX
      READ(5,5,ERR=7732) EMAX
      write(51,*) EMAX
      IF (EMAX.LT.0.5) EMAX=15.0
727   WRITE(21,4070) IPLT
4070  FORMAT(I4,',',15X,'# IPLT')
      WRITE(21,2071) EFIL
2071  FORMAT(A,15X,'# EFIL')
      WRITE(21,6072) SPIN1,SPIN2
6072  FORMAT(2(I4,','),10X,'# SPIN1,SPIN2')
      WRITE(21,6073) SPIN3,SPIN4
6073  FORMAT(2(I4,','),10X,'# SPIN3,SPIN4')
      CALL BADJT(1,-2,-2)
      WRITE(21,6074) EMAX
6074  FORMAT(F12.6,',',10X,'# EMAX')
      write(21,'(''shlab'')')
      IELEV=IELEV-1
      GO TO 720
C
C
570   IF (IAUT.NE.0)THEN
      JMIN=IMZS+2
      IF(JMIN.LE.JMAX) GO TO 367
      JMIN=JMIN_KEEP
      ITMIN=ITZS+2
      IF(ITMIN.LE.ITMAX) GO TO 367
      ITMIN = ITMIN_KEEP
      IKPARMIN = IKPARMIN+1
      IF(IKPARMIN.LE.IKPARMAX) GO TO 367
      GO TO 305
      END IF
      GO TO 305
5020  CONTINUE
 
CBAB  IF (IFILE1.EQ.0.AND.IFILE2.EQ.0) GO TO 580
CBAB  IF (IFILE1.GT.100.OR.IFILE2.GT.100) PAUSE
CBAB 1  'ERROR: IFILE1,IFILE2 TOO LARGE'
CBAB376 FORMAT('.TRD FILES :'/
CBAB 1  'FINAL STATE FILES : '/10(1X,5(I2,':',2X,A6,3X)))
CBAB377 FORMAT('INITIAL STATE FILES : '/10(1X,5(I2,':',2X,A6,3X)))
CBAB580 CONTINUE
CA    IF(ILPTRA.GT.0) WRITE(21,583)LPTFIL
CBAB583 FORMAT('$PRINT ',A,'.LPT')
CBAB  print 441
CBAB  WRITE(50,441)
CBAB441 FORMAT(' Print/Delete LOG file or Keep it on disk (P,K) : ',$)
CBAB  READ(5,4) ANS
CBAB  IF(ANS.EQ.'K')WRITE(21,442)
CBAB442 FORMAT('$ASSIGN NL: SYS$PRINT')
 
      NPOS=INDEXF(CTLFIL)
      NPOS=NPOS-1
      WRITE(21,421)
c421   FORMAT('$SET NOVERIFY')
 421  format('unset echo')
      print 590, CTLFIL(1:NPOS)
      WRITE(50,590) CTLFIL(1:NPOS)
c590   FORMAT(/,1X,'File 'A'.COM has been created')
 590  format(/1x,'File ',A,'.shl has been created')
      print*,
     &'Remember to set the +x bit on the file before execution.'
CBAB      WRITE(50,590) CTLFIL(1:NPOS),CTLFIL(1:NPOS)
C      IF(IDEL.GT.0.AND.IDEM.GT.0)
      CLOSE(UNIT=50,STATUS='DELETE')
CBAB      print 590, CTLFIL(1:NPOS),CTLFIL(1:NPOS)
CBAB590   FORMAT(/' print @'A' AREA to run small job at TTY ( < 3 mins CPUtime
CBAB     1 ) or'/' print BATCH 'A' AREA to submit to SYS$BATCH
CBAB     2 '/' EXAMPLE: BATCH 40K2HW RSH ')
      CALL EXIT
      END
 
 
      FUNCTION INDEXF(A)
      CHARACTER*9 A
      INDEXF = INDEX(A,' ')
      IF(INDEXF.EQ.0) INDEXF = 10
      RETURN
      END
 
      SUBROUTINE RUN_AREA(DEFSDIR)
      CHARACTER*72 FILE,RESULT,DEFAULT,RELATED
      CHARACTER*72 DEFSDIR,NEW,DIR
      ICONTEXT=0
c     FILE='assign.new'
c     OPEN(UNIT=75,NAME=FILE,STATUS='NEW',DISPOSE='DELETE')
c     I_STAT=LIB$FIND_FILE(FILE,RESULT,ICONTEXT,DEFAULT,RELATED)
c     CLOSE(75)
c     I1 = 1
c     I2=INDEX(RESULT,'assign')-1
c     DIR=RESULT(I1:I2)
c     print 10,DIR
c10   FORMAT(1X,'Default subdirectory: ',A)
      NEW = ' '
CBAB      print 11
CBAB 11   FORMAT(1X,'Enter new subdirectory name (<CR> for default): '
CBAB     1,$)
CBAB      ACCEPT 12,NEW
CBAB 12   FORMAT(A)
      IF(NEW.EQ.' ') THEN
      DEFSDIR='.'        ! sets default directory to current.
      ELSE
      DEFSDIR=NEW
      END IF
      RETURN
      END
 
 
      SUBROUTINE FPS_SETUP
c     CHARACTER*9 OPFILI,BAS_INT,SPSFIL,LPTFIL
c     COMMON/HEAD2/LPTFIL,SPSFIL
c     COMMON/HNORM/NINT,OPFILI(11),SPE_NORM(11),XME_NORM(11),BAS_INT
C     1MNOSC(MAX_NOSC),MXOSC(MAX_NOSC)
c     IF(ICALL.EQ.0)THEN
c     WRITE(21,'(''SJE/CONTINUE'',/,
c    1''ATT/WAIT'',/,''ACC :SHELL(BROWN)'')')
c     END IF
c     WRITE(21,'(''DEL/ALL'')')
c     WRITE(21,'(''COPYIN/BIN SHIMG:BASIS.IMG,BASIS'',/,
c    1''COPYIN/BIN SHIMG:PREDICT.IMG,PREDICT'',/,
c    1''COPYIN/BIN SHIMG:PROJ.IMG,PROJ'',/,
c    1''COPYIN/BIN SHIMG:MATRIX.IMG,MATRIX'',/,
c    1''COPYIN/BIN SHIMG:OPER.IMG,OPER'',/,
c    1''COPYIN/BIN SHIMG:LANCZOS.IMG,LANCZOS'',/,
c    1''COPYIN/BIN SHIMG:MVEC.IMG,MVEC'',/,
c    1''COPYIN/BIN SHIMG:TRAMP.IMG,TRAMP'',/,
c    1''COPYIN/BIN SHIMG:TBTDOP.IMG,TBTDOP'',/,
c    1''COPYIN/BIN SHIMG:RTRD.IMG,RTRD'')')
c     ISPS=INDEX(SPSFIL,' ')-1
c     WRITE(21,'(''COPYIN SHSPS:'',A,''.SPS,'',A,''.SPS'')')
c    1SPSFIL(1:ISPS),SPSFIL(1:ISPS)
c     DO 10001  I=1,NINT
c     IOP=INDEX(OPFILI(I),' ')
c     IF(IOP.EQ.0)IOP=10
c     IOP=IOP-1
c     WRITE(21,'(''COPYIN SHSPS:'',A,''.INT,'',A,''.INT'')')
c    1OPFILI(I)(1:IOP),OPFILI(I)(1:IOP)
C      END DO
c10001 CONTINUE
c     ICALL=1
c     RETURN
      END
      SUBROUTINE CAP(A)
      CHARACTER*1 A
      IF(A.EQ.'a') A = 'A'
      IF(A.EQ.'b') A = 'B'
      IF(A.EQ.'c') A = 'C'
      IF(A.EQ.'d') A = 'D'
      IF(A.EQ.'e') A = 'E'
      IF(A.EQ.'f') A = 'F'
      IF(A.EQ.'g') A = 'G'
      IF(A.EQ.'h') A = 'H'
      IF(A.EQ.'i') A = 'I'
      IF(A.EQ.'j') A = 'J'
      IF(A.EQ.'k') A = 'K'
      IF(A.EQ.'l') A = 'L'
      IF(A.EQ.'m') A = 'M'
      IF(A.EQ.'n') A = 'N'
      IF(A.EQ.'o') A = 'O'
      IF(A.EQ.'p') A = 'P'
      IF(A.EQ.'q') A = 'Q'
      IF(A.EQ.'r') A = 'R'
      IF(A.EQ.'s') A = 'S'
      IF(A.EQ.'t') A = 'T'
      IF(A.EQ.'u') A = 'U'
      IF(A.EQ.'v') A = 'V'
      IF(A.EQ.'w') A = 'W'
      IF(A.EQ.'x') A = 'X'
      IF(A.EQ.'y') A = 'Y'
      IF(A.EQ.'z') A = 'Z'
      IF(A.EQ.'0') A = '0'
      IF(A.EQ.'1') A = '1'
      IF(A.EQ.'2') A = '2'
      IF(A.EQ.'3') A = '3'
      IF(A.EQ.'4') A = '4'
      IF(A.EQ.'5') A = '5'
      IF(A.EQ.'6') A = '6'
      IF(A.EQ.'7') A = '7'
      IF(A.EQ.'8') A = '8'
      IF(A.EQ.'9') A = '9'
      RETURN
      END
