cbab  this subroutine opens the .vec file checks dimensions and
cbab  writes relevant  information.
cbab  below is another subroutine which reads the e-functions
cbab  (in the m-scheme basis)
c
c  icase=1 opens lpt file & idev(1)
c       =4 general header & opens idev(2)
c
c  icntl>0 writes to idev(4)
c
      subroutine manag(efil,nvxmin,nvec,basfil_bab,njtp,elev)
      include 'macfor.inc'
      include 'param.inc'
      include 'trpcom.inc'
      character*4 chardud
      character*9 opfil,basfil_bab
      real spe_norm,me_norm
      common/nhead1/opfil(9)
      common/nhead/nint,spe_norm(9),me_norm(9),
     1enli(max_njl,9),enlin(max_njl,9),denl(max_njl)
      dimension elev(*),njtp(*)
      include 'data.inc'
      vecfil=efil
      eigfil=efil
c     print*,'MANAG: vecfil, eigfil = ', vecfil, eigfil
      vec2='.vec'
      icse=icase
      if (icase.eq.4) icse=2
      idv=idev(icse)
      idvh = idev(icse)+60
      vecf=vecfil//vec2
      idevice=40+icse
 
      call open_basis(idv,vecfil,vec2,'OLD',1)
      call open_file(idvh,vecfil,'.veh','OLD','UFRM')
 
      nrec=1
c     print*,'BLAH(0); vecfil = ', vecfil
      read(idvh)
     1jay,itt,nptcl,nipart,spsf,basfil,basf,prjf,
     1opfil,matfil,redf,eigfil,imzs,itzs,matdim,njl,
     1(enl(i),i=1,njl),gndfil,gnde,neig,nv,nvmin(icse),kpar,
     1nint,(spe_norm(iint),me_norm(iint),iint=1,nint),
     1((enlin(i,iint),i=1,njl),iint=1,nint),(denl(i),i=1,njl)
c     print*,'BLAH(1); basfil = ', basfil
      if (nvmin(icse).eq.0) nvmin(icse)=1
      if(basfil_bab.eq.' ') basfil_bab = basfil
 
      read(idvh) (njtp(i),i=1,nipart)
c     print*,'BLAH(2); basfil_bab = ', basfil_bab
      read(idvh) nrecs(icse),(idisk(icse,i),i=1,nipart)
c     print*,'BLAH(3); vecfil = ', vecfil
 
      call open_file(idevice,basfil_bab,'.inf','OLD','UFRM')
c     print*,'BLAH(3.1); vecfil = ', vecfil
 
c     print*,'BLAH(3.2); vecfil = ', vecfil
      read(idevice) spsf1,njl1,(shell(i),i=1,njl1),nlwrds,zero,ivers,
     1(mnfil(i),i=1,njl1),(mxfil(i),i=1,njl1),
     1nosc,(mnosc(i),i=1,nosc),(mxosc(i),i=1,nosc),
     1(noscjl(i),i=1,nosc),nptcl,imzs,itzs,kpar,npart,nsps
c     print*,'BLAH(3.3); vecfil = ', vecfil
      do 1 iw=1,4
      read(idevice)
    1 continue
c     print*,'BLAH(3.4); vecfil = ', vecfil
 
      if (nvxmin.gt.0) go to 2
      nvxmin=1
      nvec=matdim
    2 nvec=min0(nvec,matdim,nv)
 
c     print*,'BLAH(3.5); vecfil = ', vecfil
      read(idvh) (elev(i),i=nvmin(icse),nvec)
c     print*,'BLAH(4); vecfil = ', vecfil
cbab  *** close .inf file. it will be reopenned in tramp
      close (idevice)
      if (matdim.gt.isize1) go to 9
      if (nvec.gt.isize3) go to 11
      if (nvxmin.lt.nvmin(icse)) write(6,3)nvxmin,nvmin(icse)
    3 format(1x,2i3,' ***** fatal error in manag: min vector wrong,
     1re-run mvec *****')
      if (nvxmin.lt.nvmin(icse)) stop
      call name_file(spsf,spsfil,chardud)
      if (ilpt.gt.0) call header
      if(ilpt.eq.-2) write(3,4)
    4 format(1h1)
      icase=icse
      if (icntl.eq.0) return
      idv=idev(4)
cbab  ***   now, it writes first two records to output file
 
      write(idv) itt,nsps,spsfil,basfil,basf,
     1  prjf,opfil(1),matfil,ortfil,redf,eigfil,
     2  nptcl,imzs,itzs,kpar,nipart,matdim,njl,
     3(shell(i),i=1,njl),(mnfil(i),i=1,njl),(mxfil(i),i=1,njl),
     4nosc,(mnosc(i),i=1,nosc),(mxosc(i),i=1,nosc),jay,
     5(noscjl(i),i=1,nosc),
     6  (enl(i),i=1,njl),gnde,neig,nvec,nvxmin
     7,opfil,nint,(spe_norm(iint),me_norm(iint),iint=1,nint),
     8((enlin(i,iint),i=1,njl),iint=1,nint),(denl(i),i=1,njl)
cbab  ***  eigenvalues
      write(idv) (elev(i),i=1,nvec)
      return
    5 write(6,6)mdim,matdim
    6 format(' error: mdim,matdim  :',2i5)
      stop ' ***** fatal error in manag *****'
    7 write(6,8)k,isize1
    8 format(' increase max_basis to',i7,' from',i7)
      stop ' ***** fatal error in manag *****'
    9 write(6,10)matdim,isize1
   10 format(' increase max_basis to',i7,' from',i7)
      stop ' ***** fatal error in manag *****'
   11 write(6,12)isize3
   12 format(' increase max_eig_in_mvec or enter smaller no.
     1   of vectors in mvec'/' max_eig_in_mvec = ',i5)
      stop ' ***** fatal error in manag *****'
      end
c
c
c  subroutine to read vec file
c
c
      subroutine ovread(izerob,nv0,ip,ndim0,coef)
      include 'macfor.inc'
      include 'param.inc'
      include 'trpcom.inc'
      parameter (nlwmf=nlwrds_block-4)
      dimension coef(*),read_coef(nlwrds_block)
      include 'data.inc'
      nrec=idisk(icase,ip)+nrecs(icase)*(nv0-nvmin(icase))
      read(idev(icase),rec=nrec) nv,nvec,iii,ndim,(coef(i),i=1,nlwmf)
      if (ndim.le.nlwmf) go to 3
      j=nlwmf
    1 nrec=nrec+1
      read(idev(icase),rec=nrec)read_coef
      ii=0
      do 2  i=j+1,j+nlwrds_block
      ii=ii+1
      coef(i)=read_coef(ii)
    2 continue
      j=j+nlwrds_block
      if (ndim.gt.j) go to 1
    3 if (ndim.ne.ndim0.or.nv.ne.nv0) go to 4
      izerob = 1
      do 100 i = 1,ndim
100   if(abs(coef(i)).gt..000001) izerob = 0
      return
    4 write(6,5)icase,ip,ndim,ndim0
    5   format(' error in ovread: icase,ip,ndim,ndim0 : ',4i5)
      stop ' ***** fatal error in manag *****'
      end
