c  this program makes up 1 & 2 particle wavefunctions
c  first call to set up ipart3(),nlap,npart3
c  second call partition given:
c     loop over jay3,itt3
c     make up ibas3(),coef3()
c     set ilap and call cross
c
c
c
      subroutine spec(icore)
      include 'macfor.inc'
      include 'param.inc'
      include 'trpcom.inc'
      common/ksps/ksps(100)
      common/cdj/irest,djmin,djmax,dtmin,dtmax
      character*1 pa1, pa2
      dimension olap2(max_olap),solap2(max_olap),elolf(10)
      dimension jtwpa(max_njl),jlp1a(max_npart),jlp2a(max_npart),
     1iptp1(n_words),iptp2(n_words)
      include 'data.inc'
 
      if (icall.gt.0)goto10
cbab  ***                           writes to disk and to lpt
      if (icall.lt.0) go to 24
      icall=1
 
cekw  ***                           for energy centroids
      eloli = 0.0
      do 1, i = 1,npart3
      elolf(i) = 0.0
    1 continue
cekw  ***************************************************
c
cbab  ***  read in s-p state file for parentage amplitudes and
cbab  ***  transition density calculation
c
      if (nsps1.ne.nsps2) go to 900
      call free_real_a(24,njl1,char_var,0,real_var,read_err)
      ns=0
      do 2 i=1,njl1
      jlst(i)=ns+1
      do 2 jl=1,npj1(i)
      ns=ns+1
      call free_int(24,6,int_var,read_err)
      nqu(i)=int_var(2)
      lqu(i)=int_var(3)
      jtw(i)=int_var(4)
      mztw(ns)=int_var(5)
      itztw(ns)=int_var(6)
    2 continue
      imzs3=imzs1-imzs2
      itzs3=itzs1-itzs2
      if (iobtd.gt.0) go to 5
c      if (ilpt.gt.0) write(3,3) ispec
    3 format('1'///' ',i1,' - particle parentage amplitudes'//)
 
cbab  parentage amplitudes are the coeff. of fractional parentage
cbab  multiplied by square root of the statistical factor ( a )
cbab                                                      ( k ) .
cbab  spectroscopic amplitudes are the parentage amplitudes times
cbab  the g factor (overlap of radial wfns) and the mass factor -
cbab  see phys.rep. 12c, 227 (1974). this program outputs that in
cbab  curly brackets in the noted report & page,i.e.,eq.5.6
 
      if (ispec.gt.1) go to 7
c
cbab  ***  single-particle spectroscopic factors
c
      ndim3=1
      itt3=1
      if (iabs(itt1-itt2).ne.1) go to 900
      npart3=0
      jvmin=iabs(jay1-jay2)
      do 4 jlp1=1,njl1
      call lib_assignx(zerop(1),iptp1(1),n_words)
      iptp1(jlp1)=1
      kkpar1=kpar1
      jay3=jtw(jlp1)
      if (mod(kpar1+kpar2+lqu(jlp1),2).ne.0) go to 4
      if (jay3.gt.(jay1+jay2)) go to 4
      if (jay3.lt.jvmin) go to 4
      if (jay3.gt.jvmax) jvmax=jay3
      npart3=npart3+1
      jlp1a(npart3)=jlp1
      call lib_assignx(iptp1(1),ipart3(1,npart3),n_words)
    4 continue
      if (npart3.eq.0) go to 900
      nlap=npart3
c
cbab  *** obpa (one body parentage amplitude) partitions are done
c
      return
c
cbab  ***  2-particle parentage amplitudes and transition densities
c
c
cbab  ***  set up operators
c
    5 continue
c      if (ilpt.gt.0) write(3,6)
    6 format('1'///' one- body transition densities'/)
    7 itmin=iabs(itt1-itt2)
      itmax=min0(2,(itt1+itt2))
      if(iabs(itzs1-itzs2).eq.2) itmin = 2
      if (itmax.lt.itmin) go to 900
      npart3=0
      jvmin=iabs(jay1-jay2)
      do 9 jlp1=1,njl1
      call lib_assignx(zerop(1),iptp1(1),n_words)
c
cbab  *** work out the partition for a single particle
c
      iptp1(jlp1)=1
      jtwp1=jtw(jlp1)
      do 9 jlp2=1,njl1
      if ((iobtd.eq.0).and.(jlp2.gt.jlp1)) go to 9
      call lib_assignx(zerop(1),iptp2(1),n_words)
      iptp2(jlp2)=1
      if (mod(kpar1+kpar2+lqu(jlp1)+lqu(jlp2),2).ne.0) go to 9
      jtwp2=jtw(jlp2)
      jmin=max0(iabs(jtwp1-jtwp2),jvmin)
      jmax=min0((jtwp1+jtwp2),(jay1+jay2))
      if (jmax.lt.jmin) go to 9
      if (jmax.gt.jvmax) jvmax=jmax
      npart3=npart3+1
      jlp1a(npart3)=jlp1
      jlp2a(npart3)=jlp2
      do 8 iw=1,njl1
      ipart3(iw,npart3)=iptp1(iw)+(1-2*iobtd)*iptp2(iw)
    8 continue
 
cbab  *** for obpa its the sum and for obtd the subtraction
 
    9 continue
      if (npart3.eq.0) go to 900
      nlap=npart3*(jvmax-jvmin+2)
      if (nlap.gt.isize4) go to 900
      ndepth=jvmax-jvmin+2
cwr   *** dont know if next two lines are needed any more
      nstore=isize4/ndepth
      nstore=min0(nstore,isize1-isize2)
cwr   *** end ?
      if (icntl.eq.0) return
      write(1) nv1,nv2,jvmin,jvmax,itmin,itmax,
     1  nlap,npart3,(jlp1a(i),i=1,npart3),(jlp2a(i),i=1,npart3),
     2  nv1min,nv2min
      return
   10 if (ispec.eq.2)goto14
 
cbab  ***  evaluate reduced matrix element & relevent c.g. coeff.
 
      jlp1=jlp1a(ip3)
      jay3=jtw(jlp1)
      ilap=ip3
      ia=jay2
      ib=jay3
      ic=jay1
      id=imzs2
      ie=imzs3
      if=imzs1
      call clebg
      cg=cleb
      if (cg.eq.0.0) go to 900
      ia=itt2
      ib=itt3
      ic=itt1
      id=itzs2
      ie=itzs3
      if=itzs1
      call clebg
 
cbab   *** icore=1 indicates pn formalism
 
      if(icore.eq.1) cleb = 1.
      if (cleb.eq.0.0d0) go to 900
      cg=cleb*cg
      coef3(1)=1.0/cg
      do 13 nsp1=jlst(jlp1),npj1(jlp1)+jlst(jlp1)
      if (mztw(nsp1).ne.imzs3) go to 13
      if (itztw(nsp1).ne.itzs3) go to 13
      if (use_store) goto12
      call lib_assignx(zero(1),ibas3(1,1),nlwrds)
      if(lib_btsx(ibas3(1,1),nsp1-1,nlwrds)) goto11
   11 continue
 
c
cbab  *** above is the basis for obpa
c
   12 continue
c      type 7777,nv1,nv2,nv3
c7777  format(10x,3i3)
      call cross
   13 continue
      return
 
   14 jlp1=jlp1a(ip3)
      jlp2=jlp2a(ip3)
      jtwp1=jtw(jlp1)
      jtwp2=jtw(jlp2)
      jmin=max0(iabs(jtwp1-jtwp2),jvmin)
      jmax=min0((jtwp1+jtwp2),(jay1+jay2))
      symfac=1.0
      if ((jlp1.eq.jlp2).and.(iobtd.eq.0)) symfac=sqrt(2.0)
c
cbab  *** set up for two body wfns, ispec=2
c
      if (icall.ne.10) go to 70
c
cbab  *** do all 2-particle coupling
c
      ndim33=0
      do 18 jay3=jmin,jmax,2
      do 18 itt3=itmin,itmax,2
      ibab=0
c      if(irest.eq.1.and.jay3.lt.2*djmin) ibab=1
c      if(irest.eq.1.and.jay3.gt.2*djmax) ibab=1
c      if(irest.eq.1.and.itt3.lt.2*dtmin) ibab=1
c      if(irest.eq.1.and.itt3.gt.2*dtmax) ibab=1
      if(irest.gt.0.and.jay3.lt.2*djmin) ibab=1
      if(irest.gt.0.and.jay3.gt.2*djmax) ibab=1
      if(irest.gt.0.and.itt3.lt.2*dtmin) ibab=1
      if(irest.gt.0.and.itt3.gt.2*dtmax) ibab=1
      if ((symfac.gt.1.1).and.mod((jay3+itt3),4).ne.2) go to 18
      if(ibab.eq.1) scgfac=0.
      if(ibab.eq.1) go to 15
      obfac=sqrt((jay1+1.0)*(itt1+1.0)/((jay3+1.0)*(itt3+1.0)))
      ia=jay2
      ib=jay3
      ic=jay1
      id=imzs2
      ie=imzs3
      if=imzs1
      call clebg
      cg=cleb
      if (cg.eq.0.0) go to 900
      ia=itt2
      ib=itt3
      ic=itt1
      id=itzs2
      ie=itzs3
      if=itzs1
      call clebg
      if (cleb.eq.0.0d0) go to 900
      cg=cleb*cg
c      type 7777,cleb,cg
c7777  format(1x,2f10.5)
      scgfac=symfac/cg
   15 continue
c
cbab  *** make  [j1,j2]  coupled to jay3,itt3  wavefunction
c
      do 17 nsp1=jlst(jlp1),npj1(jlp1)+jlst(jlp1)-1
      mztwp1=mztw(nsp1)
      itztp1=itztw(nsp1)
      mztwp2=(imzs3-mztwp1)
      itztp2=(itzs3-itztp1)
      do 17 nsp2=jlst(jlp2),npj1(jlp2)+jlst(jlp2)-1
      if ((iobtd.eq.0).and.(nsp2.ge.nsp1)) go to 17
      if (mztw(nsp2).ne.mztwp2*(1-2*iobtd)) go to 17
      if (itztw(nsp2).ne.itztp2*(1-2*iobtd)) go to 17
      if(ibab.eq.1) go to 16
      ia=jtwp1
      ib=jtwp2
      ic=jay3
      id=mztwp1
      ie=mztwp2
      if=imzs3
      call clebg
      cg2p=cleb
      ia=1
      ib=1
      ic=itt3
      id=itztp1
      ie=itztp2
      if=itzs3
      call clebg
      sex=-1.0
c      if((iobtd.gt.0).and.(nsp2.le.nsp1)) sex=1.0
      if((nsp2.le.nsp1)) sex=1.0
      if (iobtd.gt.0) sex=sex*(1-2*iabs(mod((jtwp2+1
     1+mztwp2+itztp2)/2,2)))*obfac
   16 continue
      ndim33=ndim33+1
c      type 7777,cleb,cg2p,scgfac,sex
c7777  format(1x,10f8.3)
      wfn(ndim33)=cleb*cg2p*scgfac*sex
   17 continue
      if (ndim33.eq.0) stop ' ***** fatal error in spec:
     1ndim33=0 *****'
   18 continue
 
      if (ndim33.gt.max_operator)stop ' *****fatal error in
     1spec: ndim3>max_operator *****'
      return
c
cbab  ***   get overlaps using stored wavefunction coefficients
c
 
70    iolpst=(ip3-1)*ndepth+1
 
c
cbab  ***   loop over j, t
c
      ndm3=0
      do 23 jay3=jmin,jmax,2
      do 23 itt3=itmin,itmax,2
      if ((symfac.gt.1.1).and.mod((jay3+itt3),4).ne.2) go to 23
      ilap=iolpst+jay3-jvmin+itt3/2
      ndim3=0
      do 22 nsp1=jlst(jlp1),npj1(jlp1)+jlst(jlp1)-1
      mztwp1=mztw(nsp1)
      itztp1=itztw(nsp1)
      mztwp2=(imzs3-mztwp1)
      itztp2=(itzs3-itztp1)
      do 22 nsp2=jlst(jlp2),npj1(jlp2)+jlst(jlp2)-1
      if ((iobtd.eq.0).and.(nsp2.ge.nsp1)) go to 22
      if (mztw(nsp2).ne.mztwp2*(1-2*iobtd)) go to 22
      if (itztw(nsp2).ne.itztp2*(1-2*iobtd)) go to 22
      ndm3=ndm3+1
      if (wfn(ndm3).eq.0.0) go to 22
      ndim3=ndim3+1
      coef3(ndim3)=wfn(ndm3)
c
cbab  *** set up basis for operator, ibas4 labels the hole
c
      if (use_store) go to 22
      call lib_assignx(zero(1),ibas3(1,ndim3),nlwrds)
      call lib_assignx(zero(1),ibas4(1,ndim3),nlwrds)
      if(nsp1.ne.nsp2)then
      if(lib_btsx(ibas3(1,ndim3),nsp1-1,nlwrds)) goto 19
   19 continue
      if(lib_btsx(ibas3(1,ndim3),nsp2-1,nlwrds)) goto 20
   20 continue
      end if
      if(lib_btsx(ibas4(1,ndim3),nsp2-1,nlwrds)) goto 21
   21 continue
 
   22 continue
c      if(irest.eq.1.and.jay3.lt.2*djmin) go to 23
c      if(irest.eq.1.and.jay3.gt.2*djmax) go to 23
c      if(irest.eq.1.and.itt3.lt.2*dtmin) go to 23
c      if(irest.eq.1.and.itt3.gt.2*dtmax) go to 23
      if(irest.gt.0.and.jay3.lt.2*djmin) go to 23
      if(irest.gt.0.and.jay3.gt.2*djmax) go to 23
      if(irest.gt.0.and.itt3.lt.2*dtmin) go to 23
      if(irest.gt.0.and.itt3.gt.2*dtmax) go to 23
      if (ndim3.eq.0.or.ndim3.gt.isize2) go to 900
c      type 7778,nv1,nv2,nv3
c7778  format(1x,3i3)
      call cross
   23 continue
      if (ndm3.ne.ndim33) stop ' ***** fatal error in spec:
     1ndm3#ndim33 *****'
      return
c
cbab  *** output
c
   24 if(ispec.eq.1)goto34
      if (ilpt.le.0)goto32
c      if (iobtd.gt.0)
c     1write(3,25) nv2,efil2,elev2(nv2),nv1,efil1,elev1(nv1)
   25 format(///' initial state :  vector',i3,' of ',a6,f10.3,
     1'  mev'/  ' final state   :  vector',i3,' of ',a6,f10.3,
     2'  mev'///  ' created  destroyed      coupled to (j,t) =')
c      if (iobtd.eq.0)
c     1write(3,26) nv2,efil2,elev2(nv2),nv1,efil1,elev1(nv1)
   26 format(///' target state   :  vector',i3,' of ',a6,f10.3,
     1'  mev'/  ' residual state :  vector',i3,' of ',a6,f10.3,
     2'  mev'///  '  orbit 1     orbit 2       coupled to (j,t) =')
c      write(3,27) ((jay3,itt3,jay3=jvmin/2,jvmax/2,1),
c     1itt3=itmin/2,itmax/2,1)
   27 format('  k, n, l,2*j   k, n, l,2*j ',
     110(8(5x,'(',i2,',',i2,')')/))
      if(nv1.eq.1.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.sp1',status='new')
      if(nv1.eq.2.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.sp2',status='new')
      if(nv1.eq.3.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.sp3',status='new')
      if(nv1.eq.4.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.sp4',status='new')
      if(nv1.eq.5.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.sp5',status='new')
 
      do 31 i=1,npart3
      iolpst=(i-1)*(jvmax-jvmin+2)+1
      i1=jlp1a(i)
      i2=jlp2a(i)
      jtwp1=iabs(jtw(i1))
      jtwp2=iabs(jtw(i2))
 
      if(idiag.ne.2) go to 29
      if(i1.ne.i2) go to 29
      naa = nqu(i1)-1.
      laa = lqu(i1)
      j2aa = jtwp1
      index1 = ((2*naa+laa)*(2*naa+laa+3)-(j2aa-1)+2)/2
      olapbab=olap(iolpst)*(sqrt(j2aa+1.)/sqrt(jay1+1.))
     1*(sqrt(2.)/sqrt(itt1+1.))
      write(40,28) index1,olapbab
   28 format(1x,i3,1x,f9.4)
   29 continue
      xnp = nptcl1*(nptcl1-1)/2.
      do 1031 jay3=0,jvmax-jvmin,2
      do 1031 itt3=itmin,itmax,2
      if(xnp.ne.0.) 
     1 iolas = 10000.*ola(iolpst+jay3+itt3/2)/sqrt(xnp)
      if(xnp.eq.0.) 
     1 iolas = 10000.*ola(iolpst+jay3+itt3/2)
      xolas = iolas
      olas(iolpst+jay3+itt3/2) = xolas/10000.
1031  continue
      if(iobtd.eq.1) go to 1033
      do 1032 jay3=0,jvmax-jvmin,2
      do 1032 itt3=itmin,itmax,2
      if(olas(iolpst+jay3+itt3/2).eq.0.) go to 1032
c      write(33,1030) nv1,nv2,elev1(nv1)+gnde1,elev2(nv2)+gnde2
c     1,ksps(i1),ksps(i2),
c     1(jay3+jvmin)/2,itt3/2,olas(iolpst+jay3+itt3/2)
1030  format(1x,2i3,2f15.3,1x,2i3,1x,2i2,1x,f10.5)
1032  continue
1033  continue
c      write(3,30)
c     1i1,nqu(i1),lqu(i1),jtwp1,i2,nqu(i2),lqu(i2),jtwp2,
c     2((ola(iolpst+jay3+itt3/2),jay3=0,jvmax-jvmin,2)
c     3,itt3=itmin,itmax,2)
   30 format(/1x,2(i2,',',i2,',',i2,',',i2,4x)
     1,10f10.7/100(20x,8f10.7/))
   31 continue
      if(idiag.eq.2) close(unit=40)
 
   32 if (icntl.le.0) return
      iposl(1)=1
      k=0
      do 33 i=1,nlap
      if (ola(i).eq.0.0) go to 33
      k=k+1
      ola(k)=ola(i)
      iposl(k)=i
   33 continue
      if (k.eq.0) k=1
c
cbab  *** main write statement for .trd and .tbd files
      write(1) nv1,nv2,k,(iposl(i),ola(i),i=1,k)
cbab  ************************************************
      return
   34 continue
c      if (ilpt.gt.0)
c     1write(3,35) nv2,efil2,elev2(nv2),nv1,efil1,elev1(nv1)
   35 format(///' target state   :  vector',i3,' of ',a6,f10.3,
     1'  mev'/'   residual state :  vector',i3,' of ',a6,f10.3,
     2'  mev'//)
      do 36 i=1,njl1
   36 jtwpa(i)=iabs(jtw(i))
c      if (ilpt.gt.0) write(3,37)
c     1(nqu(jlp1a(i)),lqu(jlp1a(i)),jtwpa(jlp1a(i)),i=1,npart3)
c   37 format('  n, l, 2*j = ',3(10(i6,',',i2,',',i2)/))
      if (ilpt.gt.0) write(3,38) (olap(i),i=1,npart3)
   38 format(/11x,10f10.5)
      do 39 i=1,npart3
      olap2(i) = olap(i)**2.
      solap2(i) = solap2(i) + olap2(i)
   39 continue
      if(ifirst40.ne.999) write(32,47)
     1(nqu(jlp1a(i)),lqu(jlp1a(i)),jtwpa(jlp1a(i)),i=1,npart3)
      if(ifirst40.ne.999) write(33,47)
     1(nqu(jlp1a(i)),lqu(jlp1a(i)),jtwpa(jlp1a(i)),i=1,npart3)
c      if(ifirst40.ne.999) write(34,47)
c     1(nqu(jlp1a(i)),lqu(jlp1a(i)),jtwpa(jlp1a(i)),i=1,npart3)
47    format(1x,'-- core state --- - overlap state -',2x,
     1 4('(',i1,1x,i1,1x,i2,')'),
     1 10(/,38x,4('(',i1,1x,i1,1x,i2,')')))
      if(ifirst40.ne.999) write(32,48)
48    format(1x,'2j2t p   n     e  2j2t p   n     e    s ')
      if(ifirst40.ne.999) write(33,50)
c      if(ifirst40.ne.999) write(34,50)
50    format(1x,'2j2t p   n     e  2j2t p   n     e    a ')
      if(ifirst40.ne.999) write(32,49),gnde2,gnde1
      if(ifirst40.ne.999) write(33,49),gnde2,gnde1
c      if(ifirst40.ne.999) write(34,49),gnde2,gnde1
49    format(2x,2(7x,f10.3,1x))
      if(efil1(4:4).eq.'0') pa1 = '+'
      if(efil1(4:4).eq.'1') pa1 = '-'
      if(efil2(4:4).eq.'0') pa2 = '+'
      if(efil2(4:4).eq.'1') pa2 = '-'
      if(efil1(4:4).eq.'2') pa1 = '+'
      if(efil1(4:4).eq.'3') pa1 = '-'
      if(efil2(4:4).eq.'2') pa2 = '+'
      if(efil2(4:4).eq.'3') pa2 = '-'
      if(ifirst40.ne.999) ifirst40 = 999
      write(32,40)efil2(2:2),efil2(3:3),pa2,nv2,elev2(nv2),
     1efil1(2:2),efil1(3:3),pa1,
     1nv1,elev1(nv1),(olap2(i),i=1,npart3)
      write(33,40)efil2(2:2),efil2(3:3),pa2,nv2,elev2(nv2),
     1efil1(2:2),efil1(3:3),pa1,
     1nv1,elev1(nv1),(olap(i),i=1,npart3)
   40 format(2x,2(a1,1x,a1,1x,a1,1x,i3,f8.3,1x),
     1 4(f8.5,1x),3(10(/,38x,4(f8.5,1x))/))
 
      jcen = 1
      if(solap2(1).eq.0)jcen = 2
      eloli = eloli + (elev2(nv2))*olap2(jcen)
      do 41,j=1,npart3
      elolf(j) = elolf(j) + (elev1(nv1))*olap2(j)
   41 continue
      if(nv1.eq.nvec1.and.nv2.eq.nvec2)then
      eloli = eloli/solap2(jcen)
      do 42, j = 1,npart3
      if(solap2(j).eq.0)then
      goto42
      endif
      elolf(j) = elolf(j)/solap2(j)
   42 continue
      write(32,43)(solap2(i),i=1,npart3)
      write(32,44)eloli,(elolf(i),i=1,npart3)
c      write(32,46)
c      write(33,46)
46    format(//)
      endif

   43 format(1x,'total = ',29x,
     1 4(f7.4,1x),1x,10(/,38x,4(f8.5,1x)))
   44 format(1x,'centroid =',f8.3,5x,
     1'centroids =',2x,
     1 4(f8.3),1x,10(/,38x,4(f8.3)))
   45 return
 
900   if (nlap.gt.isize4) stop ' ***** Fatal Error In Spec:
     1Isize4 Too Small *****'
      if (nlap.gt.isize1) stop ' ***** Fatal Error In Spec:
     1Isize1 Too Small *****'
      if (ndim3.gt.isize2) stop ' ***** Fatal Error In Spec:
     1Ndim3>Isize2 *****'
      if (isize2.gt.(isize1/4)) stop ' Fatal Error In Spec:
     1Make Isize2=0.25*Isize1 *****'
      if (nsps1.ne.nsps2) stop '***** Fatal Error In Spec:
     1Different Nsps Values *****'
      if ((iabs(itt1-itt2).ne.1).and.ispec.eq.1)
     1stop ' ***** Fatal Error In Spec: Delta T .ne.
     10.5 *****'
      if (npart3.eq.0) stop ' ***** Fatal Error In Spec: No
     1Coupling Possible *****'
      if (itmax.lt.itmin) stop ' ***** Fatal Error In Spec: No T
     1Coupling Poss *****'
      if(cg.eq.0) write(6,901)jay2,jay3,jay1,imzs2,imzs3,imzs1
  901 format(1x,'2j2,2j3,2j1,2m2,2m3,2m1 = ',6i3)
      if (cg.eq.0.0) stop ' ***** Fatal Error In Spec: Cg.eq.0 :
     1try Different Jz *****'
      if (cleb.eq.0.0d0) stop ' ***** Fatal Error In Spec:
     1cleb.eq.0 : Try Different Tz *****'
      if (ndim3.eq.0) stop ' ***** Fatal Error In Spec:
     1 No Coupling Found *****'
      stop ' ***** Fatal Error Found *****'
      end
