      SUBROUTINE CLEBG                                              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION FACLOG(200)                               
      COMMON / CRAC / IA,IB,IC,ID,IE,IF,RAC             
      ALOG(X)=DLOG(X)                                               
      EXP(X)=DEXP(X)                                                
      SQRT(X)=DSQRT(X)                                              
      ABS(X)=DABS(X)                                                

      IF(IFIRST.EQ.999) GO TO 8002
C
C  SET UP FOR CLEBG, N!=EXP(FACLOG(N-1))
C
      FACLOG(1)=0.0 
      FACLOG(2)=0.0 
      FN=1.0 
      DO 68 N=3,200 
      FN=FN+1.0 
68    FACLOG(N)=FACLOG(N-1)+DLOG(FN) 
      IFIRST = 999

8002  CONTINUE
      RAC=0.0                                                       
      IF(ID+IE-IF) 1000,105,1000                                    
  105 K1=IA+IB+IC                                                   
      IF(K1-2*(K1/2)) 1000,110,1000                                 
  110 K1=IA+IB-IC                                                   
      K2=IC-IABS(IB-IA)                                             
      K3=MIN0(K1,K2)                                                
      IF(K3) 1000,130,130                                           
  130 IF((-1)**(IB+IE)) 1000,1000,140                               
  140 IF((-1)**(IC+IF)) 1000,1000,150                               
  150 IF(IA-IABS(ID)) 1000,152,152                                  
  152 IF(IB-IABS(IE)) 1000,154,154                                  
  154 IF(IC-IABS(IF)) 1000,160,160                                  
  160 IF(IA) 1000,175,165                                           
  165 IF(IB) 1000,175,170                                           
  170 IF(IC) 1000,180,250                                           
  175 RAC=1.0                                                       
      GO TO 1000                                                    
  180 FB=IB+1                                                       
      RAC=((-1.0  )**((IA-ID)/2))/ SQRT(FB)                         
      GO TO 1000                                                    
  250 FC2=IC+1                                                      
      IABCP=(IA+IB+IC)/2+1                                          
      IF(IABCP.GT.200) GO TO 8000
      IABC=IABCP-IC                                                 
      IF(IABC.GT.200) GO TO 8000
      ICAB=IABCP-IB                                                 
      IF(ICAB.GT.200) GO TO 8000
      IBCA=IABCP-IA                                                 
      IF(IBCA.GT.200) GO TO 8000
      IAPD=(IA+ID)/2+1                                              
      IF(IAPD.GT.200) GO TO 8000
      IAMD=IAPD-ID                                                  
      IF(IAMD.GT.200) GO TO 8000
      IBPE=(IB+IE)/2+1                                              
      IF(IBPE.GT.200) GO TO 8000
      IBME=IBPE-IE                                                  
      IF(IBME.GT.200) GO TO 8000
      ICPF=(IC+IF)/2+1                                              
      IF(ICPF.GT.200) GO TO 8000
      ICMF=ICPF-IF                                                  
      IF(ICMF.GT.200) GO TO 8000
      SQFCLG=0.5  *(ALOG(FC2)-FACLOG(IABCP+1)                       
     1      +FACLOG(IABC)+FACLOG(ICAB)+FACLOG(IBCA)                 
     2      +FACLOG(IAPD)+FACLOG(IAMD)+FACLOG(IBPE)                 
     3      +FACLOG(IBME)+FACLOG(ICPF)+FACLOG(ICMF))                
      NZMIC2=(IB-IC-ID)/2                                           
      NZMIC3=(IA-IC+IE)/2                                           
      NZMI=MAX0(0,NZMIC2,NZMIC3)+1                                  
      NZMX=MIN0(IABC,IAMD,IBPE)                                     
      S1=1-2*MOD(NZMI-1,2)                                          
      DO 400 NZ=NZMI,NZMX                                           
      IF(NZ.GT.200) GO TO 8000
      NZM1=NZ-1                                                     
      NZT1=IABC-NZM1                                                
      IF(NZT1.GT.200) GO TO 8000
      NZT2=IAMD-NZM1                                                
      IF(NZT2.GT.200) GO TO 8000
      NZT3=IBPE-NZM1                                                
      IF(NZT3.GT.200) GO TO 8000
      NZT4=NZ-NZMIC2                                                
      IF(NZT4.GT.200) GO TO 8000
      NZT5=NZ-NZMIC3                                                
      IF(NZT5.GT.200) GO TO 8000
      TERMLG=SQFCLG-FACLOG(NZ)-FACLOG(NZT1)-FACLOG(NZT2)            
     1           -FACLOG(NZT3)-FACLOG(NZT4)-FACLOG(NZT5)            
      SSTERM=S1* EXP(TERMLG)                                        
      RAC=RAC+SSTERM                                                
  400 S1=-S1                                                        
      IF( ABS(RAC).LT.1.0E-10) RAC=0.0                              
 1000 RETURN                                                        
8000  TYPE 8001
8001  FORMAT(1X,'INCREASE DIMENSION OF FACLOG IN CLEBG')
      STOP
      END                                                           
