C
C
C  SUBROUTINE CALLED BY BASIS TO
C  WORK OUT ALL POSS PARTITIONS
C
C
CA  MXFIL(I)=MAXIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
CA  MNFIL(I)=MINIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
      SUBROUTINE WOTHBW(IOP)
      IMPLICIT INTEGER (A-Z)
      INCLUDE 'macfor.inc'                
      INCLUDE 'param.inc'                
      INCLUDE 'bascom.inc'                
      COMMON/CHBW/IHBWMAX,IHBW(10),IEHBW(MAX_NJL),KHBWGS
      COMMON/LISTPARTM/
     1MIN(MAX_NJL),MIN_O(MAX_NJL),MAX(MAX_NJL),MAX_O(MAX_NJL)
      INTEGER jindex(MAX_NJL),low(MAX_NJL),high(0:MAX_NJL),
     1NLEFT1(MAX_NJL)
      INTEGER step(MAX_NJL)      
      INCLUDE 'data.inc'                
C
C  WORK OUT ALL POSSIBLE PARTITIONS
CA    DOESNT USE ANY BASIS STATE 
      NLEFT=NPTCL
      DO 34 I=1,NJL 
34    NLEFT=NLEFT-MNFIL(I) 
      IF (NLEFT.LT.0) STOP ' ***** Fatal Error in WOTPTS:  
     1RESTRICTIONS TOO SEVERE-NOT ENOUGH PARTICLES *****' 
      NPART=0 


CEO   ADDED TO REPLACE NUMBER OF DO LOOPS 
C         WILL DO AS MANY SUBSHELLS AS MAX_NJL


      nused_loops=NJL-1
      DO 10001  i=1,nused_loops
      low(i)=0
      step(i)=1
      jindex(i)=low(i)
C      END DO
10001 CONTINUE    
      DO 10002  i=1,nused_loops
      NUMP(i+1)=MNFIL(i+1)
      NLEFT1(i+1)=NLEFT
      high(i)=MIN0(MXFIL(i+1)-MNFIL(i+1),NLEFT1(i+1))
C      END DO
10002 CONTINUE    
      DO 10003  i=1,nused_loops+1
C      end do
10003 CONTINUE    
      GOTO 1002

1001  continue
      DO 10004  i=1,j
      NUMP(j+2-i)=MNFIL(j+2-i)+jindex(j+1-i)
      NLEFT1(j+1-i)=NLEFT1(j+2-i)-jindex(j+1-i)
      high(j-i)=MIN0(MXFIL(j+1-i)-MNFIL(j+1-i),NLEFT1(j+1-i))
C      END DO
10004 CONTINUE    

1002  NUMP(1)=MNFIL(1)+NLEFT1(2)-jindex(1) 
      IF (NUMP(1).GT.MXFIL(1)) GO TO 37 

      KPARIT=0
      KHBW=0
      DO 402 I = 1,NJL
      KPARIT=KPARIT+KPARQ(I)*NUMP(I)
402   KHBW = KHBW + IEHBW(I)*NUMP(I)


      DO 3000 JHBW=1,IHBWMAX
      IF((KHBW-KHBWGS).EQ.IHBW(JHBW)) GO TO 3001
3000  CONTINUE
      GO TO 37
3001  CONTINUE

      IF (MOD(KPARIT,2).NE.MOD(KPAR,2)) GO TO 37

      IF(NPTYPE.NE.'BOTH'.AND.SUMRES.NE.'y')GOTO 3612


      DO 3611 KK=1,NOSCJL(1)
      DO 3610 JJ=NOSCJL(1)+1,NJL
      IF(RESUM(KK,JJ).EQ.'Y')THEN
      IF((NUMP(KK)+NUMP(JJ)).LT.MNSUM(KK,JJ)) GO TO 37
      IF((NUMP(KK)+NUMP(JJ)).GT.MXSUM(KK,JJ)) GO TO 37
      ELSE
      CONTINUE
      END IF
3610  CONTINUE
3611  CONTINUE

 3612 continue

CA  THE PATTERN HAS A NUMBER OF PARTICLES (OR HOLES) NPTOSC IN ALL GIVEN MAJOR 
CA  SHELL AND SATIFIES THE RESTRICTIONS (IF ANY) IN THE MAJOR SHELL AND 
CA  THE PARITY SO INCREMENT THE NUMBER OF PARTITIONS;
      NPART=NPART+1
      IF (NPART.GT.MAX_NPART) STOP ' ***** Fatal Error in WOTPTS:  
     1TOO MANY PARTITIONS *****' 
CA  NEXT DO LOOP IS MOST IMPORTANT: IT WORKS OUT THE PARTITION
      DO 10005  K=NJL,1,-1 
CWEO      IPART_BYTE(K,NPART)=NUMP(K) 
      IPART(K,NPART)=NUMP(K) 

      IF(NPART.EQ.1) THEN 
      MIN(K) = NUMP(K) 
      MAX(K) = NUMP(K) 
      ELSE 
      IF(NUMP(K).LT.MIN(K)) MIN(K) = NUMP(K) 
      IF(NUMP(K).GT.MAX(K)) MAX(K) = NUMP(K) 
      END IF       

C      END DO 
10005 CONTINUE    
37    CONTINUE 

      DO 10006  j=1,nused_loops
      jindex(j)=jindex(j)+step(j)
      IF(jindex(j).GT.high(j))THEN
       jindex(j)=low(j)

      else
      GOTO 1001
      END IF

C      END DO
10006 CONTINUE    

      RETURN
      END
