C
C
C  SUBROUTINE CALLED BY BASIS TO
C  WORK OUT ALL POSS PARTITIONS
C
C
CA  MXFIL(I)=MAXIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
CA  MNFIL(I)=MINIMUM NO. OF PARTICLES IN J-STATE =I(AFTER RESTRICTION IF ANY)
      SUBROUTINE WOTPTS 
      IMPLICIT INTEGER (A-Z)
      INCLUDE 'macfor.inc'                
      INCLUDE 'param.inc'                
      INCLUDE 'bascom.inc'                
      COMMON/LISTPARTM/
     1MIN(MAX_NJL),MIN_O(MAX_NJL),MAX(MAX_NJL),MAX_O(MAX_NJL)
      INTEGER jindex(MAX_NJL),low(MAX_NJL),high(0:MAX_NJL)
      INTEGER step(MAX_NJL),NLEFT1(MAX_NJL)
      INCLUDE 'data.inc'                
      NPARTERR = 0
C
C  WORK OUT ALL POSSIBLE PARTITIONS
CA    DOESNT USE ANY BASIS STATE 
      NLEFT=NPTCL
      DO 34 I=1,NJL 
34    NLEFT=NLEFT-MNFIL(I) 
      IF (NLEFT.LT.0) STOP ' ***** Fatal Error in WOTPTS:  
     1RESTRICTIONS TOO SEVERE-NOT ENOUGH PARTICLES *****' 
      NPART=0 

CJSW - FIX UP CASE WHERE NJL = 1
      IF (NJL .EQ. 1) THEN 
        NPART = 1 
CHECK PARITY
        KPARIT=KPARQ(1)*NPTCL 
        IF(MOD(KPARIT,2).NE.MOD(KPAR,2))NPART=0 
CWEO        IPART_BYTE(1,1) = NPTCL 
        IPART(1,1) = NPTCL 
        GOTO 370 
      ENDIF 
C
C
CEO   ADDED TO REPLACE NUMBER OF DO LOOPS 
C         WILL DO AS MANY SUBSHELLS AS MAX_NJL


      nused_loops=NJL-1
      DO 10001  i=1,nused_loops
      low(i)=0
      step(i)=1
      jindex(i)=low(i)
C      END DO
10001 CONTINUE    
      DO 10002  i=1,nused_loops
      NUMP(i+1)=MNFIL(i+1)
      NLEFT1(i+1)=NLEFT
      high(i)=MIN0(MXFIL(i+1)-MNFIL(i+1),NLEFT1(i+1))
C      END DO
10002 CONTINUE    
      DO 10003  i=1,nused_loops+1
C      end do
10003 CONTINUE    
      GOTO 1002

1001  continue
      DO 10004  i=1,j
      NUMP(j+2-i)=MNFIL(j+2-i)+jindex(j+1-i)
      NLEFT1(j+1-i)=NLEFT1(j+2-i)-jindex(j+1-i)
      high(j-i)=MIN0(MXFIL(j+1-i)-MNFIL(j+1-i),NLEFT1(j+1-i))
C      END DO
10004 CONTINUE    

1002  NUMP(1)=MNFIL(1)+NLEFT1(2)-jindex(1) 
      IF (NUMP(1).GT.MXFIL(1)) GO TO 37 
      K=1 
      KPARIT=0 
      IPT=0 
CA  DO OVER MAJOR SHELL
      DO 361 I=1,NOSC 
      NPTOSC=0 
CA  DO OVER ORBITALS FOR A GIVEN MAJOR SHELL
      DO 36 J=1,NOSCJL(I) 
      NPTOSC=NPTOSC+NUMP(K) 
      IF (NPTOSC.GT.MXOSC(I)) GO TO 37 
CA  PARITY OF THE PATTERN
      KPARIT=KPARIT+KPARQ(K)*NUMP(K) 
36    K=K+1 
      IF (NPTOSC.LT.MNOSC(I)) GO TO 37 
361   CONTINUE 
      IF(NPTYPE.NE.'BOTH'.AND.SUMRES.NE.'y')GOTO 3612


      DO 3611 KK=1,NOSCJL(1)
      DO 3610 JJ=NOSCJL(1)+1,NJL
c     print 7777,KK,JJ
7777  FORMAT(1X,2I4)
      IF(RESUM(KK,JJ).EQ.'Y')THEN
      IF((NUMP(KK)+NUMP(JJ)).LT.MNSUM(KK,JJ)) GO TO 37
      IF((NUMP(KK)+NUMP(JJ)).GT.MXSUM(KK,JJ)) GO TO 37
      ELSE
      CONTINUE
      END IF
3610  CONTINUE
3611  CONTINUE

 3612 continue


951   IF (MOD(KPARIT,2).NE.MOD(KPAR,2)) GO TO 37
CBAB  IF(.NOT.BPAIRS)  GOTO 71 
      IF(IBPAIRS.EQ.0) GOTO 71 
C  Now test if odd number of particles in each J-orbit
CBAB  type *,' BPAIRS is true ' 
      ntest=0 
      do 70 iw=1,njl 
      if(mod(nump(iw),2).eq.0)goto 70 
      ntest=ntest+1 
      if(ntest.gt.max_bpairs)goto 37 
70    continue 
CA  THE PATTERN HAS A NUMBER OF PARTICLES (OR HOLES) NPTOSC IN ALL GIVEN MAJOR 
CA  SHELL AND SATIFIES THE RESTRICTIONS (IF ANY) IN THE MAJOR SHELL AND 
CA  THE PARITY SO INCREMENT THE NUMBER OF PARTITIONS;
71    NPART=NPART+1 
C      TYPE 7778,(NUMP(KKK),KKK=1,6)
C7778  FORMAT(20X,6I3)
      IF(NPART.GT.MAX_NPART) NPARTERR = NPART
CBAB      IF (NPART.GT.MAX_NPART) STOP ' ***** Fatal Error in WOTPTS:  
CBAB     1TOO MANY PARTITIONS *****' 
CA  NEXT DO LOOP IS MOST IMPORTANT: IT WORKS OUT THE PARTITION
      DO 10005  K=NJL,1,-1 
CWEO      IPART_BYTE(K,NPART)=NUMP(K) 
      IF(NPARTERR.EQ.0) IPART(K,NPART)=NUMP(K) 

      IF(NPART.EQ.1) THEN 
      MIN(K) = NUMP(K) 
      MAX(K) = NUMP(K) 
      ELSE 
      IF(NUMP(K).LT.MIN(K)) MIN(K) = NUMP(K) 
      IF(NUMP(K).GT.MAX(K)) MAX(K) = NUMP(K) 
      END IF       

C      END DO 
10005 CONTINUE    
37    CONTINUE 

      DO 10006  j=1,nused_loops
      jindex(j)=jindex(j)+step(j)
      IF(jindex(j).GT.high(j))THEN
       jindex(j)=low(j)

      else
      GOTO 1001
      END IF

C      END DO
10006 CONTINUE    

370   CONTINUE
c     IF(NPARTERR.GT.0) WRITE(6,4000) MAX_NPART,NPARTERR
c4000  FORMAT(1X,'INCREASE MAX_NPART FROM ',I5,' TO ',I5)
      IF(NPARTERR.GT.0) print*,'INCREASE MAX_NPART FROM',
     &MAX_NPART,' TO ',NPARTERR
      IF(NPARTERR.GT.0) STOP

      RETURN
      END
