      IF (ICASE.GT.1) GO TO 101
      CALL TITLE(IOUT)
  101 IF (ICASE.EQ.1.OR.ICASE.EQ.4) WRITE(IOUT,102) EIGFIL 
      IF (ICASE.EQ.2) WRITE(IOUT,103) 
      IF (ICASE.EQ.3) WRITE(IOUT,104) 
  102 FORMAT(////5X,A9,' CALCULATION') 
  103 FORMAT(////'    CLUSTER STATE CALCULATION') 
  104 FORMAT(////'    CORE STATE CALCULATION') 

      WRITE(IOUT,105) NPTCL
  105 FORMAT(/,1X,'# of valence particles      : ',I3)
      IHJAY=JAY/2
      IHIMZS=IMZS/2
      IHITT=ITT/2
      IHITZS=ITZS/2
      IF(IHJAY*2.EQ.JAY) WRITE(IOUT,106) IHJAY,IHIMZS
  106 FORMAT(/,1X,'                          J : ',I3,
     13X,'(Projected from state with Jz = ',I3,')')
      IF(IHJAY*2.NE.JAY) WRITE(IOUT,107) JAY,IMZS
  107 FORMAT(/,1X,'                          J : ',I3,'/2',
     11X,'(Projected from state with Jz = ',I3,'/2)')
      IF(IHITT*2.EQ.ITT) WRITE(IOUT,108) IHITT,IHITZS
  108 FORMAT(1X,'                          T : ',I3,
     13X,'(Projected from state with Tz = ',I3,')')
      IF(IHITT*2.NE.ITT) WRITE(IOUT,109) ITT,ITZS
  109 FORMAT(1X,'                          T : ',I3,'/2',
     11X,'(Projected from state with Tz = ',I3,'/2)')

      IF (KPAR.EQ.0) PARITY='+VE'
      IF (KPAR.EQ.1) PARITY='-VE'
      IF (KPAR.EQ.2) PARITY='+VE'
      IF (KPAR.EQ.3) PARITY='-VE'
      WRITE(IOUT,110) PARITY
  110 FORMAT(1X,'                     Parity : ',A3)

      WRITE(IOUT,111) SPSFIL
  111 FORMAT(/,1X,'Model space (*.sps) name    : ',A9)
      WRITE(IOUT,112) BASFIL
  112 FORMAT(1X,'M-scheme basis (*.bas) name : ',A9)

      WRITE(IOUT,113)
  113 FORMAT(45X,'SPE_NORM  ME_NORM')
      DO 115 IINT = 1,NINT
      WRITE(IOUT,114) 
     1IINT,OPFIL(IINT),SPE_NORM(IINT),ME_NORM(IINT)
  114 FORMAT(1X,'TBME (*.int) name (',I1,')       : ',A9,3X,2F10.5)
  115 CONTINUE

      WRITE(IOUT,116) EIGFIL
  116 FORMAT(/,1X,'Eigenvector (*.eig) name    : ',A9)
      IF(IGNDERR.EQ.0) WRITE(IOUT,117) GNDFIL,GNDE
  117 FORMAT(1X,'Ground state (*.gnd) name   : ',A9,
     15X,F10.3,' = Eigenvalue of ground state')
      IF(IGNDERR.EQ.1) WRITE(IOUT,118) GNDFIL
  118 FORMAT(1X,'Ground state (*.gnd) name   : ',A9,'
     1 (Input file not found)')
      WRITE(IOUT,119) MATDIM
  119 FORMAT(1X,'Matrix dimension            : ',I6)

C
C  RESTRICTIONS
C
      WRITE(IOUT,120) (IINT,IINT=1,NINT) 
  120 FORMAT(//1X,'# of particles allowed in each j-level',
     15X,'Single-particle energies for each j-level',
     1//,1X,' SHELL         SUB SHELL     MAJOR SHELL'
     1,3X,'Total SPE  Delta SPE ------ SPE From *.INT files ------',
     1/,'                MIN   MAX      MIN   MAX '
     1,14X,'from input',9(4X,I1,4X))
      K=0 
      DO 123 I=1,NOSC 
      WRITE(IOUT,121) 
      DO 123 J=1,NOSCJL(I) 
      K=K+1 
      IF (J.EQ.1)  WRITE(IOUT,121) SHELL(K),MNFIL(K),MXFIL(K), 
     1  MNOSC(I),MXOSC(I),ENL(K),DENL(K),(ENLIN(K,IINT),IINT=1,NINT) 
  121 FORMAT(' ',A9,I9,I6,I9,I6,3X,F9.4,2X,10F9.4) 
      IF (J.GT.1) WRITE(IOUT,122) SHELL(K),MNFIL(K),MXFIL(K) 
     1  ,ENL(K),DENL(K),(ENLIN(K,IINT),IINT=1,NINT) 
  122 FORMAT(' ',A9,I9,I6,15X,3X,F9.4,2X,10F9.4) 
  123 CONTINUE 

      XCRIT=CRIT*1000.
      IF (ICASE.EQ.0) WRITE(IOUT,124) MAX_NST
  124   FORMAT(/,1X,'# iterations required       : ',I5)
      IF (ICASE.EQ.0) WRITE(IOUT,125) XCRIT
  125 FORMAT(1X,'Convergence criteria (keV)  : ',F5.2)
