C MAX_NSPS is the number of m-states allowed
C for the VAX MAX_BIT_NLWRDS=32 (see SHGRLIB:MACFOR.INC)
      PARAMETER (MAX_NLWRDS=8)           
      PARAMETER (MAX_NSPS=MAX_NLWRDS*MAX_BIT_NLWRDS)

C MAX_NJL is the number orbits allowed
      PARAMETER (MAX_NJL=24)              

C MAX_NOSC is the number orbit groupings allowed
      PARAMETER (MAX_NOSC=6)             

C MAX_NPART is the number of partitions allowed
C INCREASED MAX_NPART FROM 600 TO 3000 FOR SDPFPN SPACE
C      PARAMETER (MAX_NPART=1500)          
      PARAMETER (MAX_NPART=5000)          

C MAX_MSCHEME is the maximum m-dim within a partition
      PARAMETER (MAX_MSCHEME=60000)     

C MAX_IPROT is the maximum number of proton partitions
C increased from 24 to 30 for O16 psd 4p4h calculation
C increased from 30 to 50 for C12 psd 4p4h calculation
      PARAMETER (MAX_IPROT=50)

C MAX_NJT maximum number of J-T states for a given partition
      PARAMETER (MAX_NJT=2000)  

C MAX_LININDP used only for PROJ
      PARAMETER (MAX_LININDP=10000000)  

C used only for OPER
      PARAMETER (MAX_IBAB=6000000,MAX_ELEM_PART=100000)

C used only for MATRIX
      PARAMETER (MAX_OPER_ELEMENTS=6000000,MAX_NPARTH=10000)

      
C misc parameters not usually changed
      PARAMETER (NLWRDS_BLOCK=64)       
      PARAMETER (N_WORDS=MAX_NJL)      
      PARAMETER (MAX_PRED=MAX_NJT)
      PARAMETER (NO_JVAL=10)
      PARAMETER (NO_TVAL=3)
      INTEGER TWELVE
      PARAMETER (TWELVE=(3+NO_TVAL*NO_JVAL)*1)  ! a test at this stage...

C   where the   1 2 3 4 5 6 7 8 9 A B C D
C   parameters  -------------------------
C   ared used   S B P P O M L M T C T I H
C               H A R R P A A V R H B N C
C               E S E O E T N E A A T T M
C               L I D J R R C C M N D E
C               L S I     I Z   P G O R
C                   C     X O     E P
C                   T       S

C MAX_NOSC      1 2 3 4 5 6 7 8 9   B   D
C N_WORDS       1 2 3 4 5 6 7 8 9 A B C D
C MAX_NJL       1 2 3 4 5 6 7 8 9 A B C D
C MAX_NLWRDS      2 3 4 5 6 7 8 9   B
C MAX_NSPS        2 3 4 5 6     9
C NLWRDS_BLOCK    2 3 4   6   8 9
C MAX_NPART       2 3 4   6   8 9   B
C MAX_MSCHEME     2 3 4   6   8 9
C TWELVE          2 3 4   6     9 
C MAX_NJT           3 4   6    
C MAX_PRED          3 4   6
C MAX_IPROT         3 4        
c
