      SUBROUTINE CORE
      CHARACTER*3 KEY
      COMMON/CKEY/KEY,HBW
      COMMON/MEI/IDJ,IDT
      COMMON/CIK/IK(30,4),IKMAX(4)
      COMMON/CORE/IKC(30),IKCMAX,XCORE(100)
      COMMON/INDEX/XL(3,200)
      ICOREMAX = 0
      WRITE(6,730)
      WRITE(11,730)
730   FORMAT(/,1X,'INDEX OF ORBITS TO BE INCLUDED IN CORE ENERGY')
      READ(5,731) (IKC(I),I=1,30)
731   FORMAT(70I)
      DO 732 I = 1,20
      IF(IKC(I).EQ.0) GO TO 733
732   CONTINUE
733   IKCMAX = I-1
      IF(IKCMAX.LE.0) GO TO 700
      WRITE(11,729) (IKC(I),I=1,IKCMAX)
729   FORMAT(/,1X,'INPUT = ',20I3)
      DO 710 I = 1,IKCMAX
      WRITE(6,711) IKC(I),XL(1,IKC(I)),XL(2,IKC(I)),XL(3,IKC(I))
      WRITE(11,711) IKC(I),XL(1,IKC(I)),XL(2,IKC(I)),XL(3,IKC(I))
711   FORMAT(/,1X,'FOR ORBIT: ',I3,3X,' N,L,J = ',3F5.1)
710   CONTINUE
      IF(IKCMAX.EQ.0) GO TO 760
CBAB SINGLE PARTICLE ENERGIES
      XDJ = IDJ
      XDT = IDT
      DO 700 I1 = 1,IKMAX(1)
      I2 = I1
C      DO 700 I2 = 1,IKMAX(1)
      XJ1 = XL(3,IK(I1,1))
      XJ2 = XL(3,IK(I2,1))
C      IF(TR(XJ1,XJ2,XDJ).EQ.-1.) GO TO 700
C      IF(TR(.5,.5,XDT).EQ.-1.) GO TO 700
C      IF(PAR(XL(2,IK(I1,1))+XL(2,IK(I2,1))).NE.PAR(XDP)) GO TO 700
C      ICOREMAX = ICOREMAX + 1
C      XCORE(ICOREMAX) = COREMECM(IK(I1,1),IK(I2,1),IDJ,IDT)
      XCORE(I1) = COREMECM(IK(I1,1),IK(I2,1),IDJ,IDT)

700   CONTINUE
760   CONTINUE
      IF(KEY.NE.'HCM') RETURN
      DO 750 I1 = 1,IKMAX(1)
      X = (2.*(XL(1,IK(I1,1)) -1.)+XL(2,IK(I1,1)))
      XCORE(I1) = XCORE(I1) + X
      TYPE 7777,I1,IK(I1,1),XCORE(I1),X
7777  FORMAT(1X,2I3,2F10.5)
750   CONTINUE
      RETURN
      END

      FUNCTION COREME(I1,I2,IDJ,IDT)
      COMMON/CORE/IKC(30),IKCMAX
      COMMON/INDEX/XL(3,200)

      GS = 0.

      XK = IDJ
      XTAU = IDT
      DO 600 ICC = 1,IKCMAX
      IC = IKC(ICC)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJC = XL(3,IC)
      JTMIN = 1
      JTMAX = 2
      JTPMIN = 1
      JTPMAX = 2
      XC = PAR(XJC+XJ2+1.+XK+XTAU)
      JMIN = ABS(XJ1-XJC) + 1.
      JMAX = XJ1 + XJC + 1.
      JPMIN = ABS(XJ2-XJC) + 1.
      JPMAX = XJ2 + XJC + 1.
      S = 0.

      DO 200 JT = JTMIN,JTMAX
      DO 200 JTP = JTPMIN,JTPMAX
      DO 200 J = JMIN,JMAX
      DO 200 JP = JPMIN,JPMAX
      IJ = J-1
      IJP = JP-1
      IF(ITR(IJ,IJP,IDJ))200,200,206
206   CONTINUE
      IT = JT-1
      ITP = JTP-1
      IF(ITR(IT,ITP,IDT))200,200,205
205   CONTINUE
      XJ = IJ
      XJP = IJP
      XT = IT
      XTP = ITP
      XIC = IC
      XI1 = I1
      XI2 = I2
      X = (2.*XJ+1.)*(2.*XJP+1.)*(2.*XT+1.)*(2.*XTP+1.)
      X = PAR(XJ+XT)*SQRT(X)
      X = X*SJ(XJ,XJ1,XJC,XJ2,XJP,XK)
      X = X*SJ(XT,.5,.5,.5,XTP,XTAU)
      X = X*SQRT((1.+DELTA(XIC-XI1))*(1.+DELTA(XIC-XI2)))
      XX = TBME(IC,I1,IC,I2,IJ,IJP,IT,ITP,IDJ,IDT)
      S = S+X*XX*XC
200   CONTINUE
      GS = S + GS
      WRITE(6,410) I1,I2,IC,S,GS
      WRITE(11,410) I1,I2,IC,S,GS
410   FORMAT(1X,'I1,I2,ICORE,COREME,TOTAL COREME = ',3I4,2F10.5)
600   CONTINUE
      COREME = GS

800   CONTINUE
      RETURN
      END

      FUNCTION COREMECM(I1,I2,IDJ,IDT)
      COMMON/CORE/IKC(30),IKCMAX
      COMMON/INDEX/XL(3,200)

      GS = 0.

      XK = IDJ
      XTAU = IDT
      DO 600 ICC = 1,IKCMAX
      IC = IKC(ICC)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJC = XL(3,IC)
      JTMIN = 1
      JTMAX = 2
      JTPMIN = 1
      JTPMAX = 2
      XC = PAR(XJC+XJ2+1.+XK+XTAU)
      JMIN = ABS(XJ1-XJC) + 1.
      JMAX = XJ1 + XJC + 1.
      JPMIN = ABS(XJ2-XJC) + 1.
      JPMAX = XJ2 + XJC + 1.
      S = 0.

      DO 200 JT = JTMIN,JTMAX
      DO 200 JTP = JTPMIN,JTPMAX
      DO 200 J = JMIN,JMAX
      DO 200 JP = JPMIN,JPMAX
      IJ = J-1
      IJP = JP-1
      IF(ITR(IJ,IJP,IDJ))200,200,206
206   CONTINUE
      IT = JT-1
      ITP = JTP-1
      IF(ITR(IT,ITP,IDT))200,200,205
205   CONTINUE
      XJ = IJ
      XJP = IJP
      XT = IT
      XTP = ITP
      XIC = IC
      XI1 = I1
      XI2 = I2
      X = (2.*XJ+1.)*(2.*XT+1.)/(2.*(2.*XJ1+1.))
      XX = TBME(IC,I1,IC,I2,IJ,IJP,IT,ITP,IDJ,IDT)
      S = S+X*XX
200   CONTINUE
      GS = S + GS
      WRITE(6,410) I1,I2,IC,S,GS
      WRITE(11,410) I1,I2,IC,S,GS
410   FORMAT(1X,'I1,I2,ICORE,COREME,TOTAL COREME = ',3I4,2F10.5)
600   CONTINUE
      COREMECM = GS

800   CONTINUE
      RETURN
      END

