CBAB OCT 1990
CBAB BASED ON EQUATIONS IN M. HARVEY, AD. NUCL. PHYS. 1, 67 (1968)
CBAB DEFAULT CONSTANTS IN MAIN ROUTINE FROM BILL RAE'S ORIGINAL CODE
      SUBROUTINE SU3
     1(XCALL,IO1,IO2,IO3,IO4,IJ12,IJ34,IT12,IT34,IJ,IT)

      CHARACTER*3 KEY
      COMMON/CSU3/XCSU3,XMSU3,XLSU3,XSSU3
      COMMON/CKEY/KEY,HBW
      REAL*8 VM
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
CWAR
      INCLUDE 'VNCOM.INC'
      COMMON/SUM/SUMRT(14,15)
CWAR
      COMMON/INDEX/XL(3,200)

 
CBAB -------------------------------------------------

CBAB CENTRAL ONLY
      IS = 0
      IL = 0
      XIS = IS
      XIL = IL
      XIJ = IJ
      XIT = IT
      XIJ12 = IJ12
      XIJ34 = IJ34
      XIT12 = IT12
      XIT34 = IT34
      XN1 = XL(1,IO1)-1.
      XN2 = XL(1,IO2)-1.
      XN3 = XL(1,IO3)-1.
      XN4 = XL(1,IO4)-1.
      XL1 = XL(2,IO1)
      XL2 = XL(2,IO2)
      XL3 = XL(2,IO3)
      XL4 = XL(2,IO4)
      XJ1 = XL(3,IO1)
      XJ2 = XL(3,IO2)
      XJ3 = XL(3,IO3)
      XJ4 = XL(3,IO4)
      N1 = XN1
      N2 = XN2
      N3 = XN3
      N4 = XN4
      L1 = XL1
      L2 = XL2
      L3 = XL3
      L4 = XL4
CSU3 SEE BELOW ON THE COMMENT TO REMOVE THIS RESTRICTION TO A MAJOR SHELL
      M1 = 2*N1+L1
      M2 = 2*N2+L2
      M3 = 2*N3+L3
      M4 = 2*N4+L4
C      IF(M1.NE.M2) RETURN
C      IF(M1.NE.M3) RETURN
C      IF(M1.NE.M4) RETURN
CBAB EXTRA CHECKS
      IF(TR(XJ1,XJ2,XIJ12).EQ.-1.) GO TO 801
      IF(TR(XJ3,XJ4,XIJ34).EQ.-1.) GO TO 801
      IF(TR(XIJ12,XIJ34,XIJ).EQ.-1.) GO TO 801
      GO TO 804
801   CONTINUE
      TYPE 802
802   FORMAT(1X,'ILLEGAL J COUPLINGS')
      TYPE 803,XJI,XJ2,XJ3,XJ4,XIJ12,XIJ34,XIJ
803   FORMAT(1X,'XJI,XJ2,XJ3,XJ4,XIJ12,XIJ34,XIJ = ',7F5.1)
      RETURN
804   CONTINUE

CBAB LOOP OVER S AND L COUPLINGS OF THE INITIAL AND FINAL STATES
      JL12MIN = ABS(XL1-XL2)
      JL12MAX = XL1 + XL2
      JL34MIN = ABS(XL3-XL4)
      JL34MAX = XL3 + XL4
      DO 400 IL12 = JL12MIN,JL12MAX
      DO 400 IL34 = JL34MIN,JL34MAX
      DO 400 IS12 = 0,1
      DO 400 IS34 = 0,1
      XIL12 = IL12
      XIL34 = IL34
      XIS12 = IS12
      XIS34 = IS34
      IF(TR(XIL12,XIL34,XIL).EQ.-1.) GO TO 400
      IF(TR(XIS12,XIS34,XIS).EQ.-1.) GO TO 400

CBAB      XLS = PAR(XIS12+XIL34+XIJ12)
CBAB     1*SJ(XIL12,XIS12,XIJ12,XIS34,XIL34,XIL)
      XLS = 1.
      XLS12 = XLSJJ(XL1,0.5,XJ1,XL2,0.5,XJ2,XIL12,XIS12,XIJ12)
      XLS34 = XLSJJ(XL3,0.5,XJ3,XL4,0.5,XJ4,XIL34,XIS34,XIJ34)
      IF(XLS.EQ.0.) GO TO 400
      IF(XLS12.EQ.0.) GO TO 400
      IF(XLS34.EQ.0.) GO TO 400
CSU3-------------------------------------------------------
CSU3 2 L1.L2
      XLDL = 0.
      IF(L1.EQ.L3.AND.L2.EQ.L4
     1.AND.N1.EQ.N3.AND.N2.EQ.N4) 
     1   XLDL=XIL12*(XIL12+1.)-XL1*(XL1+1.)-XL2*(XL2+1.)
CSU3 CASIMIR = 2 Q.Q + 6 L.L
CSU3 THIS EXPRESSION IS EQ. 3.13 OF HARVEY
      VQSU3 = 2.*(16.0*3.14159/5.0)*XCSU3
     1 *PAR(XL2+XIL12+XL3)*SJ(XL1,XL2,XIL12,XL4,XL3,2.)
     1 *YLL(IO1,IO3,2)*YLL(IO2,IO4,2)
C     1 *(RL(IO1,IO3,2)+2.*XKSS(IO1,IO3))
C     1 *(RL(IO2,IO4,2)+2.*XKSS(IO2,IO4))
     1 *(RL(IO1,IO3,2)+2.*XKSS(IO1,IO3))
     1 *(RL(IO2,IO4,2)+2.*XKSS(IO2,IO4))/4.
     1 + XCSU3*3.*XLDL
CSU3 Majorana
      VMSU3 = 0.
      IF(L1.EQ.L3.AND.L2.EQ.L4
     1.AND.N1.EQ.N3.AND.N2.EQ.N4) 
     1 VMSU3=XMSU3*PAR(XIS12+XIT12+1.)
CBAB      VMSU3=XMSU3*PAR(XIS12+XIT12+1.)
CSU3 L.L
      VLSU3 = XLSU3*XLDL
CSU3 2 S.S
      VSSU3 = 0.
      IF(L1.EQ.L3.AND.L2.EQ.L4
     1.AND.N1.EQ.N3.AND.N2.EQ.N4) 
     1 VSSU3 = XSSU3*(XIS12*(XIS12+1.)-0.5*1.5-0.5*1.5)

      SUMR = VQSU3+VMSU3+VLSU3+VSSU3

      XTOTAL = XCALL*XLS*XLS12*XLS34*SUMR
      VM(IT12+1,IS12+1,1,IL+1) 
     1 = VM(IT12+1,IS12+1,1,IL+1) + XTOTAL

400   CONTINUE     ! LOOP OVER IS12,IS34,IL12,IL34
250   CONTINUE     ! LOOP OVER IL
200   CONTINUE     ! LOOP OVER IS
CBAB *****************************************************************

      RETURN
      END

      SUBROUTINE SSU3SPE
      COMMON/INDEX/XL(3,200)
      COMMON/CSU3/XCSU3,XMSU3,XLSU3,XSSU3,
     1ISU3MAX,ISU3(50),SU3SPE(50)

      DO 300 I = 1,ISU3MAX
      XN1 = XL(1,ISU3(I))
      XL1 = XL(2,ISU3(I))
      XM1 = 2.*XN1+XL1
      XJ1 = XL(3,ISU3(I))
      X = XLSU3*XL1*(XL1+1.)

      Y = 0.
      DO 400 IC = 1,ISU3MAX
      XNC = XL(1,ISU3(IC))
      XLC = XL(2,ISU3(IC))
      XMC = 2.*XNC+XLC
      IF(XM1.NE.XMC) GO TO 400
      X1 = 4.*SQRT(3.14159/5.)*EL(ISU3(I),ISU3(IC),2)
     1 *RL(ISU3(I),ISU3(IC),2)
      Y = Y + X1*X1
400   CONTINUE
      Y = (Y/(2.*XJ1+1.)) + 3.*XL1*(XL1+1.)
      X = X + XCSU3*Y
      SU3SPE(ISU3(I)) = X
300   CONTINUE
      RETURN
      END

