      SUBROUTINE GETVS(IOUT)
      CHARACTER*3 KEY,AMU
      COMMON/CKEY/KEY,HBW
      CHARACTER*10 AAMU
      DIMENSION AAMU(3)
      COMMON/CMU/XMU(7),AMU(3)
      REAL*8 VM
      COMMON/CVM/VM(2,2,30,4),VS(2,2,30,4),IVM
      COMMON/CIDD/IDD,ALD
      COMMON/CSETPARV/ICAV,ILAV,ITAV,ISETL(10),ISETLNUM
 
CBAB AMU(TYPE)
CBAB XMU(RANGE)
CBAB VS(T+1,S+1,RANGE,TYPE)
 
      IF(IOUT.EQ.1) WRITE(6,310)
      IF(IOUT.EQ.1) WRITE(11,310)
310   FORMAT(1X,'CON  CONSTANT'
     1,/,1X,'SU3  SU3 conserving interaction (4 inputs)'
     1,/,1X,'HCM  center of mass Hamiltonian P**2 + R**2'
     1,/,1X,'COU  COULOMB'
     1,/,1X,'GIL  GILLET GAUSSIAN (originally for hw = 14.)'
     1,/,1X,'MK   MILLENER-KURATH  1-RANGE YUAKAWA'
     1,/,1X,'M3Y  LOVE             3-RANGE YUKAWA BASED ON REID'
     1,/,1X,'M3A  M3Y WITH NO TENSOR'
     1,/,1X,'M3P  M3Y WITH NO RHO TENSOR'
     1,/,1X,'M3C  M3Y WITH NO TENSOR OR SPIN ORBIT (CENTRAL ONLY)'
     1,/,1X,'P4Y  RAMAN            4-RANGE YUKAWA BASED ON PARIS'
     1,/,1X,'R4Y  RAMAN            4-RANGE YUKAWA BASED ON REID'
     1,/,1X,'H6Y  HOSAKA-KUBO-TOKI 6-RANGE YUKAWA BASED ON PARIS'
     1,/,1X,'H7B  HOSAKA-KUBO-TOKI 7-RANGE OBEP   BASED ON PARIS'
     1,/,1X,'H7A  H7B NO TENSOR'
     1,/,1X,'H7T  H7B TENSOR ONLY'
     1,/,1X,'H7C  H7B NO TENSOR OR SPIN ORBIT (CENTRAL ONLY)'
     1,/,1X,'H7P  H7B NO RHO TENSOR'
     1,/,1X,'HBB  HOSAKA           4-RANGE OBEP   BASED ON BONN'
     1,/,1X,'H7M  MODIFIED H7B AUG 1988'
     1,/,1X,'OPP  One-pion exhange potential'
     1,/,1X,'H7N  H7B with Nakayamas tensor force'
     1,/,1X,'D1   Gognys D1 central interaction'
     1,/,1X,'ST1  Schiffer-True interaction (R2 = 2.0)'
     1,/,1X,'ST2  Schiffer-True interaction (R2 = 0.1)'
     1,/,1X,'HBU  Brown-Richter 17 (3 SPE) parmaeter sd-shell int.'
     1,/,1X,'BRU  Brown-Richter sd-fp-shell int.'
     1,/,1X,'HBA  HBU WITH NO TENSOR'
     1,/,1X,'HBP  HBU WITH NO RHO TENSOR'
     1,/,1X,'HBC  HBU WITH NO TENSOR OR SPIN ORBIT (CENTRAL ONLY)'
     1,/,1X,'HBM  Brown-Richter 20 (6 SPE) parmaeter sd-shell int.'
     1,/,1X,'FPV  Brown-Richter 20 (6 SPE) parmaeter pf-shell
     1(r=1) int'
     1,/,1X,'FPU  Brown-Richter 8 (6 SPE) parmaeter full pf-shell
     1 int'
     1,/,1X,'WBP  Warburton-Brown 15 (5 SPE) parameter psd-shell
     1int.'
     1,/,1X,'DE   NEW DELTA'
     1,/,1X,'TT   TO READ G-MATRIX INTERACTION STRENGTHS')
      IF(IOUT.EQ.1) RETURN
 
      DO 8000 I1 = 1,2
      DO 8000 I2 = 1,2
      DO 8000 I3 = 1,30
      DO 8000 I4 = 1,4
8000  VS(I1,I2,I3,I4) = 0.
 
      IF(KEY.EQ.'TT') GO TO 500
      IF(KEY.EQ.'CON') GO TO 161
      IF(KEY.EQ.'HCM') GO TO 160
      IF(KEY.EQ.'SU3') GO TO 150
      IF(KEY.EQ.'COU') GO TO 187
      IF(KEY.EQ.'MK') GO TO 168
      IF(KEY.EQ.'GIL') GO TO 151
      IF(KEY.EQ.'P4Y') GO TO 162
      IF(KEY.EQ.'R4Y') GO TO 163
      IF(KEY.EQ.'M3Y') GO TO 164
      IF(KEY.EQ.'M3A') GO TO 1164
      IF(KEY.EQ.'M3P') GO TO 3164
      IF(KEY.EQ.'M3C') GO TO 2164
      IF(KEY.EQ.'H6Y') GO TO 165
      IF(KEY.EQ.'H7B') GO TO 166
      IF(KEY.EQ.'H7A') GO TO 1166      
      IF(KEY.EQ.'H7T') GO TO 4166      
      IF(KEY.EQ.'H7C') GO TO 2166
      IF(KEY.EQ.'H7P') GO TO 3166
      IF(KEY.EQ.'HBB') GO TO 190
      IF(KEY.EQ.'H7M') GO TO 185
      IF(KEY.EQ.'OPP') GO TO 181
      IF(KEY.EQ.'H7N') GO TO 167
      IF(KEY.EQ.'D1') GO TO 169
      IF(KEY.EQ.'ST1') GO TO 180
      IF(KEY.EQ.'ST2') GO TO 184
      IF(KEY.EQ.'HBU') GO TO 182
      IF(KEY.EQ.'BRU') GO TO 4182
      IF(KEY.EQ.'HBA') GO TO 1182
      IF(KEY.EQ.'FPU') GO TO 6182
      IF(KEY.EQ.'HBC') GO TO 2182
      IF(KEY.EQ.'HBP') GO TO 3182
      IF(KEY.EQ.'HBM') GO TO 183
      IF(KEY.EQ.'WBP') GO TO 201
      IF(KEY.EQ.'FPV') GO TO 186
      IF(KEY.EQ.'DE') GO TO 188
 
      TYPE 152,KEY
152   FORMAT(1X,'ILLEGAL TYPE OF INTERACTION, KEY = ',A9)
      RETURN
 
500   CONTINUE
      AAMU(1) = 'CENTRAL'
      AAMU(2) = 'SPIN-ORBIT'
      AAMU(3) = 'TENSOR'
      DO 510 ITYPE = 1,3
      WRITE(6,503) AAMU(ITYPE)
503   FORMAT(1X,'TYPE OF ',A10,
     1' INTERACTION (CON,DEL,GAU,YU0,YU1,YU2,R2Y) (<CR> FOR NONE)')
      READ(5,504) AMU(ITYPE)
504   FORMAT(A)
510   CONTINUE
 
      WRITE(6,520)
520   FORMAT(1X,'LIST OF RANGES (UP TO 7)',
     1/,1X,'(0.01 WILL USE A DELTA FUNCTION INDEPENDENT OF TYPE OF
     1 INTERACTION)')
      READ(5,521) (XMU(I),I=1,7)
521   FORMAT(10F)
      DO 512 I = 7,1,-1
      IVM = I
      IF(XMU(I).NE.0.) GO TO 513
512   CONTINUE
513   CONTINUE
      DO 511 ITYPE = 1,3
CBAB      IF(AMU(ITYPE).EQ.' ') GO TO 511
      DO 171 I1 = 1,2
      DO 171 I2 = 1,2
      IF(ITYPE.EQ.2.AND.I2.EQ.1) GO TO 171
      IF(ITYPE.EQ.3.AND.I2.EQ.1) GO TO 171
      WRITE(6,170) AAMU(ITYPE),I1-1,I2-1
      WRITE(11,170) AAMU(ITYPE),I1-1,I2-1
170   FORMAT(/,1X,' STRENGTHS FOR ',A10,' (T,S)
     1= (',I1,',',I1,') (')
      READ(5,172) (VS(I1,I2,J,ITYPE),J=1,7)
172   FORMAT(20F)
      WRITE(11,173) AAMU(ITYPE),I1-1,I2-1,(VS(I1,I2,J,ITYPE),J=1,IVM)
173   FORMAT(/,1X,'FOR ',A10,' (T,S) = (',I1,',',I1,')',
     1/,1X,'INPUT = ',10F10.5)
171   CONTINUE
511   CONTINUE
      GO TO 947
 
 
160   CONTINUE
CBAB (T+1,S+1)
      IVM = 1
      XMU(1) = 1.
      AMU(1) = 'CON'
      VS(1,1,1,1) = 1.
      VS(1,2,1,1) = 1.
      VS(2,1,1,1) = 1.
      VS(2,2,1,1) = 1.
      GO TO 947
 
161   CONTINUE
CBAB (T+1,S+1)
      IVM = 1
      XMU(1) = 1.
      AMU(1) = 'CON'
      VS(1,1,1,1) = 1.
      VS(1,2,1,1) = 1.
      VS(2,1,1,1) = 1.
      VS(2,2,1,1) = 1.
      GO TO 947
 
150   CONTINUE
      IVM = 1
      XMU(1) = 1.
      AMU(1) = 'CON'
      VS(1,1,1,1) = 1.
      VS(1,2,1,1) = 1.
      VS(2,1,1,1) = 1.
      VS(2,2,1,1) = 1.
      GO TO 947
 
187   CONTINUE
CBAB (T+1,S+1)
      IVM = 1
      XMU(1) = 1.
      AMU(1) = 'COU'
      VS(1,1,1,1) = 0.
      VS(1,2,1,1) = 0.
      VS(2,1,1,1) = 1.44
      VS(2,2,1,1) = 1.44
      GO TO 947
 
151   CONTINUE
      IVM = 1
      XMU(1) = 1.72   ! ORIGINALLY FOR BOSC/XMU = 1., ASSUME HBW = 14.
      AMU(1) = 'GAU'
      VS(1,1,1,1) = -20.
      VS(1,2,1,1) = -40.
      VS(2,1,1,1) = -16.
      VS(2,2,1,1) =  20.
      GO TO 947
 
168   CONTINUE
      IVM = 2
      XMU(1) = 1.46   ! ORIGINALLY FOR BOSC/XMU = 1.18., ASSUME HBW = 14.
      XMU(2) = 0.73   ! ORIGINALLY FOR BOSC/XMU = 2.36., ASSUME HBW = 14.
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'YU0'
      VS(1,1,1,1) =  31.987
      VS(1,2,1,1) = -44.8
      VS(2,1,1,1) = -26.880
      VS(2,2,1,1) =  12.813
      VS(1,2,2,2) = -26.0
      VS(2,2,2,2) = -91.0
      VS(1,2,1,3) = -16.25
      VS(2,2,1,3) =   6.175
      GO TO 947
 
162   CONTINUE
CBAB ANANTARAMANS PARIS POTENTIAL
      IVM = 4
      XMU(1) = .25
      XMU(2) = .40
      XMU(3) = .70
      XMU(4) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'R2Y'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =  -1418.
      VS(1,2,1,1) =  13967.
      VS(2,1,1,1) =  11466.
      VS(2,2,1,1) =  11345.
      VS(1,1,2,1) =    950.
      VS(1,2,2,1) =  -4594.
      VS(2,1,2,1) =  -3556.
      VS(2,2,2,1) =  -1900.
      VS(1,1,4,1) =     31.389
      VS(1,2,4,1) =    -10.463
      VS(2,1,4,1) =    -10.463
      VS(2,2,4,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,2) = -5101.
      VS(2,2,1,2) = -1897.
      VS(1,2,2,2) = -337.
      VS(2,2,2,2) = -632.
CBAB TENSOR
CBAB ERROR FOUND JAN 23 1987
CBAB      TC = XMU(3)*XMU(3)
CBAB      VS(1,2,2,3) = -1096.*TC
CBAB      VS(2,2,2,3) = 244.*TC
CBAB      VS(1,2,3,3) = -30.9*TC
CBAB      VS(2,2,3,3) = 15.6*TC
      VS(1,2,2,3) = -1096.*XMU(2)*XMU(2)
      VS(2,2,2,3) = 244.*XMU(2)*XMU(2)
      VS(1,2,3,3) = -30.9*XMU(3)*XMU(3)
      VS(2,2,3,3) = 15.6*XMU(3)*XMU(3)
      GO TO 947
 
163   CONTINUE
CBAB ANANTARAMANS REID POTENTIAL
      IVM = 4
      XMU(1) = .25
      XMU(2) = .40
      XMU(3) = .70
      XMU(4) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'R2Y'
CBAB CENTRAL
      VS(1,1,1,1) =  29580.
      VS(1,2,1,1) =  21227.
      VS(2,1,1,1) =  12455.
      VS(2,2,1,1) =  12052.
      VS(1,1,2,1) =  -3464.
      VS(1,2,2,1) =  -6622.
      VS(2,1,2,1) =  -3835.
      VS(2,2,2,1) =  -1990.
      VS(1,1,4,1) =     31.389
      VS(1,2,4,1) =    -10.463
      VS(2,1,4,1) =    -10.463
      VS(2,2,4,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,2) = -4382.
      VS(2,2,1,2) = -2918.
      VS(1,2,2,2) = -352.
      VS(2,2,2,2) = -483.
CBAB TENSOR
CBAB ERROR FOUND JAN 23 1987
CBAB      TC = XMU(3)*XMU(3)
CBAB      VS(1,2,2,3) = -1260.*TC
CBAB      VS(2,2,2,3) = 263.*TC
CBAB      VS(1,2,3,3) = -28.4*TC
CBAB      VS(2,2,3,3) = 13.8*TC
      VS(1,2,2,3) = -1260.*XMU(2)*XMU(2)
      VS(2,2,2,3) = 263.*XMU(2)*XMU(2)
      VS(1,2,3,3) = -28.4*XMU(3)*XMU(3)
      VS(2,2,3,3) = 13.8*XMU(3)*XMU(3)
      GO TO 947
 
164   CONTINUE
CBAB  M3Y
      IVM = 4
      XMU(1) = .25
      XMU(2) = .40
      XMU(3) = .70
      XMU(4) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'R2Y'
      VS(1,1,1,1) =  26941.
      VS(1,2,1,1) =  21227.
      VS(2,1,1,1) =  12454.
      VS(2,2,1,1) =      0.
      VS(1,1,2,1) =  -2777.
      VS(1,2,2,1) =  -6622.
      VS(2,1,2,1) =  -3835.
      VS(2,2,2,1) =      0.
      VS(1,1,4,1) =     31.389
      VS(1,2,4,1) =    -10.463
      VS(2,1,4,1) =    -10.463
      VS(2,2,4,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,2) = -0.0
      VS(2,2,1,2) = -3733.
      VS(1,2,2,2) = -813.
      VS(2,2,2,2) = -427.3
CBAB TENSOR
      VS(1,2,2,3) = -1259.6*XMU(2)*XMU(2)
      VS(2,2,2,3) = 283.0*XMU(2)*XMU(2)
      VS(1,2,3,3) = -28.41*XMU(3)*XMU(3)
      VS(2,2,3,3) = 13.62*XMU(3)*XMU(3)
      GO TO 947
 
1164  CONTINUE
CBAB  M3Y
      IVM = 4
      XMU(1) = .25
      XMU(2) = .40
      XMU(3) = .70
      XMU(4) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'R2Y'
      VS(1,1,1,1) =  26941.
      VS(1,2,1,1) =  21227.
      VS(2,1,1,1) =  12454.
      VS(2,2,1,1) =      0.
      VS(1,1,2,1) =  -2777.
      VS(1,2,2,1) =  -6622.
      VS(2,1,2,1) =  -3835.
      VS(2,2,2,1) =      0.
      VS(1,1,4,1) =     31.389
      VS(1,2,4,1) =    -10.463
      VS(2,1,4,1) =    -10.463
      VS(2,2,4,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,2) = -0.0
      VS(2,2,1,2) = -3733.
      VS(1,2,2,2) = -813.
      VS(2,2,2,2) = -427.3
CBAB TENSOR
      VS(1,2,2,3) = -1259.6*XMU(2)*XMU(2)
      VS(2,2,2,3) = 283.0*XMU(2)*XMU(2)
      VS(1,2,3,3) = -28.41*XMU(3)*XMU(3)
      VS(2,2,3,3) = 13.62*XMU(3)*XMU(3)
      VS(1,2,2,3) = 0.
      VS(2,2,2,3) = 0.
      VS(1,2,3,3) = 0.
      VS(2,2,3,3) = 0.
      GO TO 947

3164  CONTINUE
CBAB  M3Y
      IVM = 4
      XMU(1) = .25
      XMU(2) = .40
      XMU(3) = .70
      XMU(4) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'R2Y'
      VS(1,1,1,1) =  26941.
      VS(1,2,1,1) =  21227.
      VS(2,1,1,1) =  12454.
      VS(2,2,1,1) =      0.
      VS(1,1,2,1) =  -2777.
      VS(1,2,2,1) =  -6622.
      VS(2,1,2,1) =  -3835.
      VS(2,2,2,1) =      0.
      VS(1,1,4,1) =     31.389
      VS(1,2,4,1) =    -10.463
      VS(2,1,4,1) =    -10.463
      VS(2,2,4,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,2) = -0.0
      VS(2,2,1,2) = -3733.
      VS(1,2,2,2) = -813.
      VS(2,2,2,2) = -427.3
CBAB TENSOR
C      VS(1,2,2,3) = -1259.6*XMU(2)*XMU(2)
C      VS(2,2,2,3) = 283.0*XMU(2)*XMU(2)
      VS(1,2,3,3) = -28.41*XMU(3)*XMU(3)
      VS(2,2,3,3) = 13.62*XMU(3)*XMU(3)
      GO TO 947

2164  CONTINUE
CBAB  M3Y
      IVM = 4
      XMU(1) = .25
      XMU(2) = .40
      XMU(3) = .70
      XMU(4) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'R2Y'
      VS(1,1,1,1) =  26941.
      VS(1,2,1,1) =  21227.
      VS(2,1,1,1) =  12454.
      VS(2,2,1,1) =      0.
      VS(1,1,2,1) =  -2777.
      VS(1,2,2,1) =  -6622.
      VS(2,1,2,1) =  -3835.
      VS(2,2,2,1) =      0.
      VS(1,1,4,1) =     31.389
      VS(1,2,4,1) =    -10.463
      VS(2,1,4,1) =    -10.463
      VS(2,2,4,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,2) = 0.
      VS(2,2,1,2) = 0.
      VS(1,2,2,2) = 0.
      VS(2,2,2,2) = 0.
CBAB TENSOR
      VS(1,2,2,3) = 0.
      VS(2,2,2,3) = 0.
      VS(1,2,3,3) = 0.
      VS(2,2,3,3) = 0.
      GO TO 947
 
165   CONTINUE
CBAB HOSAKA-KUBO-TOKI YUKAWA PARIS POTENTIAL
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU0'
      AMU(3) = 'R2Y'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =  15991.
      VS(1,2,1,1) =  19886.
      VS(2,1,1,1) =  13015.
      VS(2,2,1,1) =  26795.
      VS(1,1,3,1) = -1955.1
      VS(1,2,3,1) = -2400.9
      VS(2,1,3,1) = -882.09
      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = 396.51
      VS(1,2,5,1) = -1262.7
      VS(2,1,5,1) = -993.25
      VS(2,2,5,1) = -142.92
      VS(1,1,7,1) =     31.389
      VS(1,2,7,1) =    -10.463
      VS(2,1,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,2) = -180181.
      VS(2,2,1,2) = -2865.0
      VS(1,2,2,2) = 101484.
      VS(2,2,2,2) = 774.51
      VS(1,2,3,2) = -16105.
      VS(2,2,3,2) = -1782.1
      VS(1,2,5,2) = 658.59
      VS(2,2,5,2) = -6.0303
 
CBAB TENSOR
CBAB ERROR FOUND JAN 23 1987
CBAB      TC = XMU(3)*XMU(3)
CBAB      VS(1,2,1,3) = 83942.*TC
CBAB      VS(2,2,1,3) = -60758.*TC
CBAB      VS(1,2,2,3) = -40018.*TC
CBAB      VS(2,2,2,3) = 26077.*TC
CBAB      VS(1,2,3,3) = 1781.1*TC
CBAB      VS(2,2,3,3) = -1769.8*TC
CBAB      VS(1,2,6,3) = -65.373*TC
CBAB      VS(2,2,6,3) = 23.870*TC
      VS(1,2,1,3) = 83942.*XMU(1)*XMU(1)
      VS(2,2,1,3) = -60758.*XMU(1)*XMU(1)
      VS(1,2,2,3) = -40018.*XMU(2)*XMU(2)
      VS(2,2,2,3) = 26077.*XMU(2)*XMU(2)
      VS(1,2,3,3) = 1781.1*XMU(3)*XMU(3)
      VS(2,2,3,3) = -1769.8*XMU(3)*XMU(3)
      VS(1,2,6,3) = -65.373*XMU(6)*XMU(6)
      VS(2,2,6,3) = 23.870*XMU(6)*XMU(6)
      GO TO 947
 
166   CONTINUE
CBAB HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =  15991.
      VS(1,2,1,1) =  19886.
      VS(2,1,1,1) =  13015.
      VS(2,2,1,1) =  26795.
      VS(1,1,3,1) = -1955.1
      VS(1,2,3,1) = -2400.9
      VS(2,1,3,1) = -882.09
      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = 396.51
      VS(1,2,5,1) = -1262.7
      VS(2,1,5,1) = -993.25
      VS(2,2,5,1) = -142.92
      VS(1,1,7,1) =     31.389
      VS(1,2,7,1) =    -10.463
      VS(2,1,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
CBAB THIS FACTOR WAS REMOVED ON JAN 23 1987 BECAUSE TWO ERRORS WERE
CBAB FOUND IN HOSAKAS PAPER, 1) SIGMA DOT L IN EQ (2) SHOULD BE
CBAB S DOT L, THERE SHOULD BE ANOTHER 1/X FACTOR IN EQ (3)
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
      VS(1,2,2,2) = -30963.
      VS(2,2,2,2) = 9109.8
      VS(1,2,4,2) = 2343.4
      VS(2,2,4,2) = -2301.8
CBAB      VS(1,2,2,2) = -30963./2.
CBAB      VS(2,2,2,2) = 9109.8/2.
CBAB      VS(1,2,4,2) = 2343.4/2.
CBAB      VS(2,2,4,2) = -2301.8/2.
CBAB TENSOR
      VS(1,2,2,3) = 3104.9
      VS(2,2,2,3) = -1382.0
      VS(1,2,7,3) = -10.463
      VS(2,2,7,3) = 3.488
      GO TO 947
 
1166   CONTINUE
CBAB HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =  15991.
      VS(1,2,1,1) =  19886.
      VS(2,1,1,1) =  13015.
      VS(2,2,1,1) =  26795.
      VS(1,1,3,1) = -1955.1
      VS(1,2,3,1) = -2400.9
      VS(2,1,3,1) = -882.09
      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = 396.51
      VS(1,2,5,1) = -1262.7
      VS(2,1,5,1) = -993.25
      VS(2,2,5,1) = -142.92
      VS(1,1,7,1) =     31.389
      VS(1,2,7,1) =    -10.463
      VS(2,1,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
CBAB THIS FACTOR WAS REMOVED ON JAN 23 1987 BECAUSE TWO ERRORS WERE
CBAB FOUND IN HOSAKAS PAPER, 1) SIGMA DOT L IN EQ (2) SHOULD BE
CBAB S DOT L, THERE SHOULD BE ANOTHER 1/X FACTOR IN EQ (3)
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
      VS(1,2,2,2) = -30963.
      VS(2,2,2,2) = 9109.8
      VS(1,2,4,2) = 2343.4
      VS(2,2,4,2) = -2301.8
CBAB      VS(1,2,2,2) = -30963./2.
CBAB      VS(2,2,2,2) = 9109.8/2.
CBAB      VS(1,2,4,2) = 2343.4/2.
CBAB      VS(2,2,4,2) = -2301.8/2.
CBAB TENSOR
C      VS(1,2,2,3) = 3104.9
C      VS(2,2,2,3) = -1382.0
C      VS(1,2,7,3) = -10.463
C      VS(2,2,7,3) = 3.488
      GO TO 947
 
4166   CONTINUE
CBAB HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
C      VS(1,1,1,1) =  15991.
C      VS(1,2,1,1) =  19886.
C      VS(2,1,1,1) =  13015.
C      VS(2,2,1,1) =  26795.
C      VS(1,1,3,1) = -1955.1
C      VS(1,2,3,1) = -2400.9
C      VS(2,1,3,1) = -882.09
C      VS(2,2,3,1) = -2801.4
C      VS(1,1,5,1) = 396.51
C      VS(1,2,5,1) = -1262.7
C      VS(2,1,5,1) = -993.25
C      VS(2,2,5,1) = -142.92
C      VS(1,1,7,1) =     31.389
C      VS(1,2,7,1) =    -10.463
C      VS(2,1,7,1) =    -10.463
C      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
CBAB THIS FACTOR WAS REMOVED ON JAN 23 1987 BECAUSE TWO ERRORS WERE
CBAB FOUND IN HOSAKAS PAPER, 1) SIGMA DOT L IN EQ (2) SHOULD BE
CBAB S DOT L, THERE SHOULD BE ANOTHER 1/X FACTOR IN EQ (3)
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
C      VS(1,2,2,2) = -30963.
C      VS(2,2,2,2) = 9109.8
C      VS(1,2,4,2) = 2343.4
C      VS(2,2,4,2) = -2301.8
CBAB      VS(1,2,2,2) = -30963./2.
CBAB      VS(2,2,2,2) = 9109.8/2.
CBAB      VS(1,2,4,2) = 2343.4/2.
CBAB      VS(2,2,4,2) = -2301.8/2.
CBAB TENSOR
      VS(1,2,2,3) = 3104.9
      VS(2,2,2,3) = -1382.0
      VS(1,2,7,3) = -10.463
      VS(2,2,7,3) = 3.488
      GO TO 947
 
2166   CONTINUE
CBAB HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =  15991.
      VS(1,2,1,1) =  19886.
      VS(2,1,1,1) =  13015.
      VS(2,2,1,1) =  26795.
      VS(1,1,3,1) = -1955.1
      VS(1,2,3,1) = -2400.9
      VS(2,1,3,1) = -882.09
      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = 396.51
      VS(1,2,5,1) = -1262.7
      VS(2,1,5,1) = -993.25
      VS(2,2,5,1) = -142.92
      VS(1,1,7,1) =     31.389
      VS(1,2,7,1) =    -10.463
      VS(2,1,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
CBAB THIS FACTOR WAS REMOVED ON JAN 23 1987 BECAUSE TWO ERRORS WERE
CBAB FOUND IN HOSAKAS PAPER, 1) SIGMA DOT L IN EQ (2) SHOULD BE
CBAB S DOT L, THERE SHOULD BE ANOTHER 1/X FACTOR IN EQ (3)
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
C      VS(1,2,2,2) = -30963.
C      VS(2,2,2,2) = 9109.8
C      VS(1,2,4,2) = 2343.4
C      VS(2,2,4,2) = -2301.8
CBAB      VS(1,2,2,2) = -30963./2.
CBAB      VS(2,2,2,2) = 9109.8/2.
CBAB      VS(1,2,4,2) = 2343.4/2.
CBAB      VS(2,2,4,2) = -2301.8/2.
CBAB TENSOR
C      VS(1,2,2,3) = 3104.9
C      VS(2,2,2,3) = -1382.0
C      VS(1,2,7,3) = -10.463
C      VS(2,2,7,3) = 3.488
      GO TO 947
 
3166   CONTINUE
CBAB HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =  15991.
      VS(1,2,1,1) =  19886.
      VS(2,1,1,1) =  13015.
      VS(2,2,1,1) =  26795.
      VS(1,1,3,1) = -1955.1
      VS(1,2,3,1) = -2400.9
      VS(2,1,3,1) = -882.09
      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = 396.51
      VS(1,2,5,1) = -1262.7
      VS(2,1,5,1) = -993.25
      VS(2,2,5,1) = -142.92
      VS(1,1,7,1) =     31.389
      VS(1,2,7,1) =    -10.463
      VS(2,1,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
CBAB THIS FACTOR WAS REMOVED ON JAN 23 1987 BECAUSE TWO ERRORS WERE
CBAB FOUND IN HOSAKAS PAPER, 1) SIGMA DOT L IN EQ (2) SHOULD BE
CBAB S DOT L, THERE SHOULD BE ANOTHER 1/X FACTOR IN EQ (3)
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
      VS(1,2,2,2) = -30963.
      VS(2,2,2,2) = 9109.8
      VS(1,2,4,2) = 2343.4
      VS(2,2,4,2) = -2301.8
CBAB      VS(1,2,2,2) = -30963./2.
CBAB      VS(2,2,2,2) = 9109.8/2.
CBAB      VS(1,2,4,2) = 2343.4/2.
CBAB      VS(2,2,4,2) = -2301.8/2.
CBAB TENSOR
C      VS(1,2,2,3) = 3104.9
C      VS(2,2,2,3) = -1382.0
      VS(1,2,7,3) = -10.463
      VS(2,2,7,3) = 3.488
      GO TO 947
 
190   CONTINUE
CBAB HOSAKA OBOP BONN POTENTIAL
CBAB Bonn ref: K. Holinde, R. Machleidt and C. Elster,
CBAB Phys. Reports 149 1 (1987)
      IVM = 4
      XMU(1) = 197./800.
      XMU(2) = 197./700.
      XMU(3) = 197./500.
      XMU(4) = 197./138.
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
      XT21 = 1.0
      VS(2,1,1,1) =  31477.*XT21
      VS(2,1,2,1) =  -18186.*XT21
      VS(2,1,3,1) =  -1846.5*XT21
      VS(2,1,4,1) =  -9.6554*XT21

      XT12 = 1.
      VS(1,2,1,1) =  70264.*XT12
      VS(1,2,2,1) =  -50787.*XT12
      VS(1,2,3,1) =  211.70*XT12
      VS(1,2,4,1) =  -9.6554*XT12

      VS(1,1,1,1) =  110430.
      VS(1,1,2,1) =  -87527.
      VS(1,1,3,1) =  7311.9
      VS(1,1,4,1) =  28.996

      XT22 = 1.
      VS(2,2,1,1) =  161900.*XT22
      VS(2,2,2,1) = -111180.*XT22
      VS(2,2,3,1) =  4828.9*XT22
      VS(2,2,4,1) =  3.2218*XT22

      VS(2,2,1,2) = 434580.
      VS(2,2,2,2) =-296950.
      VS(2,2,3,2) = 12587.
      VS(1,2,1,2) = -2209800.
      VS(1,2,2,2) =  1277900.
      VS(1,2,3,2) = -43790.
      XT3 = 1.
      FACHBB = 2*SQRT(2.)
      VS(2,2,1,3) = -4983.4*XT3
      VS(2,2,2,3) = 2099.4*XT3
      VS(2,2,4,3) = 3.2218*XT3
      VS(1,2,1,3) = -7884.2*XT3/FACHBB
      VS(1,2,2,3) = 9863.5*XT3/FACHBB
      VS(1,2,4,3) = -27.338*XT3/FACHBB
      GO TO 947
C
201   CONTINUE
CEKW WBP --- WARBURTON-BROWN PSD POTENTIAL
CEKW XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      IVM = 7
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .20
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
CEKW567890123456789212345678931234567894123456789512345678961234567897123
      XC01  =        0.16215                                     ! # 2
      XC10  =        0.88048                                     ! # 4
      XT10  =       -3.44550                                     ! # 7
      XTO10 =       -0.61052                                     ! # 8
      XT11  =        1.48320                                     ! # 9
      XL11  =        1.03770                                     ! #10
      VS(1,1,1,1) = -1.85970                                     ! # 1
      VS(2,1,1,1) = -1.28100                                     ! # 3
      VS(1,2,1,1) = -0.03162                                     ! # 5
      VS(2,2,1,1) =  1.45850                                     ! # 6
      VS(1,1,6,1) =  15991.000                                   ! H7B
      VS(1,2,6,1) =  19886.000*XC10
      VS(2,1,6,1) =  13015.000*XC01
      VS(2,2,6,1) =  26795.000                                   ! H7B
      VS(1,1,3,1) =  -1955.100                                   ! H7B
      VS(1,2,3,1) =  -2400.900*XC10
      VS(2,1,3,1) =   -882.090*XC01
      VS(2,2,3,1) =  -2801.400                                   ! H7B
      VS(1,1,5,1) =    396.510                                   ! H7B
      VS(1,2,5,1) =  -1262.700*XC10
      VS(2,1,5,1) =   -993.250*XC01
      VS(2,2,5,1) =   -142.920                                   ! H7B
      VS(1,1,7,1) =     31.389                                   ! H7B
      VS(1,2,7,1) =    -10.463                                   ! H7B
      VS(2,1,7,1) =    -10.463                                   ! H7B
      VS(2,2,7,1) =      3.488                                   ! H7B
CBAB SPIN ORBIT
      VS(1,2,2,2) = -30963.000                                   ! H7B
      VS(2,2,2,2) =   9109.800*XL11
      VS(1,2,4,2) =   2343.400                                   ! H7B
      VS(2,2,4,2) =  -2301.800*XL11
CBAB TENSOR
      VS(1,2,2,3) =   3104.900*XT10
      VS(2,2,2,3) =  -1382.000*XT11
      VS(1,2,7,3) =    -10.463*XTO10
      VS(2,2,7,3) =      3.488                                   ! H7B
      GO TO 947
 
185   CONTINUE
CBAB MODIFIED HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
CBAB BASED ON AUG 1988 FITS TO N=50 AND N=82
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
      VS(1,1,1,1) =  15991.
      VS(1,2,1,1) =  19886.
      VS(2,1,1,1) =  13015.
      VS(2,2,1,1) =  26795.
      VS(1,1,3,1) = -1955.1
      VS(1,2,3,1) = -2400.9
      VS(2,1,3,1) = -882.09
      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = 396.51
      VS(1,2,5,1) = -1262.7
      VS(2,1,5,1) = -993.25*1.1
      VS(2,2,5,1) = -142.92*6.
      VS(1,1,7,1) =     31.389
      VS(1,2,7,1) =    -10.463
      VS(2,1,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
CBAB THIS FACTOR WAS REMOVED ON JAN 23 1987 BECAUSE TWO ERRORS WERE
CBAB FOUND IN HOSAKAS PAPER, 1) SIGMA DOT L IN EQ (2) SHOULD BE
CBAB S DOT L, THERE SHOULD BE ANOTHER 1/X FACTOR IN EQ (3)
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
      VS(1,2,2,2) = -30963.
      VS(2,2,2,2) = 9109.8
      VS(1,2,4,2) = 2343.4
      VS(2,2,4,2) = -2301.8
CBAB      VS(1,2,2,2) = -30963./2.
CBAB      VS(2,2,2,2) = 9109.8/2.
CBAB      VS(1,2,4,2) = 2343.4/2.
CBAB      VS(2,2,4,2) = -2301.8/2.
CBAB TENSOR
      VS(1,2,2,3) = 3104.9
      VS(2,2,2,3) = -1382.0*3.8
      VS(1,2,7,3) = -10.463
      VS(2,2,7,3) = 3.488
      GO TO 947
 
167   CONTINUE
CBAB HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =  15991.
      VS(1,2,1,1) =  19886.
      VS(2,1,1,1) =  13015.
      VS(2,2,1,1) =  26795.
      VS(1,1,3,1) = -1955.1
      VS(1,2,3,1) = -2400.9
      VS(2,1,3,1) = -882.09
      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = 396.51
      VS(1,2,5,1) = -1262.7
      VS(2,1,5,1) = -993.25
      VS(2,2,5,1) = -142.92
      VS(1,1,7,1) =     31.389
      VS(1,2,7,1) =    -10.463
      VS(2,1,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
      VS(1,2,2,2) = -30963./2.
      VS(2,2,2,2) = 9109.8/2.
      VS(1,2,4,2) = 2343.4/2.
      VS(2,2,4,2) = -2301.8/2.
CBAB BARE TENSOR FROM NAKAYAMA
CBAB      VS(1,2,2,3) = 0.
CBAB      VS(2,2,2,3) = 0.
CBAB      VS(1,2,4,3) = -509.91
CBAB      VS(2,2,4,3) = -169.97
CBAB      VS(1,2,5,3) = -11.384
CBAB      VS(2,2,5,3) = 3.7828
CBAB EFFECTIVE TENSOR FROM NAKAYAMA
      VS(1,2,2,3) = 21564.96
      VS(2,2,2,3) = -7188.32
      VS(1,2,4,3) = -3082.74
      VS(2,2,4,3) = 1027.58
      VS(1,2,7,3) = -1.9635
      VS(2,2,7,3) = 0.6545
      GO TO 947
 
169   CONTINUE
CBAB GOGNY CENTRAL INTERACTION - PRC31, 1568 (1980)
      IDD = 1
      ALD = 0.333333
      IVM = 3
CBAB 0.01 IS A DELTA FUNCTION
      XMU(1) = 0.01
      XMU(2) = 0.7
      XMU(3) = 1.2
      AMU(1) = 'GAU'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,2,21,1) =  2700.*(0.17**0.33333)
      VS(1,1,2,1) = -775.04
      VS(1,2,2,1) = -1022.16
      VS(2,1,2,1) = 170.24
      VS(2,2,2,1) = 17.36
      VS(1,1,3,1) = 96.55
      VS(1,2,3,1) = -64.61
      VS(2,1,3,1) = -115.61
      VS(2,2,3,1) = -1.53
      GO TO 947
 
180   CONTINUE
CBAB SCHIFFER-TRUE INTERACTION FROM TABLE XVII OF REV MOD PHYS 48, 191
CBAB R2 = 2.
      IVM = 2
      XMU(1) = 1.415
      XMU(2) = 2.0
      AMU(1) = 'YU0'
      AMU(3) = 'YU0'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL, S.O., T.E., S.E., T.O.
      VS(1,1,1,1) =  125.53
      VS(1,1,2,1) = -44.37
      VS(1,2,1,1) =  -118.09
      VS(1,2,2,1) = 27.27
      VS(2,1,1,1) =  -49.32
      VS(2,1,2,1) = 15.47
      VS(2,2,1,1) =  -155.82
      VS(2,2,2,1) = 62.06
CBAB SPIN ORBIT, E., 0.
CBAB      VS(1,2,1,2) = -0.43
CBAB      VS(2,2,1,2) = 3.42
CBAB TENSOR, E., 0.
      VS(1,2,1,3) = -42.52
      VS(2,2,1,3) = -6.10
      GO TO 947
 
184   CONTINUE
CBAB SCHIFFER-TRUE INTERACTION FROM TABLES XVI AND XVII OF
CBAB REV MOD PHYS 48, 191
CBAB R2 = 0.1
      IVM = 2
      XMU(1) = 1.415
      XMU(2) = 0.1
      AMU(1) = 'YU0'
      AMU(3) = 'YU0'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL, S.O., T.E., S.E., T.O.
      VS(1,1,1,1) =  -17.74
      VS(1,1,2,1) = 1661151.
      VS(1,2,1,1) =  -37.81
      VS(1,2,2,1) = -26503.
      VS(2,1,1,1) =  3.65
      VS(2,1,2,1) = -30514.
      VS(2,2,1,1) =  49.91
      VS(2,2,2,1) = -2328444.
CBAB SPIN ORBIT, E., 0.
CBAB      VS(1,2,1,2) = -0.43
CBAB      VS(2,2,1,2) = 3.42
CBAB TENSOR, E., 0.
      VS(1,2,1,3) = -42.52
      VS(2,2,1,3) = -6.10
      GO TO 947
 
181   CONTINUE
CBAB OPEP
      IVM = 1
      XMU(1) = 1.414
      AMU(1) = 'YU0'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) =     31.389
      VS(1,2,1,1) =    -10.463
      VS(2,1,1,1) =    -10.463
      VS(2,2,1,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,1,3) = -10.463
      VS(2,2,1,3) = 3.488
      GO TO 947
 
6182  CONTINUE
CBAB BROWN-RICHTER 17 PARAMETER (3 SPE) SD SHELL INTERACION
      IDD = 1
      IVM = 7
CEKW  XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = 0.74540
      VS(2,1,1,1) = 0.24306
      VS(1,2,1,1) = -0.96693
      VS(2,2,1,1) = 0.7011
      VS(1,1,5,1) = -.025916*(396.51)
      VS(2,1,5,1) = 0.56666*(-993.25)
      VS(1,2,5,1) = 0.44375*(-1262.7)
      VS(2,2,5,1) = 10.475*(-142.92)
c      VS(1,1,5,1) = -10.
c      VS(2,1,5,1) = -562.8
c      VS(1,2,5,1) = -560.3
c      VS(2,2,5,1) = -1497.1
      VS(1,1,7,1) =     31.389
      VS(2,1,7,1) =    -10.463
      VS(1,2,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
      VS(1,1,25,1) = -VS(1,1,5,1)
      VS(2,1,25,1) = -VS(2,1,5,1)
      VS(1,2,25,1) = -VS(1,2,5,1)
      VS(2,2,25,1) = -VS(2,2,5,1)
CBAB SPIN ORBIT
      VS(1,2,2,2) = -30963.*(1.2096)
      VS(2,2,2,2) = 9109.8*(-6.6471)
      VS(1,2,22,2) = -VS(1,2,2,2)
      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB TENSOR
      VS(1,2,2,3) = 3104.9*(-5.9306)
      VS(1,2,7,3) = -10.463*(-1.0098)
      VS(2,2,2,3) = -1382.0*(-4.9062)
      VS(2,2,7,3) = 3.488*(-2.6607)
      VS(1,2,22,3) = -VS(1,2,2,3)
      VS(2,2,22,3) = -VS(2,2,2,3)
      VS(1,2,27,3) = -VS(1,2,7,3)
      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947

182   CONTINUE
CBAB BROWN-RICHTER 17 PARAMETER (3 SPE) SD SHELL INTERACION
      IDD = 1
      IVM = 7
CEKW  XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = 0.74540
      VS(2,1,1,1) = 0.24306
      VS(1,2,1,1) = -1.9624
      VS(2,2,1,1) = 0.65624
      VS(1,1,5,1) = 396.51*(-4.4419)
      VS(2,1,5,1) = -993.25*(0.49700)
      VS(1,2,5,1) = -1262.7*(0.36660)
      VS(2,2,5,1) = -142.92*(3.1785)
      VS(1,1,7,1) =     31.389
      VS(2,1,7,1) =    -10.463
      VS(1,2,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
      VS(1,1,25,1) = -VS(1,1,5,1)
      VS(2,1,25,1) = -VS(2,1,5,1)
      VS(1,2,25,1) = -VS(1,2,5,1)
      VS(2,2,25,1) = -VS(2,2,5,1)
CBAB SPIN ORBIT
      VS(1,2,2,2) = -30963.*(1.2096)
      VS(2,2,2,2) = 9109.8*(-6.6471)
      VS(1,2,22,2) = -VS(1,2,2,2)
      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB TENSOR
      VS(1,2,2,3) = 3104.9*(-5.9306)
      VS(1,2,7,3) = -10.463*(-1.0098)
      VS(2,2,2,3) = -1382.0*(-4.9062)
      VS(2,2,7,3) = 3.488*(-2.6607)
      VS(1,2,22,3) = -VS(1,2,2,3)
      VS(2,2,22,3) = -VS(2,2,2,3)
      VS(1,2,27,3) = -VS(1,2,7,3)
      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947

4182  CONTINUE
CBAB BROWN-RICHTER SD-PF SHELL INTERACION
C166   CONTINUE
CCBAB HOSAKA-KUBO-TOKI OBOP PARIS POTENTIAL
      IDD = 1
      IVM = 7
      XMU(1) = .20
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
c      VS(1,1,1,1) =  102.81*15991.
c      VS(1,2,1,1) =  2.002*19886.
c      VS(2,1,1,1) =  -.37826*13015.
c      VS(2,2,1,1) =  -14.842*26795.
C      VS(1,1,3,1) = -1955.1
C      VS(1,2,3,1) = -2400.9
C      VS(2,1,3,1) = -882.09
C      VS(2,2,3,1) = -2801.4
      VS(1,1,5,1) = -4.4102*(396.51)
      VS(1,2,5,1) = -0.012372*(-1262.7)
      VS(2,1,5,1) = 0.2515*(-993.25)
      VS(2,2,5,1) = 6.4654*(-142.92)
      VS(1,1,7,1) =     1.5509*31.389
      VS(1,2,7,1) =    4.7918*(-10.463)
      VS(2,1,7,1) =    0.94571*(-10.463)
      VS(2,2,7,1) =      12.879*3.488
C      VS(1,1,25,1) = -VS(1,1,5,1)
C      VS(2,1,25,1) = -VS(2,1,5,1)
C      VS(1,2,25,1) = -VS(1,2,5,1)
C      VS(2,2,25,1) = -VS(2,2,5,1)
CBAB SPIN ORBIT
CBAB THIS FACTOR WAS REMOVED ON JAN 23 1987 BECAUSE TWO ERRORS WERE
CBAB FOUND IN HOSAKAS PAPER, 1) SIGMA DOT L IN EQ (2) SHOULD BE
CBAB S DOT L, THERE SHOULD BE ANOTHER 1/X FACTOR IN EQ (3)
CBAB DIVIDED BY 2 SINCE EQ.2 OF HOSAKA USES "SIGMA" RATHER THAN "S"
      VS(1,2,2,2) = 1.2096*(-30963.)
      VS(2,2,2,2) = -6.6471*(9109.8)
C      VS(1,2,4,2) = 2343.4
C      VS(2,2,4,2) = -2301.8
      VS(1,2,22,2) = -VS(1,2,2,2)
      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB      VS(1,2,2,2) = -30963./2.
CBAB      VS(2,2,2,2) = 9109.8/2.
CBAB      VS(1,2,4,2) = 2343.4/2.
CBAB      VS(2,2,4,2) = -2301.8/2.
CBAB TENSOR
      VS(1,2,2,3) = -5.9306*(3104.9)
      VS(2,2,2,3) = -4.9062*(-1382.0)
      VS(1,2,7,3) = -1.0098*(-10.463)
      VS(2,2,7,3) = -2.6607*(3.488)
      VS(1,2,22,3) = -VS(1,2,2,3)
      VS(2,2,22,3) = -VS(2,2,2,3)
      VS(1,2,27,3) = -VS(1,2,7,3)
      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947
 

1182  CONTINUE
CBAB BROWN-RICHTER 17 PARAMETER (3 SPE) SD SHELL INTERACION
      IDD = 1
      IVM = 7
CEKW  XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = 0.74540
      VS(2,1,1,1) = 0.24306
      VS(1,2,1,1) = -1.9624
      VS(2,2,1,1) = 0.65624
      VS(1,1,5,1) = 396.51*(-4.4419)
      VS(2,1,5,1) = -993.25*(0.49700)
      VS(1,2,5,1) = -1262.7*(0.36660)
      VS(2,2,5,1) = -142.92*(3.1785)
      VS(1,1,7,1) =     31.389
      VS(2,1,7,1) =    -10.463
      VS(1,2,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
      VS(1,1,25,1) = -VS(1,1,5,1)
      VS(2,1,25,1) = -VS(2,1,5,1)
      VS(1,2,25,1) = -VS(1,2,5,1)
      VS(2,2,25,1) = -VS(2,2,5,1)
CBAB SPIN ORBIT
      VS(1,2,2,2) = -30963.*(1.2096)
      VS(2,2,2,2) = 9109.8*(-6.6471)
      VS(1,2,22,2) = -VS(1,2,2,2)
      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB TENSOR
C      VS(1,2,2,3) = 3104.9*(-5.9306)
C      VS(1,2,7,3) = -10.463*(-1.0098)
C      VS(2,2,2,3) = -1382.0*(-4.9062)
C      VS(2,2,7,3) = 3.488*(-2.6607)
C      VS(1,2,22,3) = -VS(1,2,2,3)
C      VS(2,2,22,3) = -VS(2,2,2,3)
C      VS(1,2,27,3) = -VS(1,2,7,3)
C      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947
3182  CONTINUE
CBAB BROWN-RICHTER 17 PARAMETER (3 SPE) SD SHELL INTERACION
      IDD = 1
      IVM = 7
CEKW  XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = 0.74540
      VS(2,1,1,1) = 0.24306
      VS(1,2,1,1) = -1.9624
      VS(2,2,1,1) = 0.65624
      VS(1,1,5,1) = 396.51*(-4.4419)
      VS(2,1,5,1) = -993.25*(0.49700)
      VS(1,2,5,1) = -1262.7*(0.36660)
      VS(2,2,5,1) = -142.92*(3.1785)
      VS(1,1,7,1) =     31.389
      VS(2,1,7,1) =    -10.463
      VS(1,2,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
      VS(1,1,25,1) = -VS(1,1,5,1)
      VS(2,1,25,1) = -VS(2,1,5,1)
      VS(1,2,25,1) = -VS(1,2,5,1)
      VS(2,2,25,1) = -VS(2,2,5,1)
CBAB SPIN ORBIT
      VS(1,2,2,2) = -30963.*(1.2096)
      VS(2,2,2,2) = 9109.8*(-6.6471)
      VS(1,2,22,2) = -VS(1,2,2,2)
      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB TENSOR
C      VS(1,2,2,3) = 3104.9*(-5.9306)
      VS(1,2,7,3) = -10.463*(-1.0098)
C      VS(2,2,2,3) = -1382.0*(-4.9062)
      VS(2,2,7,3) = 3.488*(-2.6607)
C      VS(1,2,22,3) = -VS(1,2,2,3)
C      VS(2,2,22,3) = -VS(2,2,2,3)
      VS(1,2,27,3) = -VS(1,2,7,3)
      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947
2182   CONTINUE
CBAB BROWN-RICHTER 17 PARAMETER (3 SPE) SD SHELL INTERACION
      IDD = 1
      IVM = 7
CEKW  XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = 0.74540
      VS(2,1,1,1) = 0.24306
      VS(1,2,1,1) = -1.9624
      VS(2,2,1,1) = 0.65624
      VS(1,1,5,1) = 396.51*(-4.4419)
      VS(2,1,5,1) = -993.25*(0.49700)
      VS(1,2,5,1) = -1262.7*(0.36660)
      VS(2,2,5,1) = -142.92*(3.1785)
      VS(1,1,7,1) =     31.389
      VS(2,1,7,1) =    -10.463
      VS(1,2,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
      VS(1,1,25,1) = -VS(1,1,5,1)
      VS(2,1,25,1) = -VS(2,1,5,1)
      VS(1,2,25,1) = -VS(1,2,5,1)
      VS(2,2,25,1) = -VS(2,2,5,1)
CBAB SPIN ORBIT
C      VS(1,2,2,2) = -30963.*(1.2096)
C      VS(2,2,2,2) = 9109.8*(-6.6471)
C      VS(1,2,22,2) = -VS(1,2,2,2)
C      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB TENSOR
C      VS(1,2,2,3) = 3104.9*(-5.9306)
C      VS(1,2,7,3) = -10.463*(-1.0098)
C      VS(2,2,2,3) = -1382.0*(-4.9062)
C      VS(2,2,7,3) = 3.488*(-2.6607)
C      VS(1,2,22,3) = -VS(1,2,2,3)
C      VS(2,2,22,3) = -VS(2,2,2,3)
C      VS(1,2,27,3) = -VS(1,2,7,3)
C      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947
 
183   CONTINUE
CBAB BROWN-RICHTER 20 PARAMETER (6 SPE) SD SHELL INTERACION
      IDD = 1
      IVM = 7
CEKW  XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = 0.69927
      VS(2,1,1,1) = 0.14143
      VS(1,2,1,1) = -1.8741
      VS(2,2,1,1) = 0.71205
      VS(1,1,5,1) = 396.51*(-7.0829)
      VS(2,1,5,1) = -993.25*(0.48886)
      VS(1,2,5,1) = -1262.7*(0.36515)
      VS(2,2,5,1) = -142.92*(3.4056)
      VS(1,1,25,1) = -VS(1,1,5,1)
      VS(2,1,25,1) = -VS(2,1,5,1)
      VS(1,2,25,1) = -VS(1,2,5,1)
      VS(2,2,25,1) = -VS(2,2,5,1)
      VS(1,1,7,1) =     31.389
      VS(2,1,7,1) =    -10.463
      VS(1,2,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,2,2) = -30963.*(8.1080)
      VS(2,2,2,2) = 9109.8*(-6.5637)
      VS(1,2,22,2) = -VS(1,2,2,2)
      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB TENSOR
      VS(1,2,2,3) = 3104.9*(-8.4282)
      VS(1,2,7,3) = -10.463*(-1.5531)
      VS(2,2,2,3) = -1382.0*(-0.14269)
      VS(2,2,7,3) = 3.488*(-1.0903)
      VS(1,2,22,3) = -VS(1,2,2,3)
      VS(2,2,22,3) = -VS(2,2,2,3)
      VS(1,2,27,3) = -VS(1,2,7,3)
      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947
 
186   CONTINUE
CBAB BROWN-RICHTER 20 PARAMETER (6 SPE) FP SHELL (R=1) INTERACION
      IDD = 1
      IVM = 7
CEKW  XMU(I) = 999. IS A TOGGLE TO USE THE MONOPOLE FORM
      XMU(1) = 999.
      XMU(2) = .25
      XMU(3) = .33
      XMU(4) = .40
      XMU(5) = .50
      XMU(6) = .70
      XMU(7) = 1.414
      AMU(1) = 'YU0'
      AMU(2) = 'YU1'
      AMU(3) = 'YU2'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = 0.74539
      VS(2,1,1,1) = -0.41566
      VS(1,2,1,1) = -1.8798
      VS(2,2,1,1) = 0.43585
      VS(1,1,5,1) = 396.51*(-13.199)
      VS(2,1,5,1) = -993.25*(0.88652)
      VS(1,2,5,1) = -1262.7*(0.28601)
      VS(2,2,5,1) = -142.92*(7.8696)
      VS(1,1,25,1) = -VS(1,1,5,1)
      VS(2,1,25,1) = -VS(2,1,5,1)
      VS(1,2,25,1) = -VS(1,2,5,1)
      VS(2,2,25,1) = -VS(2,2,5,1)
      VS(1,1,7,1) =     31.389
      VS(2,1,7,1) =    -10.463
      VS(1,2,7,1) =    -10.463
      VS(2,2,7,1) =      3.488
CBAB SPIN ORBIT
      VS(1,2,2,2) = -30963.*(1.2096)
      VS(2,2,2,2) = 9109.8*(-6.6471)
      VS(1,2,22,2) = -VS(1,2,2,2)
      VS(2,2,22,2) = -VS(2,2,2,2)
CBAB TENSOR
      VS(1,2,2,3) = 3104.9*(-5.9306)
      VS(1,2,7,3) = -10.463*(-1.0098)
      VS(2,2,2,3) = -1382.0*(-4.9062)
      VS(2,2,7,3) = 3.488*(-2.6607)
      VS(1,2,22,3) = -VS(1,2,2,3)
      VS(2,2,22,3) = -VS(2,2,2,3)
      VS(1,2,27,3) = -VS(1,2,7,3)
      VS(2,2,27,3) = -VS(2,2,7,3)
      GO TO 947
 
188   CONTINUE
      IVM = 1
      XMU(1) = .01
      AMU(1) = 'YU0'
CBAB (T+1,S+1,RANGE,TYPE)
CBAB CENTRAL
      VS(1,1,1,1) = -560.
      VS(2,1,1,1) = -320.
      VS(1,2,1,1) = -560.
      VS(2,2,1,1) = -320.
      GO TO 947
 
947   CONTINUE
 
      ICAV = 0
      ILAV = 0
      ITAV = 0
      DO 8001 I1 = 1,2
      DO 8001 I2 = 1,2
      DO 8001 I3 = 1,30
      IF(VS(I1,I2,I3,1).NE.0.) ICAV = 1
      IF(VS(I1,I2,I3,2).NE.0.) ILAV = 1
      IF(VS(I1,I2,I3,3).NE.0.) ITAV = 1
8001  CONTINUE
      RETURN
      END
