      SUBROUTINE LANC
C
C     SUBROUTINE FOR DIAGONALIZATION BY LANCZOS ALGORITHM
C
C
CWEO ******************************************************************

CWEO         THIS STATEMENT GIVES US REAL*16 VARIABLES ON THE VAX/780
CWEO         AND IS FOLLOWED BY A CALL LIB$ESTABLISH(LIB$EMULATE)

CBAB      INCLUDE 'SHGRLIB:LANC.INC' 

CWEO ******************************************************************

      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
C      REAL*16 EVEC
      REAL*8 EVEC
      CHARACTER*9 FILE_NAME,EIGFIL
      CHARACTER*4 FILE_EXT
      COMMON/FIL/EIGFIL
      COMMON /VECTORS/VMP1(MAX_DIM),VMP2(MAX_DIM),VMPFILL(MAX_DIM) 
      COMMON /EIGENC/F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,XT(4*MAX_VEC),EVEC(MAX_VEC+2)
      COMMON/CIN/ORTFIL,ORT2,BIGF,BIGG 
      COMMON/IN/MAXB,IRSIZE,TOL1,TOL2,NKEEP,NOUT 
CWNC THESE NEXT TWO LINES CHANGED FROM (20) TO (201) TO AVOID OVERWRITING
      COMMON/OUT/EIGVAL(MAX_VEC+2) 
      COMMON/OUTO/EIGVALO(MAX_VEC+2) 
CBAB      COMMON/ITE /NPRE,ITMAX,IWC 
      COMMON/ITE /NPRE,IWC 
      COMMON/TIME/JEIGEN_TIME,JLANC_TIME,HANDLE
      COMMON/HEAD/IVERS,ICASE,NTTL,IREST,JAY,J2, 
     1 IT2,IMZS,KPAR 
      CHARACTER*13 ORTF,BIGF,BIGG 
      CHARACTER*9 ORTFIL 
      CHARACTER*4 DUD4,ORT2 
      DIMENSION EI(MAX_VEC) 
      DIMENSION LOCN(40) 
      EQUIVALENCE (XT(2*MAX_VEC+1),EI(1)) 
      DIMENSION AMP1(MAX_DIM),AMP2(MAX_DIM) 
      EQUIVALENCE (AMP1(1),VMP1(1)),(AMP2(1),VMP2(1)) 
      INCLUDE 'SHGR:DATA.INC'

CWEO ***  SUBROUTINE TO ENABLE REAL*16 VARIABLES TO BE USED ****
       
CBAB                     CALL LIB_EMULATE

C         FPS VERSION JUST RETURNS
CWEO ***********************************************************

      CALL OPEN_FILE(13,EIGFIL,'.LTG','NEW','UFRM')
      CALL OPEN_FILE(24,EIGFIL,'.LTF','NEW','UFRM')
C      CALL OPEN_FILE(25,EIGFIL,'.EEE','NEW','FORM')

CBAB JULY 2, 1984 ADDED SO THAT WE KNOW IMMEDIATELY HOW MUCH DISK
CBAB SPACE IS NEEDED FOR FILES 13 AND 22 AND 24 BY WRITING OUT TO
CBAB MAXIMUM SIZE
      DO 8002 IBAB = 1,MAXB
8002  VMPFILL(IBAB) = 0.11111111
CBAB      DO 8000 IBAB = 2,ITMAX
CBAB THE VALUE 50 BELOW REPRESENTS THE TYPICAL NUMBER OF ITERATIONS
CBAB BEYOND NKEEP TO ACHEIVE 0.5 KEV CONVERGENCE
      DO 8000 IBAB = 2,NKEEP+50
8000  CALL WRITOUT(13,VMPFILL,MAXB)
CBAB      DO 8003 IBAB = 2,ITMAX
      DO 8003 IBAB = 2,NKEEP+50
8003  BACKSPACE 13
CBAB      DO 8001 IBAB = 1,NOUT
      DO 8001 IBAB = 1,NKEEP
8001  WRITE(24) DUMMY,(VMPFILL(J),J=1,MAXB)
      REWIND 24
CBAB      DO 8005 IBAB = 1,NOUT
      DO 8005 IBAB = 1,NKEEP
8005  WRITE(22) DUMMY,(VMPFILL(J),J=1,MAXB)
      REWIND 22
CBAB      WRITE(6,8006)
CBAB8006  FORMAT(1X,'ALL BIG FILES HAVE NOW BEEN OPENED')
CBAB JULY 2, 1984

CBAB      MAXBA = MAX_DIM 
      ITEST=0 
      DO 765 I=1,MAXB 
765   VMP1(I) =1.0 
C-----------------------------------------------------------------------
CW
CW  REOPEN .MAT 
CW  ENERGY MATRIX IS READ IN BY SUBROUTINE
CW  HMULT. CORE REQUIRED CORRESPONDS TO LENGTH
CW  OF ONE ROW (MAXB). 
CW
      IX = 1 
      IF(NPRE.EQ.0) GOTO 85 
C
C--- PERFORM PRE-ITERATIONS
      DO 80 I=1,NPRE 
      IX = MOD(IX,2) + 1 
      GOTO (78,79) IX 
78    CALL HMULT(VMP1,VMP2,MAXB) 
CBAB ADDED DEC 18, 1983
      IF(MAXB.EQ.1) RETURN
      GOTO 80 
79    CALL HMULT(VMP2,VMP1,MAXB) 
CBAB ADDED DEC 18, 1983
      IF(MAXB.EQ.1) RETURN
80    CONTINUE 
C
C
85    CONTINUE 
      GOTO(86,87) IX 
86    CALL NORM(RNORM,MAXB,VMP1,VMP1,2) 
      CALL WRITOUT(13,VMP1,MAXB) 
      GOTO 110 
87    CALL NORM(RNORM,MAXB,VMP2,VMP2,2) 
      CALL WRITOUT(13,VMP2,MAXB) 
110   CONTINUE 
C
C
C-----     --- CALL LANCZOS ROUTINE ---


      NST =0 
CWEO      IF(.NOT.LIB$STAT_TIMER(2,ICPULANC,HANDLE))GOTO 7550
CBAB115   CALL LANCZOS(VMP1,VMP2,MAXB,NST,ITMAX,IX,ITEST,NKEEP) 
115   CALL LANCZOS(VMP1,VMP2,MAXB,NST,IX,ITEST,NKEEP,NOUT) 
CWEO      IF(.NOT.LIB$STAT_TIMER(2,ICPULANC2,HANDLE))GOTO 7550
CZ      JLANC_TIME=ICPULANC2-ICPULANC
      JLANC_TIME=ICPULAN2-ICPULANC
CBAB      CLOSE(UNIT=10)
      CLOSE(UNIT=10,STATUS='DELETE')
      RETURN 
CWEO7550  STOP 'LIB$STAT_TIMER ERROR'
      END 




C         LANCZOS SUBROUTINE 
C-----------------------------------------------------------------------
C
      SUBROUTINE LANCZOS(VMP1,VMP2,MAXB, 
     1NST,IX,ITEST,NKEEP,NOUT)
CBAB     1NST,ITMAX,IX,ITEST,NKEEP)
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
C      REAL*16 EVEC
      REAL*8 EVEC
      CHARACTER*13 ORTF,BIGF 
      COMMON /EIGENC/F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,XT(4*MAX_VEC),EVEC(MAX_VEC+2)
      COMMON /OUT/EIGVAL(MAX_VEC+2) 
      COMMON /OUTO/EIGVALO(MAX_VEC+2) 
CWEO      COMMON /CIN/ORTF,BIGF 
      COMMON/CRAN/IRAN,IRANERR
      COMMON/CRIT/CRIT,MAX_NST,ITMIN,MAXITER
      COMMON/TIME/JEIGEN_TIME,JLANC_TIME,HANDLE
      DIMENSION VMP1(MAXB),VMP2(MAXB) 
      INCLUDE 'SHGR:DATA.INC'               
CBAB      CHECK=1.
CBAB      NUMIN=0
      JEIGEN_TIME=0
C
C
C--- START OF ITERATION LOOP
115   LTEST = 0 
      IX = MOD(IX,2) + 1 
120   CONTINUE 
32    CONTINUE 
      GOTO (121,122) IX 
121   CALL HMULT(VMP1,VMP2,MAXB) 
      GOTO 123 
122   CALL HMULT(VMP2,VMP1,MAXB) 
123   IF(NST.LT.1) GOTO 125 
      BACKSPACE 13 
      BACKSPACE 13 
C-----  ORTHOGONALISE AND OBTAIN MATRIX ELEMENTS
125   CONTINUE 
      GOTO (126,127) IX 
126   CALL NORM(SCLRP,MAXB,VMP1,VMP2,1) 
      GOTO 128 
127   CALL NORM(SCLRP,MAXB,VMP2,VMP1,1) 
128   F(NST+1) = SCLRP 
      IF(NST.LT.1) GOTO 165 
      GOTO(131,132) IX 
131   READ(13) VMP2 
      CALL NORM(SCLRP,MAXB,VMP1,VMP2,1) 
      GOTO 133 
132   READ(13) VMP1 
      CALL NORM(SCLRP,MAXB,VMP2,VMP1,1) 
133   G(NST) = SCLRP 
C-----  RE-ORTHOGONALISE AND NORMALISE
145   REWIND 13 
      NSTP = NST + 1 
      DO 160 I=1,NSTP 
      GOTO(158,159) IX 
158   READ(13) VMP2 
      CALL NORM(SCLRP,MAXB,VMP1,VMP2,1) 
      GOTO 160 
159   READ(13) VMP1 
      CALL NORM(SCLRP,MAXB,VMP2,VMP1,1) 
160   CONTINUE 
165   CONTINUE 
c      GOTO(156,157) IX 
c156   CALL NORM(RNORM,MAXB,VMP1,VMP1,2) 
c      GOTO 166 
c157   CALL NORM(RNORM,MAXB,VMP2,VMP2,2) 
CWEO  it seems that I have messed up the original lines here!
CWEO ---------------------------------------------------------
C        Added to prevent premature termination of Lanczos
C        procedure. It is done by starting from a new 
C        random vector that has been orthogonalized 
C        with all the vectors found so far. This procedure
C        should find the eigenvalues and eigenvectors exactly
C        even for degenerate eigenvalues and block-diagonal matrices.
C        Note the added subroutine newvec
CWEO ----------------------------------------------------------
      GOTO(156,157) IX 
156   CALL NORM(RNORM,MAXB,VMP1,VMP1,2) 
      IF(RNORM.GT.1.0E-6) GO TO 170 
      IF(NST.GE.(MAXB-1)) GO TO 190 
      call newvec(vmp1,maxb)
      GOTO 145
157   CALL NORM(RNORM,MAXB,VMP2,VMP2,2) 
      IF(RNORM.GT.1.0E-6) GO TO 170 
      IF(NST.GE.(MAXB-1)) GO TO 190 
      call newvec(vmp2,maxb)
      GOTO 145
C
C-----  PREMATURE TERMINATION RECOVERY
c166   CONTINUE 
c      IF(RNORM.GT.1.0E-6) GO TO 170 
c      IF(NST.GE.(MAXB-1)) GO TO 190 
c      LTEST=LTEST+1 
c      IF(LTEST.GT.2.AND.IFIRST_IRAN.EQ.999)WRITE(6,5001) 
c5001  FORMAT(1X,'***** FATAL ERROR in LANC: LTEST.GT.2 *****'
c     1/,1X,'SOLUTION: PUT RANDOM NUMBERS IN THE MATRIX. IN THIS CASE',
c     1/,1X,'PUT IRAN=N(keV/10), IN THE FIRST LINE',
c     1/,1X,'WE HAVE AUTOMATICALLY TRIED N=1, TRY A LARGER VALUE')
c      IF(LTEST.GT.2.AND.IFIRST_IRAN.EQ.999)STOP 
c      IF(LTEST.GT.2.AND.IFIRST_IRAN.NE.999)WRITE(6,5000) 
c5000  FORMAT(1X,'***** FATAL ERROR in LANC: LTEST.GT.2 *****'
c     1/,1X,'SOLUTION: PUT RANDOM NUMBERS IN THE MATRIX. IN THIS CASE',
c     1/,1X,'PUT IRAN=N(keV/10), IN THE FIRST LINE',
c     1/,1X,'TYPICALLY N=1, AT THIS POINT WE WILL THIS IS DONE
c     1 AUTOMATICALLY')
c      IF(LTEST.GT.2) IFIRST_IRAN=999
c      IF(LTEST.GT.2) IFIRST_CALL=0
c      IF(LTEST.GT.2) RETURN
c      GO TO 145 
C-----  WRITE NEW VECTOR ON DISC
170   GOTO(171,172) IX 
171   WRITE(13) VMP1 
      GOTO 190 
172   WRITE(13) VMP2
190   NST=NST+1 
210   G(NST)=0.0 
CBAB      IF(NST.LT.NOUT) GO TO 115
      IF(NST.LT.NKEEP) GO TO 115
CBAB      IF(NST.LT.ITMAX)GOTO 115

CBAB WHEN NST GOES BEYOND THE VALUE OF ITMAX IT WILL START CHECKING
CBAB FOR CONVERGENCE
CBAB      ITMAX = NKEEP+10
      ITMAX = 5*NKEEP
CBAB START CHECKING WHEN WE ARE TWO FROM THE END OF MAX_VEC
      IF(ITMAX.GT.MAX_VEC-2) ITMAX=MAX_VEC-2
      IF(ITMAX.GT.MAXB) ITMAX=MAXB
      IF(NST.LT.ITMAX) GO TO 115
CBAB CONVERGENCE CHECK
CBAB      NUMIN=NUMIN+1
C-----  CALCULATE EIGENVALUES
      CALL EIGENH(NST) 
      DO 225 I=1,NST 
      J=NST+1-I 
CBAB      IF(NUMIN.GT.1) EIGVALO(I) = EIGVAL(I) 
      EIGVALO(I) = EIGVAL(I) 
      EIGVAL(I)=E(J) 
225   CONTINUE 
C      REWIND(UNIT=25)
C      WRITE(25,*) (EIGVAL(I),I=1,NST)
34    CONTINUE 

      IF(NST.EQ.MAXB) GO TO 220

CBAB      IF(NUMIN.GT.1)THEN 
      CHECK=0.

CBAB ADDED BY E ORMAND (JULY 1985) TO TRY TO GET VECTORS ABOVE NKEEP
CBAB PROPERLY CONVERGED
CBAB ERROR FOUND DEC 1987
CBAB      IF((NKEEP+10).LT.MATDIM)THEN

CBAB      IF((NKEEP+10).GE.MAXB)THEN
CBAB      NX=MAXB
CBAB      ELSE
CBAB      NX=NKEEP+10
CBAB      END IF

      NX = NKEEP

      DO 2255 KK=1,NX
      IF(ABS(EIGVALO(KK)-EIGVAL(KK)).GT.CHECK)CHECK
     1=ABS(EIGVALO(KK)-EIGVAL(KK))
2255  CONTINUE
CBAB      END IF

      WRITE(6,8000)NST,CHECK,EIGVAL(1),EIGVAL(2)
8000  FORMAT(1X,'ITERATION, MAX DEVIATION, E0,E1 = '
     1,I5,1X,3F9.4)
      IF(MAXITER.NE.0.AND.NST.GE.MAXITER) GO TO 1500
      IF(NST.EQ.(MAX_VEC-1)) GO TO 1500
      GO TO 1501

1500  CONTINUE
      WRITE(6,5505)
5505  FORMAT(1X,'***** WARNING #ITERATIONS EQ. (MAX_VEC-1) *****')
      IF(CHECK.LE.CRIT) WRITE(6,5506) NST,MAXB,NX
      IF(CHECK.GT.CRIT) WRITE(6,5507) NST,MAXB,NX
5506  FORMAT(1X,'CONVERGENCE TEST PASSED, NST,MAXB,NX = ',3I5)
5507  FORMAT(1X,'CONVERGENCE TEST FAILED, NST,MAXB,NX = ',3I5)
      GO TO 220

1501  CONTINUE
      IF(CHECK.LE.CRIT) GO TO 220 
      GO TO 115


CBAB      IF(NST.GT.ITMAX) GO TO 220
CBAB      IF(NST.LT.MAXB) GO TO 115
220   CONTINUE 
C-----------------------------------------------------------------------
C     CALCULATE REQUIRED EIGENVECTORS 
C-----------------------------------------------------------------------
CBAB JULY 2, 1984 MOVED UP TO AFTER OPE(UNIT=13)
CBABCBAB OPEN(UNIT=24,FILE='WOTDSK:'//BIGF,FORM='UNFORMATTED',
CBAB  OPEN(UNIT=24,FILE=AREA_RUN//BIGF,FORM='UNFORMATTED', 
CBAB 1 STATUS='NEW') 
CBAB      NKEEP = MIN0(NKEEP,MAXB) 
CBAB      NOUT = MIN0(NOUT,MAXB) 
      MAX_NST=NST
CBAB      IF(NOUT.LT.1) GOTO 260 
      IF(NKEEP.LT.1) GOTO 260 
2450  FORMAT(//' TRANSFORMATION (LANCZOS) MATRIX') 
CBAB      DO 2110 IJ=1,NOUT 
      DO 2110 IJ=1,NKEEP 
      REWIND 13 
      I=NST+1-IJ 
      DO 230 J=1,MAXB 
230   VMP1(J)=0.0 
      CALL EIGENV(I,NST) 
C-----  TRANSFORM WITH LANCZOS MATRIX
      DO 240 J=1,NST
      CALL READIN(13,VMP2,MAXB) 
      EV = EVEC(J) 
      DO 240 L=1,MAXB 
240   VMP1(L) = VMP1(L) + VMP2(L)*EV 
250   FORMAT(/100(12F10.3/)) 
CBAB ERROR FOUND NOV 1987 - IT WAS NEVER A PROBLEM BECAUSE THE
CBAB EIGENVALUES WERE TRANSFERED TO THE MAIN PROGRAM VIA THE
CBAB COMMON BLOCK /OUT/ RATHER THAN IN THIS FILE
CBAB      WRITE(24) EIGVAL(I),(VMP1(J),J=1,MAXB) 
      WRITE(24) EIGVAL(IJ),(VMP1(J),J=1,MAXB) 
      DO 255 L=1,MAXB 
255   VMP1(L)=VMP1(L)*VMP1(L) 
2110  CONTINUE 
260   CONTINUE 
CBAB      CLOSE(UNIT=24) 
      CLOSE(UNIT=13,STATUS='DELETE') 
CZ      CLOSE(UNIT=7) 
900   FORMAT(/1H )                  
1100  FORMAT(1H0,'TERMINATION TEST') 
1200  FORMAT(1H ,'PREMATURE TERMINATION - RECOVERY FAILED') 
1300  FORMAT(8(' ',I5,F11.6)) 
1600  FORMAT(/(1X,12F10.6)) 
        RETURN
      END 

      SUBROUTINE READIN(I,ARRAY,N) 
      DIMENSION ARRAY(N) 
      READ(I) ARRAY 
      RETURN 
      END 

      SUBROUTINE WRITOUT(I,ARRAY,N) 
      DIMENSION ARRAY(N) 
      WRITE(I) ARRAY 
      RETURN 
      END 


      SUBROUTINE HMULT(AMPN,AMPO,MAXB) 
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'
      COMMON/CDET/DET,IDEX               
      DIMENSION DET(MAX_DIM) 
      INTEGER*4 IDEX(MAX_DIM)
      DIMENSION AMPN(MAX_DIM),AMPO(MAX_DIM) 
      COMMON/CRAN/IRAN,IRANERR
      COMMON/HNORM/HNORM
      INCLUDE 'SHGR:DATA.INC'               
      IF(IFIRST_CALL.EQ.0)CALL MATWR
      IFIRST_CALL=1 
      REWIND 9
      REWIND 10 
      DO 5009 I=1,MAXB
5009  AMPN(I)=0.0
      DO 5004 L=1,MAXB 
      APP=0.0
      READ(9) K,(IDEX(I),I=1,K),(DET(I),I=1,K)
      READ(10) DET(K)
      IF(IRAN.EQ.1) CALL ADDRAN(K)
      IF(I.EQ.K) GO TO 5005 
      DO 5003 I=1,K-1
      APP=AMPO(IDEX(I))*HNORM*DET(I)+APP
      AMPN(IDEX(I))=AMPN(IDEX(I))+AMPO(L)*HNORM*DET(I)
5003  CONTINUE
5005  CONTINUE
      APP=AMPO(IDEX(K))*DET(K)+APP
      AMPN(IDEX(K))=AMPN(IDEX(K))+AMPO(L)*DET(K)
      AMPN(L)=APP
5004  CONTINUE
      RETURN 
      END 


      SUBROUTINE NORM(RNRM,MAXB,AMP1,AMP2,NORMT) 
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
      DIMENSION AMP1(MAX_DIM),AMP2(MAX_DIM) 
5002  FORMAT(' AMPN: ',10E12.3) 
      AM=0 
      DO 55 I=1,MAXB 
55    AM = AM + AMP1(I)*AMP2(I) 
70    CONTINUE 
      IF (NORMT .EQ. 1) GOTO 10 
      RNRM=SQRT(AM) 
CBAB  PUT IN FEB 6, 1984 WHEN I FOUND A CASE WHERE RNRM WAS ZERO 
      IF(RNRM.EQ.0) WRITE(6,500)
500   FORMAT(/,1X,'WARNING: RNRM SET EQUAL TO 10E-13 IN SUBROUTINE 
     1 NORM') 
      IF(RNRM.EQ.0) RNRM = 10E-13 
      AM=1.0/RNRM 
      DO 20 I=1,MAXB 
20    AMP1(I) = AMP1(I)*AM 
      RETURN 
10    CONTINUE 
      RNRM=AM 
      DO 30 I=1,MAXB 
30    AMP1(I) = AMP1(I) -AM*AMP2(I) 
      RETURN 
      END 




       SUBROUTINE EIGENH(NN) 
C  CALCULATE EIGENVALUES OF THE SYMMETRIC TRIDIAGONAL MATRIX IN F & G
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
C      REAL*16 Y
      REAL*8 Y
      COMMON/EIGENC/ F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,Q(MAX_VEC),R(MAX_VEC),IN(MAX_VEC),
     1DM(MAX_VEC),Y(MAX_VEC+2) 
      LOGICAL*4 IN 
      INCLUDE 'SHGR:DATA.INC'               
      IF(NN.GT.1) GO TO 5 
      E(1)=F(1) 
      GO TO 130 
5     RNORM=ABS(F(1))+ABS(G(1)) 
      IF(ABS(G(1)).LE.1.0E-15) G(1)=1.0E-15 
      P(1)=G(1)*G(1) 
      DO 10 I=2,NN 
      TNORM=ABS(F(I))+ABS(G(I))+ABS(G(I-1)) 
      RNORM=AMAX1(RNORM,TNORM) 
      IF(ABS(G(I)).LE.1.0E-15) G(I)=1.0E-15 
10    P(I)=G(I)*G(I) 
      K=1 
      U=RNORM 
      DO 20 I=1,NN 
20    E(I)=-RNORM 
30    RL=E(K) 
40    DL=0.5*(RL+U) 
      IF((DL.EQ.RL).OR.(DL.EQ.U)) GO TO 120 
      IAG=0 
      I=1 
50    S=F(I)-DL 
60    IF(S.GE.0.0) IAG=IAG+1 
      IF(S.EQ.0.0) GO TO 70 
      I=I+1 
      IF(I.GT.NN) GO TO 80 
      S=F(I)-DL-P(I-1)/S 
      GO TO 60 
70    I=I+2 
      IF(I.LE.NN) GO TO 50 
80    IF(IAG.GE.K) GO TO 90 
      U=DL 
      GO TO 40 
90    RL=DL 
      M=IAG 
      IF(NN.LT.IAG) M=NN 
      DO 110 I=K,M 
110   E(I)=DL 
      GO TO 40 
120   E(K)=DL 
      K=K+1 
      IF(K.LE.NN) GO TO 30 
130   RETURN 
      END 




      SUBROUTINE EIGENV(II,N) 
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
C      REAL*16 Y,DT
      REAL*8 Y,DT
      COMMON/EIGENC/ F(MAX_VEC),G(MAX_VEC),P(MAX_VEC),E(MAX_VEC) 
     1,Q(MAX_VEC),R(MAX_VEC),IN(MAX_VEC),
     1DM(MAX_VEC),Y(MAX_VEC+2) 
      LOGICAL IN 
      INCLUDE 'SHGR:DATA.INC'               
C
C-----------------------------------------------------------------------
C     CALCULATE I'TH EIGENVECTOR
C-----------------------------------------------------------------------
      IF(N.GT.1) GOTO 130 
      Y(1) = 1.0 
      RETURN 
130   CONTINUE 
      IRS=N-1 
      IRE=0 
      DO 140 J=1,N 
      P(J)=0.0 
      Q(J)=G(J) 
      R(J)=F(J)-E(II) 
140   Y(J)=1.0 
      Y(N+1)=0.0 
      Y(N+2)=0.0 
C-----  TRIANGULAR REDUCTION OF LEFT HAND SIDE
      IAG=N-1 
      DO 170 J=1,IAG 
      JJ=J+1 
      IF(ABS(R(J)).LT.ABS(G(J))) GO TO 150 
      DT=G(J)/R(J) 
      IN(J)=.FALSE. 
      GO TO 160 
150   DT=R(J)/G(J) 
      IN(J)=.TRUE. 
      R(J)=G(J) 
      U=R(JJ) 
      R(JJ)=Q(J) 
      Q(J)=U 
      P(J)=Q(JJ) 
      Q(JJ)=0.0 
160   DM(J)=DT 
      Q(JJ)=Q(JJ)-DT*P(J) 
      R(JJ)=R(JJ)-DT*Q(J) 
      IF(ABS(R(J)).LT.1.0E-30) R(J)=1.0E-30 
170   CONTINUE 
      IF(ABS(R(N)).LT.1.0E-30) R(N)=1.0E-30 
C-----  BACK SUBSTITUTION
190   CONTINUE 
      DO 230 J=1,N 
      JJ=N+1-J 
      T=Y(JJ) 
210   Y(JJ)=(T-Y(JJ+1)*Q(JJ)-Y(JJ+2)*P(JJ))/R(JJ) 
      IF(ABS(Y(JJ)).LE.1.0E33) GO TO 230 
      DO 220 JJJ=1,N 
220   Y(JJJ)=Y(JJJ)*1.0E-20 
      T=T*1.0E-20 
      GO TO 210 
230   CONTINUE 
      IF(IRE.EQ.2) GO TO 260 
      IRE=IRE+1 
C-----  TRIANGULAR REDUCTION OF NEW RHS
      DO 250 J=1,IRS 
      JJ=J+1 
      IF(IN(J)) GO TO 240 
      Y(JJ)=Y(JJ)-DM(J)*Y(J) 
      GO TO 250 
240   T=Y(J) 
      Y(J)=Y(JJ) 
      Y(JJ)=T-DM(J)*Y(JJ) 
250   CONTINUE 
      GO TO 190 
C-----  NORMALISE EIGENVECTOR
260   DT=0.0 
      DO 330 J=1,N 
      Y(J)=Y(J)*1.0E-10 
      DT=DT+Y(J)**2 
C  WRITE(8,350)Y(J),DT
330   CONTINUE 
      DT= SQRT(1.0/DT)*1.0E-10 
      DO 340 J=1,N 
340   Y(J)=Y(J)*1.0E+10*DT 
      RETURN 
      END 



      SUBROUTINE MATWR
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
      COMMON/CDET/DET,IDEX
      COMMON/HNORM/HNORM               
      DIMENSION DET(MAX_DIM),DETIN(MAX_DIM) 
      INTEGER*4 IDEX(MAX_DIM),IDEXIN(MAX_DIM)
      CHARACTER*4 DUD4,MAT_EXT,ORT2
      CHARACTER*9 ORTFIL
      CHARACTER*13 ORTF,BIGF,BIGG,NAME
      COMMON/CILPT/ILPT
      COMMON/CBAB/SPEBAB
      CHARACTER*1 ANSSPE
      COMMON/SPE1/ANSSPE
      COMMON/SPE/NJL,ENL(MAX_NJL),ENLOLD(MAX_NJL),
     1SPE_CHANGE(MAX_NPART),SPE_OLD(MAX_NPART) 
      COMMON/ORB/IORB,NIPART,NJTP(MAX_NPART) 
      COMMON/IN/MAXB,IRSIZE,TOL1,TOL2,NEIG,NOUT,NMX,SIGN 
      COMMON/CIN/ORTFIL,ORT2,BIGF,BIGG 
      COMMON/VBAR/IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
     1VBAR,DIAGMIN,TRACE
      INCLUDE 'SHGR:DATA.INC'               

      IMATOUT = 0       
      MAT_EXT='.MAT' 
      IF(IWC.EQ.1) MAT_EXT='.MAW' 
CBAB      CALL OPEN_FILE(9,ORTFIL,MAT_EXT,'OLD','UFRM')
      NAME = ORTFIL//MAT_EXT
      CALL OPENGEN(9,AREA_MAT,NAME,1)
      CALL OPEN_FILE(10,ORTFIL,'.MTP','NEW','UFRM')
      IF(IMATOUT.EQ.1) OPEN(UNIT=40,FILE=ORTFIL//'.MAL',STATUS='NEW')
      SPEBAB = 0.

      IPARTNO=NIPART 
      NDIAGONA=0 

CBAB      READ(9)
CBAB      READ(9)
      IF(HNORM.EQ.0.) HNORM = 1.
      DIAGMIN = 99999999.
      TRACE = 0.
      VBAR =0.
      IVBAR = 0
      IVZBAR = 0
      IVZ2BAR= 0
      IVZ3BAR = 0
      IVZ4BAR = 0
      IVZ5BAR = 0
      IVZ6BAR = 0
      IVZ7BAR = 0
      IVZ8BAR = 0
      IVZ9BAR = 0
      IVZ10BAR = 0
      IVZ11BAR = 0

      DO 5004 L=1,MAXB 
      READ(9) KMAX,(IDEXIN(I),I=1,KMAX),(DETIN(I),I=1,KMAX)
CBAB      READ(9)(DET(I),I=1,L)
      IF(IMATOUT.EQ.1) WRITE(40,4001) KMAX,(IDEXIN(I),I=1,KMAX)
4001  FORMAT(1X,10I5)
      IF(IMATOUT.EQ.1) WRITE(40,4000) (DETIN(I),I=1,KMAX)
4000  FORMAT(1X,10F10.3)
      K=0
C-----------------------------------------------------------------
      DO 5010 I=1,L
5010  DET(I) = 0.
      DO 5011 IK = 1,KMAX
      DET(IDEXIN(IK)) = DETIN(IK)
5011  CONTINUE
      DO 5000 I=1,L



      IF(I.NE.L) DET(I) = HNORM*DET(I)

      IF(I.EQ.L) TRACE = TRACE + DET(I)
      IF(I.NE.L) VBAR = VBAR + DET(I)*DET(I)
      IF(I.NE.L) IVBAR = IVBAR + 1
      IF(I.NE.L.AND.DET(I).NE.0.) IVZBAR = IVZBAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.001) IVZ2BAR = IVZ2BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.01) IVZ3BAR = IVZ3BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.1) IVZ4BAR = IVZ4BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.2) IVZ5BAR = IVZ5BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.4) IVZ6BAR = IVZ6BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.6) IVZ7BAR = IVZ7BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.0.8) IVZ8BAR = IVZ8BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.1.0) IVZ9BAR = IVZ9BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.1.5) IVZ10BAR = IVZ10BAR + 1
      IF(I.NE.L.AND.ABS(DET(I)).GT.2.0) IVZ11BAR = IVZ11BAR + 1


C                                 Do you want to change SPEs ? 
      IF(ANSSPE.EQ.'Y')THEN      
C                                          Change single particles energies 
      IF(I.EQ.L.AND.ANSSPE.EQ.'Y')THEN    
C                                          in matrix 
      NDIAGONA=NDIAGONA+1               
      IF(NDIAGONA.GE.NJTP(IPARTNO)+1)THEN 
313   IPARTNO=IPARTNO-1 
      IF(NJTP(IPARTNO).EQ.0)GO TO 313 
      NDIAGONA=1 
      END IF 

C                                           change diagonal elements 
      DET(I) = HNORM*(DET(I)-SPE_OLD(IPARTNO))+SPE_OLD(IPARTNO)
      DET(I)=DET(I)+SPE_CHANGE(IPARTNO)    

CAB ADDED DEC 18 1983

      IF(MAXB.EQ.1) SPEBAB = SPEBAB + SPE_CHANGE(IPARTNO)

CBAB IS THIS AN ERROR? AS AN EXAMPLE, FOR THE O16 1P1H PSD 0- STATE
CBAB THE VALUES OF IPARTNO ARE 5 AND 4
CBAB  IF(L.EQ.MAXB.AND.IPARTNO.NE.1)STOP  
CBAB 1' ***** FATAL ERROR in LANC: IPARTNO.NE.1 *****' 

CBAB ADDED FROM AE LETTER OF JUNE(MAY) 17 1983
871   IF(L.EQ.MAXB.AND.IPARTNO.NE.1)THEN
C                                      check if remaining partitions
      IF(NJTP(IPARTNO-1).EQ.0)THEN   
C                                      have zero JT-dimension.
      IPARTNO = IPARTNO-1            
      GO TO 871
      END IF
      STOP ' ***** FATAL ERROR in LANC: Partition number.NE.1.  Loop
     1 has not been performed over all partitions *****'
      END IF

      END IF 
      END IF 

CBAB      XMATMIN = .0001
CBAB      IF(ABS(DET(I)).GT.XMATMIN)THEN
CBAB      K=K+1
CBAB      IDEXOUT(K)=I
CBAB      END IF
      IF(I.EQ.L.AND.DET(I).LT.DIAGMIN) DIAGMIN = DET(I)
5000  CONTINUE
C-----------------------------------------------------------------
      IF(ILPT.EQ.2.AND.I30.NE.999)
     1CALL OPEN_FILE(30,ORTFIL,'.LTP','NEW','FORM')
      IF(ILPT.EQ.2.AND.I30.NE.999) I30 = 999
      WRITE(10) DET(L)
      IF(IMATOUT.EQ.1) WRITE(40,4000) DET(L)
5004  CONTINUE 



      IF(IVBAR.NE.0) VBAR = SQRT(VBAR/FLOAT(IVBAR))
      IF(IVBAR.EQ.0) VBAR = 0.
      WRITE(6,7000)IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
     1IVZ5BAR,IVZ6BAR,IVZ7BAR,IVZ8BAR,IVZ9BAR,IVZ10BAR,IVZ11BAR,
     1VBAR,DIAGMIN,TRACE
C      WRITE(3,7000)IVBAR,IVZBAR,IVZ2BAR,IVZ3BAR,IVZ4BAR,
C     1VBAR,DIAGMIN,TRACE
7000  FORMAT(/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS',/,
     11X,I9,' NON ZERO OFF DIAGONAL MATRIX ELEMENTS',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.001',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.01',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.1',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.2',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.4',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.6',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 0.8',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 1.0',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 1.5',/,
     11X,I9,' OFF DIAGONAL MATRIX ELEMENTS > 2.0',/,
     11X,F12.4,' AVERAGE (V**2)**(1/2) FOR OFF DIAGONAL ME',/,
     11X,F12.4,' MOST NEGATIVE DIAGONAL MATRIX ELEMENT',/,
     11X,E16.8,' TRACE')
CBAB      CLOSE(UNIT=9)
      RETURN
      END 

      SUBROUTINE ADDRAN(K)
      INCLUDE 'SHGRLIB:MACFOR.INC'               
      INCLUDE 'SHGR:PARAM.INC'               
      INCLUDE 'LANCOM.INC'               
      COMMON/CDET/DET,IDEX               
      DIMENSION DET(MAX_DIM) 
      INTEGER*4 IDEX(MAX_DIM)
      COMMON/CRAN/IRAN,IRANERR

      IF(IFIRST.EQ.999) GO TO 1000
      XRAN=IRAN
      XRAN=XRAN/10000.
      ISEED=-8573419
      IF(IFPS.EQ.2) CALL RANSET(ISEED)
      IFIRST = 999
1000  CONTINUE

      DO 2000 I = 1,K
      IF(IFPS.EQ.2) THEN
      IF(IRAN.GT.0)DET(I)=XRAN*RANF(ISEED)+DET(I)
      ELSE
      IF(IRAN.GT.0)DET(I)=XRAN*RAN(ISEED)+DET(I)
      END IF
2000  CONTINUE

      RETURN
      END
      subroutine newvec(vec,idim)
      common/ran/iseed
      dimension vec(idim)
      WRITE(6,'(1X,''Have encountered a premature termination of 
     1the Lanczos procedure.'',/,1x,''Will try to restart'')')
      do 10 i=1,idim
      ix=500*ran(iseed)
      sign=1.0
      if(iand(ix,1).eq.0)sign=-1.0
10    vec(i)=5.*sign*ran(iseed)
c      write(6,'(1x,f10.6)')vec(i)
      CALL NORM(RNORM,idim,VEC,VEC,2) 
c      write(6,'(1x,e15.6,/1x,10f10.6)')rnorm,(vec(i),i=1,idim)
      RETURN
      END
