CLEV-------------------------------------------------------------
CLEV                            BADJT
CLEV-------------------------------------------------------------
CLEC  SHELL MODEL - FOR SHELL.FOR
CLEV
CLEV  N SETS OF BAD J,T VALUES
CLEV  SET       J1 = -1 TO ASK "BAD J,T VALUES ?"
CLEV       = -2 TO WRITE OUT BAD J,T VALUES (FOR ELEV-SHELL)
CLEV       = >0 TO TEST IF J,T BAD:  RETURNS N=-1 IF BAD
CLEV
        SUBROUTINE BADJT(N,J1,IT1)
        LOGICAL EMPTY
        character blank*1
        DIMENSION JTBAD(3,10),NBAD(3)
        BLANK=' '
        IF (J1.GE.0)  GO TO 4
        IF (J1.EQ.-2) GO TO 7
        IF (N.GT.3) STOP 'ERROR: N>3 IN BADJT'
        NBAD(N)=0
  1     print 2
 
  2     FORMAT(' Bad J, T values ( <CR> to end ) : ',$)
        CALL FREEFM(EMPTY,SPIN1,SPIN2,DUMMY)
        IF(EMPTY)RETURN
 
  3     FORMAT(2F15.0)
        JAY=SPIN1*2
        ITT=SPIN2*2
        NBAD(N)=NBAD(N)+1
        IF (NBAD(N).GT.10) PAUSE 'ERROR: TOO MANY BAD STATES'
        JTBAD(N,NBAD(N))=JAY*100+ITT
        GO TO 1
  4     IF (NBAD(N).EQ.0) RETURN
        DO 5 I=1,NBAD(N)
        JT=J1*100+IT1
        IF (JTBAD(N,I).EQ.JT) GO TO 6
  5     CONTINUE
        RETURN
  6     N=-1
        RETURN
  7     IF (NBAD(N).EQ.0) GO TO 10
        DO 9 I=1,NBAD(N)
        JAY=JTBAD(N,I)/100
        ITT=JTBAD(N,I)-JAY*100
        SPIN1=JAY/2.0
        SPIN2=ITT/2.0
        WRITE(21,8) SPIN1,SPIN2
  8     FORMAT(1X,2F6.1)
  9     CONTINUE
 10     WRITE(21,3) BLANK
        RETURN
        END
