CLEV                            LABEL
CLEV---------------------------------------------------------------
CLEV  TO MAKE FILENAMES
CLEV
      SUBROUTINE LABEL(NAME)
      INCLUDE 'levcom.inc'
c     REAL INTCOD,NPC,JC
      character nhc*1, bic*1, codj*1, codt*1, codp*1, jc*1, npc*1
      IF (ICALL.EQ.0) CALL LABSET
      NAME='         '
  1   FORMAT(40A1)
      DO 2 I=1,NBIC
      IF (OPFIL.EQ.OPFILLAB(I).AND.SPSFIL.EQ.SPFILLAB(I)) GO TO  5
  2   CONTINUE
 
      print 3,SPSFIL,OPFIL
  3   FORMAT(1X,'In LABEL: SPS-INT code not found for ',2(A9,1X),
     1/,1X,'code X-Y temporarily added to list')
      NBIC = NBIC + 1
      IF(NBIC.GT.NO_FILES) print 4
      IF(NBIC.GT.NO_FILES) STOP
  4   FORMAT(1X,'ERROR IN LABEL NBIC>NO_FILES')
      I = NBIC
      SPFILLAB(I)=SPSFIL
      OPFILLAB(I)=OPFIL
      BICODE(I,1)='x'
      BICODE(I,2)='y'
  5   BIC=BICODE(I,1)
      NHC=BICODE(I,2)
      IF (IMZS.EQ.JAY) CODJ=INTCOD(JAY)
      IF (IMZS.EQ.JAY) GO TO 6
      CODJ=INTCOD(JAY)
  6   IF (ITZS.EQ.IT) CODT=INTCOD(IT)
      IF (ITZS.EQ.IT) GO TO 7
      CODT=INTCOD(IT)
  7   CONTINUE
      IF(KPAR.EQ.1) CODP = '1'
      IF(KPAR.EQ.0) CODP = '0'
      IF(KPAR.EQ.2) CODP = '2'
      IF(KPAR.EQ.3) CODP = '3'
c     ENCODE(6,1,NAME) BIC,CODJ,CODT,CODP,INTCOD(NPTCL),NHC
      write(name,1) BIC,CODJ,CODT,CODP,INTCOD(NPTCL),NHC
      RETURN
        END
CLEV-------------------------------------------------------------
CLEV                            DLABEL
CLEV-------------------------------------------------------------
CLEV  TO DECODE
CLEV
        SUBROUTINE DLABEL(NAME)
        INCLUDE 'levcom.inc'
c       REAL INTCOD,NPC,JC,NHC,PC
        character*1 pc, nhc, bic, jc, tc, npc
        IF (ICALL.EQ.0) CALL LABSET
  1     FORMAT(40A1)
c     DECODE(6,1,NAME) BIC,JC,TC,PC,NPC,NHC
        read(name,1) BIC,JC,TC,PC,NPC,NHC
 
        IF(PC.EQ.'0') KPAR=0
        IF(PC.EQ.'1') KPAR=1
        IF(PC.EQ.'2') KPAR=2
        IF(PC.EQ.'3') KPAR=3
        IBIC1=0
        DO  2 I=1,NBIC
        IF (BIC.NE.BICODE(I,1)) GO TO  2
        IBIC1=I
        IF (NHC.EQ.BICODE(I,2)) GO TO  6
  2     CONTINUE
        IF (IBIC1.EQ.0.OR.BICODE(IBIC1,2).NE.' ') GO TO 3
        I=IBIC1
      GO TO  6
 
  3   CONTINUE
      print 4,SPSFIL,OPFIL,BIC,NHC
  4   FORMAT(1X,'In LABEL: SPS-INT code not found for ',2(A9,1X),
     1/,1X,'code ',2A1,' temporarily added to list')
      NBIC = NBIC + 1
      IF(NBIC.GT.NO_FILES) print 5
      IF(NBIC.GT.NO_FILES) STOP
  5   FORMAT(1X,'ERROR IN LABEL NBIC>NO_FILES')
      I = NBIC
      SPFILLAB(I)='?'
      OPFILLAB(I)='?'
      BICODE(I,1)=BIC
      BICODE(I,2)=NHC
 
  6     IBIC=I
        DO 7 I=0,NINTC
        IF (JC.EQ.INTCOD(I)) JAY=I
        IMZS=JAY
        IF (JC.EQ.INTCOD(I)) GO TO 8
  7     CONTINUE
  8     DO 9 I=0,NINTC
        IF (TC.EQ.INTCOD(I)) IT=I
        ITZS=IT
        IF (TC.EQ.INTCOD(I)) GO TO 10
  9     CONTINUE
 10     DO 11 I=0,NINTC
        IF (NPC.EQ.INTCOD(I)) GO TO 13
 11     CONTINUE
        print 12
 12   FORMAT(1X,'ERROR IN DLABEL: NPTCL CODE NOT FOUND')
        GO TO 999
 13     NPTCL=I
        I=0
        IF (BICODE(IBIC,2).EQ.NHC) GO TO 15
        DO 14 I=0,NINTC
        IF (NHC.EQ.INTCOD(I)) GO TO 15
 14     CONTINUE
 15     NH=I
        OPFIL=OPFILLAB(IBIC)
        SPSFIL=SPFILLAB(IBIC)
        RETURN
999     IVERS=-IVERS
        RETURN
        END
CLEV-------------------------------------------------------------
CLEV                            LABSET
CLEV-------------------------------------------------------------
CLEV
CLEV  TO READ LABEL DATA FILE
CLEV
        SUBROUTINE LABSET
        INCLUDE 'levcom.inc'
        character ncf*5, fstr*50
c       REAL INTCOD
        LOGICAL EXIST
        ICALL=1
        CALL OPENLAB(24,'label.dat    ',0)
        CALL OPENLAB(25,'labelj.dat   ',0)
      CALL SKIPHEAD(25)
      DO 1 I = 1,NO_CODE
  1   INTCOD(I) = ' '
      write(ncf,'(i5)') no_code + 1
      fstr = '('//ncf//'a1)'
c     READ(25,3) (INTCOD(I),I=0,NO_CODE)
      READ(25,fstr) (INTCOD(I),I=0,NO_CODE)
  2   FORMAT(A8,A8,A1,3X,A1)
c 3   FORMAT(<NO_CODE+1>A1)
      DO 4 I = NO_CODE,1,-1
      IF(INTCOD(I).EQ.'!') NINTC = I-1
      IF(INTCOD(I).EQ.'!') GO TO 5
      IF(INTCOD(I).NE.' ') NINTC = I
      IF(INTCOD(I).NE.' ') GO TO 5
  4   CONTINUE
  5   CONTINUE
 
 
 
      NBIC=0
  6   CONTINUE
      NBIC=NBIC+1
 
  7   READ(24,2,END=8) SPFILLAB(NBIC),OPFILLAB(NBIC),
     1       BICODE(NBIC,1),BICODE(NBIC,2)
        IF(SPFILLAB(NBIC).EQ.' ')GOTO 7
CLEV *** which means skip information in LABEL.dat if present ***
 
 
        GO TO 6
  8     IF (NBIC.GT.400) STOP 'ERROR IN LABSET: NBIC TOO LARGE'
        IF (NINTC.GT.NO_CODE) STOP 'ERROR IN LABSET: NINTC TOO LARGE'
        RETURN
999     IVERS=-IVERS
        RETURN
        END
CLEV-------------------------------------------------------------
CLEV                            LABSPS
CLEV-------------------------------------------------------------
CLEV  TO GET THE SPS FILE GIVEN THE INTERACTION
CLEV
        SUBROUTINE LABSPS(OPFIL1,SPFIL1)
        INCLUDE 'levcom.inc'
        CHARACTER *9 OPFIL1,SPFIL1
c       REAL INTCOD
        IF (ICALL.EQ.0) CALL LABSET
        DO 1 I=1,NBIC
        IF (OPFILLAB(I).EQ.OPFIL1) GO TO 3
  1     CONTINUE
      print 2
  2   FORMAT(1X,'ERROR IN LABSPS: SPS FILE NOT FOUND')
        SPFIL1=' '
        RETURN
  3     SPFIL1=SPFILLAB(I)
        RETURN
        END
 
