      real function ran3(idum)
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
c
c     (S.K. 5/20/1996) As the compiler (f77 on DEC OSF)
c     does not seem to support an intrinsic random number
c     generator, I am supplying RAN3 from Numerical
c     Recipes as a substitute (NR, 1st Ed., page 199).
c
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

      save                ! needed, I think..... - S.K.
      parameter (mbig=1000000000,mseed=161803398,mz=0,fac=1./mbig)

      integer ma(55)
      data iff /0/

      if (idum.lt.0.or.iff.eq.0) then
         iff = 1
         mj = mseed - iabs(idum)
         mj = mod(mj, mbig)
         ma(55) = mj
         mk = 1
         do i = 1,54
            ii = mod(2*i, 55)
            ma(ii) = mk
            mk = mj - mk
            if (mk.lt.mz) mk = mk + mbig
            mj = ma(ii)
         enddo
         do k = 1,4
            do i = 1,55
               ma(i) = ma(i) - ma(1+mod(i+30, 55))
               if (ma(i).lt.mz) ma(i) = ma(i) + mbig
            enddo
         enddo
         inext = 0
         inextp = 31
         idum = 1
      endif
      inext = inext + 1
      if (inext.eq.56) inext = 1
      inextp = inextp + 1
      if (inextp.eq.56) inextp = 1
      mj = ma(inext) - ma(inextp)
      if (mk.lt.mz) mj = mj + mbig
      ma(inext) = mj
      ran3 = mj*fac
      return
      end
      
