      LOGICAL FUNCTION LIB_LEX(IAA,IBB,L)
      PARAMETER (MAX_L=100)
      DIMENSION IA(MAX_L),IB(MAX_L),IAA(MAX_L),IBB(MAX_L)
      IF(L.GT.MAX_L)STOP 'FATAL ERROR IN LIB_LEX: INCREASE MAX_L'
CWEO  Added to help the ordering of partitions without BYTE variables
      DO 10 I=1,L
      IA(I)=IAA(I)
      IB(I)=IBB(I)
      IF(IAA(I).LT.0)IA(I)=512+IAA(I)
10    IF(IBB(I).LT.0)IB(I)=512+IBB(I)
      LIB_LEX=.FALSE.
CWEO      DO 10000 I=1,L
      DO 10000 I=L,1,-1
      IF(IA(I).GT.IB(I))RETURN
      IF(IA(I).LT.IB(I))THEN
      LIB_LEX=.TRUE.
      RETURN
      END IF
10000 CONTINUE
      LIB_LEX=.TRUE.
      RETURN
      END

      LOGICAL FUNCTION LIB_LTX(IAA,IBB,L)
      PARAMETER (MAX_L=100)
      DIMENSION IA(MAX_L),IB(MAX_L),IAA(MAX_L),IBB(MAX_L)
      IF(L.GT.MAX_L)STOP 'FATAL ERROR IN LIB_LTX: INCREASE MAX_L'
CWEO  Added to help the ordering of partitions without BYTE variables
      DO 10 I=1,L
      IA(I)=IAA(I)
      IB(I)=IBB(I)
      IF(IAA(I).LT.0)IA(I)=512+IAA(I)
10    IF(IBB(I).LT.0)IB(I)=512+IBB(I)
      LIB_LTX=.FALSE.
CWEO      DO 10000 I=1,L
      DO 10000 I=L,1,-1
      IF(IA(I).GT.IB(I))RETURN
      IF(IA(I).LT.IB(I))THEN
      LIB_LTX=.TRUE.
      RETURN
      END IF
10000 CONTINUE
      RETURN
      END

      LOGICAL FUNCTION LIB_GEX(IAA,IBB,L)
      PARAMETER (MAX_L=100)
      DIMENSION IA(MAX_L),IB(MAX_L),IAA(MAX_L),IBB(MAX_L)
      IF(L.GT.MAX_L)STOP 'FATAL ERROR IN LIB_GEX: INCREASE MAX_L'
CWEO  Added to help the ordering of partitions without BYTE variables
      DO 10 I=1,L
      IA(I)=IAA(I)
      IB(I)=IBB(I)
      IF(IAA(I).LT.0)IA(I)=512+IAA(I)
10    IF(IBB(I).LT.0)IB(I)=512+IBB(I)
      LIB_GEX=.FALSE.
CWEO      DO 10000 I=1,L
      DO 10000 I=L,1,-1
      IF(IA(I).LT.IB(I))RETURN
      IF(IA(I).GT.IB(I))THEN
      LIB_GEX=.TRUE.
      RETURN
      END IF
10000 CONTINUE
      LIB_GEX=.TRUE.
      RETURN
      END

      LOGICAL FUNCTION LIB_GTX(IAA,IBB,L)
      PARAMETER (MAX_L=100)
      DIMENSION IA(MAX_L),IB(MAX_L),IAA(MAX_L),IBB(MAX_L)
      IF(L.GT.MAX_L)STOP 'FATAL ERROR IN LIB_GTX: INCREASE MAX_L'
CWEO  Added to help the ordering of partitions without BYTE variables
      DO 10 I=1,L
      IA(I)=IAA(I)
      IB(I)=IBB(I)
      IF(IAA(I).LT.0)IA(I)=512+IAA(I)
10    IF(IBB(I).LT.0)IB(I)=512+IBB(I)
      LIB_GTX=.FALSE.
CWEO      DO 10000 I=1,L
      DO 10000 I=L,1,-1
      IF(IA(I).LT.IB(I))RETURN
      IF(IA(I).GT.IB(I))THEN
      LIB_GTX=.TRUE.
      RETURN
      END IF
10000 CONTINUE
      RETURN
      END

      LOGICAL FUNCTION LIB_NEX(IAA,IBB,L)
      PARAMETER (MAX_L=100)
      DIMENSION IA(MAX_L),IB(MAX_L),IAA(MAX_L),IBB(MAX_L)
      IF(L.GT.MAX_L)STOP 'FATAL ERROR IN LIB_NEX: INCREASE MAX_L'
CWEO  Added to help the ordering of partitions without BYTE variables
      DO 10 I=1,L
      IA(I)=IAA(I)
      IB(I)=IBB(I)
      IF(IAA(I).LT.0)IA(I)=512+IAA(I)
10    IF(IBB(I).LT.0)IB(I)=512+IBB(I)
      LIB_NEX=.FALSE.
CWEO      DO 10000 I=1,L
      DO 10000 I=L,1,-1
      IF(IA(I).NE.IB(I))LIB_NEX=.TRUE.
      IF(LIB_NEX)RETURN
10000 CONTINUE
      RETURN
      END

      LOGICAL FUNCTION LIB_EQX(IAA,IBB,L)
      PARAMETER (MAX_L=100)
      DIMENSION IA(MAX_L),IB(MAX_L),IAA(MAX_L),IBB(MAX_L)
      IF(L.GT.MAX_L)STOP 'FATAL ERROR IN LIB_EQX: INCREASE MAX_L'
CWEO  Added to help the ordering of partitions without BYTE variables
      DO 10 I=1,L
      IA(I)=IAA(I)
      IB(I)=IBB(I)
      IF(IAA(I).LT.0)IA(I)=512+IAA(I)
10    IF(IBB(I).LT.0)IB(I)=512+IBB(I)
      LIB_EQX=.FALSE.
CWEO      DO 10000 I=1,L
      DO 10000 I=L,1,-1
      IF(IA(I).NE.IB(I))RETURN
10000 CONTINUE
      LIB_EQX=.TRUE.
      RETURN
      END

      LOGICAL FUNCTION LIB_BTX(IA,IB,L)
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      DIMENSION IA(MAX_NJL)
      N=(IB/MAX_BIT_NLWRDS)+1
      NX=IB-(N-1)*MAX_BIT_NLWRDS
      IX=2**NX
      IF(N.GT.L)STOP 'LIB_BTX: DIMENSION OF NLWRDS NOT GREAT ENOUGH'
      IF(IAND(IA(N),IX).NE.0)THEN
      LIB_BTX=.TRUE.
      ELSE
      LIB_BTX=.FALSE.
      END IF
      RETURN
      END

      LOGICAL FUNCTION LIB_BTSX(IA,IB,L)
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      DIMENSION IA(MAX_NJL)
      N=(IB/MAX_BIT_NLWRDS)+1
      NX=IB-(N-1)*MAX_BIT_NLWRDS
      IX=2**NX
      IF(N.GT.L) THEN
      WRITE(6,13)N,L
 13   FORMAT(1X,'N,L: ',2(I5,1X),
     1'LIB_BTSX: DIMENSION OF NLWRDS NOT GREAT ENOUGH')
      STOP
      END IF
      IF(IAND(IA(N),IX).NE.0)THEN
      LIB_BTSX=.TRUE.
      ELSE
      IA(N)=IOR(IA(N),IX)
      LIB_BTSX=.FALSE.
      END IF
      RETURN
      END


      LOGICAL FUNCTION LIB_BTCX(IA,IB,L)
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      DIMENSION IA(MAX_NJL)
      N=(IB/MAX_BIT_NLWRDS)+1
      IF(N.GT.L)STOP 'LIB_BTCX: DIMENSION OF NLWRDS NOT GREAT ENOUGH'
      NX=IB-(N-1)*MAX_BIT_NLWRDS
      IX=2**NX
      IF(IAND(IA(N),IX).NE.0)THEN
      LIB_BTCX=.TRUE.
CWEO      IA(L)=IA(L).XOR.2**IB
      IA(N)=IEOR(IA(N),IX)
      ELSE
      LIB_BTCX=.FALSE.
      END IF
      RETURN
      END
