      SUBROUTINE READLINE(IDEV,LINE,IERR)
      CHARACTER*1 LINE(300),LINES(132)
      IERR = 0
      IOLD = 0
700   CONTINUE
      CALL ZEROLINES(LINES)
      READ(IDEV,20,ERR=1000) LINES 
  20  FORMAT(132A1) 
      DO 200 I = 132,1,-1
      IF(LINES(I).NE.' ') GO TO 900
200   CONTINUE
CBAB      TYPE 7777,(LINE(I),I=1,200)
CBAB7777  FORMAT(1X,50A1)
      RETURN

900   IF(LINES(I).EQ.'-') GO TO 500
      GO TO 300

500   CONTINUE
      IMAX = I-1
      DO 600 I = 1,IMAX
      LINE(I+IOLD) = LINES(I)
600   CONTINUE
      IOLD = IOLD+IMAX
      GO TO 700

300   CONTINUE
      IMAX = I
      DO 800 I = 1,IMAX
      LINE(I+IOLD) = LINES(I)
800   CONTINUE
CBAB      TYPE 7777,(LINE(I),I=1,200)
      RETURN

1000  IERR = 1
      RETURN
      END

      SUBROUTINE ZEROLINES(LINE)
      CHARACTER*1 LINE(132)
      DO 100 I = 1,132
100   LINE(I) = ' '
      RETURN
      END 

      SUBROUTINE ZEROLINE(LINE)
      CHARACTER*1 LINE(300)
      DO 100 I = 1,300
100   LINE(I) = ' '
      RETURN
      END 

      SUBROUTINE MAXLINE(LINE,IMAXLINE)
      CHARACTER*1 LINE(300)
      DO 100 I = 300,1,-1
100   IF(LINE(I).NE.' ') GO TO 200
      IMAXLINE = 0
      RETURN
200   IMAXLINE = I
      RETURN
      END 

C-----------------------------------------------------------------------------
C           FREEFM 
C-----------------------------------------------------------------------------
C * SHELL MODEL ROUTINE *
C
      SUBROUTINE FREEFM(EMPTY,F) 
C
C ** TO READ 3 (FLOATING POINT) NUMBERS IN "FREE FORMAT".
C                   JSW  MARCH 1981 
      LOGICAL EMPTY,BLANK 
CBAB      CHARACTER *30 LINE 
      CHARACTER*1 LINE 
      DIMENSION F(3) 
      COMMON/DIGT2/ LINE(300) 
      EMPTY=.TRUE.
      IDEV = 5
      CALL ZEROLINE(LINE) 
      CALL READLINE(IDEV,LINE,IERR)
C
C ** ASSUME THAT CALLING ROUTINE HAS TYPED A PROMPT, IF NECCESARY...
C
CBAB      READ(5,20) LINE 
CBAB  20  FORMAT(132A1) 
      DO 30 I=1,3 
  30  F(I)=0.0 
      CALL MAXLINE(LINE,I)
      IF(I.EQ.0) RETURN
      EMPTY=.FALSE. 
C
C ** KHAR points to position in line, KNUM keeps track of which number
C ** we're dealing with.
C
      KHAR=1 
      DO 100 KNUM=1,3 
      FNUM=0.0 
      TEN=10. 
      TENTH=1. 
      SIGNF=1. 
 50   IF(LINE(KHAR).EQ.'.') THEN 
        TEN=1. 
        TENTH=0.1 
        KHAR=KHAR+1 
      END IF 
      CALL XDIGIT(BLANK,KHAR,DGT) 
      KHAR=KHAR+1 
      IF(.NOT.BLANK) THEN 
        IF(DGT.GT.9.5) SIGNF=-1. 
        IF(DGT.GT.9.5) GO TO 50 
        FNUM= FNUM*TEN + DGT*TENTH 
        IF(TENTH.LT.1.) TENTH = TENTH*0.1 
        IF(KHAR.LE.30) GO TO 50 
      END IF 
      F(KNUM)=FNUM*SIGNF 
 100  CONTINUE 
      RETURN 
      END 
C------------------------------------------------------------------------------
C           XDIGIT 
C------------------------------------------------------------------------------
      SUBROUTINE XDIGIT(BLANK,K,D) 
C
C ** Returns numerical value of character of line when called by FREEFM.
C ** If a digit (0...9) or a minus sign BLANK = .FALSE. , any other 
C ** character (i.e. a delimiter) BLANK = .TRUE.
C
      LOGICAL BLANK 
CBAB      CHARACTER *30 LINE 
      CHARACTER*1 LINE
      CHARACTER *11 NUMBER 
      COMMON/DIGT2/ LINE(300) 
      DATA NUMBER/'0123456789-'/ 
      BLANK=.TRUE. 
      DO 10 J=1,11 
      IF(LINE(K).EQ.NUMBER(J:J)) THEN 
        BLANK=.FALSE. 
C                    n.b. a minus sign flagged by D = 10. 
        D=J-1      
        GO TO 20 
      END IF 
 10   CONTINUE 
 20   RETURN 
      END 





C-----------------------------------------------------------------------------
C           FREEREAL 
C-----------------------------------------------------------------------------
C * SHELL MODEL ROUTINE *
C
      SUBROUTINE FREE_REAL(IDEV,J,F,ERR) 
C
C ** READ UP TO 30 (FLOATING POINT) NUMBERS IN "FREE FORMAT".
C                   JSW  MARCH 1981 
CBAB      CHARACTER *80 LINE 
      CHARACTER*1 LINE 
      DIMENSION F(30),X(16),XEXP(2) 
      LOGICAL ERR
      COMMON/DIGT2/ LINE(300) 
C
C ** ASSUME THAT CALLING ROUTINE HAS TYPED A PROMPT, IF NECCESARY...
C
      ERR=.FALSE.
      CALL ZEROLINE(LINE)
      CALL READLINE(IDEV,LINE,IERR)
      IF(IERR.EQ.1) GO TO 1000
CBAB      READ(IDEV,20,ERR=1000) LINE 
CBAB  20  FORMAT(132A1)
      DO 30 I=1,30 
  30  F(I)=0.0 
      CALL MAXLINE(LINE,I)
      IF(I.EQ.0) RETURN 
C
C ** KHAR points to position in line, KNUM keeps track of which number
C ** we're dealing with.
C
      KHAR=0 
      DO 100 KNUM=1,J 
      ITEN=0
      DO 110 I=1,16
110   X(I)=0.00
      I=0
      FNUM=0.0 
      SIGNF=1. 
 50   KHAR=KHAR+1
CBAB      IF(KHAR.EQ.81)GOTO 300
      IF(KHAR.EQ.300)GOTO 300
      IF(LINE(KHAR).EQ.' '.AND.I.EQ.0)GOTO 50 
      IF(LINE(KHAR).EQ.'!'.AND.I.EQ.0)RETURN
      IF(LINE(KHAR).EQ.'!'.AND.I.NE.0)GOTO 310 
      IF(LINE(KHAR).EQ.' '.AND.I.NE.0)GOTO 310 
      IF(LINE(KHAR).EQ.',')GOTO 310
      IF(LINE(KHAR).EQ.'E')GOTO 101
      IF(LINE(KHAR).EQ.'-')THEN
      SIGNF=-1.
      GOTO 50
      END IF
      IF(LINE(KHAR).EQ.'.') THEN
      ITEN=I+1
      GOTO 50
      END IF
      I=I+1
      CALL DIGIT(KHAR,X(I)) 
      GOTO 50
 310  IF(ITEN.EQ.0)ITEN=I+1
 99   IF(LINE(KHAR+1).EQ.'E')THEN
      KHAR=KHAR+1
      GOTO 101
      END IF
 300  DO 105 I=1,16
      F(KNUM)=F(KNUM)+X(I)*(10.**(FLOAT(ITEN-I-1)))
 105  CONTINUE
      F(KNUM)=F(KNUM)*SIGNF
      GOTO 301
 101  EXPSIGN=1.0
      DO 106 I=1,16
      F(KNUM)=F(KNUM)+X(I)*(10.**(FLOAT(ITEN-I-1)))
 106  CONTINUE
      F(KNUM)=F(KNUM)*SIGNF
      IEXP=0
 51   KHAR=KHAR+1
      IF(LINE(KHAR).EQ.' '.AND.IEXP.NE.0)GOTO 111
      IF(LINE(KHAR).EQ.',')GOTO 111
      IF(LINE(KHAR).EQ.'-')THEN
      EXPSIGN=-1.
      GOTO 51
      END IF
      IF(LINE(KHAR).EQ.' ')GOTO 51
      IEXP=IEXP+1
      CALL DIGIT(KHAR,XEXP(IEXP))
      GOTO 51
 111  IF(IEXP.EQ.1)THEN
      EXPONENT=XEXP(1)
      ELSE
      EXPONENT=XEXP(1)*10.+XEXP(2)
      END IF
      F(KNUM)=F(KNUM)*10.**(EXPSIGN*EXPONENT)
CBAB 301  IF(KHAR.EQ.81)RETURN
 301  IF(KHAR.EQ.300)RETURN
      IF(LINE(KHAR).EQ.'!')RETURN
 100  CONTINUE 
      RETURN 
1000  ERR=.TRUE.
      RETURN
      END 



C-----------------------------------------------------------------------------
C           FREEREALA
C-----------------------------------------------------------------------------
C * SHELL MODEL ROUTINE *
C
      SUBROUTINE FREE_REAL_A(IDEV,L,NAME,J,F,ERR) 
C
C ** READ UP TO 30 (FLOATING POINT) NUMBERS IN "FREE FORMAT".
C                   JSW  MARCH 1981 
      CHARACTER*9 NAME(30),BLANK
CBAB      CHARACTER *80 LINE 
      CHARACTER*1 LINE 
      DIMENSION F(30),X(16),XEXP(2) 
      LOGICAL ERR
      COMMON/DIGT2/ LINE(300) 
      DATA BLANK/'        '/
C
C ** ASSUME THAT CALLING ROUTINE HAS TYPED A PROMPT, IF NECCESARY...
C
      ERR=.FALSE.
      CALL ZEROLINE(LINE)
      CALL READLINE(IDEV,LINE,IERR)
      IF(IERR.EQ.1) GO TO 1000
CBAB      READ(IDEV,20,ERR=1000) LINE 
CBAB  20  FORMAT(132A1) 
      DO 30 I=1,30 
      NAME(I)=BLANK
  30  F(I)=0.0 
      CALL MAXLINE(LINE,I)
      IF(I.EQ.0) RETURN
C
C ** KHAR points to position in line, KNUM keeps track of which number
C ** we're dealing with.
C
      KHAR=1
      DO 200 I=1,L
202   IF(LINE(KHAR).EQ.' ')THEN
      KHAR=KHAR+1
      GOTO 202
      END IF
      NCHAR=1
204   IF(LINE(KHAR).EQ.',')GOTO 201
      IF(LINE(KHAR).EQ.'!')RETURN
      IF(LINE(KHAR).EQ.' ')GOTO 201
      NAME(I)(NCHAR:NCHAR)=LINE(KHAR)
      KHAR=KHAR+1
      NCHAR=NCHAR+1
      GOTO 204
201   KHAR=KHAR+1
200   CONTINUE
      KHAR=KHAR-1
      DO 100 KNUM=1,J 
      ITEN=0
      DO 110 I=1,16
110   X(I)=0.00
      I=0
      FNUM=0.0 
      SIGNF=1. 
 50   KHAR=KHAR+1
CBAB      IF(KHAR.EQ.81)GOTO 300
      IF(KHAR.EQ.300)GOTO 300
      IF(LINE(KHAR).EQ.' '.AND.I.EQ.0)GOTO 50 
      IF(LINE(KHAR).EQ.'!'.AND.I.EQ.0)RETURN
      IF(LINE(KHAR).EQ.'!'.AND.I.NE.0)GOTO 310 
      IF(LINE(KHAR).EQ.' '.AND.I.NE.0)GOTO 310 
      IF(LINE(KHAR).EQ.',')GOTO 310
      IF(LINE(KHAR).EQ.'E')GOTO 101
      IF(LINE(KHAR).EQ.'-')THEN
      SIGNF=-1.
      GOTO 50
      END IF
      IF(LINE(KHAR).EQ.'.') THEN
      ITEN=I+1
      GOTO 50
      END IF
      I=I+1
      CALL DIGIT(KHAR,X(I)) 
      GOTO 50
 310  IF(ITEN.EQ.0)ITEN=I+1
 99   IF(LINE(KHAR+1).EQ.'E')THEN
      KHAR=KHAR+1
      GOTO 101
      END IF
 300  DO 105 I=1,16
      F(KNUM)=F(KNUM)+X(I)*(10.**(FLOAT(ITEN-I-1)))
 105  CONTINUE
      F(KNUM)=F(KNUM)*SIGNF
      GOTO 301
 101  EXPSIGN=1.0
      DO 106 I=1,16
      F(KNUM)=F(KNUM)+X(I)*(10.**(FLOAT(ITEN-I-1)))
 106  CONTINUE
      F(KNUM)=F(KNUM)*SIGNF
      IEXP=0
 51   KHAR=KHAR+1
      IF(LINE(KHAR).EQ.' '.AND.IEXP.NE.0)GOTO 111
      IF(LINE(KHAR).EQ.',')GOTO 111
      IF(LINE(KHAR).EQ.'-')THEN
      EXPSIGN=-1.
      GOTO 51
      END IF
      IF(LINE(KHAR).EQ.' ')GOTO 51
      IEXP=IEXP+1
      CALL DIGIT(KHAR,XEXP(IEXP))
      GOTO 51
 111  IF(IEXP.EQ.1)THEN
      EXPONENT=XEXP(1)
      ELSE
      EXPONENT=XEXP(1)*10.+XEXP(2)
      END IF
      F(KNUM)=F(KNUM)*10.**(EXPSIGN*EXPONENT)
CBAB 301  IF(KHAR.EQ.81)RETURN
 301  IF(KHAR.EQ.300)RETURN
      IF(LINE(KHAR).EQ.'!')RETURN
 100  CONTINUE 
      RETURN 
1000  ERR=.TRUE.
      RETURN
      END 




C-----------------------------------------------------------------------------
C           FREEINT 
C-----------------------------------------------------------------------------
C * SHELL MODEL ROUTINE *
C
      SUBROUTINE FREE_INT(IDEV,J,INTVAR,ERR) 
C
C ** READ UP TO 30 (INTEGER) NUMBERS IN "FREE FORMAT".
C                   JSW  MARCH 1981 
CBAB      CHARACTER *80 LINE 
      CHARACTER*1 LINE 
      DIMENSION INTVAR(30),INTER(8) 
      LOGICAL ERR
      COMMON/DIGT2/ LINE(300) 
C
C ** ASSUME THAT CALLING ROUTINE HAS TYPED A PROMPT, IF NECCESARY...
C
      ERR=.FALSE.
      CALL ZEROLINE(LINE)
      CALL READLINE(IDEV,LINE,IERR)
      IF(IERR.EQ.1) GO TO 1000
CBAB      READ(IDEV,20,ERR=1000) LINE 
CBAB  20  FORMAT(132A1) 
      DO 30 I=1,30 
  30  INTVAR(I)=0 
      CALL MAXLINE(LINE,I)
      IF(I.EQ.0) RETURN
C
C ** KHAR points to position in line, KNUM keeps track of which number
C ** we're dealing with.
C
      KHAR=0
      DO 100 KNUM=1,J
      ITEN=0
      DO 110 I=1,8
110   INTER(I)=0
      I=0
      ISIGNF=1
 50   KHAR=KHAR+1
CBAB      IF(KHAR.EQ.81)GOTO 300
      IF(KHAR.EQ.300)GOTO 300
      IF(LINE(KHAR).EQ.' '.AND.I.NE.0)GOTO 99 
      IF(LINE(KHAR).EQ.',')GOTO 99
      IF(LINE(KHAR).EQ.'-')THEN
      ISIGNF=-1
      GOTO 50
      END IF
      IF(LINE(KHAR).EQ.' ')GOTO 50
      I=I+1
      CALL IDIGIT(KHAR,INTER(I))
      GOTO 50
 99   ITEN=I+1
 300  DO 105 I=1,8
CZ      INTVAR(KNUM)=INTVAR(KNUM)+INTER(I)*(10.**(FLOAT(ITEN-I-1)))
      INTVAR(KNUM)=INTVAR(KNUM)+NINT(INTER(I)*(10.**(FLOAT(ITEN-I-1))))
 105  CONTINUE
      INTVAR(KNUM)=INTVAR(KNUM)*ISIGNF
CBAB      IF(KHAR.EQ.81)RETURN
      IF(KHAR.EQ.300)RETURN
 100  CONTINUE
      RETURN
1000  ERR=.TRUE.
      RETURN
      END


C------------------------------------------------------------------------------
C           DIGIT 
C------------------------------------------------------------------------------
      SUBROUTINE DIGIT(K,D) 
C
C ** Returns numerical value of character of line when called by FREEFM.
C ** If a digit (0...9) or a minus sign BLANK = .FALSE. , any other 
C ** character (i.e. a delimiter) BLANK = .TRUE.
C
CBAB      CHARACTER *80 LINE 
      CHARACTER*1 LINE 
      CHARACTER *10 NUMBER 
      COMMON/DIGT2/ LINE(300) 
      DATA NUMBER/'0123456789'/ 
      DO 10 J=1,10 
      IF(LINE(K).EQ.NUMBER(J:J)) THEN 
        D=J-1 
        GO TO 20 
      END IF 
 10   CONTINUE 
 20   RETURN 
      END 



C------------------------------------------------------------------------------
C         IDIGIT 
C------------------------------------------------------------------------------
      SUBROUTINE IDIGIT(K,L) 
C
C ** Returns numerical value of character of line when called by FREEFM.
C ** If a digit (0...9) or a minus sign BLANK = .FALSE. , any other 
C ** character (i.e. a delimiter) BLANK = .TRUE.
C
CBAB      CHARACTER *80 LINE 
      CHARACTER*1 LINE 
      CHARACTER *10 NUMBER 
      COMMON/DIGT2/ LINE(300) 
      DATA NUMBER/'0123456789'/ 
      DO 10 J=1,10 
      IF(LINE(K).EQ.NUMBER(J:J)) THEN 
        L=J-1 
        GO TO 20 
      END IF 
 10   CONTINUE 
 20   RETURN 
      END 
