C	PROGRAM TO CONVERT "INT" FILES TO "ISO" FILES

CBAB      INCLUDE 'SHGR:MAINCOM.INC'
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHGR:PARAM.INC'
      INCLUDE 'SHGR:DATA.INC'
      PARAMETER MAX_V = 5000
      CHARACTER*9 INTFIL,SPSFIL
      CHARACTER*11 ISOFIL,NISOFIL
      CHARACTER*1 LAB,LABP,LABN
      DIMENSION LAB(9,MAX_NJL),LABP(9,MAX_NJL),LABN(9,MAX_NJL)
      DIMENSION KNJL(MAX_NJL),KNOSC(MAX_NOSC),IFIRST(MAX_NJL)
      DIMENSION KNJLPN(MAX_NJL),KNOSCPN(MAX_NOSC)
      DIMENSION KD(MAX_NSPS),KN(MAX_NSPS),KL(MAX_NSPS)
      DIMENSION KJ(MAX_NSPS),KM(MAX_NSPS),KT(MAX_NSPS)
      DIMENSION ENL(MAX_NJL),XJJ(MAX_NJL)
      DIMENSION KV(MAX_V,6),V(MAX_V)
      DIMENSION INDJ(12),NIN(12),LIN(12),JIN(12)
      COMMON/INDEX/XL(3,200)
      CALL INDEX
      TYPE 110
110   FORMAT(1X,'SPS file name (A9): '$)
      ACCEPT 111,SPSFIL
111   FORMAT(A)
      TYPE 100
100   FORMAT(1X,'INT file name (A9): '$)
      ACCEPT 101,INTFIL
101   FORMAT(A)
      ISOFIL = INTFIL

      TYPE 810,ISOFIL
810   FORMAT(/,1X,'ISO file name = ',A11,
     1//,1X,'TYPE RETURN IF YOU ARE HAPPY WITH THIS'
     1/,1X,'TYPE "NEWNAME" IF YOU WANT TO CHANGE THE NAME'/)
      ACCEPT 111,NISOFIL
      IF(NISOFIL.EQ.'NONE') IINTOUT = 0
      IF(NISOFIL.EQ.'NONE') GO TO 811
      IF(NISOFIL.NE.' ') ISOFIL = NISOFIL
811   CONTINUE

      OPEN (UNIT=10,FILE=SPSFIL//'.SPS',STATUS='OLD')
      OPEN (UNIT=11,FILE=INTFIL//'.INT',STATUS='OLD')
      OPEN (UNIT=21,FILE=ISOFIL//'.ISO',STATUS='NEW')

CBAB READ OLD SPS FILE
      READ(10,*) NSPS,NJL,(KNJL(I),I=1,NJL),NOSC,(KNOSC(I),I=1,NOSC)
C      READ(10,200) ((LAB(J,I),J=1,NOSC),I=1,NJL)
      READ(10,*)
200   FORMAT(200A1)
      CLOSE(UNIT=10)

      NUM_ORBITS=0
      DO I=1,NOSC
      NUM_ORBITS=NUM_ORBITS+KNOSC(I)
      END DO
      TYPE *,'ENTER INDEX OF J ORBITS'
      ACCEPT *,(INDJ(I),I=1,NUM_ORBITS)
      TYPE *,'PRINT T=1 OR T=0 MATRIX ELEMENTS? (1/0) '
      ACCEPT *,ITT      

CBAB READ OLD INT FILE

      CALL SKIPHEAD(11)
      READ(11,*) NV,(ENL(I),I=1,NJL)
      INV = 0
401   CONTINUE
      INV = INV + 1
      IF(INV.GT.MAX_V) TYPE 410
      IF(INV.GT.MAX_V) STOP
410   FORMAT(1X,'ERROR: INCREASE MAX_V')
      READ(11,*,END=402) (KV(INV,I),I=1,6),V(INV)
      GO TO 401
402   CONTINUE
      INV = INV-1
      IF(INV.NE.NV) TYPE 403,NV,INV
403   FORMAT(1X,'WARNING: FIRST # OF SECOND LINE OF *.INT FILE (NV)'
     1/,'DIFFERS FROM # OF MATRIX ELEMENTS READ IN (INV)',
     1/,'IN,INV = ',2I5)


      KVMIN=KV(1,1)
      DO 511 I=1,INV
      DO 511 J=1,4
 511  IF(KV(I,J).LT.KVMIN)KVMIN=KV(I,J)      
      TYPE *,KVMIN

      DO 512 I=1,INV
      DO 513 J=1,4
 513  KV(I,J) = KV(I,J) - KVMIN + 1
      TYPE *,I,(KV(I,J),J=1,4)
 512  CONTINUE

      DO 521 I=1,NUM_ORBITS
      DO 522 J=1,2
      NIN(J)=XL(1,INDJ(I))
      LIN(J)=XL(2,INDJ(I))
      JIN(J)=2.*XL(3,INDJ(I))
 522  CONTINUE
 521  WRITE(21,520)(NIN(J),LIN(J),JIN(J),J=1,2),ENL(I)
 520  FORMAT(6I4,36X,F16.8)

      DO 500 I = 1,INV

      DO J=1,4
      L=KV(I,J)
      NIN(J)=XL(1,INDJ(L))
      LIN(J)=XL(2,INDJ(L))
      JIN(J)=2.*XL(3,INDJ(L))
      END DO

      IF(KV(I,6).EQ.ITT) WRITE(21,501)
     1(NIN(J),LIN(J),JIN(J),J=1,4),(KV(I,J),J=5,6),KV(I,6),V(I)
501   FORMAT(15I4,F16.8)
500   CONTINUE

      STOP
      END


      SUBROUTINE SKIPHEAD(J)
      CHARACTER*1 A
      DIMENSION A(3)
100   READ(J,101) (A(I),I=1,3)
101   FORMAT(3A)
      DO 200 I = 1,3
200   IF(A(I).EQ.'!') GO TO 100
      BACKSPACE J
      RETURN
      END
