CBAB PROGRAM WHICH CONVERTS OXFORD SHELL MODEL *.INT FILES TO
CBAB MSU SHELL MODEL *.MIT FILES

CBAB THE *.MSP FILE CONTAINS A LIST OF IMSU,INDEX,IOX
CBAB IMSU IS THE LABEL NUMBER OF THE ORBIT IN THE MSU CODE
CBAB    IMSU MUST BE 1,2,3 ETC
CBAB INDEX IS THE LABEL OF THE ORBIT IN COMMON/INDEX/XL(3,200)
CBAB IOX IS THE ORDER OF THE LABELS IN THE OXFORD *.SPS FILE

      DIMENSION IK(1000),SPIK(1000),ISPS(1000),NEW(1000),NEWR(1000)
      DIMENSION INTL(6,1000),VINT(1000),SPE(20)
      COMMON/INDEXNEW/IM(20),IBAB(20),IOX(20),IMSP
      CHARACTER*9 FILI,FILO,FILMSP
      CALL INDEX
830   CONTINUE
      WRITE(6,220)
220   FORMAT(/,1X,'NAME FOR INPUT (.INT) FILE (A9) :')
      READ(5,221) FILI
      WRITE(6,222)
222   FORMAT(/,1X,'NAME FOR OUTPUT (.MIT) FILE (A9) (DEFALUT=INPUT) :')
      READ(5,221) FILO
221   FORMAT(A)
      IF(FILO.EQ.' ') FILO=FILI
      OPEN(UNIT=8,FILE='INT:'//FILI//'.INT',STATUS='OLD')
      OPEN(UNIT=9,FILE=FILO//'.MIT',STATUS='NEW',CARRIAGECONTROL='LIST')
      WRITE(6,223)
223   FORMAT(/,1X,'NAME FOR INPUT (.MSP) FILE (A9)')
      READ(5,221) FILMSP
      OPEN(UNIT=10,FILE='MSH:'//FILMSP//'.MSP',STATUS='OLD')
      I = 1
226   READ(10,225,END=227) IM(I),IBAB(I),IOX(I)
225   FORMAT(3I)
      I = I + 1
      GO TO 226
227   IMSP = I-1
      I = INDEXNEW(-1,0,0)
      J = 0
      READ(8,700) I1,I2,(SPE(IOX(I)),I=1,IMSP)

700   FORMAT(2I,20F)
600   CONTINUE
      READ(8,701,END=702)
     1 N1,L1,J1,N2,L2,J2,N3,L3,J3,N4,L4,J4,IJ,IT,Z
701   FORMAT(1X,14I4,F)
      J=J+1
      I1 = INDEXNEW(N1,L1,J1)
      I2 = INDEXNEW(N2,L2,J2)
      I3 = INDEXNEW(N3,L3,J3)
      I4 = INDEXNEW(N4,L4,J4)
      PH1 = 1.
      PH2 = 1.
      IF(I1.GT.I2) GO TO 750
      GO TO 751
750   CONTINUE
      IS = I1
      I1 = I2
      I2 = IS
      XJ1 = J1
      XJ1 = XJ1/2.
      XJ2 = J2
      XJ2 = XJ2/2.
      XJ = IJ
      XT = IT
      PH1 = PAR(XJ+XT-XJ1-XJ2)
751   CONTINUE
      IF(I3.GT.I4) GO TO 760
      GO TO 761
760   CONTINUE
      IS = I3
      I3 = I4
      I4 = IS
      XJ3 = J3
      XJ3 = XJ3/2.
      XJ4 = J4
      XJ4 = XJ4/2.
      XJ = IJ
      XT = IT
      PH2 = PAR(XJ+XT-XJ3-XJ4)
761   CONTINUE
      I12 = I2+I1*100
      I34 = I4+I3*100
      IF(I12.GT.I34) GO TO 710
      GO TO 711
710   CONTINUE
      IS1 = I3
      IS2 = I4
      I3 = I1
      I4 = I2
      I1 = IS1
      I2 = IS2
711   CONTINUE
      INTL(1,J) = I1
      INTL(2,J) = I2
      INTL(3,J) = I3
      INTL(4,J) = I4
      INTL(5,J) = IJ
      INTL(6,J) = IT
      VINT(J) = PH1*PH2*Z
      GO TO 600
702   CONTINUE
      INTMAX = J
      TYPE 300,INTMAX
300   FORMAT(' NUMBER OF 2-BODY MATRIX ELEMENTS =',I5)

C REORDER MATRIX ELEMENTS TO BE NUMERICALLY INCREASING
      DO 900 I = 1,INTMAX
      I1 = INTL(1,I)
      I2 = INTL(2,I)
      I3 = INTL(3,I)
      I4 = INTL(4,I)
      IJ = INTL(5,I)
      IT = INTL(6,I)
      IF(I1.GE.10) TYPE 940
      IF(I1.GE.10) STOP
      IF(I2.GE.10) TYPE 940
      IF(I2.GE.10) STOP
      IF(I3.GE.10) TYPE 940
      IF(I3.GE.10) STOP
      IF(I4.GE.10) TYPE 940
      IF(I4.GE.10) STOP
940   FORMAT(1X,'ERROR INDEX GE 10')
900   ISPS(I) = I1*1000000+I2*100000+I3*10000+I4*1000+IJ*10+IT
      DO 904 III = 1,INTMAX
      IIS = 0
      DO 901 I = 1,INTMAX
      IF(III.EQ.1) GO TO 902
      DO 903 J = 1,III-1
903   IF(I.EQ.NEWR(J)) GO TO 901
902   IF(ISPS(I).GT.IIS) INA = I
      IF(ISPS(I).GT.IIS) IIS = ISPS(I)
901   CONTINUE
      NEWR(III) = INA
904   CONTINUE
      DO 906 I = 1,INTMAX
906   NEW(I) = NEWR(INTMAX-I+1)

      WRITE(9,820) INTMAX,IMSP
820   FORMAT(' 21',7X,2I10)
      DO 810 J = 1,INTMAX
      JNEW = NEW(J)
      Z = VINT(JNEW)
      IJ = 2*INTL(5,JNEW)
      IT = 2*INTL(6,JNEW)
      I1 = INTL(1,JNEW)
      I2 = INTL(2,JNEW)
      I3 = INTL(3,JNEW)
      I4 = INTL(4,JNEW)
      WRITE(9,592) I1,I2,I3,I4,IJ,IT,Z
592   FORMAT(' 28',7X,6I5,F15.5)
810   CONTINUE
      WRITE(9,593) (SPE(I),I=1,IMSP)
593   FORMAT(' 52',7X,9F10.4)
      STOP
      END
      FUNCTION INDEXNEW(I1,I2,I3)
      COMMON/INDEXNEW/IM(20),IBAB(20),IOX(20),IMSP
      COMMON/INDEX/XL(3,200)
      DIMENSION N(200),L(200),J(200)
      IF(I1.EQ.-1) GO TO 300
      GO TO 200
300   DO 310 I = 1,IMSP
      N(IM(I)) = XL(1,IBAB(I))
      L(IM(I)) = XL(2,IBAB(I))
      J(IM(I)) = 2.*XL(3,IBAB(I))
310   CONTINUE
      INDEXNEW = 0
      RETURN 
200   CONTINUE
      DO 100 I = 1,IMSP
      IF(I1.EQ.N(I).AND.I2.EQ.L(I).AND.I3.EQ.J(I)) GO TO 120
100   CONTINUE
      TYPE 110
110   FORMAT(1X,'NO INDEX FOUND')
      RETURN
120   CONTINUE
      INDEXNEW = I
      RETURN
      END

