C
C
C  TO CALC 9J		1	2	3
C			4	5	6
C			7	8	9
C
C  SUM OVER RACAH'S
C
C
	FUNCTION COEF9(J1,J2,J3,J4,J5,J6,J7,J8,J9)
	DOUBLE PRECISION COEF9,W
	COEF9=0.0
	KMIN=MAX0(IABS(J1-J9),IABS(J4-J8),IABS(J2-J6))
	KMAX=MIN0(J1+J9,J4+J8,J2+J6)
	IF (KMIN.GT.KMAX) RETURN
	DO 100 K=KMIN,KMAX,2
	COEF9=COEF9+(K+1)
	1	*W(J1,J9,J4,J8,K,J7)
	2	*W(J2,J6,J8,J4,K,J5)
	3	*W(J1,J9,J2,J6,K,J3)
100	CONTINUE
	RETURN
	END
C
C
C  TO CALC W COEFFICIENT
C
	FUNCTION W(IA,IB,IC,ID,IE,IF)
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DIMENSION FACLOG(100),LT(6)
      EXP(X)=DEXP(X)                                                    WDMR0002
      SQRT(X)=DSQRT(X)                                                  WDMR0003
      ABS(X)=DABS(X)                                                    WDMR0004
	IF (ISETFC.GT.0) GO TO 10
	ISETFC=1
C
C  SET UP FACLOG
C
	FACLOG(1)=0.0
	FACLOG(2)=0.0
	FN=1.
	DO 5 N=3,100
	FN=FN+1.0D0
5	FACLOG(N)=FACLOG(N-1)+DLOG(FN)
10    K1=IA+IB-IE                                                       ABPA2315
      K3=IC+ID-IE                                                       ABPA2316
      K5=IA+IC-IF                                                       ABPA2317
      K7=IB+ID-IF                                                       ABPA2318
      K2=IE-IABS(IA-IB)                                                 ABPA2319
      K4=IE-IABS(IC-ID)                                                 ABPA2320
      K6=IF-IABS(IA-IC)                                                 ABPA2321
      K8=IF-IABS(IB-ID)                                                 ABPA2322
      K9=MIN0(K1,K2,K3,K4,K5,K6,K7,K8)                                  ABPA2323
      W=0.0                                                             ABPA2324
      IF (K9) 4000,20,20                                                ABPA2325
   20 K2=K1-2*(K1/2)                                                    ABPA2326
      K4=K3-2*(K3/2)                                                    ABPA2327
      K6=K5-2*(K5/2)                                                    ABPA2328
      K8=K7-2*(K7/2)                                                    ABPA2329
      IF(MAX0(K2,K4,K6,K8)) 4000,25,4000                                ABPA2330
   25 LTMIN=MIN0(IA,IB,IC,ID,IE,IF)                                     ABPA2331
      IF(LTMIN) 4000,30,150                                             ABPA2332
   30 LT(1)=IA                                                          ABPA2333
      LT(2)=IB                                                          ABPA2334
      LT(3)=IC                                                          ABPA2335
      LT(4)=ID                                                          ABPA2336
      LT(5)=IE                                                          ABPA2337
      LT(6)=IF                                                          ABPA2338
      LTMIN=LT(1)                                                       ABPA2339
      KMIN=1                                                            ABPA2340
      DO 40 N=2,6                                                       ABPA2341
      IF(LT(N)-LTMIN)35,40,40                                           ABPA2342
   35 LTMIN=LT(N)                                                       ABPA2343
      KMIN=N                                                            ABPA2344
   40 CONTINUE                                                          ABPA2345
      S1=1.0                                                            ABPA2346
      F1=IE                                                             ABPA2347
      F2=IF                                                             ABPA2348
      GO TO (55,55,55,55,45,50),KMIN                                    ABPA2349
   45 F1=IA                                                             ABPA2350
      F2=IC                                                             ABPA2351
      S1=1-2*MOD(K5/2,2)                                                ABPA2352
      GO TO 55                                                          ABPA2353
   50 F1=IA                                                             ABPA2354
      F2=IB                                                             ABPA2355
      S1=1-2*MOD(K1/2,2)                                                ABPA2356
   55 W=S1/ SQRT((F1+1.  )*(F2+1.  ))                                   ABPA2357
      GO TO 4000                                                        ABPA2358
  150 IABEP=(IA+IB+IE)/2+1                                              ABPA2359
      ICDEP=(IC+ID+IE)/2+1                                              ABPA2360
      IACFP=(IA+IC+IF)/2+1                                              ABPA2361
      IBDFP=(IB+ID+IF)/2+1                                              ABPA2362
      IABE=IABEP-IE                                                     ABPA2363
      IEAB=IABEP-IB                                                     ABPA2364
      IBEA=IABEP-IA                                                     ABPA2365
      ICDE=ICDEP-IE                                                     ABPA2366
      IECD=ICDEP-ID                                                     ABPA2367
      IDEC=ICDEP-IC                                                     ABPA2368
      IACF=IACFP-IF                                                     ABPA2369
      IFAC=IACFP-IC                                                     ABPA2370
      ICFA=IACFP-IA                                                     ABPA2371
      IBDF=IBDFP-IF                                                     ABPA2372
      IFBD=IBDFP-ID                                                     ABPA2373
      IDFB=IBDFP-IB                                                     ABPA2374
      NZMAX=MIN0(IABE,ICDE,IACF,IBDF)                                   ABPA2375
      IABCD1=(IA+IB+IC+ID+4)/2                                          ABPA2376
      IEFMAD=(IE+IF-IA-ID)/2                                            ABPA2377
      IEFMBC=(IE+IF-IB-IC)/2                                            ABPA2378
      NZMI1=-IEFMAD                                                     ABPA2379
      NZMI2=-IEFMBC                                                     ABPA2380
      NZMIN=MAX0(0,NZMI1,NZMI2)+1                                       ABPA2381
      SQLOG=0.5  *(FACLOG(IABE)+FACLOG(IEAB)+FACLOG(IBEA)+FACLOG(ICDE)  ABPA2382
     1          +FACLOG(IECD)+FACLOG(IDEC)+FACLOG(IACF)+FACLOG(IFAC)    ABPA2383
     2          +FACLOG(ICFA)+FACLOG(IBDF)+FACLOG(IFBD)+FACLOG(IDFB)    ABPA2384
     3 -FACLOG(IABEP+1)-FACLOG(ICDEP+1)-FACLOG(IACFP+1)-FACLOG(IBDFP+1))ABPA2385
      DO 200 NZ=NZMIN,NZMAX                                             ABPA2386
      NZM1=NZ-1                                                         ABPA2387
      S1=1-2*MOD(NZM1,2)                                                ABPA2388
      K1=IABCD1-NZM1                                                    ABPA2389
      K2=IABE-NZM1                                                      ABPA2390
      K3=ICDE-NZM1                                                      ABPA2391
      K4=IACF-NZM1                                                      ABPA2392
      K5=IBDF-NZM1                                                      ABPA2393
      K6=NZ                                                             ABPA2394
      K7=IEFMAD+NZ                                                      ABPA2395
      K8=IEFMBC+NZ                                                      ABPA2396
      SSLOG=SQLOG+FACLOG(K1)-FACLOG(K2)-FACLOG(K3)-FACLOG(K4)           ABPA2397
     1           -FACLOG(K5)-FACLOG(K6)-FACLOG(K7)-FACLOG(K8)           ABPA2398
      SSTERM=S1* EXP(SSLOG)                                             ABPA2399
      W=W+SSTERM                                                        ABPA2400
  200 CONTINUE                                                          ABPA2401
      IF( ABS(W).LT.1.0E-10 ) W=0.0                                     ABPA2402
 4000 RETURN                                                            ABPA2403
      END                                                               ABPA2404
