C  **** Program to generate SPS files.
C  **** E. Ormand Jan 1988
      REAL*4 XL
      dimension ind(2,200),num_orb(200),nump_orb(200),numn_orb(200)
      CHARACTER*9 OUTNAME
      CHARACTER LABEL*1,ans*2,shell(200)*9,COMMENT*70
      COMMON/CLABEL/LABEL(30)
      COMMON/INDEX/XL(3,200)
      CALL INDEX
      DO I=1,200
      SHELL(I)='         '
      END DO
      type *,'Enter output file name'
      read(5,'(a)')outname
      open(unit=10,name=outname//'.sps',status='new')
      N=15
      DO I=1,N
      IND1=XL(2,I)+1
      IND2=XL(2,I+N)+1
      IN1=XL(1,I)
      IN2=XL(1,I+N)
      JAY1=2*XL(3,I)
      JAY2=2*XL(3,I+N)
C create the labels SHELL for each orbit. eq. 1S1/2
      if(in1.lt.10)then
      write(shell(i)(1:1),'(i1)')in1
      shell(i)(2:2)=label(ind1)
      if(jay1.lt.10)then
      write(shell(i)(3:3),'(i1)')jay1
      shell(i)(4:5)='/2'
      else
      write(shell(i)(3:4),'(i2)')jay1
      shell(i)(5:6)='/2'
      end if
      else
      write(shell(i)(1:2),'(i2)')in1
      shell(i)(3:3)=label(ind1)
      if(jay1.lt.10)then
      write(shell(i)(4:4),'(i1)')jay1
      shell(i)(5:6)='/2'
      else
      write(shell(i)(4:5),'(i2)')jay1
      shell(i)(6:7)='/2'
      end if
      end if
      if(in2.lt.10)then
      write(shell(i+N)(1:1),'(i1)')in2
      shell(i+N)(2:2)=label(ind2)
      if(jay2.lt.10)then
      write(shell(i+N)(3:3),'(i1)')jay2
      shell(i+N)(4:5)='/2'
      else
      write(shell(i+N)(3:4),'(i2)')jay2
      shell(i+N)(5:6)='/2'
      end if
      else
      write(shell(i+N)(1:2),'(i2)')in2
      shell(i+N)(3:3)=label(ind2)
      if(jay2.lt.10)then
      write(shell(i+N)(4:4),'(i1)')jay2
      shell(i+N)(5:6)='/2'
      else
      write(shell(i+N)(4:5),'(i2)')jay2
      shell(i+N)(6:7)='/2'
      end if
      end if
      WRITE(6,10010)I,shell(I),(I+N),shell(i+N)
10010 format(1x,i5,1x,a9,1x,i5,1x,a9)
      END DO
      type *,'Isospin or proton neutron formalism?(PN/IS)'
      read(5,'(a)')ans
      if(ans.eq.'PN'.or.ans.eq.'pn')goto 200
C   Isospin formalism
      type *, 'How many orbits?'
      accept *,num
      type *,'Enter orbit numbers'
      accept *,(ind(1,i),i=1,num)
      TYPE *,'IA,IZ for core'
      accept *,IA,IZ
      numpart=0
      iosc=1
      do i=1,num
      numpart=numpart+2*(2*xl(3,ind(1,i))+1)
      num_orb(i)=2*(2*xl(3,ind(1,i))+1)
      end do
      TYPE *,'ENTER A COMMENT LINE'
      READ(5,'(A)')COMMENT
      WRITE(10,'(''!'',A)')COMMENT
      if(num.le.18) write(10,500)
     1 numpart,num,(num_orb(i),i=1,num),iosc,num,ia,iz
500   format(2i5,<num>i3,4i5)

      if(num.gt.18) write(10,501)
     1 numpart,num,(num_orb(i),i=1,18)
501   format(2i5,<18>i3,'-')

      if(num.gt.18) write(10,502)
     1(num_orb(i),i=13,num),iosc,num,ia,iz
502   format(<num-18>i3,4i5)

      if(num.le.18) WRITE(10,503) (SHELL(IND(1,I)),I=1,NUM)
503   format(1X,18(A6,1X))

      if(num.gt.18) WRITE(10,504) (SHELL(IND(1,I)),I=1,18)
504   format(1X,18(A6,1X),'-')

      if(num.gt.18) 
     1 WRITE(10,505) (SHELL(IND(1,I)),I=11,NUM)
505   format(1X,18(A6,1X))

C      if(num.ge.24) 
C     1 WRITE(10,506) (SHELL(IND(1,I)),I=11,20)
C506   format(1X,12(A8,1X),'-')

C      if(num.ge.24) 
C     1 WRITE(10,507) (SHELL(IND(1,I)),I=21,num)
C507   format(1X,12(A8,1X))
      j=1
      itz1=-1
      itZ2=1
      do i=1,num
      in=ind(1,i)
      mdeg=2*xl(3,in)+1
      n=xl(1,in)
      l=xl(2,in)
      jay=2*xl(3,in)
      do k=1,mdeg
      write(10,'(8i5)')j,n,l,jay,(2*(k-1)-jay),itz1
      write(10,'(8i5)')j,n,l,jay,(2*(k-1)-jay),itz2
      j=j+1
      end do
      end do
      GOTO 2000
200   CONTINUE
C  Proton formalism
      type *, 'How many proton and neutron orbits?'
      accept *,nump,numn
      type *,'Enter proton orbit numbers'
      accept *,(ind(1,i),i=1,nump)
      type *,'Enter neutron orbit numbers'
      accept *,(ind(2,i),i=1,numn)
      numpart=0
      iosc=2
      do i=1,nump
      numpart=numpart+(2*xl(3,ind(1,i))+1)
      nump_orb(i)=(2*xl(3,ind(1,i))+1)
      end do
      do i=1,numn
      numpart=numpart+(2*xl(3,ind(2,i))+1)
      numn_orb(i)=(2*xl(3,ind(2,i))+1)
      end do
      TYPE *,'ENTER A COMMENT LINE'
      READ(5,'(A)')COMMENT
      WRITE(10,'(''!'',A)')COMMENT
      if(nump+numn.lt.15)then
      write(10,'(2i5,<numP>i5,<numN>i5,3i5)')
     1numpart,(nump+numn),(nump_orb(i),i=1,nump),(numn_orb(i),i=1,numn),
     1iosc,nump,numn
      WRITE(10,'(1X,<nump>(''P'',A9,1x),<numn>(''N'',A9,1X))')
     1(SHELL(IND(1,I)),I=1,NUMp),(SHELL(IND(2,I)),I=1,NUMN)
      endif
      if(nump+numn.ge.15)then
      write(10,'(2i4,<numP>i4,'' - '',/,8x,<numN>i4,3i4)')
     1numpart,(nump+numn),(nump_orb(i),i=1,nump),(numn_orb(i),i=1,numn),
     1iosc,nump,numn
      WRITE(10,'(1X,<nump>(''P'',A6,1x),'' - ''/,1x,
     1<numn>(''N'',A6,1X))')
     2(SHELL(IND(1,I)),I=1,NUMp),(SHELL(IND(2,I)),I=1,NUMN)
      endif
      j=1
      itz1=-1
      itZ2=1
      do i=1,nump
      in=ind(1,i)
      mdeg=2*xl(3,in)+1
      n=xl(1,in)
      l=xl(2,in)
      jay=2*xl(3,in)
      do k=1,mdeg
      write(10,'(8i5)')j,n,l,jay,(2*(k-1)-jay),itz1
      j=j+1
      end do
      end do
      do i=1,numn
      in=ind(2,i)
      mdeg=2*xl(3,in)+1
      n=xl(1,in)
      l=xl(2,in)
      jay=2*xl(3,in)
      do k=1,mdeg
      write(10,'(8i5)')j,n,l,jay,(2*(k-1)-jay),itz2
      j=j+1
      end do
      end do
2000  END
