c***********************************************************************
c
c       This is the new PV function fro the WS orbits. It use the old
c       PV function from pvg program in the OXBASH code which was
c       renamed as PVOLD.
c
c       !!!  For the description of the common see PRGM.FOR  !!!
c
c***********************************************************************
 
        function pv(i1,i2,i3,i4,ij,it,itp)
        common /npnc/kws,ios,iox(50),iows(10),ihws(10),ews(8),coef(8,50)
 
        in1=ihws(i1)
        in2=ihws(i2)
        in3=ihws(i3)
        in4=ihws(i4)
 
c       write(*,*)'pv',i1,i2,i3,i4
c       write(*,*)'pv',in1,in2,in3,in4
 
        s=0.0
        k=0
        do 1 k1=1,ios
        do 1 k2=1,ios
        do 1 k3=1,ios
        do 1 k4=1,ios
        c1=coef(in1,k1)
        c2=coef(in2,k2)
        c3=coef(in3,k3)
        c4=coef(in4,k4)
        if(c1.eq.0.0.or.c2.eq.0.0.or.c3.eq.0.0.or.c4.eq.0.0)go to 1
        k=k+1
        ih1=iox(k1)
        ih2=iox(k2)
        ih3=iox(k3)
        ih4=iox(k4)
        pvo=pvold(ih1,ih2,ih3,ih4,ij,it,itp)
        s=s+c1*c2*c3*c4*pvo
c       write(*,*)k,ih1,ih2,ih3,ih4
c       write(*,*)k,pvo,s
1       continue
 
        write(*,*)'kf',k
        pv=s
 
        return
        end
 
 
 
      FUNCTION PVOLD(I1,I2,I3,I4,IJ,IT,ITP)
      DIMENSION KNS(140),KLS(140),KNC(140),KLC(140)
      DIMENSION KNSP(140),KLSP(140),KNCP(140),KLCP(140)
      DIMENSION AFC(40)
      DIMENSION RSGN(60)
CBAB      DIMENSION FLAB(600),FREL(5200),FBKT(5200),IFROM(600)
 
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CPV/ISYMT,ISYMS,IRAD,CONST,XUM,ISC,HBW
      COMMON/INDEX/XL(3,200)
CBAB      COMMON  AFC    , RSGN   , FLAB   , FREL   , FBKT   , IFROM
CBAB      COMMON  ITAL
 
      IF(INEWINT.EQ.0) GO TO 948
 
      CLOSE(UNIT=8)
CBAB      OPEN(UNIT=8,FILE='MO.DAT',STATUS='OLD')
CBAB      OPEN(UNIT=8,FILE='MBKT.DAT',STATUS='OLD')
CBAB      CALL READM(FLAB,FREL,FBKT,IFROM,ITAL)
      CALL ETBME(0,0,0)
      CALL ZERORAD
      WRITE(6,610)
      WRITE(11,610)
610   FORMAT(
     1/,1X,'THIS IS THE PNC INTERACTION IN THE
     1 FORM GIVEN BY DESPLANQUES-DONOHUE-HOLSTEIN',
     1/,1X,'EXCEPT FOR A FACTOR (-i)',
     1/,1X,'PNC(r) = CONST SYM(ISYMT,TAU1,TAU2) SYM(ISYMS,SIG1,SIG2).
     1DOT.RADINT',
     1/,1X
     1/,1X,'WHERE "CONST" IS A CONSTANT ( e.g. 2.2E-06 FOR THE OPEP)',
     1/,1X,
     1/,1X,'RADINT = 41.465*<[DEL,G(ABS(XUM),r))]> FOR "PV"'
     1/,1X,'RADINT = 41.465*<{DEL,G(ABS(XUM),r))}> FOR "PVA"'
     1/,1X,
     1/,1X,'WHERE G(X,r) = exp(-X*r)/(4*pi*r)  AND DEL IS THE GRADIENT
     1 OPERATOR',
     1/,1X,'41.465 = hbar*hbar*c*c/(proton-mass*c*c)
     1 AND X = meson-mass*c*c/(hbar*c)',
     1/,1X,
     1/,1X,'HBW IS THE NUCLEAR OSCILLATOR CONSTANT (THE RELATIVE
     1 OSC CONSTANT IS HBW/2.)',
     1/,1X,
     1/,1X,'ISC = (0/1) = (WITHOUT/WITH) SRC (SHORT RANGE CORRELATIONS)',
     1/,1X,'WHERE  SRC = 1.-[EXP(-1.1*XR*XR)*(1.-0.68*XR*XR)]')
      WRITE(6,220)
      WRITE(11,220)
220   FORMAT(/,1X,'CONST,ISYMT,ISYMS,XUM,ISC,HBW')
      READ(5,221) CONST,ISYMT,ISYMS,XUM,ISC,HBW
221   FORMAT(F,2I,F,I,F)
      WRITE(*,223) CONST,ISYMT,ISYMS,XUM,ISC,HBW
      WRITE(11,223) CONST,ISYMT,ISYMS,XUM,ISC,HBW
223   FORMAT(/,1X,'INPUT = ',F10.5,2X,2I4,F10.5,I2,F10.5)
CBAB      CALL RADRD
      INEWINT = 0
948   CONTINUE
      PV = 0.
c       write(*,*)i1,i2,i3,i4,ij,it,itp
      IF(ETBME(IT,ITP,ISYMT).EQ.0.) RETURN
      XTTT = ETBME(IT,ITP,ISYMT)
c       write(*,*)'pvold',xttt
      LAMDA = 1
      XLAMDA = LAMDA
 
      IJP = IJ
      XJ = IJ
      XJP = IJP
      J = 2*IJ
      JP = 2*IJP
      XN1 = XL(1,I1)-1.
      XN2 = XL(1,I2)-1.
      XN3 = XL(1,I3)-1.
      XN4 = XL(1,I4)-1.
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XL3 = XL(2,I3)
      XL4 = XL(2,I4)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      N1 = XN1
      N2 = XN2
      N3 = XN3
      N4 = XN4
      L1 = 2.*XL1
      L2 = 2.*XL2
      L3 = 2.*XL3
      L4 = 2.*XL4
      J1 = 2.*XJ1
      J2 = 2.*XJ2
      J3 = 2.*XJ3
      J4 = 2.*XJ4
      LL1 = XL1
      LL2 = XL2
      LL3 = XL3
      LL4 = XL4
      S = 0.
      IF(ITR(J1,J2,J)) 801,801,802
802   IF(ITR(J3,J4,JP)) 801,801,803
803   CONTINUE
      ISMIN = 1
      ISMAX = 2
      ILMIN = IABS(LL1-LL2) + 1
      ILMAX = LL1 + LL2 + 1
      ILPMIN = IABS(LL3-LL4) + 1
      ILPMAX = LL3 + LL4 + 1
      DO 200 IL = ILMIN,ILMAX
      DO 200 ILP = ILPMIN,ILPMAX
      DO 200 IS = ISMIN,ISMAX
      DO 200 ISP = ISMIN,ISMAX
      XIL = IL-1
      XILP = ILP-1
      XS = IS-1
      XSP = ISP-1
      JL = 2*IL-2
      JLP = 2*ILP-2
      JS = 2*IS-2
      JSP = 2*ISP-2
      XC = SQRT((2.*XJ1+1.)*(2.*XJ2+1.)*(2.*XJ3+1.)*(2.*XJ4+1.))
      XC = XC/SQRT((2.*XJ+1.)*(2.*XJP+1.))
CBAB203   IF(IJ-IJP) 201,204,201
204   IF(ITR(JL,JS,J)) 201,201,205
205   IF(ITR(JLP,JSP,JP)) 201,201,206
206   CONTINUE
208   CONTINUE
      IIS = XS
      IISP = XSP
      X12 = ETBME(IIS,IISP,ISYMS)
      IF(X12.EQ.0.) GO TO 201
      X1 = SJ(XIL,XS,XJ,XSP,XILP,1.)
      X1 = X1*PAR(XS+XJ+XILP)
      X11= X1*SQRT(2.*XJ+1.)
      X = XNIN(L1,1,J1,L2,1,J2,JL,JS,J)
      X = X*XNIN(L3,1,J3,L4,1,J4,JLP,JSP,JP)
      X = X*X11*X12
      SS = 0.
      ILM1=IL-1
      ILPM1=ILP-1
CBAB      CALL CMSUM(N1,LL1,N2,LL2,ILM1,NUM,KNS,KLS,KNC,KLC)
CBAB      CALL CMSUM(N3,LL3,N4,LL4,ILPM1,NUMP,KNSP,KLSP,KNCP,KLCP)
      CALL MOSHQN(N1,LL1,N2,LL2,ILM1,KNS,KLS,KNC,KLC,NUM)
      CALL MOSHQN(N3,LL3,N4,LL4,ILPM1,KNSP,KLSP,KNCP,KLCP,NUMP)
      DO 300 I = 1,NUM
      DO 300 IP = 1,NUMP
      IF(ITR(KLS(I),KLSP(IP),LAMDA)) 301,301,303
303   IF(KLC(I)-KLCP(IP)) 301,304,301
304   CONTINUE
305   IF(KNC(I)-KNCP(IP)) 301,306,301
306   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
CBAB      IF(TR(XKLS,XKLSP,1.)) 301,301,307
CBAB307   CONTINUE
CBAB      CALL MOSHIN(KNS(I),KLS(I),KNC(I),KLC(I),N1,LL1,N2,LL2,ILM1,BKT)
CBAB      CALL MOSHIN(KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP)
CBAB     1,N3,LL3,N4,LL4,ILPM1,BKTP)
      BKT = BMOSH(N1,LL1,N2,LL2,ILM1,KNS(I),KLS(I),KNC(I),KLC(I))
      BKTP = BMOSH(N3,LL3,N4,LL4,ILPM1,
     1KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP))
C      type 7777,kns(i)+1,kls(i),knsp(ip)+1,klsp(ip)
C7777  format(1x,4i4)
      XXX = FRAD(KNS(I)+1,KLS(I)+1,KNSP(IP)+1,KLSP(IP)+1)
      IF(XXX) 901,900,901
900   WRITE(6,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
      WRITE(11,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
902   FORMAT(1X,'MISSING RADIAL INTEGRAL'5I5)
901   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
      XKLC = KLC(I)
      X11 = PAR(XKLS+XKLC+XILP+XLAMDA)
      X11 = X11*SJ(XKLS,XIL,XKLC,XILP,XKLSP,XLAMDA)
      X11 = X11*SQRT((2.*XIL+1.)*(2.*XILP+1.))
      XX = XXX*BKT*BKTP
      XX = XX*X11
      SS = SS + XX
301   CONTINUE
300   CONTINUE
      S = S + SS*X
201   CONTINUE
200   CONTINUE
      S = S*XC
801   CONTINUE
CBAB      PV = S*CONST*XTTT/1000.
 
CMH      PV = S*CONST*XTTT
 
      PVOLD = S*CONST*XTTT
      RETURN
      END
 
      SUBROUTINE LISTRAD
      COMMON/RAD/RAD(10,10,10,10)
      WRITE(6,100)
      WRITE(11,100)
100   FORMAT(/,1X,'  N1  L1  N2  L2   RADINT
     1 LIST OF RADIAL INTEGRALS USED',/)
      DO 200 KN1 = 1,10
      DO 200 KL1 = 1,10
      DO 200 KN2 = 1,10
      DO 200 KL2 = 1,10
      X = RAD(KN1,KL1,KN2,KL2)
      IF(X.EQ.0.) GO TO 200
      N1 = KN1
      N2 = KN2
      L1 = KL1-1
      L2 = KL2-1
      WRITE(6,300) N1,L1,N2,L2,X
      WRITE(11,300) N1,L1,N2,L2,X
300   FORMAT(1X,4I4,F10.5)
200   CONTINUE
      RETURN
      END
 
      SUBROUTINE ZERORAD
      COMMON/RAD/RAD(10,10,10,10)
      DO 510 I = 1,10
      DO 510 J = 1,10
      DO 510 K = 1,10
      DO 510 L = 1,10
510   RAD(I,J,K,L) = 0.
      RETURN
      END
 
      FUNCTION FRAD(KN1,KL1,KN2,KL2)
      CHARACTER*4 KEY
      COMMON/KEY/KEY
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CPV/ISYMT,ISYMS,IRAD,CONST,XUM,ISC,HBW
      COMMON/RAD/RAD(10,10,10,10)
      FRAD = RAD(KN1,KL1,KN2,KL2)
      IF(FRAD.NE.0.) RETURN
      N1 = KN1-1
      N2 = KN2-1
      L1 = KL1-1
      L2 = KL2-1
      I1 = ISEEK_INDEX(N1+1,L1)
      I2 = ISEEK_INDEX(N2+1,L2)
      IF(KEY.EQ.'PNC')X=FRPI(I1,I2,ABS(XUM),ISC,HBW/2.,XNORM1,XNORM2)
      IF(KEY.EQ.'PNA')X=AFRPI(I1,I2,ABS(XUM),ISC,HBW/2.,XNORM1,XNORM2)
      IF(KEY.EQ.'MEX')X=RMEEX(I1,I2,ABS(XUM),ISC,HBW/2.,XNORM1,XNORM2)
      RAD(KN1,KL1,KN2,KL2) = X/SQRT(XNORM1*XNORM2)
      FRAD = RAD(KN1,KL1,KN2,KL2)
      RETURN
      END
 
      FUNCTION ISEEK_INDEX(N,L)
      COMMON/INDEX/XL(3,200)
      XN = N
      XLL = L
      DO 100 I = 1,200
      IF(XN.EQ.XL(1,I).AND.XLL.EQ.XL(2,I)) GO TO 200
100   CONTINUE
      WRITE(6,300) N,L
      WRITE(11,300) N,L
300   FORMAT(/,1X,'INDEX NOT FOUND FOR N,L = ',2I3)
      STOP
200   ISEEK_INDEX = I
      RETURN
      END
 
      FUNCTION ETBME(I1,I2,ISYM)
      ETBME = 0.
      IF(ISYM.LT.0) GO TO 100
      IF(ISYM.GT.6) GO TO 100
      IF(ISYM.GT.0) GO TO 120
      WRITE(6,500)
      WRITE(11,500)
500   FORMAT(
     1/,1X,
     1/,1X,'      SYM(X1,X2,1) =  (X1  PLUS X2)^1',
     1/,1X,'      SYM(X1,X2,2) =  (X1 MINUS X2)^1',
     1/,1X,'      SYM(X1,X2,3) = i(X1 CROSS X2)^1',
     1/,1X,'      SYM(X1,X2,4) =  (X1   DOT X2)^0',
     1/,1X,'      SYM(X1,X2,5) = 1               ',
     1/,1X,'      SYM(X1,X2,6) =  (X1 CROSS X2)^2',
     1/,1X)
      RETURN
100   CONTINUE
      WRITE(6,110) ISYM
      WRITE(11,110) ISYM
110   FORMAT(1X,'ILLEGAL VALUE FOR ISYM',I5)
      RETURN
120   CONTINUE
      GO TO (10,20,30,40,50,60),ISYM
10    IF(I1.EQ.1.AND.I2.EQ.1) GO TO 11
      RETURN
11    ETBME = 2.*SQRT(6.)
      RETURN
20    IF(IABS(I1-I2).EQ.1) GO TO 21
      RETURN
21    X = I2
      ETBME = PAR(X)*2.*SQRT(3.)
      RETURN
30    IF(IABS(I1-I2).EQ.1) GO TO 31
      RETURN
31    ETBME = 2.*SQRT(3.)
      RETURN
40    IF(IABS(I1-I2).EQ.0) GO TO 41
      RETURN
41    IF(I1.EQ.0) ETBME = -3.
      IF(I1.EQ.1) ETBME = SQRT(3.)
      RETURN
50    IF(IABS(I1-I2).EQ.0) GO TO 51
      RETURN
51    X = I1
      ETBME = SQRT(2.*X+1.)
      RETURN
60    IF(I1.EQ.1.AND.I2.EQ.1) GO TO 61
      RETURN
61    ETBME = 2.*SQRT(5.)
      RETURN
      END
      FUNCTION XNIN(I1,I2,I3,I4,I5,I6,I7,I8,I9)
      X1 = I1
      X2 = I2
      X3 = I3
      X4 = I4
      X5 = I5
      X6 = I6
      X7 = I7
      X8 = I8
      X9 = I9
      X1 = X1/2.
      X2 = X2/2.
      X3 = X3/2.
      X4 = X4/2.
      X5 = X5/2.
      X6 = X6/2.
      X7 = X7/2.
      X8 = X8/2.
      X9 = X9/2.
      XI7=I7
      XI8=I8
      XI9=I9
      XNIN=SQRT((XI7+1.)*(XI8+1.)*(XI9+1.))
     1*QJ(X1,X2,X3,X4,X5,X6,X7,X8,X9)
      RETURN
      END
      FUNCTION XMEEX(I1,I2,I3,I4,IJ12,IJ34,IT,ITP)
      DIMENSION KNS(140),KLS(140),KNC(140),KLC(140)
      DIMENSION KNSP(140),KLSP(140),KNCP(140),KLCP(140)
      DIMENSION AFC(40)
      DIMENSION RSGN(60)
CBAB      DIMENSION FLAB(600),FREL(5200),FBKT(5200),IFROM(600)
      COMMON/MAIN/IDJ,IDT,IDP,INEWINT
      COMMON/CPV/ISYMT,ISYMS,IRAD,CONST,XUM,ISC,HBW
      COMMON/INDEX/XL(3,200)
CBAB      COMMON  AFC    , RSGN   , FLAB   , FREL   , FBKT   , IFROM
CBAB      COMMON  ITAL
 
      IF(INEWINT.EQ.0) GO TO 948
 
      CLOSE(UNIT=8)
CBAB      OPEN(UNIT=8,FILE='MO.DAT',STATUS='OLD')
CBAB      OPEN(UNIT=8,FILE='MBKT.DAT',STATUS='OLD')
CBAB      CALL READM(FLAB,FREL,FBKT,IFROM,ITAL)
      CALL ETBME(0,0,0)
      CALL ZERORAD
      WRITE(6,220)
      WRITE(11,220)
220   FORMAT(/,1X,'C,ISYMT,ISYMS,XUM,ISC,HBW')
      READ(5,221) CONST,ISYMT,ISYMS,XUM,ISC,HBW
221   FORMAT(F,2I,F,I,F)
      WRITE(11,223) CONST,ISYMT,ISYMS,XUM,ISC,HBW
223   FORMAT(/,1X,'INPUT = ',F10.5,2X,2I4,F10.5,I2,F10.5)
      INEWINT = 0
948   CONTINUE
      XMEEX = 0.
CBAB      IF(ETBME(IT,ITP,ISYMT).EQ.0.) RETURN
CBAB      XTTT = ETBME(IT,ITP,ISYMT)
      XTTT = 1.
      LAMDA = 0
      XLAMDA = LAMDA
 
      IJ = IJ12
      IJP = IJ34
      XJ = IJ12
      XJP = IJP
      J = 2*IJ
      JP = 2*IJP
      XN1 = XL(1,I1)-1.
      XN2 = XL(1,I2)-1.
      XN3 = XL(1,I3)-1.
      XN4 = XL(1,I4)-1.
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XL3 = XL(2,I3)
      XL4 = XL(2,I4)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      XJ3 = XL(3,I3)
      XJ4 = XL(3,I4)
      N1 = XN1
      N2 = XN2
      N3 = XN3
      N4 = XN4
      L1 = 2.*XL1
      L2 = 2.*XL2
      L3 = 2.*XL3
      L4 = 2.*XL4
      J1 = 2.*XJ1
      J2 = 2.*XJ2
      J3 = 2.*XJ3
      J4 = 2.*XJ4
      LL1 = XL1
      LL2 = XL2
      LL3 = XL3
      LL4 = XL4
      S = 0.
      IF(ITR(J1,J2,J)) 801,801,802
802   IF(ITR(J3,J4,JP)) 801,801,803
803   CONTINUE
      ISMIN = 1
      ISMAX = 2
      ILMIN = IABS(LL1-LL2) + 1
      ILMAX = LL1 + LL2 + 1
      ILPMIN = IABS(LL3-LL4) + 1
      ILPMAX = LL3 + LL4 + 1
      DO 200 IL = ILMIN,ILMAX
      DO 200 ILP = ILPMIN,ILPMAX
      DO 200 IS = ISMIN,ISMAX
      DO 200 ISP = ISMIN,ISMAX
      XIL = IL-1
      XILP = ILP-1
      XS = IS-1
      XSP = ISP-1
      JL = 2*IL-2
      JLP = 2*ILP-2
      JS = 2*IS-2
      JSP = 2*ISP-2
      XC = SQRT((2.*XJ1+1.)*(2.*XJ2+1.)*(2.*XJ3+1.)*(2.*XJ4+1.))
      XC = XC/SQRT((2.*XJ+1.)*(2.*XJP+1.))
CBAB203   IF(ITR(J,JP,IDJ)) 201,201,204
204   IF(ITR(JL,JS,J)) 201,201,205
205   IF(ITR(JLP,JSP,JP)) 201,201,206
206   CONTINUE
208   CONTINUE
      IIS = XS
      IISP = XSP
CBAB      XX12 = ETBME(IIS,IISP,ISYMS)
      XX12 = ETBME(IIS,IISP,1)*ETBME(IT,ITP,1)
     1 + ETBME(IIS,IISP,2)*ETBME(IT,ITP,2)
     1 - 2.*ETBME(IIS,IISP,3)*ETBME(IT,ITP,3)
CBAB      XX12 = -2.*ETBME(IIS,IISP,3)*ETBME(IT,ITP,3)
      IF(XX12.EQ.0.) GO TO 201
 
      IF(IL.NE.ILP) GO TO 201
CBAB -----------------------------------
      X1 = SJ(XS,XSP,1.,XJP,XJ,XIL)
      X1 = X1*PAR(XILP+XSP+XJ+1.)
      XX11 = X1*SQRT((2.*XJ+1.)*(2.*XJP+1.))
CBAB -----------------------------------
 
 
      X = XNIN(L1,1,J1,L2,1,J2,JL,JS,J)
      XX3 = X*XNIN(L3,1,J3,L4,1,J4,JLP,JSP,JP)
      X = XX3*XX11*XX12
      IF(X.EQ.0.) GO TO 201
      SS = 0.
      ILM1=IL-1
      ILPM1=ILP-1
CBAB      CALL CMSUM(N1,LL1,N2,LL2,ILM1,NUM,KNS,KLS,KNC,KLC)
CBAB      CALL CMSUM(N3,LL3,N4,LL4,ILPM1,NUMP,KNSP,KLSP,KNCP,KLCP)
      CALL MOSHQN(N1,LL1,N2,LL2,ILM1,KNS,KLS,KNC,KLC,NUM)
      CALL MOSHQN(N3,LL3,N4,LL4,ILPM1,KNSP,KLSP,KNCP,KLCP,NUMP)
      DO 300 I = 1,NUM
      DO 300 IP = 1,NUMP
      IF(ITR(KLS(I),KLSP(IP),LAMDA)) 301,301,303
303   IF(KLC(I)-KLCP(IP)) 301,304,301
304   CONTINUE
305   IF(KNC(I)-KNCP(IP)) 301,306,301
306   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
CBAB      CALL MOSHIN(KNS(I),KLS(I),KNC(I),KLC(I),N1,LL1,N2,LL2,ILM1,BKT)
CBAB      CALL MOSHIN(KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP)
CBAB     1,N3,LL3,N4,LL4,ILPM1,BKTP)
      BKT = BMOSH(N1,LL1,N2,LL2,ILM1,KNS(I),KLS(I),KNC(I),KLC(I))
      BKTP = BMOSH(N3,LL3,N4,LL4,ILPM1,
     1KNSP(IP),KLSP(IP),KNCP(IP),KLCP(IP))
      XXX = FRAD(KNS(I)+1,KLS(I)+1,KNSP(IP)+1,KLSP(IP)+1)
      IF(XXX) 901,900,901
900   WRITE(6,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
      WRITE(11,902) KNS(I),KLS(I),KNSP(IP),KLSP(IP)
902   FORMAT(1X,'MISSING RADIAL INTEGRAL'5I5)
901   CONTINUE
      XKLS = KLS(I)
      XKLSP = KLSP(IP)
      XKLC = KLC(I)
 
CBAB --------------------------------------------------
CBAB      X11 = PAR(XKLS+XKLC+XILP+XLAMDA)
CBAB      X11 = X11*SJ(XKLS,XIL,XKLC,XILP,XKLSP,XLAMDA)
CBAB      X11 = X11*SQRT((2.*XIL+1.)*(2.*XILP+1.))
      X11 = 1.
CBAB --------------------------------------------------
 
      XX = X11*XXX*BKT*BKTP
CBAB      XX = XX*X11
      SS = SS + XX
CBAB      WRITE(6,7777) IS,ISP,IL,ILP,KNS(I)+1,KLS(I)+1,KNSP(IP)+1,
CBAB     1KLSP(IP)+1,XXX,BKT,BKTP,XX,SS
CBAB      WRITE(11,7777) IS,ISP,IL,ILP,KNS(I)+1,KLS(I)+1,KNSP(IP)+1,
CBAB     1KLSP(IP)+1,XXX,BKT,BKTP,XX,SS
CBAB7777  FORMAT(1X,8I3,5F10.5)
301   CONTINUE
300   CONTINUE
      S = S + SS*X
CBAB      WRITE(6,7778) IS,ISP,IL,ILP,XX11,XX12,XX3,X,S
CBAB      WRITE(11,7778) IS,ISP,IL,ILP,XX11,XX12,XX3,X,S
CBAB7778  FORMAT(1X,4I3,5F10.5)
201   CONTINUE
200   CONTINUE
      S = S*XC
801   CONTINUE
      XMEEX = S*CONST*XTTT
      RETURN
      END
 
