C              PROGRAM PRIORPROJ
CA  NOTATION:
CA  BAD STATE: M-SCHEME BASIS STATE WHICH IS EITHER NOT GOOD ENOUGH TO
CA             PROJECT FROM (SEE ABOVE LABEL 715) OR ONE THAT WAS TRIED
CA             AND FAILED TO PASS THE TESTS;
CA  GOOD STATE:M-SCHEME BASIS STATE USED TO PROJECT FROM, WHICH
cA  PROJECTION
CA             PJT|IBASIS(GOOD)> PASSED THE TESTS.


      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
      DIMENSION IDEORD(MAX_NPART),KLOOKP(MAX_NPART),
     1 MNFIL(MAX_NJL),MNOSC(MAX_NOSC),MXOSC(MAX_NOSC),NOSCJL(MAX_NOSC)
      DIMENSION FED_ARRAY(MAX_MSCHEME)
      DOUBLE PRECISION RANV
      DIMENSION RANV(MAX_MSCHEME)
CBAB      COMMON/READ/NJTA(3,3)
      COMMON/READ/NJTA(NO_JVAL,NO_TVAL)
      LOGICAL BADSTATE,EXISTE
      INCLUDE 'SHEXE:DATA.INC'
CBAB THESE NEXT TWO LINES MUST BE USED FOR SINGLE PRRECISION
CBAB      DABS(X) = ABS(X)
CBAB      DSQRT(X) = SQRT(X)


      IPSF(J,I)=(J-1)*J/2+I    !to address a lower triangular matrix
      IPRC(I,J)=IPSF(J,I)      !to address an upper triangular matrix

      CALL TEST_BATCH(ILOG)
      HANDLE=0
      IF(.NOT.LIB$INIT_TIMER(HANDLE))GO TO 7790

CA  TIMING PERFORMACE OF PROJ WILL STRONGLY DEPEND ON THE BELOW
CA  WRITTEN LIMITS
CA  IT IS RECOMMENDED FOR A LONG SET OF SIMILAR CALCULATIONS TO
CA  PERFORM TEST
CA  RUNS SO AS TO OPTIMIZE THESE LIMITS (I.E.,LOOK AT THE LOG FILE TO SEE
CA  IF MANY VECTORS HAVE BEEN PROJECTED OUT AND REJECTED)

CBAB
      TYPE 8000
8000  FORMAT(1X,'THIS IS PRIORPROJ')

      ISEED=473901921
C                      !initialize for random vector
      NLILIM=5.E-5
C                      !CHECK MODULUS OF ORTHOGONAL JT BASIS STATE,
C                      !LINEAR INDEPENDENCE CHECK.ALSO MINIMUM TO NEW
C                      !RANDOM VECTOR COEFF TO START TO PROJECT FROM.
C                      !Too small or too large a limit might cause
C                      !rounding errors for which warnings would be
C                      !issued.

      PJLIM=1.E-07     !TEST ACCURACY OF THE PROJECTION, SEE IROU

      LIMFAC=2         !FACTOR BY WHICH NLILIM IS CHANGED IN NEW ATTEMPT

      IUPLIM=0         !NO. TIMES LIMIT (NLILIM) IS CHANGED
      IUPLIM_MAX=5     !MAX NO. TIMES LIMIT (NLILIM) IS CHANGED

C  GET INPUT INFORMATION

CA  This version of PROJ does not test the accuracy of the
CA  projection against rounding errors unless IROU > 0'.
CA  Nevertheless, accuracy is always tested for the random vector. If
CA  it fails once it will test the accuracy for ALL remaining vectors.
CA  T projection accuracy is checked only if IROU > 2

      TYPE 808
808   FORMAT(' Control integers ILPT,ILIM,IROU : ',$)
      ACCEPT 818, ILPT,ILIM,IROU
      IF(ILOG)WRITE(6,918)ILPT,ILIM,IROU
918   FORMAT('+',3I3)
      WRITE(6,810)
810   FORMAT(' Name of basis : ',$)
CBAB      READ(5,811) LONGB,BASFIL
CBAB811   FORMAT(Q,A)
CBAB      IF(ILOG)WRITE(6,9111)BASFIL(1:LONGB)
CBAB      READ(5,811) BASFIL
811   FORMAT(A)
      CALL FREE_REAL_A(5,2,CHAR_VAR,0,REAL_VAR,READ_ERR)
      BASFIL = CHAR_VAR(1)
      BASFILP = CHAR_VAR(2)
      LONGB=INDEX(BASFIL,' ')-1
      IF(ILOG)WRITE(6,9111)BASFIL(1:LONGB)
9111  FORMAT('+',A,'.BAS')
      WRITE(6,812)
812   FORMAT(' Name for projected-basis : ',$)
CBAB      READ(5,811) LONGP,PRJFIL
      READ(5,811) PRJFIL
      IF (PRJFIL.EQ.' ')THEN
      PRJFIL=BASFIL
      LONGP=LONGB
      END IF
      LONGP=INDEX(PRJFIL,' ')-1
      IF(ILOG)WRITE(6,912)PRJFIL(1:LONGP)
912   FORMAT('+',A,'.PRJ')
      WRITE(6,817)
817   FORMAT(' Value of J*2, T*2 : ',$)
      READ(5,818) JAY,ITT
818   FORMAT(3I)
      IF(ILOG)WRITE(6,918)JAY,ITT
      IF (ILPT.EQ.0) GO TO 822
      IDEV=3
      OPEN(UNIT=IDEV,FILE=PRJFIL//'.LPP',STATUS='NEW')
822   IF (ILIM.EQ.0) GO TO 825
      TYPE 824, NLILIM,LIMFAC,PJLIM
824   FORMAT(' NLILIM = For lin.indep. check and random vector
     1prediction'/
     1' LIMFAC = Factor by which limits
     1 are changed for new attempt'/
     1' PJLIM = Limit of bad J after projection'/
     1' Old limits NLILIM,LIMFAC,PJLIM :'/
     2F12.7,I4,F12.9/
     1' NEW LIMITS : ',$)
      ACCEPT 826, RNLIM,LFAC,PLIM2
826   FORMAT(F,I,F)
      IF (RNLIM.NE.0.0) NLILIM=RNLIM
      IF (LFAC.NE.0) LIMFAC=LFAC
      IF (PLIM2.NE.0.0) PJLIM=PLIM2
825   BAS2='.BAS'
C
C  READ IN BASIS FILE INFORMATION, AND CHECK SUFFICIENT CORE
C
      BASF=BASFIL//BAS2
CBAB      OPEN(2,FILE='WOTDSK:'//BASFIL//'.INF',STATUS='OLD',
CBAB     1FORM='UNFORMATTED')
      OPEN(2,FILE=AREA_RUN//BASFIL//'.INF',STATUS='OLD',
     1FORM='UNFORMATTED')
CBAB      OPEN(UNIT=1,FILE='WOTDSK:'//BASF,ACCESS='DIRECT',
      OPEN(UNIT=1,FILE=AREA_RUN//BASF,ACCESS='DIRECT',
     1FORM='UNFORMATTED',STATUS='OLD',ASSOCIATEVARIABLE=NREAD,
     1READONLY)
      NREAD=1
CBAB      READ(2)SPSF,SHELL,NLWRDS,ZERO,IVERS,MNFIL,MXFIL,
CBAB     1 MNOSC,MXOSC,NOSCJL,NOSC,NPTCL,IMZS,ITZS,KPAR,NIPART,NJL,
CBAB     1NSPS,SUM_NPJ,
CBAB     1 MREADBAS
      READ(2)SPSF,NJL,(SHELL(I),I=1,NJL),NLWRDS,ZERO,IVERS,
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1(NOSCJL(I),I=1,NOSC),NPTCL,IMZS,ITZS,KPAR,NIPART,NSPS,SUM_NPJ,
     1 MREADBAS
CBAB      READ(2)IORD
CBAB      READ(2)IPART
CBAB      READ(2)NDIMA
CBAB      READ(2)NBLOCK
      READ(2)(IORD(I),I=1,NIPART)
      READ(2)NWORDS,((IPART(J,I),J=1,NWORDS),I=1,NIPART)
      READ(2)(NDIMA(I),I=1,NIPART)
      READ(2)(NBLOCK(I),I=1,NIPART)
      CLOSE(2)
C  now read Jz=Jz+1 basis information
C  MREADBAS=maximum Jz value for present no. of particles and
C  restrictions
C  if equal to present Jz value, Jz+1 basis will have zero dimension.
      IF(MREADBAS.NE.IMZS)CALL READBAS(1)
      IMZSA=IABS(IMZS)
      ITZSA=IABS(ITZS)
      IF (ITZSA.GT.ITT) GO TO 500
      IF (JAY.LT.IMZSA) GO TO 500
CBAB      IF ((JAY-IMZSA).GT.4.OR.(ITT-ITZSA).GT.4)
CBAB     1STOP ' ***** FATAL ERROR
      IF ((JAY-IMZSA).GT.2*(NO_JVAL).
     1OR.(ITT-ITZSA).GT.4) STOP ' ***** FATAL ERROR
     1 IN MAIN: J-JZ OR T-TZ TOO LARGE FOR PROGRAM *****'
      DO 835 III=NIPART,1,-1
      II=IORD(III)
CBAB      READ(1,REC=NBLOCK(II)) DUD,((NJTA(IJ,IT),IJ=1,3),IT=1,3)
      READ(1,REC=NBLOCK(II)) DUD,((NJTA(IJ,IT),IJ=1,NO_JVAL),
     1IT=1,NO_TVAL)
      IF (III.NE.1) FIND(1,REC=NBLOCK(IORD(III-1)))
      NJT=NJTA((JAY-IMZSA)/2+1,(ITT-ITZSA)/2+1)
      IF (NJT.GT.MAXNJT) MAXNJT=NJT
      MATDIM=MATDIM+NJT
      NJTP(III)=NJT
835   CONTINUE
      IF (NDIMA(IORD(NIPART)).GT.MAX_MSCHEME) GO TO 520
C
C
C  SET UP FOR J-, T- PROJECTION
C
      CALL FACSET
CEKW  IMAC>0
CEKW  IMAC<0
      IF(NSPS.LE.IMAC_NSPS) IMAC = 0
      IF(NSPS.GT.IMAC_NSPS) IMAC = 1
CA  MASK WILL HAVE A BIT WHERE PROTONS (or neutrons) ARE
      IF(IMAC.NE.0)CALL LIB_ASSIGNX(ZERO(1),MASK(1),NLWRDS)
      IF(IMAC.EQ.0) MASK(1) = ZERO(1)
      DO 10001 I=1,NSPS
      IF(IMAC.NE.0) GOTO5040
      IF(ISIGN(1,ITZTW(I)).EQ.ISIGN(1,ITZTW(1)))
     1MASK(1) = JIOR(MASK(1),2**(I-1))
      GOTO5041
5040  IF(ISIGN(1,ITZTW(I)).EQ.ISIGN(1,ITZTW(1))) THEN
      IF(LIB_BTSX(MASK(1),I-1,NLWRDS))GOTO9000
9000  CONTINUE
      ELSE
      END IF
5041  CONTINUE
CEKW      END DO
10001 CONTINUE
      IF (ILPT.EQ.0) GO TO 4
      IOUT = 3
      CALL TITLE(IOUT)
CBAB      WRITE(IDEV,8110)
CBAB8110  FORMAT(//' OXBASH: The Oxford-Buenos Aires Shell model code -
CBAB     1  OUTPUT OF PRIORPROJ '//
CBAB     1' AUTHORS: W.D.M.Rae, A.Etchegoyen, N.S.Godwin and B.A.Brown'/
CBAB     1' CONTRIBUTORS: W.A.Richter, C.H.Zimmerman and J.S.Winfield')
CBAB      WRITE(IDEV,401) BASFIL,PRJFIL,MATDIM,NLILIM,LIMFAC,PJLIM
401   FORMAT(' NAME OF BASIS = ',A',  NAME OF PROJECTED BASIS = ',A,
     1//'  DIMENSION OF MATRIX :',I10,//,
     1'  PROJECTION STATISTICS'/
     1'    (NLILIM,LIMFAC,PJLIM =',
     1F10.7,',',I3,',',F12.9,')'//)
4     CONTINUE
      PRJ2='.PRJ'
      RED2='.RED'
      REDF=PRJFIL//RED2
      PRJF=PRJFIL//PRJ2
CA  OPEN THE .PRJ FILE TO BE READ BACK IN MATRIX
CBAB      OPEN(UNIT=23,FILE='WOTDSK:'//PRJF,STATUS='NEW',
CBAB     1FORM='UNFORMATTED')
      OPEN(UNIT=23,FILE=AREA_RUN//PRJF,STATUS='NEW',FORM='UNFORMATTED')
CBAB      OPEN(UNIT=24,FILE='WOTDSK:'//REDF,STATUS='NEW',
CBAB     1FORM='UNFORMATTED')
      OPEN(UNIT=24,FILE=AREA_RUN//REDF,STATUS='NEW',FORM='UNFORMATTED')
      WRITE(24)PRJF,BASFIL,BASF
      NUNIT23=1
      WRITE(23)JAY,ITT,NIPART,NSPS,SPSF,BASFIL,BASF,MATDIM,
     1  (NJTP(I),I=1,NIPART)
      INQUIRE(FILE=PRJFIL//'.PRD',EXIST=EXISTE)
      IF(EXISTE)THEN
C  Open file with predicted good- mscheme vectors
CBAB      OPEN(UNIT=7,FILE='WOTDSK:'//PRJFIL//'.PRD',FORM='UNFORMATTED',
      OPEN(UNIT=7,FILE=AREA_RUN//PRJFIL//'.PRD',FORM='UNFORMATTED',
     1STATUS='OLD')
      READ(7)
      TYPE *, '**** INFORMATION from MAIN: Running with advanced
     1prediction file *****'
      ELSE
CBAB      TYPE *, '**** INFORMATION from MAIN: Running without advanced
CBAB     1prediction file *****'
      TYPE *
      END IF
C
C  LOOP OVER ALL PARTITIONS. BEGINNING OF THE CALCULATION
C
      DO 101 III=NIPART,1,-1
      NJT=NJTP(III)             !DIMENSION FOR A GIVEN PARTITION
      IF (NJT.EQ.0) GO TO 101
      IF(NJT.GT.MAX_NJT)THEN
      TYPE 828,NJT
828   FORMAT(' INCREASE MAX_NJT TO = ',I)
      STOP ' ***** FATAL ERROR in MAIN *****'
      END IF
      II=IORD(III)
      IDEORD(II)=III
      NWOTPT=III
      CALL LIB_ASSIGNX(IPART(1,II),WOTPT(1),N_WORDS)
      NDIMII=NDIMA(II)
CBAB      WRITE(6,734)(WOTPT_BYTE(IW),IW=NJL,1,-1)
CBAB734   FORMAT(' Partition = ',<NJL>(I2))
      IPR=1
      IF(EXISTE)THEN
      READ(7)IIII,NPRED
      TYPE 7777,IIII,NPRED
7777  FORMAT(1X,'IIII,NPRED = ',2I6)
      IF(NPRED.GT.MAX_PRED)THEN
      TYPE *,' NPRED,MAX_PRED',NPRED,MAX_PRED
      STOP ' ***** FATAL ERROR in MAIN: Increase MAX_PRED *****'
      END IF
      BACKSPACE 7
      READ(7)IIII,NPRED,(I_PREDICT(I),I=1,NPRED)
      NPRED_FIRST=NPRED
      IF (IPSF(NPRED,NPRED).GT.MAX_ORTHOG) THEN
      II=IPSF(NPRED,NPRED)
      TYPE 829,II
829   FORMAT(' INCREASE MAX_ORTHOG TO = ',I)
      STOP ' ***** FATAL ERROR in MAIN *****'
      END IF
CEKW      IF(EXISTE)THEN
      IF(III.NE.IIII)THEN
      TYPE 10000,III,IIII
10000 FORMAT(' Current partition no. in PRIORPROJ = ',I5,' While reading
     1record'/' of .PRD file corresponding to partition no. = ',I5)
      STOP '***** FATAL ERROR in MAIN: Diff. part. numbers  *****'
      END IF
      ELSE
      IRAN = 0
      NGOOD=0
      JJJ=0
      NPRED=0
      CALL FEDUP(FED_ARRAY(1),&75)
      END IF
CA  OPENS UNIT 21(20) IN CASE TABLE IN JMJP0(TMTP0) OVERFLOWS.
CBAB      OPEN(21,FILE='WOTDSK:'//PRJFIL//'.JJ',STATUS='SCRATCH',
CBAB      OPEN(21,FILE=AREA_RUN//PRJFIL//'.JJ',STATUS='SCRATCH',
CBAB     1FORM='UNFORMATTED')
      OPEN(21,FILE=AREA_RUN//PRJFIL//'.JJ',STATUS='NEW',
     1FORM='UNFORMATTED',DISPOSE='DELETE')
CBAB      OPEN(20,FILE='WOTDSK:'//PRJFIL//'.TT',STATUS='SCRATCH',FORM=
CBAB      OPEN(20,FILE=AREA_RUN//PRJFIL//'.TT',STATUS='SCRATCH',FORM=
CBAB     1'UNFORMATTED')
      OPEN(20,FILE=AREA_RUN//PRJFIL//'.TT',STATUS='NEW',FORM=
     1'UNFORMATTED',DISPOSE='DELETE')
CA SET UP FLAGS TO CALL JMJP0 (TMTP0) OR JMJP1 (TMTP1)
      JMJP_FLAG=1
      TMTP_FLAG=1


      READ(1,REC=NBLOCK(II)) NDM2II,NJTA,MAXJZ,MAXTZ,
     1((IBASIS(IW,I),IW=1,NLWRDS),I=1,NLWRDS_BLOCK-TWELVE)


      IF (NDIMII.GT.NLWRDS_BLOCK-TWELVE)THEN
      J=NLWRDS_BLOCK-TWELVE
12    READ(1,REC=NREAD) ((IBASIS(IW,I+J),IW=1,NLWRDS),I=1,NLWRDS_BLOCK)
      J=J+NLWRDS_BLOCK
      IF (NDIMII.GT.J) GO TO 12
      IF (J.GT.MAX_MSCHEME) GO TO 530
      IF (III.NE.1) FIND(1,REC=NBLOCK(IORD(III-1)))
      END IF

      IF (NDIMII.EQ.0) STOP ' ***** FATAL ERROR in MAIN: NDIMII
     1IS ZERO *****'
      NNLI=0
      NBP=0            !NO. OF BAD PROJECTIONS
C  SET UP FLAGS FOR STATES : IPROT_BYTE=.FALSE. WILL INDICATE BAD STATES
      DO J=1,MAX_IPROT
      CALL LIB_BTSX(NP_DIFF(1,J),32*N_WORDS-1,N_WORDS)
      END DO
      NDIFFM=1
      DO 18 I=1,NDIMII
      IF(IMAC.NE.0)CALL LIB_ASSIGNX(IBASIS(1,I),IPATRN(1),NLWRDS)
      IF(IMAC.EQ.0) IPATRN(1) = IBASIS(1,I)
      IF(IMAC.NE.0)CALL LIB_ANDX(IPATRN(1),MASK(1),IPATRN(1),NLWRDS)
      IF(IMAC.EQ.0) IPATRN(1) = JIAND(IPATRN(1),MASK(1))
      CALL PATTPART
      IPROT_BYTE(I)=.TRUE.
      CALL LIB_ASSIGNX(IPARTN(1),IPROT(1,I),N_WORDS)
      NDIFF=NDIFFM
CA COUNTING DIFFERENT PROTON PARTITION TO REORDER COEFFICENTS IN JMJP
      IF(I.EQ.1)THEN
      CALL LIB_ASSIGNX(IPARTN(1),NP_DIFF(1,1),N_WORDS)
      ELSE
      DO J=1,NDIFF
      IF(LIB_EQX(IPARTN(1),NP_DIFF(1,J),N_WORDS))GOTO 664
      END DO
      NDIFFM=NDIFFM+1
      IF(NDIFFM.GT.MAX_IPROT)STOP ' ***** FATAL ERROR in MAIN: INCREASE
     1MAX_IPROT *****'
      CALL LIB_ASSIGNX(IPARTN(1),NP_DIFF(1,NDIFFM),N_WORDS)
      END IF
664   CONTINUE
      COEF(I)=0.0
      COEF0(I)=0.
18    CONTINUE
C NP_DIFF,PROT_PART are vectors to use JMJP2 only for given proton
C partitions,
C  not all.
      DO 19 J=1,NPRED
      DO IPTN=1,NDIFFM
      IF(LIB_EQX(NP_DIFF(1,IPTN),IPROT(1,I_PREDICT(J)),N_WORDS))THEN
      PROT_PART(I_PREDICT(J))=IPTN
      GO TO 19
      END IF
      IF(IPTN.EQ.NDIFFM)THEN
      CALL BWRITE(6,NSPS,NLWRDS,IPROT(1,I_PREDICT(J)))
      TYPE 722,(WOTPT_BYTE(IW),IW=NJL,1,-1),NDIFFM,
     1((NP_DIFF_BYTE(IW1,IW),IW1=NJL,1,-1),IW=1,NDIFFM)
722   FORMAT(' Partition ',<NJL>I2,/,' Proton partitions (No =',I4,')'
     1,/,1X,<NDIFFM>(<NJL>I2,3X))
      STOP ' ***** FATAL ERROR in MAIN: A PROTON
     1PARTITION HAS NOT BEEN FOUND *****'
      END IF
      END DO
19    CONTINUE
      IPR=1
      IF(IMAX.NE.0.AND.NDIFFM.NE.1)STOP ' ***** FATAL ERROR in Main:
     1 Maximum
     1Tz SPS  file has more than 1 proton part. *****'
10    NGOOD=0
C!WILL BE NUMBER OF GOOD JT STATES FOR THE PRESENT PARTITION
      BADSTATE=.FALSE.
C!To skip invertion after an ibasis(jjj) tried and failed
      DO I=1,NPRED      !Set up array to single out I_Predict states made
      I_PRD(I)=.TRUE. !bad by random vector
      END DO
      JKEEPOL2=0      !to reject a state if rounding error
      JKEEP=0         !Counts bad I_Predict states up to present NGOOD
      JKEEPOLD=0      !  "     "      "        "   "   " NGOOD-1
      FEDUP_CALL=.TRUE.
C  LOOP OVER NJTP BASIS STATES WITHIN A PARTITION
C  Y SE VA LA PRIMERA.... ADENTRO, MI ALMA!
      JJJ=0
      IPR=0
1000  CONTINUE
      IF (JJJ.EQ.0)THEN
CA  RANDOM VECTOR
      DO 23 I=1,NDIMII
23    COEF0(I)=(RAN(ISEED)-0.5)*2.0  !RANDOM VECTOR WFN
      IF(ILPT.GT.3) WRITE(IDEV,210) (COEF0(I),I=1,NDIMII)
210   FORMAT(/////,' RANDOM VECTOR'/<NDIMII/10 +1>(10E10.2/))
      ELSE    !JJJ.NE.0
C  Set of error messages
      IF(EXISTE)THEN    ! ******* EKW
      IF(IPR.GT.NPRED)STOP ' ***** FATAL ERROR in MAIN: IPR.GT.NPRED
     1 *****'
      IF(JJJ.NE.I_PREDICT(IPR))STOP ' ***** FATAL ERROR in MAIN:
     1 JJJ.NE.I_PREDICT *****'
      IF(.NOT.I_PRD(IPR))STOP ' ***** FATAL ERROR in MAIN:
     1I_PRD=.FALSE. *****'
      ENDIF              !******** EKW
      IF(NGOOD.EQ.NJT) STOP ' ***** FATAL ERROR in MAIN: trying to
     1 project one more than the JT-basis dimension *****'
C  Commence calculation
      GO TO 332
C  Predict a new set
333   IF(FEDUP_CALL)THEN
      TYPE 3471,(WOTPT_BYTE(IW),IW=NJL,1,-1)
3471  FORMAT( ' ***** INFORMATION from MAIN:',/,
     11X,'Predicted set finished for partition ',<NJL>I2,/,
     11X,'Will predict new set *****')
      MINDO=NPRED+1
      CALL FEDUP(FED_ARRAY(1),&75)
      STOP ' ***** FATAL ERROR in MAIN: it cant be here *****'
      ELSE
      GO TO 600                    !Try changing limits
      END IF     !IF(FEDUP_CALL)
      END IF     !end of IF(JJJ.EQ.0)
C   IPROT WILL BE false FOR A BAD STATE
CA  AT THIS STAGE, WHEN JJJ.NE.0, COEF=COEF0=0. SEE DO LOOP 73
332   IF (JJJ.NE.0)THEN
      IF(NGOOD.EQ.0)THEN
      COEF0(JJJ)=1.0
      BADSTATE =.FALSE.
C !this resets BADSTATE in case first trials failed.
      ELSE
C  Invert previous Pjt|Mngood-1> vector  and set up new |Mngood>
      IF(.NOT.BADSTATE)CALL INVERT
C  check norm of previous wfn.
      IF(NGOOD.GE.1.AND.IROU.GE.0.AND..NOT.BADSTATE)THEN
      TEMP=0.
      DO I=1,NGOOD
      TEMP=TEMP+ORTHOG(IPSF(NGOOD,I))*COEF0P(I)
      END DO
      IF(ILPT.GE.2)WRITE(3,994)TEMP
994   FORMAT(' Norm of vector = ',F)
CBAB      IF(DABS(TEMP-1.).GE.1.E-3)THEN   !0.1% rounding error allowed
      IF(ABS(TEMP-1.).GE.1.E-3)THEN   !0.1% rounding error allowed
C  Reset to previous-previous good state by making previous vector bad.
      NGOOD=NGOOD-1
C!position of rounding error vector in predicted set
      NGOODPLUS=NGOOD+JKEEPOLD+1
      IPROT_BYTE(I_PREDICT(NGOODPLUS))=.FALSE.
      I_PRD(NGOODPLUS)=.FALSE.
      JKEEPOLD=JKEEPOL2
      JKEEP=JKEEP+1  !sum present vector
      BACKSPACE(23)
      NUNIT23=NUNIT23-1   !For FEDUP.FOR
***      TYPE 447,NGOODPLUS,I_PREDICT(NGOODPLUS),NGOOD,TEMP
***447   FORMAT(' ***** INFORMATION: NGOODPLUS,I_PREDICT(NGOODPLUS),
***     1NGOOD,
***     1NORM(should be 1.)=',3I5,1E13.5,'. Rejected. *****')
      END IF
      END IF
*      IF(DABS(TEMP-1.).GE.1.E-1)STOP ' ***** FATAL ERROR IN MAIN: Above
*     1 rounding error is too large ***** '
*      END IF
      BADSTATE=.FALSE.
      COEF0(JJJ)=1.0
      NGOODPLUS=NGOOD+JKEEP !NGOODPLUS=IPR-1
      IF(NGOODPLUS.NE.IPR-1)STOP ' ***** FATAL ERROR:
     1 NGOODPLUS.NE.IPR *****'
      IARGUMENT=-(MAX_PRED+1)+NGOODPLUS+1
      ISETG=0
C  Now ready to orthogonalize before projection. That is, set up
C  coef0s so
C  that projection will produce an orthogonal vector to those already
C  obtained

      DO IW=IPR-1,1,-1
      IF(I_PRD(IW))GOTO 83
      END DO
      STOP ' ***** FATAL ERROR in MAIN: IW=0 *****'
83    CONTINUE
      DO 55 ISET=1,IW !NGOODPLUS
      ISETG=ISETG+1
      IARGUMENT=IARGUMENT+(MAX_PRED+1-ISET)   !Jumps previous good states
      IF(.NOT.I_PRD(ISET))THEN
      ISETG=ISETG-1
      GO TO 55
      END IF
      COEFK=-GOODCOEF0_PREVIOUS(IARGUMENT)
C  IGOOD(JSET) will not be equal to I_PREDICT(JSET) when a vectors has
C  been
C  made bad by the random vector.
      DO JSET=1,ISETG
      COEF0(IGOOD(JSET))=COEF0(IGOOD(JSET))
     1+ORTHOG(IPSF(ISETG,JSET))*COEFK
      END DO
55    CONTINUE
      IF(ISETG.NE.NGOOD)THEN
      TYPE 578,(I_PRD(IW),IW=1,NPRED-NJT)
      TYPE *
      TYPE 578,(I_PRD(IW),IW=NPRED-NJT+1,NPRED)
578   FORMAT(1X,50(L1,1X)/)
      TYPE 577,ISETG,NGOOD,JKEEP,JKEEPOLD,JJJ,IW,IPR,NPRED
577   FORMAT(' ISETG,NGOOD,JKEEP,JKEEPOLD,JJJ,IW,IPR,NPRED =',
     14I4,I6,3I6)
      STOP ' ***** FATAL ERROR in MAIN: ISETG.NE.NGOOD  *****'
      END IF
      END IF
      END IF
      DO I=1,NDIFFM
      NPROT_P(I)=.FALSE.
      END DO
      IF(JJJ.NE.0)NPROT_P(PROT_PART(JJJ))=.TRUE.
      DO 778 I=1,NGOOD
      DO IJ=1,NDIFFM
      IF(PROT_PART(IGOOD(I)).EQ.IJ)THEN
      NPROT_P(IJ)=.TRUE.          !Set up nprot_p for PRJSBS
      GO TO 778
      END IF
      END DO
778   CONTINUE
C  APPLY JT-PROJECTION OPERATOR TO IBASIS(JJJ) and mob defined by
C  do 55 and 778
C   JMJP APPLY J-J+ TO COEF0 AND RETURN RESULT IN COEF
C   [J**2 = J-J+ + JZ(JZ+1)]. SAME WITH T-T+. FINAL RESULT,
CA  I.E., PJT|IBASIS(JJJ)+mob>, IN COEF0.
C
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU1,HANDLE)) GO TO 7790
*BT !START CLOCK
C
CA  ENTER IBASIS(JJJ)+ MOB

       CALL JTPROJ(JJJ)
CA  RETURNS PJT(|IBASIS(JJJ)>+MOB), M-SCHEME BASIS EXPANSION
CA  COEFFIENCTES IN COEF0
CA  COEF ARRAY HAS BEEN SET TO ZERO
C
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU2,HANDLE)) GO TO 7790
*BT !STOP CLOCK
*BT     JTPROJ_TIME = JTPROJ_TIME + ICPU2 - ICPU1
C
      IF(JJJ.EQ.0) GO TO 395            !RANDOM VECTOR?
      IF(IBP.GT.0) GO TO 393            !BAD PROJECTION?
      GO TO 440  !GO TO GOOD STATE
C BAD STATE
392   IPROT_BYTE(JJJ)=.FALSE.
      I_PRD(IPR)=.FALSE.
      BADSTATE=.TRUE.
      MINDO=IPR
      DO JJ=1,NDIMII
C!EVERYTHING ZEROED TO START AGAIN WITH NEW GOOD STATE
      COEF(JJ)=0.0
      COEF0(JJ)=0.0
      END DO
      GO TO 76
C
C  BAD PROJECTION
C
393   NBP=NBP+1
      GO TO 392
C
C  LI PREDICTION WRONG
C
394   NNLI=NNLI+1
      NGOOD=NGOOD-1
      GO TO 392
C
CA Here only for JJJ=0, good |JT> random vector
CA COEFK = modulus of godd |JT> random vector
395   COEFK=0.0
      DO I=1,NDIMII
      COEFK=COEFK+COEF0(I)*COEF0(I)
      END DO
CA
CA NORMALIZE RANDOM VECTOR TO 1.
CBAB      COEFK=DSQRT(1./COEFK)
      COEFK=SQRT(1./COEFK)
      DO 397 I=1,NDIMII
397   RANV(I)=COEF0(I)*COEFK
      GO TO 73
C
C  GOOD STATE
C
440   NGOOD=NGOOD+1
      IGOOD(NGOOD)=JJJ
C  check if linear independent
      IF(COEF0(JJJ).LT.NLILIM)GO TO 394
C  Check rounding errors
      TEMP=0
      DO I=1,NDIMII
      TEMP=TEMP+COEF0(I)**2
      END DO

CBAB      DIFF=DABS(COEF0(JJJ)/TEMP-1.)
      DIFF=ABS(COEF0(JJJ)/TEMP-1.)
      IF(DIFF.GT.1.E-3)THEN   !0.1% rounding error allowed
***      TYPE 3331,NGOOD,JJJ,100*DIFF
***3331  FORMAT(' ***** INFORMATION: NGOOD,JJJ,% R.Error=',I4,1X,I5,
***     11X,E12.4,
***     1' Rounding errors - . *****')
      GO TO 394
      END IF

***      TYPE 725,NPRED,JKEEP,JKEEPOLD,JKEEPOL2,
***     1JJJ,IPR,I_PREDICT(IPR),NGOOD,NGOODPLUS,COEF0(JJJ),
***725   FORMAT(' NPRED,JKEEP,JKEEPOLD,JKEEPOL2,JJJ,IPR,I_PREDICT(IPR),
***     1NGOOD,NGOODPLUS, COEF0, ',/,I5,1X,I5,1X,I8,1X,I7,2X,I4,I4,I9,6X,
***     1I6,I7,2X,D10.3)

      TEM=TEMP
CBAB      TEMP=DSQRT(1./TEM)
      TEMP=SQRT(1./TEM)
      DO I=1,NDIMII
      COEF0(I)=COEF0(I)*TEMP
C!Normalise with TEMP to avoid rounding errors
      END DO
C  it's  normalized, write it out
      WRITE(23) NGOOD,NDIMII,IGOOD(NGOOD),(SNGL(COEF0(I)) ,I=1,NDIMII)
      NUNIT23=NUNIT23+1
      IF (ILPT.GE.1)THEN
      WRITE(3,3411)
3411  FORMAT(/' Projection from m-scheme vector : ',$)
      CALL BWRITE(3,NSPS,NLWRDS,IBASIS(1,JJJ))
      CALL BWRITE(3,NSPS,NLWRDS,IBASIS(1,IGOOD(NGOOD)))
      TYPE *
      WRITE(3,7132)NDIMII,JJJ,(SNGL(COEF0(I)),I=1,NDIMII)
7132  FORMAT(/' .PRJ FILE: M_SCHEME DIM., GOOD M_SCHEME VECT. NO. =',2I,
     1/,'                           WAVE FUNCTION ',/<NDIMII>E10.2)
      END IF
C  Set up for inversion. Bad I_predict set by random vectors
C  considered in
C  JKEEP. Corresponding spaces in ORTHOG and GOODCOEF0_PREVIOUS
C  left blank
      NGOODPLUS=NGOOD+JKEEP
      NG(NGOOD)=NGOODPLUS
      DO J=NGOODPLUS,NPRED
      ORTHOG(IPRC(NGOODPLUS,J))=COEF0(I_PREDICT(J))
      END DO
      IF(ORTHOG(IPRC(NGOODPLUS,NGOODPLUS)).EQ.0)STOP
     1 ' ***** FATAL ERROR in
     1 MAIN: Matrix can not be inverted *****'
C  NSTART initial address for present <Oi|I_Predict(NGOODPLUS)>
C  i.GT.NGOODPLUS
      NSTART=(NGOODPLUS-1)*MAX_PRED-((NGOODPLUS-1)*(NGOODPLUS-2))/2
      I=0
      DO 59 J=NGOODPLUS+1,NPRED
      I=I+1
      GOODCOEF0_PREVIOUS(NSTART+I)=COEF0(I_PREDICT(J))
59    CONTINUE
      IF(IROU.GE.0)THEN   ! ROUNDING ERROR
      I=0
      DO J=1,NGOODPLUS
      IF(I_PRD(J))THEN
      I=I+1
      COEF0P(I)=COEF0(I_PREDICT(J))
      END IF
      END DO

      IF(I.NE.NGOOD)THEN
      TYPE 9581,I,NGOOD
9581  FORMAT(' I,NGOOD ',2I)
      STOP ' ***** FATAL ERROR in MAIN: I.NE.NGOOD *****'
      END IF

      END IF
C
C PREDICT LINEARLY INDEPENDENT STATES. CHOSE NEXT POSSIBLE GOOD M-SCHEME
C VECTOR.
      IF (NGOOD.EQ.NJT)GO TO 73  !DO WE HAVE ENOUGH FOR THIS PARTITION?
CBAB      COEFJ=RANV(JJJ)/DSQRT(TEM)
      COEFJ=RANV(JJJ)/SQRT(TEM)
      DO 715 I=1,NDIMII
      RANV(I)=RANV(I)-COEF0(I)*COEFJ
***      IF (I.EQ.JJJ) GO TO 715
CBAB      IF (DABS(RANV(I)).LT.(2.*NLILIM))IPROT_BYTE(I)=.FALSE.
      IF (ABS(RANV(I)).LT.(2.*NLILIM))IPROT_BYTE(I)=.FALSE.
715   CONTINUE
      DO I=1,NGOOD
      IPROT_BYTE(IGOOD(I))=.TRUE.
      END DO
73    DO 72 JJ=1,MAX(NDIMII,NDIMP)
C!EVERYTHING ZEROED TO START AGAIN WITH NEW GOOD STATE
      COEF_JP(JJ)=0
      COEF(JJ)=0.0
72    COEF0(JJ)=0.0
      IF(NGOOD.EQ.NJT)GOTO 96
      IF(NGOOD.EQ.0)GO TO 100
C  Will be here only when IBASIS(JJJ) good state
C  JKEEP, I_PRD(I) are used only to avoid those rows and columns
C  corresponding
C  to bad I_Predict states in ORTHOG
74    MINDO=IPR+1
CBAB   MOVED TWO LINES DOWN ACCORDING TO TELEX FROM AE ON OCT 20, 1983
CBAB      IF(MINDO.GT.NPRED)GOTO 77
      JKEEPOL2=JKEEPOLD
      JKEEPOLD=JKEEP
      IF(MINDO.GT.NPRED)GOTO 77
      IF(NGOOD.GT.NJT)
     1STOP ' ***** FATAL ERROR in MAIN: NGOOD.GT.NJT *****'
75    DO I=1,NPRED  !75 Return from FEDUP, MINDO set NPRED+1
      IF(.NOT.IPROT_BYTE(I_PREDICT(I)))I_PRD(I)=.FALSE.
      END DO
76    DO I=MINDO,NPRED
      IF(I_PRD(I)) GO TO 69   !will project next one out of this one
      JKEEP=JKEEP+1
      IF(I.EQ.NPRED)THEN    !predict new set, call FEDUP
77    IF(JKEEP+NGOOD.NE.NPRED)THEN
      TYPE *,' JKEEP,NGOOD,NPRED ',JKEEP,NGOOD,NPRED
      STOP ' ***** FATAL ERROR in MAIN: NGOOD+JKEEP.NE.NPRED *****'
      END IF
      GOTO 333
      END IF
      END DO
69    IPR=I-1  !Pick next one for projection, see under label 100
96    IF(NGOOD.EQ.NJT)THEN
      JKEEPOLD=JKEEP
      CALL INVERT
C  check norm of previous wfn.
      IF(IROU.GE.0)THEN
      TEMP=0.
      DO I=1,NGOOD
      TEMP=TEMP+ORTHOG(IPSF(NGOOD,I))*COEF0P(I)
      END DO
      IF(ILPT.GE.2)WRITE(3,994)TEMP
***      IF(DABS(TEMP-1.).GE.1.E-4)TYPE 449,NGOOD,TEMP
***449   FORMAT(' ***** WARNING2:
***     1NGOOD,NORM(should be 1.) ***** =',I,E13.5)
CBAB      IF(DABS(TEMP-1.).GE.1.E-1)
CBAB     1STOP ' ***** FATAL ERROR IN MAIN: Above
      IF(ABS(TEMP-1.).GE.1.E-1)STOP ' ***** FATAL ERROR IN MAIN: Above
     1 rounding error is too large ***** '
C  ******************
      END IF
      GO TO 1013
      END IF
100   IF(JJJ.EQ.NDIMII)GOTO 1013
      IPR=IPR+1  !Get next 'would be LI'
CEKW      IF(IPR.EQ.NPRED)NPRED=NPRED+1       ! &&&&&&& EKW
      IF(IPR.GT.NPRED)THEN
      TYPE *,' IPR,NPRED',IPR,NPRED
      STOP ' ***** FATAL ERROR in MAIN: IPR.GT.NPRED *****'
      END IF
      JJJ=I_PREDICT(IPR)
      IF(JJJ.LE.0)THEN
      TYPE *,' JJJ ',JJJ
      STOP ' ***** FATAL ERROR in MAIN: JJJ.LE.0 *****'
      END IF
      IF(JJJ.GT.NDIMII)
     1STOP ' ***** FATAL ERROR in MAIN: JJJ.GT.NDIMII *****'
      GO TO 1000
C--------------------------------------------------
1013  IF(NBP.GT.0.OR.NNLI.GT.0.)THEN
      WRITE(*,104)
104   FORMAT(/' ***** INFORMATION: PROJECTION STATISTICS - NO. OF
     1REJECTED TRIALS : *****')
      END IF
      IF(NBP.GT.0)TYPE 62,(WOTPT_BYTE(IW),IW=NJL,1,-1),NBP
62    FORMAT(' PARTITION,NBP = ',<NJL>I2,5X,I5)
      IF(NNLI.GT.0)TYPE 63,(WOTPT_BYTE(IW),IW=NJL,1,-1),NNLI
63    FORMAT(' PARTITION,NNLI = ',<NJL>I2,5X,I5)
      IF (NGOOD.LT.NJT) GO TO 600
1014  IF (IUPLIM.EQ.0) GO TO 1012
CA  GOES BACK TO INITIAL LIMIT FOR NEW PARTITION
CBAB / TO * NOV 16 1984
      NLILIM=NLILIM*LIMFAC
      IUPLIM=IUPLIM-1
      GO TO 1014
1012  CONTINUE
      WRITE(24)NJT,NXX,(IGOOD(I),I=1,NJT)
      IF(ILPT.GE.2)WRITE(3,771)(IGOOD(I),I=1,NJT)
771   FORMAT(' .RED FILE - No. of good vectors from 1 to JT-basis
     1dimension:'/<NJT>I6)
      NXX=IPSF(NJT,NJT)
      IF (NXX.NE.NJT*(NJT+1)/2) STOP ' ***** FATAL ERROR in MAIN:
     1SUMTHIN UP .RED WRITEOUT *****'
      WRITE(24)NJT,NXX,(SNGL(ORTHOG(I)),I=1,NXX)
      IF(ILPT.GT.1)WRITE(3,772)NJT,(SNGL(ORTHOG(I)),I=1,NXX)
772   FORMAT(' .RED FILE  - NJT,(ORTHOG(I), I=1,NXX)'/I5,<NXX>E)
      CLOSE(UNIT=20,DISPOSE='DELETE')
CA  IT HAS SUCESSFULLY FOUND ALL STATES FOR A GIVEN PARTITION
101   CONTINUE
C--------------------BASE OF DO LOOP OVER PARTITIONS.
C WILL NOW READ NEXT ONE.
      IF (NPRJM.GT.1) TYPE 10100, NPRJM
10100 FORMAT(/' MORE THAN ONE PROJECTION NEEDED, NPRJM =',I5)
      TYPE *
*BT CALL TIME_PROJ('JTPROJ   ',JTPROJ_TIME)
*BT CALL TIME_PROJ('JMJP0    ',JMJP0_TIME)
*BT CALL TIME_PROJ('JMJP1    ',JMJP1_TIME)
*BT CALL TIME_PROJ('JMJP2    ',JMJP2_TIME)
*BT CALL TIME_PROJ('TMTP0+1  ',TMTP_TIME)
*BT CALL TIME_PROJ('FEDUP    ',IFED_TIME)
*BT CALL TIME_PROJ('IDO      ',IDO_TIME)
*BT CALL TIME_PROJ('INVERT   ',INVERT_TIME)
      TYPE 4520
4520  FORMAT(1X,'Projection calculation succesfully completed')
8888  CONTINUE
      IF(.NOT.LIB$SHOW_TIMER(HANDLE,2)) GO TO 7778
C! EXIT FROM HERE AFTER
      IF(.NOT.LIB$SHOW_TIMER(HANDLE,1)) GO TO 7778
C! ... SHOWING CPU TIME
      TYPE 1051
1051  FORMAT(///)
      CALL EXIT
7790  STOP ' ***** MAIN:FATAL ERROR1 IN LIB$STAT_TIMER *****'
7778  STOP ' ***** MAIN:FATAL ERROR2 IN LIB$SHOW TIMER *****'

500   WRITE(6,505) JAY,IMZS,ITT,ITZS
505   FORMAT(' ERROR: J*2,JZ*2,T*2,TZ*2 : ',5I5)
      STOP ' ***** FATAL ERROR in MAIN *****'
520   TYPE 525, NDIMA(IORD(NIPART))
525   FORMAT(' MORE MEMORY NEEDED, INCREASE MAX_MSCHEME TO',I10)
      STOP ' ***** FATAL ERROR in MAIN *****'
530   TYPE 531, MAX_MSCHEME,J
531   FORMAT(' INCREASE MAX_MSCHEME FROM',I7,' TO',I7)
      STOP ' ***** FATAL ERROR in MAIN *****'


600   CONTINUE
      IF(IRAN.LT.3) GO TO 4500
      TYPE 1010,(IPART_BYTE(I,II),I=NJL,1,-1),NJT,NGOOD,NNLI,
     1NDIMII,NLILIM
1010  FORMAT(/,' NOT ENOUGH GOOD M-STATES FOUND',
     1/,' IPART1,NJT,NGOOD,NNLI,NDIMII ',
     1/,1X,<NJL>I2,2X,4I7/
     1' - WILL TRY CHANGING LIMIT '/' PRESENT NLILIM = ',F)

CBAB600   TYPE 1010,(IPART_BYTE(IW,II),IW=NJL,1,-1),NJT,NGOOD,NNLI,
CBAB     1NDIMII,NLILIM
CBAB1010  FORMAT(' ***** INFORMATION: IPART,NJT,NGOOD,NNLI,NDIMII ',
CBAB     1<NJL>I2,4I7/
CBAB     1'  - WILL TRY CHANGING LIMIT '/' PRESENT NLILIM = ',F)

      IF(ILPT.GT.0)WRITE(IDEV,1010)IPART(1,II),NJT,NGOOD,NNLI,NDIMII
      NLILIM=NLILIM/LIMFAC
      WRITE(6,2227)NLILIM
2227  FORMAT(' NEW LIMIT:'/' NLILIM = ',F)
      PREDICT=.TRUE.
      FEDUP_CALL=.TRUE.
      IPR=1
      IUPLIM=IUPLIM+1
CBAB      IF (IUPLIM.GT.3)
CBAB     1 STOP ' ***** FATAL ERROR in MAIN: Limits changed 3
      IF (IUPLIM.GT.IUPLIM_MAX) TYPE 8889
8889  FORMAT(/,1X,'Projection calculation NOT completed',
     1/,1X,'To fix this try the following:',
     1/,1X,'1) Try running POSTPROJ',
     1/,1X,'2) Try projecting from a lower JZ and/or TZ value',
     1/,1X,'3) Try changing the limits in the input with ILIM=1',
     1/,1X,'See the manual for more details')
CBAB   IF (IUPLIM.GT.IUPLIM_MAX) TYPE 8889,IUPLIM_MAX
CBAB8889  FORMAT(1X,' ***** FATAL ERROR in MAIN: Limits changed ',I2,
CBAB     1' times - GIVING UP - AT LEAST I TRIED *****')
      IF (IUPLIM.GT.IUPLIM_MAX) GO TO 8888
**************
CTEST      WRITE(112,983)
CTEST983   FORMAT(' GOING TO CHANGE LIMITS ')
CTEST      CLOSE (112)
*************
      GO TO 4501

4500  CONTINUE
      TYPE 4502,(IPART_BYTE(I,II),I=NJL,1,-1),NJT,NGOOD,NNLI,NZ,NDIMII
4502  FORMAT(/,' NOT ENOUGH GOOD M-STATES FOUND',
     1/,1X,'IPART1,NJT,NGOOD,NNLI,NZ,NDIMII  = ',
     1/,1X,<NJL>I2,2X,5I7,
     1/,1X,'- WILL TRY CHANGING SEED FOR RANDOM VECTOR')
      IRAN = IRAN+1
      ISEED = -ISEED+674931


4501  CONTINUE
      NNLI=0
      NBP=0      !NO. OF BAD PROJECTIONS
      DO I=1,NDIMII
      IPROT_BYTE(I)=.TRUE.
      IF(EXISTE)THEN
C  Set to bad, states different from i_predict and lower to
C  i_predict(max)
      IF(IPR.LE.NPRED_FIRST.AND.I.LT.I_PREDICT(IPR))THEN
      IPROT_BYTE(I)=.FALSE.
      END IF
      IF(I_PREDICT(IPR).EQ.I)IPR=IPR+1
      END IF
      END DO
      IPR=1
      DO I=1,NGOOD
C!Rewind .PRJ file to beginning of current partition
      BACKSPACE 23
      NUNIT23=NUNIT23-1
      END DO
      GO TO 10
      END

C  Subroutine to invert a lower triangular matrix, line by line.
C  It avoids bad columns (i.e. IPRD_BYTE.EQ.FALSE, hopefully.
C  It enters in a good row. Called for the last(previous) good state.
C  Returns ORTHOG as:
C  |Ongoodprevious>=Sum ORTHOG(ngoodp,K)PJT|K>, for K=1,...,Ngoodp. Main
C  no. n

      SUBROUTINE INVERT
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
      INCLUDE 'SHEXE:DATA.INC'
***      EXTERNAL LIB$EMULATE
***      REAL *16 S
***      CALL LIB$ESTABLISH(LIB$EMULATE)
      IPSN(I,J)=(I-1)*I/2+J
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPUIN,HANDLE)) STOP ' INVERT ERROR'
*BT !START CLOCK

***      IF(NPRED.GT.418)THEN
***      TYPE *,' INVERT: NJT,JKEEPOLD,JKEEP,NGOODPLUS,NPRED',
***     1NJT,JKEEPOLD,JKEEP,NGOODPLUS,NPRED
***      TYPE 733,(NG(IW),IW=1,NGOOD)
***      TYPE 734,(IGOOD(IW),IW=1,NGOOD)
***      TYPE 735,(I_PREDICT(IW),IW=1,NPRED)
***      TYPE 736,(I_PRD(IW),IW=1,NPRED)
733   FORMAT(' NG '/<NPRED/10+1>(10(I6,1X)/))
734   FORMAT(' IG '/<NPRED/10+1>(10(I6,1X)/))
735   FORMAT(' I_PREDICT'/<NPRED/10+1>(10(I6,1X)/))
736   FORMAT(' I_PRD'/<NPRED/50+1>(50(1X,L1)/))
***      TYPE 737,(IPROT_BYTE(IW),IW=1,1000)
737   FORMAT(' IPROT_BYTE'/<NPRED/50+1>(50(1X,L1)/))
***      END IF
      NGOODPLUS=NGOOD+JKEEPOLD
      K1=0
      DO 24 K=1,NGOOD-1
23    K1=K1+1
      IF(K1.GE.NGOODPLUS)GO TO 21
      IF(.NOT.I_PRD(K1))GO TO 23
      S=ORTHOG(IPSN(NGOODPLUS,K1))*ORTHOG(IPSN(K,K))
      J1=K1
      DO 20 J=K+1,NGOOD-1
22    J1=J1+1
      IF(.NOT.I_PRD(J1))GO TO 22
      IF(J1.GE.NGOODPLUS)GO TO 25
      S=S+ORTHOG(IPSN(NGOODPLUS,J1))*ORTHOG(IPSN(J,K))
20    CONTINUE
25    IF(J.NE.NGOOD)THEN
      TYPE 233,J,NGOOD,NGOODPLUS,(I_PRD(IW),IW=1,NGOODPLUS)
233   FORMAT(' J,NGOOD,NGOODPLUS ',3I6,/,' I _PRD ',/,
     1<NGOODPLUS/50+1>(50(L1,1X)/))
      STOP ' ***** FATAL ERROR in INVERT:J.NE.NGOOD *****'
      END IF
      ORTHOG(IPSN(NGOOD,K))=-S/ORTHOG(IPSN(NGOODPLUS,NGOODPLUS))
24    CONTINUE
21    IF(K.NE.NGOOD)STOP ' ***** FATAL ERROR in INVERT:K.NE.NGOOD ****'
      ORTHOG(IPSN(NGOOD,NGOOD))=1./ORTHOG(IPSN(NGOODPLUS,NGOODPLUS))

*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPUIN2,HANDLE))
*BT     1STOP ' INVERT ERROR 2'!STOP CLOCK
*BT      INVERT_TIME = INVERT_TIME + ICPUIN2 - ICPUIN

      RETURN
      END

      SUBROUTINE TIME_PROJ(TIMEN,JTPROJ_TIME)
      CHARACTER *9 TIMEN
      J_SEC=MOD(JTPROJ_TIME/100,60)
      J_MIN=MOD(JTPROJ_TIME/6000,60)
      J_HOU=JTPROJ_TIME/360000
      J_HUN=JTPROJ_TIME-360000*J_HOU-6000*J_MIN-J_SEC*100
      TYPE 7776,TIMEN,J_HOU,J_MIN,J_SEC,J_HUN
7776  FORMAT(' CPU TIME spent in ',A,'=', 2(I2,':'),I2,'.',I2)
      RETURN
      END

