C  SUBROUTINE TO READ IN A BASIS FILE
C  IWHERE.EQ.1 READS IN GENERAL INFORMATION
C        .NE.1 READS IN THE BASIS FOR A GIVEN PARTITION

      SUBROUTINE READBAS(IWHERE)
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
CBAB      CHARACTER *9 BASFILP
      CHARACTER *1 AA,TWCJ
      LOGICAL EXIST
      DIMENSION IPARTP(N_WORDS,MAX_NPART)
CWEO      BYTE IPARTP_BYTE(N_WORDS*4,MAX_NPART)
      DIMENSION MNFIL(MAX_NJL),MNOSC(MAX_NOSC),MXOSC(MAX_NOSC),
     1NOSCJL(MAX_NOSC),NJTAP(NO_JVAL,NO_TVAL)
CWEO      EQUIVALENCE(IPARTP_BYTE(1,1),IPARTP(1,1))
      INCLUDE 'SHEXE:DATA.INC'
      IF(IWHERE.EQ.1)THEN
      IF(BASFILP.NE.' ') GO TO 6000
C  Work out the name for Jz=Jz+1 basis file
      BASFILP=BASFIL
      AA=BASFIL(2:2)
      READ(AA,11,ERR=160)I
CWEO      DECODE(1,11,AA,ERR=160)I
      I=I+2
      IF(I.LE.9)THEN
      WRITE(TWCJ,11)I
CWEO      ENCODE(1,11,TWCJ)I
11    FORMAT(I1)
      GO TO 161
      ELSE
      IF(I.EQ.10)TWCJ='A'
      IF(I.EQ.11)TWCJ='B'
      GO TO 161
      END IF
160   IF(AA.EQ.'A')TWCJ='C'
      IF(AA.EQ.'B')TWCJ='D'
      IF(AA.EQ.'C')TWCJ='E'
      IF(AA.EQ.'D')TWCJ='F'
      IF(AA.EQ.'E')TWCJ='G'
      IF(AA.EQ.'F')TWCJ='H'
      IF(AA.EQ.'G')TWCJ='I'
      IF(AA.EQ.'H')TWCJ='J'
      IF(AA.EQ.'I')TWCJ='K'
      IF(AA.EQ.'J')TWCJ='L'
      IF(AA.EQ.'K')TWCJ='M'
      IF(AA.EQ.'L')TWCJ='N'
      IF(AA.EQ.'M')TWCJ='O'
      IF(AA.EQ.'N')TWCJ='P'
      IF(AA.EQ.'O')TWCJ='Q'
      IF(AA.EQ.'P')TWCJ='R'
      IF(AA.EQ.'Q')TWCJ='S'
      IF(AA.EQ.'R')TWCJ='T'
C  U,V,W,X,Y,Z left for J(or T) different from Jz(Tz)
      IF(AA.EQ.'U')TWCJ='W'
      IF(AA.EQ.'V')TWCJ='X'
      IF(AA.EQ.'X')TWCJ='2'
      IF(AA.EQ.'Y')TWCJ='3'
      IF(AA.EQ.'W')TWCJ='Y'
      IF(AA.EQ.'Z')TWCJ='1'

161   BASFILP(2:2)=TWCJ
C  Name has been worked out
6000  CONTINUE

CWEO      INQUIRE(FILE=BASFILP//'.BAS',EXIST=EXIST)
CWEO      IF(.NOT.EXIST)THEN
CWEO      WRITE(6,163)
CWEO163   FORMAT(' Name of Jz+1 basis = ')
CWEO      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
CWEO      BASFILP=CHAR_VAR(1)
CWEO      NPOS=INDEX(BASFILP,' ')
CWEO      IF(ILOG)WRITE(6,165)BASFILP(1:NPOS-1)
CWEO165   FORMAT('+',A9,'.BAS')
CWEO      END IF
      NPOS=INDEX(BASFILP,' ')
C  Open basis file with projection value Jz = Jz+1
      CALL OPEN_FILE(2,BASFILP,'.INF','OLD','UFRM')
CVAX      OPEN(UNIT=10,FILE=BASFILP(1:NPOS-1)//'.BAS',ACCESS='DIRECT',
CVAX     1FORM='UNFORMATTED',STATUS='OLD',ASSOCIATEVARIABLE=NJZP1,
CVAX     1READONLY)
      CALL OPEN_BASIS(10,BASFILP,'.BAS','OLD',NLWRDS)
      NJZP1=1
CBAB  READ(2)SPSF,SHELL,NLWRDS,ZERO,IVERS,MNFIL,MXFIL,
CBAB 1 MNOSC,MXOSC,NOSCJL,NOSC,NPTCL,IMZSP,ITZSP,KPAR,NIPARTP,NJL,NSPS
      READ(2)SPSF,NJL,(SHELL(I),I=1,NJL),NLWRDS,ZERO,IVERS,
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1(NOSCJL(I),I=1,NOSC),NPTCL,IMZSP,ITZSP,KPAR,NIPARTP,NSPS
      IF(IMZSP.NE.IMZS+2)THEN
       WRITE(6,130)IMZSP,IMZS
130    FORMAT (' IMZSP,IMZS =',2I5)
       STOP 'Error in READBAS'
      END IF
       III=NIPARTP+1
       NPART2=1
131    NPART2=NPART2*2
       IF(NPART2.LT.NIPARTP)GO TO 131
CBAB   READ(2)IORDP                       !holds order
CBAB   READ(2)IPARTP
CBAB   READ(2)NDIMAP
CBAB   READ(2)NBLOCKP                  !first block of partition I
C                                       holds order
       READ(2)(IORDP(I),I=1,NIPARTP)
       READ(2)NWORDS,((IPARTP(J,I),J=1,NWORDS),I=1,NIPARTP)
       READ(2)(NDIMAP(I),I=1,NIPARTP)
C                                       first block of partition I
       READ(2)(NBLOCKP(I),I=1,NIPARTP)
      CLOSE (2)
C               Read in basis states
      ELSE
      IF(III.NE.0)THEN
       III=III-1
       II=IORDP(III)
       IF(LIB_EQX(IPARTP(1,II),WOTPT(1),N_WORDS))GO TO 210
      END IF
C  enter to the find subroutine
      II=NIPARTP
      IF(LIB_EQX(WOTPT(1),IPARTP(1,II),N_WORDS)) GO TO 110
      II=NPART2/2
      M=II
      IF(LIB_LTX(WOTPT(1),IPARTP(1,II),N_WORDS))GO TO 101
      IF(LIB_EQX(WOTPT(1),IPARTP(1,II),N_WORDS))GO TO 110
      M=M/2
      II=NIPARTP-M
      GO TO 102
101   M=M/2
      II=II-M
102   IF(M.EQ.0)THEN
      NDIMP=0
      NDM2P=0
      RETURN
      END IF
      IF(LIB_LTX(WOTPT(1),IPARTP(1,II),N_WORDS))GO TO 101
      IF(LIB_EQX(WOTPT(1),IPARTP(1,II),N_WORDS))GO TO 110
      M=M/2
      II=II+M
      GO TO 102
110   III=0
C  READ IN BASIS
210   READ(10,REC=NBLOCKP(II)) NDM2P,NJTAP,MAXJZP,MAXTZP,
     1  ((IBASISP(IW,I),IW=1,NLWRDS),I=1,NLWRDS_BLOCK-TWELVE)
      NDIMP=NDIMAP(II)

C  NDIMP might be greater than NDIMII if JZ.NE.J
      IF(NDIMP.GT.MAX_MSCHEME)THEN
      WRITE(6,926)NDIMP
926   FORMAT(' ***** FATAL ERROR IN READBAS: Increase MAX_MSCHEME
     1to :',I10)
      STOP
      END IF
      DO 10001  IW=1,NDIMP
      COEF_JP(IW)=0.
C      END DO
10001 CONTINUE

      IF (NDIMP.GT.NLWRDS_BLOCK-TWELVE)THEN
      NJZP1=NBLOCKP(II)
      J=NLWRDS_BLOCK-TWELVE
12    NJZP1=NJZP1+1
      READ(10,REC=NJZP1)((IBASISP(IW,I+J),IW=1,NLWRDS),I=1,NLWRDS_BLOCK)
C12    READ(10,REC=NJZP1)((IBASISP(IW,I+J),IW=1,NLWRDS),I=1,NLWRDS_BLOCK)
      J=J+NLWRDS_BLOCK
      IF (NDIMP.GT.J) GO TO 12
      IF (J.GT.MAX_MSCHEME) STOP 'Error in READBAS: J.GT.MAX_MSCHEME'
      END IF
      END IF
      RETURN
      END
