      SUBROUTINE TMTP0
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
      INTEGER *2 TTSTORE(MAX_TTORE),NTTORE(MAX_TTORE)
      INTEGER *2 JJ20(NUNIT20),N20(NUNIT20)
      DIMENSION JPATRN(MAX_NLWRDS),MPATRN(MAX_NLWRDS),IPOSN(MAX_NSPS)
      INCLUDE 'SHEXE:DATA.INC'

CA   THE TWO SUBROUTINES JMJP0 AND TMTP0 ARE ESSENTIALLY
CA   THE SAME. THEY DIFFERS IN THAT TMTP0 HAS IPHASE=FACPM(NP,NM)=1
CA   THIS SUBROUTINE APPLIES THE TOTAL T-T+ OPERATOR WITH NO GOOD
C    PROTON PARTITION.
C    IT APPLIES T-T+ OPERATORS TO COEF0 AND RETURNS RESULT IN COEF.
CA   COEF IS THEN, THE OUTPUT OF THE SUBROUTINE
CA   T-T+ IS TAKEN AS A SUM OVER NNM(NNP)SINGLE PARTICLE T- (T+)
CA   OPERATORS. SEE DO LOOPS 300 AND 200.


      LLL = 1
      ITIME=1
      NBLOCKS=0

      NDIM2B=NDM2II/2

CA   START OF THE LOOP OVER THE BASIS STATES

      DO 400 JJ=1,NDIMII
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(IBASIS(1,JJ),JPATRN(1),NLWRDS)
      IF(IMAC.EQ.0) JPATRN(1)=IBASIS(1,JJ)
      NPTCLE=0


CA   NEXT DO LOOP FINDS WHERE THE PARTICLES IN JPATRN ARE (I.E. IN
CA   WHAT SINGLE
CA   PARTICLE STATES THEY ARE) AND STORES THE RESULT IN IPOSN.


      DO 10001  I=1,NLWRDS
      NSTART=0
CA  SEE RUNTIME MANUAL FOR SUBROUTINE LIB$FFS.SHORTLY,IT FINDS THE
CA  FIRST BIT IN JPATRN(1) THAT OCCURS FROM POSITION NSTART ONWARDS.
CA  IT RETURNS THE POSITION  OF THE FIRST OCCURENCE IN N.
CWEO20    IF(.NOT.LIB$FFS(NSTART,32,JPATRN(I),N))GO TO 10
20    IF(.NOT.LIB_WHERE_BIT(NSTART,MAX_BIT_NLWRDS,JPATRN(I),N))GO TO 10
      IF(N.GT.(MAX_BIT_NLWRDS-1))GO TO 10
      NSTART=N+1
      NPTCLE=NPTCLE+1
      IPOSN(NPTCLE)=NSTART+(I-1)*MAX_BIT_NLWRDS
      GO TO 20
10    CONTINUE
C      END DO
10001 CONTINUE

CA   WE SHALL NOW APPLY T+(DO 300)AND THEN T-(DO 200)

      DO 300  NNP=1,NPTCLE
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(JPATRN(1),IPATRN(1),NLWRDS)
      IF(IMAC.EQ.0) IPATRN(1)=JPATRN(1)
      NP=IPOSN(NNP)
      JP=TPLUS(NP)

CA   JP TELLS WHAT PATTERN WE GET WHEN WE APPLY T+(NNP) TO IPATRN.
CA   T+(NNP) IS APPLIED ONLY ON PARTICLE IN POSITION NP AND IT
CA   MOVES IT TO POSITION JP.

      IF(JP.EQ.0)GO TO 300
      IF(IMAC.NE.0) GO TO 5050
      IF(JIAND(IPATRN(1),2**(JP-1)).NE.0)GO TO 300
      GO TO 5051
5050  IF(LIB_BTX(IPATRN(1),JP-1,NLWRDS))GO TO 300
5051  CONTINUE

CA   WE HAVE JUST CHECKED THAT THE PLACE IS EMPTY,SO NOW CHANGE THE
CA   PLACE OF THE PARTICLE.

      CALL LIB_BTSX(IPATRN(1),JP-1,NLWRDS)
      CALL LIB_BTCX(IPATRN(1),NP-1,NLWRDS)
CWEO      IF(IMAC.EQ.0) IPATRN(1)=IPATRN(1).OR.2**(JP-1)
CWEO      IF(IMAC.EQ.0) IPATRN(1)=IPATRN(1).AND..NOT.2**(NP-1)

      DO 200 NNM=1,NPTCLE
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(IPATRN(1),MPATRN(1),NLWRDS)
      IF(IMAC.EQ.0) MPATRN(1)=IPATRN(1)
      NM=IPOSN(NNM)
      IF(NNP.NE.NNM)GO TO 50

C    THEY ARE EQUAL,SO WE ARE APPLYING T+ AND T- TO THE SAME
C    PARTICLE. REMEMBER THAT T+ HAS ALREADY MOVED THE PARTICLE TO
CA   NP+2.

      N=JJ
      NM=NP+2
      GO TO 110

CA   THEY ARE DIFFERENT PARTICLES, SO REPEAT PROCEDURE OF DO 300
CA   BUT NOW FOR T-:

50    JM=TMIN(NM)
      IF(JM.EQ.0)GO TO 200
      IF(IMAC.NE.0) GO TO 5060
      IF(JIAND(MPATRN(1),2**(JM-1)).NE.0)GO TO 200
      GO TO 5061
5060  IF(LIB_BTX(MPATRN(1),JM-1,NLWRDS))GO TO 200
5061  CONTINUE
      CALL LIB_BTSX(MPATRN(1),JM-1,NLWRDS)
      CALL LIB_BTCX(MPATRN(1),NM-1,NLWRDS)
CWEO      IF(IMAC.EQ.0) MPATRN(1)=MPATRN(1).OR.2**(JM-1)
CWEO      IF(IMAC.EQ.0) MPATRN(1)=MPATRN(1).AND..NOT.2**(NM-1)


CA   NEXT FEW LINES,UP TO LABEL 110 IS THE FIND SUBROUTINE.IF YOU
CA   WANT THE COMMENTED VERSION SEE FINDP.FOR

      N=NDIMII
      IF(IMAC.NE.0) GO TO 5070
      IF(MPATRN(1).EQ.IBASIS(1,N))GO TO 110
      GO TO 5071
5070  IF(LIB_EQX(MPATRN(1),IBASIS(1,N),NLWRDS))GO TO 110
5071  CONTINUE
      N=NDIM2B
      M=N
      IF(IMAC.NE.0) GO TO 5080
      IF(MPATRN(1).LT.IBASIS(1,N))GO TO 101
      IF(MPATRN(1).EQ.IBASIS(1,N))GO TO 110
      GO TO 5081
5080  IF(LIB_LTX(MPATRN(1),IBASIS(1,N),NLWRDS))GO TO 101
      IF(LIB_EQX(MPATRN(1),IBASIS(1,N),NLWRDS))GO TO 110
5081  CONTINUE
      M=M/2
      N=NDIMII-M
      GO TO 102
101   M=M/2
      N=N-M

CA   *******************************************************************
102   IF(M.EQ.0)STOP 'ERROR IN TMTP0:
     1A BASIS PATTERN HAS NOT BEEN FOUND- ARRAYS DIMENSIONS COULD
     1BE WRONG. TRY COMPILING WITH CHECK SWITCH'
CA   ******************************************************************

      IF(IMAC.NE.0) GO TO 5090
      IF(MPATRN(1).LT.IBASIS(1,N))GO TO 101
      IF(MPATRN(1).EQ.IBASIS(1,N))GO TO 110
      GO TO 5091
5090  IF(LIB_LTX(MPATRN(1),IBASIS(1,N),NLWRDS))GO TO 101
      IF(LIB_EQX(MPATRN(1),IBASIS(1,N),NLWRDS))GO TO 110
5091  CONTINUE
      M=M/2
      N=N+M
      GO TO 102
110   COEF(N)=COEF(N)+COEF0(JJ)
      IF(LLL.LE.MAX_TTORE)THEN
       TTSTORE(LLL) = JJ
       NTTORE(LLL) = N
      ELSE
       IF(ITIME.LT.NUNIT20)THEN
        N20(ITIME)=N
        JJ20(ITIME)=JJ
        ITIME=ITIME+1
       ELSE
        N20(NUNIT20)=N
        JJ20(NUNIT20)=JJ
        WRITE(20)JJ20,N20
        ITIME=1
        NBLOCKS=NBLOCKS+1
       ENDIF
      ENDIF
      LLL = LLL + 1

200   CONTINUE
300   CONTINUE
400   CONTINUE
      IF(ITIME.GT.1)THEN
       WRITE(20)JJ20,N20
       NBLOCKS=NBLOCKS+1
      ENDIF
      IF(LLL-1.GT.MAX_TTORE)WRITE(6,501)PRJFIL(1:LONGP),LLL-1
501   FORMAT(1X,A9,'.TT FILE HAS BEEN OPENED'/
     1' NO. OF COEFFICIENTS = ',I10)
      RETURN
      ENTRY TMTP1
      DO 10002  J=1,MIN(LLL-1,MAX_TTORE)
      COEF(NTTORE(J))=COEF(NTTORE(J)) + COEF0(TTSTORE(J))
C      END DO
10002 CONTINUE
      IF(LLL-1.GT.MAX_TTORE)THEN
       REWIND 20
       DO 10003  JSW=1,NBLOCKS
       NUMBER=NUNIT20
       IF(JSW.EQ.NBLOCKS)NUMBER=ITIME-1
       READ(20)JJ20,N20
       DO 10004  IKP=1,NUMBER
       COEF(N20(IKP))=COEF(N20(IKP))+COEF0(JJ20(IKP))
C       END DO
10004  CONTINUE
C       END DO
10003  CONTINUE
      END IF
      RETURN
      END
