      SUBROUTINE JMJP0 
      INCLUDE 'macfor.inc'                
      INCLUDE 'param.inc'                
      INCLUDE 'real.inc'                
      INCLUDE 'prjcom.inc'                
      INTEGER *2 NPSTORE(MAX_STORE,MAX_IPROT),
     1TABLENP(MAX_IPROT*MAX_STORE) 
c      INTEGER *2 JJSTORE(MAX_STORE,MAX_IPROT),
CBAB changed for g9-g7 space
      INTEGER *4 JJSTORE(MAX_STORE,MAX_IPROT),
     1NSTORE(MAX_STORE,MAX_IPROT), 
     1TABLEJJ(MAX_STORE*MAX_IPROT),TABLEN(MAX_STORE*MAX_IPROT)
      DIMENSION IPOSN(MAX_NSPS),IARG(MAX_IPROT),ISTART(MAX_IPROT) 
      DIMENSION JPATRN(MAX_NLWRDS),MPATRN(MAX_NLWRDS), 
     1IARG_KEEP(0:MAX_IPROT),IARGO(MAX_IPROT),KEEP_SUM(0:MAX_IPROT)
      EQUIVALENCE(TABLENP(1),NPSTORE(1,1)) 
      EQUIVALENCE(TABLEJJ(1),JJSTORE(1,1)) 
      EQUIVALENCE(TABLEN(1),NSTORE(1,1)) 
      INCLUDE 'data.inc'                

CA   THIS SUBROUTINE APPLIES THE TOTAL J-J+ OPERATOR WITHOUT GOOD
C    PROTON PARTITION.
CA   IT IS USED FOR RANDOM VECTOR FIRST AND J TO PROJECT OUT ONLY
C    IT APPLIES J-J+ OPERATORS TO COEF0 AND RETURNS RESULT IN COEF.
CA   COEF IS THEN,THE OUTPUT OF THE SUBROUTINE
CA   J-J+ IS TAKEN AS A SUM OVER NNM(NNP)SINGLE PARTICLE J- (J+)
CA   OPERATORS. SEE DO LOOPS 300 AND 200.
CA   INITIALLY WE HAVE SOME WAVEFUNCTION |W>=SUMi COEF0(i)IBASIS(i)
CA   RETURNS J-J+|W>= SUMi COEF(i)IBASIS(i)

      KEEP_SUM(0)=0 
      IARG_KEEP(0)=0 
      NBLOCKS=0 
      LLL = 1 
CA  NP_DIFF IS AN ARRAY WITH ALL POSSIBLE DIFFERENT PROTON PARTITIONS,
CA  IPA PRESENT PROTON PARTITION. THEY ARE ARBITRARILY NUMBERED FROM 1 TO
CA  MAX_IPROT
CA  IARG PRESENT NUMBER OF COEFFICIENTS - 1 STORED FOR EACH OF THE PROTON 
CA  PARTITIONS
CA  IARG_KEEP NUMBER OF COEFFICIENTS FOR EACH PROTON PARTITION. IT IS
CA  EQUAL TO IARG -1 WHEN UNIT 21 IS NOT USED, OR ELSE THE SUM OVER IARG
CA  OVER THE PRESENT AND WRITTEN RECORDS
CA  KEEP_SUM SUM OF IARG_KEEP(IPA) FOR I.LE.IPA
CA  IARGO LIKE KEEP-SUM BUT ONLY OVER THE RECORDS READ AT ANY GIVEN MOMENT

      DO 10001  IPA=1,NDIFFM 
      IARGO(IPA)=0 
      IARG_KEEP(IPA)=0 
      IARG(IPA)=1 
      KEEP_SUM(IPA)=0 
C      END DO 
10001 CONTINUE    

      NDIM2B=NDM2P/2 

CA   START OF THE LOOP OVER THE BASIS STATES

      DO 400 JJ=1,NDIMII 
CA  SORT OUT THE PROTON PARTITION TO STORE IT.
      DO 10002  IPA=1,NDIFFM 
      IF(LIB_EQX(NP_DIFF(1,IPA),IPROT(1,JJ),N_WORDS))GO TO 12 
C      END DO 
10002 CONTINUE    
      STOP ' JMJP0: ONE PROTON PARTITION IS NOT IN THE TABLE' 
12    CONTINUE 
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(IBASIS(1,JJ),JPATRN(1),NLWRDS) 
      IF(IMAC.EQ.0) JPATRN(1)=IBASIS(1,JJ) 
      NPTCLE=0 


CA   NEXT DO LOOP FINDS WHERE THE PARTICLES IN JPATRN ARE.FINDS IN WHAT SINGLE
CA   PARTICLE STATES THEY ARE AND STORES THE RESULT IN IPOSN.


      DO 10003  I=1,NLWRDS 
      NSTART=0 
CA  SEE RUNTIME MANUAL FOR SUBROUTINE LIB$FFS.SHORTLY,IT FINDS THE
CA  FIRST BIT IN JPATRN(1) THAT OCCURS FROM POSITION NSTART ONWARDS.
CA  IT RETURNS THE POSITION  OF THE FIRST OCCURENCE IN N.
CWEO20    IF(.NOT.LIB$FFS(NSTART,32,JPATRN(I),N))GO TO 10 
CWEO LIB$FFS REPLACED 30 APRIL 1986 WITH SHELL-MODEL LIBRARY ROUTINE
CWEO LIB_WHERE_BIT SO THAT COMPATABILITY WITH OTHER COMPUTERS IS POSSIBLE
20    IF(.NOT.LIB_WHERE_BIT(NSTART,MAX_BIT_NLWRDS,JPATRN(I),N))GO TO 10 
CWEO      IF(N.GT.31)GO TO 10 
      IF(N.GT.(MAX_BIT_NLWRDS-1))GO TO 10 
      NSTART=N+1 
      NPTCLE=NPTCLE+1 
CWEO      IPOSN(NPTCLE)=NSTART+(I-1)*32 
      IPOSN(NPTCLE)=NSTART+(I-1)*MAX_BIT_NLWRDS
      GO TO 20 
10    CONTINUE 
C      END DO 
10003 CONTINUE    


CA   WE SHALL NOW APPLY J+(DO 300)AND THEN J-(DO 200)

      DO 300  NNP=1,NPTCLE 
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(JPATRN(1),IPATRN(1),NLWRDS) 
      IF(IMAC.EQ.0) IPATRN(1)=JPATRN(1) 
C                          NP POSITION WHERE PARTICLE IS 
      NP=IPOSN(NNP)       

CA   JP TELLS WHAT PATTERN WE GET WHEN WE APPLY J+(NNP) TO IPATRN.
CA   J+(NNP) IS APPLIED ONLY ON PARTICLE IN POSITION NP AND IT
CA   MOVES IT TO POSITION JP.
      JP=JPLUS(NP) 
      IF(JP.EQ.0)GO TO 300 
      IF(IMAC.NE.0) GO TO 5040 
      IBAB=0 
      IF(IAND(IPATRN(1),2**(JP-1)).NE.0) IBAB=1 
CWEO      IPATRN(1)=IPATRN(1).OR.2**(JP-1) 
      IPATRN(1)=IOR(IPATRN(1),2**(JP-1)) 
      IF(IBAB.EQ.1) GO TO 300 
      GO TO 5041 
5040  CONTINUE 
      IF(LIB_BTSX(IPATRN(1),JP-1,NLWRDS))GOTO 300 
5041  CONTINUE 

CA   WE HAVE JUST CHECKED (and set) THAT THE PLACE IS EMPTY,SO NOW CHANGE THE
CA   PLACE OF THE PARTICLE.

CZ      CALL LIB_BTCX(IPATRN(1),NP-1,NLWRDS) 
      IF(LIB_BTCX(IPATRN(1),NP-1,NLWRDS)) GOTO 9012
9012  CONTINUE
CZ 
CWEO      IF(IMAC.EQ.0) IPATRN(1)=IPATRN(1).AND..NOT.2**(NP-1) 


CA   NEXT FEW LINES,UP TO LABEL 110 IS THE FIND SUBROUTINE.IF YOU
CA   WANT THE COMMENTED VERSION SEE FINDP.FOR.

      N=NDIMP 
      IF(IMAC.NE.0) GO TO 5030 
      IF(IPATRN(1).EQ.IBASISP(1,N))GO TO 110 
      GO TO 5031 
5030  CONTINUE
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110 
5031  CONTINUE 
      N=NDIM2B 
      M=N 
      IF(IMAC.NE.0) GO TO 5050 
      IF(IPATRN(1).LT.IBASISP(1,N))GO TO 101 
      IF(IPATRN(1).EQ.IBASISP(1,N))GO TO 110 
      GO TO 5051 
5050  IF(LIB_LTX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 101 
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110 
5051  CONTINUE 
      M=M/2 
      N=NDIMP-M 
      GO TO 102 
101   M=M/2 
      N=N-M 

CA   **********************************************************************
102   IF(M.EQ.0)THEN 
      WRITE(6,'(1X,''Initial pattern'')') 
       CALL BWRITE(6,NSPS,NLWRDS,JPATRN) 
      WRITE(6,'(1X,''Final pattern'')') 
       CALL BWRITE(6,NSPS,NLWRDS,IPATRN) 
       WRITE(6,335)NP,JP 
335    FORMAT(' NP,JP = ',2I4) 
      NMAX=MIN(100,NDIMP) 
      WRITE(6,'(1X,''BASIS'')') 
      DO 10004  I=1,NMAX 
       CALL BWRITE(6,NSPS,NLWRDS,IBASISP(1,I)) 
C      END DO 
10004 CONTINUE    
       STOP 'ERROR IN JMJP0:  
     1A BASIS PATTERN HAS NOT BEEN FOUND-ARRAYS DIMENSIONS COULD  
     1BE WRONG. COMPILE WITH CHECK SWITCH' 
      END IF 
CA   *********************************************************************

      IF(IMAC.NE.0) GO TO 5060 
      IF(IPATRN(1).LT.IBASISP(1,N))GO TO 101 
      IF(IPATRN(1).EQ.IBASISP(1,N))GO TO 110 
      GO TO 5061 
5060  IF(LIB_LTX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 101 
      IF(LIB_EQX(IPATRN(1),IBASISP(1,N),NLWRDS))GO TO 110 
5061  CONTINUE 
      M=M/2 
      N=N+M 
      GO TO 102 
110   CONTINUE 
CA   WORK OUT THE PHASE
      IPHASP=1 
      IF(IMAX.EQ.0)THEN 
      IF(IMAC.NE.0) GO TO 5070 
      IF(IAND(JPATRN(1),2**NP).NE.0)IPHASP=-1 
      GO TO 5071 
5070  IF(LIB_BTX(JPATRN(1),NP,NLWRDS))IPHASP=-1 
5071  CONTINUE 
      END IF 
      IF(FACP(NP).EQ.0)STOP ' ***** FATAL ERROR in JMJP: FACP.EQ.0 *****
     1' 
CJ   *********************************************************************
      IF(IARG(IPA).LT.MAX_STORE)THEN 
       IPACK=NP+NSPS*((1-IPHASP)/2) 
       NPSTORE(IARG(IPA),IPA)=IPACK 
       JJSTORE(IARG(IPA),IPA)=JJ 
       NSTORE (IARG(IPA),IPA)=N 
      ELSE
c      type 7777,NP,NSPS,IPHASP,IPACK,IPA,JJ,N
c7777  FORMAT(1X,8I10) 
       IPACK=NP+NSPS*((1-IPHASP)/2) 
       NPSTORE(IARG(IPA),IPA)=IPACK 
       JJSTORE(IARG(IPA),IPA)=JJ 
       NSTORE (IARG(IPA),IPA)=N 
       LLL=LLL+1 
       LTEST=LLL 
       IARG(IPA)=IARG(IPA)+1 
       NBLOCKS=NBLOCKS+1 
       WRITE(21)(IARG(I),I=1,NDIFFM) 
       WRITE(21)((NPSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((JJSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((NSTORE (I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       DO 10005  I=1,NDIFFM 
       IARG_KEEP(I)=IARG_KEEP(I)+IARG(I)-1 
       IARG(I)=1 
C       END DO 
10005  CONTINUE    
       GO TO 300 
      ENDIF 
      LLL=LLL+1 
      IARG(IPA)=IARG(IPA)+1 
CJ   *********************************************************************
300   CONTINUE 
400   CONTINUE 
       DO 10006  IPA=1,NDIFFM 
       IARG_KEEP(IPA)=IARG_KEEP(IPA)+IARG(IPA)-1 
       KEEP_SUM(IPA)=KEEP_SUM(IPA-1)+IARG_KEEP(IPA) 
C       END DO 
10006  CONTINUE    
       IF(LLL-1.GT.MAX_IPROT*MAX_STORE)THEN 
        WRITE(6,501)LLL-1 
501     FORMAT(' JMJP0: INCREASE MAX_IPROT*MAX_STORE TO =',I10) 
        STOP 
       END IF 
      IF(NBLOCKS.GT.0.AND.LTEST.NE.LLL)THEN 
       NBLOCKS=NBLOCKS+1 
       WRITE(21)(IARG(IPA),IPA=1,NDIFFM) 
       WRITE(21)((NPSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((JJSTORE(I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
       WRITE(21)((NSTORE (I,J),I=1,IARG(J)-1),J=1,NDIFFM) 
      ENDIF 
CA  READ THEM ORDERLY AND DUMP THEM IN THE TABLES AVOINDING THE BLANKS
CA  INITIALLY WE DIMENSIONED THE ARRAYS IN MAX_IPROT BLOCKS OF MAX_STORE
CA  PLACES EACH. THE WRITING IN UNIT 21 WAS PERFORMED IN ORDER TO DIVIDE 
CA  THE PLACES
CA  ACCORDING TO THE REAL DIMENSIONS OF THE DIFFERENT PROTON PARTITIONS. AT
CA  THIS STAGE WE KNOW THESE DIMENSIONS AND HAVE STORED THEM IN IARG_KEEP.
      IF(NBLOCKS.GT.0)THEN 
       REWIND 21 
      DO 10007  NB=1,NBLOCKS 
       READ(21)(IARG(IPA),IPA=1,NDIFFM) 
       READ(21)((TABLENP(I+IARGO(IPA)), 
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1), 
     2  IPA=1,NDIFFM) 
       READ(21)((TABLEJJ(I+IARGO(IPA)), 
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1), 
     2  IPA=1,NDIFFM) 
       READ(21)((TABLEN(I+IARGO(IPA)), 
     1  I=KEEP_SUM(IPA-1)+1,KEEP_SUM(IPA-1)+IARG(IPA)-1), 
     2  IPA=1,NDIFFM) 
      DO 10008  IPA=1,NDIFFM 
      IARGO(IPA)=IARG(IPA)+IARGO(IPA)-1 
C      END DO 
10008 CONTINUE    
C      END DO   
10007 CONTINUE    
      END IF 
      IF(NBLOCKS.GT.0)WRITE(6,551)PRJFIL(1:LONGP),LLL-1 
551   FORMAT(1X,A9,'.JJ FILE HAS BEEN OPENED'/ 
     1' NO. OF PROJECTION COEFFICIENTS = ',I10) 
CA  SET UP DO LOOP LIMITS FOR JMJP1 AND JMJP2
      ISTART(1)=1 
      DO 10009  IPA=2,NDIFFM 
      IF(NBLOCKS.EQ.0)THEN 
       ISTART(IPA)=ISTART(IPA-1)+MAX_STORE 
      ELSE 
       ISTART(IPA)=ISTART(IPA-1)+IARG_KEEP(IPA-1) 
      END IF 
C      END DO 
10009 CONTINUE    
CZ      CLOSE(21) 
C  Entry JMJP1 and then return
       
      ENTRY JMJP1 
CA SUBROUTINE FOR ADMIXTURE OF PROTON PARTITIONS
C  Apply J+
      DO 10010  IPAR1=1,NDIFFM 
      DO 10011  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF_JP(TABLEN(J))=COEF_JP(TABLEN(J))+FACP(TABLENP(J))* 
     1               COEF0(TABLEJJ(J)) 
C      END DO 
10011 CONTINUE    
C      END DO 
10010 CONTINUE    
C  Now apply J-
      DO 10012  IPAR1=1,NDIFFM 
      DO 10013  J=ISTART(IPAR1),ISTART(IPAR1)+IARG_KEEP(IPAR1)-1 
      COEF(TABLEJJ(J))=COEF(TABLEJJ(J))+FACP(TABLENP(J))* 
     1               COEF_JP(TABLEN(J)) 
C      END DO 
10013 CONTINUE    
C      END DO 
10012 CONTINUE    

      DO 10014  IW=1,NDIMP 
      COEF_JP(IW)=0. 
C      END DO 
10014 CONTINUE    

      RETURN 

      ENTRY JMJP2(IPAR) 
CA  SUBROUTINE FOR GOOD PROTON PARTITION STATES
C  Apply J+
      DO 10015  J=ISTART(IPAR),ISTART(IPAR)+IARG_KEEP(IPAR)-1 
      IF(COEF0(TABLEJJ(J)).NE.0) 
     1COEF_JP(TABLEN(J))=COEF_JP(TABLEN(J))+FACP(TABLENP(J))* 
     1               COEF0(TABLEJJ(J)) 
C      END DO 
10015 CONTINUE    
C  Now apply J-
      DO 10016  J=ISTART(IPAR),ISTART(IPAR)+IARG_KEEP(IPAR)-1 
      IF(COEF_JP(TABLEN(J)).NE.0) 
     1COEF(TABLEJJ(J))=COEF(TABLEJJ(J))+FACP(TABLENP(J))* 
     1               COEF_JP(TABLEN(J)) 
C      END DO 
10016 CONTINUE    

      DO 10017  IW=1,NDIMP 
      COEF_JP(IW)=0. 
C      END DO 
10017 CONTINUE    

      RETURN 
      END 
