
      SUBROUTINE CROSS
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'trpcom.inc'
      DIMENSION IBASIS(MAX_NLWRDS),NBSIS2(MAX_NLWRDS),IPAT1(MAX_NLWRDS)
      INCLUDE 'data.inc'
      integer*2 one
 
CBAB *** IMAC>0 WILL USE ALL MACRO ROUTINES FOR NLWRDS
CBAB *** IMAC=0 WILL USE SOME FORTRAN ROUTINES FOR NLWRDS
 
      one = 1
      IF(NSPS1.LE.IMAC_NSPS) IMAC = 0
      IF(NSPS1.GT.IMAC_NSPS) IMAC = 1
 
CBAB *** ENTER ICI
 
      IF (USE_STORE) GOTO300
      IENTRY=IENTRY+1
      IF (IENTRY.GT.MAX_ENTRY) WRITE(6,555)IENTRY,MAX_ENTRY
  555 FORMAT(1X,'IENTRY,MAX_ENTRY=',2I4)
      IF (IENTRY.GT.MAX_ENTRY) STOP ' ***** FATAL ERROR in CROSS:
     1INCREASE MAX_ENTRY *****'
      ISTART(IENTRY)=KSTORE+1
 
      DO 200 IB2=1,NDIM2
      CALL LIB_SHIFTX(IBAS2(1,IB2),NSHIFT,IBAS2(1,IB2),NLWRDS)
      DO 200 IB3=1,NDIM3
 
CBAB  *** CHECK TO SEE IF THERE IS A BIT TO BE DESTROYED. FOR OBTD.: IBAS3 HAS
CBAB  *** TWO BITS(OR NONE):ONE FOR THE PARTICLE TO BE CREATED AND ONE
CBAB  *** FOR THE PARTICLE TO BE DESTROYED.IBAS4 HAS ONLY ONE BIT:IT IS
CBAB  *** IN THE PLACE OF THE PARTICLE TO BE DESTROYED.
CBAB  *** IBAS3 & IBAS4 COMPLETELY DETERMINED THE OBTD OPERATOR
 
CBAB  *** CHECK  FOR PARTICLE TO BE DESTROYED
 
      IF(IOBTD.GT.0)THEN
      IF(IMAC.NE.0) GO TO 5050
      IPAT1(1)=IAND(IBAS2(1,IB2),IBAS4(1,IB3))
      IF(IPAT1(1).NE.IBAS4(1,IB3))GO TO 200
      GO TO 5051
 5050 CALL LIB_ANDX(IBAS2(1,IB2),IBAS4(1,IB3),IPAT1(1),NLWRDS)
      IF(LIB_NEX(IPAT1(1),IBAS4(1,IB3),NLWRDS))GO TO 200
 5051 CONTINUE
      END IF
      IF(IMAC.NE.0) GO TO 5060
      IBASIS(1)=IEOR(IBAS2(1,IB2),IBAS3(1,IB3))
      GO TO 5061
 5060 CALL LIB_XORX(IBAS2(1,IB2),IBAS3(1,IB3),IBASIS(1),NLWRDS)
 5061 CONTINUE
 
CBAB** Count number of bits in ibasis, equivalent to check place(s) of
CBAB** particle(s) to be created
 
      IF(LIB_BITSX(IBASIS(1),NLWRDS).NE.NBIT1)GO TO 200
 
CBAB ** NEXT LINES ARE SUBROUTINE FINDB.
CBAB ** FOR A COMMENTED VERSION SEE FINDP.FOR
 
      N=NDIM1
      IF(IMAC.NE.0) GO TO 5070
      IF(IBASIS(1).EQ.IBAS1(1,N)) GO TO 110
      GO TO 5071
 5070 IF(LIB_EQX(IBASIS(1),IBAS1(1,N),NLWRDS)) GO TO 110
 5071 CONTINUE
      N=NDIM12/2
      M=N
      IF(IMAC.NE.0) GO TO 5080
      IF(IBASIS(1).LT.IBAS1(1,N))GO TO 101
      IF(IBASIS(1).EQ.IBAS1(1,N))GO TO 110
      GO TO 5081
 5080 IF(LIB_LTX(IBASIS(1),IBAS1(1,N),NLWRDS))GO TO 101
      IF(LIB_EQX(IBASIS(1),IBAS1(1,N),NLWRDS))GO TO 110
 5081 CONTINUE
      M=M/2
      N=NDIM1-M
      GO TO 102
  101 M=M/2
      N=N-M
  102 IF(M.EQ.0) GO TO 200
      IF(IMAC.NE.0) GO TO 5090
      IF(IBASIS(1).LT.IBAS1(1,N))GO TO 101
      IF(IBASIS(1).EQ.IBAS1(1,N))GO TO 110
      GO TO 5091
 5090 IF(LIB_LTX(IBASIS(1),IBAS1(1,N),NLWRDS))GO TO 101
      IF(LIB_EQX(IBASIS(1),IBAS1(1,N),NLWRDS))GO TO 110
 5091 CONTINUE
      M=M/2
      N=N+M
      GO TO 102
  110 IB1=N
 
CBAB  *** BASIS STATE FOUND - NOW FIND THE PHASE
CBAB    It moves bits in ibsis2 one place at a time by dividing by two
CBAB    (more exactly by a logical shift). Finds with an .AND.
CBAB    instruction if a bit passes though a bit in the wfn of the
CBAB    operator (ibsis3): this is stored in ipat1. Next, no. of odd
CBAB    passes is stored in ibasis. See that it is an .XOR. rather
CBAB    than an .OR. so even number of passes are cancelled out.
CBAB    Finally the odd number of passes is counted by CBIT
CBAB    (i.e. no. of bits in ibasis)
 
      IF(IMAC.EQ.0) NBSIS2(1)=IBAS2(1,IB2)
      IF(IMAC.EQ.0) IBASIS(1)=ZERO(1)
      IF(IMAC.EQ.0) IPAT1(1)=ZERO(1)
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(IBAS2(1,IB2),NBSIS2(1),NLWRDS)
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(ZERO(1),IBASIS(1),NLWRDS)
      IF(IMAC.NE.0) CALL LIB_ASSIGNX(ZERO(1),IPAT1(1),NLWRDS)
      DO 150 N=1,NSPS1
      CALL LIB_SHIFTX(NBSIS2(1),-1,NBSIS2(1),NLWRDS)
      IF(IMAC.EQ.0) IPAT1(1)=IAND(NBSIS2(1),IBAS3(1,IB3))
      IF(IMAC.EQ.0) IBASIS(1)=IEOR(IPAT1(1),IBASIS(1))
      IF(IMAC.NE.0)
     1CALL LIB_ANDX(NBSIS2(1),IBAS3(1,IB3),IPAT1(1),NLWRDS)
      IF(IMAC.NE.0)
     1CALL LIB_XORX(IBASIS(1),IPAT1(1),IBASIS(1),NLWRDS)
  150 CONTINUE
      NUM_BITS=LIB_BITSX(IBASIS(1),NLWRDS)
      NBIT=LIB_BITSX(IBASIS(1),NLWRDS)
      IPHASE=1-2*MOD(NBIT,2)
 
CBAB  *** NOW INCREMENT OVERLAP
 
      OLAP(ILAP)=OLAP(ILAP)+IPHASE*COEF1(IB1)*COEF2(IB2)*COEF3(IB3)
 
 
      IF(MAX_STORE.NE.0) KSTORE=KSTORE+1
 
CBAB  ************************************************
CBAB
CBAB IF PROBLEM WITH MAX_STORE COMMMENT OUT ABOVE
CBAB INCREMENT
CBAB
CBAB  ************************************************
 
      IF(KSTORE.GT.MAX_STORE) GO TO 5000
      GO TO 5001
 5000 WRITE(6,5002)KSTORE,MAX_STORE
 5002 FORMAT(1X,'***** FATAL ERROR in CROSS: INCREASE MAX_STORE OR
     1 REPLACE TRAMP BY TRAMPZ *****'
     1/,1X,'KSTORE,MAX_STORE = ',2I9)
      STOP
 5001 CONTINUE
      IADR1(KSTORE)=IB1
      IADR2(KSTORE)=IB2
      IADR3(KSTORE)=IB3*IPHASE
 
  200 CONTINUE
 
CBAB *** RETURN AQUI
 
      IFIN(IENTRY)=KSTORE
      RETURN
 
 
  300 IENTRY=IENTRY+1
      IF (ISTART(IENTRY).GT.IFIN(IENTRY))RETURN
      DO 301  I=ISTART(IENTRY),IFIN(IENTRY)
      KSTORE=KSTORE+1
      IB1=IADR1(KSTORE)
      IB2=IADR2(KSTORE)
      IB3=IABS(IADR3(KSTORE))
      IPHASE=ISIGN(one,IADR3(KSTORE))
      OLAP(ILAP)=OLAP(ILAP)+IPHASE*COEF1(IB1)*COEF2(IB2)*COEF3(IB3)
  301 CONTINUE
      RETURN
      END
