C  THIS PROGRAM MAKES UP 1 & 2 PARTICLE WAVEFUNCTIONS
C  FIRST CALL TO SET UP IPART3(),NLAP,NPART3
C  SECOND CALL PARTITION GIVEN:
C     LOOP OVER JAY3,ITT3
C     MAKE UP IBAS3(),COEF3()
C     SET ILAP AND CALL CROSS
C
C
C
      SUBROUTINE SPEC(ICORE)
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'trpcom.inc'
caix
	character*4 pa1,pa2
      COMMON/CDJ/IREST,DJMIN,DJMAX,DTMIN,DTMAX
      DIMENSION OLAP2(MAX_OLAP),SOLAP2(MAX_OLAP),ELOLF(10)
      DIMENSION JTWPA(MAX_NJL),JLP1A(MAX_NPART),JLP2A(MAX_NPART),
     1IPTP1(N_WORDS),IPTP2(N_WORDS)
      INCLUDE 'data.inc'
 
      IF (ICALL.GT.0)GOTO10
CBAB  ***                           Writes to disk and to lpt
      IF (ICALL.LT.0) GO TO 24
      ICALL=1
 
CEKW  ***                           For energy centroids
      ELOLI = 0.0
      DO 1, I = 1,NPART3
      ELOLF(I) = 0.0
    1 CONTINUE
CEKW  ***************************************************
C
CBAB  ***  READ IN S-P STATE FILE FOR PARENTAGE AMPLITUDES AND
CBAB  ***  TRANSITION DENSITY CALCULATION
C
      IF (NSPS1.NE.NSPS2) GO TO 900
      CALL FREE_REAL_A(24,NJL1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      NS=0
      DO 2 I=1,NJL1
      JLST(I)=NS+1
      DO 2 JL=1,NPJ1(I)
      NS=NS+1
      CALL FREE_INT(24,6,INT_VAR,READ_ERR)
      NQU(I)=INT_VAR(2)
      LQU(I)=INT_VAR(3)
      JTW(I)=INT_VAR(4)
      MZTW(NS)=INT_VAR(5)
      ITZTW(NS)=INT_VAR(6)
    2 CONTINUE
      IMZS3=IMZS1-IMZS2
      ITZS3=ITZS1-ITZS2
      IF (IOBTD.GT.0) GO TO 5
      IF (ILPT.GT.0) WRITE(3,3) ISPEC
    3 FORMAT('1'///' ',I1,' - PARTICLE PARENTAGE AMPLITUDES'//)
 
CBAB  PARENTAGE AMPLITUDES ARE THE COEFF. OF FRACTIONAL PARENTAGE
CBAB  MULTIPLIED BY SQUARE ROOT OF THE STATISTICAL FACTOR ( A )
CBAB                                                      ( k ) .
CBAB  SPECTROSCOPIC AMPLITUDES ARE THE PARENTAGE AMPLITUDES TIMES
CBAB  THE G FACTOR (OVERLAP OF RADIAL WFNS) AND THE MASS FACTOR -
CBAB  SEE PHYS.REP. 12C, 227 (1974). THIS PROGRAM OUTPUTS THAT IN
CBAB  CURLY BRACKETS IN THE NOTED REPORT & PAGE,I.E.,EQ.5.6
 
      IF (ISPEC.GT.1) GO TO 7
C
CBAB  ***  SINGLE-PARTICLE SPECTROSCOPIC FACTORS
C
      NDIM3=1
      ITT3=1
      IF (IABS(ITT1-ITT2).NE.1) GO TO 900
      NPART3=0
      JVMIN=IABS(JAY1-JAY2)
      DO 4 JLP1=1,NJL1
      CALL LIB_ASSIGNX(ZEROP(1),IPTP1(1),N_WORDS)
      IPTP1(JLP1)=1
      KKPAR1=KPAR1
      JAY3=JTW(JLP1)
      IF (MOD(KPAR1+KPAR2+LQU(JLP1),2).NE.0) GO TO 4
      IF (JAY3.GT.(JAY1+JAY2)) GO TO 4
      IF (JAY3.LT.JVMIN) GO TO 4
      IF (JAY3.GT.JVMAX) JVMAX=JAY3
      NPART3=NPART3+1
      JLP1A(NPART3)=JLP1
      CALL LIB_ASSIGNX(IPTP1(1),IPART3(1,NPART3),N_WORDS)
    4 CONTINUE
      IF (NPART3.EQ.0) GO TO 900
      NLAP=NPART3
C
CBAB  *** OBPA (one body parentage amplitude) partitions are done
C
      RETURN
C
CBAB  ***  2-PARTICLE PARENTAGE AMPLITUDES AND TRANSITION DENSITIES
C
C
CBAB  ***  Set up operators
C
    5 IF (ILPT.GT.0) WRITE(3,6)
    6 FORMAT('1'///' ONE- BODY TRANSITION DENSITIES'/)
    7 ITMIN=IABS(ITT1-ITT2)
      ITMAX=MIN0(2,(ITT1+ITT2))
      IF(IABS(ITZS1-ITZS2).EQ.2) ITMIN = 2
      IF (ITMAX.LT.ITMIN) GO TO 900
      NPART3=0
      JVMIN=IABS(JAY1-JAY2)
      DO 9 JLP1=1,NJL1
      CALL LIB_ASSIGNX(ZEROP(1),IPTP1(1),N_WORDS)
C
CBAB  *** Work out the partition for a single particle
C
      IPTP1(JLP1)=1
      JTWP1=JTW(JLP1)
      DO 9 JLP2=1,NJL1
      IF ((IOBTD.EQ.0).AND.(JLP2.GT.JLP1)) GO TO 9
      CALL LIB_ASSIGNX(ZEROP(1),IPTP2(1),N_WORDS)
      IPTP2(JLP2)=1
      IF (MOD(KPAR1+KPAR2+LQU(JLP1)+LQU(JLP2),2).NE.0) GO TO 9
      JTWP2=JTW(JLP2)
      JMIN=MAX0(IABS(JTWP1-JTWP2),JVMIN)
      JMAX=MIN0((JTWP1+JTWP2),(JAY1+JAY2))
      IF (JMAX.LT.JMIN) GO TO 9
      IF (JMAX.GT.JVMAX) JVMAX=JMAX
      NPART3=NPART3+1
      JLP1A(NPART3)=JLP1
      JLP2A(NPART3)=JLP2
      DO 8 IW=1,NJL1
      IPART3(IW,NPART3)=IPTP1(IW)+(1-2*IOBTD)*IPTP2(IW)
    8 CONTINUE
 
CBAB  *** For OBPA its the sum and for OBTD the subtraction
 
    9 CONTINUE
      IF (NPART3.EQ.0) GO TO 900
      NLAP=NPART3*(JVMAX-JVMIN+2)
      IF (NLAP.GT.ISIZE4) GO TO 900
      NDEPTH=JVMAX-JVMIN+2
CWR   *** DONT KNOW IF NEXT TWO LINES ARE NEEDED ANY MORE
      NSTORE=ISIZE4/NDEPTH
      NSTORE=MIN0(NSTORE,ISIZE1-ISIZE2)
CWR   *** END ?
      IF (ICNTL.EQ.0) RETURN
      WRITE(1) NV1,NV2,JVMIN,JVMAX,ITMIN,ITMAX,
     1  NLAP,NPART3,(JLP1A(I),I=1,NPART3),(JLP2A(I),I=1,NPART3),
     2  NV1MIN,NV2MIN
      RETURN
   10 IF (ISPEC.EQ.2)GOTO14
 
CBAB  ***  Evaluate reduced matrix element & relevent C.G. coeff.
 
      JLP1=JLP1A(IP3)
      JAY3=JTW(JLP1)
      ILAP=IP3
      IA=JAY2
      IB=JAY3
      IC=JAY1
      ID=IMZS2
      IE=IMZS3
      IF=IMZS1
      CALL CLEBG
      CG=CLEB
      IF (CG.EQ.0.0) GO TO 900
      IA=ITT2
      IB=ITT3
      IC=ITT1
      ID=ITZS2
      IE=ITZS3
      IF=ITZS1
      CALL CLEBG
 
CBAB   *** ICORE=1 INDICATES PN FORMALISM
 
      IF(ICORE.EQ.1) CLEB = 1.
      IF (CLEB.EQ.0.0D0) GO TO 900
      CG=CLEB*CG
      COEF3(1)=1.0/CG
      DO 13 NSP1=JLST(JLP1),NPJ1(JLP1)+JLST(JLP1)
      IF (MZTW(NSP1).NE.IMZS3) GO TO 13
      IF (ITZTW(NSP1).NE.ITZS3) GO TO 13
      IF (USE_STORE) GOTO12
      CALL LIB_ASSIGNX(ZERO(1),IBAS3(1,1),NLWRDS)
      IF(LIB_BTSX(IBAS3(1,1),NSP1-1,NLWRDS)) GOTO11
   11 CONTINUE
 
C
CBAB  *** Above is the basis for OBPA
C
   12 CALL CROSS
   13 CONTINUE
      RETURN
 
   14 JLP1=JLP1A(IP3)
      JLP2=JLP2A(IP3)
      JTWP1=JTW(JLP1)
      JTWP2=JTW(JLP2)
      JMIN=MAX0(IABS(JTWP1-JTWP2),JVMIN)
      JMAX=MIN0((JTWP1+JTWP2),(JAY1+JAY2))
      SYMFAC=1.0
      IF ((JLP1.EQ.JLP2).AND.(IOBTD.EQ.0)) SYMFAC=SQRT(2.0)
C
CBAB  *** Set up for two body wfns, ISPEC=2
C
      IF (ICALL.NE.10) GO TO 70
C
CBAB  *** DO ALL 2-PARTICLE COUPLING
C
      NDIM33=0
      DO 18 JAY3=JMIN,JMAX,2
      DO 18 ITT3=ITMIN,ITMAX,2
      IBAB=0
      IF(IREST.EQ.1.AND.JAY3.LT.2*DJMIN) IBAB=1
      IF(IREST.EQ.1.AND.JAY3.GT.2*DJMAX) IBAB=1
      IF(IREST.EQ.1.AND.ITT3.LT.2*DTMIN) IBAB=1
      IF(IREST.EQ.1.AND.ITT3.GT.2*DTMAX) IBAB=1
      IF ((SYMFAC.GT.1.1).AND.MOD((JAY3+ITT3),4).NE.2) GO TO 18
      IF(IBAB.EQ.1) SCGFAC=0.
      IF(IBAB.EQ.1) GO TO 15
      OBFAC=SQRT((JAY1+1.0)*(ITT1+1.0)/((JAY3+1.0)*(ITT3+1.0)))
      IA=JAY2
      IB=JAY3
      IC=JAY1
      ID=IMZS2
      IE=IMZS3
      IF=IMZS1
      CALL CLEBG
      CG=CLEB
      IF (CG.EQ.0.0) GO TO 900
      IA=ITT2
      IB=ITT3
      IC=ITT1
      ID=ITZS2
      IE=ITZS3
      IF=ITZS1
      CALL CLEBG
      IF (CLEB.EQ.0.0D0) GO TO 900
      CG=CLEB*CG
      SCGFAC=SYMFAC/CG
   15 CONTINUE
C
CBAB  *** MAKE  [J1,J2]  COUPLED TO JAY3,ITT3  WAVEFUNCTION
C
      DO 17 NSP1=JLST(JLP1),NPJ1(JLP1)+JLST(JLP1)-1
      MZTWP1=MZTW(NSP1)
      ITZTP1=ITZTW(NSP1)
      MZTWP2=(IMZS3-MZTWP1)
      ITZTP2=(ITZS3-ITZTP1)
      print*,'SPEC:'
      DO 17 NSP2=JLST(JLP2),NPJ1(JLP2)+JLST(JLP2)-1
         print*,'  iobtd, nsp2, nsp1 = ',iobtd,nsp2,nsp1
         print*,'  mztw(',nsp2,') = ',MZTW(NSP2)
         print*,'  mztwp2*(1-2*iobtd) = ',MZTWP2*(1-2*IOBTD)
         print*,'  itztw(',nsp2,') = ',ITZTW(NSP2)
         print*,'  itztp2*(1-2*iobtd) = ',ITZTP2*(1-2*IOBTD)
      IF ((IOBTD.EQ.0).AND.(NSP2.GE.NSP1)) GO TO 17
      IF (MZTW(NSP2).NE.MZTWP2*(1-2*IOBTD)) GO TO 17
      IF (ITZTW(NSP2).NE.ITZTP2*(1-2*IOBTD)) GO TO 17
      IF(IBAB.EQ.1) GO TO 16
      IA=JTWP1
      IB=JTWP2
      IC=JAY3
      ID=MZTWP1
      IE=MZTWP2
      IF=IMZS3
      CALL CLEBG
      CG2P=CLEB
      IA=1
      IB=1
      IC=ITT3
      ID=ITZTP1
      IE=ITZTP2
      IF=ITZS3
      CALL CLEBG
      SEX=-1.0
      IF((IOBTD.GT.0).AND.(NSP2.LE.NSP1)) SEX=1.0
      IF (IOBTD.GT.0) SEX=SEX*(1-2*IABS(MOD((JTWP2+1
     1+MZTWP2+ITZTP2)/2,2)))*OBFAC
   16 CONTINUE
      NDIM33=NDIM33+1
      WFN(NDIM33)=CLEB*CG2P*SCGFAC*SEX
   17 CONTINUE
      IF (NDIM33.EQ.0) STOP ' ***** FATAL ERROR in SPEC:
     1NDIM33=0 *****'
   18 CONTINUE
 
      IF (NDIM33.GT.MAX_OPERATOR)STOP ' *****FATAL ERROR in
     1SPEC: NDIM3>MAX_OPERATOR *****'
      RETURN
C
CBAB  ***   GET OVERLAPS USING STORED WAVEFUNCTION COEFFICIENTS
C
 
70    IOLPST=(IP3-1)*NDEPTH+1
 
C
CBAB  ***   LOOP OVER J, T
C
      NDM3=0
      DO 23 JAY3=JMIN,JMAX,2
      DO 23 ITT3=ITMIN,ITMAX,2
      IF ((SYMFAC.GT.1.1).AND.MOD((JAY3+ITT3),4).NE.2) GO TO 23
      ILAP=IOLPST+JAY3-JVMIN+ITT3/2
      NDIM3=0
      DO 22 NSP1=JLST(JLP1),NPJ1(JLP1)+JLST(JLP1)-1
      MZTWP1=MZTW(NSP1)
      ITZTP1=ITZTW(NSP1)
      MZTWP2=(IMZS3-MZTWP1)
      ITZTP2=(ITZS3-ITZTP1)
      DO 22 NSP2=JLST(JLP2),NPJ1(JLP2)+JLST(JLP2)-1
      IF ((IOBTD.EQ.0).AND.(NSP2.GE.NSP1)) GO TO 22
      IF (MZTW(NSP2).NE.MZTWP2*(1-2*IOBTD)) GO TO 22
      IF (ITZTW(NSP2).NE.ITZTP2*(1-2*IOBTD)) GO TO 22
      NDM3=NDM3+1
      IF (WFN(NDM3).EQ.0.0) GO TO 22
      NDIM3=NDIM3+1
      COEF3(NDIM3)=WFN(NDM3)
C
CBAB  *** Set up basis for operator, IBAS4 labels the hole
C
      IF (USE_STORE) GO TO 22
      CALL LIB_ASSIGNX(ZERO(1),IBAS3(1,NDIM3),NLWRDS)
      CALL LIB_ASSIGNX(ZERO(1),IBAS4(1,NDIM3),NLWRDS)
      IF(NSP1.NE.NSP2)THEN
      IF(LIB_BTSX(IBAS3(1,NDIM3),NSP1-1,NLWRDS)) GOTO 19
   19 CONTINUE
      IF(LIB_BTSX(IBAS3(1,NDIM3),NSP2-1,NLWRDS)) GOTO 20
   20 CONTINUE
      END IF
      IF(LIB_BTSX(IBAS4(1,NDIM3),NSP2-1,NLWRDS)) GOTO 21
   21 CONTINUE
 
   22 CONTINUE
      IF(IREST.EQ.1.AND.JAY3.LT.2*DJMIN) GO TO 23
      IF(IREST.EQ.1.AND.JAY3.GT.2*DJMAX) GO TO 23
      IF(IREST.EQ.1.AND.ITT3.LT.2*DTMIN) GO TO 23
      IF(IREST.EQ.1.AND.ITT3.GT.2*DTMAX) GO TO 23
      IF (NDIM3.EQ.0.OR.NDIM3.GT.ISIZE2) GO TO 900
      CALL CROSS
   23 CONTINUE
      IF (NDM3.NE.NDIM33) STOP ' ***** FATAL ERROR in SPEC:
     1NDM3#NDIM33 *****'
      RETURN
C
CBAB  *** OUTPUT
C
   24 IF(ISPEC.EQ.1)GOTO34
      IF (ILPT.LE.0)GOTO32
      IF (IOBTD.GT.0)
     1WRITE(3,25) NV2,EFIL2,ELEV2(NV2),NV1,EFIL1,ELEV1(NV1)
   25 FORMAT(///' INITIAL STATE :  VECTOR',I3,' OF ',A6,F10.3,
     1'  MEV'/  ' FINAL STATE   :  VECTOR',I3,' OF ',A6,F10.3,
     2'  MEV'///  ' CREATED  DESTROYED      COUPLED TO (J,T) =')
      IF (IOBTD.EQ.0)
     1WRITE(3,26) NV2,EFIL2,ELEV2(NV2),NV1,EFIL1,ELEV1(NV1)
   26 FORMAT(///' TARGET STATE   :  VECTOR',I3,' OF ',A6,F10.3,
     1'  MEV'/  ' RESIDUAL STATE :  VECTOR',I3,' OF ',A6,F10.3,
     2'  MEV'///  '  ORBIT 1     ORBIT 2       COUPLED TO (J,T) =')
      WRITE(3,27) ((JAY3,ITT3,JAY3=JVMIN/2,JVMAX/2,1),
     1ITT3=ITMIN/2,ITMAX/2,1)
   27 FORMAT('  K, N, L,2*J   K, N, L,2*J ',
     110(8(5X,'(',I2,',',I2,')')/))
      IF(NV1.EQ.1.AND.IDIAG.EQ.2)
     1 OPEN(UNIT=40,FILE=EFIL1//'.sp1',STATUS='NEW')
      IF(NV1.EQ.2.AND.IDIAG.EQ.2)
     1 OPEN(UNIT=40,FILE=EFIL1//'.sp2',STATUS='NEW')
      IF(NV1.EQ.3.AND.IDIAG.EQ.2)
     1 OPEN(UNIT=40,FILE=EFIL1//'.sp3',STATUS='NEW')
      IF(NV1.EQ.4.AND.IDIAG.EQ.2)
     1 OPEN(UNIT=40,FILE=EFIL1//'.sp4',STATUS='NEW')
      IF(NV1.EQ.5.AND.IDIAG.EQ.2)
     1 OPEN(UNIT=40,FILE=EFIL1//'.sp5',STATUS='NEW')
 
      DO 31 I=1,NPART3
      IOLPST=(I-1)*(JVMAX-JVMIN+2)+1
      I1=JLP1A(I)
      I2=JLP2A(I)
      JTWP1=IABS(JTW(I1))
      JTWP2=IABS(JTW(I2))
 
      IF(IDIAG.NE.2) GO TO 29
      IF(I1.NE.I2) GO TO 29
      NAA = NQU(I1)-1.
      LAA = LQU(I1)
      J2AA = JTWP1
      INDEX1 = ((2*NAA+LAA)*(2*NAA+LAA+3)-(J2AA-1)+2)/2
      OLAPBAB=OLAP(IOLPST)*(SQRT(J2AA+1.)/SQRT(JAY1+1.))
     1*(SQRT(2.)/SQRT(ITT1+1.))
      WRITE(40,28) INDEX1,OLAPBAB
   28 FORMAT(1X,I3,1X,F9.4)
   29 CONTINUE
 
      WRITE(3,30)
     1I1,NQU(I1),LQU(I1),JTWP1,I2,NQU(I2),LQU(I2),JTWP2,
     2((OLA(IOLPST+JAY3+ITT3/2),JAY3=0,JVMAX-JVMIN,2)
     3,ITT3=ITMIN,ITMAX,2)
   30 FORMAT(/1X,2(I2,',',I2,',',I2,',',I2,4X)
     1,10F10.7/100(20X,8F10.7/))
   31 CONTINUE
      IF(IDIAG.EQ.2) CLOSE(UNIT=40)
 
   32 IF (ICNTL.LE.0) RETURN
      IPOSL(1)=1
      K=0
      DO 33 I=1,NLAP
      IF (OLA(I).EQ.0.0) GO TO 33
      K=K+1
      OLA(K)=OLA(I)
      IPOSL(K)=I
   33 CONTINUE
      IF (K.EQ.0) K=1
C
CBAB  *** Main write statement for .TRD and .TBD files
      WRITE(1) NV1,NV2,K,(IPOSL(I),OLA(I),I=1,K)
CBAB  ************************************************
      RETURN
   34 IF (ILPT.GT.0)
     1WRITE(3,35) NV2,EFIL2,ELEV2(NV2),NV1,EFIL1,ELEV1(NV1)
   35 FORMAT(///' TARGET STATE   :  VECTOR',I3,' OF ',A6,F10.3,
     1'  MEV'/'   RESIDUAL STATE :  VECTOR',I3,' OF ',A6,F10.3,
     2'  MEV'//)
      DO 36 I=1,NJL1
   36 JTWPA(I)=IABS(JTW(I))
      IF (ILPT.GT.0) WRITE(3,37)
     1(NQU(JLP1A(I)),LQU(JLP1A(I)),JTWPA(JLP1A(I)),I=1,NPART3)
   37 FORMAT('  N, L, 2*J = ',10(I6,',',I2,',',I2))
      IF (ILPT.GT.0) WRITE(3,38) (OLAP(I),I=1,NPART3)
   38 FORMAT(/11X,10F10.5)
      DO 39 I=1,NPART3
      OLAP2(I) = OLAP(I)**2.
      SOLAP2(I) = SOLAP2(I) + OLAP2(I)
   39 CONTINUE
      IF(IFIRST40.NE.999) WRITE(32,47)
     1(NQU(JLP1A(I)),LQU(JLP1A(I)),JTWPA(JLP1A(I)),I=1,NPART3)
      IF(IFIRST40.NE.999) WRITE(33,47)
     1(NQU(JLP1A(I)),LQU(JLP1A(I)),JTWPA(JLP1A(I)),I=1,NPART3)
47    FORMAT(1X,'-- core state --- - overlap state -',2X,
     1 4('(',I1,1X,I1,1X,I2,')'),
     1 10(36X,4('(',I1,1X,I1,1X,I2,')')))
      IF(IFIRST40.NE.999) WRITE(32,48)
48    FORMAT(1X,'2J2T P   N     E  2J2T P   N     E    S ')
      IF(IFIRST40.NE.999) WRITE(33,50)
50    FORMAT(1X,'2J2T P   N     E  2J2T P   N     E    A ')
      IF(IFIRST40.NE.999) WRITE(32,49)GNDE2,GNDE1
      IF(IFIRST40.NE.999) WRITE(33,49)GNDE2,GNDE1
49    FORMAT(2X,2(6X,F10.3,2X))
      IF(EFIL1(4:4).EQ.'0') PA1 = '+'
      IF(EFIL1(4:4).EQ.'1') PA1 = '-'
      IF(EFIL2(4:4).EQ.'0') PA2 = '+'
      IF(EFIL2(4:4).EQ.'1') PA2 = '-'
      IF(IFIRST40.NE.999) IFIRST40 = 999
      WRITE(32,40)EFIL2(2:2),EFIL2(3:3),PA2,NV2,ELEV2(NV2),
     1EFIL1(2:2),EFIL1(3:3),PA1,
     1NV1,ELEV1(NV1),(OLAP2(I),I=1,NPART3)
      WRITE(33,40)EFIL2(2:2),EFIL2(3:3),PA2,NV2,ELEV2(NV2),
     1EFIL1(2:2),EFIL1(3:3),PA1,
     1NV1,ELEV1(NV1),(OLAP(I),I=1,NPART3)
   40 FORMAT(2X,2(A1,1X,A1,1X,A1,1X,I3,F8.3,1X),
     1 4(F7.4,1X),10(/,36X,4F7.4,1X))
 
      JCEN = 1
      IF(SOLAP2(1).EQ.0)JCEN = 2
      ELOLI = ELOLI + (ELEV2(NV2))*OLAP2(JCEN)
      DO 41,J=1,NPART3
      ELOLF(J) = ELOLF(J) + (ELEV1(NV1))*OLAP2(J)
   41 CONTINUE
      IF(NV1.EQ.NVEC1.AND.NV2.EQ.NVEC2)THEN
      ELOLI = ELOLI/SOLAP2(JCEN)
      DO 42, J = 1,NPART3
      IF(SOLAP2(J).EQ.0)THEN
      GOTO42
      ENDIF
      ELOLF(J) = ELOLF(J)/SOLAP2(J)
   42 CONTINUE
      WRITE(32,43)(SOLAP2(I),I=1,NPART3)
      WRITE(32,44)ELOLI,(ELOLF(I),I=1,NPART3)
      WRITE(32,46)
      WRITE(33,46)
46    FORMAT(//)
      ENDIF

   43 FORMAT(1X,'total = ',29X,
     1 4(F7.4,1X),1X,10(/,36X,4(F7.4,1X)))
   44 FORMAT(1x,'centroid =',F8.3,5x,
     1'centroids =',2X,
     1 4(F8.3),1X,10(/,36X,4(F8.3)))
   45 RETURN
 
900   IF (NLAP.GT.ISIZE4) STOP ' ***** FATAL ERROR in SPEC:
     1ISIZE4 TOO SMALL *****'
      IF (NLAP.GT.ISIZE1) STOP ' ***** FATAL ERROR in SPEC:
     1ISIZE1 TOO SMALL *****'
      IF (NDIM3.GT.ISIZE2) STOP ' ***** FATAL ERROR in SPEC:
     1NDIM3>ISIZE2 *****'
      IF (ISIZE2.GT.(ISIZE1/4)) STOP ' FATAL ERROR in SPEC:
     1MAKE ISIZE2=0.25*ISIZE1 *****'
      IF (NSPS1.NE.NSPS2) STOP '***** FATAL ERROR in SPEC:
     1DIFFERENT NSPS VALUES *****'
      IF ((IABS(ITT1-ITT2).NE.1).AND.ISPEC.EQ.1)
     1STOP ' ***** FATAL ERROR in SPEC: DELTA T .NE.
     10.5 *****'
      IF (NPART3.EQ.0) STOP ' ***** FATAL ERROR in SPEC: NO
     1COUPLING POSSIBLE *****'
      IF (ITMAX.LT.ITMIN) STOP ' ***** FATAL ERROR in SPEC: NO T
     1COUPLING POSS *****'
      IF(CG.EQ.0) WRITE(6,901)JAY2,JAY3,JAY1,IMZS2,IMZS3,IMZS1
  901 FORMAT(1X,'2J2,2J3,2J1,2M2,2M3,2M1 = ',6I3)
      IF (CG.EQ.0.0) STOP ' ***** FATAL ERROR in SPEC: CG.EQ.0 :
     1TRY DIFFERENT JZ *****'
      IF (CLEB.EQ.0.0D0) STOP ' ***** FATAL ERROR in SPEC:
     1CLEB.EQ.0 : TRY DIFFERENT TZ *****'
      IF (NDIM3.EQ.0) STOP ' ***** FATAL ERROR in SPEC:
     1 NO COUPLING FOUND *****'
      STOP ' ***** FATAL ERROR FOUND *****'
      END
