      SUBROUTINE OPSET(NOPS)
 
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'trpcom.inc'
      COMMON/NSPS3/NSPS3
      DIMENSION IBASC(MAX_NW),IJLPW(5500)
      EQUIVALENCE (COEF4(MAX_NW+1),IBASC(1)),(IMOVE(1),IJLPW(1))
      INCLUDE 'data.inc'
 
      IPHASE(N)=1-2*IABS(N-2*(N/2))
      NSPSP = NSPS3+1
      IF (IABS(NOPS).EQ.1) GO TO 100
      IF (IABS(NOPS).EQ.2) GO TO 200
      IF (IABS(NOPS).EQ.3) GO TO 300
 
      IF (NWMAX.GT.MAX_NW) STOP ' ***** FATAL ERROR in OPSET:
     1NWMAX.GT.MAX_NW *****'
      IF (ISIZE1.LT.MAX_BASIS) STOP ' ***** FATAL ERROR in OPSET:
     1ISIZE1.LT.MAX_BASIS *****'
 
CBAB  *** TO POSITION OP2 FILE FOR READING FROM START OF OPERATOR
 
      REWIND 27
      READ(27)
      READ(27)
      NZP=1
      RETURN
 
CBAB  *** TO GET J1,J2,J3,J4 INFORMATION BEFORE ACTUALLY READING OPERATOR
 
  100 READ(27) III,NDIM,NJLPW,(IJLPW(I),I=1,NJLPW)
      IF (NJLPW.GT.MAX_NSPS) STOP ' ***** FATAL ERROR in OPSET:
     1NJLPW>MAX_NSPS *****'
      IW=1
      NOPS=IJLPW(IW)
      NPOS=0
      ND3=0
      ND=NDIM
      IF (ISWOP.GT.0) GO TO 120
      IF (III.NE.IP3) GO TO 150
      RETURN
 
CBAB  *** J1,J2 SWAPPED WITH J3,J4
 
  120 IF (LIB_EQX(IPART3(1,III),ZEROP(1),N_WORDS)) NZP=0
      IF (III-NZP+(NPART3+1)/2.NE.IP3)  GO TO 150
      RETURN
 
CBAB  *** SKIP OVER RECORDS
 
  150 NW=MIN0(ND,NWMAX)
      IF(ND.EQ.0)GOTO 100
      READ(27)
      ND=ND-NW
      IF (ND.GT.0) GO TO 150
      GO TO 100
 
CBAB  *** SET UP FOR CROSS HERE
 
  200 NDIM3=0
 
  220 NDIM3=NDIM3+1
      IF (NDIM3.GT.ISIZE1) STOP ' ***** FATAL ERROR in OPSET:
     1NDIM3>ISIZE1 *****'
      NPOS=NPOS+1
      IF (NPOS.GT.NWMAX) NPOS=1
      IF (NPOS.NE.1) GO TO 230
 
      NW=MIN0(ND,NWMAX)
      IF (ND.LE.0) STOP ' ***** FATAL ERROR in OPREAD:
     1ND< OR =0 *****'
      CALL OPREAD(COEF4,IBASC,NW)
      ND=ND-NW
  230 IBSC12=IABS(IBASC(NPOS))/(NSPSP*NSPSP)
      III = IBSC12*NSPSP*NSPSP
      IBSC34=IABS(IBASC(NPOS))-IBSC12*NSPSP*NSPSP
      IF (ISWOP.GT.0) IBSC12=IBSC34
C      IF (ISWOP.GT.0) IBSC34=IABS(IBASC(NPOS))/1000
      IF (ISWOP.GT.0) IBSC34=IABS(IBASC(NPOS))/(NSPSP*NSPSP)

      NSP1=IBSC12/NSPSP
      NSP2=IBSC12-NSP1*NSPSP
      NSP3=IBSC34/NSPSP
      NSP4=IBSC34-NSP3*NSPSP
CBAB  *** Now set up the two body operator. As usual ibas4 says where
CBAB  *** the holes are
 
      IF (USE_STORE) GOTO 299
      CALL LIB_ASSIGNX(ZERO(1),IBAS3(1,NDIM3),NLWRDS)
      CALL LIB_ASSIGNX(ZERO(1),IBAS4(1,NDIM3),NLWRDS)
      IF(NSP1.NE.NSP2)THEN
      IF(LIB_BTSX(IBAS3(1,NDIM3),NSP1-1,NLWRDS)) GOTO 294
  294 CONTINUE
      IF(LIB_BTSX(IBAS3(1,NDIM3),NSP2-1,NLWRDS)) GOTO 295
  295 CONTINUE
      END IF
      IF(NSP3.NE.NSP4)THEN
      IF(LIB_BTSX(IBAS4(1,NDIM3),NSP3-1,NLWRDS)) GOTO 296
  296 CONTINUE
      IF(LIB_BTSX(IBAS4(1,NDIM3),NSP4-1,NLWRDS)) GOTO 297
  297 CONTINUE
      CALL LIB_XORX(IBAS3(1,NDIM3),IBAS4(1,NDIM3),IBAS3(1,NDIM3),NLWRDS)
      END IF
 
  299 COEF3(NDIM3)=COEF4(NPOS)*REDFAC
      IF (ISWOP.GT.0)
     1 COEF3(NDIM3)=IPHASE((IT12-IT34-ITZS3+J12-J34-IMZS3)/2)
     1*COEF3(NDIM3)
      IF (IBASC(NPOS).GT.0) GO TO 220
 
      ND3=ND3+NDIM3
      RETURN
 
  300 IW=IW+1
      NOPS=IJLPW(IW)
      IF (IW.GT.NJLPW) NOPS=0
      IF (IW.GT.NJLPW.AND.ND3.NE.NDIM) WRITE(6,301) IW,NJLPW,ND3,NDIM
  301 FORMAT(1X,'IW,NJLPW,ND3,NDIM = ',4I5)
      IF (IW.GT.NJLPW.AND.ND3.NE.NDIM) STOP ' ***** FATAL ERROR in
     1 OPSET: ND3#NDIM *****'
      RETURN
      END
 
CBAB  *** FOR FAST READING
 
      SUBROUTINE OPREAD(COEF,IBASC,NW)
      DIMENSION COEF(NW),IBASC(NW)
      READ(27) COEF,IBASC
      RETURN
      END
