CBAB  TO CALCULATE TWO-BODY TRANSITION DENSITIES USING MATRIX
CBAB  ELEMENTS FROM OP2 FILE
 
      SUBROUTINE TBTD
 
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'trpcom.inc'
      COMMON/NSPS3/NSPS3
 
      PARAMETER(MAX_NTC=3)
      PARAMETER(MAX_NJBAB=11)
      DIMENSION ITCA(2*MAX_NTC),JMINA(MAX_NTC,MAX_NJBAB),
     1JMAXA(MAX_NTC,MAX_NJBAB),JLPA(MAX_NPART3)
      DIMENSION KEEPJ(max_olap),KEEPT(max_olap)
 
      EQUIVALENCE (NDIMA3(1),JLPA(1))
      CHARACTER*3 PARITY
      INCLUDE 'data.inc'
 
      IF (ICALL.GT.0) GO TO 11
      IF (ICALL.LT.0) GO TO 18
      ICALL=1
 
 
CBAB ******  INITIALISE FOR TBTD
 
CBAB ******  GET SPS FILE INFO
 
      CALL FREE_REAL_A(24,NJL1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      NS=0
      DO 1 I=1,NJL1
      JLST(I)=NS+1
      DO 1 JL=1,NPJ1(I)
      NS=NS+1
      CALL FREE_INT(24,6,INT_VAR,READ_ERR)
      NQU(I)=INT_VAR(2)
      LQU(I)=INT_VAR(3)
      JTW(I)=INT_VAR(4)
      MZTW(NS)=INT_VAR(5)
      ITZTW(NS)=INT_VAR(6)
    1 CONTINUE  
      NSPS3 = NS
 
CBAB ******  OPEN OP2 FILE
 
      OP22='.op2'
      NPOS=INDEX(OP2FIL,' ')
      IF(NPOS.EQ.0)NPOS=10
      NPOS=NPOS-1
      OP2F=OP2FIL(1:NPOS)//OP22
      WRITE(6,2)OP2F
    2 FORMAT(1X,A13)
      CALL OPENOP2(27,AREA_OP2,OP2F,1)
      READ(27) IV,SPSF,ITT3,ITZS3,KPAR3,NPART3,NJLP,NJTCMX,NWMAX,
     1 JTW,NTC,NJBAB,JAY3,IMZS3,((JMINA(I,J),I=1,NTC),J=1,NJBAB),
     1((JMAXA(I,J),I=1,NTC),J=1,NJBAB),(ITCA(I),I=1,2*NTC),NWORDS
      NJLPP = NJL1+1
C      NJLPP = 10
 
      IF(NWORDS.NE.N_WORDS)STOP ' ***** FATAL ERROR in TBTD:
     1 N_WORDS DIFF. in TBTDOP and TRAMP *****'
      READ(27) ((IPART3(IW,I),IW=1,N_WORDS),I=1,NPART3),
     1(JLPA(I),I=1,NJLP)
      NPOS=INDEX(SPSFIL,' ')
      IF(NPOS.EQ.0)NPOS=10
      IF(SPSF.NE.SPSFIL(1:NPOS-1)//'.sps')
     1WRITE(6,3)SPSF,SPSFIL
    3 FORMAT(1X,A13,1X,A13)
      IF (SPSF.NE.SPSFIL(1:NPOS-1)//'.sps')
     1STOP ' ***** FATAL ERROR in TBTD: SPSF#SPSFIL *****'
      IF (NPART3.GT.MAX_NPART3) WRITE(6,4) MAX_NPART3,NPART3
    4 FORMAT(1X,'NPART3 TOO LARGE,
     1INCREASE MAX_NPART3 FROM ',I6,' TO ',I6)
      IF (NPART3.GT.MAX_NPART3) STOP
      IF (NJLP.GT.MAX_NPART3) WRITE(6,5) MAX_NPART3,NJLP
    5 FORMAT(1X,'NJLP TOO LARGE,
     1INCREASE MAX_NPART3 FROM ',I6,' TO ',I6)
      IF (NJLP.GT.MAX_NPART3) STOP
      NLAP=NJTCMX*NJLP
      IF (NLAP.GT.ISIZE4) WRITE(6,6) ISIZE4,NLAP
    6 FORMAT(1X,'NLAP TOO LARGE,
     1INCREASE MAX_OLAP FROM ',I6,' TO ',I6)
      IF (NLAP.GT.ISIZE4) STOP
 
CBAB ******  OUTPUT HEADING TO LPT
 
      IF (ILPT.EQ.0) GO TO 10
 
      PARITY='+VE'
      IF (MOD(KPAR3,2).NE.0) PARITY='-VE'
      N1A=JAY3/2
      N2A=IMZS3/2
      N1=ITT3/2
      N2=ITZS3/2
      WRITE(3,7) OP2FIL,N1A,N2A,N1,N2,PARITY
    7 FORMAT(//////////' TWO-BODY TRANSITION DENSITIES'/
     1  ' OPERATOR FILE : ',A9/
     1  ' J, JZ, OF OPERATOR : ',2(I3,','),/,
     1  ' T, TZ, OF OPERATOR : ',2(I3,','),/,
     1  ' PARITY OF OPERATOR : ',A3)
      WRITE(3,8) (I,I=1,NJL1)
    8 FORMAT(//' SINGLE-PARTICLE ORBITS :',6I10)
      WRITE(3,9) (NQU(I),LQU(I),JTW(I),I=1,NJL1)
    9 FORMAT(/' N,L,J VALUES           :  ',6(I6,',',I1,',',I1))
 
CBAB ******  WRITE OUTPUT TO TBD FILE
 
   10 IF (ICNTL.EQ.0) RETURN
 
 
      MARKBAB = -999
CBAB ****** MARKBAB IS WRITTEN SIX TIMES TO BE CONSISTENT WITH OLD
CBAB ****** DIMENSION OF JMINA(3) AND JMINB(3) DO THAT OLD VERSIONS
CBAB ****** OF THE INPUTS WILL STILL WORK WITH THE SAME READ PROGRAMS
      WRITE(1) NV1,NV2,NV1MIN,NV2MIN,OP2FIL,SPSF,ITT3,ITZS3,KPAR3,
     1 NPART3,NJLP,NJTCMX,NTC,MARKBAB,MARKBAB,MARKBAB,MARKBAB,
     1MARKBAB,MARKBAB,(ITCA(I),I=1,2*NTC),
     1 (JLPA(I),I=1,NJLP)
      WRITE(1) JAY3,IMSZ3,NJBAB,((JMINA(I,J),I=1,NTC),J=1,NJBAB),
     1((JMAXA(I,J),I=1,NTC),J=1,NJBAB)
 
      RETURN
 
CBAB  TO CALCULATE TRANSITION DENSITY OVERLAPS
CBAB  FINAL ("2-D") ARRAY OF OVERLAPS (AS WRITTEN TO LPT) FOR
CBAB  GIVEN VECTORS 1 & 2 IS STORED IN OLAP ARRAY
 
CBAB  TBTD IS CALLED FOR JUST ONE PARTITION AT A TIME
CBAB  SO THE IDEA IS TO LOOP OVER ALL J1,J2,J3,J4 VALUES IN THIS PARTITION
CBAB  AND ALL INTERMEDIATE COUPLINGS PER CALL
 
CBAB  THE OPERATOR FILE IS READ IN RECORD BY RECORD
CBAB  AND THE FIRST NDIM3 PARTS OF IBAS3, IBAS4, COEF3 ARE FILLED
CBAB  BY CALLING OPSET BEFORE CALLING CROSS
 
CBAB  FIRST OPSET IS CALLED TO GET J1,J2,J3,J4 VALUES
 
   11 NOPS=1
      CALL OPSET(NOPS)
 
   12 IF (ISWOP.GT.0) GO TO 13
 
      IOLPST=(NOPS-1)*NJTCMX+1
      JLP12=JLPA(NOPS)/(NJLPP*NJLPP)
      JLP34=JLPA(NOPS)-JLP12*NJLPP*NJLPP
      GO TO 14
 
CBAB ******  J1,J2 AND J3,J4 ARE SWOPPED
 
   13 IOLPST=(NJLP+NOPS-1)*NJTCMX+1
 
      JLP34=JLPA(NOPS)/(NJLPP*NJLPP)
      JLP12=JLPA(NOPS)-JLP34*NJLPP*NJLPP
   14 CONTINUE
      JLP1=JLP12/NJLPP
      JLP2=JLP12-JLP1*NJLPP
      JLP3=JLP34/NJLPP
      JLP4=JLP34-JLP3*NJLPP
      JTWP1=JTW(JLP1)
      JTWP2=JTW(JLP2)
      JTWP3=JTW(JLP3)
      JTWP4=JTW(JLP4)
      JMIN=0
      JMAX=MAX0(JTWP1+JTWP2,JTWP3+JTWP4)
 
      IF (JMAX.LT.JMIN) STOP ' *** FATAL ERROR IN TBTD: JMAX<JMIN ***'
 
CBAB ******  LOOP OVER DIFFERENT T-COUPLING
 
      NJTC=0
      NJBAB = 0
      IJ34MIN = -JAY3
      IJ34MAX = JAY3
      DO 17 IJ34 = IJ34MIN,IJ34MAX,2
      NJBAB = NJBAB+1
      ITC=0
      DO 17 IT12=0,2,2
      DO 17 IT34=0,2,2
      IF (IT12+IT34.LT.ITT3) GO TO 17
      IF (IABS(IT12-IT34).GT.ITT3) GO TO 17
      ITC=ITC+1
 
CBAB ******  LOOP OVER DIFFERENT J-COUPLING
 
      DO 16 J12=JMIN,JMAX,2
      J34 = J12 + IJ34
      IF(J34.LT.0) GO TO 16
      JTWP2=IABS(JTW(JLP2))
      JTWP1=IABS(JTW(JLP1))
      IF(JTWP1+JTWP2.LT.J12) GO TO 16
      IF(IABS(JTWP1-JTWP2).GT.J12) GO TO 16
      JTWP4=IABS(JTW(JLP4))
      JTWP3=IABS(JTW(JLP3))
      IF(JTWP3+JTWP4.LT.J34) GO TO 16
      IF(IABS(JTWP3-JTWP4).GT.J34) GO TO 16
      IF(J12+J34.LT.JAY3) GO TO 16
      IF(IABS(J12-J34).GT.JAY3) GO TO 16
      IF (JLP1.EQ.JLP2.AND.MOD(J12+IT12,4).NE.2) GO TO 16
      IF (JLP3.EQ.JLP4.AND.MOD(J34+IT34,4).NE.2) GO TO 16
      NJTC=NJTC+1
 
CBAB ******  OPSET WILL READ IN OPERATOR AND SET UP NDIM3,
CBAB ******  IBAS3, IBAS4, COEF3 FOR CROSS
 
      NOPS=2
 
      CALL OPSET(NOPS)
      ILAP=IOLPST+J12/2-JMINA(ITC,NJBAB)
      KEEPJ(ILAP) = (J12/2)
      KEEPT(ILAP) = (IT12/2)+10
      CALL CROSS
 
   16 CONTINUE
      if(jmaxa(itc,njbab).ge.jmina(itc,njbab))
     1 IOLPST=IOLPST+JMAXA(ITC,NJBAB)-JMINA(ITC,NJBAB)+1
   17 CONTINUE
 
      IF (NJTC.GT.NJTCMX) STOP ' ***** FATAL ERROR in TBTD:
     1NJTC>NJTCMX *****'
 
      NOPS=3
      CALL OPSET(NOPS)
      IF (NOPS.GT.0) GO TO 12
 
      RETURN
 
CBAB ******  OUTPUT VALUES TO LPT AND DATA FILE
 
   18 IF (ILPT.LE.0) GO TO 31
      WRITE(3,19) NV2,EFIL2,ELEV2(NV2),NV1,EFIL1,ELEV1(NV1)
   19 FORMAT(//' INITIAL STATE :  VECTOR',I3,' OF ',A6,F8.3,'  MEV'/
     3  ' FINAL STATE   :  VECTOR',I3,' OF ',A6,F8.3,'  MEV')
 
      WRITE(3,20)
   20 FORMAT(/,1X,'tensor ranks of the operator for
     1 results on the output from left to right',/)
      IDELBAB = -(JAY3/2)-1
      DO 24 IBAB = 1,NJBAB
      IDELBAB = IDELBAB+1
      DO 23 I = 1,NTC
      DO 22 JBAB = JMINA(I,IBAB),JMAXA(I,IBAB)
      WRITE(3,21) ITCA(2*I-1),ITCA(2*I),JBAB,JBAB+IDELBAB
   21 FORMAT(1X,'IT12,IT34,IJ12,IJ34 = ',4I4)
   22 CONTINUE
   23 CONTINUE
   24 CONTINUE
 
      WRITE(3,25)
   25 FORMAT(/' ORBITS'/' TO FROM')
 
      if(nv1.eq.1.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.tp1',status='new')
      if(nv1.eq.2.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.tp2',status='new')
      if(nv1.eq.3.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.tp3',status='new')
      if(nv1.eq.4.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.tp4',status='new')
      if(nv1.eq.5.and.idiag.eq.2)
     1 open(unit=40,file=efil1//'.tp5',status='new')
      iolpst=1
      DO 30 IJLP=1,NJLP
      JLP12=JLPA(IJLP)/(NJLPP*NJLPP)
      JLP1=JLP12/NJLPP
      JLP2=JLP12-JLP1*NJLPP
      JLP34=JLPA(IJLP)-JLP12*NJLPP*NJLPP
      JLP3=JLP34/NJLPP
      JLP4=JLP34-JLP3*NJLPP
 
      IF(IDIAG.NE.2) GO TO 28
      NAA = NQU(JLP1)-1.
      LAA = LQU(JLP1)
      J2AA = JTW(JLP1)
      INDEX1 = ((2*NAA+LAA)*(2*NAA+LAA+3)-(J2AA-1)+2)/2
      NAA = NQU(JLP2)-1.
      LAA = LQU(JLP2)
      J2AA = JTW(JLP2)
      INDEX2 = ((2*NAA+LAA)*(2*NAA+LAA+3)-(J2AA-1)+2)/2
      NAA = NQU(JLP3)-1.
      LAA = LQU(JLP3)
      J2AA = JTW(JLP3)
      INDEX3 = ((2*NAA+LAA)*(2*NAA+LAA+3)-(J2AA-1)+2)/2
      NAA = NQU(JLP4)-1.
      LAA = LQU(JLP4)
      J2AA = JTW(JLP4)
      INDEX4 = ((2*NAA+LAA)*(2*NAA+LAA+3)-(J2AA-1)+2)/2
 
      DO 27 I=IOLPST,IOLPST+NJTCMX-1
      IF(KEEPT(I).EQ.0) GO TO 27
      KEEPT(I)=KEEPT(I)-10
      OLAP(I)=OLAP(I)*(SQRT(2.*KEEPJ(I)+1.)/SQRT(JAY1+1.))
     1*(SQRT(2.*KEEPT(I)+1.)/SQRT(ITT1+1.))
      WRITE(40,26) INDEX1,INDEX2,INDEX3,INDEX4,
     1KEEPJ(I),KEEPT(I),OLAP(I)
   26 FORMAT(1X,4I3,1X,2I3,F9.4)
   27 CONTINUE
   28 CONTINUE
 
      WRITE(3,29) JLP1,JLP2,JLP3,JLP4,
     1  (OLAP(I),I=IOLPST,IOLPST+NJTCMX-1)
 
   29 FORMAT(/4I2,2X,10F7.3,10(/,10X,10F7.3))
   30 IOLPST=IOLPST+NJTCMX
      IF(IDIAG.EQ.2) CLOSE(UNIT=40)
   31 IF (ICNTL.LE.0) RETURN
      IPOSL(1)=1
      K=0
      DO 32 I=1,NLAP
      IF (OLAP(I).EQ.0.0) GO TO 32
      K=K+1
      IF (K.GT.ISIZE1) STOP ' ***** FATAL ERROR IN TBTD: K>ISIZE1 *****'
     1
      IF (K.GT.ISIZE4) STOP ' ***** FATAL ERROR IN TBTD: K>ISIZE4 *****'
     1
      OLAP(K)=OLAP(I)
      IPOSL(K)=I
   32 CONTINUE
      IF (K.EQ.0) K=1
      WRITE(1) NV1,NV2,K,(IPOSL(I),OLAP(I),I=1,K)
      RETURN
      END
