      IF (ICASE.GT.1) GO TO 15 
      CALL TITLE(IOUT)
15    IF (ICASE.EQ.1.OR.ICASE.EQ.4) WRITE(IOUT,20) EIGFIL 
      IF (ICASE.EQ.2) WRITE(IOUT,21) 
      IF (ICASE.EQ.3) WRITE(IOUT,22) 
20    FORMAT(////5X,A9,' CALCULATION') 
21    FORMAT(////'    CLUSTER STATE CALCULATION') 
22    FORMAT(////'    CORE STATE CALCULATION') 

      WRITE(IOUT,143) NPTCL
143   FORMAT(/,1X,'# of valence particles      : ',I3)
      IHJAY=JAY/2
      IHIMZS=IMZS/2
      IHITT=ITT/2
      IHITZS=ITZS/2
      IF(IHJAY*2.EQ.JAY) WRITE(IOUT,144) IHJAY,IHIMZS
144   FORMAT(/,1X,'                          J : ',I3,
     13X,'(Projected from state with Jz = ',I3,')')
      IF(IHJAY*2.NE.JAY) WRITE(IOUT,145) JAY,IMZS
145   FORMAT(/,1X,'                          J : ',I3,'/2',
     11X,'(Projected from state with Jz = ',I3,'/2)')
      IF(IHITT*2.EQ.ITT) WRITE(IOUT,146) IHITT,IHITZS
146   FORMAT(1X,'                          T : ',I3,
     13X,'(Projected from state with Tz = ',I3,')')
      IF(IHITT*2.NE.ITT) WRITE(IOUT,147) ITT,ITZS
147   FORMAT(1X,'                          T : ',I3,'/2',
     11X,'(Projected from state with Tz = ',I3,'/2)')

      IF (KPAR.EQ.0) PARITY='+VE'
      IF (KPAR.EQ.1) PARITY='-VE'
      IF (KPAR.EQ.2) PARITY='+VE'
      IF (KPAR.EQ.3) PARITY='-VE'
      WRITE(IOUT,148) PARITY
148   FORMAT(1X,'                     Parity : ',A3)

      WRITE(IOUT,129) SPSFIL
129   FORMAT(/,1X,'Model space (*.SPS) name    : ',A9)
      WRITE(IOUT,130) BASFIL
130   FORMAT(1X,'M-scheme basis (*.BAS) name : ',A9)

      WRITE(IOUT,128)
128   FORMAT(45X,'SPE_NORM  ME_NORM')
      DO 132 IINT = 1,NINT
      WRITE(IOUT,131) 
     1IINT,OPFIL(IINT),SPE_NORM(IINT),ME_NORM(IINT)
131   FORMAT(1X,'TBME (*.INT) name (',I1,')       : ',A9,3X,2F10.5)
132   CONTINUE

      WRITE(IOUT,140) EIGFIL
140   FORMAT(/,1X,'Eigenvector (*.EIG) name    : ',A9)
      IF(IGNDERR.EQ.0) WRITE(IOUT,141) GNDFIL,GNDE
141   FORMAT(1X,'Ground state (*.GND) name   : ',A9,
     15X,F10.3,' = Eigenvalue of ground state')
      IF(IGNDERR.EQ.1) WRITE(IOUT,142) GNDFIL
142   FORMAT(1X,'Ground state (*.GND) name   : ',A9,'
     1 (Input file not found)')
      WRITE(IOUT,149) MATDIM
149   FORMAT(1X,'Matrix dimension            : ',I6)

C
C  RESTRICTIONS
C
      WRITE(IOUT,42) (IINT,IINT=1,NINT) 
CBAB42 FORMAT(//' NO. OF PARTICLES ALLOWED IN EACH J-LEVEL'//
42    FORMAT(//1X,'# of particles allowed in each j-level',
     15X,'Single-particle energies for each j-level',
     1//,1X,' SHELL         SUB SHELL     MAJOR SHELL'
     1,3X,'Total SPE  Delta SPE ------ SPE From *.INT files ------',
     1/,'                MIN   MAX      MIN   MAX '
     1,14X,'from input',9(4X,I1,4X))
      K=0 
      DO 45 I=1,NOSC 
      WRITE(IOUT,43) 
      DO 45 J=1,NOSCJL(I) 
      K=K+1 
      IF (J.EQ.1)  WRITE(IOUT,43) SHELL(K),MNFIL(K),MXFIL(K), 
     1  MNOSC(I),MXOSC(I),ENL(K),DENL(K),(ENLIN(K,IINT),IINT=1,NINT) 
43    FORMAT(' ',A9,I9,I6,I9,I6,3X,F9.4,2X,10F9.4) 
      IF (J.GT.1) WRITE(IOUT,44) SHELL(K),MNFIL(K),MXFIL(K) 
     1  ,ENL(K),DENL(K),(ENLIN(K,IINT),IINT=1,NINT) 
44    FORMAT(' ',A9,I9,I6,15X,3X,F9.4,2X,10F9.4) 
45    CONTINUE 

      XCRIT=CRIT*1000.
      IF (ICASE.EQ.0) WRITE(IOUT,150) MAX_NST
150   FORMAT(/,1X,'# iterations required       : ',I5)
      IF (ICASE.EQ.0) WRITE(IOUT,151) XCRIT
151   FORMAT(1X,'Convergence criteria (keV)  : ',F5.2)
