	SUBROUTINE EIGENA(EIGFIL,NVMIN,NVEC,ELEV)
C  THIS SUBROUTINE READS THE CALCULATED EIGEN VALUES
C  AND WRITES IT IN THE *.SAV FILE
C
C      INCLUDE 'SHGR:MAINCOM.INC'
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHGR:PARAM.INC'
      INCLUDE 'SHGR:DATA.INC'
	PARAMETER MAX_EIG=10000,MAX_PMAT=200
	PARAMETER MAX_NVEC=300
	CHARACTER*13 BASF,PRJF,EIGF,REDF,MVECF,SPSF,MVECFA,MVECFB
      CHARACTER*9 OPFIL
      REAL SPE_NORM,ME_NORM
      COMMON/CHEAD/NINT,OPFIL(9),SPE_NORM(9),ME_NORM(9),ENLI(MAX_NJL,9),
     1ENLIN(MAX_NJL,9),DENL(MAX_NJL)
      DIMENSION IORD(MAX_NPART),NDIMA(MAX_NPART),NBLCK(MAX_NPART)
      DIMENSION IPART(N_WORDS,MAX_NPART)
	CHARACTER*7 AREA
	CHARACTER*9 EIGFIL,MVFIL,PRJFIL,GNDFIL,MATFIL,MVFILA,MVFILB
	CHARACTER*9 LPTFIL,SPSFIL,BASFIL,INTFIL,BASFL1,ORTFIL,SHELL
	CHARACTER*4 GND2,MVEC2,PRJ2,EIG2,DUD4,MVEC2A,MVEC2B
	INTEGER ZERO(MAX_NLWRDS)
	DIMENSION EVEC(MAX_MSCHEME),EVEC0(MAX_EIG),COEF(MAX_MSCHEME),
	1	ELEV(MAX_NVEC),NJTP(MAX_NPART),IDISK(MAX_NPART),
	1       MNOSC(MAX_NOSC),MXOSC(MAX_NOSC),SHELL(MAX_NJL),
     1 ENL(MAX_NJL),MNFIL(MAX_NJL),MXFIL(MAX_NJL),NOSCJL(MAX_NOSC)
	NPOS=INDEX(EIGFIL,' ')
	IF(ILOG)WRITE(*,410)EIGFIL(1:NPOS-1)
410	FORMAT('+',A,'.EIG')

CBAB IWRITE ADDED MAY 24 84 TO MAKE FORMATED OUTPUTS
	IF (NVMIN.EQ.0.AND.NVEC.EQ.0) NVEC=5
	IF (NVMIN.EQ.0) NVMIN=1
	IF (NVMIN.GT.NVEC) NVEC=NVMIN
15	FORMAT(20I)
	IF(ILOG)WRITE(*,420)NVMIN,NVEC
420	FORMAT('+',2I4)
	IF(NVEC.GT.MAX_NVEC)STOP ' ***** FATAL ERROR: 
	1Increase MAX_NVEC to Max. no. of vectors ***** '
	EIG2='.EIG'
	EIGF=EIGFIL//EIG2
CBAB	OPEN(UNIT=21,FILE=AREA_RUN//EIGF,STATUS='OLD',FORM='UNFORMATTED')
	OPEN(UNIT=21,FILE=EIGF,STATUS='OLD',FORM='UNFORMATTED')
	AREA = '   RSH:'
CWAR	OPEN(UNIT=21,FILE=AREA//EIGF,STATUS='OLD',FORM='UNFORMATTED')
CBAB	READ(21) IV,PRJF,MDIM,SHELL,ENL,
CBAB	1	BASFL1,INTFIL,MATFIL,GNDE,
CBAB	1MNFIL,MXFIL,MNOSC,MXOSC,NEIG,ORTFIL,REDF,NOSCJL,NOSC

	READ(21) IV,PRJF,MDIM,NJL,(SHELL(I),I=1,NJL),(ENL(I),I=1,NJL),
CBAB	1	BASFL1,INTFIL,MATFIL,GNDE,
	1	BASFL1,OPFIL,MATFIL,GNDFIL,GNDE,
	1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
	1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
CBAB	1NEIG,ORTFIL,REDF,(NOSCJL(I),I=1,NOSC)
	1NEIG,ORTFIL,REDF,(NOSCJL(I),I=1,NLSC),NPTCL,
	1NINT,(SPE_NORM(IINT),ME_NORM(IINT),IINT=1,NINT),
	1((ENLIN(I,IINT),I=1,NJL),IINT=1,NINT),(DENL(I),I=1,NJL)
	IF (NVMIN.GT.0) GO TO 20
	NVMIN=1
	NVEC=MDIM
20	NVEC=MIN0(NVEC,MDIM)
	IF (NEIG.GT.0) NVEC=MIN0(NVEC,NEIG)
	IF (NVMIN.GT.NVEC) STOP ' ***** FATAL ERROR: NVMIN>NVEC *****'
CBAB	READ(21)
CBAB	READ(21) (ELEV(I),I=1,NVEC)
	READ(21) (ELEV(I),I=1,NVEC)   
	READ(21)
	CLOSE(UNIT=21)
	CLOSE(UNIT=76)
28	CONTINUE
	GO TO 1234
CBAB	OPEN(UNIT=22,FILE='WOTDSK:'//PRJF,STATUS='OLD',FORM='UNFORMATTED')
1234	CONTINUE
	RETURN
	END

